#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a)        \
    for (auto& i : a) \
    cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x)
        x = y;
}

template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y)
        x = y;
}

string SubOne(string value) {
    int pos = value.size() - 1;
    while (pos >= 0 && value[pos] == '0') {
        value[pos] = '9';
        --pos;
    }
    assert(pos >= 0);
    value[pos]--;
    return value;
}

bool isLess(string lhs, string rhs) {
    assert(lhs.size() == rhs.size());
    for (int i = 0; i < (int)lhs.size(); ++i) {
        if (lhs[i] != rhs[i]) {
            return lhs[i] < rhs[i];
        }
    }
    return false;
}

ll Calc(string value, char prime) {
    ll ans = 0;
    for (int i = 1; i < value.size(); ++i) {
        ans += i;
    }
    string has(value.size(), '1');
    int l = -1;
    int r = value.size();
    while (l < r - 1) {
        int m = (l + r) / 2;
        has[m] = prime;
        if (isLess(value, has)) {
            l = m;
        } else {
            r = m;
        }
        has[m] = '1';
    }
    ans += value.size() - r;
    return ans;
}

ll Calc(string value) {
    vector<char> primes = {'2', '3', '5', '7'};
    ll ans = 0;
    for (char prime : primes) {
        ans += Calc(value, prime);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    string l, r;
    cin >> l >> r;
    l = SubOne(l);
    ll ans_r = Calc(r);
    ll ans_l = Calc(l);
    cout << ans_r - ans_l << endl;
    return 0;
}
