#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include<string>


using namespace std;

#define int long long
#define pii pair<int,int>
#define f first
#define s second
#define pb push_back


void solve(){

    int n,k;
    cin >> n >> k;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if(k==2) {
        int sum = 0;
        for(int i = 0; i < n; ++i) {
            sum += a[i];
        }
        cout << max(sum-2*a[0], sum - 2*a[n-1]);
        return;
    }
    vector<int> pref(n+1);
    pref[0] = 0;
    for(int i = 1; i <= n; ++i) {
        pref[i] = pref[i-1]+a[i-1];
    }
    vector<int> tr(n);
    vector<int> tl(n);
    tl[0] =0 ;
    for(int i =1; i < n; ++i) {
        tl[i] = max(tl[i-1], pref[i] - pref[max(0ll,i-(n-k+1))]);
    }
    tr[n-1] = 0;
    for(int i = n-2; i >= 0; i--) {
        tr[i] = max(tr[i+1], pref[min(n,i+1+(n-k+1))] - pref[i+1]);
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        ans = max(ans, max(tl[i],tr[i])-a[i]);
    }
    cout << ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t=1;
    //cin >> t;
    while(t--) {
        solve();
    }
}