#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include<string>


using namespace std;

#define int long long
#define pii pair<int,int>
#define f first
#define s second
#define pb push_back

pii dp[100005];
void solve(){

    int n,s;
    cin >> n >> s;
    for(int i = 0; i <= s; ++i) {
        dp[i] = {-2,-2};
    }
    dp[0] = {-1,-1};
    vector<int> k(n);

    vector<vector<int>> c(n);
    for(int i = 0; i < n; ++i) {
        cin >> k[i];
        for(int j = 0; j < k[i]; ++j) {
            int cost;
            cin >> cost;
            c[i].pb(cost);
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < k[i]; ++j) {
            for(int st = s-c[i][j]; st >= 0; --st) {
                if(dp[st].f < i-1) continue;
                else {
                    dp[st+c[i][j]] = {i,j};
                }
            }
        }
    }
    if(dp[s].f != n-1) {
        cout << "No\n";
        return;
    }
    vector<vector<int>> ans(n);
    int now = s;
    while(now>0) {
        ans[dp[now].f].pb(dp[now].s);
        now -= c[dp[now].f][dp[now].s];
    }
    cout << "Yes\n";
    for(int i = 0; i < n; ++i) {
        cout << ans[i].size() << '\n';
        for(int j: ans[i]) {
            cout << j+1 << ' ';

        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t=1;
    //cin >> t;
    while(t--) {
        solve();
    }
}