#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include<string>
#include<cassert>

using namespace std;

#define int long long
#define pii pair<int,int>
#define f first
#define s second
#define pb push_back
vector<int> fact(2e6+5);
vector<int> invfact(2e6+5);
int mod = 1e9+7;
int po(int a,int n) {
    if(n==0) return 1;
    if(n%2==0) {
        int tmp = po(a,n/2);
        return (tmp*tmp)%mod;
    }
    return (a*po(a,n-1))%mod;
}
vector<vector<pii>> paths;
int n,m;
void dfs(int u, int v, vector<pii>&p) {
    p.pb({u,v});
    if(u==n-1&&v==m-1) {
        paths.pb(p);
        return;
    }
    if(u<n-1) {
        dfs(u+1,v,p);
        p.pop_back();
    }
    if(v<m-1) {
        dfs(u,v+1,p);
        p.pop_back();
    }
}
void solve(){
    int k;
    cin >> n >> m >> k;
    vector<pii> a(k);
    for(int i = 0; i < k; ++i) {
        cin >> a[i].f >> a[i].s;
        a[i].f--;
        a[i].s--;
    }
    if(n==3&&m<=100&&k<=100) {
        int ans = 0;
        for(int l = 0; l < m; ++l) {
            for(int r = l+1; r < m; ++r) {
                bool ok = true;
                for(int i = 0; i < k;++i) {
                    if(a[i].f==0&&a[i].s>r) ok=false;
                    if(a[i].f==1&&a[i].s>l&&a[i].s<r) ok = false;
                    if(a[i].f==2&&a[i].s<l)ok=false;
                }
                if(ok) ans++;
            }
        }
        cout << 2*ans;
        return;
    }
    if(n <= 8 && m <= 8 && k <= 8) {
        vector<pii> p;
        dfs(0,0,p);
        int ans = 0;
       // cout << paths.size() << '\n';
        for(vector<pii>& v: paths) {
            for(vector<pii>& w: paths) {
                bool ok = true;
                for(int i = 1; i < v.size()-1; ++i) {
                    if(v[i].f==w[i].f && v[i].s==w[i].s) {
                        ok = false;
                        break;
                    }
                }
                if(!ok) continue;
                for(int i = 0; i < k; ++i) {
                    bool found = false;
                    for(int j = 0; j < v.size(); ++j) {
                        if(v[j].f==a[i].f&&v[j].s==a[i].s){found=true;break;}
                        if(w[j].f==a[i].f&&w[j].s==a[i].s){found=true;break;}
                    }
                    if(!found) {
                        ok=false;
                        break;
                    }
                }
                if(ok)ans++;
            }
        }
        cout << ans;
        return;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    fact[0] = 1;
    for(int i = 1; i < fact.size(); ++i) {
        fact[i] = (i*fact[i-1])%mod;
    }
    invfact[fact.size()-1] = po(fact[fact.size()-1],mod-2);
    for(int i = fact.size()-2; i >= 0; i--) {
        invfact[i] = ((i+1)*invfact[i+1])%mod;
    }
    int t=1;
    //cin >> t;
    while(t--) {
        solve();
    }
}