#include <bits/stdc++.h>

using namespace std;

#define CE constexpr

using i64 = int64_t;
using i128 = __int128;

constexpr int mod = 998'244'353;


void solve() {
    int n, k;
    cin >> n >> k;

    vector<i64> v(n);

    for (auto &e: v) cin >> e;

    vector<i64> cum(n + 1);
    for (int i = 0; i < n; ++i) {
        cum[i + 1] = cum[i] + v[i];
    }



    i64 res = 0;


    if (k == 2) {
        for (int i = 1; i < n; ++i) {
            res = max(res, abs(2 * cum[i] - cum[n]));
        }
    } else {
        vector<i64> sums(k);
        int single_len = n - (k - 1);
        sums[0] = std::accumulate(v.begin(), v.begin() + single_len, 0);
        for (int j = 1; j < k; ++j) {
            sums[j] = sums[j - 1] - v[j - 1] + v[j - 1 + single_len];
        }

        vector<i64> pref_sums(k);
        pref_sums[0] = sums[0];
        for (int i = 1; i < k; ++i) {
            pref_sums[i] = max(sums[i], pref_sums[i - 1]);
        }

        vector<i64> suff_sums(k);
        suff_sums.back() = sums.back();
        for (int i = k - 1; i--;) {
            suff_sums[i] = max(sums[i], suff_sums[i + 1]);
        }

        for (int i = 0; i < n; ++i) {
            if (i < single_len) {
                res = max(res, cum[i] - v[i]);
            } else {
                res = max(res, pref_sums[i - single_len] - v[i]);
            }
            if (i + 1 + single_len > n) {
                res = max(res, cum[n] - cum[n - single_len] - v[i]);
            } else {
                res = max(res, suff_sums[i + 1] - v[i]);
            }
        }
    }

    cout << res << '\n';


}


int main() {
#ifndef DBG
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;

//    cin >> t;
    for (int i = 0; i < t; ++i) { solve(); }
    return 0;
}