#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long
#define ENDL "\n"
#define forn(i, s, f) for (int i=(s); i<(f); ++i)

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int>> a(n);
    forn(i, 0, n) {
        int ki;
        cin >> ki;
        a[i].resize(ki);
        forn(j, 0, ki) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> dp(n, vector<int>(s + 1, 0)), pr(n, vector<int>(s + 1, -1));
    vector<vector<vector<int>>> dp2(n), pr2(n);
    forn(ind, 0, n) {
        int m = a[ind].size();
        dp2[ind].resize(m, vector<int>(s + 1));
        pr2[ind].resize(m, vector<int>(s + 1, -1));
        if (a[ind][0] <= s) {
            dp2[ind][0][a[ind][0]] = 1;
        }
        dp2[ind][0][0] = 1;
        forn(i, 1, m) {
            forn(j, 0, s + 1) {
                dp2[ind][i][j] = dp2[ind][i - 1][j];
                pr2[ind][i][j] = j;
                if (j - a[ind][i] >= 0 and !dp2[ind][i][j]) {
                    dp2[ind][i][j] = dp2[ind][i - 1][j - a[ind][i]];
                    pr2[ind][i][j] = j - a[ind][i];
                }
            }
        }
        if (ind == 0) {
            forn(j, 1, s + 1) {
                if (dp2[ind][m - 1][j]) {
                    dp[ind][j] = 1;
                    pr[ind][j] = j;
                }
            }
        } else {
            forn(j, 1, s + 1) {
                forn(prs, 1, j + 1) {
                    if (dp2[ind][m - 1][prs] and dp[ind - 1][j - prs]) {
                        dp[ind][j] = 1;
                        pr[ind][j] = prs;
                    }
                }
            }
        }
    }
//    forn(i, 0, n) {
//        forn(j, 0, s + 1) {
//            cerr << "i=" << i << " j=" << j << " dp[i][j]=" << dp[i][j] << ENDL;
//        }
//    }
    if (dp[n - 1][s]) {
        cout << "Yes" << ENDL;
        int ind = n - 1, j = s;
        while (j > 0) {
            int m = a[ind].size();
            int i = m - 1, prs = pr[ind][j];
            vector<int> cur;
            while (prs > 0) {
                if (pr2[ind][i][prs] != prs) {
                    cur.push_back(i);
                }
                prs = pr2[ind][i][prs];
                --i;
            }
            cout << cur.size() << ENDL;
            forn(i, 0, cur.size()) {
                cout << cur[i] + 1<< ' ';
            }
            cout << ENDL;
            j -= pr[ind][j];
            --ind;
        }
    } else {
        cout << "No" << ENDL;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}

