#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;


int main(){
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> lm(k);
    for (auto& [i, j]: lm){
        cin >> i >> j;
        i --, j --;
    }
    if (n != 3){
        int ans = 0;
        lm.push_back({0, 0});
        lm.push_back({n - 1, m - 1});
        for (int i = 0; i < (1u << (2 * n + 2 * m - 4)); i ++){
            int x = 0, y = 0;
            int u = 0, d = 0;
            vector<vector<int>> cnt(n, vector<int>(m, 0));
            for (int j = 0; j < 2 * n + 2 * m - 4; j ++){
                cnt[x][y] ++;
                if ((i >> j) & 1){
                    if (u >= n - 1) x --;
                    else x ++;
                }else{
                    if (d >= m - 1) y --;
                    else y ++;
                }
            }
            bool ok = true;
            for (auto p: cnt) for (auto q: p) if (q >= 2) ok = false;
            for (auto [p, q]: lm) ok = ok and cnt[p][q];
            ans += ok;
        }
        cout << ans;
        return 0;
    }
    int ans = 0;
    for (int l = 0; l < m; l ++)
        for (int r = l + 1; r < m; r ++){
            vector<vector<bool>> a(3, vector<bool>(m, false));
            for (int i = 0; i < m; i ++){
                if (i <= r) a[0][i] = true;
                if (i >= l) a[2][i] = true;
                if (i >= r or i <= l) a[1][i] = true;
            }
            bool ok = true;
            for (auto [x, y]: lm) ok = ok and a[x][y];
            ans += ok;
        }
    cout << ans * 2 << "\n";
}
