//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <unordered_map>
#include <queue>

using namespace std;
typedef long long ll;
// typedef long double ld;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout << fixed;
    // cout.precision(5);
    int n, m, k;
    cin >> n >> m >> k;
    unordered_map< int, unordered_map<int, ll> > M;
    M[0][0] = 0;
    queue< pair<int, int> > Q;
    Q.push({0, 0});
    while (!Q.empty()) {
        auto [i, j] = Q.front();
        Q.pop();
        for (int d = k; d >= 1; --d) {
            if (i + d < n && !M[i + d][j]) {
                M[i + d][j] = M[i][j] + 1;
                Q.push({i + d, j});
            }
            if (j + d < m && !M[i][j + d]) {
                M[i][j + d] = M[i][j] + 1;
                Q.push({i, j + d});
            }
            if (i + d < n && j + d < m && !M[i + d][j + d]) {
                M[i + d][j + d] = M[i][j] + 1;
                Q.push({i + d, j + d});
            }
        }
    }
    cout << M[n - 1][m - 1];
    return 0;
}