#include <iostream>
#include <cmath>
#include <vector>
// #include <bitset>

using namespace std;
typedef long long ll;
const ll INF = 1e18;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k; cin >> n >> k;
    vector<ll> A(n), P(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        P[i + 1] = P[i] + A[i];
    }
    if (k == 2) {
        ll answer = -INF;
        for (int r = 1; r < n; ++r)
            answer = max(answer, max(P[r] - (P[n] - P[r]), (P[n] - P[r]) - P[r]));
        cout << answer;
        return 0;
    }
    if (k == 3) {
        int a = -1, b = -1;
        ll answer = -INF;
        for (int r = 2; r < n - 1; ++r) {
            if ((P[n] - P[r]) - P[r] > answer) {
                answer = (P[n] - P[r]) - P[r];
                a = r, b = n - 1;
            }
            if (P[r] - (P[n] - P[r]) > answer) {
                answer = P[r] - (P[n] - P[r]);
                a = 0, b = r - 1;
            }
        }
        ll minimum = INF;
        if (a == 0) {
            for (int i = b + 1; i < n; ++i)
                minimum = min(minimum, A[i]);
        }
        else if (b == n - 1) {
            for (int i = 0; i < a; ++i)
                minimum = min(minimum, A[i]);
        }
        answer = (P[b + 1] - P[a]) - minimum;
        cout << max(answer, (P[n - 1] - P[1]) - min(A[0], A[n - 1]));
        return 0;
    }
    ll answer = -INF;
    for (int l = 0; l < n - 1; ++l)
        for (int r = l; r < n && (n - (r - l + 1) >= k - 1); ++r) {
            for (int l_ = 0; l_ < l; ++l_)
                for (int r_ = l_; r_ < l && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
            for (int l_ = r + 1; l_ < n; ++l_)
                for (int r_ = l_; r_ < n && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
        }
    cout << answer;
    return 0;
}
