#include <iostream>
#include <vector>
#include <bitset>

using namespace std;
typedef long long ll;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, s; cin >> n >> s;
    vector<ll> K(n);
    vector< vector<ll> > C(n);
    for (ll i = 0; i < n; ++i) {
        cin >> K[i];
        C[i].reserve(K[i]);
        for (ll j = 0; j < K[i]; ++j)
            cin >> C[i][j];
    }
    bitset<10> LastD;
    bitset<10> NewD;
    LastD[0] = 1;
    vector< pair<ll, ll> > P(s + 1, {-1, -1});
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < K[i]; ++j) {
            for (ll w  = 0; w < s; ++w) {
                if (LastD[w] == 0 && NewD[w] == 0) continue;
                if (w + C[i][j] > s) continue;
                if (P[w].first == i && P[w].second == j) continue;
                NewD[w + C[i][j]] = 1;
                P[w + C[i][j]] = {i, j};
            }
        }
        LastD = NewD;
        NewD = 0;
    }
    if (LastD[s] == 0) {
        cout << "No\n";
        return 0;
    }
    cout << "Yes\n";
    vector< vector<ll> > answer(n);
    for (ll i = 0; i < n; ++i)
        answer[i].resize(K[i]);
    ll w = s;
    while (w != 0) {
        //cout << w << " " << P[w].first << " " << P[w].second << "\n";
        answer[P[w].first][P[w].second] = 1;
        w -= C[P[w].first][P[w].second];
    }
    for (ll i = 0; i < n; ++i) {
        ll number = 0;
        for (ll j = 0; j < K[i]; ++j)
            number += answer[i][j];
        cout << number << "\n";
        for (ll j = 0; j < K[i]; ++j) {
            if (!answer[i][j]) continue;
            cout << j + 1 << "\n";
        }
    }
    return 0;
}
