#include <iostream>
#include <vector>
#include <unordered_map>
// #include <bitset>

using namespace std;
typedef long long ll;
const ll INF = 1e18;

int n, m, k;


ll f_(int i, int j, vector< vector<int> >& used, unordered_map< int, unordered_map<int, int> >& M, int number) {
    if (i == 0 && j == 0) {
        return (number == k);
    }
    ll answer = 0;
    if (i > 0 && !used[i - 1][j]) {
        used[i - 1][j] = 1;
        answer += f_(i - 1, j, used, M, number + M[i - 1][j]);
        used[i - 1][j] = 0;
    }
    if (j > 0 && !used[i][j - 1]) {
        used[i][j - 1] = 1;
        answer += f_(i, j - 1, used, M, number + M[i][j - 1]);
        used[i][j - 1] = 0;
    }
    return answer;
}

ll f(int i, int j, vector< vector<int> >& used, unordered_map< int, unordered_map<int, int> >& M, int number) {
    if (i == n - 1 && j == m - 1) {
        return f_(i, j, used, M, number);
    }
    ll answer = 0;
    if (i + 1 < n && !used[i + 1][j]) {
        used[i + 1][j] = 1;
        answer += f(i + 1, j, used, M, number + M[i + 1][j]);
        used[i + 1][j] = 0;
    }
    if (j + 1 < m && !used[i][j + 1]) {
        used[i][j + 1] = 1;
        answer += f(i, j + 1, used, M, number + M[i][j + 1]);
        used[i][j + 1] = 0;
    }
    return answer;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    unordered_map< int, unordered_map<int, int> > M;
    for (int i = 0; i < k; ++i) {
        int a, b; cin >> a >> b;
        M[a][b] = 1;
    }
    vector< vector<int> > used(n, vector<int> (m, 0));
    cout << f(0, 0, used, M, 0) / 2;
    return 0;
}
