#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

ll fl(ll n, string l) {
    ll ans = 0;
    ll e = 0;
    for (; e < n; e++) {
        if ((l[e] - '0') != 1) {
            break;
        }
    }
    if (e == n || l[e] == '0') {
        ans += 4 * n;
    } else if ((l[e] - '0') < 7) {
        if (l[e] == '2' || l[e] == '3' || l[e] == '5') {
            ans += 4 * e + 1;
            if (l[e] == '2') {
                ans += 2;
            } else if (l[e] == '3') {
                ans += 1;
            }
            bool f = true;
            e++;
            for (; e < n; e++) {
                if ((l[e] - '0') > 1) {
                    f = false;
                    break;
                }
                if (l[e] == '0') {
                    break;
                }
            }
            if (f) {
                ans++;
            }
        } else {
            ans += 4 * e + 1;
            if (l[e] == '4') {
                ans += 1;
            }
        }
    } else {
        ans += 4 * e;
        if (l[e] == '7') {
            bool f = true;
            e++;
            for (; e < n; e++) {
                if ((l[e] - '0') > 1) {
                    f = false;
                    break;
                }
                if (l[e] == '0') {
                    break;
                }
            }
            if (f) {
                ans++;
            }
        }
    }
    return ans;
}

ll fr(ll n, string l) {
    ll e = 0, ans = 0;
    for (; e < n; e++) {
        if ((l[e] - '0') != 1) {
            break;
        }
    }
    if (e == n || l[e] == '0') {
        ans += 0;
    } else if ((l[e] - '0') <= 7) {
        if (l[e] == '7' || l[e] == '3' || l[e] == '5') {
            ans += 4 * (n - e - 1) + 1;
            if (l[e] == '7') {
                ans += 2;
            } else if (l[e] == '5') {
                ans += 1;
            }
            bool f = true;
            e++;
            for (; e < n; e++) {
                if ((l[e] - '0') > 1) {
                    break;
                }
                if (l[e] == '0') {
                    f = false;
                    break;
                }
            }
            if (f) {
                ans++;
            }
        } else {
            if (l[e] == '2') {
                ans += 4 * (n - e - 1);
                bool f = true;
                e++;
                for (; e < n; e++) {
                    if ((l[e] - '0') > 1) {
                        break;
                    }
                    if (l[e] == '0') {
                        f = false;
                        break;
                    }
                }
                if (f) {
                    ans++;
                }
            } else {
                ans += 4 * (n - e - 1) + 2;
                if (l[e] == '6') {
                    ans += 1;
                }
            }
        }
    } else {
        ans += 4 * (n - e);
    }
    return ans;
}

void solve() {
    string l, r;
    cin >> l >> r;
    ll n = l.size();
    ll m = r.size();
    if (n == m) {
        if (n > 1e4) {
            cout << n / 0;
        }
        ll ans = 0;
        string s(n, '1');
        s[n - 1] = '2';
        ll ind = n - 1;
        while (ind >= 0 && s <= r) {
            if (s >= l) {
                ans++;
            }
            if (s[ind] == '7') {
                s[ind] = '1';
                if (ind != 0) {
                    s[ind - 1] = '2';
                }
                ind--;
            } else {
                if (s[ind] == '5') {
                    s[ind] = '7';
                } else if (s[ind] == '3') {
                    s[ind] = '5';
                } else {
                    s[ind] = '3';
                }
            }
        }
        cout << ans;
        return;
    }
    ll ans = 0;
    for (ll i = n + 1; i < m; i++) {
        ans += 4 * i;
    }
    ans += fl(n, l);
    ans += fr(m, r);
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
