#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-8;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> ls(n);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i];
    }
    if (k == 1) {
        cout << 1;
        return;
    }
    if (k == 2) {
        pair<ll, ll> a = {0, 0};
        if (ls[0] == 0) {
            a.first = 1;
        } else if (ls[0] == 2) {
            a.second = 1;
        } else {
            a.first = 1;
            a.second = 1;
        }
        for (ll i = 1; i < n; i++) {
            if (ls[i] == 0) {
                a.second = 0;
            }
            if (ls[i] == 3) {
                a.first = 0;
            }
            if (ls[i] == 1) {
                a = {(a.second + a.first) % mod, a.first};
            }
            if (ls[i] == 2) {
                a = {a.second, (a.second + a.first) % mod};
            }
        }
        cout << (a.first + a.second) % mod;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
