#include <iostream>
#include <set>
#include <bitset>
#include <vector>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

ll n, m, k;
vector<vector<bool>> ls;

vector<vector<bool>> vis;

ll fu(ll i, ll j, ll ost, bool f) {
    vis[i][j] = true;
    if (ls[i][j]) {
        ost--;
    }
    if (i == n - 1 && j == m - 1) {
         f = false;
    }
    if (i == n - 2 && j == 0) {
        if (ost == 0) {
            return 1;
        }
        return 0;
    }
    ll ans = 0;
    if (f) {
        if (i < n - 1 && !vis[i + 1][j]) {
            ans += fu(i + 1, j, ost, f);
        }
        if (j < m - 1  && !vis[i][j + 1]) {
            ans += fu(i, j + 1, ost, f);
        }
    } else {
        if (i > 0  && !vis[i - 1][j]) {
            ans += fu(i - 1, j, ost, f);
        }
        if (j > 0 && !vis[i][j - 1]) {
            ans += fu(i, j - 1, ost, f);
        }
    }
    vis[i][j] = false;
    return ans % mod;
}

void solve() {
    cin >> n >> m >> k;
    if (n == 3) {
        vector<bool> s(m, false);
        ll f = 0, t = m + 1;
        for (ll i = 0; i < k; i++) {
            ll x, y;
            cin >> x >> y;
            if (x == 1) {
                f = max(f, y - 1);
            } else if (x == 2) {
                s[y - 1] = true;
            } else {
                t = min(t, y - 1);
            }
        }
        ll ans = 0;
        for (ll i = f; i < m; i++) {
            for (ll j = 0; j <= min(i - 1, t); j++) {
                bool fl = true;
                for (ll e = j + 1; e < i; e++) {
                    if (s[e]) {
                        fl = false;
                        break;
                    }
                }
                if (fl) {
                    ans = (ans + 1) % mod;
                }
            }
        }
        cout << (ans * 2) % mod;
        return;
    }
    ls.resize(n, vector<bool> (m, false));
    for (ll i = 0; i < k; i++) {
        ll x, y;
        cin >> x >> y;
        ls[x - 1][y - 1] = true;
    }
    cout << fu(n - 1, 1, k, true);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
