#include <iostream>
#include <deque>
#include <cmath>
#include <algorithm>

using namespace std;

deque<long long> poland(deque <long long>& d){
    deque<long long> line(1);
    if (d[0] < d[d.size()-1]){
        line[0] = d[0];
        d.pop_front();
    } else {
        line[0] = d[d.size()-1];
        d.pop_back();
    }
    return line;
}

int main() {
    int n,k;
    long long minsum = 1000000001,maxsum = 0;
    cin >> n >> k;
    deque<long long> d(n), a(0);
    for (int i = 0; i < n; i++){
        cin >> d[i];
    }
    int j = 1;
    while (j != k){
        a = poland(d);
        if (minsum > a[0]){
            minsum = a[0];
        }
        j++;
    }
    for (int i = 0; i < d.size(); i ++){
        maxsum+=d[i];
    }
    cout << maxsum - minsum;
    return 0;
}

