#include <iostream>
#include <vector>
#include <cmath>

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

vector<pair<ll, bool>> res;

ll ans = -2;

void f(const vector<ll>& vec, ll ind, ll k, ll num) {
	if (ind == vec.size()) {
		ll mx = -1, mn = 1e18;
		bool flag = true;
		for (int i = 0; i < k; i++) {
			if (!res[i].second) {
				flag = false;
				break;
			}

			if (res[i].first > mx) {
				mx = res[i].first;
			}

			if (res[i].first < mn) {
				mn = res[i].first;
			}
		}

		if (flag && mx - mn > ans) {
			ans = mx - mn;
		}

		return;
	}

	for (int i = num; i < k; i++) {
		res[i].first += vec[ind];
		res[i].second = true;
		f(vec, ind + 1, k, i);
		res[i].first -= vec[ind];
		if (res[i].first == 0) {
			res[i].second = false;
		}
	}
}

int main() {
	ll n, k;
	cin >> n >> k;

	vector<ll> vec(n);
	bool flag = true;
	for (int i = 0; i < n; i++) {
		cin >> vec[i];

		if (vec[i] != 0) {
			flag = false;
		}
	}

	if (flag) {
		cout << "0\n";
		return 0;
	}

	res.resize(k, { 0, false });
	f(vec, 0, k, 0);

	cout << ans << "\n";
}