from functools import reduce


def prime(a):
    if a in [0, 1]:
        return False
    for i in range(2, int(a**0.5+1)):
        if a % i == 0 or a % (a//i) == 0:
            return False
    return True


def solve(l, r):
    c = 0
    for i in range(l, r+1):
        i = reduce(lambda x, y: x*y, [int(j) for j in str(i)])
        c += prime(i)

    return c

if __name__ == "__main__":
    l = int(input())
    r = int(input())
    print(solve(l, r))