#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;
struct  node
{
	int i, j, c, ch, b;
};
int main()
{
	int n, s;
	cin >> n >> s;
	vector<vector<int>> a(n);
	vector<vector<vector<int>>> dp0(n);
	vector<vector<vector<int>>> dp1(n);
	vector<vector<vector<node>>> pr1(n);
	vector<vector<vector<node>>> pr0(n);
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		a[i].assign(k, 0);
		dp0[i].assign(k, vector<int>(s + 1));
		dp1[i].assign(k, vector<int>(s + 1));

		pr0[i].assign(k, vector<node>(s + 1, { -1, -1, -1, -1, -1 }));
		pr1[i].assign(k, vector<node>(s + 1, { -1, -1, -1, -1, -1 }));
		for (int j = 0; j < k; j++)
			cin >> a[i][j];

	}
	dp0[0][0][0] = 1;
	pr0[0][0][0] = { -1, -1, -1, -1, -1 };

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < a[i].size(); j++)
		{
			for (int c = 0; c <= s; c++)
			{
				if (i == 0 && j == 0)
				{
					if (c == a[i][j])
					{
						dp0[i][j][c] = 1;
						dp1[i][j][c] = 1;
						pr0[i][j][c] = { -1, -1, -1, -1,1 };
						pr1[i][j][c] = { -1,-1, -1, -1, 1 };
					}

				}
				else if (j != 0)
				{
					if (c - a[i][j] >= 0)
					{
						dp0[i][j][c] = max(dp0[i][j - 1][c], dp0[i][j - 1][c - a[i][j]]);
						dp1[i][j][c] = max(dp1[i][j - 1][c], dp0[i][j - 1][c - a[i][j]]);

						if (dp1[i][j - 1][c])
							pr1[i][j][c] = { i, j - 1, c, 1, 0  };
						else
							pr1[i][j][c] = { i, j - 1, c - a[i][j], 0, 1 };

						if (dp0[i][j - 1][c])
							pr0[i][j][c] = { i, j - 1, c, 0, 0 };
						else
							pr0[i][j][c] = { i, j - 1, c - a[i][j], 0, 1  };
					}
					else
					{
						dp0[i][j][c] = dp0[i][j - 1][c];
						dp1[i][j][c] = dp1[i][j - 1][c];

						pr0[i][j][c] = { i, j - 1, c, 0, 0 };
						pr1[i][j][c] = { i, j - 1, c, 1, 0 };
					}
				}
				else
				{
					if (c - a[i][j] >= 0)
					{
						dp0[i][j][c] = max(dp1[i - 1][a[i - 1].size() - 1][c], dp1[i - 1][a[i - 1].size() - 1][c - a[i][j]]);
						dp1[i][j][c] = dp1[i - 1][a[i - 1].size() - 1][c - a[i][j]];

						if (dp1[i - 1][a[i - 1].size() - 1][c])
							pr0[i][j][c] = { i - 1, int(a[i - 1].size()) - 1, c, 1, 0 };
						else
							pr0[i][j][c] = { i - 1, int(a[i - 1].size()) - 1, c - a[i][j], 1, 1 };
						pr1[i][j][c] = { i - 1, int(a[i - 1].size()) - 1, c - a[i][j], 1, 1 };
					}
					else
					{
						dp0[i][j][c] = dp1[i - 1][a[i - 1].size() - 1][c];
						dp1[i][j][c] = 0;
						pr0[i][j][c] = { i - 1, int(a[i - 1].size()) - 1, c, 1, 0 };

					}
					
				}

			}
		}
	}
	if (dp1[n - 1][a[n - 1].size() - 1][s] == 1)
	{
		cout << "Yes\n";
		vector<vector<int>> ans(n);
		for (int i = 0; i < n; i++)
		{
			ans[i].assign(a[i].size(), 0);
		}


		int i = n - 1, j = a[n - 1].size() - 1, c = s, ch = 0;

		while (i != -1)
		{
			if (ch == 1)
			{
				if (pr1[i][j][c].b == 1)
					ans[i][j] = 1;
				int i1 = pr1[i][j][c].i;
				int j1 = pr1[i][j][c].j;
				int c1 = pr1[i][j][c].c;
				i = i1;
				j = j1;
				c = c1;
			}
			else
			{
				if (pr0[i][j][c].b == 1)
					ans[i][j] = 1;
				int i1 = pr0[i][j][c].i;
				int j1 = pr0[i][j][c].j;
				int c1 = pr0[i][j][c].c;
				i = i1;
				j = j1;
				c = c1;
			}
		}



		for (int i = 0; i < n; i++)
		{
			vector<int> ans1;
			for (int j = 0; j < a[i].size(); j++)
				if (ans[i][j])
					ans1.push_back(j + 1);
			if (ans1.size())
			{
				cout << ans1.size() << "\n";
				for (int j = 0; j < ans1.size(); j++)
					cout << ans1[j] << " ";
				cout << "\n";
			}
		}
	}
	else
	{
		cout << "No";
	}
}

