#include <bits/stdc++.h>
#define int long long
#define endl "\n"

using namespace std;
vector<vector<int>> pieces;
vector<int> h;


int get(int piece) {
    int w = 0;
    for (int p = 0; p < pieces[piece].size(); p++) {
        int lefter = -1;
        for (int i = 0; i <= p; i++) lefter = max(lefter, h[pieces[piece][i]]);
        int righter = -1;
        for (int i = p; i < pieces[piece].size(); i++) righter = max(righter, h[pieces[piece][i]]);
        w += min(lefter, righter) - h[pieces[piece][p]];
    }
    return w;
}


void union_(int x) {
    for (int i = x; i < pieces.size() - 1; i++) {
        for (auto j: pieces[i + 1])
            pieces[i].push_back(j);
        pieces[i + 1].clear();
    }
    pieces.pop_back();
}


void solve() {
    int n;
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; i++)
        cin >> h[i];
    vector<int> k(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> k[i];
        k[i]--;
    }
    for (int i = 0; i < n; i++)
        pieces.emplace_back(vector<int>{i});
    for (int i = 0; i < n - 1; i++) {
        union_(k[i]);
        cout << get(k[i]) << endl;
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    t = 1;
    while (t--)
        solve();
    return 0;
}
