#include <bits/stdc++.h>
#define int int64_t
#define inf INT64_MAX
#define endl "\n"
using namespace std;
vector<int> t;


void build(int v, int tl, int tr, vector<int> &a) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm, a);
    build(v * 2 + 1, tm + 1, tr, a);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}


int getmin(int v, int tl, int tr, int l, int r) {
    if (l > r)
        return 1e18l;
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    int first = getmin(v * 2, tl, tm, l, min(r, tm));
    int second = getmin(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
    return min(first, second);
}


int solve(int n, int k, vector<int>&a) {
    t.clear();
    t.resize(12 * 100000, 1e18l);
    vector<int> suf_sum(n);
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            suf_sum[i] = a[i];
            continue;
        }
        suf_sum[i] = suf_sum[i + 1] + a[i];
    }
    vector<int> suf_min(n);
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            suf_min[i] = a[i];
            continue;
        }
        suf_min[i] = min(suf_min[i + 1], a[i]);
    }

    vector<int> bad(n);
    for (int i = 0; i < n; i++) {
        bad[i] = suf_sum[i] + suf_min[i];
    }
    build(1, 0, n - 1, bad);
    int res = -1;
    for (int l = 0; l < n - 1; l++) {
        int now = getmin(1, 0, n - 1, l + 1, n - max((k - l), 1ll));
        res = max(res, suf_sum[l] - now);
        if (k == 2)
            break;
    }
    return res;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    k--;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int solve_front = solve(n, k, a);
    reverse(a.begin(), a.end());
    int solve_back = solve(n, k, a);
    cout << max(solve_front, solve_back);
}
