#include <bits/stdc++.h>
#define int int64_t
#define inf INT64_MAX
#define endl "\n"
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, s;
    cin >> n >> s;
    vector<vector<int>> costs(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            costs[i].push_back(x);
        }
    }
    if (n == 1) {
        vector<int> a = costs[0];
        n = a.size();
        vector<vector<int>> dp(n + 1, vector<int>(s + 1, -1));
        vector<vector<pair<int, int>>> back(n + 1, vector<pair<int, int>>(s + 1, make_pair(-2ll, -2ll)));
        dp[0][0] = 0;
        back[0][0] = {-1, -1};
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j <= s; j++) {
                if (dp[i - 1][j] != -1) {
                    dp[i][j] = dp[i - 1][j];
                    back[i][j] = make_pair(i - 1, j);
                }
                else if (j >= a[i - 1] && dp[i - 1][j - a[i - 1]] != -1) {
                    dp[i][j] = dp[i - 1][j - a[i - 1]] + 1;
                    back[i][j] = make_pair(i - 1, j - a[i - 1]);
                }
            }
        }
        if (dp[n][s] == -1) {
            cout << "No" << endl;
            return 0;
        }
        cout << "Yes" << endl;
        cout << dp[n][s] << endl;
        int i = n;
        int j = s;
        while (i != 0 && j != 0) {
            if (back[i][j].second != j) {
                cout << i << endl;
            }
            auto tmp = back[i][j];
            i = tmp.first;
            j = tmp.second;
        }
    }
}
