#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <random>
#include <chrono>
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;

/*#define _GLIBCXX_DEBUG random device rd;
mt19937_rg(chrono(high_time_resilution()(now()_since_time_apoch() :(count()))*/


int num(char i) {
	return i - '0';
}

ll bin_pow(ll n, ll s) {
	if (s == 0)
		return 1;
	if (s % 2)
		return n * bin_pow(n, s - 1);
	return bin_pow(n * n, s / 2);
}

bool is_simple(ll n) {
	if (n < 2)
		return false;
	for (int i = 2; i < n; i++)
		if (n % i == 0) return false;
	return true;
}

ll count_dp(string n) {
	vector <vector <vector <int>>> dp(n.size() + 1, vector <vector <int>>(2, vector <int>(10)));
	vector <ll> simps = {2, 3, 5, 7 };
	for (int d : simps) {
		if (d < num(n[0])) {
			for (int c = 0; c <= 9; c++) {
				dp[1][0][c]++;
			}
		}
		else if (d == num(n[0]))
			for (int c = 0; c <= 9; c++) {
				dp[1][1][c] = 1;
			}
	}
	for (int len = 1; len < n.size(); len++) {
		for (int d : simps) {
			if (d == num(n[len])) {
				for (int c = 0; c <= 9; c++) {
					dp[len + 1][1][c]++;//= dp[len][1][d];
					dp[len + 1][0][c]++;//= dp[len][0][d];
				}
			}
			else if (d < num(n[len])) {
				for (int c = 0; c <= 9; c++) {
					dp[len + 1][0][c]++;//= dp[len][1][d] + dp[len][0][d];
				}
			}
			else {
				for (int c = 0; c <= 9; c++) {
					dp[len + 1][0][c] += dp[len][0][d];
				}
			}
		}
	}
	ll ans = 0;
	for (int i = 0; i <= 9; i++) {
		ans += dp[n.size()][0][i] + dp[n.size()][1][i];
	}
	return ans;
}

bool find_zero(string s) {
	for (int i = 0; i < s.size(); i++)
		if (s[i] == '0')
			return false;
	return true;
}

ll get_dp(string n) {
	ll ans = 0;
	vector <ll> simps = { 2, 3, 5, 7 };

	if (n.size() == 1) {
		for (int i : simps)
			if (i <= num(n[0]))
				ans++;
		return ans;
	}
	for (int i = 1; i < n.size(); i++)
		ans += 4 * i;
	if (num(n[0]) > 1)
		ans += 4 * (n.size() - 1);
	else {
		for (int i = 0; i < n.size(); i++) {
			if (n[i] == 0)
				return ans;
			if (num(n[i]) > 1) {
				ans += 4 * (n.size() - i - 1);
				for (int t : simps) {
					if (t < num(n[i])) {
						ans++;
 					}
					else if (t == num(n[i])) {
						if (find_zero(n))
							ans++;
					}
					else
						break;
				}
				break;
			}
		}
	}
	for (int i : simps) {
		if (i < num(n[0])) {
			ans++;
		}
		else if (i == num(n[0])) {
			if (find_zero(n))
				ans++;
		}
		else
			break;
	}
	return ans;
}

void sample() {
	string a, b;
	cin >> a >> b;

	ll ans = get_dp(b) - get_dp(a);
	int cnt = 1;
	for (int i = 0; i < a.size(); i++) {
		cnt *= num(a[i]);
	}
	if (cnt == 2 || cnt == 3 || cnt == 5 || cnt == 7)
		ans++;
	cout << ans;
}

int main() {
	sample();
	return 0;
}