#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

bool isin(vector<string> a, string s) {
    for (auto i:a) {
        if (s==i) return true;
    }
    return false;
}

vector<string> generate(int n) {
    string alp = "2357";
    vector<string> ans;
    for (int i=0; i<n; i++) {
        for (auto c : alp) {
            string tmp = "";
            for (auto j=0; j<n-i-1; j++) tmp.push_back('1');
            tmp.push_back(c);
            for (auto j=0; j<i; j++) tmp.push_back('1');
            ans.push_back(tmp);
        }
    }
    return ans;
}

pair<string, int> up(string a) {
    vector<string> tmp = generate(a.size());
    tmp.push_back(a);
    sort(tmp.begin(), tmp.end());
    //for (auto i:tmp) cout << "up: " << i << endl;
    if (tmp[tmp.size()-1] == a) {
        a = generate(a.size()+1)[0];
        return {a, 0};
    }
    else {
        int ptr = 0;
        for (int i=0; i<tmp.size(); i++) {
            if (tmp[i] == a) {
                ptr = i;
                //cout << ptr << endl;
                break;
            }
        }
        a = tmp[ptr+1];
        return {a, tmp.size()-ptr};
    }
}

pair<string, int> down(string a) {
    vector<string> tmp = generate(a.size());
    tmp.push_back(a);
    sort(tmp.begin(), tmp.end());
    //for (int i=0; i<tmp.size(); i++) cout << "down : " << tmp[i] << endl;
    int ptr = 0;
    if (tmp[0] == a) {
        ptr = (a.size()-1)*4-1;
        a = generate(a.size()-1)[ptr];
        return {a, ptr};
    }
    else {
        for (int i=0; i<tmp.size(); i++) {
            if (tmp[i] == a) {
                ptr = i;
                //cout << ptr;
                break;
            }
        }
        a = tmp[ptr-1];
        return {a, ptr-1};
    }
}

int main() {
    string l, r; cin >> l >> r;
    int ans = 0;
    pair<string, int> pl, pr;
    vector<string> tmp;

    int lind = 0, rind = 0;

    if ( !(isin(generate(l.size()), l)) )  {
        pl = up(l); // если l не простоватое, добить вверх
        lind = pl.second;
    }
    else {
        //cout << "generatel " << l.size() << endl;
        tmp = generate(l.size());
        //for (auto i : tmp) cout << i << " ";
        //cout << endl;
        for (int i=0; i<tmp.size(); i++) {
            if (tmp[i] == l) {
                lind = tmp.size()-i;
                //cout << lind << endl;
                break;
            }
        }
    }

    if ( !(isin(generate(r.size()), r)) )  {
        pr = down(r); // если r не простоватое, добить вниз
        rind = pr.second;
    }
    else {
        tmp = generate(r.size());
        for (int i=0; i<tmp.size(); i++) {
            if (tmp[i] == r) {
                rind = i;
                break;
            }
        }
    }

    if (r.size() - l.size() >= 2) {
        for (int i = l.size() + 1; i < r.size(); i++) ans += i*4;
        //cout << ans << endl;
    }

    ans += rind + lind;

    if (pl.first.size() == pr.first.size()) {
        ans = lind + rind - generate(l.size()).size() + 1;
    }

    //cout << pl.first << " " << pr.first << " " << lind << " " << rind << endl;

    cout << ans;
    return 0;
}