#include <iostream>
#include <vector>
using namespace std;

vector<vector<bool>> inuse;
vector<pair<int, int>> kcoords;
int n, m, k;

void printmap() {
    for (auto i:inuse) {
        for (auto j:i) cout << (j?"#":".");
        cout << endl;
    }
}

bool isin(vector<pair<int, int>> a, pair<int, int> b) {
    //cout << "[D] check: start" << endl;
    for (int i=0; i<a.size(); i++) {
        if (a[i] == b) {
            //cout << "[D] check: end (true)" << endl;
            return true;
        }
    }
    //cout << "[D] check: end (false)" << endl;
    return false;
}

void dfs(int x, int y, int kcnt, bool reverse, int &cnt, int layer) {
    //cout << "[D] x = " << x << ", y = " << y << ";" << "layer: " << layer << endl;
    inuse[x][y] = true; inuse[0][0] = false;
    //printmap();
    if (isin(kcoords, {x, y}) && !(x==0 && y==0)) kcnt++;
    if (!reverse) {
        //cout << "[D] trying x+1: ";
        if (x!=n-1 && !inuse[x+1][y]) {
            //cout << 1 << endl;
            dfs(x+1, y, kcnt, reverse, cnt, layer+1);
        }
        //else cout << 0 << endl;
        //cout << "[D] trying y+1: ";
        if (y!=m-1 && !inuse[x][y+1]) {
            //cout << 1 << endl;
            dfs(x, y+1, kcnt, reverse, cnt, layer+1);
        }
        //else cout << 0 << endl;
    }
    if (x == n-1 && y == m-1) reverse = true;
    if (reverse) {
        //cout << "[D] trying x-1: ";
        if (x!=0 && !inuse[x-1][y]) {
            //cout << 1 << endl;
            dfs(x-1, y, kcnt, reverse, cnt, layer+1);
        }
        //else cout << 0 << endl;
        //cout << "[D] trying y-1: ";
        if (y!=0 && !inuse[x][y-1]) {
            //cout << 1 << endl;
            dfs(x, y-1, kcnt, reverse, cnt, layer+1);
        }
        //else cout << 0 << endl;
    }
    if (x == 0 && y == 0 && kcnt == k) {
        cnt++;
        if (cnt == 1e9+7) cnt = 0;
    }
    inuse[x][y] = false;
}

int main() {
    cin >> n >> m >> k;
    inuse.resize(n);
    for (auto &i : inuse) i.resize(m, false);
    for (int i=0; i<k; i++) {
        int x, y; cin >> x >> y;
        kcoords.push_back({x-1, y-1});
    }
    int cnt = 0;
    if (isin(kcoords, {0, 0})) dfs(0, 0, 1, false, cnt, 0);
    else dfs(0, 0, 0, false, cnt, 0);
    cout << cnt;
    return 0;
}