#include <iostream>
#include <vector>
#include <string>

using namespace std;
using ll = long long;

ll mul(ll a) {
    ll res = 1;
    while (a > 0) {
        res *= a % 10;
        a /= 10;
    }
    return res;
}

ll stupid(ll a, ll b) {
    ll ans = 0;
    for (ll i = a; i <= b; i++) {
        ll res = mul(i);
        if (res == 2 || res == 3 || res == 5 || res == 7) {
            ans++;
        }
    }
    return ans;
}

ll fullk(string& l, string& r) {
    ll n = l.size(), m = r.size();
    return (m + 1) * m * 2 - (n + 1) * n * 2;
}

ll partk(string& l, string& r) {
    ll n = l.size(), m = r.size();
    ll o1 = 0, o2 = 0;
    for (int i = 0; i < n; i++) {
        if (l[i] > '1') break;
        o1++;
    }
    for (int i = 0; i < m; i++) {
        if (r[i] > '1') break;
        o2++;
    }
    ll resl = o1 * 4;
    ll resr = o2 * 4;
    if (o1 != n) {
        if (l[o1] == '2' || l[o1] == '3' || l[o1] == '5' || l[o1] == '7') {
            bool win = true;
            for (int i = o1 + 1; i < n; i++) {
                if (l[i] > '1') win = false;
            }
            if (win) resl++;
        }
        if (l[o1] - '0' < 2) resl++;
        if (l[o1] - '0' < 3) resl++;
        if (l[o1] - '0' < 5) resl++;
        if (l[o1] - '0' < 7) resl++;
    }
    if (o2 != m) {
        if (r[o2] == '2' || r[o2] == '3' || r[o2] == '5' || r[o2] == '7') {
            bool win = true;
            bool ex = false;
            for (int i = o2 + 1; i < m; i++) {
                if (r[i] > '1') win = false;
                if (r[i] == '0') ex = true;
            }
            if (win && ex) resr++;
        }
        if (r[o2] - '0' < 2) resr++;
        if (r[o2] - '0' < 3) resr++;
        if (r[o2] - '0' < 5) resr++;
        if (r[o2] - '0' < 7) resr++;
    }
    return resl - resr;
}

int main() {
    string s1, s2;
    ll a = 1, b;
    cin >> s1;
    if (s1 == "1") cin >> b;
    else cin >> s2;
    if (s1 != "1") cout << fullk(s1, s2) + partk(s1, s2) << '\n';
    else cout << stupid(a, b) << '\n';
    return 0;
}
