#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;

string test = "5 3 2 1 3 4 1";

vector<ll> pref(vector<ll>& arr) {
    vector<ll> p(arr.size() + 1, 0);
    for (ll i = 0; i < arr.size(); i++) {
        p[i + 1] = p[i] + arr[i];
    }
    return p;
}

int main() {
    ll n, K;
    cin >> n >> K;
    vector<ll> arr(n);
    for (ll& o : arr) cin >> o;
    vector<ll> p = pref(arr);
    vector<ll> smn(n + 1, inf);
    vector<ll> pmn(n + 1, inf);
    for (ll i = 0; i < n; i++) {
        pmn[i + 1] = min(pmn[i], arr[i]);
    }
    for (ll i = n; i > 0; i--) {
        smn[i - 1] = min(smn[i], arr[i - 1]);
    }
    if (K == 2) {
        ll mx = 0;
        ll k = n - K + 1;
        for (ll i = 0; i <= n - k; i++) {
            mx = max(mx, abs((p[i + k] - p[i]) - min(pmn[i], smn[i + k])));
        }
        cout << mx << endl;
        return 0;
    }
    ll mx = 0;
    for (ll k_ = K; k_ <= n && k_ <= K + 1'000; k_++) {
        ll k = n - k_ + 1;
        for (ll i = 0; i <= n - k; i++) {
            mx = max(mx, abs((p[i + k] - p[i]) - min(pmn[i], smn[i + k])));
        }
    }
    cout << mx << endl;
    return 0;
}
