#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#ifdef OST
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template<class T> using ordered_set=tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

struct ps_t
{
    ll sm;
    vector<ll> idx;
};

void gps(vector<ps_t>& ans, vector<ll>& src)
{
    ans.reserve(src.size()*src.size());
    for(ll i = 0; i < src.size(); i++)
    {
        ll csz = ans.size();
        for(ll j = 0; j < csz; j++)
        {
            ps_t tmp = ans[j];
            tmp.idx.push_back(i);
            tmp.sm += src[i];
            ans.push_back(tmp);
        }
        ans.push_back({src[i], {i}});
        ans.back().idx.reserve(1000);
    }
}

ll ga(vector<vector<ps_t>>& dt, vector<ll>& ans, ll cr, ll csm, ll s)
{
    for(ll i = 0; i < dt[cr].size(); i++)
    {
        if(cr == dt.size()-1)
        {
            ll cttl = csm + dt[cr][i].sm;
            if(cttl == s)
            {
                ans[cr] = i;
                return cttl;
            }
        }
        else {
            ll cttl = ga(dt, ans, cr + 1, csm + dt[cr][i].sm, s);
            if (cttl == s) {
                ans[cr] = i;
                return cttl;
            }
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, s;
    cin >> n >> s;
    vector<vector<ll>> vec(n);
    for(ll i = 0; i < n; i++)
    {
        ll k;
        cin >> k;
        vec[i].reserve(k);
        for(ll j = 0; j < k; j++)
        {
            ll tmp;
            cin >> tmp;
            vec[i].push_back(tmp);
        }
    }

    vector<vector<ps_t>> psm(n);
    for(ll i = 0; i < n; i++)
    {
        gps(psm[i], vec[i]);
    }

    vector<ll> ans(n);
    ll as = ga(psm, ans, 0, 0, s);
    if(as == s)
    {
        cout << "Yes\n";
        for(ll i = 0; i < n; i++)
        {
            cout << psm[i][ans[i]].idx.size() << "\n";
            for(auto j: psm[i][ans[i]].idx)
                cout << j+1 << " ";
            cout << "\n";
        }
    }
    else
    {
        cout << "No\n";
    }

    return 0;
}
