#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
using namespace std;
using ill = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, s, m = 0;
    cin >> n >> s;
    vector<vector<int>> c(n);
    vector<int> w;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        m += k;
        c[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> c[i][j];
            w.emplace_back(c[i][j]);
        }
    }
    sort(w.begin(), w.end());

    vector<vector<bool>> dp(m + 1, vector<bool>(s + 1, false));
    vector<int> p(s + 1, -1);
    dp[0][0] = true;
    if (n == 1) {
        for (int i = 1; i <= m; i++)
            for (int j = 0; j <= s; j++) {
                dp[i][j] = dp[i - 1][j];
                if (j - w[i - 1] >= 0 && dp[i - 1][j - w[i - 1]]) {
                    if (p[j] == -1)
                        p[j] = i - 1;
                    dp[i][j] = true;
                }
            }
        for (int i = 0; i <= s; i++)
            cout << p[i] << ' ';
        cout << '\n';
        if (!dp[m][s]) {
            cout << "No";
            return 0;
        }
        cout << "Yes" << '\n';
        vector<int> ans;
        int j = s;
        for (int i = m; i > 0; i--) {
            if (dp[i - 1][j])
                continue;
            ans.push_back(p[j]);
            j -= w[i];
        }
        cout << ans.size() << '\n';
        for (int i = ans.size() - 1; i >= 0; i--)
            cout << ans[i] + 1 << ' ';
        return 0;
    }

    int ans = 0;
    for (int i = 0; i < n; i++)
        ans += w[i];
    if (ans != s) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << '\n';
    for (int i = 0; i < 2 * n; i++)
        cout << 1 << '\n';
    return 0;
}
