#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,tree_order_statistics_node_update>;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

typedef long long ll;
typedef long double ld;

struct Test {
    vector<char> primes = {'2', '3', '5', '7'};

    ll get(const string &s) {
        ll ans = 2 * (s.size() - 1) * s.size();
        for (int v = 0; v < s.size(); v++) {
            if (s[v] != '1') {
                ans += (s.size() - v - 1) * 4;
                for (auto prime: primes) {
                    if (s[v] > prime)ans++;
                    if (s[v] == prime) {
                        bool flag = true;
                        for (int u = v + 1; u < s.size(); u++) {
                            if (s[u] == '0') {
                                flag = false;
                                break;
                            }
                            if (s[u] > '1')break;
                        }
                        ans += flag;
                    }
                }
                return ans;
            }
        }
        return ans;
    }

    Test() {
        string l, r;
        cin >> l >> r;
        ll res = get(r) - get(l);
        int t = 1;
        bool flag = true;
        for (auto u: l) {
            t *= (u - '0');
            if (t > 10) {
                flag = false;
                break;
            }
        }
        if (t == 0 || t == 1 || t == 4 || t == 6 || t == 8 || t == 9)flag = false;
        cout << res + flag << '\n';
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
    return 0;
}
