#include <iostream>
#include <vector>
#include <string>
#include <cmath>


unsigned int numLen(std::string num)
{
	return num.size();
}

bool cmp(std::string a, std::string b)
{
	if (a.size() < b.size())
		return true;
	else if (a.size() > b.size())
		return false;
	else
		return a <= b;
}

std::string buildNum(int simple, int degree, int n)
{
	std::string res = "";

	for (int i = 0; i < degree; i++)
		res += "1";

	res += 48 + simple;

	for (int i = degree; i < n - 1; i++)
		res += "1";

	return res;
}

int cnt(int degree, std::string l, std::string r) 
{
	std::vector<int> SIMPLES = { 2, 3, 5, 7 };
	int res = 0;
	std::string num;
	bool fullStop = false;

	//if (l > buildNum(7, 0, degree))
		//return 0;

	for (int i = degree - 1; 0 <= i; i--)
	{
		for (int simple : SIMPLES)
		{
			num = buildNum(simple, i, degree);
			//std::cout << num << '\n';

			if (cmp(l, num) && cmp(num, r))
				res++;
			/*else if (r < num) {
				fullStop = true;
				break;
			}*/
		}

		if (fullStop)
			break;
	}
	
	return res;
}

int main() {
	std::string l, r;
	int res = 0;
	
	std::cin >> l;
	std::cin >> r;

	//std::cout << l << " " << r << " " << (std::string("42") <= std::string("112"));
	//std::cout << numLen(l);
	//std::cout << buildNum(3, 2, 5);

	for (int degree = numLen(l); degree < numLen(r) + 1; degree++)
		res += cnt(degree, l, r);

	std::cout << res;
}
