#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

#define max(a, b) __max(a, b)

typedef long long ll;

ll solve2(vector<ll> &mas)
{
	ll sum = 0;
	for (auto val : mas)
		sum += val;
	return __max(sum - 2 * *mas.begin(), sum - 2 * *(mas.end() - 1));
}

ll solve3(vector<ll>& mas)
{
	ll suml = mas[0], sumr = 0, mid = mas[1];
	for (auto val = mas.begin() + 2; val != mas.end(); ++val) {
		if (*val < mid and val != (mas.end() - 1)) {
			suml = suml + mid + sumr;
			mid = *val;
			sumr = 0;
		}
		else {
			sumr += *val;
		}
	}
	return max(max(abs(suml - mid), abs(sumr - suml)), abs(sumr - mid));
}

int main(void)
{
	ll n, k;
	cin >> n >> k;
	vector<ll> mas(n);
	for (ll i = 0; i < n; i++)
		cin >> mas[i];
	if (k == 2)
		cout << solve2(mas);
	else if (k == 3)
		cout << solve3(mas);
	else
		cout << ":)";
}