#include <bits/stdc++.h>

using namespace std;

long long slow1(long long d, long long l, long long r) {
    long long ans = 0;
    for (long long i = l; i <= sqrt(r); i++) {
        for (long long j = l + 1; j <= sqrt(r); j++) {
            if (j * j - i * i == d) {
                ans++;
//                cout << i << ' ' << j << '\n';
            }
        }
    }

    return ans;
}

long long count1(long long l, long long r) {
//    cout << l << ' ' << r << ' ' << r * r - l * l << '\n';
    return r * r - l * l;
}

int sqrt_up(long long n) {
    if (int(sqrt(n)) * int(sqrt(n)) != n) return sqrt(n) + 1;
    else return int(sqrt(n));
}

long long slow(long long l, long long r, long long d) {
    long long ans = 0;
//    vector<long long> dp(r, 0);
//    int v = int(sqrt(l) ) * int(sqrt(l));
//    int e = (int(sqrt(l)) - 1) * (int(sqrt(l)) - 1);
//    dp[int(sqrt(l))] = v - e;
//    for (int i = int(sqrt(l)) + 1; i <= int(sqrt(r)); i++) {
//        dp[i] = dp[i - 1] + 2;
//    }


    for (int i = sqrt_up(l); i <= sqrt(r); i++) {
        long long l1 = i;
        auto r1 = (long long) (sqrt(r));
        while (l1 + 1 < r1) {
            long long mid = l1 + (r1 - l1) / 2;
            if (count1(i, mid) < d) {
                l1 = mid;
            } else {
                r1 = mid;
            }
        }

        if (count1(i, r1) == d) {
            ans++;
//            cout << i << ' ' << r1 << '\n';
        }
        if (count1(i, r1) > d * 2) {
            break;
        }
    }

//    cout << slow(d, l, r) << ' ' << ans;

    return ans;
}

long long fast(long long l, long long r, long long d) {
    long long ans = 0;

    long long l1 = sqrt_up(l);
    long long r1 =  sqrt_up(l)+1;

    long long sum = 0;

    while (l1 < r1 && r1 * r1 <= r) {
        sum = count1(l1, r1);
        if (sum < d) {
            r1++;
        }
        else if (sum == d) {
//            cout << l1 << ' ' << r1 << '\n';
            ans++;
            l1++;
        }
        else if (sum > d) {
            l1++;
        }
    }

    return ans;
}


int main() {
    long long d, l, r;
    cin >> d >> l >> r;
//    if (d % 2) {
//        cout << 0;
//        return 0;
//    }
    cout << fast(l, r, d);

    return 0;
}