#include <iostream>
#include <array>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cmath>
#include <algorithm>
#include <utility>

using namespace std;

typedef long long ll;

void podz1(ll n, ll k) {

}

void podz2(ll n, ll k) {
    std::vector<ll> a(n);

    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    std::vector<ll> pref(n);
    std::vector<ll> suff(n);

    pref[0] = a[0];
    suff[n - 1] = a[n - 1];

    for (ll i = 1; i < n; ++i) {
        pref[i] = a[i] + pref[i - 1];
    }

    for (ll i = n - 2; i != -1; --i) {
        suff[i] = a[i] + suff[i + 1];
    }

    ll ans = -1;
    for (int i = 0; i < n - 1; ++i) {
        ans = max(ans, max(pref[i], suff[i + 1]) - min(pref[i], suff[i + 1]));
    }

    cout << ans;
}

//void podz3(ll n, ll k) {
//    std::vector<ll> a(n);
//
//    for (ll i = 0; i < n; ++i) {
//        cin >> a[i];
//    }
//
//    std::vector<ll> pref(n);
//    std::vector<ll> suff(n);
//
//    pref[0] = a[0];
//    suff[n - 1] = a[n - 1];
//
//    for (ll i = 1; i < n; ++i) {
//        pref[i] = a[i] + pref[i - 1];
//    }
//
//    for (ll i = n - 2; i != -1; --i) {
//        suff[i] = a[i] + suff[i + 1];
//    }
//
//
//    ll ans1 = max({pref[n - 3], a[n - 2], a[n - 1]}) - min({pref[n - 3], a[n - 2], a[n - 1]});
//    ll ans2 = max({a[0], pref[n - 2] - a[0], a[n - 1]}) - min({a[0], pref[n - 2] - a[0], a[n - 1]});
//    ll ans3 = max({a[0], a[1], pref[n - 1] - a[0] - a[1]}) - min({a[0], a[1], pref[n - 1] - a[0] - a[1]});
//    cout << max({ans1, ans2, ans3});
//}


void podz3(ll n, ll k) {
    std::vector<ll> a(n);

    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    std::vector<ll> pref(n);
    std::vector<ll> suff(n);

    pref[0] = a[0];
    suff[n - 1] = a[n - 1];

    for (ll i = 1; i < n; ++i) {
        pref[i] = a[i] + pref[i - 1];
    }

    for (ll i = n - 2; i != -1; --i) {
        suff[i] = a[i] + suff[i + 1];
    }

    ll ans1 = -1;
    for (ll i = 1; i < n - 1; ++i) {
        ll locans = max({pref[i - 1], a[i], suff[i + 1]}) - min({pref[i - 1], a[i], suff[i + 1]});
        ans1 = max(locans, ans1);
    }

    ll ans2 = -1;
    for (int i = 1; i < n - 1; ++i) {
        ll locans = max({a[0], pref[i] - a[0], suff[1 + i]}) - min({a[0], pref[i] - a[0], suff[1 + i]});
        ans2 = max(locans, ans2);
    }

    ll ans3 = -1;
    for (int i = 0; i < n - 2; ++i) {
        ll locans = max({pref[i], pref[n - 2] - pref[i], a[n - 1]}) - min({pref[i], pref[n - 2] - pref[i], a[n - 1]});
        ans3 = max(locans, ans3);
    }
    cout << max({ans1, ans2, ans3});
}

void podz5(ll n, ll k) {
    std::vector<ll> a(n);

    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    std::vector<ll> pref(n);
    std::vector<ll> suff(n);

    pref[0] = a[0];
    suff[n - 1] = a[n - 1];

    for (ll i = 1; i < n; ++i) {
        pref[i] = a[i] + pref[i - 1];
    }

    for (ll i = n - 2; i != -1; --i) {
        suff[i] = a[i] + suff[i + 1];
    }

    ll first;
    ll second;

    ll res = -1;
    for (ll l1 = 0; l1 < n - 1; ++l1) {
        for (ll r1 = l1; r1 < n - 1; ++r1) {
            for (ll l2 = r1; l2 < n; ++l2) {
                for (ll r2 = l2; r2 < n; ++r2) {
                    if(l2+1 != r1){
                        if(k-2==1){
                            continue;
                        }
                    }

                    if (n - (r1 - l1 + 1) - (r2 - l2 + 1) >= k - 2) {
                        first = pref[r1];
                        if (l1 != 0) {
                            first -= pref[l1 - 1];
                        }

                        second = pref[r2];
                        if (l1 != 0) {
                            second -= pref[l2 - 1];
                        }

                        res = max(res,
                                  max(first, second) - min(first, second));
                    }
                }
            }
        }
    }

    cout << res;
}

int main() {
    cout.sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, k;
    cin >> n >> k;

    if (k == 2ll) {
        podz2(n, k);
        return 0;
    } else if (k == 3ll) {
        podz3(n, k);
        return 0;
    } else {
        podz5(n, k);
        return 0;
    }

    return 0;
}
