/* NK1 */

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <set>
#include <cmath>

typedef signed long long SLL;  // MY type

// from 1 to UpTo

int Res( const std::string &S1, const std::string &S2 )
{
  int i = 0;
  auto s = S1.size();
  while (i < s && S1[i] == S2[i])
  {
    i++;
  }
  if (i == s)
    return 0;
  if (S1[i] < S2[i])
    return -1;
  return 1;
}

SLL Simplistic( std::string UpTo )
{
  int n = UpTo.size();
  SLL result = 0;
  for (int i = 2; i < n; i++)
    result += i * 4;
  
  std::string test;
  test.resize(n);
  for (int i = 0; i < n; i++)
    test[i] = '1';

  for (char c : {'2', '3', '5', '7'})
  {
    for (int i = 0; i < n; i++)
    {
      test[i] = c;
      if (Res(test, UpTo) != 1)
        result++;
      test[i] = '1';
    }
  }

  return result;
}

int main( void )
{
  std::string L, R;
  std::cin >> L >> R;

  std::cout << Simplistic(R) - Simplistic(L);
}
