/* NK1 */

#include <iostream>
#include <map>
#include <cmath>
#include <vector>
#include <stdint.h>
#include <algorithm>

typedef signed long long SLL;

#define PART_SUM(A, L, R) ((A)[(R) + 1] - (A)[(L)]) // --> [L, R]

int main( void )
{
  int n, k;
  std::cin >> n >> k;

  std::vector<int> A(n);

  for (int i = 0; i < n; i++)
  {
    std::cin >> A[i];
  }

  std::vector<SLL> PartSum(n + 1);
  PartSum[0] = 0;

  for (int i = 0; i < n; i++)
    PartSum[i + 1] = A[i] + PartSum[i];

  std::vector<std::pair<int, int>> Mins;

  for (int i = 0; i < n; i++)
    Mins.push_back({A[i], i});
  std::sort(Mins.data(), Mins.data() + Mins.size());

  SLL MaxDiff = -INT64_MAX;

  // if (k == 2)
  // {
  //   std::cout << std::min(PART_SUM(PartSum, 0, n - 2) - A[n - 1], PART_SUM(PartSum, 1, n - 1) - A[0]);
  // }
  std::cout << std::max(PART_SUM(PartSum, 0, n - 2) - A[n - 1], PART_SUM(PartSum, 1, n - 1) - A[0]);
  return 0;

  for (int i = 0; i < n; i++)
  {
    auto MinNumber = Mins[i].first, MinIndex = Mins[i].second;
    auto
      LPS = PART_SUM(PartSum, 0, MinIndex - 1),
      RPS = PART_SUM(PartSum, MinIndex + 1, n - 1);

    int
      LL = 0, LR = MinIndex - 1,
      RL = MinIndex + 1, RR = n - 1,
      LLen = LR - LL + 1,
      RLen = RR - RL + 1;

    // For L
    int LMinus = k - 1 - RLen;
    SLL MinSumL = INT64_MAX;

    if (LMinus <= 0)
      LMinus = 0;

    for (int x = 0; x < LMinus; x++)
    {
      auto sum1 =
        PART_SUM(PartSum, LL, x) +
        PART_SUM(PartSum, LR - (LMinus - x - 1), LR);
      if (sum1 < MinSumL)
        MinSumL = sum1;
    }

    if (LPS - MinSumL - MinNumber > MaxDiff)
      MaxDiff = LPS - MinSumL - MinNumber;

    // For R
    int RMinus = k - 1 - LLen;
    SLL MinSumR = INT64_MAX;

    if (RMinus <= 0)
      RMinus = 0;

    for (int x = 0; x < RMinus; x++)
    {
      auto sum1 =
        PART_SUM(PartSum, RL, x) +
        PART_SUM(PartSum, RR - (RMinus - x - 1), RR);
      if (sum1 < MinSumR)
        MinSumR = sum1;
    }

    if (RPS - MinSumR - MinNumber > MaxDiff)
      MaxDiff = RPS - MinSumR - MinNumber;
  }
}
