/* NK1 */

#include <iostream>
#include <map>
#include <cmath>
#include <vector>
#include <stdint.h>
#include <algorithm>

typedef signed long long SLL;

SLL Sum( const std::vector<std::pair<int, std::pair<int, int>>> &Vector, int Pos, SLL S, SLL Required, std::vector<int> &Solved, int n )
{
  if (S == Required)
  {
    // goto End;

    std::vector<int> All(n);

    for (auto &s : Solved)
      All[Vector[s].second.first]++;

    auto flag = true;
    for (auto &x : All)
      if (x == 0)
      {
        flag = false;
        // return 0;
      }
    if (flag)
    {
      std::cout << "Yes\n";
      int AnotherDummyVariable = 0;
      for (auto k : All)
      {
        std::cout << k << "\n";
        for (auto &s : Solved)
          if (Vector[s].second.first == AnotherDummyVariable)
            std::cout << Vector[s].second.second + 1 << " ";
        std::cout << "\n";
        AnotherDummyVariable++;
      }
      exit(0);
    }
    return -1;
  }

  for (int i = Pos + 1; i < Vector.size(); i++)
  {
    if (S + Vector[i].first <= Required)
    {
      Solved.push_back(i);
      Sum(Vector, i, S + Vector[i].first, Required, Solved, n);
      Solved.pop_back();
    }
  }
  return -1;
}

int main( void )
{
  int n, s;
  std::cin >> n >> s;

  std::vector<std::vector<int>> Contest(n);

  bool FlagForSub4 = true;

  SLL SumK = 0;
  for (int i = 0; i < n; i++)
  {
    int k;
    std::cin >> k;
    SumK += k;

    if (k != 1)
      FlagForSub4 = false;

    Contest[i].resize(k);
    for (int j = 0; j < k; j++)
      std::cin >> Contest[i][j];
  }
  if (FlagForSub4)
  {
    SLL sum = 0;
    for (int i = 0; i < n; i++)
      sum += Contest[i][0];

    if (sum == s)
    {
      std::cout << "Yes\n";
      for (int i = 0; i < n * 2; i++)
        std::cout << "1\n";
    }
    else
    {
      std::cout << "No";
    }
    return 0;
  }
  else if (1)
  {
    std::vector<std::pair<int, std::pair<int, int>>> Vector;
    
    for (int i = 0; i < n; i++)
      for (int j = 0; j < Contest[i].size(); j++)
        Vector.push_back({Contest[i][j], {i, j}});
    std::sort(Vector.data(), Vector.data() + Vector.size());
    std::reverse(Vector.data(), Vector.data() + Vector.size());
    auto VectorSize = Vector.size();
    std::vector<int> Solved;

    Sum(Vector, -1, 0, s, Solved, n);
    std::cout << "No";
    return 0;
  }

  std::cout << "Later";
  
}
