#include <iostream>
#include <vector>
#include <set>

#define int long long

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    ll diff, l, r;
    cin >> diff >> l >> r;

    vector<ll> gg = {1, diff};
    int d = 2;
    while (d * d <= diff) {
        if (diff % d == 0) {
            gg.push_back(diff / d);
            if (diff / d != d) gg.push_back(d);
        }
        ++d;
    }

    set<pll> ans;
    for (ll z : gg) {
        ll b = diff / z - z;
        if (b % 2 == 0) {
            ll y = b / 2;
            ll x = y * y + diff;
            if (l <= y * y && 0 <= y && y * y < x * x && x <= r && y * y <= r) {
                ans.insert({y, x});
            }
        }
    }

    cout << ans.size() << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}