#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    ll n, k;
    cin >> n >> k;

    vector<ll> a(n);
    vector<ll> pref(n + 1);
    vector<ll> suf(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll len = n - k + 1;
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
        if (i >= len) pref[i + 1] -= a[i - len];
    }

    for (int i = n - 1; i >= 0; --i) {
        suf[i] = suf[i + 1] + a[i];
        if (i + len < n) suf[i] -= a[i + len];
    }

    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        if (k > 2) ans = max(ans, max(pref[i], suf[i + 1]) - a[i]);
        if (k == 2) ans = max(ans, max(pref[i + 1], suf[i]) - a[i]);
    }

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}