#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>

#define all(a) a.begin(),a.end()

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

const ll INF = 1e18;

const int N = 1e5 + 1;

vector<int> cnt;
int nbr;
int a[N];
vector<vector<vector<bool>>> dp;
vector<vector<int>> ans;
vector<map<int, vector<int>>> index;

void solve() {
    ll n, s;
    cin >> n >> s;

    vector<int> b;
    int m = 0, ind = 1;
    cnt.resize(n + 1);
    ans.resize(n + 1);
    index.resize(n + 1);
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        m += k;
        cnt[i + 1] = cnt[i] + k;
        b.clear();
        for (int j = 0, val; j < k; ++j) {
            cin >> val;
            index[i + 1][val].push_back(j + 1);
            b.push_back(val);
        }
        sort(all(b));
        for (int& val : b) {
            a[ind++] = val;
        }
    }
    b.clear();

//    for (int i = 1; i <= n; ++i) {
//        cout << i << endl;
//        for (auto [key, elems] : index[i]) {
//            cout << key << ": ";
//            for (int val : elems) {
//                cout << val << ' ';
//            }
//            cout << endl;
//        }
//    }

    dp.resize(s + 1, vector<vector<bool>>(m + 1, vector<bool>(2)));
    for (int i = 0; i < cnt[1]; ++i) {
        dp[0][i][0] = 1;
        dp[0][i][1] = 1;
    }
    for (int sum = 1; sum <= s; ++sum) {
        int nbr = 1;
        for (int i = 1; i <= m; ++i) {
            if (i > cnt[nbr]) ++nbr;
            dp[sum][i][0] = dp[sum][i - 1][1];
            if (cnt[nbr - 1] < i - 1) dp[sum][i][1] = dp[sum][i - 1][1];
            if (a[i] <= sum) dp[sum][i][1] = max(dp[sum][i][1], dp[sum - a[i]][i - 1][0 + (i == (cnt[nbr - 1] == 0 ? -1 : cnt[nbr - 1]) + 1)]);
            dp[sum][i][0] = max(dp[sum][i][0], dp[sum][i][1]);
        }
    }

    if (!dp[s][m][1]) {
        cout << "NO" << '\n';
        return;
    }

    cout << "YES" << endl;

    nbr = n;
    int i = m;
    bool flag = 0;
    while (s != 0) {
        if (s == 0) break;
        if (i <= cnt[nbr - 1]) --nbr;
        if (i == cnt[nbr - 1] + 1 && flag && dp[s][i - 1][1]) {
            --i;
            flag = 0;
        } else if (i != cnt[nbr - 1] + 1 && (dp[s][i - 1][1] || (flag && dp[s][i - 1][0]))) {
            --i;
        } else {
            ans[nbr].push_back(i);
            s -= a[i];
            flag = (i != cnt[nbr - 1] + 1);
            --i;
        }
    }

    for (int i = 1; i <= n; ++i) {
        cout << ans[i].size() << '\n';
        vector<int> res;
        for (int& ind : ans[i]) {
            res.push_back(index[i][a[ind]].back());
            index[i][a[ind]].pop_back();
        }
        sort(all(res));
        for (int& val : res) {
            cout << val << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

}