
#include <bits/stdc++.h>
using ll = long long;
using namespace std;
template<typename t>
istream &operator>>(istream &in, vector<t> &v){
    for(int i = 0; i<v.size(); i++){
        in>>v[i];
    }
    return in;
}
template<typename t>
ostream &operator<<(ostream &out, const vector<t> v){
    for(auto x: v)out<<x<<" ";
    return out;
}
ll check(ll x, ll y, ll d, ll l, ll r){
    if(x*x-y*y==d&&x*x<=r&&y*y<=r&&x*x>=l&&y*y>=l)return 1;
    return 0;
}
vector<vector<ll>> gens;
vector<ll> cur;
void gen(ll n, ll m){
    if(n==0&&m==0){
        gens.push_back(cur);
        return;
    }
    if(n>0){
        cur.push_back(-1);
        gen(n-1, m);
        cur.pop_back();
    }
    if(m>0){
        cur.push_back(1);
        gen(n, m-1);
        cur.pop_back();
    }

}
vector<vector<ll>> gens1;
vector<ll> cur1;
map<pair<ll, ll>, ll> mp1;
void gen1(ll n, ll m, ll x1, ll y1){
    if(n==0&&m==0){
        gens1.push_back(cur1);
        return;
    }
    if(mp1[{x1, y1}]==1){
        return;
    }
    if(n>0){
        cur1.push_back(-1);
        gen1(n-1, m, x1, y1+1);
        cur1.pop_back();
    }
    if(m>0){
        cur1.push_back(1);
        gen1(n, m-1, x1+1, y1);
        cur1.pop_back();
    }

}

ll fastpow(ll a, ll b, ll mod){
    if(b==0){
        return 1;
    }
    ll x = fastpow(a, b/2, mod);
    x*=x;
    x%=mod;
    if(b%2){
        x*=a;
        x%=mod;
    }
    return x;
}
ll mod = 1e9+7;
ll C(ll n, ll k){
    vector<ll> fact, fact1;
    if(fact.size()==0){
        fact.push_back(1);
        fact1.push_back(1);
    }
    while(fact.size()<=n){
        fact.push_back(fact.back()*fact.size()%mod);
        fact1.push_back(fastpow(fact.back(), mod-2, mod));
    }
    return fact[n]*fact1[k]%mod*fact1[n-k]%mod;
}
void solve(){
    ll n, m, k;
    cin>>n>>m>>k;
    if(k==0){
        if(n>m){
            swap(n, m);
        }
        cout<<C(m+n-3, n-1)*C(n+m-4, n-3)%mod*2%mod*fastpow(n-2, mod-2, mod)%mod<<"\n";//*fact[n-3]%mod*2%mod*fact1[n-1]%mod<<"\n";
        return;
    }
    vector<pair<ll, ll>> v(k);
    for(int i = 0; i<k; i++){
        cin>>v[i].first>>v[i].second;
        v[i].first--, v[i].second--;
    }
    gen(n-1, m-1);
    //cout<<gens.size()<<"\n";
    ll ans = 0;
    for(auto mask: gens){
        map<pair<ll,ll>, ll> mp;
        ll x = 0, y = 0;
        for(int i = 0; i<mask.size()-1; i++){
            if(mask[i]==-1){
                y++;
            }
            else{
                x++;
            }
            mp[{x, y}]=1;
        }
        mp1 = mp;
        gens1.clear();
        gen1(n-1, m-1, 0, 0);
        //cout<<gens1<<"\n";
        for(auto mask1: gens1){
            mp = mp1;
             x = 0, y = 0;
            for(int i = 0; i<mask1.size()-1; i++){
                if(mask1[i]==-1){
                    y++;
                }
                else{
                    x++;
                }
                mp[{x, y}]=1;
            }
            bool ok = 1;
            mp[{0, 0}]=mp[{m-1, n-1}]=1;
            for(auto [a, b]: v){
                if(mp[{b, a}]!=1){
                    ok = 0;
                    break;
                }
            }
            ans+=ok;
        }
        //cout<<ans<<"\n";
    }
    cout<<ans<<"\n";
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //cout<<3528/6*6<<"\n";
    ll t = 1;
    //cin>>t;
    while(t--)solve();
}