#include <vector>
#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <cmath>

using namespace std;
typedef long long ll;


struct Node {
	ll cnt = 0;
	ll color = 0;
	vector<pair<ll, ll>> to;
};

int main()
{
	ll n, s;
	cin >> n >> s;
	vector<Node> res(1000001);
	for (ll t = 0; t < n; t++) {
		ll m;
		cin >> m;
		vector<ll> vec(m);
		for (ll i = 0; i < m; i++) {
			cin >> vec[i];
			if (res[vec[i]].color == 0 && t == 0) {
				res[vec[i]].color = 1;
				res[vec[i]].to.push_back(make_pair(t, i));
				res[vec[i]].cnt=1;
			}
		}
		for (ll j = 0; j < m; j++) {
			for (ll i = 0; i <= s; i++) {
				if (res[i].color == 1 && res[i].cnt == t && res[i+vec[j]].color == 0) {
					res[i + vec[j]].color = 1;
					res[i + vec[j]].to = res[i].to;
					res[i + vec[j]].to.push_back(make_pair(t, j));
					res[i + vec[j]].cnt = t + 1;

				}
			}
		}
	}
	
	if (res[s].color == 1) {
		vector<vector<ll>> p(n);
		for (ll i = 0; i < res[s].to.size(); i++) {
			p[res[s].to[i].first].push_back(res[s].to[i].second);
		}
		if (p.size() == n) {
			cout << "Yes" << endl;
			for (ll i = 0; i < res[s].to.size(); i++) {
				cout << p[i].size() << endl;
				for (ll j = 0; j < p[i].size(); j++) {
					cout << p[i][j]+1 << ' ';
				}
				cout << endl;
			}
		}
		else {
			cout << 'No' << endl;
		}
	}
	else {
		cout << "No" << endl;
	}
}