def is_prime(n: int) -> bool:
    if n < 2:
        return False
    if n == 2:
        return True
    if n % 2 == 0:
        return False
    for i in range(3, int(pow(n, 1/2)) + 2, 2):
        if n % i == 0:
            return False
    return True

def is_almost(n: int) -> bool:
    p = 1
    s = str(n)
    flag = False
    for i in range(len(s)):
        k = int(s[i])
        p *= k
        if k == 1:
            continue
        elif not flag and is_prime(k):
            flag = True
            continue
        else:
            return False
    return is_prime(p)

def count(n: int) -> int:
    s = 0
    for i in range(0, n):
        s += is_almost(i)
    return s


l = int(input())
s = count(l)
r = int(input())
s = count(r + 1) - s
print(s)