#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int n, k;
	cin >> n >> k;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	vector<ll> p1(n + 1, 0), p2(n + 1, 1e10), s2(n + 1, 1e10);

	for (int i = 0; i < n; ++i) {
		p1[i + 1] = p1[i] + a[i];
		p2[i + 1] = min(p2[i], a[i]);
	}

	for (int i = n - 1; i >= 0; --i) {
		s2[i] = min(s2[i + 1], a[i]);
	}

	ll ans = 0;
	if (k == 2) {
		for (int i = 1; i <= n - 1; ++i) {
			ans = max(ans, abs(2 * p1[i] - p1[n]));
		}
	}
	else {
		for (int i = 0; i < n; ++i) {
			{
				int l = i;
				int r = min(i + n - k + 1, n);
				ans = max(ans, p1[r] - p1[l] - min(p2[l], s2[r]));
			}
			{
				int l = max(i - n + k - 1, 0);
				int r = i;
				ans = max(ans, p1[r] - p1[l] - min(p2[l], s2[r]));
			}
		}
	}
	cout << ans << '\n';
}
