#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
		--a[i].first, --a[i].second;
	}

	int ln = n + m - 2;

	vector<vector<int>> us(n, vector<int>(m, -1));

	int ans = 0;

	for (int i = 0; i < 1 << (2 * ln); ++i) {
		bool skip = false;
		int pi = 0, pj = 0;
		for (int j = 0; j < ln; ++j) {
			if (i & (1 << j)) {
				++pi;
			}
			else {
				++pj;
			}
			if (pi >= n || pj >= m || us[pi][pj] == i) {
				skip = true;
				break;
			}
			us[pi][pj] = i;
		}

		if (skip) continue;
		for (int j = 0; j < ln; ++j) {
			if (i & (1 << (j + ln))) {
				--pi;
			}
			else {
				--pj;
			}
			if (pi < 0 || pj < 0 || us[pi][pj] == i) {
				skip = true;
				break;
			}
			us[pi][pj] = i;
		}
		if (skip) continue;

		for (int j = 0; j < k; ++j) {
			skip = skip || (us[a[j].first][a[j].second] != i);
		}
		if (skip) continue;
		/*
		for (int pi = 0; pi < n; ++pi) {
			for (int pj = 0; pj < m; ++pj) {
				if (us[pi][pj] == i) cout << '*';
				else cout << '.';
			}
			cout << '\n';
		}
		cout << '\n';
		*/
		++ans;
	}
	cout << ans << '\n';
}
