#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <valarray>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> ns(n);
    int sum_ns = 0;
    vector<vector<int>> a(n);
    int sum_a_i = 0;
    for (int i = 0; i < n; i++) {
        cin >> ns[i];
        sum_ns += ns[i];
        a[i].resize(ns[i]);
        for (int j = 0; j < ns[i]; j++) {
            cin >> a[i][j];
            sum_a_i += a[i][j];
        }
    }
    if (sum_ns == n) {
        if (sum_a_i == s) {
            cout << "Yes\n";
            for (int i = 0; i < 2 * n; i++) cout << "1\n";
        } else {
            cout << "No\n";
        }
        return;
    }
    const int len = 20;
    if (sum_ns <= len) {
        for (int mask = 0; mask < (1 << (len)); mask++) {
            int ic = 0;
            bool in;
            int curs = 0;
            for (int i = 0; i < n; i++) {
                in = false;
                for (int j = 0; j < ns[i]; j++) {
                    if (mask & (1 << (ic++))) {
                        curs += a[i][j];
                        in = true;
                    }
                }
                if (!in) {
                    break;
                }
            }
            if (in && curs == s) {
                vector<vector<int>> ans(n);
                ic = 0;
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < ns[i]; j++) {
                        if (mask & (1 << (ic++))) {
                            ans[i].push_back(j);
                        }
                    }
                }
                cout << "Yes\n";
                for (int i = 0; i < n; i++) {
                    cout << ans[i].size() << '\n';
                    for (int e : ans[i]) cout << e + 1 << ' ';
                    cout << '\n';
                }
                return;
            }
        }
    }
    cout << "No\n";
}
/*
2 4
1
2
2
3 1

2 4
1
2
2
2 1

 */