#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>

using namespace std;

void solve();

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

#define x first
#define y second

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    k += 2;
    vector<pair<int, int>> a(k);
    a[0] = {0, 0};
    for (int i = 1; i < k - 1; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].x--;
        a[i].y--;
    }
    a[k - 1] = {n - 1, m - 1};
    set<vector<pair<int, int>>> ways;
    vector<pair<int, int>> f_way;
    for (int i = 0; i < m; i++) f_way.emplace_back(0, i);
    for (int i = 1; i < n; i++) f_way.emplace_back(i, m - 1);
    for (int i = m - 2; i >= 0; i--) f_way.emplace_back(n - 1, i);
    for (int i = n - 2; i > 0; i--) f_way.emplace_back(i, 0);
    ways.insert(f_way);
    reverse(f_way.begin(), f_way.end());
    ways.insert(f_way);

    while (true) {
        int sz = ways.size();
        for (auto e : ways) {
            for (int i = 2; i < e.size(); i++) {
                auto p1 = e[i - 2];
                auto p2 = e[i - 1];
                auto p3 = e[i - 0];
                if ((p1.y == p2.y && p2.y == p3.y) || (p1.x == p2.x && p2.x == p3.x)) continue;
                pair<int, int> p2n = {p1.x + p3.x - p2.x, p1.y + p3.y - p2.y};
                if (find(e.begin(), e.end(), p2n) == e.end()) {
                    e[i - 1] = p2n;
                    ways.insert(e);
                }
            }
        }
        if (sz == ways.size()) break;
    }
    int ans = 0;
    for (auto way : ways) {
        bool f = true;
        for (auto e : a) {
            if (find(way.begin(), way.end(), e) == way.end()) {
                f = false;
                break;
            }
        }
        ans += f;
    }
    cout << ans << '\n';
}
/*
3 4 2
2 2
2 3

 */