#include <bits/stdc++.h>

using namespace std;

#define int int64_t

const int maxn = 2000001;
const int mod = int(1e9)+7;

int fact[maxn],invfact[maxn];


int binpow(int a,int b)
{
    return (b == 0 ? 1 : (b%2 == 0 ? binpow((a*a)%mod,b/2) : (a*binpow(a,b-1))%mod));
}
int del(int a,int b)
{
    return (a*binpow(b,mod-2))%mod;
}
int cnk(int n,int k)
{
    return ((fact[n]*invfact[k])%mod*invfact[n-k])%mod;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,m,k;
    cin >> n >> m >> k;

    fact[0] = 1;
    invfact[0] = 1;
    for(int i = 1;i < maxn;++i)
    {
        fact[i] = (fact[i-1]*i)%mod;
        invfact[i] = del(1,fact[i]);
    }
    n -= 2;
    m -= 2;
    int64_t ans = 0;
    for(int k = 0;k <= min(n,m);++k)
    {
        ans = (ans + ((del(1,k+1)*cnk(2*k,k))%mod*cnk(n+m,2*k))%mod*cnk(n+m-2*k,n-k))%mod;
    }
    cout << (2*ans)%mod << endl;
}
