#include <bits/stdc++.h>

using namespace std;

#define int int64_t

const int mod = int(1e9)+7;

const int mx2 = 200001;

int fact[mx2],invfact[mx2];

const int maxn = 105;

int dp[maxn][maxn][maxn];
int a[maxn][maxn];
int sum_diag[2*maxn];

vector<pair<int,int>> step = {{1,0},{1,1},{0,0},{0,1}};


int binpow(int a,int b)
{
    return (b == 0 ? 1 : (b%2 == 0 ? binpow((a*a)%mod,b/2) : (a*binpow(a,b-1))%mod));
}
int del(int a,int b)
{
    return (a*binpow(b,mod-2))%mod;
}
int cnk(int n,int k)
{
    return ((fact[n]*invfact[k])%mod*invfact[n-k])%mod;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,m,k;
    cin >> n >> m >> k;
    if(k == 0)
    {
        fact[0] = 1;
        invfact[0] = 1;
        for(int i = 1;i < mx2;++i)
        {
            fact[i] = (fact[i-1]*i)%mod;
            invfact[i] = del(1,fact[i]);
        }
        n -= 2;
        m -= 2;
        int64_t ans = 0;
        for(int k = 0;k <= min(n,m);++k)
        {
            ans = (ans + ((del(1,k+1)*cnk(2*k,k))%mod*cnk(n+m,2*k))%mod*cnk(n+m-2*k,n-k))%mod;
        }
        cout << ans << endl;

    }
    else
    {
        for(int j = 0;j < k;++j)
        {
            int x,y;
            cin >> x >> y;
            x--;
            y--;
            a[x][y] ++;
            sum_diag[x+y] ++;
        }
        dp[0][1][1] = 1;
        for(int i = 0;i < n;++i)
        {
            for(int j = 0;j < m;++j)
            {
                for(int i2 = 0;i2 < n;++i2)
                {
                    int j2 = i+j-i2;
                    int osum = a[i][j] + a[i2][j2];
                    if(j2 < 0 || i2 == i || osum != sum_diag[i+j])
                    {
                        dp[i][j][i2] = 0;
                        continue;
                    }
                    for(int g = 0;g < step.size();++g)
                    {
                        int ni = step[g].first + i;
                        int nj = 1-step[g].first+j;
                        int ni2 = step[g].second + i2;
                        int nj2 = 1-step[g].second+j2;
                        if(ni >= 0 && ni < n && nj >= 0 && nj < m && ni2 >= 0 && ni2 < n && nj2 >= 0 && nj2 < m)
                        {
                            //if(ni == 1 && nj == 3 && ni2 == 2)
                           // {
                           //     cout << i << ' ' << j << ' ' << i2 << "!\n";
                           // }
                            dp[ni][nj][ni2] = (dp[ni][nj][ni2] + dp[i][j][i2])%mod;
                        }
                    }
                   // cout << i << ' ' << j << ' ' << i2 << ' ' << j2 << ' ' << dp[i][j][i2] << endl;
                }
            }
        }
        cout << (dp[n-2][m-1][n-1]+dp[n-2][m-1][n-1])%mod << "\n";
        return 0;
    }
}
