#include <iostream>
#include <string>

short info[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

bool IsPrimish(std::string& num){
    bool n2 = false;
    bool n3 = false;
    bool n5 = false;
    bool n7 = false;
    char chr;
    for(short i = num.length() - 1; i >= 0; --i){
        chr = num[i];
        if(chr == '0' or chr == '4' or chr == '6' or chr == '8' or chr == '9')
            return false;
        switch(chr){
            case '2': { if(n2 == true){ return false; }; n2 = true; };
            case '3': { if(n3 == true){ return false; }; n3 = true; };
            case '5': { if(n5 == true){ return false; }; n5 = true; };
            case '7': { if(n7 == true){ return false; }; n7 = true; };
        }

    };
    return n2 + n3 + n5 + n7;
}

void Increase(std::string& num, short offset = 0){
    bool increased = false;
    for(short i = num.length() - 1 - offset; i >= 0; --i){
        if(num[i] == '9')
            num[i] = '0';
        else{
            num[i] = num[i] + 1;
            increased = true;
            break;
        }
    }
    if(not increased)
        num = "1" + num;
}

void GetInfo(std::string& num){
    for(short i = 0; i < 10; ++i){
        info[i] = 0;
    };
    for(short i = num.length() - 1; i >= 0; --i){
        char chr = num[i];
        info[0] += chr == '0';
        info[1] += chr == '1';
        info[2] += chr == '2';
        info[3] += chr == '3';
        info[4] += chr == '4';
        info[5] += chr == '5';
        info[6] += chr == '6';
        info[7] += chr == '7';
        info[8] += chr == '8';
        info[9] += chr == '9';
    };
}

bool IsGreater(std::string& a, std::string& b){
    if( a.length() < b.length() ) return false;
    if( a.length() > b.length() ) return true;
    for(short i = 0; i < a.length(); ++i){
        if(a[i] > b[i]) return true;
        if(a[i] < b[i]) return false;
    }
    return false;
}

bool IsSimillar(std::string& a, std::string& b){
    if( a.length() != b.length()) return false;
    if( a.length() == 1 ) return a[0] == b[0];
    for(short i = a.length() - 2; i < a.length(); ++i){
        if(a[i] != b[i]) return false;
    }
    return true;
}


int main(){
    std::string a, b;

    std::cin >> a >> b;

    int primish_numbers = 0;

    while(a[a.length() - 1] != '0'){
        primish_numbers += IsPrimish(a);
        Increase(a);
    }

    a[a.length() - 1] = '1';
    while(not IsGreater(a, b)){
        GetInfo(a);
        bool only_one = info[1] == a.length();
        if(IsPrimish(a) or only_one){
            if( IsSimillar(a, b) ){
                primish_numbers += not only_one;
                primish_numbers += only_one;
            }
            else{
                primish_numbers += not only_one;
                primish_numbers += only_one * 4;
            }
        }
        Increase(a, 1);
    }

    std::cout << primish_numbers << std::endl;

    return 0;
}
