#include <iostream>
#include <string>
#include <chrono>

bool IsPrimish(std::string& num){
    bool n2 = false;
    bool n3 = false;
    bool n5 = false;
    bool n7 = false;
    char chr;
    for(short i = num.length() - 1; i >= 0; --i){
        chr = num[i];
        if(chr == '0' or chr == '4' or chr == '6' or chr == '8' or chr == '9')
            return false;
        switch(chr){
            case '2': { if(n2 == true){ return false; }; n2 = true; };
            case '3': { if(n3 == true){ return false; }; n3 = true; };
            case '5': { if(n5 == true){ return false; }; n5 = true; };
            case '7': { if(n7 == true){ return false; }; n7 = true; };
        }

    };
    return n2 + n3 + n5 + n7;
}

void Increase(std::string& num){
    bool increased = false;
    for(short i = num.length() - 1; i >= 0; --i){
        if(num[i] == '9')
            num[i] = '0';
        else{
            num[i] = num[i] + 1;
            increased = true;
            break;
        }
    }
    if(not increased)
        num = "1" + num;
}

int main(){
    auto time_point = std::chrono::high_resolution_clock::now();

    std::string a, b;

    std::cin >> a >> b;

    int primish_numbers = 0;

    while(a != b){
        primish_numbers += IsPrimish(a);
        Increase(a);
        if ((std::chrono::high_resolution_clock::now() - time_point).count() / 1000000 > 9900)
            break;
    }
    primish_numbers += IsPrimish(a);

    std::cout << primish_numbers;
}
