#include <iostream>
#include <thread>
#include <cmath>

int main(){
    unsigned long long d, l, r;
    scanf("%llu", &d);
    scanf("%llu", &l);
    scanf("%llu", &r);

    short pairs_count = 0;

    unsigned long long d_lr = r - l;

    unsigned long long sqrt_l = sqrt(l);

    unsigned long long sqrt_l_2 = sqrt(l + d_lr / 2);

    std::thread thread = std::thread([&pairs_count, sqrt_l, r, d_lr, d](){
        unsigned long long cusp = r - d_lr / 2;
        for(unsigned long long y = sqrt_l; y * y <= cusp ; ++y){
            for(unsigned long long x = y + 1; x * x <= r; ++x){
                pairs_count += x * x - y * y == d;
            }
        }});

    for(unsigned long long y = sqrt_l_2; y * y <= r; ++y){
        for(unsigned long long x = y + 1; x * x <= r; ++x){
                pairs_count += x * x - y * y == d;
        }
    }

    thread.join();

    printf("%i", pairs_count);
}
