#include <iostream>
#include <vector>
#include <cmath>

std::vector<unsigned int> FindDelimetes(unsigned long long num){
    std::vector<unsigned int> dels;;
    for(unsigned long long i = 2; i <= num; ++i){
        if(num / i * i == num)
            dels.push_back(i);
    };

    return dels;
}

int main(){
    unsigned long long d, l, r;
    scanf("%llu", &d);
    scanf("%llu", &l);
    scanf("%llu", &r);

    short pairs_count = 0;

    unsigned long long sqrt_l = sqrt(l);

    std::vector<unsigned int> x_solutions;
    std::vector<unsigned int> dels = FindDelimetes(d);

    if(dels.size() >= 0){
        unsigned int last_del = dels[dels.size() - 1];
        for(unsigned int y = 1; y < last_del; ++y){
            for(unsigned int x = y + 1; x < last_del; ++x){
                pairs_count += x * x - y * y == d;
            }
        }
    }

    printf("%i", pairs_count);
}
