#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef unsigned long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
const vector<ll> prime = {2, 3, 5, 7};
ll count_large(int x) {
    ll ans = 0;
    for (ll i = x; i < 10; i++) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
ll count_large_prime(string r) {
   ll non_1 = 0;
    for (char c : r) {
        if (c - '0' == 0) {
            if (non_1 == 0) {
                return 4 * r.size();
            }
        }
        if (c - '0' > 1) {
            non_1++;
        }
    }
    ll fl2 = 0;
    ll rem2 = 0;
    for (char c : r) {
        if (!fl2) {
            rem2 += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && non_1 > 1);
        }
        fl2 += ((c - '0') > 1);
    }
    if (r.size() == 1) {
        rem2 = count_large(r[0] - '0');
    }
    return rem2;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string l, r;
    cin >> l >> r;
    ll ans = 0;
    if (l.size() < r.size()) {
       ll rem1 = count_large_prime(l);
       ans += rem1;
//       ll len = (ll)l.size() + 1;
//       while (len < r.size()) {
//           ans += len * 4;
//           len++;
//       }
       if (l.size() + 1 < r.size()) {
           ans += (r.size() - 1) * r.size() * 2 - (l.size() + 1) * l.size() * 2;
       }
       ll rem2 = 4 * r.size() - count_large_prime(r);
       // cout << count_large_prime(s) << ' ' << count_large_prime(r) << ' ' << count_large_prime(l) << endl;
       ll v = 0;
       ll x = 0;
       for (char c : r) {
           if (c != '1') {
               v++;
               x = c - '0';
           }
       }
       if (v == 1 && find(prime.begin(), prime.end(), x) != prime.end()) {
           rem2++;
       }
       ans += rem2;
    } else {
       ll rem1 = count_large_prime(l);
       ll rem2 = count_large_prime(r);
       ll v = 0;
       ll x = 0;
       for (char c : r) {
           if (c != '1') {
               v++;
               x = c - '0';
           }
       }
       if (v == 1 && find(prime.begin(), prime.end(), x) != prime.end()) {
           rem2--;
       }
      //cout << rem1 << ' ' << rem2 << endl;
       ans = rem1 - rem2;
    }
    cout << ans << endl;
    return 0;
}
