#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
int h[MAX_N];
int k[MAX_N];
int d[MAX_N];
int g(int x) {
    return -x & x;
}
int get(int r) {
    int sum = 0;
    for (int i = r; i >= 1; i -= g(i)) {
        sum += d[i-1];
    }
    return sum;
}
int sum(int l, int r) {
    return get(r) - get(l-1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n-1; i++) {
        cin >> k[i];
    }
    vector<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.emplace_back(i, i);
    }
    for (int i = 0; i < n-1; i++) {
        s[k[i]-1].second = s[k[i]].second;
        s.erase(find(s.begin(), s.end(), s[k[i]]));
        int m = -1, sm = -1;
        int im = -1, ism = -1;
        for (int j = s[k[i]-1].first; j <= s[k[i]-1].second; j++) {
            if (h[j] > m) {
                sm = m;
                ism = im;
                m = h[j];
                im = j;
            } else if (h[j] > sm) {
                sm = h[j];
                ism = j;
            }
        }
        int sum = 0;
        for (int j = s[k[i]-1].first; j <= s[k[i]-1].second; j++) {
            if (j < min(im, ism) || j > max(im, ism)) {
                int maxim = -1;
                if (j < min(im, ism)) {
                    for (int r = s[k[i]-1].first; r <= j; r++) {
                        maxim = max(maxim, h[r]);
                    }
                } else {
                    for (int r = j; r <= s[k[i]-1].second; r++) {
                        maxim = max(maxim, h[r]);
                    }
                }
                sum += maxim - h[j];
            } else if (j == im || j == ism) {
                sum += 0;
            } else {
                sum += sm - h[j];
            }
        }
        cout << sum << endl;
    }
    return 0;
}
