#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
#include <cmath>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 3e5+1;
ll a[MAX_N];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    ll s = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s += a[i];
    }
    set<pair<ll, pair<ll, ll>>> cur = {{s, {0, n}}};
    while (cur.size() < k) {
        ll c_max = min(a[cur.rbegin()->second.first], a[cur.rbegin()->second.second-1]);
        ll c_min = max(a[cur.begin()->second.first], a[cur.begin()->second.second-1]);
        if (c_max > c_min && cur.begin()->second.second - cur.begin()->second.first != 1) {
             auto p = cur.begin();
            if (a[p->second.first] > a[p->second.second-1]) {
                cur.insert({p->first - a[p->second.first], {p->second.first + 1, p->second.second}});
                cur.insert({a[p->second.first], {p->second.first, p->second.first + 1}});
            } else {
                cur.insert({p->first - a[p->second.second - 1], {p->second.first, p->second.second - 1}});
                cur.insert({a[p->second.second - 1], {p->second.second - 1, p->second.second}});
            }
            cur.erase(p);
        } else {
            auto p = (--cur.end());
            if (a[p->second.first] < a[p->second.second-1]) {
                cur.insert({p->first - a[p->second.first], {p->second.first + 1, p->second.second}});
                cur.insert({a[p->second.first], {p->second.first, p->second.first+1}});
            } else {
                cur.insert({p->first - a[p->second.second-1], {p->second.first, p->second.second-1}});
                cur.insert({a[p->second.second-1], {p->second.second-1, p->second.second}});
            }
            cur.erase(p);
        }
    }
    cout << cur.rbegin()->first - cur.begin()->first;
    return 0;
}
