#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64  gen(chrono::high_resolution_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

ll stupid(string r) {
    ll n = r.size();
    ll res = 2 * n * (n - 1);
    string s;
    for (ll i = 0; i < n; i++) s += "1";
    string abc = "2357";
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < 4; j++) {
            s[i] = abc[j];
            ll ad = -1;
            for (ll q = 0; q < n && ad == -1; q++) {
                if (s[q] - '0' < r[q] - '0') {
                    ad = 1;
                } else if (s[q] - '0' > r[q] - '0') {
                    ad = 0;
                }
            }
            if (ad == -1) ad = 1;
            res += ad;
            s[i] = '1';
        }
    }
    return res;
}

ll f(string r) {
    ll n = r.size();
    vector<ll> suf(n + 1, 1);
    for (ll i = n - 1; i >= 0; i--) {
        if (r[i] == '0' || (r[i] == '1' && !suf[i + 1])) suf[i] = 0;
    }
    ll res = 2 * n * (n - 1);
    string abc = "2357";
    bool same = true;
    for(ll i = 0; i < n; i++) {
        for (ll j = 0; j < 4; j++) {
            if (!same || (abc[j] - '0' == r[i] - '0' && suf[i + 1]) || (abc[j] - '0' < r[i] - '0')) res++;
        }
        if (same) {
            if (r[i] - '0' > 1) {
                same = false;
            }
            if (r[i] - '0' < 1) {
                return res;
            }
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string l, r;
    cin >> l >> r;
    bool ok = true;
    ll prod = 1;
    for (ll i = 0; i < l.size() && ok; i++) {
        prod *= (l[i] - '0');
        if (prod != 1 && prod != 2 && prod != 3 && prod != 5 && prod != 7) ok = false;
    }
    if (prod != 2 && prod != 3 && prod != 5 && prod != 7) ok = false;
    cout << f(r) - f(l) + ok;
//    while (true) {
//        ll tl = rand1(1, 1e18), tr = rand1(tl, 1e18);
//        string l = to_string(tl), r = to_string(tr);
//        ll prod = 1;
//        ll res = 0;
//        bool ok = true;
//        for (ll i = 0; i < l.size() && ok; i++) {
//            prod *= (l[i] - '0');
//            if (prod != 1 && prod != 2 && prod != 3 && prod != 5 && prod != 7) ok = false;
//        }
//        if (prod != 2 && prod != 3 && prod != 5 && prod != 7) ok = false;
//        if (stupid(r) - stupid(l) != f(r) - f(l)) {
//            cout << "FAIL:\n";
//            cout << tl << " " << tr << '\n';
//            cout << stupid(r) - stupid(l) + ok << " " << ok +  f(r) - f(l);
//            return 0;
//        }
//    }
    return 0;
}
