#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64  gen(chrono::high_resolution_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    ll msz = (k * (k + 1) / 2);
    vector<vector<ll>> dp(n + 1, vector<ll> (1LL << msz, 0));
    dp[0][0] = 1;
    for (ll i = 0; i < n; i++) {
        for (ll mask = 0; mask < (1LL << msz); mask++) {
            if (dp[i][mask] == 0) continue;
            for (ll nmask = 0; nmask < (1LL << k); nmask++) {
                ll sum = 0;
                ll curn = 1;
                ll go = 0;
                ll cnt = msz - 1;
                for (ll j = msz - 1; j >= 0; j--) {
                    if (msz - j == ((curn * (curn + 1)) / 2)) {
                        curn++;
                        continue;
                    }
                    go += ((mask & (1LL << j)) >> j) * (1LL << cnt);
                    cnt--;
                    sum += (mask & (1LL << j)) >> j;
                }
                for (ll j = 0; j < k; j++) {
                    sum += (nmask & (1LL << j)) >> j;
                }
                go += nmask;
                if (sum == a[i]) {
                    dp[i + 1][go] += dp[i][mask];
                    dp[i + 1][go] %= mod;
                }
            }
        }
    }
    ll res = 0;
    for (ll mask = 0; mask < (1LL << msz); mask++) {
        res += dp[n][mask];
        res %= mod;
    }
    cout << res;
    return 0;
}
