#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937_64  gen(chrono::high_resolution_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int rand1(int a, int b) {
    return uniform_int_distribution<int> (a, b) (gen);
}

struct node {
    bool vis, cur, p;
    node() : vis(false), cur(false), p(false) {};
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, s;
    cin >> n >> s;
    vector<vector<int>> pset(n, vector<int> ());
    vector<int> tot;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        pset[i].resize(k);
        for (auto &j : pset[i]) {
            cin >> j;
            tot.push_back(j);
        }
    }
    vector<int> st(n + 1, 0);
    for (int i = 1; i <= n; i++) st[i] = st[i - 1] + pset[i - 1].size();
    int pos = 0;
    vector<vector<node>> bp(st[n] + 1, vector<node> (s + 1, node()));
    bp[0][0].vis = true;
    bp[0][0].cur = true;
    for (int lay = 1; lay <= st[n]; lay++) {
        for (int sum = 0; sum <= s; sum++) {
            if (bp[lay - 1][sum].vis) {
                if (lay == st[pos] + 1) {
                    if (bp[lay - 1][sum].cur) {
                        if (!bp[lay][sum].vis) {
                            bp[lay][sum].vis = true;
                        }
                        if (sum + tot[lay - 1] <= s) {
                            bp[lay][sum + tot[lay - 1]].vis = true;
                            bp[lay][sum + tot[lay - 1]].p = true;
                            bp[lay][sum + tot[lay - 1]].cur = true;
                        }
                    }
                } else {
                    if (!bp[lay][sum].vis) {
                        bp[lay][sum].vis = true;
                        bp[lay][sum].cur = bp[lay - 1][sum].cur;
                    }
                    if (sum + tot[lay - 1] <= s) {
                        bp[lay][sum + tot[lay - 1]].vis = true;
                        bp[lay][sum + tot[lay - 1]].p = true;
                        bp[lay][sum + tot[lay - 1]].cur = true;
                    }
                }
            }
        }
        if (lay == st[pos] + 1) pos++;
    }
    if (!bp[st[n]][s].vis || !bp[st[n]][s].cur) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    int clay = st[n], csum = s;
    vector<int> res;
    while (clay != 0) {
        if (bp[clay][csum].p) {
            csum -= tot[clay - 1];
            res.push_back(clay - 1);
        }
        clay--;
    }
    reverse(res.begin(), res.end());
    vector<vector<int>> ans(n, vector<int> ());
    pos = 1;
    for (int i = 0; i < res.size(); i++) {
        if (res[i] < st[pos]) {
            ans[pos - 1].push_back(res[i] - st[pos - 1] + 1);
        } else {
            pos++;
            ans[pos - 1].push_back(res[i] - st[pos - 1] + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i].size() << '\n';
        for (auto &e : ans[i]) cout << e << " ";
        cout << '\n';
    }
    return 0;
}
