#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937_64  gen(chrono::high_resolution_clock::now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int rand1(int a, int b) {
    return uniform_int_distribution<int> (a, b) (gen);
}

vector<string> paths;

void f(ll r, ll c, ll n, ll m, string cur) {
    if (r == n - 1 && c == m - 1) {
        paths.push_back(cur);
        return;
    }
    if (r + 1 < n) {
        cur += '1';
        f(r + 1, c, n, m, cur);
        cur.pop_back();
    }
    if (c + 1 < m) {
        cur += '0';
        f(r, c + 1, n, m, cur);
        cur.pop_back();
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> a(n, vector<ll> (m, 0));
    for (ll i = 0; i < k; i++) {
        ll r, c;
        cin >> r >> c;
        r--;
        c--;
        a[r][c] = 1;
    }
    if (a[0][0] == 1) k--;
    if (a[n - 1][m - 1] == 1) k--;
    f(0, 0, n, m, "");
    ll res = 0;
    for (ll i = 0; i < paths.size(); i++) {
        for (ll j = i + 1; j < paths.size(); j++) {
            ll ar = 0, ac = 0, br = 0, bc = 0, cnt = 0;
            bool ok = true;
            for (ll s = 0; s < paths[i].size() - 1 && ok; s++) {
                if (paths[i][s] == '1') {
                    ar++;
                } else {
                    ac++;
                }
                if (paths[j][s] == '1') {
                    br++;
                } else {
                    bc++;
                }
                if (ar == br && bc == ac) ok = false;
                cnt += a[ar][ac];
                cnt += a[br][bc];
            }
            if (ok && cnt == k) res += 2;
        }
    }
    cout << res % 1000000007;
    return 0;
}
