#include <iostream>
#include <map>
#include <set>
#include <numeric>
#include <vector>
#include <algorithm>
using namespace std;
#define int long long
using ll = long long;

signed main()
{
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (auto& v : a)
		cin >> v;
	vector<int> pref(n + 1, 1e15 + 10);
	for (int i = n - 1; i >= 0; i--)
		pref[i] = min(pref[i + 1], a[i]);
	vector<int> prefl(n + 1, 1e15 + 10);
	for (int i = 1; i <= n; i++)
		prefl[i] = min(prefl[i - 1], a[i - 1]);
	if (k == 2) {
		int len = n - k + 1;
		int l = 0, r = len - 1;
		ll ans = -1;
		ll sum = accumulate(a.begin(), a.begin() + len, 0ll);
		int mn = 1e15 + 10;
		while (r < n) {
			ans = max(ans, sum - min(mn, pref[r + 1]));
			mn = min(mn, a[l]);
			if (r != n - 1)
				sum += a[r + 1];
			sum -= a[l];
			r++;
			l++;
		}
		cout << ans << '\n';
	}
	else {
		ll ans = 0;
		for (int r = 0; r < n; r++) {
			ll sum = 0;
			for (int l = r; n - (r - l + 1) >= k - 1 && l >= 0; l--) {
				sum += a[l];
				ans = max(ans, sum - min(prefl[l], pref[r + 1]));
			}
		}
		cout << ans << "\n";
	}
	return 0;
}
