﻿#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
using namespace std;
   
   
   
void solve() {
    int n, s, el;
    cin >> n >> s;
    vector<int> ks(n);
    vector<int> all;
    int sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> ks[i];
        for (int j = 0; j < ks[i]; j++) {
            cin >> el;
            all.push_back(el);
        }
        sm += ks[i];
    }
    vector<vector<vector<int>>> dp(sm + 1, vector<vector<int>> (s + 1, vector<int> (2, -1)));
    int cnt = 0;
    dp[0][0][0] = 0;
    dp[0][0][1] = 0;
    int it = 0;
    for (int i = 1; i <= sm; i++) {
        if (cnt == ks[it]) {
            cnt = 0;
            it++;
        }
        for (int j = 0; j <= s; j++) {
            if (cnt == 0) {
                if (j - all[i - 1] >= 0) {
                    if (dp[i - 1][j - all[i - 1]][1] != -1) {
                        dp[i][j][1] = i - 1;
                        dp[i][j][0] = i - 1;
                    }
                }
                if (dp[i - 1][j][1] != -1) {
                    dp[i][j][0] = dp[i - 1][j][1];
                }
            }
            else {
                if (j - all[i - 1] >= 0) {
                    if (dp[i - 1][j - all[i - 1]][1] != -1 || dp[i - 1][j - all[i - 1]][0] != -1) {
                        dp[i][j][1] = i - 1;
                        dp[i][j][0] = i - 1;
                    }
                }
                if (dp[i - 1][j][1] != -1 || dp[i - 1][j][0] != -1) {
                    dp[i][j][0] = dp[i - 1][j][0];
                    dp[i][j][1] = dp[i - 1][j][1];
                }
            }
        }
        cnt++;
    }
    if (dp[sm][s][1] == -1) {
        cout << "No\n";
        return;
    }
    
    vector<bool> colour(sm);
    cnt = 0;
    it = 0;
    for (int i = 0; i < sm; i++) {
        if (cnt == ks[it]) {
            cnt = 0;
            it++;
            colour[i] = true;
        }
        cnt++;
    }
    int cs = s;
    int zer = 0;
    vector<int> pick;
    for (int i = sm; i > 0; i--) {
        if (cs == 0) break;
        if (colour[i - 1]) {
            if (cs - all[i - 1] >= 0) {
                if (dp[i - 1][cs - all[i - 1]][1] != -1) {
                    cs -= all[i - 1];
                    pick.push_back(i - 1);
                }
            }
        }
        else {
            if (cs - all[i - 1] >= 0) {
                if (dp[i - 1][cs - all[i - 1]][1] != -1 || dp[i - 1][cs - all[i - 1]][0] != -1) {
                    cs -= all[i - 1];
                    pick.push_back(i - 1);
                }
            }
        }
    }
    vector<bool> which(sm);
    for (int x : pick) which[x] = true;
    vector<vector<int>> ans(n);
    it = 0;
    cnt = 0;
    int smm = 0;
    int allcheck = 0;
    for (int i = 0; i < sm; i++) {
        if (cnt == ks[it]) {
            smm += ks[it];
            it++;
            cnt = 0;
        }
        if (which[i]) {
            allcheck += all[i];
            ans[it].push_back(i - smm);
        }
        cnt++;
    }
    cnt = 1;
    if (allcheck != s) {
        cout << "No\n";
        return;
    }
    for (auto v : ans) {
        if (v.size() == 0) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    for (auto v : ans) {
        cout << v.size() << '\n';
        for (int x : v) cout << x + 1 << '\n';
    }
}
signed main()
{
    solve();
}