﻿#include <iostream>
#include <vector>
#include <string>
using namespace std;


struct asd
{
	long long x, x1, x2, x3, x5, x4;
	asd() {}
	asd(long long a)
	{
		x = a;
		x1 = a;
		x2 = a;
		x3 = a;
		x4 = a;
		x5 = a;
	}
};

long long f(string a, int i, vector<long long>& d, vector<long long>& p, vector<int>& e)
{
	long long ans = 0, n = a.size() - i;

	if (n == 0)
	{
		return 0;
	}
	if (a[i] == '0')
	{
		return 0;
	}

	if (a[i] == '1')
	{
		ans += f(a, i + 1, d, p, e);
	}
	else
	{
		if(n > 1) ans += d[n - 1] - d[n - 2];
		//cout << a << " " << i << "-) " << ans << "\n";
	}

	int j = 0; 
	while (j < p.size() && p[j] < a[i] - '0')
	{
		j++;
	}
	ans += j;
	if (j < p.size() && p[j] == a[i] - '0')
	{
		if (i == a.size() - 1)
		{
			ans++;
		}
		else
		{
			if (e[i + 1] == 1)
			{
				ans++;
			}
		}
	}
	//cout << a << " " << i << ") " << ans << "\n";
	return ans;

}

void build(vector<long long>& d)
{
	long long inf = 1e5 + 1;
	d.resize(inf);

	d[0] = 0;
	d[1] = 4;

	for (int i = 2; i < d.size(); i++)
	{
		d[i] = d[i - 1] + i * 4;
	}

}

int main()
{
	string l, r;
	cin >> l >> r;
	long long ansl, ansr;

	vector<long long> d;
	build(d);
	vector<long long> p = { 2, 3, 5, 7 };

	vector<int> e(l.size());
	for (int i = e.size() - 1; i >= 0; i--)
	{
		if (l[i] == '0')
		{
			e[i] = 0;
			continue;
		}
		if (l[i] == '1')
		{
			if (i < e.size() - 1)
			{
				e[i] = e[i + 1];
				continue;
			}
			e[i] = 1;
			continue;
		}
		e[i] = 1;
	}
	ansl = f(l, 0, d, p, e);


	e.resize(r.size());
	for (int i = e.size() - 1; i >= 0; i--)
	{
		if (r[i] == '0')
		{
			e[i] = 0;
			continue;
		}
		if (r[i] == '1')
		{
			if (i < e.size() - 1)
			{
				e[i] = e[i + 1];
				continue;
			}
			e[i] = 1;
			continue;
		}
		e[i] = 1;
	}
	ansr = f(r, 0, d, p, e);

	if(l.size() > 0) ansl += d[l.size() - 1];
	if (r.size() > 0) ansr += d[r.size() - 1];

	vector<int> pr(10, 0);
	for (int i = 0; i < l.size(); i++)
	{
		if (l[i] != '1' && pr[l[i] - '0'] == 1)
		{
			//cout << "\n" << ansl << " " << ansr << "\n";
			cout << ansr - ansl << "\n";
			return 0;
		}
		pr[l[i] - '0']++;
		if (l[i] != '1' && l[i] != '2' && l[i] != '3' && l[i] != '5' && l[i] != '7')
		{
			//cout << "\n" << ansl << " " << ansr << "\n";
			cout << ansr - ansl << "\n";
			return 0;
		}

	}
	//cout << "\n" << ansl << " " << ansr << "\n";
	if (pr[2] == 1 || pr[3] == 1 || pr[5] == 1 || pr[7] == 1) ansl--;

	cout << ansr - ansl;
}

/*

C

struct asd
{
	long long x, x1, x2, x3, x5, x4;
	asd() {}
	asd(long long a)
	{
		x = a;
		x1 = a;
		x2 = a;
		x3 = a;
		x4 = a;
		x5 = a;
	}
};

int main()
{
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

}
*/

/*

A 100

	long long n, m, k;
	cin >> n >> m >> k;
	n--;
	m--;
	if (n > m)
	{
		swap(n, m);
	}
	long long ans = n / k;
	if (n % k > 0) ans++;
	ans += (m - n) / k;
	if ((m - n) % k > 0) ans++;
	cout << ans;

B 0

struct asd
{
	long long x, x1, x2, x3, x5, x4;
	asd() {}
	asd(long long a)
	{
		x = a;
		x1 = a;
		x2 = a;
		x3 = a;
		x4 = a;
		x5 = a;
	}
};

long long f(string a, int i, vector<asd>& d, vector<long long>& p)
{
	long long ans = 0, n = a.size() - i;
	ans += d[n - 1].x - (n - 1);
	if ((a[i] - '0') == 0)
	{
	cout << a << " " << i << ") " << 0 << "\n";
		return 0;
	}

	if (n == 1)
	{
		int j = 0;
		while (j < p.size() && p[j] <= (a[i] - '0'))
		{
			ans++;
			j++;
		}
		if (i == 0)
		{
			cout << a << " " << i << ") " << ans - 1 << " - 5\n";
			return ans - 1;
		}
		cout << a << " " << i << ") " << ans << " - 6\n";
		return ans;
	}
	int j = 0;
	while (j < p.size() && p[j] < (a[i] - '0'))
	{
		ans += d[n - 1].x;
		j++;
	}
	if (j < p.size() && p[j] == (a[i] - '0'))
	{
		ans += f(a, i + 1, d, p);
	}
	if (i == 0)
	{
		int h = 0;
		for (j = 0; j < a.size(); j++)
		{
			if ((a[j] - '0') > 1)
			{
				cout << a << " " << i << ") " << ans - 1 << " - 1 \n";
				return ans - 1;
			}
			if ((a[j] - '0') < 1)
			{
				cout << a << " " << i << ") " << d[n - 1].x << " - 2\n";
				return d[n - 1].x;
			}
		}
		cout << a << " " << i << ") " << d[n -1].x << " - 3\n";
		return d[n - 1].x;
	}
	cout << a << " " << i << ") " << ans << " - 4\n";
	return ans;
}

void build(vector<asd>& d)
{
	long long inf = 1e5 + 1;
	d.resize(inf);

	d[0] = asd(0);
	d[1].x = 5;
	d[1].x1 = 0;
	d[1].x2 = 0;
	d[1].x3 = 0;
	d[1].x4 = 4;
	d[1].x5 = 1;

	for (int i = 2; i < d.size(); i++)
	{
		long long x1 = d[i - 1].x1, x2 = d[i - 1].x2, x3 = d[i - 1].x3, x5 = d[i - 1].x5, x4 = d[i - 1].x4;
		d[i].x = x1 + x2 * 2 + x3 * 3 + x4 * 4 + x5 * 5 - 1;
		d[i].x5 = x5;
		d[i].x4 = x5 * 4 + x4;
		d[i].x3 = x4 * 3 + x3;
		d[i].x2 = x3 * 2 + x2;
		d[i].x1 = x2 * 1 + x1;
	}

	//for (int i = 1; i < 5; i++)
	//{
	//	cout << d[i].x << " ";
	//}
}

int main()
{
	string l, r;
	cin >> l >> r;
	long long ansl, ansr;

	vector<asd> d;
	build(d);

	vector<long long> p = { 1, 2, 3, 5, 7 };

	ansl = f(l, 0, d, p);
	ansr = f(r, 0, d, p);

	vector<int> pr(10, 0);
	for (int i = 0; i < l.size(); i++)
	{
		pr[l[i] - '0']++;
		if (l[i] != '1' && l[i] != '2' && l[i] != '3' && l[i] != '5' && l[i] != '7')
		{
			cout << ansr - ansl << "\n";
			return 0;
		}

	}
	cout << "\n" << ansl << " " << ansr << "\n";
	if (pr[2] <= 1 && pr[3] <= 1 && pr[5] <= 1 && pr[7] <= 1) ansl--;

	cout << ansr - ansl;
}





struct asd
{
	long long x, x1, x2, x3, x5, x4;
	asd() {}
	asd(long long a)
	{
		x = a;
		x1 = a;
		x2 = a;
		x3 = a;
		x4 = a;
		x5 = a;
	}
};

//long long f(string a, int i, vector<asd>& d, vector<long long>& p, map<int, int> m)
//{
//	long long ans = 0, n = a.size() - i;
//	if ((a[i] - '0') == 0)
//	{
//		cout << a << " " << i << ") " << 0 << "\n";
//		return 0;
//	}
//	int z = 0;
//	for (int j = 0; j < p.size(); j++)
//	{
//		if (m[p[j]] == 0) z++;
//	}
//	int j = 1, li = ;
//
//	ans += d[n - 1].x;
//
//	while (j < p.size() && p[j] < (a[i] - '0'))
//	{
//		if (m[p[j]] == 0)
//		{
//			j++;
//			continue;
//		}
//		ans += d[n - 1].x - li;
//		j++;
//	}
//	if (j < p.size() && p[j] == (a[i] - '0') && m[p[j]] == 1)
//	{
//		m[p[j]] = 0;
//		ans += f(a, i + 1, d, p, m);
//	}
//
//	if (i == 0)
//	{
//		for (j = 0; j < a.size(); j++)
//		{
//			if ((a[j] - '0') > 1)
//			{
//				cout << a << " " << i << ") " << ans - 1 << " - 1 \n";
//				return ans - 1;
//			}
//			if ((a[j] - '0') < 1)
//			{
//				cout << a << " " << i << ") " << d[n - 1].x << " - 2\n";
//				return d[n - 1].x;
//			}
//		}
//		cout << a << " " << i << ") " << d[n - 1].x << " - 3\n";
//		return d[n - 1].x;
//	}
//
//	cout << a << " " << i << ") " << ans << " - 4\n";
//	return ans;
//}

void build(vector<asd>& d)
{
	long long inf = 1e5 + 1;
	d.resize(inf);

	d[0] = asd(0);
	d[1].x = 5;
	d[1].x1 = 0;
	d[1].x2 = 0;
	d[1].x3 = 0;
	d[1].x4 = 4;
	d[1].x5 = 1;

	for (int i = 2; i < d.size(); i++)
	{
		long long x1 = d[i - 1].x1, x2 = d[i - 1].x2, x3 = d[i - 1].x3, x5 = d[i - 1].x5, x4 = d[i - 1].x4;
		d[i].x = x1 + x2 * 2 + x3 * 3 + x4 * 4 + x5 * 5;
		d[i].x5 = x5;
		d[i].x4 = x5 * 4 + x4;
		d[i].x3 = x4 * 3 + x3;
		d[i].x2 = x3 * 2 + x2;
		d[i].x1 = x2 * 1 + x1;
	}

	//for (int i = 1; i < 5; i++)
	//{
	//	cout << d[i].x << " ";
	//}
}

int main()
{
	string l, r;
	cin >> l >> r;
	long long ansl, ansr;

	vector<asd> d;
	build(d);

	//vector<long long> p = { 1, 2, 3, 5, 7 };
	//map<int, int> m;
	//m[1] = 1;
	//m[2] = 1;
	//m[3] = 1;
	//m[5] = 1;
	//m[7] = 1;
	long long ans = 0;
	for (int i = 1; i < r.size(); i++)
	{
		ans += d[i].x - 1;
	}
	cout << ans;

	//ansl = f(l, 0, d, p, m);
	//ansr = f(r, 0, d, p, m);
	//ansl += d[l.size() - 1].x - (l.size() - 1);
	//ansr += d[r.size() - 1].x - (r.size() - 1);

	//vector<int> pr(10, 0);
	//for (int i = 0; i < l.size(); i++)
	//{
	//	pr[l[i] - '0']++;
	//	if (l[i] != '1' && l[i] != '2' && l[i] != '3' && l[i] != '5' && l[i] != '7')
	//	{
	//		cout << ansr - ansl << "\n";
	//		return 0;
	//	}

	//}
	//cout << "\n" << ansl << " " << ansr << "\n";
	//if (pr[2] <= 1 && pr[3] <= 1 && pr[5] <= 1 && pr[7] <= 1) ansl--;

	//cout << ansr - ansl;
}

C 26

struct tree
{
	long long ma, mip, map, p;
	tree() {}
	tree(long long a)
	{
		ma = a;
	}
};
void build(int x, int l, int r, vector<tree>& t, vector<long long>& a)
{
	if (r - l == 1)
	{
		t[x].ma = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(x * 2 + 1, l, m, t, a);
	build(x * 2 + 2, m, r, t, a);

	t[x].ma = max(t[x * 2 + 1].ma, t[x * 2 + 2].ma);

}

void build(vector<tree>& t, vector<long long>& a)
{
	t.resize(a.size() * 4, tree(-1));
	build(0, 0, a.size(), t, a);
}

long long getm(int x, int lx, int rx, int l, int r, vector<tree>& t, vector<long long>& a)
{
	if (l >= rx || r <= lx)
	{
		return -1;
	}
	if (l >= lx && r <= rx)
	{
		return t[x].ma;
	}
	int m = (l + r) / 2;
	return max(getm(x * 2 + 1, lx, rx, l, m, t, a), getm(x * 2 + 2, lx, rx, m, r, t, a));
}

long long getm(int lx, int rx, vector<tree>& t, vector<long long>& a)
{
	return getm(0, lx, rx, 0, a.size(), t, a);
}

//long long getp(int x, int v, int l, int r, int pu, vector<tree>& t, vector<long long>& a)
//{
//	if (r - l == 1)
//	{
//		return t[x].map + pu;
//	}
//
//	int m = (l + r) / 2;
//}
//
//long long getm(int lx, int rx, vector<tree>& t, vector<long long>& a)
//{
//	return getm(0, lx, rx, 0, a.size(), t, a);
//}
//
//void set(int x, int lx, int rx, vector<tree>& t, vector<long long>& a)
//{
//
//}
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	vector<long long> a(n);
	vector<int> p(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		p[i] = i;
	}
	vector<tree> t;
	build(t, a);

	//cout << "+";

	for (int i = 0; i < n - 1; i++)
	{
		int k;
		cin >> k;
		k--;
		int j = 0, l, r = -1;
		while (p[j] < k)
		{
			j++;
		}
		l = j;
		j++;
		while (p[j] == p[j - 1])
		{
			j++;
		}
		int v = p[j];
		while (j < n)
		{
			if (r == -1 && p[j] > v)
			{
				r = j;
			}
			p[j]--;
			j++;
		}
		if (r == -1)
		{
			r = n;
		}
		long long ans = 0;
		for (j = l; j < r; j++)
		{
			long long s = min(getm(l, j + 1, t, a), getm(j, r, t, a)) - a[j];
			//cout << j << ") " << s << "\n";
			ans += s;
		}
		cout << ans << "\n";
		//cout << l << " " << r << "\n";
		//for (int i = 0; i < n; i++)
		//{
		//	cout << p[i] << " ";
		//}
		//cout << "\n";
	}
}

*/