﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;

long long f(long long x)
{
	return x * x;
}

int main()
{

	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	long long d, l, r;
	cin >> d >> l >> r;
	r++;
	long long x = 1, y = 1;
	while (y * y < l)
	{
		y++;
	}
	l = y;
	while (x * x <= r)
	{
		x++;
	}
	r = x;
	long long s = 0;
	for (long long i = l; i < r - 1; i++)
	{
		x = abs(d - i * i);
		if (x >= l && x < r && sqrt(x) * sqrt(x) == x)
		{
			s++;
		}
	}
	cout << s;

}
/*

2 4
1
2
2
3 1

2 4
1 
2
2 
2 1


*/










/*

A 78


	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	long long d, l, r;
	cin >> d >> l >> r;
	r++;
	vector<long long> a(2);
	a[1] = 1;
	a[0] = 0;
	long long x = 2, y = 1;
	while (y * y < l)
	{
		y++;
	}
	l = y;
	while (x * x < r)
	{
		a.push_back(x * x - (x - 1) * (x - 1) + a[a.size() - 1]);
		x++;
	}
	r = x;
	long long s = 0;
	for (long long i = l; i < r - 1; i++)
	{
		long long ll = i + 1, rr = r;
		while (rr - ll > 1)
		{
			long long m = (ll + rr) / 2;
			if (a[m] - a[i] > d) rr = m;
			else ll = m;
		}
		if (a[ll] - a[i] == d)
		{
			//cout << i << " " << ll << " " << d << "\n";
			s++;
		}
	}
	cout << s;

64 1 100

64 1 300




C 45
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

struct asd
{
	int x, i;
	asd() {}
	asd(int a, int b)
	{
		x = a;
		i = b;
	}
};

bool comp(asd a, asd b)
{
	return a.x < b.x;
}

void build(vector<vector<int>>& d, vector<asd>& a, int s)
{
	sort(a.begin(), a.end(), comp);

	d.resize(a.size(), vector<int>(s + 1, -1));
	d[0][a[0].x] = 1;
	d[0][0] = 0;

	for (int i = 1; i < d.size(); i++)
	{
		for (int j = 0; j < d[i].size(); j++)
		{
			if (d[i - 1][j] != -1)
			{
				d[i][j] = 0;
				continue;
			}
			if (j >= a[i].x && d[i - 1][j - a[i].x] != -1)
			{
				d[i][j] = 1;
				continue;
			}
		}
	}
}

vector<int> get(vector<vector<int>>& d, vector<asd>& a, int s)
{
	vector<int> ans;
	int i = d.size() - 1, j = s;
	while (i >= 0 && j >= 0)
	{
		if (d[i][j] == 1)
		{
			ans.push_back(a[i].i);
			j -= a[i].x;
			i--;
			continue;
		}
		i--;
	}
	return ans;
}

void prin(vector<vector<int>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
		{
			cout << a[i][j] << " ";
		}
		cout << "\n";
	}

}

int main()
{
	int n, s;
	cin >> n >> s;
	int m = 0, h = 1;
	vector<vector<asd>> a(n);
	vector<vector<vector<int>>> d(n);
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		if (k != 1) h = 0;
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			a[i].push_back(asd(x, j));
			m += x;
		}
		build(d[i], a[i], s);
	}
	if (h == 1)
	{
		if (m == s)
		{
			cout << "Yes\n";
			for (int i = 0; i < n; i++)
			{
				cout << "1\n1\n";
			}
			return 0;
		}
		cout << "No";
		return 0;
	}

	vector<vector<int>> dd(n, vector<int> (s + 1, -1));
	for (int i = 1; i < s + 1; i++)
	{
		if (d[0][d[0].size() - 1][i] != -1)
		{
			dd[0][i] = i;
		}
	}
	for (int i = 1; i < dd.size(); i++)
	{
		for (int j = 0; j < dd[i].size(); j++)
		{
			for (int g = 1; g <= j; g++)
			{
				if (d[i][d[i].size() - 1][g] == -1)
				{
					continue;
				}
				if (dd[i - 1][j - g] != -1)
				{
					dd[i][j] = g;
					continue;
				}

			}
		}
	}

	//prin(dd);

	if (dd[dd.size() - 1][s] == -1)
	{
		cout << "No";
		return 0;
	}
	vector<vector<int>> ans(n);

	int i = n - 1, j = s;
	while (i >= 0 && j >= 0)
	{
		if (dd[i][j] != -1)
		{
			ans[i] = get(d[i], a[i], dd[i][j]);
			//cout << "---- " << i << " ----\n";
			//prin(d[i]);
			j -= dd[i][j];
			i--;
			continue;
		}
		else
		{
			cout << "No";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < ans.size(); i++)
	{
		//cout << i << ") ";
		cout << ans[i].size() << "\n";
		for (int j = 0; j < ans[i].size(); j++)
		{
			cout << ans[i][j] + 1 << " ";
		}
		cout << "\n";
	}
}







1 7
5
1 5 3 2 8

1 6
5
2 5 3 2 2

struct tree
{
	long long sum, mi;
	int ima, imi;
	tree() {}
	tree(long long a)
	{
		sum = a;
		mi = a;
	}
	tree(long long a, int b)
	{
		sum = a;
		mi = a;
		ima = b;
		imi = b;
	}
	tree(long long a, long long c)
	{
		sum = a;
		mi = c;
		ima = -1;
		imi = -1;
	}
};

void build(int x, int l, int r, vector<long long>& t, vector <long long>& a)
{
	if (r - l == 1)
	{
		t[x] = a[l];
		return;
	}

	int m = (l + r) / 2;
	build(x * 2 + 1, l, m, t, a);
	build(x * 2 + 2, m, r, t, a);

	t[x] = min(t[x * 2 + 1], t[x * 2 + 2]);
}

void build(vector<long long>& t, vector<long long>& a)
{
	t.resize(a.size() * 4, 0);
	build(0, 0, a.size(), t, a);
}

long long get(int x, int l, int r, int lx, int rx, vector<long long>& t, vector<long long>& a)
{
	if (r <= lx || l >= rx)
	{
		return 1e9;
	}
	if (r <= rx && l >= lx)
	{
		return t[x];
	}

	int m = (l + r) / 2;
	return min(get(x * 2 + 1, l, m, lx, rx, t, a), get(x * 2 + 2, m, r, lx, rx, t, a));

}

long long get(int lx, int rx, vector<long long>& t, vector<long long>& a)
{
	return get(0, 0, a.size(), lx, rx, t, a);
}
*/