#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>;

using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
#define all(x) x.begin(), x.end()
#define endl "\n"

int get_full(int len){
    return 4 * len;
}

int get_max(string& str){
    int n = (int)str.size();
    int ans = 0;
    int i = 0;
    for (; i < n; i++){
        int fig = str[i] - '0';
        if (fig > 1){
            ans += get_full(n - i - 1) * (fig - 1);
            int cnt = 0;
            vi v = {2, 3, 5, 7};
            for (auto& x: v){
                if (fig >= x){
                    cnt++;
                }
            }
            for (int j = i + 1; j < n; j++){
                int fig2 = str[j] - '0';
                if (fig2 > 1){
                    break;
                }
                if (fig2 == 0){
                    cnt--;
                    break;
                }
            }
            ans += cnt;
            return ans;
        }
    }
}

void solve(){
    string l, r; cin >> l >> r;

    int n = (int)l.size();
    int m = (int)r.size();

    int ans = 0;
    for (int len = n; len < m; len++){
        ans += get_full(len);
    }
    ans += get_max(r);
    ans -= get_max(l);

    int cnt1 = 0;
    int fig = -1;
    for (int i = 0; i < n; i++){
        int f = l[i] - '0';
        if (f == 1){
            cnt1++;
        }
        else{
            fig = f;
        }
    }
    set<int> st = {2, 3, 5, 7};
    if (cnt1 == n - 1 && st.count(fig)){
        ans++;
    }

    cout << ans << endl;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
};
