#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>;

using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
#define all(x) x.begin(), x.end()
#define endl "\n"



vi v = {2, 3, 5, 7};
set<int> st = {2, 3, 5, 7};


// stress

bool check(int x){
    int fig = -1;
    while (x > 0){
        int f = x % 10;
        if (f != 1){
            if (fig != -1 || !(st.count(f))){
                return false;
            }
            fig = f;
        }
        x /= 10;
    }
    return fig != -1;
}

int ans(string l, string r){
    int x = stoi(l);
    int y = stoi(r);

    int ans = 0;
    for (int i = x; i <= y; i++){
        ans += check(i);
    }

    return ans;

}

// solve

int get_full(int len){
    return 4ll * len;
}

int get_lim(string& str){
    int n = (int)str.size();
    int i = 0;
    for (; i < n; i++){
        if (str[i] > '1'){
            break;
        }
    }

    if (i == n){
        return 0ll;
    }
    int f = str[i] - '0';
    if (f == 0){
        return 0;
    }

    int ans = get_full(n - i - 1);

    for (int j = 2; j < f; j++){
        if (st.count(j)){
            ans++;
        }
    }

    bool flag = true;
    for (int j = i + 1; j < n; j++){
        int fig = str[j] - '0';
        if (fig == 0){
            flag = false;
            break;
        }
        if (fig > 1){
            break;
        }
    }

    if (st.count(f) && flag){
        ans++;
    }

    return ans;
}

bool check(string str){
    int n = (int)str.size();
    int cnt1 = 0;
    int fig = -1;
    for (auto c: str){
        if (c == '1'){
            cnt1++;
        }
        else{
            fig = c - '0';
        }
    }

    return (cnt1 == n - 1) && (st.count(fig));
}

void solve_equal(string& l, string& r){
    int n = (int)l.size();
    reverse(all(l));
    reverse(all(r));
    while (!l.empty()){
        if (l.back() == '1' && r.back() == '1'){
            l.pop_back();
            r.pop_back();
        }
        else{
            break;
        }
    }
    n = (int)l.size();
    if (n == 0) {
        cout << 0 << endl;
        return;
    }
    reverse(all(l));
    reverse(all(r));

    int fl = l[0] - '0';
    int fr = r[0] - '0';
    int cnt_full = 0;
    for (int i = fl + 1; i < fr; i++){
        if (st.count(i)){
            cnt_full++;
        }
    }
    cout << "check1 " << cnt_full << endl;

    bool flag1 = true;
    for (int i = 1; i < n; i++){
        int fig = l[i] - '0';
        if (fig == 0){
            break;
        }
        if (fig > 1){
            flag1 = false;
            break;
        }
    }
    if (flag1 && st.count(fl)){
        cnt_full++;
    }
    else if (check(l)){
        cnt_full++;
    }


    bool flag2 = true;
    for (int i = 1; i < n; i++){
        int fig = r[i] - '0';
        if (fig == 0){
            flag2 = false;
            break;
        }
        else{
            break;
        }
    }
    if (flag2 && st.count(fr)){
        cnt_full++;
    }
    else if (check(r)){
        cnt_full++;
    }


    cout << flag1 << " " << flag2 << endl;

    cout << "check2 " << cnt_full << endl;

    int ans = cnt_full;

    if (fl > 1 || fr < 1 || (fl == 1 && !flag1) || (fr == 1 && !flag2)){
        cout << ans << endl;
        return;
    }

    ans += get_full(n - 1);

    cout << ans << endl;

}

void solve(){
    string l, r; cin >> l >> r;

    int n = (int)l.size();
    int m = (int)r.size();

    if (n == m){
        solve_equal(l, r);
        return;
    }

    int ans = 0;
    for (int len = n; len < m; len++){
        ans += get_full(len);
    }

    ans += get_lim(r);
    ans -= get_lim(l);

    if (check(l)){
        ans++;
    }

    cout << ans << endl;
}

void solve0(){
    string l, r; cin >> l >> r;

    int n = (int)l.size();
    int m = (int)r.size();

    if (n == m){
        solve_equal(l, r);
        return;
    }

    cout << ans(l, r) << endl;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--){
        solve0();
    }
};
