#include <bitset>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <map>
#include <deque>
#include <iostream>

using namespace std;
using ll = long long;

constexpr ll M = 1e9 + 7;

void sol() {
    int n, k;
    cin >> n >> k;
    vector <int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    if (n * k <= 25) {
        int ans = 0;
        for (int mask = 0; mask < (1 << (n * k)); mask++) {
            bool flag = true;
            int sm = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < k; j++) {
                    sm += (mask >> (j * n + i)) & 1;
                }
                for (int j = i - 1; j >= max(0, (i - k)); j--) {
                    sm -= (mask >> ((k - i + j) * n + j)) & 1;
                }
                if (sm != v[i]) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                ans++;
            }
        }
        cout << ans << '\n';
    } else if (k == 1) {
        cout << 1 << '\n';
    } else if (k == 2) {
        vector <vector <ll>> dp(n, vector <ll> (4, 0));
        if (v[0] == 0) {
            dp[0][0] = 1;
        } else if (v[0] == 1) {
            dp[0][1] = 1;
            dp[0][2] = 1;
        } else if (v[0] == 2) {
            dp[0][3] = 1;
        } else {
            cout << 0 << '\n';
            return;
        }
        for (int i = 1; i < n; i++) {
            if (v[i] == 0) {
                dp[i][0] = (dp[i - 1][0] + dp[i - 1][2]) % M;
            } else if (v[i] == 1) {
                dp[i][0] = (dp[i - 1][1] + dp[i - 1][3]) % M;

                dp[i][1] = (dp[i - 1][0] + dp[i - 1][2]) % M;
                dp[i][2] = dp[i][1];
            } else if (v[i] == 2) {
                dp[i][1] = (dp[i - 1][1] + dp[i - 1][3]) % M;
                dp[i][2] = dp[i][1];

                dp[i][3] = (dp[i - 1][0] + dp[i - 1][2]) % M;
            } else {
                dp[i][3] = (dp[i - 1][1] + dp[i - 1][3]) % M;
            }
        }
        cout << (dp[n - 1][0] + dp[n - 1][1] + dp[n - 1][2] + dp[n - 1][3]) % M;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> t;
    while (T--) {
        sol();
    }
}

//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1
