#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <climits>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

void sol() {
    int n, s, k, c;
    cin >> n >> s;
    int S = s + 1;
    vector <int> dp(S);
    vector <vector <pair <int, int>>> re(n, vector <pair <int, int>> (S, {-1, -1}));
    dp[0] = 1;
    for (int i = 0; i < n; i++) {
        if (i != 0) {
            dp[0] = 0;
        }
        cin >> k;
        vector <int> temp = dp;
        for (int j = 0; j < k; j++) {
            cin >> c;
            for (int ii = S - c - 1; ii >= 0; ii--) {
                dp[ii + c] += dp[ii];
                if (dp[ii] != 0 && re[i][ii + c].first == -1) {
                    re[i][ii + c] = {c, j + 1};
                }
            }
        }
        for (int i = 0; i < S; i++) {
            dp[i] -= temp[i];
        }
    }
    if (dp[s] == 0) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        vector <vector <int>> res(n);
        for (int i = n - 1; i >= 0; i--) {
            int last = 2e5;
            while (re[i][s].first != -1 && re[i][s].second != last) {
                res[i].push_back(re[i][s].second);
                last = re[i][s].second;
                s -= re[i][s].first;
            }
        }
        for (int i = 0; i < n; i++) {
            cout << res[i].size() << '\n';
            if (res[i].size() == 0) {
                exit(1);
            }
            sort(res[i].begin(), res[i].end());
            for (int j : res[i]) {
                cout << j << " ";
            }
            cout << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}
