#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <climits>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

constexpr ll M = 1e9 + 7;

int n, m, k;
int ans = 0;
vector <pair <int, int>> v;

void dfs(int x, int y, vector <int> used, bool vniz, bool k1, bool k2, bool p1, bool p2, int type, int cnt) {
//    if (vniz) {
//        for (int i = 0; i < k; i++) {
//            if (!used[v[i].first][v[i].second]) {
//                if (k1 && v[i].second < y && v[i].first == x) {
//                    return;
//                }
//                if (k2 && v[i].second > y && v[i].first == x) {
//                    return;
//                }
//                if (p1 && v[i].second == y && v[i].first < x) {
//                    return;
//                }
//                if (p2 && v[i].second == y && v[i].first > x) {
//                    return;
//                }
//            }
//        }
//    }
    if (x == n - 1 && y == m - 1) {
        k1 = false;
        k2 = false;
        p1 = false;
        p2 = false;
        vniz = false;
        cnt++;
    } else if (x != 0 || y != 0) {
        if (y == 0) {
            k1 = true;
        }
        if (y == m - 1) {
            k2 = true;
        }
        if (k1 && k2) {
            return;
        }
        if (x == 0) {
            p1 = true;
        }
        if (x == n - 1) {
            p2 = true;
        }
        if (p1 && p2) {
            return;
        }
    }
    for (int i = 0; i < k; i++) {
        if (v[i].first == x && v[i].second == y) {
            cnt++;
        }
    }
    if (x == 0 && y == 0) {
        if (cnt == k + 1) {
            ans++;
        }
        return;
    }
    if (!vniz) {
        if (type == 1) {
            if (x != 0) {
                dfs(x - 1, y, used, false, k1, k2, p1, p2, type, cnt);
            }
            if (y != 0 && (used[x] < y - 1 || (x == 0 && y == 1))) {
                dfs(x, y - 1, used, false, k1, k2, p1, p2, type, cnt);
            }
        } else {
            if (x != 0 && used[x - 1] > y) {
                dfs(x - 1, y, used, false, k1, k2, p1, p2, type, cnt);
            }
            if (y != 0) {
                dfs(x, y - 1, used, false, k1, k2, p1, p2, type, cnt);
            }
        }
    } else {
        used[x] = y;
        if (x != n - 1) {
            dfs(x + 1, y, used, true, k1, k2, p1, p2, type, cnt);
        }
        if (y != m - 1) {
            dfs(x, y + 1, used, true, k1, k2, p1, p2, type, cnt);
        }
    }
}

void sol() {
    cin >> n >> m >> k;
    v.resize(k);
    vector <vector <bool>> mp(n, vector <bool> (m));
    for (int i = 0; i < k; i++) {
        cin >> v[i].first >> v[i].second;
        v[i].first--, v[i].second--;
        mp[v[i].first][v[i].second] = true;
    }
    vector<int> used(n);
    dfs(1, 0, used, true, false, false, false, false, 1, 0);
    dfs(0, 1, used, true, false, false, false, false, 2, 0);
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}
