#include <iostream>
#include <algorithm>
#include "set"
#include "map"
#include "unordered_map"
#include "unordered_set"
#include "cmath"
#include "vector"
#include "limits"
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using orderd_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fi first
#define se second
#define pb push_back
#define eb emplace_back
#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": " << for (auto &i : a) cerr << i << ' '; cerr << '\n'
#define vin(a) for (auto &i : a) cin >> i
#define int ll

void solve() {
    string l, r;
    cin >> l >> r;
    auto is = [&](int x) -> bool {
        return x == 2 || x == 3 || x == 5 || x == 7;
    };
    auto get = [&](string &x) -> int {
        int n = x.size();
        vi p(n);
        for (int j = 0; j < n; ++j) {
            p[j] = int(x[j] - '0');
        }
        vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(2, vector<int>(2, 0)));
        // len, visit num > 1, on the line with x
        for (int i = 0; i <= p[0]; ++i) {
            if (i == 1) {
                if (i == p[0]) {
                    dp[1][0][1] += 1;
                } else {
                    dp[1][0][0] += 1;
                }
            } else {
                if (is(i)) {
                    if (i == p[0]) {
                        dp[1][1][1] += 1;
                    } else {
                        dp[1][1][0] += 1;
                    }
                }
            }
        }
        for (int sz = 1; sz < n; ++sz) {
            for (int j = 0; j < 2; ++j) {
                for (int k = 0; k < 2; ++k) {
                    if (j == 0 && k == 0) {
                        for (int i = 0; i < 10; ++i) {
                            if (is(i)) {
                                dp[sz + 1][1][k] += dp[sz][j][k];
                            }
                        }
                        dp[sz + 1][j][k] += dp[sz][j][k];
                    } else if (j == 1 && k == 0) {
                        dp[sz + 1][j][k] += dp[sz][j][k];
                    } else if (j == 1 && k == 1) {
                        if (p[sz] > 1) {
                            dp[sz + 1][j][0] += dp[sz][j][k];
                        } else if (p[sz] == 1) {
                            dp[sz + 1][j][1] += dp[sz][j][k];
                        }
                    } else {
                        for (int i = 0; i <= p[sz]; ++i) {
                            if (is(i)) {
                                if (i == p[sz])
                                    dp[sz + 1][1][k] += dp[sz][j][k];
                                else
                                    dp[sz + 1][1][0] += dp[sz][j][k];
                            }
                        }
                        if (p[sz - 1] == 1)
                            dp[sz + 1][j][k] += dp[sz][j][k];
                        else
                            dp[sz + 1][j][0] += dp[sz][j][k];
                    }
                }
            }
        }
//        for (auto &i:dp) {
//            cerr << i[0][0] << ' ' << i[0][1] << ' ' << i[1][0] << ' ' << i[1][1] << '\n';
//        }
        int cnt = dp.back()[1][0] + dp.back()[1][1];
        // cerr << cnt << '\n';
        vector<vector<int>> dp1(n, vector<int>(2));
        for (int i = 0; i < 10; ++i) {
            if (is(i)) {
                dp1[1][1] += 1;
            } else if (i == 1) {
                dp1[1][0] += 1;
            }
        }
        for (int sz = 1; sz < n - 1; ++sz) {
            for (int j = 0; j < 2; ++j) {
                // cerr << j << '\n';
                if (j == 0) {
                    for (int i = 0; i < 10; ++i) {
                        if (is(i)) {
                            dp1[sz + 1][1] += dp1[sz][j];
                        }
                    }
                    dp1[sz + 1][j] += dp1[sz][j];
                } else {
                    dp1[sz + 1][j] += dp1[sz][j];
                }
            }
        }
        int cnt1 = 0;
        for (int i = 0; i < n; ++i) {
            cnt1 += dp1[i][1];
        }
        return cnt + cnt1;
    };
    auto check = [&](string &x) -> bool {
        int cnt = 0;
        int zxc = -1;
        for (int i = 0; i < x.size(); ++i) {
            if (x[i] == '0') return 0;
            if (x[i] != '1') {
                ++cnt;
                zxc = int(x[i] - '0');
            }
        }
        if (cnt > 1) return 0;
        if (cnt == 0) return 0;
        return is(zxc);
    };

    cout << max<int>(0, get(r) - get(l) + check(l));
}

signed main() {
#ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}