#include <iostream>
#include <algorithm>
#include "set"
#include "map"
#include "unordered_map"
#include "unordered_set"
#include "cmath"
#include "vector"
#include "limits"
#include "random"
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using orderd_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fi first
#define se second
#define pb push_back
#define eb emplace_back
#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": "; for (auto &i : a) cerr << i << ' '; cerr << '\n'
#define vin(a) for (auto &i : a) cin >> i
#define int ll

mt19937_64 rnd(239);

//struct node {
//    int mx, sm, lmx, rmx;
//};
//
//struct ST {
//    int n;
//    vector<int> a;
//    vector<node> t;
//    vector<
//    ST(vector<int> _a) {
//        a = _a;
//        n = a.size();
//
//    }
//};
int n;
vector<int> a;
vector<int> t;

int op(int x, int y) {
    return max(x, y);
}

void build(int v, int l, int r) {
    if (r == l + 1) {
        t[v] = a[l];
        return;
    }
    int mid = (l + r) >> 1;
    build(2 * v + 1, l, mid);
    build(2 * v + 2, mid, r);
    t[v] = op(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) return t[v];
    if (qr <= l || r <= ql) return 0;
    int mid = (l + r) >> 1;
    int ans = get(2 * v + 1, l, mid, ql, qr);
    int ans1 = get(2 * v + 2, mid, r, ql, qr);
    if (ans > ans1) return ans;
    return ans1;
}


void solve() {
    cin >> n;
    a.resize(n);
    t.resize(4 * n);
    vin(a);
    if (n <= 1000) {
        vector<vector<int>> b(n);
        for (int j = 0; j < n; ++j) {
            b[j].pb(a[j]);
        }
        for (int q = 0; q < n - 1; ++q) {
            int id;
            cin >> id;
            int j = -1, j1 = -1, cnt = 0;
            for (int i = 0; i < n; ++i) {
                if (!b[i].empty()) ++cnt;
                if (cnt == id && j == -1) {
                    j = i;
                } else if (cnt == id + 1 && j1 == -1) {
                    j1 = i;
                } else if (cnt > id) {
                    break;
                }
            }
            // cerr << j << ' ' << j1 << '\n';
            // dbv(b[j]);
            // dbv(b[j1]);
            auto x = b[j];
            for (auto &i:b[j1]) x.pb(i);
            vector<int> c(x.size()), d(x.size());
            c[0] = x[0];
            for (int i = 1; i < x.size(); ++i) {
                c[i] = max(c[i - 1], x[i]);
            }
            d.back() = x.back();
            for (int i = x.size() - 2; i >= 0; --i) {
                d[i] = max(d[i + 1], x[i]);
            }
            int sm = 0;
            for (int k = 0; k < x.size(); ++k) {
                sm += min(c[k], d[k]) - x[k];
            }
            cout << sm << '\n';
            b[j1].clear();
            b[j] = x;
        }
        return;
    }
    build(0, 0, n);
    int ff;
    vector<int> p(n);
    vector<int> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + a[i];
    }
    auto get_ = [&](int l, int r) -> int {
        return pr[r + 1] - pr[l];
    };
    int mx = 0;
    int id_mx = -1;
    for (int q = 0; q < n - 1; ++q) {
        cin >> ff;
        int l = 0, r = q;
        while (l < r) {
            int mid = (l + r + 1) >> 1;
            if (get(0, 0, n, mid, q + 1) >= a[q + 1]) l = mid;
            else r = mid - 1;
        }
        int ans;
        if (get(0, 0, n, l, q + 1) >= a[q + 1]) {
            if (l > 0) {
                ans += p[l - 1];
                ans += (q - l) * a[q + 1] - get_(0, l - 1);
            } else {
                ans += q * a[q + 1] - get_(1, q);
            }
        } else {
            ans += (q - id_mx) * mx - get_(id_mx, q);
            ans += p[id_mx - 1];
        }
        cout << ans << '\n';
        p[q] = ans;
        if (a[q + 1] > mx) {
            mx = a[q + 1];
            id_mx = q + 1;
        }
    }
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
 */

signed main() {
#ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}