#include <iostream>
#include <algorithm>
#include "set"
#include "map"
#include "unordered_map"
#include "unordered_set"
#include "cmath"
#include "vector"
#include "limits"
#include "random"
#include "ext/pb_ds/assoc_container.hpp"

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using orderd_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fi first
#define se second
#define pb push_back
#define eb emplace_back
#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": " << for (auto &i : a) cerr << i << ' '; cerr << '\n'
#define vin(a) for (auto &i : a) cin >> i
#define int ll

mt19937_64 rnd(239);

const int mod = 1e9 + 7;

int add(int a, int b) {
    return (a + b) % mod;
}

void cadd(int &a, int b) {
    a = add(a, b);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vi a(n);
    vin(a);
    if (k == 1) {
        cout << 1 << '\n';
        return;
    }
    if (k == 2) {
        vector<vector<int>> dp(n, vector<int>(4, 0));
        if (a[0] == 0) {
            dp[0][0] = 1;
        } else if (a[0] == 1) {
            dp[0][1] = 1;
            dp[0][2] = 1;
        } else {
            dp[0][3] = 1;
        }
        for (int i = 1; i < n; ++i) {
            if (a[i] == 0) {
                cadd(dp[i][0], dp[i - 1][0]);
                cadd(dp[i][0], dp[i - 1][1]);
            } else if (a[i] == 1) {
                cadd(dp[i][1], dp[i - 1][0]);
                cadd(dp[i][2], dp[i - 1][0]);
                cadd(dp[i][1], dp[i - 1][1]);
                cadd(dp[i][2], dp[i - 1][1]);
                cadd(dp[i][0], dp[i - 1][2]);
                cadd(dp[i][0], dp[i - 1][3]);
            } else if (a[i] == 2) {
                cadd(dp[i][3], dp[i - 1][0]);
                cadd(dp[i][3], dp[i - 1][1]);
                cadd(dp[i][1], dp[i - 1][2]);
                cadd(dp[i][2], dp[i - 1][2]);
                cadd(dp[i][1], dp[i - 1][3]);
                cadd(dp[i][2], dp[i - 1][3]);
            } else {
                cadd(dp[i][3], dp[i - 1][2]);
                cadd(dp[i][3], dp[i - 1][3]);
            }
        }
        int ans = 0;
        for (int i = 0; i < 4; ++i) {
            cadd(ans, dp[n - 1][i]);
            // cerr << dp[n - 1][i] << ' ';
        }
        cout << ans << '\n';
    }
}

/*

 */

signed main() {
#ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//     cin >> t;
    while (t--) {
        solve();
    }
}