#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using oredred_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int ll

#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": "; for (auto &i : a) cerr << i << ' '; cerr << '\n'


void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &i:a) cin >> i;
    int sm = 0;
    for (auto &i:a) sm += i;
    if (k == 2) {
        cout << max(sm - 2 * a[0], sm - 2 * a.back()) << '\n';
        return;
    }
    vector<int> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + a[i];
    }
    auto get_pr = [&](int l, int r) -> int {
        return pr[r + 1] - pr[l];
    };
    vector<int> mn(n + 1);
    mn[0] = 1e9;
    for (int i = 0; i < n; ++i) {
        mn[i + 1] = min(mn[i], a[i]);
    }
    vector<int> mn1(n + 1);
    mn1.back() = 1e9;
    for (int i = n - 1; i >= 0; --i) {
        mn1[i] = min(mn1[i + 1], a[i]);
    }
    vector<int> zxc(n);
    int sz = n - k + 1;
    auto get = [&](int sz) -> void {
        int cur = 0;
        int last = 0;
        for (int i = 0; i < sz; ++i) {
            cur += a[i];
        }
        for (int i = 0; i < n - sz + 1; ++i) {
            zxc[i] = cur;
            int pr = last + sz - 1;
            cur -= a[last];
            ++last;
            int idx = last + sz - 1;
            if (idx >= 0 && idx < n) cur += a[idx];
        }
    };
    get(sz);
    vector<int> prmx(n + 1);
    for (int i = 0; i < n; ++i) {
        prmx[i + 1] = max(prmx[i], zxc[i]);
    }
    vector<int> sfmx(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        sfmx[i] = max(sfmx[i + 1], zxc[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int mx = 0;
        if (i >= sz) {
            mx = max(mx, prmx[i - sz + 1]);
        } else if (i > 0) {
            mx = max(mx, get_pr(0, i - 1));
        }
        if (n - i - 1 >= sz) {
            mx = max(mx, sfmx[i + 1]);
        } else if (i < n - 1) {
            mx = max(mx, get_pr(i + 1, n - 1));
        }
        ans = max(ans, mx - a[i]);
    }
    cout << ans << '\n';
//    if (k < 2) {
//        for (int i = 0; i < n; ++i) {
//            if (i < sz && n - 1 - i < sz) {
//                int mx = 0;
//                if (i > 0) mx = max(mx, get_pr(0, i - 1));
//                if (i < n - 1) mx = max(mx, get_pr(i + 1, n - 1));
//                ans = max(ans, mx - a[i]);
//            }
//        }
//    }
    // cout << ans << '\n';
    // for ()
//    int ans = 0;
//    ans = max(ans, sm - a[0] - a[1] - min(a[0], a[1]));
//    ans = max(ans, sm - a[0] - a[n - 1] - min(a[0], a[n - 1]));
//    ans = max(ans, sm - a[n - 2] - a[n - 1] - min(a[n - 2], a[n - 1]));
//    cout << ans << '\n';
}

/*
4 2
2 1 3 4
 */

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    solve();
}