#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using oredred_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int ll

#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": "; for (auto &i : a) cerr << i << ' '; cerr << '\n'


void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &i:a) cin >> i;
    vector<int> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + a[i];
    }
    auto get_pr = [&](int l, int r) -> int {
        return pr[r + 1] - pr[l];
    };
    vector<int> mn(n + 1);
    mn[0] = 1e9;
    for (int i = 0; i < n; ++i) {
        mn[i + 1] = min(mn[i], a[i]);
    }
    vector<int> mn1(n + 1);
    mn1.back() = 1e9;
    for (int i = n - 1; i >= 0; --i) {
        mn1[i] = min(mn1[i + 1], a[i]);
    }
    int sz = n - k + 1;
    auto get = [&](int sz) -> int {
        int cur = 0;
        int last = 0;
        for (int i = 0; i < sz; ++i) {
            cur += a[i];
        }
        int ans = 0;
        for (int i = 0; i < n - sz + 1; ++i) {
            // cerr << cur << ' ' << last << '\n';
            int pr = last + sz - 1;
            int m = min(mn1[pr + 1], mn[last]);
            // cerr << m << '\n';
            if (m != 1e9) {
                ans = max(ans, abs(cur - m));
            }
            cur -= a[last];
            ++last;
            int idx = last + sz - 1;
            if (idx >= 0 && idx < n) cur += a[idx];
        }
        return ans;
    };
    int ans = get(sz);
    if (k < 2) {
        for (int i = 0; i < n; ++i) {
            if (i < sz && n - 1 - i < sz) {
                int mx = 0;
                if (i > 0) mx = max(mx, get_pr(0, i - 1));
                if (i < n - 1) mx = max(mx, get_pr(i + 1, n - 1));
                ans = max(ans, mx - a[i]);
            }
        }
    }
    cout << ans << '\n';
    // for ()
//    int sm = 0;
//    for (auto &i:a) sm += i;
//    int ans = 0;
//    ans = max(ans, sm - a[0] - a[1] - min(a[0], a[1]));
//    ans = max(ans, sm - a[0] - a[n - 1] - min(a[0], a[n - 1]));
//    ans = max(ans, sm - a[n - 2] - a[n - 1] - min(a[n - 2], a[n - 1]));
//    cout << ans << '\n';
}

/*
4 2
2 1 3 4
 */

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    solve();
}