#include <iostream>
#include <istream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;

struct node {
    ll l, r, mx;
};

ll max(ll a, ll b) {
    if (a > b) {
        return a;
    }
    return b;
}

int main() {
    ll n, x;
    cin >> n;
    vector<ll> h(n);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
    }

    vector<ll> pref(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + h[i];
    }

    vector<ll> ind (n, 0);
    vector<node> ans(n, {0, 0, 0});

    for (ll i = 0; i < n; i++) {
        ind[i] = i;
        ans[i].mx = i;
    }

    vector<node> ans2;
    for (ll q = 0; q < n - 1; q++) {
        cin >> x;
        node nd = {0, 0, 0};
        if (h[ans[x - 1].mx] > h[ans[x].mx]) {
            nd.l = ans[x - 1].l;
            nd.mx = ans[x - 1].mx;
            nd.r = ans[x].r + h[ans[x].mx] * (ans[x].mx - ans[x - 1].mx - 1) - (pref[ans[x].mx] - pref[ans[x - 1].mx + 1]);
        }
        else {
            nd.r = ans[x].r;
            nd.mx = ans[x].mx;
            nd.l = ans[x].l + h[ans[x - 1].mx] * (ans[x].mx - ans[x - 1].mx - 1) - (pref[ans[x].mx] - pref[ans[x - 1].mx + 1]);
        }
        cout << nd.l + nd.r << '\n';
        ans[x - 1] = nd;
        ans2.assign(ans.size() - 1, {0, 0, 0});
        for (ll i = 0; i < ans.size(); i++) {
            if (i < x) {
                ans2[i] = ans[i];
            }
            else if (i > x) {
                ans2[i - 1] = ans[i];
            }
        }
        swap(ans, ans2);

    }
}