#include <iostream>
#include <istream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;

int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> ls(n);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i];
    }

    if (n * k <= 25) {
        ll ans = 0;
        for (ll matr = 0; matr < (1 << (n * k)); matr++) {
            bool f = true;
            for (ll i = 0; i < n; i++) {
                ll cnt = 0;
                for (ll j = 0; j < k; j++) {
                    if (i - j < 0) {
                        continue;
                    }
                    for (ll d = 0; d < k - j; d++) {
                        ll x = k * (i - j) + d;
                        if (((matr >> x) & 1) == 1) {
                            cnt++;
                        }
                        if (cnt > ls[i]) {
                            f = false;
                            break;
                        }
                    }
                }
                if (cnt != ls[i]) {
                    f = false;
                }
                if (!f) {
                    break;
                }
            }
            if (f) {
                ans++;
                ans %= MOD;
            }
        }
        cout << ans;
        return 0;
    }
}