#include <iostream>
#include <istream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = long long;
const ll INF = 1e18;

int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<ll> pref(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    }

    vector<ll> mnr(n + 1, INF);
    for (ll i = n - 1; i >= 0; i--) {
        mnr[i] = min(mnr[i + 1], a[i]);
    }
    vector<ll> mnl(n + 1, INF);
    for (ll i = 0; i < n; i++) {
        mnl[i + 1] = min(mnl[i], a[i]);
    }

    ll ans = -INF;
    ll l = 0;
    ll cur = 0;
    for (ll r = 0; r < n; r++) {
        cur += a[r];
        if (r - l + 1 < n - k + 1) {
            continue;
        }
        // cout << l << " " << r << " " << cur << " " << mnl[l] << " " << mnr[r + 1] << '\n';
        if (abs(cur - min(mnl[l], mnr[r + 1])) > ans) {
            ans = cur - min(mnl[l], mnr[r + 1]);
        }
        cur -= a[l];
        l++;
    }

    for (ll i = 0; i < n; i++) {
        if (n - i - 1 < n - k + 1) {
            ans = max(ans, abs(a[i] - (pref[n] - pref[i + 1])));
        }
        if (i < n - k + 1) {
            ans = max(ans, abs(a[i] - pref[i]));
        }
    }

    cout << ans;
}