#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int z=1e5+10;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,s;
    cin>>n>>s;
    if(n==1){
        int k;
        cin>>k;
        vector<pair<int,int>> c(k);
        for(int i=0;i<k;i++){
            cin>>c[i].first;
            c[i].second=i+1;
        }
        sort(c.begin(),c.end());
        vector<int> ans;
        int l=0,r=1,sum=c[0].first;
        while(r<k){
            if(sum==s){
                for(int i=l;i<r;i++){
                    ans.push_back(c[i].second);
                }
                sort(ans.begin(),ans.end());
                cout<<"Yes\n"<<ans.size()<<'\n';
                for(auto i:ans){
                    cout<<i<<' ';
                }
                return 0;
            }
            if(sum<s || l==r){
                sum=sum+c[r].first;
                r++;
            }else{
                sum=sum-c[l].first;
                l++;
            }
        }
        while(sum>=s && l<r){
            if(sum==s){
                for(int i=l;i<r;i++){
                    ans.push_back(c[i].second);
                }
                sort(ans.begin(),ans.end());
                cout<<"Yes\n"<<ans.size()<<'\n';
                for(auto i:ans){
                    cout<<i<<' ';
                }
                return 0;
            }
            sum=sum-c[l].first;
            l++;
        }
        cout<<"No";
        return 0;
    }
    vector<int> k(n+1),p(z),pref(n+1);
    pref[0]=0;
    for(int i=1;i<=n;i++){
        cin>>k[i];
        pref[i]=pref[i-1]+k[i];
        for(int j=pref[i-1]+1;j<=pref[i];j++){
            cin>>p[j];
        }
    }
    if(pref[n]==n){
        ll sum=0;
        for(int i=1;i<=n;i++){
            sum+=p[i];
        }
        if(sum==s){
            cout<<"Yes\n";
            for(int i=0;i<n;i++){
                cout<<1<<'\n'<<1<<'\n';
            }
        }else{
            cout<<"No";
        }
        return 0;
    }
    if(pref[n]<=20){
        for(int mask=1;mask<(1<<20);mask++){
            vector<bool> used(20,0);
            ll sum=0;
            for(int i=0;i<20;i++){
                if(mask & (1<<i)){
                    int t=lower_bound(pref.begin(),pref.end(),i+1)-pref.begin();
                    used[t-1]=1;
                    sum=sum+p[i+1];
                }
            }
            bool f=1;
            for(int i=0;i<n;i++){
                f=f && used[i];
            }
            if(f && sum==s){
                vector<vector<int>> ans(n);
                for(int i=19;i>=0;i--){
                    if(mask & (1<<i)){
                        int t=lower_bound(pref.begin(),pref.end(),i+1)-pref.begin();
                        ans[t-1].push_back(i+1-pref[t-1]);
                    }
                }
                cout<<"Yes\n";
                for(auto i:ans){
                    cout<<i.size()<<'\n';
                    for(auto j:i){
                        cout<<j<<' ';
                    }
                    cout<<'\n';
                }
                return 0;
            }
        }
        cout<<"No";
        return 0;
    }
}