n, m, k = [int(_) for _ in input().split(" ")]
maxLen = 2 * n + 2 * m - 4
x, y = [], []

for i in range(k):
    x1, y1 = [int(_) for _ in input().split(" ")]
    x.append(x1-1)
    y.append(y1-1)


def getAllPathes(mapp, sizex, sizey, xfrom=0, yfrom=0):
    path = [[(xfrom, yfrom)]]
    newmap = [[mapp[x][y] for y in range(sizey)] for x in range(sizex)]
    newmap[xfrom][yfrom] = True
    newmap[0][0] = False
    if xfrom - 1 >= 0:
        if not newmap[xfrom - 1][yfrom]:
            newpathes = getAllPathes(newmap, sizex, sizey, xfrom - 1, yfrom)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if len(newpath) <= maxLen]
    if xfrom + 1 < sizex:
        if not newmap[xfrom + 1][yfrom]:
            newpathes = getAllPathes(newmap, sizex, sizey, xfrom + 1, yfrom)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if len(newpath) <= maxLen]
    if yfrom - 1 >= 0:
        if not newmap[xfrom][yfrom - 1]:
            newpathes = getAllPathes(newmap, sizex, sizey, xfrom, yfrom - 1)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if len(newpath) <= maxLen]
    if yfrom + 1 < sizey:
        if not newmap[xfrom][yfrom + 1]:
            newpathes = getAllPathes(newmap, sizex, sizey, xfrom, yfrom + 1)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if len(newpath) <= maxLen]
    # if (0, 0) in [(xfrom - 1, yfrom), (xfrom + 1, yfrom), (xfrom, yfrom - 1), (xfrom, yfrom + 1)]:
    #     path.append([(xfrom, yfrom), (0, 0)])
    return path


def getways(sizex, sizey, count, xd, yd):
    mapp = [[False for _ in range(sizey)] for _ in range(sizex)]
    q = getAllPathes(mapp, sizex, sizey)
    # print(f"Found at all: {len(q)} pathes.")
    newq = []
    for path in q:
        # print(f"  length of {len(path): <2}: {path}")
        if len(path) == maxLen + 1:  # because count dots is by 1 greater than count of edges.
            newq.append(path)
    del q
    # print(f"After length correction: {len(newq): <2} pathes (all with length of {maxLen}).")
    newnewq = []
    for path in newq:
        # print(f"  path: {path}")
        presist = int(path[-1] == (0, 0))
        if presist:
            for point in list(zip(xd, yd)) + [(sizex - 1, sizey - 1)]:
                if point not in path:
                    presist = False
                    break
        if presist:
            newnewq.append(path)
    # print(f"After point correction: {len(newnewq)} pathes (all go through {list(zip(xd, yd)) + [(sizex - 1, sizey - 1)]}).")
    # for path in newnewq:
    #     print(f"  path: {path}")
    return len(newnewq)


def sollStupid():
    return getways(n, m, k, x, y)


# print(list(zip(x, y)))

print(sollStupid())

'''
3 4 2
2 2
2 3


3 4 3
3 1
2 3
1 4
'''
