n, m, k = [int(_) for _ in input().split(" ")]
maxLen = 2 * n + 2 * m - 4
# 153745 on 5x5 field
# 248383 on 5x5 field fixed
# 58971  on 5x5 field fixed optimised ~ 6.0 - 6.4s
# 58971  on 5x5 field fixed more optimised ~ 5.0 - 5.6s
# 58971  on 5x5 field fixed a bit more optimised ~ 5.0s
# 14859  on 5x5 field fixed even more optimised ~ 2.5s
x, y = [], []

for i in range(k):
    x1, y1 = [int(_) for _ in input().split(" ")]
    x.append(x1-1)
    y.append(y1-1)


def getAllPathes(mapp, sizex, sizey, xfrom=0, yfrom=0):
    path = [[(xfrom, yfrom)]]
    # newmap = [[mapp[x][y] for y in range(sizey)] for x in range(sizex)]
    # newmap = mapp
    mapp[xfrom][yfrom] = True
    # newmap[0][0] = False
    if xfrom - 1 >= 0:
        if not mapp[xfrom - 1][yfrom]:
            newpathes = getAllPathes(mapp, sizex, sizey, xfrom - 1, yfrom)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if maxLen - len(newpath) >= newpath[-1][0] + newpath[-1][1] >= 0]
    if xfrom + 1 < sizex:
        if not mapp[xfrom + 1][yfrom]:
            newpathes = getAllPathes(mapp, sizex, sizey, xfrom + 1, yfrom)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if maxLen - len(newpath) >= newpath[-1][0] + newpath[-1][1] >= 0]
    if yfrom - 1 >= 0:
        if not mapp[xfrom][yfrom - 1]:
            newpathes = getAllPathes(mapp, sizex, sizey, xfrom, yfrom - 1)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if maxLen - len(newpath) >= newpath[-1][0] + newpath[-1][1] >= 0]
    if yfrom + 1 < sizey:
        if not mapp[xfrom][yfrom + 1]:
            newpathes = getAllPathes(mapp, sizex, sizey, xfrom, yfrom + 1)
            [path.append([(xfrom, yfrom)] + newpath) for newpath in newpathes if maxLen - len(newpath) >= newpath[-1][0] + newpath[-1][1] >= 0]
    # if (0, 0) in [(xfrom - 1, yfrom), (xfrom + 1, yfrom), (xfrom, yfrom - 1), (xfrom, yfrom + 1)]:
    #     path.append([(xfrom, yfrom), (0, 0)])
    mapp[xfrom][yfrom] = False
    return path


def getways(sizex, sizey, count, xd, yd):
    mapp = [[False for _ in range(sizey)] for _ in range(sizex)]
    q = getAllPathes(mapp, sizex, sizey)
    # print(f"Found at all: {len(q)} pathes.")
    # # exit()
    # newq = []
    # for path in q:
    #     print(f"  length of {len(path): <2}: {path}")
    #     # if len(path) == maxLen + 1:  # because count dots is by 1 greater than count of edges.
    #     if len(path) == maxLen:  # because program not including last point (0;0).
    #         newq.append(path)
    # # del q
    # print(f"After length correction: {len(newq): <2} pathes (all with length of {maxLen}).")
    # newnewq = []
    # for path in newq:
    #     print(f"  path: {path}")
    #     presist = int(path[-1] in [(1, 0), (0, 1)])
    #     if presist:
    #         for point in list(zip(xd, yd)) + [(sizex - 1, sizey - 1)]:
    #             if point not in path:
    #                 presist = False
    #                 break
    #     if presist:
    #         newnewq.append(path)
    # print(f"After point correction: {len(newnewq)} pathes (all go through {list(zip(xd, yd)) + [(sizex - 1, sizey - 1)]}).")
    # for path in newnewq:
    #     print(f"  path: {path}")
    newnewq = []
    for path in q:
        if len(path) != maxLen:  # because program not including last point (0;0), otherwise it would be 'maxLen + 1'.
            continue
        presist = int(path[-1] in [(1, 0), (0, 1)])
        if presist:
            for point in list(zip(xd, yd)) + [(sizex - 1, sizey - 1)]:
                if point not in path:
                    presist = False
                    break
        if presist:
            newnewq.append(path)
    return len(newnewq)


def sollStupid():
    return getways(n, m, k, x, y)


# print(list(zip(x, y)))

# from time import perf_counter as time

# tim = time()
print(sollStupid())
# print(time()-tim)

'''
3 4 2
2 2
2 3  # 6

3 4 3
3 1
2 3
1 4  # 0


5 5 5
1 2
1 3
1 4
5 2
5 3  # 32
'''
