#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
using namespace std;
#define ll long long
#define ld long double

//struct tree {
//    int n;
//    vector<node> t;
//    tree(int N, vector<ll> &a) : n(N) {
//        t.resize(2 * n);
//        build(0, 0, n, a);
//
//    }
//};

int k, n;
ll inf = 1000000000;
vector<ll> a;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> k;
    vector<ll> prefmin(n + 1, inf), sufmin(n + 1, inf), prefsum(n + 1);
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        prefsum[i + 1] = prefsum[i] + a[i];
        prefmin[i + 1] = min(a[i], prefmin[i]);
    }
    for (int i = n-1; i >= 0; --i) {
        sufmin[i] = min(sufmin[i + 1], a[i]);
    }

    int len = n - k + 1;
    ll ans = 0;
    for (int i = 0; i <= n - len; ++i) {
        ans = max(ans, prefsum[i + len] - prefsum[i] - min(prefmin[i], sufmin[i + len]));
    }
    for (int i = 0; i <= n - len + 1; ++i) {
        ans = max(ans, prefsum[i + len - 1] - prefsum[i] - min(prefmin[i], sufmin[i + len - 1]));
    }
    cout << ans;
    return 0;
}
