#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
using namespace std;
#define ll long long

int n, s;
vector<vector<int>> dp, c;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> s;
    dp.resize(s + 1, vector<int> (n + 1));
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int C; cin >> C;
            c[i].push_back(C);
        }
    }
    dp[0][0] = 1;
    for (int j = 1; j <= n; ++j) {
        int sz = c[j-1].size();
        for (int k = 0; k < sz; ++k) {
            for (int i = s; i > 0; --i) {
                if (i >= c[j-1][k]) {
                    dp[i][j] = max(max(dp[i - c[j-1][k]][j-1], dp[i - c[j-1][k]][j]), dp[i][j]);
                    //cout << i << ' ' << j << ' ' << dp[i][j] << '\n';
                }
            }
        }
    }

    if (dp[s][n]) {
        cout << "Yes\n";
        vector<vector<int>> p(n);
        int i = s, j = n;
        while (i != 0 || j != 0) {
            //cout << i << ' ' << j << '\n';
            int sz = c[j-1].size();
            for (int k = sz-1; k >= 0; --k) {
                if (i >= c[j-1][k]) {
                    if (dp[i][j] == dp[i - c[j-1][k]][j-1]) {
                        i -= c[j-1][k];
                        p[j-1].push_back(k + 1);
                        j--;
                        c[j-1].pop_back();
                        break;
                    } else if (dp[i][j] == dp[i - c[j-1][k]][j]) {
                        i -= c[j - 1][k];
                        p[j-1].push_back(k + 1);
                        c[j-1].pop_back();
                        break;
                    }
                }
                c[j-1].pop_back();
            }
        }

        for (int i = 0; i < n; ++i) {
            cout << p[i].size() << '\n';
            for (int el : p[i]) {
                cout << el << ' ';
            }cout << '\n';
        }
    } else {
        cout << "No";
    }
    return 0;
}
