#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
using namespace std;
#define ll long long

int n,m,k;
vector<pair<int, int>> p;
int mod = 1000000007;
vector<vector<int>> d;
vector<int> mars;

void gen(int cur, int k0, int k1) {
    if (k1 == 0 && k0 == 0) {
        mars.push_back(cur);
        return;
    }
    if (k1) gen(cur * 2 + 1, k0, k1 - 1);
    if (k0) gen(cur * 2, k0 - 1, k1);
}

void solve1() {
    d.resize(n, vector<int>(m));
    gen(0, m-1, n-1);
    int cnt = 0;
    for (int i : mars) {
        d.assign(n, vector<int> (m, 0));
        int x = 0, y = 0;
        for (int j = 0; j < n + m - 2; ++j) {
            d[x][y] = 1;
            if ((i >> j)&1) {
                x++;
            } else {
                y++;
            }
            if (x >= n || y >= m) {
                x = -1;
                break;
            }
        }
        if (x == -1) continue;
        //cout << i << '\n';
        for (int q : mars) {
            x = 0, y = 0;
            for (int j = 0; j < n + m - 2; ++j) {
                if ((q >> j)&1) {
                    x++;
                } else {
                    y++;
                }
                if (x >= n || y >= m || d[x][y] == 1) {
                    x = -1;
                    break;
                }
                d[x][y] = 2;
            }
            if (x == -1) {
                x = 0, y = 0;
                for (int j = 0; j < n + m - 2; ++j) {
                    if ((q >> j)&1) {
                        x++;
                    } else {
                        y++;
                    }if (x >= n || y >= m || d[x][y] == 1) {
                        x = -1;
                        break;
                    }
                    d[x][y] = 0;
                }
                continue;
            }
            //cout << i << ' ' << q << '\n';
            cnt++;
            for (int j = 0; j < k; ++j) {
                if (!d[p[j].first-1][p[j].second-1]) {
                    cnt--;
                    break;
                }
            }
            x = 0, y = 0;
            for (int j = 0; j < n + m - 2; ++j) {
                if ((q >> j)&1) {
                    x++;
                } else {
                    y++;
                }d[x][y] = 0;
            }
        }
    }
    cout << cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> k;
    p.resize(k);
    for (int i = 0; i < k; ++i) cin >> p[i].first >> p[i].second;
    solve1();
    return 0;
}
