#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
using namespace std;
#define ll long long

int n,m,k;
vector<pair<int, int>> p;
int mod = 1000000007;
vector<vector<int>> d;
vector<int> mars;

void gen(int cur, int k0, int k1) {
    if (k1 == 0 && k0 == 0) {
        mars.push_back(cur);
        return;
    }
    if (k1) gen(cur * 2 + 1, k0, k1 - 1);
    if (k0) gen(cur * 2, k0 - 1, k1);
}

void solve2() {
    int pos1 = 1, pos2 = m-2;
    for (int i = 0; i < k; ++i) {
        if (p[i].first == 1) {
            pos1 = max(pos1, p[i].second - 1);
        } else if (p[i].first == 3) {
            pos2 = min(pos2, p[i].second - 1);
        }
    }
    if (pos1 > pos2) {
        int pos3 = 0, pos4 = m - 1;
        for (int i = 0; i < k; ++i) {
            if (p[i].first == 2) {
                int ps = p[i].second -1;
                if (ps <= pos2) pos3 = ps;
                else if (ps >= pos1) pos4 = ps;
                else {
                    cout << 0;
                    return;
                }
            }
        }

        cout << 2 * (pos4 - pos1 + 1) * (pos2 - pos3 + 1);
    } else {
        int pos3 = 0, pos4 = m - 1;
        for (int i = 0; i < k; ++i) {
            if (p[i].first == 2) {
                int ps = p[i].second - 1;
                if (ps < pos1) pos3 = ps;
                else if (ps > pos2) pos4 = ps;
            }
        }
        int ans = 0;
        for (int i = pos3; i <= pos2; ++i) {
            int id = lower_bound(p.begin(), p.end(), make_pair(2, max(pos1, i + 1) + 1)) - p.begin();
            if (id == k || p[id].first == 3) id = m;
            else id = p[id].second;
            ans += 2 * (id - max(pos1, i + 1));
        }
        cout << ans;
    }
}

void solve1() {
    d.resize(n, vector<int>(m));
    gen(0, m-1, n-1);
    int cnt = 0;
    for (int i : mars) {
        d.assign(n, vector<int> (m, 0));
        int x = 0, y = 0;
        for (int j = 0; j < n + m - 2; ++j) {
            d[x][y] = 1;
            if ((i >> j)&1) {
                x++;
            } else {
                y++;
            }
        }
        //cout << i << '\n';
        for (int q : mars) {
            x = 0, y = 0;
            for (int j = 0; j < n + m - 2; ++j) {
                if ((q >> j)&1) {
                    x++;
                } else {
                    y++;
                }
                if (d[x][y] == 1) {
                    x = -1;
                    break;
                }
                d[x][y] = 2;
            }
            if (x == -1) {
                x = 0, y = 0;
                for (int j = 0; j < n + m - 2; ++j) {
                    if ((q >> j)&1) {
                        x++;
                    } else {
                        y++;
                    }if (d[x][y] == 1) {
                        x = -1;
                        break;
                    }
                    d[x][y] = 0;
                }
                continue;
            }
            //cout << i << ' ' << q << '\n';
            cnt++;
            for (int j = 0; j < k; ++j) {
                if (!d[p[j].first-1][p[j].second-1]) {
                    cnt--;
                    break;
                }
            }
            x = 0, y = 0;
            for (int j = 0; j < n + m - 2; ++j) {
                if ((q >> j)&1) {
                    x++;
                } else {
                    y++;
                }d[x][y] = 0;
            }
        }
    }
    cout << cnt;
}

int main() {
    cin >> n >> m >> k;
    p.resize(k);
    for (int i = 0; i < k; ++i) cin >> p[i].first >> p[i].second;
    sort(p.begin(), p.end());
    if (n == 3) solve2();
    else solve1();
    return 0;
}
