#include <iostream>
#include <vector>
#include <set>

using namespace std;

void solve()
{
    long long n, k, ans = 0;

    cin >> n >> k;

    const long long sm = n - k + 1;

    vector<long long> a(n);
    vector<long long> d(n + 1, 0);
    set<long long> m;

    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        m.insert(a[i]);
        d[i + 1] = a[i] + d[i];
    }

    for (int i = 0; i < n; ++i)
    {
        m.erase(a[i]);

        if (i - sm < 0)
        {
            const auto& t = *m.begin();
            ans = max(ans, d[i + 1] - d[0] - t);
            //cout << d[i + 1] - d[0] - t << endl;
        }
        else
        {
            m.insert(a[i - sm]);
            const auto& t = *m.begin();
            ans = max(ans, d[i + 1] - d[i - sm + 1] - t);
            //cout << d[i + 1] - d[i - sm + 1] - t << endl;
        }
    }

    for (int i = n - sm; i < n - 1; ++i)
    {
        m.insert(a[i]);

        const auto& t = *m.begin();
        ans = max(ans, d[n] - d[i + 1] - t);
        //cout << d[n] - d[i + 1] - t << endl;
    }

    cout << ans;
}

int main()
{
    int t = 1;

    //cin >> t;

    while (t)
    {
        solve();
        --t;
    }
}