#include <iostream>
#include <vector>
#include <set>

using namespace std;

long long max1(long long a, long long b)
{
    if (a > b) return a;
    return b;
}

void solve()
{
    long long n, k, ans = 0;

    cin >> n >> k;

    long long sm = n - k + 1;

    vector<long long> a(n);
    vector<long long> d(n + 1);
    multiset<long long> m;

    d[0] = 0;

    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        m.insert(a[i]);
        d[i + 1] = a[i] + d[i];
    }

    if (k == 2)
    {
        cout << max(d[n - 1] - d[0] - a[n - 1], d[n] - d[1] - a[0]);
        return;
    }

    for (int i = 0; i < n; ++i)
    {
        auto it = m.begin();
        const auto &r = *it;
        ++it;
        const auto &rr = *it;
        if (!(a[i] == r && r == rr)) m.erase(a[i]);


        if (i - sm < 0)
        {
            const auto &t = *m.begin();
            ans = max1(ans, d[i + 1] - d[0] - t);
            //cout << t << endl;
        }
        else
        {
            m.insert(a[i - sm]);
            const auto &t = *m.begin();
            ans = max1(ans, d[i + 1] - d[i - sm + 1] - t);
            //cout << d[i + 1] - d[i - sm + 1] - t << endl;
        }
    }

    for (int i = n - sm; i < n - 1; ++i)
    {
        m.insert(a[i]);
        const auto &t = *m.begin();
        ans = max1(ans, d[n] - d[i + 1] - t);
        //cout << d[n] - d[i + 1] - t << endl;
    }

    cout << ans;
}

/*void solve()
{
    int n, m, k;
    long long ans = 0;

    cin >> n >> m >> k;

    vector<vector<int>> a(n, vector<int> (m));

    for (int i = 0; i < k; ++i)
    {
        int x, y;

        cin >> x >> y;

        a[x - 1][y - 1] = 1;
    }
}*/

int main()
{
    int t = 1;

    //cin >> t;

    while (t)
    {
        solve();
        --t;
    }
}