#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
using namespace std;
int n, s; vector<int> k;
vector<vector<pair<int , int>>> a;
vector<map<int, pair<int, int>>> can_do;
void run(int pos) {
    for (int i = 0; i < k[pos]; i++) {
        vector<int> upd;
        if (can_do[pos].find(a[pos][i].first) == can_do[pos].end()) {
            upd.push_back(a[pos][i].first);
        }
        for (auto j = can_do[pos].begin(); j != can_do[pos].end() && j->first + a[pos][i].first <= s; j++) {
            if (can_do[pos].find(j->first + a[pos][i].first) == can_do[pos].end()) {
                upd.push_back(j->first + a[pos][i].first);
            }
        }
        for (size_t j = 0; j < upd.size(); j++) {
            can_do[pos][upd[j]] = a[pos][i];
        }
    }
}
vector<int> back_trip(int pos, int v) {
    vector<int> ans;
    int now = v;
    while (now) {
        ans.push_back(can_do[pos][now].second);
        now -= can_do[pos][now].first;
    }
    return ans;
}
void OUT(vector<int> ans) {
    cout << ans.size() << endl;
    for (size_t i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}
void solve_1(void) {
    if (can_do[0].find(s) == can_do[0].end()) {cout << "No" << endl; return;}
    cout << "Yes" << endl;
    OUT(back_trip(0, s));
}
void solve_2(void) {
    for (auto j = can_do[0].begin(); j != can_do[0].end(); j++) {
        if (j->first != 0 && j->first != s - 1 && can_do[1].find(s - j->first) != can_do[1].end()) {
            cout << "Yes" << endl;
            OUT(back_trip(0, j->first));
            OUT(back_trip(1, s - j->first));
            return;
        }
    }
    cout << "No" << endl;
}
void big_solve_AAA(void) {
    cin >> n >> s;
    k.clear(); k.resize(n);
    a.clear(); a.resize(n, vector<pair<int , int>> ());
    can_do.clear(); can_do.resize(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].clear();
        a[i].resize(k[i]);
        for (int j = 0; j < k[i]; j++) {
            cin >> a[i][j].first;
            a[i][j].second = j;
        }
        sort(a[i].begin(), a[i].end());
        sum += a[i][0].first;
        can_do[i].clear();
        if (k[i] != 1) {
            run(i);
        } else {
            can_do[i][a[i][0].first] = a[i][0];
        }
    }
    if (n == 1) {solve_1(); return;}
    if (n == 2) {solve_2(); return;}
    if (sum == s) {
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            OUT(vector<int>(1, 0));
        }
        return;
    }
    cout << "No" << endl;
}
int main() {
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        big_solve_AAA();
    }
    return 0;
}
