﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <set>

using namespace std;

/*struct vec
{
    int x;
    int y;
    
    vec(int x, int y)
    {
        this->x = x;
        this->y = y;
    }

    vec operator*(int k)
    {
        return { this->x * k, this->y * k };
    }

    friend istream& operator>>(istream& in, vec& a)
    {
        return in >> a.x >> a.y;
    }

    friend ostream& operator<<(ostream& out, vec& a)
    {
        return out << a.x << a.y;
    }
};
*/

set<pair<long long, long long>> ans;
long long d, l, r;

void check(int sum, int razn, int nod)
{
    if ((sum + razn) % 2) return;
    long long x = (sum + razn) / 2;
    long long y = sum - x;
    x *= nod;
    y *= nod;
    x *= x;
    y *= y;
    if (x > r || x < l || y > r || y < l) return;
    ans.insert({ max(x, y), min(x, y) });
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    //freopen("a.txt", "r", stdin);
    //freopen("a.txt", "w", stdout);

    cin >> d >> l >> r;


    for (long long i = 1; i * i <= d; i++)
    {
        if (d % (i * i) == 0)
        {
            long long h = d / (i * i);
            for (int j = 1; j * j <= h; j++)
            {
                if (h % j == 0)
                {
                    check(h / j, j, i);
                }
            }
        }
    }
    cout << ans.size();
}
