﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <set>

using namespace std;

/*struct vec
{
    int x;
    int y;
    
    vec(int x, int y)
    {
        this->x = x;
        this->y = y;
    }

    vec operator*(int k)
    {
        return { this->x * k, this->y * k };
    }

    friend istream& operator>>(istream& in, vec& a)
    {
        return in >> a.x >> a.y;
    }

    friend ostream& operator<<(ostream& out, vec& a)
    {
        return out << a.x << a.y;
    }
};
*/



int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    //freopen("a.txt", "r", stdin);
    //freopen("a.txt", "w", stdout);
    int n, k;
    cin >> n >> k;
    vector<long long> a(n);
    vector<long long> pref(n + 1, 0);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    long long ans = 0;
    if (k == 2)
    {
        for (int i = 1; i < n; i++)
        {
            long long s1 = pref[i];
            long long s2 = pref[n] - pref[i];
            if (ans < max(s1, s2) - min(s1, s2)) ans = max(s1, s2) - min(s1, s2);
        }
        cout << ans;
        return 0;
    }
    if (k == 3)
    {
        long long f = a[0];
        for (int i = 2; i < n; i++)
        {
            long long s1 = pref[i] - a[0];
            long long s2 = pref[n] - pref[i];
            if (ans < max(max(f, s1), s2) - min(min(f, s1), s2)) ans = max(max(f, s1), s2) - min(min(f, s1), s2);
        }

        for (int i = 1; i < n - 1; i++)
        {
            long long c = a[i];
            long long d = pref[i];
            long long e = pref[n] - pref[i + 1];
            if (ans < max(max(c, d), e) - min(min(c, d), e)) ans = max(max(c, d), e) - min(min(c, d), e);
        }

        f = a[n - 1];
        for (int i = 1; i < n - 1; i++)
        {
            long long s1 = pref[i];
            long long s2 = pref[n] - pref[i] - f;
            if (ans < max(max(f, s1), s2) - min(min(f, s1), s2)) ans = max(max(f, s1), s2) - min(min(f, s1), s2);
        }

        cout << ans;
        return 0;
    }
}
