

#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")


using namespace std;

using ll = long long;
#define all(x) x.begin(), x.end()




int main() {
//    iostream::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    ll n, s;
    cin >> n >> s;
    vector<vector<int>> arr(n);
    int checked = 0;
    int min_checked = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        arr[i].resize(k);
        int minvs = 1e7;
        for (int j = 0; j < k; ++j) {
            cin >> arr[i][j];
            checked+= arr[i][j];
            minvs = min(minvs, arr[i][j]);
        }

//        sort(all(arr[i]));
        min_checked += minvs;
    }

    if(checked < s || s < min_checked) {
        cout << "No" << endl;
        return 0;
    }


//    cout << "im alive" << endl;





    // process
    vector<bool> prev_ans(s+100);
    prev_ans[0] = 1;
    vector<bool> cur_ans(s+100);
    vector<vector<int>> jump(n,vector<int>(s+100));

//    jump[0] = vector<int>(s+1,-1);

    for (int i = 0; i < n; ++i) {
        vector<bool> prev_inc(s+100);
        vector<bool> now_inc(s+100);
        prev_inc[0] = 1;


        for (int j = 0; j < arr[i].size(); ++j) {
            now_inc[arr[i][j]] = 1;
            for (int k = 0; k <= s; ++k) {
                if(prev_inc[k] && k + arr[i][j] <= s) {
                    now_inc[k + arr[i][j]] = true;

                }
                if(prev_inc[k] &&  k!=0){
                    now_inc[k] = true;
                }
            }

            prev_inc = now_inc;
        }



        now_inc = prev_inc;

        vector<int> avalible_add;
        for (int l = 0; l <= s; ++l) {
            if(now_inc[l]) {
                avalible_add.push_back(l);
            }
        }


        for (int j = 0; j <= s; ++j) {
            for (int k = 0; k < avalible_add.size(); ++k) {
                if(prev_ans[j]&&j + avalible_add[k] <= s) {
                    jump[i][j + avalible_add[k]] = j;
                    cur_ans[j + avalible_add[k]] = true;
                }
            }
        }

//        cout << "Indx: " << i << endl;
//        cout << "Main: " << endl;
//        for (int m =0; m <= s; ++m) {
//            cout << cur_ans[m] << ' ';
//        }
//        cout << endl;
//
//        cout << "Additonal: " << endl;
//        for (int m = 0; m < avalible_add.size(); ++m) {
//            cout << avalible_add[m] << ' ';
//        }
//        cout << endl;
//
//        cout << "Jump: " << endl;
//        for (int m = 0; m <=s; ++m) {
//            cout << jump[i][m] << ' ';
//        }
//        cout << endl;
//
//        cout << "--------------" << endl;

        prev_ans = cur_ans;
        prev_ans[0] = false;


    }


//    return 0;


    if(!cur_ans[s]) {
        cout << "No" << endl;
        return 0;
    } else {
        // print ans
        cout << "Yes" << endl;


        vector<ll> unfold(n);


        int shifted = n-1;
        ll cur = s;
        while(cur != 0) {
            unfold[shifted] = cur - jump[shifted][cur];
            cur = jump[shifted][cur];
            shifted--;
        }



        for (int i = 0; i < n; ++i) {
            vector<bool> prev_inc(s+100);
            vector<bool> now_inc(s+100);
            vector<vector<pair<int,int>>> jumps(arr[i].size()+1, vector<pair<int,int>>(s+100, {-1,-1}));

            prev_inc[0] = 1;


            for (int j = 0; j < arr[i].size(); ++j) {
                now_inc[arr[i][j]] = 1;
//                jumps[j+1] = jumps[j];
                jumps[j+1][arr[i][j]] = {0, j+1};
                for (int k = 0; k <= s; ++k) {
                    if(prev_inc[k] && k != 0) {
                        now_inc[k] = true;
                        jumps[j+1][k] = jumps[j][k];
                    }
                    if(prev_inc[k] && k + arr[i][j] <= s) {
                        now_inc[k + arr[i][j]] = true;
                        jumps[j+1][k + arr[i][j]]  = {k, j};
                    }

                }

                prev_inc = now_inc;
            }

            int shifted = arr[i].size();

//            for(int a= 0; a < jumps.size(); a++){
//                for(int b= 0; b < jumps[a].size(); b++) {
//                    cout << "{"<< jumps[a][b].first << ", " << jumps[a][b].second << "}, ";
//                }
//                cout << endl;
//            }
//            int cur = s;
//            int prev = 1e7;
            vector<int> ans;
            vector<int> sans;

            pair<int,int> cur;
            int x = unfold[i];
            int y = arr[i].size();
            while (x != -1 && y != -1) {
//                cout << x << " " << y << endl;
                cur = jumps[y][x];
//                if(cur.second == shifted)

                sans.push_back(x);
                x = cur.first;

                y = cur.second;
//                shifted = cur.second;
            }


            reverse(all(sans));
            vector<ll> pre_ans;
            for (int l = 1; l < sans.size(); ++l) {
                pre_ans.push_back(sans[l]-sans[l-1]);
            }
//            if(sans.size() < 2) {
//                cout << -1 << endl;
//                return 0;
//            }

//            for (int m = 0; m < pre_ans.size(); ++m) {
//                cout << pre_ans[m] << " ";
//            }
//            cout <<" * "<< endl;


            cout << pre_ans.size() << "\n";
            int cur_indx = 0;
            for(int j = 0; j < arr[i].size(); j++) {
                if(cur_indx < pre_ans.size() &&  arr[i][j] == pre_ans[cur_indx]) {
                    cout << j +1 << ' ';
                    cur_indx++;
                }
//                cout << pre_ans[i] << " ";
            }
            cout << '\n';

        }
    }


    return 0;
}
