#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int n, k;
vector <vector <int>> twos;
vector <int> bs;

int get1(int n, int k) {
	return (n >> k) & 1;
}

int bin(int n) {
	int res = 0;
	for (int i = 0; i < 8; i++) {
		res += get1(n, i);
	}
	return res;
}

long long d(int p, vector <int> prev, int g_now) {
	long long res = 0;

	if (p == n) {
		return 1;
	}

	int i = -1;
	while (prev.size() >= -i && -i <= k) {
		g_now -= get1(prev[prev.size() + i], k + i);
		i -= 1;
	}

	if (bs[p] - g_now < 0 || bs[p] - g_now > k) {
		return 0;
	}

	auto possible = twos[bs[p] - g_now];
	for (int i = 0; i < possible.size(); i++) {
		auto tmprev = prev;
		tmprev.push_back(possible[i]);
		res += d(p + 1, tmprev, bs[p]);
	}

	return res;
}

int main() {
	cin >> n >> k;
	bs.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> bs[i];
	}

	twos.resize(k+1);
	for (int i = 0; i < pow(2, k); i++) {
		twos[bin(i)].push_back(i);
	}

	cout << d(0, vector<int>(), 0);
	return 0;
}