#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

ll min(ll a, ll b) {
  if (a < b) {
    return a;
  }
  return b;
}

int main() {
  int n;
  cin >> n;
  vector<ll> h(n);
  vector<int> t(n);
  vector<int> maxl(n), maxr(n);
  for (int i = 0; i < n; i++) {
    cin >> h[i];
    maxl[i] = h[i];
    maxr[i] = h[i];
    t[i] = i;
  }
  int q = n - 1;
  while (q--) {
    int k;
    cin >> k;
    k--;
    int cur = 0;
    int l = 1;
    while (cur < k) {
      if (l < n && t[l] != t[l - 1]) {
        cur++;
      }
      l++;
    }
    l--;
    int r = l + 1;
    while (r < n && t[r] == t[r - 1]) {
      r++;
    }
    r++;
    while (r < n && t[r] == t[r - 1]) {
      r++;
    }
    for (int i = l + 1; i < r; i++) {
      t[i] = t[l];
      maxl[i] = max(maxl[i], maxl[i - 1]);
    }
    ll ans = 0;
    for (int i = r - 2; i >= l; i--) {
      maxr[i] = max(maxr[i], maxr[i + 1]);
      ans += min(maxl[i], maxr[i]) - h[i];
    }
    cout << ans << '\n';
  }
}