#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#pragma GCC optimize("O3, unroll-loops")
using namespace std;

const int mod = 1e9 + 7;

int min(int a, int b) {
  if (a < b) {
    return a;
  }
  return b;
}


void GOYDA(int n, int k) {
  vector<int> b(n, 0);
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  int sz = n * k;
  int ans = 0;
  for (int mask = 0; mask < (1 << sz); mask++) {
    vector<int> cnt(n, 0);
    bool good = true;
    for (int i = 0; i < k && good; i++) {
      for (int j = 0; j < n && good; j++) {
        int pos = i * n + j;
        if (((mask >> pos) & 1) == 0) continue;
        for (int x = j; x <= min(n - 1, i + j); x++) {
          cnt[x]++;
          if (cnt[x] > b[x]) {
            good = false;
            break;
          }
        }
      }
    }
    for (int i = 0; i < n && good; i++) {
      if (cnt[i] != b[i]) {
        good = false;
        break;
      }
    }
    if (good) {
      ans++;
      if (ans >= mod) {
        ans -= mod;
      }
    }
  }
  cout << ans;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, k;
  cin >> n >> k;
  vector<int> b(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    cin >> b[i];
  }
  int sz = k * (k + 1) / 2;
  vector<vector<int>> dp(n + 1, vector<int>(1 << sz, 0));
  dp[0][0] = 1;
  int ans = 1;
  for (int i = 1; i <= n; i++) {
    ans = 0;
    for (int mask = 0; mask < (1 << (sz)); mask++) {
      if (dp[i - 1][mask] == 0) continue;
      for (int m = 0; m < (1 << k); m++) {
        int curm = m;
        int pos = 0;
        int curr = k;
        for (int want = k - 1; want > 0; want--) {
          pos++;
          for (int j = 0; j < want; j++) {
            if ((mask >> (pos)) & 1) {
              curm = curm | (1 << curr);
            }
            pos++;
            curr++;
          }
        }
        curm = curm & ((1 << sz) - 1);
        int good = __builtin_popcount(curm);
        /*
        for (int j = 0; j < sz; j++) {
          good += ((curm >> (j)) & 1);
        }
        */
        if (good != b[i]) {
          continue;
        }
        dp[i][curm] += dp[i - 1][mask];
        ans += dp[i - 1][mask];
        if (ans >= mod) {
          ans -= mod;
        }
        if (dp[i][curm] >= mod) {
          dp[i][curm] -= mod;
        }
      }
    }
    /*
    int cur = 0;
    for (int mask = 0; mask < (1 << sz); mask++) {
      cur = (cur + dp[i][mask]) % mod;
    }
    cout << i << " : " << cur << '\n';
    */
  } 
  cout << ans;
  /*
  int cur = 0;
  for (int mask = 0; mask < (1 << sz); mask++) {
    cur = (cur + dp[n][mask]);
    if (cur >= mod) {
      cur -= mod;
    }
  }
  cout << cur << '\n';
  */
}
