#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
using namespace std;

const int mod = 1e9 + 7;

int min(int a, int b) {
  if (a < b) {
    return a;
  }
  return b;
}


int main() {
  int n, k;
  cin >> n >> k;
  vector<int> b(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    cin >> b[i];
  }
  vector<map<int, int>> dp(n + 1);
  dp[0][0] = 1;
  for (int i = 1; i <= n; i++) {
    for (int mask = 0; mask < (1 << (k * k)); mask++) {
      for (int m = 0; m < (1 << k); m++) {
        int curm = m | (mask << k);
        curm = curm & ((1 << (k * k)) - 1);
        int c = 0;
        for (int j = 0; j < k; j++) {
          if ((m >> j) & 1) {
            c++;
          }
        }
        int good = c;
        for (int j = 1; j < k; j++) {
          for (int cur = j; cur < k; cur++) {
            if ((curm >> (k * j + cur)) & 1) {
              good++;
            }
          }
        }
        if (good != b[i]) {
          continue;
        }
        dp[i][curm] += dp[i - 1][mask];
        if (dp[i][curm] >= mod) {
          dp[i][curm] -= mod;
        }
        /*
        for (int cnt = 0; cnt + c <= i * k; cnt++) {
          dp[i][curm][cnt + c] += dp[i - 1][mask][cnt];
          dp[i][curm][cnt + c] %= mod;
        }
        */
      }
    }
    
  } 
  int cur = 0;
  for (int mask = 0; mask < (1 << (k * k)); mask++) {
    cur = (cur + dp[n][mask]) % mod;
  }
  cout << cur << '\n';
}
