#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
using namespace std;

const int mod = 1e9 + 7;

int min(int a, int b) {
  if (a < b) {
    return a;
  }
  return b;
}


int main() {
  int n, k;
  cin >> n >> k;
  vector<int> b(n + 1, 0);
  for (int i = 1; i <= n; i++) {
    cin >> b[i];
  }
  int sz = k * (k + 1) / 2;
  vector<vector<int>> dp(n + 1, vector<int>(1 << sz, 0));
  dp[0][0] = 1;
  for (int i = 1; i <= n; i++) {
    for (int mask = 0; mask < (1 << (sz)); mask++) {
      for (int m = 0; m < (1 << k); m++) {
        int curm = m;
        int pos = 0;
        int curr = k;
        for (int want = k - 1; want > 0; want--) {
          pos++;
          for (int j = 0; j < want; j++) {
            if ((mask >> (pos)) & 1) {
              curm = curm | (1 << curr);
            }
            pos++;
            curr++;
          }
        }
        curm = curm & ((1 << sz) - 1);
        int good = 0;
        for (int j = 0; j < sz; j++) {
          good += ((curm >> (j)) & 1);
        }
        if (good != b[i]) {
          continue;
        }
        dp[i][curm] += dp[i - 1][mask];
        if (dp[i][curm] >= mod) {
          dp[i][curm] -= mod;
        }
      }
    }
    /*
    int cur = 0;
    for (int mask = 0; mask < (1 << sz); mask++) {
      cur = (cur + dp[i][mask]) % mod;
    }
    cout << i << " : " << cur << '\n';
    */
  } 
  int cur = 0;
  for (int mask = 0; mask < (1 << sz); mask++) {
    cur = (cur + dp[n][mask]) % mod;
  }
  cout << cur << '\n';
}
