//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <functional>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_map>
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    vector<int> p = {2, 3, 5, 7};

    function<ll(int)> f = [&](int k) -> ll{
        string r; cin >> r;
        vector dp(r.size(), vector (3, vector<ll>(2)));

        dp[0][2][0] = 1;
        if (r[0] == '1') dp[0][1][0] = 1;
        else {
            dp[0][0][0] = 1;
            for (int i = 0; i < 4; ++i) {
                if (p[i] < r[0] - '0') dp[0][0][1]++;
                else if (p[i] == r[0] - '0') dp[0][1][1]++;
            }
        }

        for (int i = 1; i < r.size(); ++i){
            dp[i][2][0] += dp[i - 1][2][0];
            dp[i][0][1] += dp[i - 1][0][1];
            dp[i][0][0] += dp[i - 1][0][0] + dp[i - 1][2][0];
//            if (r[i] - '0' == 0) {
//                dp[i][1][0] = dp[i - 1][2][0];
//            }
            if (r[i] - '0' >= 1) {
                dp[i][1][1] += dp[i - 1][1][1];
                dp[i][1][0] += dp[i - 1][1][0];
            }
            for (int j = 0; j < 4; ++j) {
                dp[i][0][1] += dp[i - 1][0][0] + dp[i - 1][2][0];
                if (p[j] < r[i] - '0') dp[i][0][1] += dp[i - 1][1][0];
                else if (p[j] == r[i] - '0') dp[i][1][1] += dp[i - 1][1][0];
            }
        }

        int n = r.size() - 1;
        ll ans = dp[n][0][1] + dp[n][1][1] - dp[n][2][0];
        if (k) ans -= dp[n][1][1];
        return ans;
    };
    ll l = f(1), r = f(0);
//    cout << r - l << ' ' << l << ' ' << r;
    cout << r - l;


    return 0;
}
