//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
#include <iostream>
#include <cmath>
#include <algorithm>
#include <functional>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <unordered_map>
#include <map>
#include <set>
#include <bitset>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n, s; cin >> n >> s;
    vector<vector<int>> t(n), g(n), p1(n, vector<int> (s + 1, -1));
    bitset<100001> dp1, diff;
    for (int i = 0; i < n; ++i){
        int k; cin >> k;
        for (int j = 0; j < k; ++j){
            int c; cin >> c;
            t[i].emplace_back(c);
        }
        dp1 &= 0; dp1 |= 1;
        for (int j = 0; j < k; ++j){
            diff = dp1;
            dp1 |= dp1 << t[i][j];
            diff ^= dp1;
            for (int t = 1; t <= s; ++t){
                if (diff[t] && p1[i][t] == -1) p1[i][t] = j;
            }
        }
        for (int j = 1; j <= s; ++j){
            if (dp1[j]) g[i].emplace_back(j);
        }
    }

    vector<vector<int>> dp(n + 1, vector<int> (s + 1, 0));
    vector<pair<int, int>> p(s + 1, {-1, -1});
    dp[0][0] = 1;

    for (int i = 1; i <= n; ++i){
        for (int j: g[i - 1]){
            for (int w = s; w >= 0; --w){
                if (w - j < 0) break;
                if (!dp[i][w] && dp[i - 1][w - j]) {
                    dp[i][w] |= dp[i - 1][w - j];
                    if (p[w].first == -1) p[w] = {j, i};
                }
            }
        }
    }

    if (dp[n][s]){
        cout << "Yes" << '\n';
        int w = s;
        vector<int> ans(n, -1);
        while (p[w].first != -1){
            ans[p[w].second - 1] = p[w].first;
            w -= p[w].first;
        }

        for (int i = 0; i < n; ++i){
            if (ans[i] == -1){
                cout << "No";
                return 0;
            }
        }

        for (int i = 0; i < n; ++i){
            vector<int> ans1; int w1 = ans[i];
            while (p1[i][w1] != -1){
                ans1.emplace_back(p1[i][w1] + 1);
                w1 -= t[i][p1[i][w1]];
            }
            cout << ans1.size() << '\n';
            for (int el: ans1) cout << el << ' ';
            cout << '\n';
        }

    } else cout << "No";

    return 0;
}


//2 4
//1
//2
//2
//3 1

//2 4
//1
//2
//2
//2 1

//1 4
//2
//2 2
