//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
#include <iostream>
#include <cmath>
#include <algorithm>
#include <functional>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <unordered_map>
#include <map>
#include <set>
#include <bitset>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

using namespace std;

struct P{
    int i = -1, j, val, n = -1;
};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n, s; cin >> n >> s;
    vector<vector<int>> t(n);
    for (int i = 0; i < n; ++i){
        int k; cin >> k;
        for (int j = 0; j < k; ++j){
            int c; cin >> c;
            t[i].emplace_back(c);
        }
    }

    vector<vector<int>> dp(n + 1, vector<int> (s + 1, 0));
    vector<P> p(s + 1, {-1, -1});
    dp[0][0] = 1;

    for (int i = 1; i <= n; ++i){
        for (int j = 0; j < t[i - 1].size(); ++j) {
            for (int w = 0; w <= s; ++w) {
            if (w - t[i - 1][j] < 0) continue;
//                if (dp[i - 1][w - t[i - 1][j]] && !dp[i][w]) {
                if (p[w].i == -1 && dp[i - 1][w - t[i - 1][j]]) p[w] = {i, j, t[i - 1][j], j};
                dp[i][w] |= dp[i - 1][w - t[i - 1][j]];
//                }
                if (dp[i][w - t[i - 1][j]] && !dp[i][w] && p[w - t[i - 1][j]].n != j) {
                    if (p[w].i == -1) p[w] = {i, j, t[i - 1][j], j};
                    dp[i][w] |= dp[i][w - t[i - 1][j]];
                }
            }
        }
    }

    if (dp[n][s]) {
        cout << "Yes" << '\n';
        int w = s;
        vector<vector<int>> ans(n);
        while (p[w].i != -1){
            ans[p[w].i - 1].emplace_back(p[w].j);
            w -= p[w].val;
        }
        for (auto &el: ans){
            cout << el.size() << '\n';
            for (auto el1: el) cout << el1 + 1 << ' ';
            cout << '\n';
        }
    }
    else cout << "No";

    return 0;
}

//2 4
//1
//2
//2
//3 1

//2 4
//1
//2
//2
//2 1

//1 4
//2
//2 2