#include <algorithm>
#include <cstdint>
#include <iostream>
using namespace std;

const int N = 1e5 + 1000;
int64_t s[N];

int main() {
  int64_t l, r, d;
  cin >> d >> l >> r;

  int k = 0; // amount of squares checked
  int ans = 0;

  for (int64_t i = 1; i * i <= r; i++) {
    if (i * i < l) {
      continue;
    }
    ans += binary_search(s, s + k, i * i - d);
    s[k++] = i * i;
  }

  cout << ans;
}