#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  int n, k;
  cin >> n >> k;

  assert(k == 2);

  vector<int> a(n);

  for (int &x : a) {
    cin >> x;
  }

  vector<int64_t> p(n + 1);

  for (int i = 0; i < n; i++) {
    p[i + 1] = p[i] + a[i];
  }

  int64_t ans = 0;

  for (int i = 1; i + 1 < n; i++) {
    auto s = p[i];
    auto t = p[n] - p[i];
    ans = max(ans, abs(s - t));
  }

  cout << ans;
}