#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  int n, k;
  cin >> n >> k;

  vector<int> a(n);

  for (int &x : a) {
    cin >> x;
  }

  vector<int64_t> p(n + 1);

  for (int i = 0; i < n; i++) {
    p[i + 1] = p[i] + a[i];
  }

  int64_t ans = 0;

  for (int l1 = 0; l1 < n; l1++) {
    for (int r1 = l1 + 1; r1 <= n; r1++) {
      for (int l2 = r1; l2 < n; l2++) {
        for (int r2 = l2 + 1; r2 <= n; r2++) {
          auto s = p[r1] - p[l1];
          auto t = p[r2] - p[l2];
          int len1 = r1 - l1;
          int len2 = r2 - l2;
          auto op = abs(t - s);
          if (n - len1 - len2 >= k - 2 && op > ans) {
            // cout << l1 << " " << r1 << "; " << l2 << " " << r2 << ": " << op
            //      << "\n";
            // cout << s << " " << t << "\n";
            ans = max(ans, op);
          }
        }
      }
    }
  }

  cout << ans;
}