#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  int n, k;
  cin >> n >> k;

  vector<int> a(n), s(n);

  for (int &x : a) {
    cin >> x;
  }

  vector<int64_t> p(n + 1);
  int64_t ans = 0;

  for (int z : {1, 2}) {
    (void)z;
    for (int i = 0; i < n; i++) {
      p[i + 1] = p[i] + a[i];
    }

    for (int i = n - 1; i >= 0; i--) {
      s[i] = a[i];
      if (i != n - 1) {
        s[i] = min(s[i], s[i + 1]);
      }
    }

    int m = n - k + 1;

    int64_t a1 = 0;

    for (int i = 1; i < n; i++) {
      if (i < m) {
        a1 = max(a1, p[i]);
      } else {
        a1 = max(a1, p[i] - p[i - m]);
      }
      auto a2 = s[i];
      ans = max(ans, abs(a2 - a1));
    }

    reverse(a.begin(), a.end());
  }

  cout << ans;
}