// semenInRussia 2024
#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>

using namespace std;

int main() {
  int n, s;
  cin >> n >> s;

  vector<vector<int>> t(n);

  for (int i = 0; i < n; i++) {
    int k;
    cin >> k;
    t[i].resize(k);
    for (int &x : t[i]) {
      cin >> x;
    }
  }

  vector<pair<int, int>> prv(s + 1);
  vector<int> g(s + 1);
  g[0] = 1;
  vector<int> f(s + 1);

  for (int i = 0; i < n; i++) {
    int k = (int)t[i].size();

    // add every element of t[i]
    for (int j = 0; j < k; j++) {
      int c = t[i][j];
      for (int x = s; x >= c; x--) {
        if (f[x]) {
          continue;
        }
        f[x] = g[x - c] || f[x - c];
        if (f[x]) {
          prv[x] = {i, j};
        }
      }
    }

    swap(f, g);
    f.assign(s + 1, 0);
  }

  if (!g[s]) {
    cout << "No";
    return 0;
  }

  int x = s;

  vector<vector<int>> ans(n);

  while (x != 0) {
    auto [i, j] = prv[x];
    ans[i].push_back(j);
    x -= t[i][j];
    assert(x >= 0);
  }

  cout << "Yes\n";
  for (auto &row : ans) {
    cout << row.size() << "\n";
    for (int j : row) {
      cout << (j + 1) << "\n";
    }
  }
}