#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bitset>

const int MAX_N = 1e5 + 1;

typedef long long ll;

#define sz(s) int(s.size())
#define pb push_back
#define eb emplace_back
#define mp make_pair

using namespace std;
using namespace __gnu_pbds;

template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

ll l, r, d;

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> d >> l >> r;
    ll cnt = 0;
    for (int i = 1; i * i <= d; i++) {
        if (d % i == 0) {
            ll a = i;
            ll b = d / i;
            if (a % 2 == b % 2) {
                ll x = (a + b) / 2;
                ll y = (b - a) / 2;
                if (x * x >= l && x * x <= r && y * y >= l && y * y <= r) {
                    cnt++;
                }
            }
        }
    }
    cout << cnt << endl;
    
    return 0;
}

