#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
#include <bitset>
#include <random>


const int MAX_N = 3e5 + 1;
const long long INF = 1e18 + 1;

typedef long long ll;

#define sz(s) int(s.size())
#define pb push_back
#define eb emplace_back
#define mp make_pair

using namespace std;
// using namespace __gnu_pbds;

// template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int n, k;
ll a[MAX_N];
ll pref[MAX_N];
ll cyff[MAX_N];


mt19937 r(214145);

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> k;

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
    }
    for (int i = n; i >= 1; i--) {
        cyff[i] = cyff[i + 1] + a[i];
    }
    if (k == 2) {
        ll ans = 0;
        for (int i = 1; i <= n - 1; i++) {
            ans = max(ans, abs(pref[i] - cyff[i + 1]));
            // cout << ans << " " << i << endl;
            // cout << pref[i] << " " << cyff[i + 1] << endl;
        }
        cout << ans << endl;
        return 0;
    }
    ll ans = 0;
    // cout << ans << endl;
    for (int chosen = 1; chosen <= n; chosen++) {
        ll law = n - k + 2;
        
        // cout << chosen << " " << law << endl;
        if (k <= n - chosen + 2 && chosen != 1) {
            ans = max(ans, abs( pref[chosen - 1] - a[chosen]));
            // cout << ans << "EXTRA" << "  " << chosen << " " << law << endl;
        } else {
            law = n - k + 1;
            // cout << law << "L<LAW" << endl;
            for (int i = 1; i <= chosen - law; i++) {
                ans = max(ans, abs(pref[i + law - 1] - pref[i - 1] - a[chosen]));
                // cout << ans << " " << chosen << " ss " << i << endl;
            }
        }
        
        if (k <= chosen + 1 && chosen != n) {
            ans = max(ans, abs(cyff[chosen + 1] - a[chosen]));
            // cout << ans << "DOUBLEE" << "  " << chosen << " " << law << endl;
        } else {
            law = n - k + 1;
            for (int i = chosen + 1; i <= chosen - law; i++) {
                ans = max(ans, abs(cyff[i] - cyff[i + law] - a[chosen]));
                // cout << ans << " " << chosen << " " << i << endl;
            }
        }
    }

    cout <<  ans << endl;
    
    
    
    return 0;
}
