#include<bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

using ll = long long;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

// #include<ext/pb_ds/assoc_container.hpp>
// #include<ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

// int getInt(int l, int r) {
//     return uniform_int_distribution<int>(l, r)(gen);
// }


// ll bp(ll a, ll n) {
//     if (!n) return 1;
//     if (n % 2) return a * bp(a, n - 1);
//     ll b = bp(a, n / 2);
//     return b * b;
// }

struct node {
    int l_ind, r_ind, mx;
    node() {}
    node(int L_IND, int R_IND, int MX) {
        l_ind = L_IND; r_ind = R_IND; mx = MX;
    }
};


int q = 1; 
vector<node> d;
vector<int> child_info;

void update (int v) {
    int val = child_info[v];
    child_info[v] = 0;

    d[v * 2].l_ind += val;
    d[v * 2].r_ind += val;


    d[v * 2 + 1].l_ind += val;
    d[v * 2 + 1].r_ind += val;

    if (v * 2 < q) {
        child_info[v * 2] += val;
        child_info[v * 2 + 1] += val;
    }
}

node merge(node &v1, node &v2) {
    if (v2.l_ind == 1e9) return v1;
    if (v1.l_ind == 1e9) return v2;

    node v = node(v1.l_ind, v2.r_ind, max(v1.mx, v2.mx));
    return v;
}

int get_l(int v, int k) {
    if (child_info[v]) update(v);
    //cout << v << "   "; 
    if (v >= q) return v - q;
    if (d[v * 2].r_ind >= k) return get_l(v * 2, k);
    return get_l(v * 2 + 1, k);
}

int get_r(int v, int k) {
    if (child_info[v]) update(v);

    if (v >= q) return v - q;
    if (d[v * 2 + 1].l_ind <= k) return get_r(v * 2 + 1, k);
    return get_r(v * 2, k);
}

node get_mx(int v, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) return d[v];
    if (r <= lq || rq <= l) return node(1e9, 1e9, -1e9);

    node v1 = get_mx(v * 2, l, (l + r) / 2, lq, rq);
    node v2 = get_mx(v * 2 + 1, (l + r) / 2, r, lq, rq);

    return merge(v1, v2);
}

void upd(int v, int l, int r, int lq, int rq, int val) {
    if (child_info[v]) update(v);

    if (lq <= l && r <= rq) {

        d[v].l_ind -= val;
        d[v].r_ind -= val;

        if (v < q) {
            child_info[v] -= val;
        }

        return;
    }

    if (rq <= l || r <= lq) return;

    upd(v * 2, l, (l + r) / 2, lq, rq, val);
    upd(v * 2 + 1, (l + r) / 2, r, lq, rq, val);

    d[v] = merge(d[v * 2], d[v * 2 + 1]);
}

void solve() {
    int n; cin >> n;
    vector<int> h(n);

    int fl = 0, prev = 2e9;
    bool sbt2 = 1;

    vector<ll> pr_h(n);

    for (auto &i: h) {
        cin >> i;
        if (fl == 0 && i > prev) fl = 1;
        else if (fl == 1 && prev > i) {
            sbt2 = 0;
        }

        prev = i;
    }

    if (sbt2) {
        for (int i = 0; i < n; i++) {
            pr_h[i] = h[i];
            if (i) pr_h[i] += pr_h[i - 1];
        }
    }
    vector<int> w(n - 1);


    for (auto &i: w) {
        cin >> i;
    }


    
    while (q < n) q *= 2;

    d.resize(q * 2);
    child_info.resize(q * 2);

    for (int i = 0; i < n; i++) {
        d[q + i] = node(i, i, h[i]);
    }

    for (int i = n; i < q; i++) {
        d[q + i] = node(1e9, 1e9, -1e9);
    }


    for (int i = q - 1; i > 0; i--) {
        d[i] = merge(d[i * 2], d[i * 2 + 1]);
    }

    //cout << d[2].l_ind << " " << d[2].r_ind << "!\n";

    for (int i = 0; i < n - 1; i++) {
        int k = w[i] - 1;
        //cout << k << "    !    ";
        int l = get_l(1, k);
        int r = get_r(1, k + 1);

        ll ans = 0;


        if (sbt2) {
            //cout << (r - l + 1) * min(h[l], h[r]) << " " ;
            ans = (r - l) * min(h[l], h[r]) + max(h[l], h[r]) - (pr_h[r] - (l ? pr_h[l - 1] : 0));
            int u = get_l(1, k + 1);
            upd(1, 0, q, u, q, 1);
            cout << ans << '\n';
            continue;
        }

        //cout << l << " " << r << "\n";

        for (int j = l; j <= r; j++) {
            int mx1 = get_mx(1, 0, q, l, j + 1).mx;
            int mx2 = get_mx(1, 0, q, j, r + 1).mx;

            ans += min(mx1, mx2) - h[j];
        }

        int u = get_l(1, k + 1);
        upd(1, 0, q, u, q, 1);
        cout << ans << '\n';
    }
}


void solve2() {
    int n; cin >> n;
    int k; cin >> k;

    vector<int> a(n);
    int ans = 1;

    set<int> nxt;

    for (int i = 0; i < n; i++) {
        int x; cin >> x;

        if(nxt.find(x) == nxt.end()) {
            ans = 0;
            break;
        }

        nxt.clear();

        if (i == 0 && x == 1) {
            nxt.insert(2);
            nxt.insert(0);
            nxt.insert(1);
            nxt.insert(3);
        } else if (i == 0 && x == 0) {
            nxt.insert(2);
            nxt.insert(0);
            nxt.insert(1);
            nxt.insert(3);
        } else if (i == 0 && x == 2) {
            nxt.insert(2);
            nxt.insert(1);
            nxt.insert(3);
        } else if (i == 0) {
            ans = 0;
            break;
        } else if (x == 3 || x == 2) {
            nxt.insert(2);
            nxt.insert(1);
            nxt.insert(3);
        } else if (x <= 1) {
            nxt.insert(2);
            nxt.insert(0);
            nxt.insert(1);
            nxt.insert(3);
        } else {
            ans = 0;
            break;
        }
    }

    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}