#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

int getInt(int l, int r) {
    return uniform_int_distribution<int>(l, r)(gen);
}

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    ll d, l, r; cin >> d >> l >> r;


    ll ans = 0;
    set<pair<ll, ll>> s;

    ll f = 1;
    for (ll i = 2; i * i <= d; i++) {
        if (d % i == 0) {
            f = i;
            break;
        }
    }


    for (ll a = f; a <= d; a += f) {
        if (d % a) continue;
        ll b = d / a;

        if ((a + b) % 2) continue;

        ll x = (a + b) / 2;
        ll y = a - x;

        if (x > 0 && y > 0 && y < x && l <= x * x && x * x <= r && l <= y * y && y * y <= r) {
            s.insert({x, y});
            ans++;
        }
    }

    ll a = 1;
    ll b = d / a;

    if (f != 1 && (a + b) % 2 == 0) {

        ll x = (a + b) / 2;
        ll y = a - x;

        if (x > 0 && y > 0 && y < x && l <= x * x && x * x <= r && l <= y * y && y * y <= r) {
            s.insert({x, y});
            ans++;
        }
    }
    
    cout << s.size() << "\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}