#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

// int getInt(int l, int r) {
//     return uniform_int_distribution<int>(l, r)(gen);
// }

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<ll> a(n);

    for (auto &i : a) cin >> i;

    vector<ll> pr(n), sf(n), mn_pref(n), mn_sf(n);
    ll ans = 0;

    for(int i = 0; i < n; i++) {
        pr[i] = a[i];
        mn_pref[i] = a[i];
        if (i) pr[i] += pr[i - 1];
        if (i) mn_pref[i] = min(mn_pref[i], mn_pref[i - 1]);
    }

    for (int i = n -1 ;i >= 0; i--) {
        sf[i] = a[i];
        mn_sf[i] = a[i];

        if (i != n - 1) sf[i] += sf[i + 1];
        if (i != n - 1) mn_sf[i] = min(mn_sf[i], mn_sf[i + 1]);
    }

    if (k == 2) {
        
        for (int i = 0; i < n - 1; i++) {
            ans = max(ans, max(pr[i], sf[i + 1]) -  min(pr[i], sf[i + 1]));
        }

        cout << ans << "\n";
        return;
    }


    for (int i = 0; i < n; i++) {
        //x = 1

        if (i == 1) {
            int left = k - 2;
            if (n - 1 - left >= i) 
                ans = max(ans, (pr[n - 1 - left] - pr[i - 1]) - pr[i - 1]);
        }

        // x = 2

        if (i >= 2) {
            int left = k - 3;
            if (n - 1 - left >= i) {
                ans = max(ans, (pr[n - 1 - left] - pr[i - 1]) - a[0]);
                ans = max(ans, (pr[n - 1 - left] - pr[i - 1]) - a[i - 1]);
            }
        }

        // x = 3

        if (i >= 3) {
            int left = k - 4;
            if (n - 1 - left >= i)
                ans = max(ans, (pr[n - 1 - left] - pr[i - 1]) - mn_pref[i - 1]);
        }
    }


    for (int i = n - 1; i >= 0; i--) {
        //x = 1

        if (i == n - 2) {
            int left = k - 2;
            if (left >= 0 && left <= i) 
                ans = max(ans, (sf[left] - sf[i + 1]) - sf[i + 1]);
        }

        // x = 2

        if (i <= n - 3) {
            int left = k - 3;
            if (left >= 0 && left <= i)  {
                ans = max(ans, (sf[left] - sf[i + 1]) - a[n - 1]);
                ans = max(ans, (sf[left] - sf[i + 1]) - a[i + 1]);
            }
        }

        // x = 3

        if (i <= n - 4) {
            int left = k - 4;
            if (left >= 0 && left <= i) 
                ans = max(ans, (sf[left] - sf[i + 1]) - mn_sf[i + 1]);
        }
    }

    cout << ans << "\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}