#pragma GCC optimize("Ofast")
#pragma target("avx2", "sse2")
#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5 + 1000;

int n, m, k;

int table[100][100], x[maxn], y[maxn];

void solve1() {
    for (int i = 0; i < k; i++) {
        int x1, y1;
        cin >> x1 >> y1; x1--, y1--;
        table[x1][y1] = 1;
    }
    int mx11 = 0, mn11 = m;
    for (int j = 0; j < m; j++) {
        if (table[j][1]) {
            mn11 = min(mn11, j);
        }
        if (table[j][0]) {
            mx11 = max(mx11, j);
        }
    }
    int ans = max(mn11 - mx11 + 1, 0);
    int mx21 = 0, mn21 = m;
    for (int j = 0; j < m; j++) {
        if (table[j][1]) {
            mn21 = min(mn21, j);
        }
        if (table[j][0]) {
            mx21 = max(mx21, j);
        }
    }
    ans += max(mn21 - mx21 + 1, 0);
    cout << ans << '\n';
}

void solve2() {
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i]; x[i]--, y[i]--;
    }
    vector<int> perm1(n + m - 2), perm2(n + m - 2);
    for (int i = n - 1; i < n + m - 2; i++) {
        perm1[i] = 1;
        perm2[i] = 1;
    }
    int alans = 0;
    do {

        vector<bitset<100>> was(n + 1);
        do {
            int x1 = 0, y1 = 0;
            for (auto i : perm1) {
                if (i) y1++;
                else x1++;
                was[x1][y1] = 1;
            }
            x1 = n - 1;
            y1 = m - 1;
            bool fl = 1;
            for (auto i : perm2) {
                if (i) y1--;
                else x1--;
                if (was[x1][y1]) {
                    fl = 0;
                    break;
                }
                was[x1][y1] = 1;
            }
            for (int i = 0; i < k; i++) {
                if (!was[x[i]][y[i]]) {
                    fl = 0;
                }
            }
            if (fl) {
                alans++;
            }
            x1 = 0, y1 = 0;
            for (auto i : perm1) {
                if (i) y1++;
                else x1++;
                was[x1][y1] = 0;
            }
            x1 = n - 1;
            y1 = m - 1;
            fl = 1;
            for (auto i : perm2) {
                if (i) y1--;
                else x1--;
                was[x1][y1] = 0;
            }
        } while (next_permutation(perm2.begin(), perm2.end()));
        for (int i = 0; i < n - 1; i++) {
            perm2[i] = 0;
        }
        for (int i = n - 1; i < n + m - 2; i++) {
            perm2[i] = 1;
        }
    } while (next_permutation(perm1.begin(), perm1.end()));
    cout << alans << '\n';
}

void solve() {
    cin >> n >> m >> k;
    solve2();
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int tests = 1;
    while (tests--) solve();
}
