#include <iostream>
#include <algorithm>
#include <climits>
#include <vector>
#include <chrono>
#include <cmath>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll d, l, r, ans = 0;
    cin >> d >> l >> r;

    for (ll y = ceil(sqrt(l)); y * y < r; y++) {
        ll x = d + y * y;
        if (x > r) break;
        ll tmp = (ll) sqrt(x);
        if (tmp * tmp == x) ans++;
    }
    cout << ans;
    return 0;
}
