import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class TemplateIO {
    public boolean test(String n) {
        boolean used = false;
        char[] chars = n.toCharArray();
        int length = chars.length;

        int t = 0;
        boolean proceed = false;
        while (t < length) {
            if (chars[t] != '1') {
                proceed = true;
                break;
            }
            t += 1;
        }

        if (!proceed) {
            return false;
        }

        int ii = 0;

        while (ii < length) {
            char i = chars[ii];

            if (i == '0') {
                return false;
            } else if (i == '1') {

            } else if (i == '2' || i == '3' || i == '5' || i == '7'){
                if (used) {
                    return false;
                }
                used = true;
            } else {
                return false;
            }

            ii += 1;
        }
        return true;
    }

    public void solve() throws IOException {
        Scanner scanner = new Scanner(System.in);
        Integer l = scanner.nextInt();
        Integer r = scanner.nextInt();

        double l2 = Math.ceil(Math.log10(l));
        double r2 = Math.floor(Math.log10(r));

        if (r2 <= l2) {
            int n = 0;
            Integer i = l;
            while (i < r + 1) {
                if (test(i.toString())) {
                    n += 1;
                }

                i += 1;
            }
            System.out.println(n);
        } else {
            int n = (int) (2*(l2+r2+1)*(r2-l2));
            Integer i = l;
            while (i < Math.pow(10, l2)) {
                if (test(i.toString())) {
                    n += 1;
                }
                i += 1;
            }
            i = (int) Math.pow(10, r2);
            while (i < r+1) {
                if (test(i.toString())) {
                    n += 1;
                }
                i += 1;
            }
            System.out.println(n);
        }

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TemplateIO().run();
    }

}