from itertools import combinations

from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    n, k = map(int, input().split())
    a = list(map(int, input().split()))

    Min = float('inf')
    Max = 0

    for peregorodki in combinations(range(1, n), k - 1):
        peregorodki = [0] + list(peregorodki) + [n]
        for i in range(k):
            result = sum(a[peregorodki[i]:peregorodki[i + 1]])
            if result < Min:
                Min = result
            if result > Max:
                Max = result

    print(Max - Min)


thread = threading.Thread(target=main)
thread.start()

