﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;
#define int long long
int mod = 1e9 + 7;

vector<string> gen(int e, int n) {
	if (e < 0) return {};
	if (n == 1) {
		if (e == 0) {
			return { "0" };
		}
		if (e == 1) {
			return { "1" };
		}
		return {};
	}
	vector<string> g0 = gen(e, n - 1);
	vector<string> g1 = gen(e - 1, n - 1);
	for (int i = 0; i < g0.size(); i++) {
		g0[i] = "0" + g0[i];
	}
	for (int i = 0; i < g1.size(); i++) {
		g1[i] = "1" + g1[i];
	}
	for (int i = 0; i < g1.size(); i++) g0.push_back(g1[i]);
	return g0;
}

signed main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
	}
	if (n==3) {
		int maxim = 1;
		for (auto j : a) if(j.first==0) maxim = max(maxim, j.second);
		int ans = 0;
		for (int i = maxim; i < m; i++) {
			vector<vector<int>> b(2, vector<int>(i, 0));
			int mn=i-1, mx=0;
			for (auto j : a) {
				if (j.first == 1 && j.second<i) mx = max(mx, j.second);
				if (j.first == 2 && j.second < i) mn = min(mn, j.second);
			}
			ans += max(0LL, mn - mx + 1);
			//cout<< max(0LL, mn - mx + 1)<<"\n";
			ans %= mod;
		}
		cout << (ans*2)%mod;
		return 0;
	}
	vector<string> g1 = gen(n-1,n+m-2);
	vector<string> g2 = g1;
	vector<vector<int>> ss(n, vector<int>(m,0));
	for (auto k : a) ss[k.first][k.second] = -1;
	int ans = 0;
	for (auto p1 : g1) {
		for (auto p2 : g2) {
			int i1 = 0;
			int j1 = 0;
			vector<vector<int>> sss = ss;
			for (int i = 0; i < p1.size(); i++) {
				sss[i1][j1] = 1;
				if (p1[i] == '1') i1++;
				else j1++;
			}
			sss[i1][j1] = 1;
			i1 = n-1;
			j1 = m - 1;
			for (int i = 0; i < p2.size(); i++) {
				sss[i1][j1] = 2;
				if (p2[i] == '1') i1--;
				else j1--;
			}
			sss[i1][j1] = 2;
			int c1 = 0;
			int c2 = 0;
			int cm1 = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					c1 += (sss[i][j] == 1);
					c2 += (sss[i][j] == 2);
					cm1 += (sss[i][j] == -1);
				}
			}
			if (c1 == n + m - 3 && c2 == n + m - 1 && cm1 == 0) {
				ans++;
				ans %= mod;
				
			}
			
		}
	}
	cout << ans;
}
