#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

ll solve_corr(ll _L, ll _R) {
    ll L = _L, R = _R;
    ll ans = 0;
    for (ll i = L; i < R; ++i) {
        ll cur = 1;
        ll j = i;
        while (j > 0) {
            cur *= (j % 10);
            j /= 10;
        }
        if (cur == 2 || cur == 3 || cur == 5 || cur == 7) {
            ++ans;
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    ll L, R;
    cin >> L >> R;
    cout << solve_corr(L, R) << endl;

    return 0;
}
