#include <algorithm>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

using ll = long long;

int solve_corr(string _L, string _R) {
    int p = 1;
    int L = 0;
    for (int i = (int)_L.size() - 1; i >= 0; --i) {
        L += (_L[i] - '0') * p;
        p *= 10;
    }
    p = 1;
    int R = 0;
    for (int i = (int)_R.size() - 1; i >= 0; --i) {
        R += (_R[i] - '0') * p;
        p *= 10;
    }

    set<int> P = {2, 3, 5, 7};
    int ans = 0;
    for (int i = L; i <= R; ++i) {
        int cur = 1;
        int j = i;
        while (j > 0) {
            cur *= (j % 10);
            j /= 10;
        }
        if (P.count(cur)) {
            ++ans;
        }
    }
    return ans;
}
/*
ll get(string _s) {
    string s = _s;
    int n = (int)s.size();
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(2, {0, 0, 0}));
    set<int> P = {2, 3, 5, 7};
}*/

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    string L, R;
    cin >> L >> R;
    cout << solve_corr(L, R) << endl;

    return 0;
}
