#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

ll d, l, r;

ll solve() {
    ll p = 1;
    vector<pair<ll, ll>> res;
    while (p * p <= d) {
        if (d % p == 0) {
            res.push_back({p, d / p});
        }
        ++p;
    }

    ll ans = 0;
    for (pair<ll, ll> w : res) {
        ll a = w.first, b = w.second;
        if (a % 2 == b % 2) {
            ll x = (a + b) / 2;
            ll y = (b - a) / 2;
            if (l <= y * y && y < x && x * x <= r) {
                ++ans;
            }
        }
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> d >> l >> r;
    cout << solve() << endl;

    return 0;
}
