#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

int n, k;
vector<ll> a;

ll solve() {
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }

    if (k == 2) {
        ll ans = 0;
        for (int i = 1; i < n; ++i) {
            ans = max(ans, abs(2 * pref[i] - pref[n]));
        }
        return ans;
    }

    vector<ll> cnt(n), U(n);
    for (int i = 0; i < n; ++i) {
        cnt[i] = pref[min(n, i + n - k + 1)] - pref[i];
        U[i] = cnt[i];
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        cnt[i] -= U[i];
        /*for (auto x : cnt) {
            cout << x << ' ' ;
        }
        cout << endl;*/
        ll Max = 0;
        for (int j = 0; j < i; ++j) {
            Max = max(Max, cnt[j]);
        }
        for (int j = i + 1; j < n; ++j) {
            Max = max(Max, cnt[j]);
        }
        ans = max(ans, Max - a[i]);
        //cout << i << ' ' << Max << endl;

        for (int j = max(0, i + k - n); j <= i; ++j) {
            cnt[j] += a[i];
        }
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cin.precision(30);
    cout.tie(nullptr), cout.precision(30);

    cin >> n >> k;
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cout << solve() << endl;

    return 0;
}
