#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;

int bpr(char c, string &s) {
	string p(s.size(), '1');
	int l = -1, r = s.size();
	while (r - l > 1) {
		int m = (r - l) / 2 + l;
		p[m] = c;
		if (s >= p) {
			r = m;
		}
		else {
			l = m;
		}
		p[m] = '1';
	}
	return s.size() - r;
}

int bpl(char c, string& s) {
	string p(s.size(), '1');
	int l = -1, r = s.size();
	while (r - l > 1) {
		int m = (r - l) / 2 + l;
		p[m] = c;
		if (s > p) {
			r = m;
		}
		else {
			l = m;
		}
		p[m] = '1';
	}
	return s.size() - r;
}

int fr(string s) {
	int ans = 0;
	for (int len = 1; len < s.size(); len++) {
		ans += len * 4; // 2 3 5 7
	}
	ans += bpr('2', s);
	ans += bpr('3', s);
	ans += bpr('5', s);
	ans += bpr('7', s);
	return ans;
}

int fl(string s) {
	int ans = 0;
	for (int len = 1; len < s.size(); len++) {
		ans += len * 4; // 3 5 7
	}
	ans += bpl('2', s);
	ans += bpl('3', s);
	ans += bpl('5', s);
	ans += bpl('7', s);
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	string l, r;
	cin >> l >> r;
	cout << fr(r) - fl(l);
}