#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>
#include <vector>
#include <set>
#include <tuple>

using namespace std;

template <typename type> void out(type a) {
	auto it = a.begin();
	while (it != a.end()) {
		for (auto e : *it) {
			cout << e << " ";
		}
		it++;
		cout << "\n";
	}
	cout << "\n";
}

bool comp(vector <int> a, int k) {
	return a[0] == k;
}

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <int> h(n);
	set <vector <int>> a; // granici, max 
	vector <pair <int, int>> g(n);
	for (int i = 0; i < n; i++) {
		cin >> h[i];
		a.insert({i, i + 1, h[i]});
		g[i] = { h[i],h[i] };
	}
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		auto it = a.begin();
		while (k > 1) {
			it++;
			k--;
		}
		//auto it = lower_bound(a.begin(), a.end(), k - 1, comp);
		/*if (it != a.end()) {
			for (auto e : *it) {
				cout << e << " ";
			}
			cout << "it\n";
		}
		it++;
		if (it != a.end()) {
			for (auto e : *it) {
				cout << e << " ";
			}
			cout << "it++\n";
		}*/
		vector <int> t1 = *it, t2 = *(++it);
		a.erase(t1);
		a.erase(t2);
		vector <int> ans(3);
		ans[2] = max(t1[2], t2[2]);
		ans[0] = t1[0];
		ans[1] = t2[1];
		ll gl = 0;
		for (int j = t1[0]; j < t1[1]; j++) {
			if (g[j].second < t2[2]) {
				g[j].second = t2[2];
			}
			gl += min(g[j].first, g[j].second) - h[j];
		}
		for (int j = t2[0]; j < t2[1]; j++) {
			if (g[j].first < t1[2]) {
				g[j].first = t1[2];
			}
			gl += min(g[j].first, g[j].second) - h[j];
		}
		a.insert(ans);
		cout << gl << "\n";
	}

}