#include <iostream>
#include <vector>
#include <map>

using namespace std;
typedef int ll;

vector<pair<ll, int>> c;
vector<int> pr;
map<tuple<int, int, int>, bool> mem;
map<tuple<int, int>, bool> back;

bool res(int s, int k, int d) {
    // cout << s << ' ' << k << ' ' << d << ' ' << "...\n";
    if (mem.find({s, k, d}) != mem.end()) {
        // cout << s << ' ' << k << ' ' << d << ' ' << mem[{s, k, d}] << '\n';
        return mem[{s, k, d}];
    }
    if (k == 0) {
        // cout << s << ' ' << k << ' ' << d << ' ' << false << '\n';
        return false;
    }
    mem[{s, k, 0}] = false;
    mem[{s, k, 1}] = false;
    back[{s, k}] = false;
    if (s >= c[k].first) {
        bool t = c[k].second == 0 ? res(s-c[k].first, k-1, 1) : res(s-c[k].first, k-1, 0);
        mem[{s, k, 0}] = t;
        mem[{s, k, 1}] = t;
        if (t) back[{s, k}] = true;
    }
    bool t = c[k].second == 0 ? res(s, k-1, 1) : res(s, k-1, 0);
    mem[{s, k, 0}] = mem[{s, k, 0}] || t;
    if (c[k].second != 0) {
        mem[{s, k, 1}] = mem[{s, k, 1}] || res(s, k-1, 1);
    }
    // cout << s << ' ' << k << ' ' << d << ' ' << mem[{s, k, d}] << '\n';
    return mem[{s, k, d}];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; ll sd; cin >> n >> sd;
    pr.reserve(1e5);
    c.reserve(1e5);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            ll x; cin >> x;
            c.emplace_back(x, j);
            pr.push_back(i);
        }
    }

    // vector<vector<vector<bool>>> dp(sd + 1, vector<vector<bool>>(c.size(), {false, false}));

    // vector<vector<bool>> back(sd + 1, vector<bool>(c.size(), false));
    mem[{0, 0, 0}] = true;
    if (c[0].first <= sd) {
        mem[{c[0].first, 0, 0}] = true;
        mem[{c[0].first, 0, 1}] = true;
        back[{c[0].first, 0}] = true;
    }

    // cout << (mem.find({2,0,1}) == mem.end()) << '\n';

    cout << (res(sd, c.size()-1, 1) ? "Yes" : "No") << '\n';
    if (res(sd, c.size()-1, 1)) {
        vector<vector<int>> ans(n);
        int s = sd;
        for (int k = c.size() - 1; k >= 0; k--) {
            if (back[{s, k}]) {
                s -= c[k].first;
                ans[pr[k]].push_back(c[k].second);
            }
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            for (auto j = ans[i].rbegin(); j != ans[i].rend(); j++) {
                cout << *j + 1 << ' ';
            }
            cout << '\n';
        }
    }
}