﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
//#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, s, k;
	cin >> n >> s;
	int a;

	//vector<vector<int>> v(n);
	if (n > 1) {
		vector<vector<pair<int, pair<int, int>>>> pred(n + 1, vector<pair<int, pair<int, int>>>(s + 1, { -1, {-1, -1} }));
		vector<vector<int>> dp(n + 1, vector<int>(s + 1));
		//vector<vector<int>> dp;
		dp[0][0] = { 1};
		pred[0][0] = { -1, {-1, -1} };
		for (int i = 0; i < n; i++) {
			cin >> k;
			for (int j = 0; j < k; j++) {
				cin >> a;
				for (int o = s; o >= 0; o--) {
					if (dp[i + 1][o] && o + a <= s && dp[i + 1][o + a] == 0) {
						dp[i + 1][o + a] = 1;
						pred[i + 1][o + a] = { i + 1, {j + 1, o} };
					}
					if (dp[i][o] && o + a <= s && dp[i + 1][o + a] == 0) {
						dp[i + 1][o + a] = 1;
						pred[i + 1][o + a] = { i, { j + 1, o } };
					}
				}
			}
			/*
			for (auto& j : se) {
				cout << j << ' ';
			}cout << '\n';*/
		}
		if (dp[n][s]) {
			cout << "Yes\n";
			int ind = s, i = n;
			int newind, newi;
			vector<vector<int>> ans(n);
			while (i != 0 || ind != 0) {
				ans[i - 1].push_back(pred[i][ind].y.x);
				newi = pred[i][ind].x;
				newind = pred[i][ind].y.y;
				ind = newind;
				i = newi;
			}
			for (auto& i : ans) {
				cout << i.size() << '\n';
				for (auto& j : i) {
					cout << j << ' ';
				}cout << '\n';
			}
		}
		else {
			cout << "No\n";
		}
		/*
		for (auto& i : pred) {
			for (auto& j : i) {
				cout << j.x << ' ' << j.y.x << ' ' << j.y.y << "   ";
			}cout << "\n\n";
		}*/
	}
	else {
		cin >> k;
		vector<int> dp(s + 1, 0);
		vector<pair<int, int>> pred(s + 1);
		dp[0] = 1;
		for (int i = 0; i < k; i++) {
			cin >> a;
			for (int j = s; j >= 0; j--) {
				if (dp[j] && j + a <= s && !dp[j + a]) {
					dp[j + a] = 1;
					pred[j + a] = { j, i + 1 };
				}
			}
		}
		if (dp[s]) {
			cout << "Yes\n";
			int ind = s;
			vector<int> ans;
			while (ind != 0) {
				ans.push_back(pred[ind].y);
				ind = pred[ind].x;
			}
			cout << ans.size() << '\n';
			for (auto& i : ans) {
				cout << i << ' ';
			}
		}
		else {
			cout << "No\n";
		}
	}
	
}


signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}


/*
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
//#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, s, k;
	cin >> n >> s;
	int a;

	//vector<vector<int>> v(n);
	if (n > 1) {
		set<int> se, se2, se3;
		vector<vector<pair<int, pair<int, int>>>> pred(n + 1, vector<pair<int, pair<int, int>>>(s + 1, { -1, {-1, -1} }));
		vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(s + 1));
		//vector<vector<int>> dp;
		dp[0][0] = { 1, 1 };
		pred[0][0] = { -1, {-1, -1} };
		for (int i = 0; i < n; i++) {
			cin >> k;
			for (int j = 0; j < k; j++) {
				cin >> a;
				for (auto& o : se2) {
					if (o + a > s) {
						break;
					}
					if (se3.insert(o + a).second) {
						if (pred[i + 1][o + a].first == -1) {
							pred[i + 1][o + a] = { i + 1,  {j + 1, o } };
						}
					}
				}
				for (auto& o : se) {
					if (o + a > s) {
						break;
					}
					if (se2.insert(o + a).second) {
						if (pred[i + 1][o + a].first == -1) {
							pred[i + 1][o + a] = { i, { j + 1, o } };
						}
					}
				}
				for (auto& o : se3) {
					se2.insert(o);
				}
				se3.clear();
			}
			se = se2;
			for (auto& j : se) {
				cout << j << ' ';
			}cout << '\n';
			se2.clear();
		}
		if (se.find(s) != se.end()) {
			cout << "Yes\n";
			int ind = s, i = n;
			int newind, newi;
			vector<vector<int>> ans(n);
			while (i != 0 || ind != 0) {
				ans[i - 1].push_back(pred[i][ind].y.x);
				newi = pred[i][ind].x;
				newind = pred[i][ind].y.y;
				ind = newind;
				i = newi;
			}
			for (auto& i : ans) {
				cout << i.size() << '\n';
				for (auto& j : i) {
					cout << j << ' ';
				}cout << '\n';
			}
		}
		else {
			cout << "No\n";
		}
	}
	else {
		cin >> k;
		vector<int> dp(s + 1, 0);
		vector<pair<int, int>> pred(s + 1);
		dp[0] = 1;
		for (int i = 0; i < k; i++) {
			cin >> a;
			for (int j = s; j >= 0; j--) {
				if (dp[j] && j + a <= s && !dp[j + a]) {
					dp[j + a] = 1;
					pred[j + a] = { j, i + 1 };
				}
			}
		}
		if (dp[s]) {
			cout << "Yes\n";
			int ind = s;
			vector<int> ans;
			while (ind != 0) {
				ans.push_back(pred[ind].y);
				ind = pred[ind].x;
			}
			cout << ans.size() << '\n';
			for (auto& i : ans) {
				cout << i << ' ';
			}
		}
		else {
			cout << "No\n";
		}
	}
	
	for (auto& i : pred) {
		for (auto& j : i) {
			cout << j.x << ' ' << j.y.x << ' ' << j.y.y << "   ";
		}cout << "\n\n";
	}
}


signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}

*/