#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

#define FAST ios::sync_with_stdio(0), cout.tie(0); cin.tie(0);
#define ll int64_t
#define int int32_t
#define endl '\n'

void solve();

int32_t main() {
    FAST;

    int64_t t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

void solve() {
    ll n, k;
    cin >> n >> k;

    multiset<ll> s;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;

        s.insert(i);
    }

    ll sum = 0;
    for (int i = 0; i < k; i++) {
        sum += a[i];
        s.erase(a[i]);
    }

    ll mx = abs(sum - *s.begin());
    for (int i = k; i < n; i++) {
        sum -= a[i - k];
        sum += a[i];

        s.insert(a[i - k]);
        s.insert(a[i]);

        mx = max(mx, sum - *s.begin()); 
    }

    cout << mx << endl;
}