#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	int n;
	cin >> n;
	vector<int> h(n);
	for (auto& i : h) cin >> i;
	vector<ll> spref(n + 1);
	partial_sum(h.begin(), h.end(), spref.begin() + 1);
	vector<int> prv_(n), nxt_(n);
	iota(prv_.begin(), prv_.end(), 0);
	iota(nxt_.begin(), nxt_.end(), 0);
	auto nxt = [&](int i) -> int {
		while (nxt_[i] != i) i = nxt_[i] = nxt_[nxt_[i]];
		return i;
	};
	auto prv = [&](int i) -> int {
		while (prv_[i] != i) i = prv_[i] = prv_[prv_[i]];
		return i;
	};
	vector<int> fenw(n);
	auto upd = [&](int k, int x) -> void {
		for (; k < n; k |= k + 1) fenw[k] += x;
	};
	auto get = [&](int k) -> int {
		int ret = 0;
		for (; k >= 0; k &= k + 1, --k) ret += fenw[k];
		return ret;
	};
	for (int i = 0; i < n; ++i) upd(i, 1);
	vector<deque<int>> pref(n), suf(n);
	vector<ll> sum(n);
	for (int i = 0; i < n; ++i) {
		pref[i] = {i};
		suf[i] = {i};
		sum[i] = 2 * h[i];
	}
	for (int iter = 0; iter < n - 1; ++iter) {
		int k;
		cin >> k;
		int i, j;
		{
			int L = 0, R = n - 1;
			while (L != R) {
				int M = (L + R) / 2;
				if (get(M) >= k) R = M;
				else L = M + 1;
			}
			i = L;
		}
		j = nxt(i) + 1;
		upd(j, -1);
		// cout << i << ' ' << j << endl;
		while (pref[j].size() && h[pref[j].front()] <= h[pref[i].back()]) {
			int s = pref[j].front();
			pref[j].pop_front();
			int f= pref[j].size() ? pref[j].front() : nxt(j) + 1;
			sum[j] -= 1ll * (f - s) * h[s];
		}
		int f = pref[j].size() ? pref[j].front() : nxt(j) + 1;
		sum[i] += 1ll * (f - nxt(i) - 1) * h[pref[i].back()];
		// for (auto x : pref[j]) cout << x << ' ';
		// cout << endl;
		// cout << sum[j] << endl;
		while (suf[i].size() && h[suf[i].front()] < h[suf[j].back()]) {
			int s = suf[i].front();
			suf[i].pop_front();
			int f = suf[i].size() ? suf[i].front() : i - 1;
			sum[i] -= 1ll * (s - f) * h[s];
		}
		f = suf[i].size() ? suf[i].front() : i - 1;
		sum[j] += 1ll * (j - f - 1) * h[suf[j].back()];
		// for (auto x : suf[i]) cout << x << ' ';
		// cout << endl;
		// cout << sum[i] << ' ' << sum[j] << endl;
		sum[i] += sum[j];
		if (pref[i].size() > pref[j].size()) {
			for (auto x : pref[j]) pref[i].push_back(x);
			pref[j].clear();
		} else {
			while (pref[i].size()) {
				pref[j].push_front(pref[i].back());
				pref[i].pop_back();
			}
			swap(pref[i], pref[j]);
		}
		nxt_[nxt(i)] = j;
		prv_[j] = nxt(i);
		if (suf[i].size() < suf[j].size()) {
			for (auto x : suf[i]) suf[j].push_back(x);
			suf[i].clear();
			swap(suf[i], suf[j]);
		} else {
			while (suf[j].size()) {
				suf[i].push_front(suf[j].back());
				suf[j].pop_back();
			}
		}
		int mx = pref[i].back();
		cout << sum[i] - (spref[nxt(i) + 1] - spref[i]) - 1ll * (nxt(i) - mx) * h[mx] - 1ll * (mx - i + 1) * h[mx] << '\n';
	}
}