#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
int inv(int x) {
	return x == 1 ? 1 : sub(0, mul(mod / x, inv(mod % x)));
}

const int N = 3e6;

int fact[N], ifact[N];

int C(int n, int k) {
	if (n < 0 || k < 0 || n < k) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}

int catalan(int n) {
	return sub(C(2 * n, n), C(2 * n, n + 1));
}
int go(pair<int, int> start, pair<int, int> finish) {
	int dx = finish.first - start.first, dy = finish.second - start.second;
	return C(dx + dy, dx);
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	fact[0] = 1;
	for (int i = 1; i < N; ++i) fact[i] = mul(i, fact[i - 1]);

	ifact[N - 1] = inv(fact[N - 1]);
	for (int i = N - 1; i; --i) ifact[i - 1] = mul(i, ifact[i]);

	int n, m, k;
	cin >> n >> m >> k;
	n--, m--;
	vector<pair<int, int>> pts(k);
	for (auto& [x, y] : pts) cin >> x >> y, --x, --y;
	pts.emplace_back(0, 0);
	pts.emplace_back(0, 1);
	sort(pts.begin(), pts.end());
	map<pair<int, int>, int> dp;
	dp[{0, 1}] = 1;
	for (int i = 2; i < pts.size(); ++i) {
		map<pair<int, int>, int> nw;
		for (auto& [pt, val] : dp) {
			auto [x, y] = pt;
			nw[{i, y}] = add(nw[{i, y}], mul(go(pts[x], pts[i]), val));
			nw[{x, i}] = add(nw[{x, i}], mul(go(pts[y], pts[i]), val));
		}
		dp = nw;
	}
	int ret = 0;
	for (auto& [pt, val] : dp) {
		auto [x, y] = pt;
		ret = add(ret, mul(mul(go(pts[x], {n, m - 1}), go(pts[y], {n, m})), val));
		ret = sub(ret, mul(mul(go(pts[x], {n, m}), go(pts[y], {n, m - 1})), val));
	}
	cout << mul(2, ret);
}