﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

const int INF = 1e18;

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;

	vector<int> prefix(n + 1);

	vector<int> a(n, 0);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		prefix[i + 1] = prefix[i] + a[i];
	}

	vector<int> prefmin(n + 1, INF);
	vector<int> sufmin(n + 1, INF);

	for (int i = 0; i < n;i++) {
		prefmin[i + 1] = min(prefmin[i], a[i]);
	}

	for (int i = 0; i < n; i++) {
		sufmin[i + 1] = min(sufmin[i], a[n - i - 1]);
	}

	int ans = 0;

	int len = n - k + 1;

	for (int i = 0; i < k;i++) {
		int sum = prefix[i + len] - prefix[i];
		int mn = min(prefmin[i], sufmin[n - len - i]);
		ans = max(ans, sum - mn);
	}

	cout << ans << endl;
}

