﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

const int INF = 1e18;

int slv(int n, int k, vector<int> a) {
	vector<int> prefmin(n + 1, INF);
	vector<int> sufmin(n + 1, INF);

	for (int i = 0; i < n; i++) {
		prefmin[i + 1] = min(prefmin[i], a[i]);
	}

	for (int i = 0; i < n; i++) {
		sufmin[i + 1] = min(sufmin[i], a[n - i - 1]);
	}
	vector<int> pref(n + 1);
	for (int i = 0; i < n;i++) {
		pref[i + 1] = pref[i] + a[i];
	}

	vector<int> mnx(n + 1, INF);

	int ans = 0;

	for (int i = 0; i < n;i++) {
		mnx[i] = min(mnx[i], pref[i] + prefmin[i]);
		int ost = n - i - 1;
		for (int num = max(0ll, k - 1 - ost); num <= n;num++) {
			ans = max(ans, pref[i + 1] - mnx[num]);
		}
	}

	return ans;

}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, k;
	cin >> n >> k;

	vector<int> a(n, 0);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int ans = slv(n, k, a);
	reverse(a.begin(), a.end());
	ans = max(ans, slv(n, k, a));

	cout << ans << endl;

}

