#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

typedef tree<int, int, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve() {
    int n;
    cin >> n;
    vector <ll> h(n);
    ordered_set s;
    vector <ll> l(n);
    vector <ll> r(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        s.insert({i, i + 1}); // [l..r)
        l[i] = h[i];
        r[i] = h[i];
    }
    for (int t = 0; t < n - 1; t++) {
        int k;
        cin >> k;
        k--;
        auto p1 = s.find_by_order(k);
        auto p2 = s.find_by_order(k + 1);
        int L1 = p1 -> first;
        int R1 = p1 -> second;
        int L2 = p2 -> first;
        int R2 = p2 -> second;
        s.erase(p1);
        s.erase(p2);
        s.insert({L1, R2});
        ll mxL = 0, mxR = 0;
        for (int i = L1; i < R1; i++) {
            mxL = max(mxL, h[i]);
        }
        for (int i = L2; i < R2; i++) {
            mxR = max(mxR, h[i]);
        }
        for (int i = L1; i < R1; i++) {
            r[i] = max(r[i], mxR);
        }
        for (int i = L2; i < R2; i++) {
            l[i] = max(l[i], mxL);
        }
        ll ans = 0;
        for (int i = L1; i < R2; i++) {
            ans += min(l[i], r[i]) - h[i];
        }
        cout << ans << "\n";
    }
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
