#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, k;
    cin >> n >> k;
    vector <int> b(n);
    for (int i=0; i<n; i++) cin >> b[i];

    if (k == 1)
    {
        for (auto x : b)
        {
            if (x > 1)
            {
                cout << 0;
                return;
            }
        }
        cout << 1;
        return;
    }
    if (k == 2)
    {
        vector <vector <int>> dp(n, vector <int> (4, 0));
        if (b[0] == 0) dp[0] = {1, 0, 0, 0};
        if (b[0] == 1) dp[0] = {0, 1, 1, 0};
        if (b[0] == 2) dp[0] = {0, 0, 0, 1};

        for (int i=1; i<n; i++)
        {
            if (b[i] == 0) dp[i] = {dp[i-1][0]+dp[i-1][2], 0, 0, 0};
            else if (b[i] == 1) dp[i] = {dp[i-1][1]+dp[i-1][3], dp[i-1][0]+dp[i-1][2], dp[i-1][0]+dp[i-1][2], 0};
            else if (b[i] == 2) dp[i] = {0, dp[i-1][1]+dp[i-1][3], dp[i-1][1]+dp[i-1][3], dp[i-1][0]+dp[i-1][2]};
            else if (b[i] == 3) dp[i] = {0, 0, 0, dp[i-1][1]+dp[i-1][3]};
            else
            {
                cout << 0;
                return;
            }
        }
        cout << dp[n-1][0]+dp[n-1][1]+dp[n-1][2]+dp[n-1][3];
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}
