#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, k;
    cin >> n >> k;
    k = n-k+1;

    vector <int> a(n);
    for (int i=0; i<n; i++)
    {
        cin >> a[i];
    }

    deque <int> pref(n), suf(n);

    pref[0] = a[0];
    for (int i=1; i<n; i++)
    {
        pref[i] = pref[i-1] + a[i];
    }

    suf[n-1] = a[n-1];
    for (int i=n-2; i>=0; i--)
    {
        suf[i] = suf[i+1] + a[i];
    }

    vector <int> lk(n), leftk(n, -INF), rightk(n, -INF);
    lk[0] = pref[k-1];
    for (int i=1; i<n-k+1; i++)
    {
        lk[i] = pref[i+k-1] - pref[i-1];
    }

    for (int i=k; i<n; i++)
    {
        leftk[i] = max(leftk[i-1], lk[i-k]);
    }

    for (int i=n-k-1; i>=0; i--)
    {
        rightk[i] = max(rightk[i+1], lk[i+1]);
    }

    pref.push_front(0);
    suf.push_back(0);

    int ans = 0;
    for (int i=0; i<n; i++)
    {
        int l = leftk[i];
        if (i < k)
        {
            l = pref[i];
        }
        int r = rightk[i];
        if (i >= n-k)
        {
            r = suf[i+1];
        }
        ans = max(ans, max(l, r) - a[i]);
    }
    cout << ans;

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << endl;
    }
}
