#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;
const int mod = 1e9 + 7;

int poww(int a, int n, int mod)
{
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n%2 == 0)
    {
        int x = poww(a, n/2, mod);
        return (x*x) % mod;
    }
    return (poww(a, n-1, mod) * a) % mod;
}

int num(int a, int b, int n, int m)
{
    if (a < 0 || b < 0 || a >= n || b >= m) return -1;
    return (m*a+b);
}

vector <vector <int>> g;
vector <int> used;
vector <int> h;
int now_h, n, m, k;

int dfs(int v, bool f, bool ff)
{
    if (v == n*m-1) ff = true;
    int ans=0;
    used[v] = 1;

    for (auto u : g[v])
    {
        if (ff && u>v) continue;
        if (!ff && u<v) continue;
        if (u == 0 && f) ans++;

        else if (!used[u])
        {
            if (h[u])
            {
                now_h++;
            }
            if (now_h == k) f = true;
            ans += dfs(u, f, ff);
            if (h[u])
            {
                now_h--;
                f = false;
            }
        }
    }

    if (v == n*m-1) ff = false;
    used[v] = 0;
    return ans;
}

void solve()
{
    cin >> n >> m >> k;

    if (k == 0)
    {
        vector <int> fact(n+m);
        fact[0] = 1;

        for (int i=1; i<n+m; i++)
        {
            fact[i] = (fact[i-1] * i) % mod;
        }

        int ans = (fact[n+m-3]*fact[n+m-3]) % mod;
        int zn = (((((fact[n-2]*fact[m-1])%mod)*((fact[m-2]*fact[n-1])%mod))%mod)*(n+m-3))%mod;
        ans *= poww(zn, mod-2, mod); ans %= mod;

        cout << (ans*2)%mod;
        return;
    }

    vector <int> p(k);
    h.assign(n*m, 0);

    int x, y;
    for (int i=0; i<k; i++)
    {
        cin >> x >> y; x--; y--;
        if (x == 0 && y == 0) continue;
        p[i] = num(x, y, n, m);
        h[p[i]] = 1;
    }

    g.resize(n*m);
    used.assign(n*m, 0);

    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            int a, b;
            a = num(i, j, n, m);
            b = num(i-1, j, n, m);
            if (b+1) g[a].push_back(b);
            b = num(i+1, j, n, m);
            if (b+1) g[a].push_back(b);
            b = num(i, j-1, n, m);
            if (b+1) g[a].push_back(b);
            b = num(i, j+1, n, m);
            if (b+1) g[a].push_back(b);
        }
    }

    now_h = 0;
    int ans = dfs(0, false, false);

    cout << ans;
    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << endl;
    }
}
