primes = frozenset([2,3,5,7])

def is_subprime(n):
	if isinstance(n,int):
		n=str(n)
	if isinstance(n,str):
		n=tuple(filter(lambda v:v!=1,map(int,n)))
	return len(n)==1 and n[0] in primes
def is_subprime2(n):
	q=False
	while n!=0:
		m=n%10
		n//=10
		if m==1:
			continue
		if m in primes:
			if q:
				return False
			q=True
			continue
		return False
	return q
def solve_with_len(b,e,l):
	r=[1]*l
	n=0
	for prime_pos in range(l):
		for p in primes:
			r[l-1-prime_pos]=p
			if r>e:
				break
			if r>=b:
				n+=1
		r[l-1-prime_pos]=1
	return n
def solve_with_len_nb(l):
	return len(primes)*l

def get_boundary(l):
	return [1]+[0]*(l-1)
def get_boundary2(l):
	return [9]*(l-1)

def sol1(l,r):
	b=list(map(int,str(l)))
	e=list(map(int,str(r)))
	bl = len(b)
	el=len(e)
	n=0
	if bl!=el:
		n+=solve_with_len(b,get_boundary2(bl+1), bl)
		n+=solve_with_len(get_boundary(el),e, el)
		for i in range(bl+1,el):
			n+=solve_with_len(get_boundary(i), get_boundary2(i+1), i)
	else:
		n=solve_with_len(b,e,bl)
	return n
def sol3(l,r):
	b=list(map(int,str(l)))
	e=list(map(int,str(r)))
	bl = len(b)
	el=len(e)
	n=0
	if bl!=el:
		n+=solve_with_len(b,get_boundary2(bl+1), bl)
		n+=solve_with_len(get_boundary(el),e, el)
		for i in range(bl+1,el):
			n+=solve_with_len_nb( i)
	else:
		n=solve_with_len(b,e,bl)
	return n
def sol2(l,r):
	n=0
	for i in range(int(l),int(r)+1):
		if is_subprime2(i):
			n+=1
	return n
def full_sol():
	l=input()
	r=input()
	n=sol3(l,r)
	print(n)
def test():
	import random
	import time
	ft1=0
	ft2=0
	for i in range(10):
		l=random.randint(1, 10**1000)
		l=1
		r=random.randint(l, 10**100)
		t1=time.time()
		n1=sol1(l,r)
		t2=time.time()
		n2=sol3(l,r)
		t3=time.time()
		ft1+=t2-t1
		ft2+=t3-t2
		if n1!=n2:
			print(l,r,n1,n2)
			break
	print(ft1,ft2)
# test()
full_sol()
