
class Segment:
	heights=[]
	caps=[]
	max_h=0
	min_h=0
	max_hpos=0
	def __init__(self,h):
		self.heights=[h]
		self.caps=[0]
		self.max_h=h
		self.min_h=h
	def merge(self,rhs):
		self.calc_merged_cap(rhs)
		if rhs.max_h>self.max_h:
			self.max_h=rhs.max_h
			self.max_hpos = len(self.heights)+rhs.max_hpos
		if rhs.min_h<self.min_h:
			self.min_h=rhs.min_h
		self.heights=self.heights+rhs.heights
		return self
	def calc_merged_cap(self,rhs):
		if True or rhs.min_h<self.max_h:
			for z in range(rhs.max_hpos):
				if rhs.heights[z]>=self.max_h:
					break
				rhs.caps[z]=min(self.max_h,rhs.max_h)-rhs.heights[z]
		if True or self.min_h<rhs.max_h:
			for z in range(1,len(self.heights)-self.max_hpos):
				if self.heights[-z]>=rhs.max_h:
					break
				self.caps[-z]=min(self.max_h,rhs.max_h)-self.heights[-z]
		self.cap=sum(rhs.caps)+sum(self.caps)
		self.caps+=rhs.caps

def sol(n,h,k):
	segs = list(map(Segment,h))
	for i in k:
		yield segs[i-1].merge(segs.pop(i)).cap

def main():
	n=int(input())
	h=tuple(map(int,input().split()))
	assert len(h)==n
	k=tuple(map(int,input().split()))
	assert len(k)==n-1
	w=sol(n,h,k)
	print(*w,sep="\n")


def test1():
	n=8
	h=[9,1,8,1,5,2,3,6]
	k=[3,3,1,3,3,2,1]
	w=list(sol(n,h,k))
	assert w==[0,4,0,0,0,13,20]
def test():
	test1()
	import random
	n=10000
	h=[random.randint(1,10**9) for i in range(n)]
	k=[random.randint(1,n-i-1) for i in range(n-1)]
	import time
	a=time.time()
	w=list(sol(n,h,k))
	b=time.time()
	print(b-a)

main()
