class Segment:
	heights=[]
	caps=[]
	max_h=0
	min_h=0
	max_hpos=0
	def __init__(self,h):
		self.heights=[h]
		self.caps=[0]
		self.cap=0
		self.max_h=h
		self.min_h=h
	def merge(self,rhs):
		self.calc_merged_cap(rhs)
		if rhs.max_h>self.max_h:
			self.max_h=rhs.max_h
			self.max_hpos = len(self.heights)+rhs.max_hpos
		if rhs.min_h<self.min_h:
			self.min_h=rhs.min_h
		self.heights=self.heights+rhs.heights
		return self
	def recalc_cap(self, i1,i2, ord_, waterline):
		z=i1
		pwl=0
		pcap=0
		while z!=i2:
			if self.heights[z]>=waterline:
				return
			if self.heights[z]>pwl:
				pwl=self.heights[z]
				pcap=waterline-pwl
			self.caps[z]+=pcap
			self.cap+=pcap
			z+=ord_
	def calc_merged_cap(self,rhs):
		if rhs.min_h<self.max_h:
			rhs.recalc_cap(0,rhs.max_hpos,1,min(self.max_h,rhs.max_h))
		if self.min_h<rhs.max_h:
			self.recalc_cap(len(self.heights)-1,self.max_hpos,-1,min(self.max_h,rhs.max_h))
		self.cap+=rhs.cap
		self.caps+=rhs.caps

def sol(n,h,k):
	segs = list(map(Segment,h))
	for i in k:
		yield segs[i-1].merge(segs.pop(i)).cap

def main():
	n=int(input())
	h=tuple(map(int,input().split()))
	assert len(h)==n
	k=tuple(map(int,input().split()))
	assert len(k)==n-1
	w=sol(n,h,k)
	for z in w:
		print(z)


if __name__=="__main__":
	main()
