#include <iostream>
#include <cmath>

bool isP(long long x) {
	long long g = (long long)sqrt(x) + 1;
	if (x < 2)
		return 0;
	if (x == 2)
		return 1;
	for (int i = 2; i < g; i++)
		if (x % i == 0)
			return 0;
	return 1;
}
int main(void){
	long long l, r, p = 1, cop, cnt = 0;
	std::cin >> l >> r;
	float deg = log10(r);
	if (l == 1 && deg - (int)deg == 0) {
		for (int i = 1; i < deg + 1; i++)
			cnt += 4 * i;
		std::cout << cnt << std::endl;
		return 0;
	}
	
	for (int i = l; i <= r; i++)
	{
		p = 1;
		cop = i;
		while (cop != 0) {
			p *= cop % 10;
			cop /= 10;
		}
		if (isP(p))
			cnt++;
	}
	std::cout << cnt << std::endl;
	return 0;
}
