n = int(input())
h = [int(i) for i in input().split()]
k = [int(i) for i in input().split()]


class segment:
    def __init__(self, n, m_right, m_left, l):
        self.n = n
        self.m_right = m_right
        self.m_left = m_left
        self.l = l
        
    def h(self, i):
        return h[i + self.l]
    
    def volume(self):
        v = 0
        
        for i in range(self.n):
            v += min(self.m_right[i], self.m_left[i]) - self.h(i)
            
        return v
    
    def concat(self, s):
        m = s.n + self.n
        m_left = [0] * m
        m_right = [0] * m
        h = [0] * m
        
        for i in range(self.n):
            h[i] = self.h(i)
            m_right[i] = self.m_right[i]
        
        for i in range(s.n):
            h[i + self.n] = s.h(i)
            m_left[i + self.n] = s.m_left[i]
        
        for i in range(self.n - 1, -1, -1):
            m_left[i] = max(m_left[i + 1], self.m_left[i])
        
        for i in range(s.n):
            m_right[self.n + i] = max(s.m_right[i], m_right[self.n + i - 1])
        
        #print(h)
        #print(m_right)
        #print(m_left)
        
        return segment(m, m_right, m_left, self.l)
    
segments = [
    segment(1, [hi], [hi], i) for i, hi in enumerate(h)
]

for ki in k:
    idx = ki - 1
    snew = segments[idx].concat(segments[idx + 1])
    segments[idx] = snew
    segments.pop(idx + 1)
    print(snew.volume())
    
"""
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
"""
        