
#include <iostream>
#include <vector>

using namespace std;

int w = 10e+9 + 7;

int rec(int i, int j, int phase, vector< vector<int> > & visited, vector< vector<int> >& xy) {
    if (i == 1 && j == 1 && phase == 1) {
        for (int k = 0; k < xy.size(); k++)
            if (visited[xy[k][0]][xy[k][1]] == 0)
                return 0;
        return 1;
    }
    else if (i == visited.size() - 1 && j == visited[0].size() - 1 && phase == 0) {
        return rec(i, j, 1, visited, xy);
    }

    long c = 0;
    int delta = phase == 0 ? 1 : -1;

    if (1 <= i + delta && i + delta <= visited.size() - 1 && visited[i + delta][j] == 0) {
        visited[i + delta][j] = 1;
        c += rec(i + delta, j, phase, visited, xy);
        visited[i + delta][j] = 0;
    }

    if (1 <= j + delta && j + delta <= visited[0].size() - 1 && visited[i][j + delta] == 0) {
        visited[i][j + delta] = 1;
        c += rec(i, j + delta, phase, visited, xy);
        visited[i][j + delta] = 0;
    }

    return c % w;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector< vector<int> > xy(k, vector<int>(2));
    for (int i = 0; i < k; i++)
        cin >> xy[i][0] >> xy[i][1];
    vector< vector<int> > visited(n + 1, vector<int>(m + 1));

    long z = rec(1, 1, 0, visited, xy);

    cout << z;


}

