#include<bits/stdc++.h>

using namespace std;

#define int long long 



struct seg{
    vector<int> t, tr ;
    seg(vector<int> & a){
        tr = a;
        t.resize(a.size()*2-1);
        build(0, 0, a.size() );
    }
    void build(int v, int l, int r){
        if(r - l == 1){
            t[v]=tr[l];
            return;
        }
        int m = l+r >> 1;
        build(v+1, l, m);
        build(v+2*(m-l), m, r);
        t[v] = min(t[v+2*(m-l)], t[v+1]);
    }
    int get_min(int v, int l, int r, int ql, int qr){
        if(qr <= l || r <= ql){
            return INT_MAX;}
        if(ql <= l && r <= qr){
            return t[v];}
        int m = l+r>>1;
        return min(get_min(v+1, l, m, ql, qr), get_min(v+2*(m-l), m, r, ql, qr));
    }
};
int smart(int n, int k, vector<int> v, int max_e){
    
    vector<int> p_sum(n+1), p_min(n+1, LONG_LONG_MAX);
    for(int i = 1; i < n+1; i++){
        p_sum[i]=p_sum[i-1]+v[i-1];
        p_min[i]=min(p_min[i-1], v[i-1]);
    }
    if(k == 3){
        return p_sum[n+1]- min(min(v[0] + v[n-1], v[0]+v[1]), v[n-1]+v[n-2]); 
    
    }
    seg tree(v);
    int ans = LONG_LONG_MIN;
    int c_min = LONG_LONG_MAX, real_min = LONG_LONG_MAX;
    k = n - k + 1;
    for(int i = 0; i <= n - k; i++){
        if(i!=0) c_min = min(c_min, v[i-1]);
        //cout << i <<": ";
        int s = max(p_sum[i+k] - p_sum[i], max_e);
        real_min = min(p_min[i], tree.get_min(0,0, n, i+k, n));
        //cout << s <<" "<<c_min<< p_min[i]<<" "<<real_min<<" "<< s - real_min << " "<<tree.get_min(0,0, n, i+k, n)<<endl;
        //cout << i <<" "<< i+k << " "<<n - k <<" "<<k<<endl;
        //cout <<i << " " << s  <<" "<< ( v[i] + v[i+1]+v[i+2])<<endl;
        ans = max(ans, s - real_min);
    }
    return ans;
}
int stupid(int n, int k, vector<int> v, int max_e){
    int ans = 0;
    for(int i = 0; i < n - k +1; i++){
        int s = 0;
        int m = INT_MAX;
        //cout  <<"=========="<<endl;
        for(int j = 0; j < i; j++) {
             //cout << 1 <<" "<<j<<endl;
            m = min(m, v[i]);}
        for(int j = i + k; i < n; i++) {
            ///cout << 2 <<" "<<j<<endl;
            m = min (m, v[i]);}
        for(int j = i; j < i + k; j++){
            //cout << 3 <<" "<<j<<endl;
             s+=v[i];}
        ans = max(s - m, ans);
    }
    return ans;
}
void stress(){
    for(int i = 0; i < 5; i++){
        if(i%100 == 0) cout << "I = "<<i<<endl;
        int n = 15;
        int k = 15 , max_e = INT_MIN;
        vector<int> v(n);
        for(int j = 0; j < n; j ++){
            v[j]=rand()%101;
            max_e = max(max_e, v[j]);
        }
        cout <<"========================"<<endl;
        for(int i : v){cout << i <<" ";}
        cout <<endl<<"========================"<<endl;
        cout << "smart = "<<smart(n, k, v, max_e) <<endl;

          
    }
}
signed main(){
    vector<int> v;
    int n, k;
    int max_e = INT_MIN;
    cin >> n >> k;
    v.resize(n);

    for(int & i: v){
        cin >> i;
        max_e = max(max_e, i);
    }
    //stress();
    cout << smart(n , k, v, max_e);
}