#include <bits/stdc++.h>

using namespace std;

using ll = long long;

constexpr int mod = 1'000'000'007;

int add(int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int bin_pow(int a, int x) {
    int res = 1;
    while (x) {
        if (x & 1) res = mul(res, a);
        a = mul(a, a);
        x >>= 1;
    }
    return res;
}

int inv(int a) {
    return bin_pow(a, mod - 2);
}

const int N = 101;
int a[N][N];
int dp[N][N][N];

void to_pref_sum(int j, int n) {
    for (int i = 1; i <= n; i++) {
        for (int ii = 1; ii <= n; ii++) {
            dp[j][i][ii] = add(dp[j][i][ii], add(dp[j][i - 1][ii], sub(dp[j][i][ii - 1], dp[j][i - 1][ii - 1])));
        }
    }
}

int get(int j, int lx, int rx, int ly, int ry) {
    return add(dp[j][rx][ry], sub(dp[j][lx - 1][ly - 1], add(dp[j][lx - 1][ry], dp[j][rx][ly - 1])));
}

int32_t main() {
    int n, m, k;
    cin >> n >> m >> k;
    int mx = 2;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y; y--;
        a[x][y] = 1;
        if (!y) {
            mx = max(x, mx);
        }
    }
    a[1][1] = 1;
    a[2][0] = 1;
    a[n][m - 2] = 1;
    a[n - 1][m - 1] = 1;
    {
        for (int i = mx; i <= n; i++) {
            dp[0][1][i] = 2;
        }
    }
    for (int j = 1; j < m; j++) {
        to_pref_sum(j - 1, n);
        int mx = 1, mn = n;
        for (int i = 1; i <= n; i++) {
            if (a[i][j]) {
                mx = max(mx, i);
                mn = min(mn, i);
            }
        }
        int bord = n;
        for (int i = n; i >= 1; i--) {
            for (int ii = max(i + 1, mx); ii <= n; ii++) {
                dp[j][i][ii] = get(j - 1, 1, min(mn, i), i + 1, min(bord, ii));
            }
            if (a[i][j]) {
                bord = i;
            }
        }
        // for (int i = 1; i <= n; i++) {
        //     for (int ii = 1; ii <= n; ii++) {
        //         cout << dp[j - 1][i][ii] << ' ';
        //     }
        //     cout << '\n';
        // }
        // cout << '\n';
        // for (int i = 1; i <= n; i++) {
        //     for (int ii = 1; ii <= n; ii++) {
        //         cout << dp[j][i][ii] << ' ';
        //     }
        //     cout << '\n';
        // }
        // cout << '\n';
    }
    cout << dp[m - 1][n - 1][n] << '\n';
}