﻿#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vi vector<int>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)


int sum(vi::iterator beg, vi :: iterator en) {
	int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
	return ans;
}

void print(vi a) {
	for (int i : a) cout << i << ' ';
	cout << '\n';
}

vi stupid(int n, vi a, vi kk) {
	vi ans;
	vi seg(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	for (int k : kk) {
		int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;
		for (int i = l2; i < n; i++) seg[i]--;
		int mx1 = *max_element(a.begin() + l1, a.begin() + r1 + 1);
		int mx2 = *max_element(a.begin() + l2, a.begin() + r2 + 1);
		for (int i = l2; i <= r2; i++) {
			imax(pr[i + 1], mx1);
		}
		for (int i = l1; i <= r1; i++) {
			imax(suf[i], mx2);
		}
		for (int i = l1; i <= r2; i++) {
			val[i] = min(suf[i], pr[i + 1]);
		}

		ans.push_back(sum(val.begin() + l1, val.begin() + r2) - sum(a.begin() + l1, a.begin() + r2));
	}
	return ans;
}

vi solve(int n, vi a, vi kk) {
	vi ans;
	vi seg(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	auto print_val = [&] {
		for (int i = 0; i < n; i++) {
			cout << val[i] - a[i] << ' ';
		}
		cout << '\n';
	};
	for (int k : kk) {
		int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;
		for (int i = l2; i < n; i++) seg[i]--; 
		int mx2 = *max_element(a.begin() + l2, a.begin() + r2 + 1);
		int mx1 = *max_element(a.begin() + l1, a.begin() + r1 + 1);
		for (int i = r1; i >= l1; i--) {
			if (suf[i] <= mx2 && pr[i + 1] >= mx2) {
				val[i] = mx2;
			}
			else break;
		}
		for (int i = r1; i >= l1; i--) {
			if (suf[i] <= mx2) suf[i] = mx2;
			else break;
		}
		for (int i = l2; i <= r2; i++) {
			if (suf[i] >= mx1 && pr[i + 1] <= mx1) {
				val[i] = mx1;
			}
			else break;
		}
		for (int i = l2; i <= r2; i++) {
			if (pr[i + 1] <= mx1) {
				pr[i + 1] = mx1;
			}
			else break;
		}
	//	print_val();
		//print(val);
	//	print(suf);
	//	print(pr);
	//	print(seg);
		//cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << '\n';
		
		//cout << '\n';

		ans.push_back(sum(val.begin() + l1, val.begin() + r2) - sum(a.begin() + l1, a.begin() + r2));
	}

	return ans;
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vi a(n); for (auto& e : a) cin >> e;
	vi k(n - 1); for (auto& e : k) cin >> e, e--;
	vi ans = solve(n, a, k);
	if (n <= 1000) {
		ans = stupid(n, a, k);
	}
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << '\n';
	}
}
