﻿#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vi vector<int>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)


int sum(vi::iterator beg, vi :: iterator en) {
	int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
	return ans;
}

void print(vi a) {
	for (int i : a) cout << i << ' ';
	cout << '\n';
}

struct Info {
	int x;
	int push = 0;
	Info() {}
};

const int inf = 1e16;

vi seg;
vec<Info> tree;
void push(int v) {
	if (tree[v].push != 0) {
		tree[v].x += tree[v].push;
		if ((v << 1) < tree.size()) tree[v << 1].push += tree[v].push;
		if ((v << 1 | 1) < tree.size()) tree[v << 1 | 1].push += tree[v].push;
		tree[v].push = 0;
	}
}
void build(int v, int l, int r) {
	if (l + 1 >= r) {
		tree[v].x = seg[l];
		return;
	}
	int m = (r + l) >> 1;
	build(v << 1, l, m);
	build(v << 1 | 1, m, r);
	tree[v].x = min(tree[v << 1].x, tree[v << 1 | 1].x);
}

void upd(int v, int l, int r, int ql, int qr, int pl) {
	push(v);
	if (l >= qr || ql >= r) return;
	if (l >= ql && r <= qr) {
		tree[v].push += pl;
		push(v);
		return;
	}
	int m = (r + l) >> 1;
	upd(v << 1, l, m, ql, qr, pl);
	upd(v << 1 | 1, m, r, ql, qr, pl);
	tree[v].x = min(tree[v << 1].x, tree[v << 1 | 1].x);
}

int get(int v, int l, int r, int i) {
	push(v);
	if (l > i || r <= i) return inf;
	if (l + 1 >= r) {
		return tree[v].x;
	}
	int m = (r + l) >> 1;
	return min(get(v << 1, l, m, i), get(v << 1 | 1, m, r, i));
}

vi stupid(int n, vi a, vi kk) {
	vi ans;
	seg.resize(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	for (int k : kk) {
		int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;
		for (int i = l2; i < n; i++) seg[i]--;
		int mx1 = *max_element(a.begin() + l1, a.begin() + r1 + 1);
		int mx2 = *max_element(a.begin() + l2, a.begin() + r2 + 1);
		for (int i = l2; i <= r2; i++) {
			imax(pr[i + 1], mx1);
		}
		for (int i = l1; i <= r1; i++) {
			imax(suf[i], mx2);
		}
		for (int i = l1; i <= r2; i++) {
			val[i] = min(suf[i], pr[i + 1]);
		}

		ans.push_back(sum(val.begin() + l1, val.begin() + r2) - sum(a.begin() + l1, a.begin() + r2));
	}
	return ans;
}
vi stupid2(int n, vi a, vi kk) {
	vi ans;
	seg.resize(n + 1, inf); for (int i = 0; i < n; i++) seg[i] = i;
	tree.resize((n + 1) * 4);
	build(1, 0, n + 1);
	
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	auto printseg = [&]() {
		for (int i = 0; i < n; i++) {
			cout << get(1, 0, n + 1, i) << ' ';
		}
		cout << '\n';
		};
	for (int k : kk) {
		/*int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;*/
		int l1 = 0;
		int r1 = n;
		while (l1 < r1) {
			int m = (r1 + l1) / 2;
			if (get(1, 0, n + 1, m) >= k) r1 = m;
			else l1 = m + 1;
		}
		int ll1 = 0;
		int rr1 = n;
		while (ll1 < rr1) {
			int m = (rr1 + ll1) / 2;
			if (get(1, 0, n + 1, m) >= k + 1) rr1 = m;
			else ll1 = m + 1;
		}
		r1 = ll1 - 1;
		int l2 = ll1;
		int lll1 = 0;
		int rrr1 = n;
		while (lll1 < rrr1) {
			int m = (rrr1 + lll1) / 2;
			if (get(1, 0, n + 1, m) >= k + 2) rrr1 = m;
			else lll1 = m + 1;
		}
		int r2 = lll1 - 1;
		//for (int i = l2; i < n; i++) seg[i]--;
		upd(1, 0, n + 1, l2, n, -1);
		int mx1 = *max_element(a.begin() + l1, a.begin() + r1 + 1);
		int mx2 = *max_element(a.begin() + l2, a.begin() + r2 + 1);
		for (int i = l2; i <= r2; i++) {
			imax(pr[i + 1], mx1);
		}
		for (int i = l1; i <= r1; i++) {
			imax(suf[i], mx2);
		}
		for (int i = l1; i <= r2; i++) {
			val[i] = min(suf[i], pr[i + 1]);
		}
		//cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << '\n';
		//printseg();
		//cout << '\n';

		ans.push_back(sum(val.begin() + l1, val.begin() + r2) - sum(a.begin() + l1, a.begin() + r2));
	}
	return ans;
}

vi stupid3(int n, vi a, vi kk) {
	vi ans;
	seg.resize(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	int r1 = 0;
	for (int k : kk) {
		int l1 = 0;
		r1++;
		int i = r1 + 1;


	}
	return ans;
}

vi solve(int n, vi a, vi kk) {
	vi ans;
	vi seg(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1); for (int i = 0; i < n; i++) pr[i + 1] = a[i];
	vi suf(n + 1); for (int i = 0; i < n; i++) suf[i] = a[i];
	vi val(n); for (int i = 0; i < n; i++) val[i] = a[i];
	auto print_val = [&] {
		for (int i = 0; i < n; i++) {
			cout << val[i] - a[i] << ' ';
		}
		cout << '\n';
	};
	for (int k : kk) {
		int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;
		for (int i = l2; i < n; i++) seg[i]--; 
		int mx2 = *max_element(a.begin() + l2, a.begin() + r2 + 1);
		int mx1 = *max_element(a.begin() + l1, a.begin() + r1 + 1);
		for (int i = r1; i >= l1; i--) {
			if (suf[i] <= mx2 && pr[i + 1] >= mx2) {
				val[i] = mx2;
			}
			else break;
		}
		for (int i = r1; i >= l1; i--) {
			if (suf[i] <= mx2) suf[i] = mx2;
			else break;
		}
		for (int i = l2; i <= r2; i++) {
			if (suf[i] >= mx1 && pr[i + 1] <= mx1) {
				val[i] = mx1;
			}
			else break;
		}
		for (int i = l2; i <= r2; i++) {
			if (pr[i + 1] <= mx1) {
				pr[i + 1] = mx1;
			}
			else break;
		}
	//	print_val();
		//print(val);
	//	print(suf);
	//	print(pr);
	//	print(seg);
		//cout << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << '\n';
		
		//cout << '\n';

		ans.push_back(sum(val.begin() + l1, val.begin() + r2) - sum(a.begin() + l1, a.begin() + r2));
	}

	return ans;
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vi a(n); for (auto& e : a) cin >> e;
	vi k(n - 1); for (auto& e : k) cin >> e, e--;
	vi ans;
	/*if (*max_element(all(k)) == 0) {
		ans = stupid3(n, a, k);
	}
	else {*/

		//if (*max_element(all(a)) <= 10) {
		ans = stupid2(n, a, k);
		//}
		//if (n <= 1000) {
		//	ans = stupid(n, a, k);
		//}
	//}
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << '\n';
	}
}
