#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <algorithm>

using namespace std;

#define int long long

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> q(n, 1);
    for (int i = 1; i < n; i++) {
        cin >> q[i]; q[i]--;
    }
    
    // k_i == 1
    if (*min_element(q.begin(), q.end()) == 0 && *max_element(q.begin(), q.end()) == 0) {
        priority_queue<int> pq;
        pq.push(a[0]);
        int ans = 0, reserved = 0, l = 0;
        for (int i = 1; i < n; i++) {
            if (a[i] <= pq.top()) {
                reserved += a[i];
            } else {
                ans += min(a[l], a[i]) * (i - l) - a[l] - reserved;
                l = i;
                pq.push(a[i]);
            }
            cout << ans << '\n';
        }
        return;
    }

    // {l, r, mx, res}

    vector<vector<int>> v;      // {l, r}
    for (int i = 0; i < n; i++) {
        v.push_back({i, i});
    }
    for (int i = 0; i < n - 1; i++) {
        int k = q[i];
        vector<int> x = v[k];
        vector<int> y = v[k + 1];
        v.erase(v.begin() + k);
        v.erase(v.begin() + k);

        multiset<int> lp, rp;
        for (int j = x[0]; j <= y[1]; j++) {
            rp.insert(-a[j]);
        }
        int ans = 0;
        for (int j = x[0]; j <= y[1]; j++) {
            lp.insert(-a[j]);
            ans += min(-*(lp.begin()), -*(rp.begin())) - a[j];
            rp.erase(rp.find(-a[j]));
        }
        cout << ans << '\n';
        vector<int> curr = {x[0], y[1]};
        v.insert(v.begin() + k, curr);
    }
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}