#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    k = n - k + 1;
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    // сумма на отрезке [l, l + k - 1]
    // vector<int> precalc(n + 1);
    // int s = 0;
    // for (int i = 1; i <= k; i++) {
    //     s += a[i];
    // }
    // precalc[1] = s;
    // for (int i = k; i <= n; i++) {
    //     precalc[i - k + 2] = precalc[i - k + 1] + a[i]
    // }

    int mn = *min_element(a.begin() + 1, a.end());
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != mn) {
            continue;
        }
        int s = 0, mx = 0;
        for (int j = 1; j <= i - 1; j++) {
            if (j > k) {
                s -= a[j - k];
            }
            s += a[j];
            mx = max(mx, s);
        }
        ans = max(ans, mx - mn);

        s = 0, mx = 0;
        for (int j = i + 1; j <= n; j++) {
            if (j - i > k) {
                s -= a[j - k];
            }
            s += a[j];
            mx = max(mx, s);
        }
        ans = max(ans, mx - mn);
    }
    cout << ans;
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}