#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long

int n, k;

int get(vector<int>& aa) {
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + aa[i];
    }

    int ans = 0;

    set<int> stR;
    int s = 0;
    for (int i = 1; i <= n; i++) {
        s += aa[i];
        int mx;
        if (i <= k) {
            mx = pref[i - 1];
        } else {
            s -= aa[i - k];
            mx = -*stR.begin();
        }
        if (i >= k) {
            stR.insert(-s);
        }
        ans = max(ans, mx - aa[i]);
    }
    return ans;
}

void solve() {
    cin >> n >> k;
    k = n - k + 1;
    vector<int> aa(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> aa[i];
    }
    int ans1 = get(aa);
    aa.push_back(0);
    reverse(aa.begin(), aa.end());
    aa.pop_back();
    int ans2 = get(aa);
    cout << max(ans1, ans2);
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}