#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long

int n, k, kk;

void k2() {
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    k = n - k + 1;
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    int mn = *min_element(a.begin() + 1, a.end());
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != mn) {
            continue;
        }
        int r1 = i - 1, l1 = max(1ll, r1 - k + 1);
        int s1 = pref[r1] - pref[l1 - 1];
        ans = max(ans, s1 - mn);

        int l2 = i + 1, r2 = min(n, l2 + k - 1);
        int s2 = pref[r2] - pref[l2 - 1];
        ans = max(ans, s2 - mn);
    }
    cout << ans;
}

int get(vector<int>& aa) {
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + aa[i];
    }

    int ans = 0;

    set<int> stR;
    int s = 0;
    for (int i = 1; i <= n; i++) {
        s += aa[i];
        int mx;
        if (i <= kk) {
            mx = pref[i - 1];
        } else {
            s -= aa[i - kk];
            mx = -*stR.begin();
        }
        if (i >= kk) {
            stR.insert(-s);
        }
        ans = max(ans, mx - aa[i]);
    }
    return ans;
}

void solve() {
    cin >> n >> k;
    if (k == 2) {
        k2();
        return;
    }
    kk = n - k + 1;
    vector<int> aa(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> aa[i];
    }
    int ans1 = get(aa);
    aa.push_back(0);
    reverse(aa.begin(), aa.end());
    aa.pop_back();
    int ans2 = get(aa);
    cout << max(ans1, ans2);
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}