﻿#include <string>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

void solve() {
    int n, s;
    cin >> n >> s;
    if (n > s) {
        cout << "No";
        return;
    }
    vector <vector <int>> a(n);
    int summ = 0;
    bool flag = 1;
    for (int i = 0; i < n; i++) {
        int kol;
        cin >> kol;
        summ += kol;
        for (int j = 0; j < kol; j++) {
            int x;
            cin >> x;
            a[i].push_back(x);
            if (a[i][j] != 1) {
                flag = 0;
            }
        }
    }
    if (flag) {
        //cout << "hui";
        if (summ >= s) {
            cout << "Yes\n";
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                int dl = a[i].size();
                if (cnt + n - i - 1 + dl <= s) {
                    cout << dl << "\n";
                    for (int j = 0; j < dl; j++) {
                        cout << j + 1 << " ";
                    }
                    cnt += dl;
                }
                else {
                    int ost = s - cnt - (n - i - 1);
                    cout << ost << "\n";
                    for (int j = 0; j < ost; j++) {
                        cout << j + 1 << " ";
                    }
                    cnt += ost;
                }
                cout << "\n";
            }
            return;
        }
        cout << "No";
    }
    else if (n == 2) {
        vector<pair<pair<int, int>, int>> dp1(s + 1, { {-1, -1}, -1 }), dp2(s + 1, { {-1, -1}, -1 });
        dp1[0].second = 0;
        dp2[0].second = 0;
        for (int j = 0; j < a[0].size(); j++) {
            for (int cost = s - a[0][j]; cost >= 0; cost--) {
                if (dp1[cost].second != -1 && dp1[cost + a[0][j]].second == -1) {
                    dp1[cost + a[0][j]].second = cost;
                    dp1[cost + a[0][j]].first = { 0, j };
                }
            }
        }
        for (int j = 0; j < a[1].size(); j++) {
            for (int cost = s - a[1][j]; cost >= 0; cost--) {
                if (dp2[cost].second != -1 && dp2[cost + a[1][j]].second == -1) {
                    dp2[cost + a[1][j]].second = cost;
                    dp2[cost + a[1][j]].first = { 1, j };
                }
            }
        }
        for (int i = 1; i < s; i++) {
            if (dp1[i].second != -1 && dp2[s - i].second != -1) {
                cout << "Yes\n";
                vector <int> ans1, ans2;
                int cost = i;
                while (cost != 0) {
                    int j = dp1[cost].first.second;
                    ans1.push_back(j);
                    cost = dp1[cost].second;
                }
                cost = s - i;
                while (cost != 0) {
                    int j = dp2[cost].first.second;
                    ans2.push_back(j);
                    cost = dp2[cost].second;
                }
                cout << ans1.size() << "\n";
                for (auto j : ans1) {
                    cout << j + 1 << " ";
                }
                cout << "\n";
                cout << ans2.size() << "\n";
                for (auto j : ans2) {
                    cout << j + 1 << " ";
                }
                return;
            }
            
        }
        cout << "No";
    }
    else if (n == 1){
        vector<pair<pair<int, int>, int>> dp(s + 1, { {-1, -1}, -1 });
        dp[0].second = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < a[i].size(); j++) {
                for (int cost = s - a[i][j]; cost >= 0; cost--) {
                    if (dp[cost].second != -1 && dp[cost + a[i][j]].second == -1) {
                        dp[cost + a[i][j]].second = cost;
                        dp[cost + a[i][j]].first = { i, j };
                    }
                }
            }
        }
        if (dp[s].second == -1) {
            cout << "No";
        }
        else {
            cout << "Yes\n";
            vector<vector<int>> ans(n);
            int cost = s;
            while (cost != 0) {
                int i = dp[cost].first.first;
                int j = dp[cost].first.second;
                ans[i].push_back(j);
                cost = dp[cost].second;
            }
            for (int i = 0; i < n; i++) {
                cout << ans[i].size() << "\n";
                for (auto j : ans[i]) {
                    cout << j + 1 << " ";
                }
                cout << "\n";
            }
        }
    }
    else {
        vector<vector<pair<pair<int, int>, int>>> dp(n, vector<pair<pair<int, int>, int>>(s + 1, { {-1, -1}, -1 }));
    }
}

/*
5 11
2
1 1
3
1 1 1
5
1 1 1 1 1
1
1
1
1
*/
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
