﻿// ConsoleApplication2.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void ruk(vector<ll> a, ll s, vector<vector<ll>>&dp) {
    for (ll i = 0; i < a.size(); i++) {
        for (ll j = 0; j <= s; j++) {
            if (j != a[i]) {
                dp[i][j] = -1;
            }
            else {
                dp[i][j] = i;
            }
        }
    }
    for (ll j = 1; j < a.size(); j++) {
        for (ll i = 0; i <= s; i++) {
            if (i - a[j] > -1 && dp[j - 1][i - a[j]] != -1) {
                dp[j][i] = j;
            }
            else if (dp[j - 1][i] != -1) {
                dp[j][i] = dp[j - 1][i];
            }
        }
    }
}

int main()
{
    ll n, s, k, t, m;
    ll INF = 1e9;
    m = 0;
    cin >> n >> s;
    vector<vector<ll>> c(n);
    for (ll i = 0; i < n; i++) {
        cin >> k;
        for (ll j = 0; j < k; j++) {
            cin >> t;
            c[i].push_back(t);
        }
        m = max(m, k);
    }
    ll vans;
    vans = 0;
    if (m == 1) {
        for (ll i = 0; i < n; i++) {
            vans += c[i][0];
        }
        if (vans == s) {
            cout << "Yes"<< '\n';
            for (ll i = 0; i < n; i++) {
                cout << 1 << '\n' << 1 << '\n';
            }
        }
        else {
            cout << "No";
        }
        return 0;
    }
    vector<vector<ll>>dp(n, vector<ll>(s + 1, -1));
    vector<vector<vector<ll>>> dpp(n, vector<vector<ll>>(m, vector<ll>(s + 1)));
    for (ll i = 0; i < n; i++) {
        ruk(c[i], s, dpp[i]);
    }
    for (ll j = 0; j <= s; j++) {
        if (dpp[0][c[0].size() - 1][j] != -1) {
            dp[0][j] = j;
        }
    }
    for (ll i = 1; i < n; i++) {
        for (ll j = 0; j <= s; j++) {
            for (ll k = 0; k <= j; k++) {
                if (dpp[i][c[i].size() - 1][k] != -1) {
                    if (dp[i - 1][j - k] != -1) {
                        dp[i][j] = k;
                    }
                }
            }
        }
    }
    vector<vector<ll>> ans(n);
    ll an, as, an1, ss;
    an = dp[n - 1][s];
    ss = s;
    if (dp[n - 1][s] != -1) {
        cout << "Yes" << '\n';
        for (ll i = n - 1; i > -1; i--) {
            an1 = dp[i][ss];
            an = an1;
            as = dpp[i][c[i].size() - 1][an];
            ans[i].push_back(as);
            while (an != 0) {
                an -= c[i][as];
                if (an == 0) {
                    break;
                }
                as = dpp[i][as - 1][an];
                ans[i].push_back(as);
            }
            ss -= an1;
        }
        for (ll i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            for (ll j : ans[i]) {
                cout << j + 1<< " ";
            }
            cout << '\n';
        }
    }
    else {
        cout << "No";
    }
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
