#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n, s;
    cin >> n >> s;

    vector<vector<int>> tasks(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        tasks[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> tasks[i][j];
        }
    }

    bool found = false;

    for (int i = 0; i < (1 << n); i++) {
        int sum = 0;
        vector<vector<int>> chosen_tasks(n);
        for (int j = 0; j < n; j++) {
            if ((i >> j) & 1) {
                sum += tasks[j][0];
                chosen_tasks[j].push_back(1);
            }
        }

        if (sum == s) {
            found = true;
            cout << "Yes" << endl;
            for (int j = 0; j < n; j++) {
                cout << chosen_tasks[j].size() << " ";
                for (int k = 0; k < chosen_tasks[j].size(); k++) {
                    cout << chosen_tasks[j][k] << " ";
                }
                cout << endl;
            }
            break;
        }
    }

    if (!found) {
        cout << "No" << endl;
    }

    return 0;
}