#include <iostream>
#include <vector>
#define ff first
#define ss second
#define ls(v) (v << 1)
#define rs(v) (v << 1 | 1)

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

template<class T> using ord_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ord_mst = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using seg = ll;

// struct seg {
//     int l;
// };

struct sprs { // maximum
    vector<ll> a;
    sprs(vector<ll> &_a) {
        a = _a;
    }

    ll get(int l, int r) {
        ll mx = 0;
        for (int i = l; i < r; ++i)
            mx = max(mx, a[i]);
        return mx;
    }
};

int main() {
    int n;
    cin >> n;
    vector<ll> h(n);
    vector<int> q(n - 1);
    for (auto &i: h) cin >> i;
    for (auto &i: q) cin >> i;
    ord_set<seg> st;               // !!!!!!!!!!!!
    for (int i = 0; i <= n; ++i)
        st.insert(i);              // !!!!!!!!!!!!

    sprs tbl(h);

    int qq = 0;
    for (; qq < n - 1; ++qq) {
        int qi = q[qq];
        auto lft_it = st.find_by_order(qi - 1);
        auto rgh_it = st.find_by_order(qi);
        auto rrgh_it = st.find_by_order(qi + 1);
        int l = *lft_it, m = *rgh_it, r = *rrgh_it;
        st.erase(rgh_it);
        // cout << l << " " << r << "\n";
        ll ans = 0;
        for (int i = l; i < r; ++i) {
            ans += min(tbl.get(l, i + 1), tbl.get(i, r)) - h[i];
            // cout << i << ": " << tbl.get(l, i + 1) << " " << tbl.get(i, r) << " " << h[i] << "\n";
        }
        cout << ans << "\n";
        // break;
    }
}