#include <iostream>
#include <vector>

#define deb(x) cout << (#x) << ": " << x << "\n";

using namespace std;

using ll = long long;

int main() {
    const ll INF = 1e18;
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (auto &i: a) cin >> i;
    vector<ll> pr_mn(n), sf_mn(n);
    pr_mn[0] = a[0];
    for (int i = 1; i < n; ++i)
        pr_mn[i] = min(pr_mn[i - 1], a[i]);
    sf_mn[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i)
        sf_mn[i] = min(sf_mn[i + 1], a[i]);
    vector<ll> pr_sm(n + 1);
    for (int i = 0; i < n; ++i)
        pr_sm[i + 1] = pr_sm[i] + a[i];
    auto f = [&](int l, int r) {
        return pr_sm[r] - pr_sm[l];
    };

    ll ans = -INF;
    ll l = n - k + 1;
    // deb(l)
    for (int i = 0; i <= n - l; ++i) {
        ll mn = INF;
        if (i > 0) mn = min(mn, pr_mn[i - 1]);
        if (i < n - l) mn = min(mn, sf_mn[i + l]);
        ans = max(ans, f(i, i + l) - mn);
    }
    cout << ans << "\n";
}