#include <iostream>
#include <vector>
#include <map>

using namespace std;

using ll = long long;

vector<vector<ll>> w;
vector<int> k;
int n, s;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> s;
    w.resize(n);
    k.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> k[i];
        w[i].resize(k[i]);
        for (auto &j: w[i]) cin >> j;
    }
    if (n == 1) {
        map<ll, vector<int>> mp;
        for (int i = 0; i < k[0]; ++i) {
            map<ll, vector<int>> tmp;
            for (auto [j, vi]: mp)
                if (mp.find(j + w[0][i]) == mp.end()) {
                    tmp[j + w[0][i]] = mp[j];
                    tmp[j + w[0][i]].push_back(i);
                }
            for (auto [j, vi]: tmp)
                mp[j] = vi;
            if (mp.find(w[0][i]) == mp.end())
                mp[w[0][i]] = {i};
        }
        if (mp.find(s) != mp.end()) {
            cout << "Yes\n" << mp[s].size() << "\n";
            for (int i: mp[s])
                cout << i + 1 << " ";
            cout << "\n";
        } else {
            cout << "No\n";
        }
    }
}