//#define _GLIBCXX_DEBUG 1
//#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <cmath>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

void inittm(ll v, vector<ll>& t, ll l, ll r, vector<ll>& arr) {
    if (r == l) {
        t[v] = arr[l];
        return;
    }
    ll mid = (r + l) / 2;
    inittm(v * 2, t, l, mid, arr);
    inittm(v * 2 + 1, t, mid + 1, r, arr);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

ll gettm(ll v, vector<ll>& t, ll l, ll r, ll q, ll w) {
    if (q <= l && r <= w) {
        return t[v];
    }
    if (q > r || w < l) {
        return -2100000000;
    }
    ll mid = (r + l) / 2;
    return max(gettm(v * 2, t, l, mid, q, w), gettm(v * 2 + 1, t, mid + 1, r, q, w));
}
// m debugged

ll getindl(ll v, vector<ll>& t, ll l, ll r, ll num, ll a, ll b) {
	ll q = a - 1;
	ll w = b;
	ll mid;
	while (w - q > 1) {
		mid = (q + w) / 2;
		if (gettm(1, t, l, r, a, mid) >= num) {
			w = mid;
		} else {
			q = mid;
		}
	}
	return w;
	/*if (num > t[v]) return -1;
	ll mid = (r + l) / 2;
	if (num <= t[v * 2]) {
		return getindf(v * 2, t, l, mid, num, a, b);
	} else {
		return getindf(v * 2 + 1, t, mid + 1, r, num, a, b);
	}*/
}


ll getindr(ll v, vector<ll>& t, ll l, ll r, ll num, ll a, ll b) {
	ll q = a;
	ll w = b + 1;
	ll mid;
	while (w - q > 1) {
		mid = (q + w) / 2;
		if (gettm(1, t, l, r, mid, b) >= num) {
			q = mid;
		} else {
			w = mid;
		}
	}
	return q;
	/*if (num > t[v]) return -1;
	ll mid = (r + l) / 2;
	if (num <= t[v * 2 + 1]) {
		return getindl(v * 2 + 1, t, mid + 1, r, num, a, b);
	} else {
		return getindl(v * 2, t, l, mid, num, a, b);
	}*/
}

void initts(ll v, vector<pair<ll, ll>>& t, ll l, ll r, vector<ll>& arr) {
	if (r == l) {
		t[v].first = arr[l];
		t[v].second = 0;
		return;
	}
	ll mid = (r + l) / 2;
	initts(v * 2, t, l, mid, arr);
	initts(v * 2 + 1, t, mid + 1, r, arr);
	t[v].first = t[v * 2 + 1].first + t[v * 2].first;
}

void setts(ll v, vector<pair<ll, ll>>& t, ll l, ll r, ll a, ll b, ll num) {
	if (a <= l && r <= b) {
		t[v].first = num * (r - l + 1);
		t[v].second = num;
		return;
	}
	if (a > r || b < l) return;
	ll mid = (r + l) / 2;
	if (t[v].second != 0) {
		t[v * 2].first = t[v].second * (mid - l + 1);
		t[v * 2 + 1].first = t[v].second * (r - mid);
		t[v * 2].second = t[v].second;
		t[v * 2 + 1].second = t[v].second;
		t[v].second = 0;
	}
	setts(v * 2, t, l, mid, a, b, num);
	setts(v * 2 + 1, t, mid + 1, r, a, b, num);
	t[v].first = t[v * 2].first + t[v * 2 + 1].first;
}

ll getts(ll v, vector<pair<ll, ll>>& t, ll l, ll r, ll a, ll b) {
	if (a <= l && r <= b) {
		return t[v].first;
	}
	if (a > r || b < l) return 0;
	ll mid = (r + l) / 2;
	if (t[v].second != 0) {
		t[v * 2].first = t[v].second * (mid - l + 1);
		t[v * 2 + 1].first = t[v].second * (r - mid);
		t[v * 2].second = t[v].second;
		t[v * 2 + 1].second = t[v].second;
		t[v].second = 0;
	}
	return (getts(v * 2, t, l, mid, a, b) + getts(v * 2 + 1, t, mid + 1, r, a, b));
}

void solve() {
    tree<pair<ll, ll>, null_type, less<pair<ll, ll>>, rb_tree_tag, tree_order_statistics_node_update> blocks;// l, r, ans
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        blocks.insert({i, i});
    }
    vector<ll> arr(n);
    vector<ll> ps(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> arr[i];
        ps[i + 1] = ps[i] + arr[i];
    }
    ll _ = n - 1;
    vector<ll> t(n * 4 + 4, 0);
    vector<pair<ll, ll>> sumt(n * 4 + 4, {0, 0});
    initts(1, sumt, 0, n - 1, arr);
    inittm(1, t, 0, n - 1, arr);
    while (_--) {
        ll k;
        cin >> k;
        k--;
        pair<ll, ll> seg1 = *blocks.find_by_order(k);
        pair<ll, ll> seg2 = *blocks.find_by_order(k + 1);
        //cout << seg1.first << " " << seg1.second << "  ";
        //cout << seg2.first << " " << seg2.second << endl;
        blocks.erase(seg1);
        blocks.erase(seg2);
        blocks.insert(make_pair(seg1.first, seg2.second));
        ll mx1 = gettm(1, t, 0, n - 1, seg1.first, seg1.second);
        ll mx2 = gettm(1, t, 0, n - 1, seg2.first, seg2.second);
        //cout << mx1 << " " << mx2 << endl;
        if (mx1 < mx2) {
            ll indr = getindl(1, t, 0, n - 1, mx1, seg2.first, seg2.second);
            ll indl = getindr(1, t, 0, n - 1, mx1, seg1.first, seg1.second);
            if (indr > indl)
            setts(1, sumt, 0, n - 1, indl, indr - 1, mx1);
        } else {
            ll indl = getindr(1, t, 0, n - 1, mx2, seg1.first, seg1.second);
            ll indr = getindl(1, t, 0, n - 1, mx2, seg2.first, seg2.second);
            if (indr > indl)
            setts(1, sumt, 0, n - 1, indl + 1, indr, mx2);
        }
        /*for (int i = 0; i < n; ++i) {
            cout << getts(1, sumt, 0, n - 1, i, i) << " ";
        }
        cout << endl;*/
        cout << getts(1, sumt, 0, n - 1, seg1.first, seg2.second) - ps[seg2.second + 1] + ps[seg1.first] << "\n";
    }
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}

/*

5 2 0 0 1 1 3

4 2
0 1 1 2

5 3
2 1 2 3 2

8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1


//#define _GLIBCXX_DEBUG 1
//#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <cmath>
#include <random>

using namespace std;

mt19937 gen(553321);

ll fr(ll a, ll b) {
	return uniform_ll_distribution<ll>(a, b)(gen);
}

typedef long long ll;
typedef long double ld;

void solve() {
	ll k, n;
	cin >> n >> k;
	vector<ll> arr(n);
	for (ll i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	if (n * k <= 25) {
		ll ans = 0;
		vector<vector<ll>> vec(k, vector<ll>(n, 0));
		vector<vector<ll>> ps(k, vector<ll>(n, 0));
		for (ll i = (1 << (n * k)) - 1; i >= 0; --i) {
			ll cnt = 0;
			for (ll q = 0; q < k; ++q) {
				for (ll w = 0; w < n; ++w) {
					if (i & (1 << cnt)) {
						vec[q][w] = 1;
					} else {
						vec[q][w] = 0;
					}
					ps[q][w] = vec[q][w];
					if (q > 0) {
						ps[q][w] += ps[q - 1][w];
					}
					++cnt;
				}
			}
			bool flag = true;
			for (ll q = 0; q < n; ++q) {
				cnt = 0;
				for (ll w = q; w >= 0; --w) {
					if (k + w - q - 1 < 0) break;
					cnt += ps[k - q + w - 1][w];
				}
				if (cnt != arr[q]) {
					flag = false;
					break;
				}
			}
			if (flag) {
				ans++;
			}
		}
		cout << ans;
	}
	if (k < 3) {

		return;
	}
}

ll main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}


*/
