﻿/*#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast");*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

void initt(int v, vector<int>& t, int l, int r, vector<int>& arr) {
	if (l == r) {
		t[v] = arr[l];
		return;
	}
	int mid = (r + l) / 2;
	initt(v * 2, t, l, mid, arr);
	initt(v * 2 + 1, t, mid + 1, r, arr);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int gett(int v, vector<int>& t, int l, int r, int q, int w) {
	if (q <= l && r <= w) {
		return t[v];
	}
	if (q > r || w < l) {
		return 2100000000;
	}
	int mid = (r + l) / 2;
	return min(gett(v * 2, t, l, mid, q, w), gett(v * 2 + 1, t, mid + 1, r, q, w));
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	vector<ll> ps(n + 1, 0);
	for (int i = 1; i <= n; ++i) {
		ps[i] = ps[i - 1] + arr[i - 1];
	}
	if (k == n) {
		cout << 0;///////////////////////////////////////////////////////////////////////////
		return;
	}
	vector<int> t(n * 4 + 4, 2100000000);
	initt(1, t, 0, n - 1, arr);
	ll ans = 0;
	int sz = n - k + 1;
	for (int i = sz - 1; i < n; ++i) {
		ll sum = ps[i + 1] - ps[i - sz + 1];
		int mn = 2100000000;
		if (i >= sz)
			mn = min(mn, gett(1, t, 0, n - 1, 0, i - sz));
		if (i < n - 1) {
			mn = min(mn, gett(1, t, 0, n - 1, i + 1, n - 1));
		}
		ans = max(ans, sum - mn);
	}
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}

/*

5 4
2 1 3 4 1

*/