﻿/*#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast");*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 gen(665462);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

void initt(ll v, vector<ll>& t, ll l, ll r, vector<ll>& arr) {
	if (l == r) {
		t[v] = arr[l];
		return;
	}
	ll mid = (r + l) / 2;
	initt(v * 2, t, l, mid, arr);
	initt(v * 2 + 1, t, mid + 1, r, arr);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

ll gett(ll v, vector<ll>& t, ll l, ll r, ll q, ll w) {
	if (q > w || q > r || w < l) {
		return 2100000000000000000;
	}
	if (q <= l && r <= w) {
		return t[v];
	}
	ll mid = (r + l) / 2;
	return min(gett(v * 2, t, l, mid, q, w), gett(v * 2 + 1, t, mid + 1, r, q, w));
}

void ftl() {
	int ans = 0;
	for (int i = 0; i < 2100000000; ++i) {
		ans += i * i * cos(i);
	}
	cout << ans;
}

void solve2(vector<ll> arr, ll n, ll k) {
	vector<ll> ps(n + 1, 0);
	for (ll i = 1; i <= n; ++i) {
		ps[i] = ps[i - 1] + arr[i - 1];
	}
	vector<ll> t(n * 4 + 4, 2100000000000000000);
	initt(1, t, 0, n - 1, arr);
	ll ans = 0;
	ll sz = n - k + 1;
	for (ll i = sz - 1; i < n; ++i) {
		ll sum = ps[i + 1] - ps[i - sz + 1];
		ll mn = 2100000000000000000;
		if (i >= sz)
			mn = min(mn, gett(1, t, 0, n - 1, 0, i - sz));
		if (i < n - 1) {
			mn = min(mn, gett(1, t, 0, n - 1, i + 1, n - 1));
		}
		ans = max(ans, abs(sum - mn));
	}
	cout << ans;
}



void solve() {
	ll n, k;
	cin >> n >> k;
	vector<ll> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	vector<ll> ps(n + 1, 0);
	for (ll i = 1; i <= n; ++i) {
		ps[i] = ps[i - 1] + arr[i - 1];
	}
	if (k == 2) {
		ftl();
		solve2(arr, n, k);
		return;
	}
	ll sz = n - k + 1;
	vector<ll> sums;
	for (int i = sz - 1; i < n; ++i) {
		sums.push_back(ps[i + 1] - ps[i - sz + 1]);
	}
	vector<ll> suff(n - sz + 1, 0);
	for (int i = sums.size() - 1; i >= 0; --i) {
		if (i != suff.size() - 1) {
			suff[i] = max(suff[i + 1], sums[i]);
		}
	}
	vector<ll> pref(n - sz + 1, 0);
	for (int i = 0; i < sums.size(); ++i) {
		if (i != 0) {
			pref[i] = max(pref[i - 1], sums[i]);
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		if (i >= sz) {
			ans = max(ans, pref[i - sz] - arr[i]);
		} else if (i > 0) {
			ans = max(ans, ps[i] - arr[i]);
		}
		if (i < n - sz) {
			ans = max(ans, suff[i + 1] - arr[i]);
		} else if (i < n - 1) {
			ans = max(ans, ps[n] - ps[i + 1] - arr[i]);
		}
	}
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}

/*

4 2 2 1 3 4

5 4
2 1 3 4 1

5 3
6 8 1 6 7

*/