﻿/*#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast");*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937 gen(665462);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

void solve() {
	int n, s;
	cin >> n >> s;
	vector<vector<int>> arr(n);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		while (x--) {
			int t;
			cin >> t;
			arr[i].push_back(t);
		}
		//sort(arr[i].begin(), arr[i].end());
	}
	vector<vector<bool>> bp(n, vector<bool>(s + 1, false));
	vector<vector<pair<pair<int, int>, pair<int, int>>>> pred(n, vector<pair<pair<int, int>, pair<int, int>>>(s + 1, { {-1, -1}, {-1, -1} }));
	{
		int cnt = 0;
		bp[0][0] = true;
		for (int j : arr[0]) {
			for (int k = s - j; k >= 0; --k) {
				if (bp[0][k]) {
					bp[0][k + j] = true;
					pred[0][k + j] = { {0, k}, {0, cnt} };
				}
			}
			cnt++;
		}
		bp[0][0] = false;
		pred[0][0] = { {-1, -1}, {-1, -1} };
	}
	for (int i = 1; i < n; ++i) {
		int cnt = 0;
		for (int j : arr[i]) {
			for (int k = s - j; k >= 0; --k) {
				if (bp[i - 1][k]) {
					bp[i][k + j] = true;
					pred[i][k + j] = { {i - 1, k}, {i, cnt} };
				} else if (bp[i][k]) {
					bp[i][k + j] = true;
					pred[i][k + j] = { {i, k}, {i,cnt} };
				}
			}
			cnt++;
		}
	}
	if (bp[n - 1][s]) {
		cout << "Yes\n";
		pair<int, int> ind = { n - 1, s };
		vector<vector<int>> ans(n);
		while (pred[ind.first][ind.second].first.first != -1) {
			ans[pred[ind.first][ind.second].second.first].push_back(pred[ind.first][ind.second].second.second);
			ind = pred[ind.first][ind.second].first;
		}
		for (int i = 0; i < n; ++i) {
			cout << ans[i].size() << "\n";
			for (int j : ans[i]) {
				cout << j + 1 << " ";
			}
			cout << "\n";
		}
	} else {
		cout << "No";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		//cout << "\n";
	}
	return 0;
}

/*

2 4
1 2
2 3 1

2 4
1 2
2 2 1

2 4
1 2
2 1 1

*/