#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#define ll long long

using namespace std;

vector<ll> delit(ll x) {
    vector<ll> ans;
    for (int d = 1; d * d <= x; d++) {
        if (x % d == 0) {
            ans.push_back(d);
        }
    }
    return ans;
}

int main() {
    ll d, l, r;
    cin >> d >> l >> r;
    ll ans = 0;
    for(ll k : delit(d)) {
        // x - y = k, x + y = x / k
        if (d / k % 2 != k % 2) {
            continue;
        }
        // теоретически возможно переполнение
        ll x = (k + d / k) / 2;
        ll y = (d / k - k) / 2;
        ll xx = x * x;
        ll yy = y * y;
        if (l <= yy && xx <= r) {
            ans++;
        }
    }
    cout << ans;
    return 0;
}