#include <bits/stdc++.h>
#define int long long

using ll = long long;
using ld = long double;
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    vector<ll>pref_sum(n + 1), pref_min(n + 1), suf_min(n + 1);
    pref_sum[0] = 0;
    pref_min[0] = LONG_MAX;
    for(int i = 0; i < n ; ++i){
        pref_sum[i + 1] = pref_sum[i] + a[i];
        pref_min[i + 1] = min(pref_min[i], a[i]);
    }
    suf_min[n] = a[n - 1];
    for(int i = n - 1; i > 0; --i)
        suf_min[i] = min(suf_min[i + 1], a[i - 1]);

    int len = n - (k - 1);
    ll answer = 0;
    for(int i = 1; i < len; ++i)
        answer = max(answer, pref_sum[i] - suf_min[i + 1]);

    for(int i = 1; i < n - len + 1; ++i)
        answer = max(answer, (pref_sum[i + len - 1] - pref_sum[i - 1]) - min(pref_min[i - 1], suf_min[i + len]));

    for(int i = 1; i <= len; ++i)
        answer = max(answer, (pref_sum[n] - pref_sum[n - i]) - pref_min[n - i]);
    cout << answer;
}
