#include <iostream>
#include <vector>
#include <string>

using namespace std;
using ll = long long;

const int N = 1e5 + 5;

struct tres {
    ll a, b, c;
};

tres f(int idx, vector<int>& vec) { // 1, 2, 3 replaces
    if (idx == vec.size()-1) {
        tres res = { 0, 0, 0 };
        for (int i = vec[idx]; i < 9; i++)
            if (i == 3 || i == 5 || i == 7)
                res.a++;
        return res;
    }
    else {
        tres res = f(idx + 1, vec);
        for (int i = vec[idx]; i < 8; i+=2)
            if (i == 3 || i == 5 || i == 7) {
                res.a++;
                res.b++;
                res.c++;
            }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    string lstr, rstr;
    cin >> lstr >> rstr;
    int ls = lstr.size(), rs = rstr.size();
    vector <int> l(ls), r(rs);
    for (int i = 0; i < ls; i++)
        l[i] = lstr[i] - '0';
    for (int i = 0; i < rs; i++)
        r[i] = rstr[i] - '0';

    ll ans = 0;

    for (int i = ls; i <= rs; i++) {
        if (i == rs) {
            bool ok = true;
            int breakidx = -1;
            for (int j = 0; j < rs; j++) {
                if (r[j] == 0) {
                    ok = false;
                    breakidx = j;
                    break;
                }
                else if (r[j] > 1) {
                    break;
                }
            }
            if (!ok) {
                for (int k = 0; k < breakidx; k++) {
                    for (int j = 2; j < 8; j++)
                        if (j == 2 || j == 3 || j == 5 || j == 7)
                            ans++;
                }
            }
            else {
                for (int j = 0; j < rs; j++) {
                    for (int k = 2; k < 8; k++)
                        if (k == 2 || k == 3 || k == 5 || k == 7)
                            if (k <= r[j])
                                ans++;
                }
            }

            continue;
        }
        else if (i == ls) {
            bool ok = true;
            int breakidx = -1;
            for (int j = 0; j < ls; j++) {
                if (l[j] == 0) {
                    break;
                }
                else if (l[j] > 1) {
                    ok = false;
                    breakidx = j;
                    break;
                }
            }
            if (!ok) {
                for (int k = 2; k < 8; k++) {
                    if (k == 2 || k == 3 || k == 5 || k == 7) {
                        if (k >= l[breakidx])
                            ans += 1;
                    }
                }
                continue;
            }
        }

        ans += 1ll * i * 4;
    }

    cout << ans;

    return 0;
}
