#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;

/*int main()
{
    int n, k;
    cin >> n >> k;

    vector<int> b(n);
    for (int& i : b)
        cin >> i;



    return 0;
}*/

vector<ll> tree;
void build_tree(int v, int L, int R, vector<ll> a)
{
    if (L + 1 == R)
    {
        tree[v] = a[L];
        return;
    }
    int m = (L + R) / 2;
    build_tree(2 * v + 1, L, m, a);
    build_tree(2 * v + 2, m, R, a);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mx(int v, int l, int r, int L, int R)
{
    if (L >= l && R <= r)
        return tree[v];
    if (R <= l || L >= r)
        return 0;
    int m = (L + R) / 2;
    return max(mx(2 * v + 1, l, r, L, m), mx(2 * v + 2, l, r, m, R));
}

int main()
{
    int n;
    cin >> n;

    vector<ll> h(n);
    for (ll& i : h)
        cin >> i;

    ll nn = n;
    while (1 << __lg(n) != n)
    {
        n++;
        h.push_back(0);
    }

    tree.resize(2 * n, 0);
    build_tree(0, 0, n, h);

    vector<pair<int, int>> lr(nn);
    for (int i = 0; i < nn; i++)
        lr[i] = { i, i };

    nn--;
    while (nn--)
    {
        int x;
        cin >> x;

        lr[x - 1].second = lr[x].second;

        ll res = 0, v = 0;
        for (int i = lr[x - 1].first; i <= lr[x - 1].second; i++)
        {
            if (v - h[i] <= 0)
                v = min(mx(0, lr[x - 1].first, i + 1, 0, n), mx(0, i + 1, lr[x - 1].second + 1, 0, n));
            res += (v - h[i]) * ((v - h[i]) > 0);
        }
        lr.erase(lr.begin() + x);

        cout << res << '\n';
    }

    return 0;
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/

/*int solve(string l, string r, map<char, int> pr)
{
    int ans = 0;
    int lll = stoi(l), rrr = stoi(r);
    for (int i = lll; i <= rrr; i++)
    {
        string si = to_string(i);
        if (count(si.begin(), si.end(), '1') == si.size() - 1)
            for (char c : si)
                if (pr[c])
                    ans++;
    }
    return ans;
}

int main()
{
    string l, r;
    cin >> l >> r;

    map<char, int> pr;
    pr['2'] = 1;
    pr['3'] = 1;
    pr['5'] = 1;
    pr['7'] = 1;

    ll ans = 0;
    {
        int i = 0;
        for (; i < l.size(); i++)
            if (l[i] == '0')
            {
                for (; i < l.size(); i++)
                    l[i] = '1';
                break;
            }
    }
    {
        int i = 0;
        for (; i < r.size(); i++)
            if (r[i] == '0')
            {
                r.erase(r.begin());
                if (r.size() > l.size())
                    for (i = 0; i < l.size(); i++)
                    {
                        r[i] = '1';
                        ans += 4;
                    }
                break;
            }
    }

    if (l.size() < r.size())
    {
        int i = 0;
        for (; i < l.size(); i++)
            if (l[i] != '1')
            {
                if (pr[l[i]] && count(l.begin(), l.end(), '1') == l.size() - 1)
                    ans++;
                break;
            }
        if (i < l.size())
        {
            if (l[i] < '4')
                ans += 3;
            else if (l[i] < '6')
                ans += 2;
            else if (l[i] < '8')
                ans++;
            ans += i * 4;
            l[i]++;
            i++;
            for (int i = 0; i < l.size(); i++)
                l[i] = '1';
            l += '1';
        }
    }
   // cout << l << ' ' << r << ' ' << ans << '\n';

    while (l.size() < r.size())
    {
        ans += l.size() * 4;
        l += '1';
    }

    if (l.size() == r.size())
    {
        for (int i = 0; i < l.size(); i++)
            if (l[i] == r[i] && l[i] != '1')
            {
                if (pr[l[i]] && count(l.begin(), l.end(), '1') == l.size() - 1)
                    ans++;
                break;
            }
            else if (l[i] < r[i])
            {
                if (pr[l[i]] && count(l.begin(), l.end(), '1') == l.size() - 1)
                    ans++;
                ans += (l.size() - i) * 4;
                break;
            }
    }
    cout << ans;

    return 0;
}*/
