#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

ll d, l, r;
map<ll, int> bilo;

ll del(ll n)
{
    for (ll i = 2; i * i <= n; i++)
        if (!(n % 2))
            return i;
    return n;
}

vector<ll> dels(ll n)
{
    vector<ll> ans(1, 1);
    while (n > 1)
    {
        ans.push_back(del(n));
        n /= ans.back();
    }
    return ans;
}

vector<ll> z;
ll ans = 0;

void dfs(int v, ll a = 1)
{
    a *= z[v];
    bilo[a] = 1;
    if (!((d / a - a) % 2) && a * a >= l && (d / a) * (d / a) <= r && a < d / a)
        ans++;
    for (int i = 0; i < z.size(); i++)
        if (i != v && d / a > a && !bilo[a * z[i]])
            dfs(i, a);
}

int main()
{
    cin >> d >> l >> r;

    z = dels(d);

    for (int i = 0; i < z.size(); i++)
        dfs(i);

    cout << ans;

    return 0;
}
