#include <iostream>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;

ll d, l, r;
map<ll, int> bilo;

ll del(ll n)
{
    for (ll i = 2; i * i <= n; i++)
        if (!(n % i))
            return i;
    return n;
}

vector<ll> dels(ll n)
{
    vector<ll> ans(1, 1);
    while (n > 1)
    {
        ans.push_back(del(n));
        n /= ans.back();
    }
    return ans;
}

vector<ll> z;
ll ans = 0;

void dfs(int v, ll a = 1, map<int, int> bil = {})
{

    a *= z[v];
    if (bilo[a] || (d / a - a) <= 0)
        return;
    bil[v] = 1;
    bilo[a] = 1;
    if (!((d / a - a) % 2) && (d / a - a) / 2 * (d / a - a) / 2 >= l && ((d / a - a) / 2 + a) * ((d / a - a) / 2 + a) <= r && (d / a - a) / 2 > 0)
        ans++;
    for (int i = 0; i < z.size(); i++)
        if (!bil[i])
            dfs(i, a, bil);
}

ll solve()
{
    ll res = 0;
    for (ll i = 0; i * i <= r; i++)
        for (ll j = 0; j < i; j++)
            if (i * i - j * j == d && j * j >= l)
                res++;
    return res;
}

int main()
{
    cin >> d >> l >> r;

    /*for (int dd = 1; dd <= 100; dd++)
    {
    d = dd;
    bilo.clear();
    z.clear();
    ans = 0;
    ll zov = solve();*/
    z = dels(d);

    for (int i = 0; i < z.size(); i++)
        dfs(i);

    cout << ans;
   /* if (ans != zov)
        cout << d << ' ' << ans << ' ' << zov << '\n';
    }*/

    return 0;
}
