#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;

/*int n, s;
vector<vector<ll>> k;
void zov(int v = 0, ll sum = 0, vector<int> ans = {})
{
    ans.push_back(0);
    for (ll i : k[v])
    {
        if (v < k.size() - 1)
            zov(v + 1, sum + i);
        else
            if (sum + i == s)
            {

            }
    }
}

int main()
{
    cin >> n >> s;

    k.resize(n);
    for (vector<int>& i : k)
    {
        int c;
        cin >> c;

        i.resize(c);
        for (ll& j : i)
            cin >> j;
    }

    return 0;
}*/

ll n, k;
vector<ll> tree;
void build_tree(ll v, ll L, ll R, vector<ll> a)
{
    if (L + 1 == R)
    {
        tree[v] = a[L];
        return;
    }
    ll m = (L + R) / 2;
    build_tree(2 * v + 1, L, m, a);
    build_tree(2 * v + 2, m, R, a);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mx(ll v, ll l, ll r, ll L, ll R)
{
    if (L >= l && R <= r)
        return tree[v];
    if (L >= r || R <= l)
        return 0;
    ll m = (L + R) / 2;
    return max(mx(2 * v + 1, l, r, L, m), mx(2 * v + 2, l, r, m, R));
}

int main()
{
    cin >> n >> k;

    vector<ll> a(n);
    for (ll& i : a)
        cin >> i;

    if (k == 2)
    {
        ll sum = 0, ans = 0;
        for (ll i : a)
            sum += i;
        ll goida = 0;
        for (ll i = 0; i < n - 1; i++)
        {
            goida += a[i];
            ans = max(ans, abs(sum - 2 * goida));
        }
        cout << ans;
        return 0;
    }
    if (k == 3)
    {
        ll ans = 0;
        vector<ll> pref(n + 1, 0);
        for (ll i = 1; i <= n; i++)
            pref[i] = pref[i - 1] + a[i - 1];
        for (ll i = 1; i < n - 1; i++)
        {
            ll z = pref[i], o = pref[n] - pref[i + 1], v = a[i];
            ans = max(ans, max({ z, o, v }) - min({ z, o, v }));
        }
        ans = max(ans, pref[n] - a[n - 1] - a[0] - min(a[n - 1], a[0]));
        cout << ans;
        return 0;
    }

    ll nn = n;

    vector<ll> zov(nn, a[0]), svo(nn, a[nn - 1]);
    for (ll i = 1; i < nn; i++)
    {
        zov[i] = zov[i - 1] + a[i];
        svo[nn - i - 1] = svo[nn - i] + a[nn - i - 1];
        if (i > nn - k)
        {
            zov[i] -= a[i - nn + k - 1];
            svo[nn - i - 1] -= a[nn - i + nn - k];
        }
    }

    while (1 << __lg(n) != n)
    {
        n++;
        svo.push_back(0);
    }

    tree.resize(2 * n);
    build_tree(0, 0, n, svo);

    ll ans = 0, mxzov = 0, mxsvo = tree[0];
    for (ll i = 0; i < nn; i++)
    {
        if (i > 0 && zov[i - 1] > mxzov)
            mxzov = zov[i - 1];
        if (i == nn - 1)
            mxsvo = 0;
        else if (svo[i] == mxsvo)
            mxsvo = mx(0, i + 1, nn, 0, n);
        ans = max(ans, mxzov - a[i]);
        ans = max(ans, mxsvo - a[i]);
    }
    cout << ans;

    return 0;
}
