#include <iostream>
#include <stack>
#include <algorithm>
#define INF 1000000000

using namespace std;
stack<int> x, y, z;

void push(int v) {
   x.push(v);
   y.push(min(y.top(), v)); 
}

void pop() {
    if (z.size() == 1) {
        while (!x.empty()) {
            z.push(min(z.top(), x.top()));
            x.pop();
            y.pop();
        }
    }
    z.pop();
}

int get_min() {
    return min(y.top(), z.top());
}

int main() {
    int n, k;
    cin >> n >> k;
    k = n - k + 1;
    int a[n];
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    
    y.push(INF);
    z.push(INF);
    
    long long s = 0;
    for (int i = 0; i < k; ++i)
        s += a[i];
    for (int i = n; --i >= k; )
        push(a[i]);
    
    long long d = s - get_min();
    for (int i = 0; i < n - k; ++i) {
        s -= a[i];
        s += a[i + k];
        pop();
        push(a[i]);
        d = max(d, s - get_min());
    }

    cout << d;
    return 0;
}