#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, s;
    cin >> n >> s;
    vector<int> c[n];
    pair<int, int> d[s+1];
    d[0] = pair(n, 0);
    fill(d+1, d+s+1, pair(-1, 0));
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        c[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> c[i][j];
            for (int l = s; l >= c[i][j]; --l) {
                if (d[l-c[i][j]].first != -1)
                    d[l] = pair(i, j);
            }
        }
        for (int j = 0; j <= s; ++j)
            if (d[j].first != i)
                d[j] = pair(-1, 0);
    }
    if (d[s].first == -1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        vector<int> r[n];
        while (s) {
            int m, p;
            m = d[s].first;
            p = d[s].second;
            r[m].push_back(p);
            s -= c[m][p];
        }
        for (vector<int> &p : r) {
            cout << p.size() << "\n";
            for (int &e : p) {
                cout << e << " ";
            }
            cout << "\n";
        }
    }
}