                                                                                                                                  #include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>
#include <set>

using namespace std;

struct subtask
{
  int Index = 0;
  long long Points = 0;
};

vector<vector<subtask>> Tasks;
vector<set<subtask*>> Path;

long long CurPoints = 0;
int n;
long long s;

void search( int Task, int startSub )
{
  

  if (Task == n)
  {
    if (CurPoints == s && Path[n - 1].size() != 0)
    {
      cout << "Yes" << endl;
      
      for (auto tsk : Path)
      {
        cout << tsk.size() << endl;
        for (auto sub : tsk)
          cout << sub->Index + 1 << " ";
        cout << endl;
      }
      
      exit(0);
    }
    else
      return;
  }

  /**
  cout << "______________________________________" << endl;
  for (auto tsk : Path)
  {
    cout << tsk.size() << endl;
    for (auto sub : tsk)
      cout << sub->Index + 1 << " ";
    cout << endl;
  }
  cout << "--------------------------------------" << endl;
  /**/

  for (int i = startSub; i < Tasks[Task].size(); i++)
  {
    /*
    if (Path[Task].count(&(Tasks[Task][i])))
      continue;

    CurPoints += Tasks[Task][i].Points;
    Path[Task].insert(&(Tasks[Task][i]));

    search(Task + 1);
    for (int j = 0; j < Tasks[Task].size(); j++)
      search(Task);
    
    Path[Task].erase(&(Tasks[Task][i]));
    CurPoints -= Tasks[Task][i].Points;
    /**/
    CurPoints += Tasks[Task][i].Points;
    Path[Task].insert(&(Tasks[Task][i]));

    search(Task + 1, 0);
    for (int j = i + 1; j < Tasks[Task].size(); j++)
      search(Task, j);
    
    Path[Task].erase(&(Tasks[Task][i]));
    CurPoints -= Tasks[Task][i].Points;
  }
}

int main()
{
  cin >> n;
  cin >> s;
  
  for (int i = 0; i < n; i++)
  {
    int k;
    cin >> k;
    Tasks.push_back({});
    Path.push_back({});

    for (int j = 0; j < k; j++)
    {
      long long c;
      cin >> c;

      for (int a = Tasks[i].size(); a >= 0; a--)
      {
        if (Tasks[i].size() == 0 || a == 0 || c > Tasks[i][a - 1].Points)
        {
          Tasks[i].insert(Tasks[i].begin() + a, {j, c});
          break;
        }
      }
    }
  }
  
  search(0, 0);

  cout << "No";

  return 0;
}
