#include <iostream>
#include <cmath>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

ll bin_sqrt(ll x)
{
	ll l = 1, r = x;

	while (r >= l)
	{
		ll m = (l + r) / 2;

		if (m * m == x)
			return m;

		if (l == r)
			return m;

		if (m * m > x)
			r = m - 1;
		else if (m * m < x)
			l = m + 1;
	}
	return 0;
}

int main()
{
	ll l, r, d;

	cin >> d >> l >> r;

	l = ceil(sqrt(l));
	r = floor(sqrt(r));

	ll res = 0;

	for (ll y = l; y <= r; y++)
	{
		// ll x = bin_sqrt(d + y * y);
		ll x = sqrt(d + y * y);

		if (x > r)
			break;
		if (x * x - y * y == d)
			res++;
	}

	cout << res << endl;

	return 0;
}