#include <iostream>
#include <cmath>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

#define MAXN 400000
#define INF 1000000000000000

ll a[MAXN], mins[MAXN];

int main()
{
	ll n, k;

	cin >> n >> k;

	for (ll i = 0; i < n; i++)
		cin >> a[i];

	if (k == 2)
	{
		ll lsum = a[0], rsum = 0, dmax = -INF;

		for (int i = 1; i < n; i++)
			rsum += a[i];

		for (int i = 0; i < n - 1; i++)
		{
			if (abs(rsum - lsum) > dmax)
				dmax = abs(rsum - lsum);

			lsum += a[i + 1];
			rsum -= a[i + 1];
		}
		cout << dmax << endl;
	}
	else if (k >= 3)
	{
		// pre calculating minimums
		{
			ll minr = INF;
			for (ll i = n - 1; i >= 0; i--)
			{
				mins[i] = minr;
				if (a[i] < minr)
					minr = a[i];
			}
		}

		// moving block
		ll dmax = -INF;
		for (ll lmax = 1; lmax <= n - k + 1; lmax++)
		{
			ll minl = INF, minr = mins[lmax - 1];

			ll sum = 0;

			for (int i = 0; i < lmax; i++)
				sum += a[i];

			for (int i = 0; i <= n - lmax; i++)
			{
				// updating diff
				if (min(minl, minr) == INF)
					continue;
				if (sum - min(minl, minr) > dmax)
					dmax = sum - min(minl, minr);

				// moving values
				sum -= a[i];
				if (a[i] < minl)
					minl = a[i];
				sum += a[i + lmax];
				minr = mins[i + lmax];
			}
		}

		cout << dmax << endl;
	}
	return 0;
}