#include <iostream>
#include <cmath>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<ll>> table;
ll n, s;
vector<vector<ll>> sub_table;

bool found = false;

void g(ll prob, ll n, ll sum, ll sub_sum)
{
	if (found)
		return;
	if (n <= 0)
	{
		if (sub_sum > 0)
		{
			if (prob + 1 < table.size())
			{
				g(prob + 1, table[prob + 1].size(), sum, 0);
			}
			else if (sum == s)
				found = true;
		}
		return;
	}
	g(prob, n - 1, sum, sub_sum);
	if (found)
		return;
	sub_table[prob].push_back(n - 1);
	if (sum <= s)
	{
		g(prob, n - 1, sum + table[prob][n - 1], sub_sum + table[prob][n - 1]);
		if (found)
			return;
		sub_table[prob].pop_back();
	}
}

int main()
{
	cin >> n >> s;

	table.resize(n);
	sub_table.resize(n);

	for (int i = 0; i < n; i++)
	{
		ll k;

		cin >> k;
		table[i].resize(k);
		sub_table[i].reserve(k);

		for (int j = 0; j < k; j++)
			cin >> table[i][j];
	}

	g(0, table[0].size(), 0, 0);

	if (found)
	{
		cout << "Yes" << endl;

		for (int i = 0; i < table.size(); i++)
		{
			cout << sub_table[i].size() << endl;

			for (int j = 0; j < sub_table[i].size(); j++)
				cout << sub_table[i][j] + 1 << " ";
			cout << endl;
		}

	}
	else
		cout << "No" << endl;
	return 0;
}