#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;


int cnt_p = 4;
vector<int> p = { 2, 3, 5, 7 };


ll solve1(str x) { // 
	int n = (int)x.size();
	ll ans = 0;
	for (int k = 1; k < n; k++) {
		ans += (cnt_p * k);
	}

	int i;
	for (i = 0; i < n; i++) {
		if (x[i] == '0') return ans;
		if (x[i] != '1') break;
	}
	if (i == n) return ans;
	bool have0 = false;
	for (int j = i + 1; j < n; j++) {
		if (x[j] == '0') have0 = true;
	}
	bool ok = !have0;


	for (auto& j : p) {
		if (j < x[i] - '0') ans++;
		if (j == x[i] - '0') ans += ok;
	}

	ans += (cnt_p * (n - 1 - i));

	return ans;
}

ll solve2(str x) { //  
	int n = (int)x.size();
	ll ans = 0;
	for (int k = 1; k < n; k++) {
		ans += (cnt_p * k);
	}

	int i;
	for (i = 0; i < n; i++) {
		if (x[i] == '0') return ans;
		if (x[i] != '1') break;
	}
	if (i == n) return ans;
	bool ok = false;
	bool have0 = false;
	for (int j = i + 1; j < n; j++) {
		if (x[j] == '0') have0 = true;
		if (x[j] != '1') ok = true;
	}
	if (have0) ok = false;


	for (auto& j : p) {
		if (j < x[i] - '0') ans++;
		if (j == x[i] - '0') ans += ok;
	}

	ans += (cnt_p * (n - 1 - i));

	return ans;
}





signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	str l, r;
	cin >> l >> r;


	cout << solve1(r) - solve2(l);
}