#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;

//#define int ll


vector<ll> ps;

int get(int l, int r) {
	return ps[r] - ps[l];
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (auto& i : a) {
		cin >> i;
	}


	int len = n - k + 1;
	ps.resize(n + 1);
	ps[0] = 0;
	for (int i = 1; i <= n; i++) {
		ps[i] = ps[i - 1] + a[i - 1];
	}
	if (k == 2) {
		ll ans = 0;
		for (int i = 1; i < n; i++) {
			ll sm1 = ps[i], sm2 = ps[n] - ps[i];
			ans = max(ans, abs(sm1 - sm2));
		}
		cout << ans;
		exit(0);
	}
	vector<ll> x(n);
	for (int i = 0; i < n; i++) {
		int r = i + 1;
		int l = max(0, r - len);
		x[i] = get(l, r);
	}
	vector<ll> mx_x(n);
	mx_x[0] = x[0];
	for (int i = 1; i < n; i++) {
		mx_x[i] = max(mx_x[i - 1], x[i]);
	}

	vector<ll> y(n);
	for (int i = n - 1; i >= 0; i--) {
		int l = i;
		int r = min(n, l + len);
		y[i] = get(l, r);
	}
	vector<ll> mx_y(n);
	mx_y[n - 1] = y[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		mx_y[i] = max(mx_y[i + 1], y[i]);
	}


	ll ans = 0;
	for (int i = 0; i < n; i++) {
		if (i != 0) {
			ans = max(ans, mx_x[i - 1] - a[i]);
		}
		if (i != n - 1) {
			ans = max(ans, mx_y[i + 1] - a[i]);
		}
	}


	cout << ans;
}