#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;
using pii = pair<int, int>;

//#define int ll


const int MOD = 1e9 + 7;


struct i_j {
	int i, j;
};
vector<i_j> moves = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };


int n, m, k;
bool check(i_j x) {
	return (0 <= x.i && x.i < n) && (0 <= x.j && x.j < m);
}


vector<vector<int>> a;
int ans = 0;
vector<vector<bool>> vis;

void solve(i_j v, int cnt) {
	vis[v.i][v.j] = true;
	for (int j = 0; j < 4; j++) {
		i_j move = moves[j];
		if (!vis[n - 1][m - 1] && min(move.i, move.j) == -1) continue;
		if (vis[n - 1][m - 1] && max(move.i, move.j) == 1) continue;
		i_j u = { v.i + move.i, v.j + move.j };
		if (!check(u)) continue;
		if (u.i == 0 && u.j == 0) {
			if (cnt == k) ans++;
		}
		if (vis[u.i][u.j]) continue;
		vis[u.i][u.j] = true;
		solve(u, cnt + a[u.i][u.j]);
		vis[u.i][u.j] = false;
	}
}



signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	cin >> n >> m >> k;
	a.resize(n, vector<int>(m, 0));
	for (int _ = 0; _ < k; _++) {
		int i, j;
		cin >> i >> j;
		i--; j--;
		a[i][j] = 1;
	}


	vis.assign(n, vector<bool>(m, false));
	solve({ 0, 0 }, a[0][0]);


	cout << ans;
}