#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3,unrool-loops")
#pragma GCC target("avx2")
#define isz(x) (int(x.size()))
using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using vll = vector<ll>;
void solve();

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
ll ans =0;
int right_solve(int n, vector<int>& a, vector<int>& k) {
    vector<pair<int, int>> help(n);

    for (int i = 0; i < n; ++i) {
        help[i] = {i, i};
    }
    for (int i = 0; i + 1 < n; ++i) {
        ll obed = k[i];
        --obed;
        auto [l1, r1] = help[obed];
        auto [l2, r2] = help[obed + 1];
        pair<ll, ll> x = {l1, r2};
        help.erase(help.begin() + obed);
        help[obed] = x;
        // solve for current
        ll w = 0, mx = l1;
        for (int j = l1; j <= r2; ++j) {
            if (a[mx] < a[j]) mx = j;
        }
        // cout << "mx: " << mx << endl;
        ll cur = a[l1];
        for (int j = l1 + 1; j < mx; ++j) {
            if (cur > a[j]) w += (cur - a[j]);
            else cur = a[j];
        }
        cur = a[r2];
        for (int j = r2 - 1; j >= mx; --j) {
            if (cur > a[j]) w += (cur - a[j]);
            else cur = a[j];
            // cout << j << ' ' << w  << '\t' << cur << ' ' << a[j] << endl;
        }
        cout << w << '\n';
    }
    return 0;
}
bool p4 = 1;
const int maxn = 1e5 + 5;
ll fenw[maxn];
// in 1-index
void add(int index, ll val) {
    for (; index < maxn; index += (index & -index)) {
        fenw[index] += val;
    }
}

ll sum(int r) {
    ll res =0;
    for (; r > 0; r -= (r & -r)) {
        res += fenw[r];
    }
    return res;
}

ll sum (int l ,int r) {
    return sum(r) - sum(l - 1);
}
void solve() {
    int n;
    cin >> n;
    vector<int> a(n), k(n - 1);
    for (auto& el : a) cin >> el;
    for (int i = 0; i < n; ++i) add(i + 1, a[i]);
    for (auto& el : k) cin >> el;
    int mn = 0;
    for (int i = 0; i < n; ++i) {
        if (a[mn] > a[i]) mn = i;
    }
    for (int i = 1; i < mn; ++i) {
        p4 &= (a[i] <= a[i - 1]);
    }
    for (int i = n - 1; i > mn; --i) {
        p4 &= (a[i] >= a[i - 1]);
    }
    // cout << p4 << endl;
    if (p4) {
        ordered_set m;
        for (int i = 0; i < n; ++i) m.insert({i, i});
        // cout << "here" << endl;
        for (int i = 0; i < n - 1; ++i) {
            int cur = k[i];
            auto [l1, r1] = *m.find_by_order(cur - 1);
            auto [l2, r2] = *m.find_by_order(cur);
            // cout << l1 << r2 << endl;
            if (a[l1] >= a[r2]) {
                cout << max(0LL, a[r2] * (r2 - l1) - sum(l1 + 2, r2 + 1)) << '\n';
            } else {
                cout << max(0LL, a[l1] * (r2 - l1) - sum(l1 + 1, r2)) << '\n';
            }
            m.erase({l1, r1}); m.erase({l2, r2});m.insert({l1, r2});
        }
    } else {
        right_solve(n, a, k);
    }
}
