#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3,unrool-loops")
#pragma GCC target("avx2")
#define isz(x) (int(x.size()))
using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using vll = vector<ll>;
void solve();

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (auto& el : a) cin >> el;
    vector<ll> pref_sums(n + 1), pref_min(n + 1), suff_min(n + 1);
    pref_min[0] = 1e18;
    pref_sums[0] = 0;
    for (int i = 0; i < n; ++i) {
        pref_sums[i + 1] = pref_sums[i] + a[i];
        pref_min[i + 1] = min(a[i], pref_min[i]);
    }
    suff_min[n] = 1e18;
    for (int i = n - 1; i >= 0; --i) {
        suff_min[i] = min(suff_min[i + 1], a[i]);
    }

    int len = n - k + 1;
    ll ans = 0;
    int min_index = 0;
    for (int i = 0; i< n; ++i) {
        if (a[min_index] > a[i]) min_index = i;
    }
    for (int i = len; i <= n; ++i) {
        // zero index
        ll mn = min(pref_min[i - len], suff_min[i]);
        ll sum = pref_sums[i] - pref_sums[i - len];
        ans = max(ans, abs(sum - mn));
    }
    //cout << min_index << endl;
    int i = 1;
    while (i <= min_index) {
        ll mn = a[min_index];
        ll sum = pref_sums[i] - pref_sums[max(0, i - len)];
        ans = max(ans, abs(sum - mn));
        ++i;
    }
    ++i;
    while (i < n) {
        ll mn = a[min_index];
        ll sum = pref_sums[i + 1] - pref_sums[max(i - len + 1, min_index + 1)];
        ans = max(ans, abs(sum - mn));
        ++i;
    }
    cout << ans;
}
