#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3,unrool-loops")
#pragma GCC target("avx2")
#define isz(x) (int(x.size()))
using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using vll = vector<ll>;
void solve();

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}

int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, -1, 1};
int n, m, k;
multiset<pair<int, int>> z;

int rec(int x, int y, int moves, vector<vector<bool>> used, bool finish, int cnt) {
    if (2 * (n + m) - 4 - moves < x + y) return 0;
    if (moves == 2 * (n + m) - 4) {
        if (x == 0 && y == 0 && finish && cnt == isz(z)){
            return 1;
        }
        return 0;
    }
    int res = 0;
    for (int i = 0; i < 4; ++i) {
        int cx = x + dx[i], cy = y + dy[i];
        if (0 <= cx && cx < n && 0 <= cy && cy < m && !used[cx][cy]) {
            used[cx][cy] = 1;
            res += rec(cx, cy, moves+1, used, finish + (cx == n - 1 && cy == m-1), cnt + (z.find({cx, cy}) != z.end()));
            used[cx][cy] = 0;
        }
    }
    return res;
}

void solve() {
    cin >> n >> m >> k;
    vector<pair<int, int>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first, --a[i].second;
        z.insert({a[i]});
    }
    vector<vector<bool>> used(n, vector<bool>(m));
    cout << rec(0, 0, 0, used, false, 0);
}
