﻿//#include <iostream>
//#include <vector>
//#include <algorithm>
//
//#define int long long
//
//using namespace std;
//
//vector<int> a;
//vector<int> tree;
//
//void build(int v, int l, int r) {
//    if (r - l == 1) {
//        tree[v] = a[l];
//        return;
//    }
//    int mid = (r + l) / 2;
//    build(v * 2 + 1, l, mid);
//    build(v * 2 + 2, mid, r);
//    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
//}
//
//int get(int v, int l, int r, int tl, int tr) {
//    if (l >= tl && r <= tr) {
//        return tree[v];
//    }
//    if (r <= tl || l >= tr) {
//        return 1e9+1;
//    }
//    int mid = (r + l) / 2;
//    return min(get(v * 2 + 1, l, mid, tl, tr), get(v * 2 + 2, mid, r, tl, tr));
//}
//
//
//void solve() {
//    int n, s;
//    cin >> n >> s;
//    vector<int> p;
//    vector<int> subg_cnt(n);
//    int sub_n = 0;
//    for (int i = 0; i < n; i++) {
//        int k;
//        cin >> k;
//        sub_n += k;
//        subg_cnt.push_back(k);
//        for (int j = 0; j < k; j++) {
//            int a;
//            cin >> a;
//            p.push_back(a);
//        }
//    }
//
//    vector<vector<bool>> dp(sub_n+1, vector<bool>(s + 1, false));
//    for (int i = 0; i <= sub_n; i++) {
//        dp[i][0] = true;
//    }
//
//    for (int i = 1; i <= sub_n; i++) {
//        for (int j = 1; j <= s; j++) {
//            dp[i][j] = dp[i - 1][j];
//            if (p[i - 1] <= j) {
//                dp[i][j] = dp[i][j] || dp[i - 1][j - p[i - 1]];
//            }
//        }
//    }
//    for (vector<bool> line : dp) {
//        for (bool el : line) {
//            if (el) {
//                cout << 1 << ' ';
//            }
//            else {
//                cout << 0 << ' ';
//            }
//        }
//        cout << '\n';
//    }
//}
//
//signed main() {
//    int t = 1;
//    //cin >> t;
//    while (t--) {
//        solve();
//    }
//    return 0;
//}

#include <iostream>
#include <vector>
#include <algorithm>

#define int unsigned long long

using namespace std;

void solve() {
    int d, tl, tr;
    cin >> d >> tl >> tr;
    int ans = 0;
    for (int y = tl; y * y <= tr; y++) {
        int x_x = d + y * y;
        int l = 1, r = x_x, mid;
        if (x_x <= tr && x_x >= tl) {
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (mid * mid >= x_x) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            if (r * r == x_x) {
                ans++;
            }
        }
    }
    cout << ans;
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}