﻿#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

vector<int> a;
vector<int> tree;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    int mid = (r + l) / 2;
    build(v * 2 + 1, l, mid);
    build(v * 2 + 2, mid, r);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int l, int r, int tl, int tr) {
    if (l >= tl && r <= tr) {
        return tree[v];
    }
    if (r <= tl || l >= tr) {
        return 1e9+1;
    }
    int mid = (r + l) / 2;
    return min(get(v * 2 + 1, l, mid, tl, tr), get(v * 2 + 2, mid, r, tl, tr));
}


void solve() {
    int n, k;
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    //cout << "a: ";
    //for (int el : a) {
    //    cout << el << ' ';
    //}
    //cout << '\n';

    tree.resize(4 * n);
    build(0, 0, n);

    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    }

    //cout << "pref: ";
    //for (int el : pref) {
    //    cout << el << ' ';
    //}
    //cout << '\n';

    int ans = 0;
    int len = n - k + 1;
    //for (int len = 1; len <= n - k + 1; len++) {
    //    for (int i = len; i <= n; i++) {
    //        int cur_sum = pref[i] - pref[i - len];
    //        /*cout << i << " : cur_sum = " << cur_sum << '\n';*/
    //        ans = max(ans, cur_sum - min(get(0, 0, n, 0, i - len), get(0, 0, n, i, n)));
    //    }
    //}
    for (int i = len; i <= n; i++) {
        int cur_sum = pref[i] - pref[i - len];
        /*cout << i << " : cur_sum = " << cur_sum << '\n';*/
        ans = max(ans, cur_sum - min(get(0, 0, n, 0, i - len), get(0, 0, n, i, n)));
    }
    cout << ans << '\n';
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}