﻿#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> p;
    vector<int> subg_cnt(n);
    int sub_n = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        sub_n += k;
        subg_cnt.push_back(k);
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            p.push_back(a);
        }
    }

    vector<vector<bool>> dp(sub_n + 1, vector<bool>(s + 1, false));
    vector <vector<pair<int, int>>> prev(sub_n + 1, vector<pair<int, int>>(s + 1, { -1, -1 }));
    for (int i = 0; i <= sub_n; i++) {
        dp[i][0] = true;
    }

    for (int i = 1; i <= sub_n; i++) {
        for (int j = 1; j <= s; j++) {
            dp[i][j] = dp[i - 1][j];
            prev[i][j] = { i - 1, j };
            if (p[i - 1] <= j && dp[i - 1][j - p[i - 1]]) {
                dp[i][j] = dp[i - 1][j - p[i - 1]];
                prev[i][j] = { i - 1, j - p[i-1]};
            }
        }
    }
    if (!dp[sub_n][s]) {
        cout << "No" << '\n';
        return;
    }
    else {
        cout << "Yes" << '\n';
    }
    int i = sub_n, j = s;
    int ans_cnt = 0;
    vector<int> ans;
    while (i != 0 && j != 0) {
        if (prev[i][j].second != j) {
            ans_cnt++;
            ans.push_back(i);
        }
        pair<int, int> boba = prev[i][j];
        i = boba.first;
        j = boba.second;
    }
    cout << ans_cnt << '\n';
    for (int el : ans) {
        cout << el << '\n';
    }

    //for (vector<bool> line : dp) {
    //    for (bool el : line) {
    //        if (el) {
    //            cout << 1 << ' ';
    //        }
    //        else {
    //            cout << 0 << ' ';
    //        }
    //    }
    //    cout << '\n';
    //}
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}