﻿#include <iostream>
#include <vector>
#include <map>
using namespace std;

#define ll long long

const int mod = 1000000007;

signed main() {
    int n;
    cin >> n;
    int k;
    cin >> k;
    if (k == 1) {
        cout << 1 << "\n";
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<map<vector<int>, int>> a(n + 1);
    vector<int> base(k, 0);
    a[0][base] = 1;
    for (int i = 0; i < n; i++) {
        for (auto u : a[i]) {
            vector<int> vec = u.first;
            vector<int> newnew(k);
            int sum = 0;
            for (int i = 1; i < k; i++) {
                sum += vec[i];
            }
            int val = u.second;
            for (int mask = 0; mask < (1 << k); mask++) {
                vector<int> vec_mask(k);
                for (int i = 0; i < k; i++) {
                    if (mask & (1 << i)) {
                        vec_mask[i] = 1;
                    }
                }
                int cnt = 0;
                for (int i = 0; i < k; i++) {
                    cnt += vec_mask[i];
                }
                if (sum + cnt != b[i]) {
                    continue;
                }
                vec.push_back(0);
                for (int i = 0; i < k; i++) {
                    newnew[i] = vec[i + 1] + vec_mask[i];
                }
                vec.pop_back();
                a[i + 1][newnew] += a[i][vec];
                if (a[i + 1][newnew] >= mod) {
                    a[i + 1][newnew] -= mod;
                }
            }
        }
    }
    int ans = 0;
    for (auto u : a[n]) {
        ans += u.second;
        if (ans >= mod) {
            ans -= mod;
        }
    }
    cout << ans << "\n";
}
