﻿#include <iostream>
#include <bitset>
#include <vector>
#include <algorithm>
#include <math.h>
#include <unordered_set>
#include <map>
#include <set>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx")

using namespace std;
const int kv_sz = 101;

const int mod = 1000000007;

int dp[kv_sz][kv_sz][kv_sz];

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    unordered_set<int> arch;
    vector<int> x(k);
    vector<int> y(k);
    vector<vector<int>> diag(n + m);
    int dop_all = 0;
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--;
        y[i]--;
        if ((x[i] == n - 1) && (y[i] == m - 1)) {
            dop_all++;
            continue;
        }
        if ((x[i] == 0) && (y[i] == 0)) {
            dop_all++;
            continue;
        }
        arch.insert(1000 * x[i] + y[i]);
        diag[x[i] + y[i]].push_back(x[i]);
    }
    for (int i = 0; i < n + m; i++) {
        sort(diag[i].begin(), diag[i].end());
    }
    /*vector<int> uh_n(n, 0);
    vector<int> uh_m(m, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            if (x[j] == i) {
                uh_n[i] = max(uh_n[i], y[j]);
            }
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < k; j++) {
            if (y[j] == i) {
                uh_m[i] = max(uh_m[i], x[j]);
            }
        }
    }*/
    vector<int> pos(4);
    vector<int> ps(4);
    vector<vector<int>> move(4);
    move[0] = { 1, 0, 1, 0 };
    move[1] = { 0, 1, 0, 1 };
    move[2] = { 1, 0, 0, 1 };
    move[3] = { 0, 1, 1, 0 };
    dp[0][0][0] = 1;
    for (pos[0] = 0; pos[0] < n; pos[0]++) {
        for (pos[1] = 0; pos[1] < m; pos[1]++) {
            for (pos[2] = 0; pos[2] <= pos[0]; pos[2]++) {
                if (dp[pos[0]][pos[1]][pos[2]] == 0) {
                    continue;
                }
                pos[3] = pos[0] + pos[1] - pos[2];
                if (!((pos[3] >= 0) && (pos[3] < m))) {
                    continue;
                }
                for (auto vec : move) {
                    if (pos[0] + vec[0] == n) {
                        continue;
                    }
                    if (pos[1] + vec[1] == m) {
                        continue;
                    }
                    if (pos[2] + vec[2] == n) {
                        continue;
                    }
                    if (pos[3] + vec[3] == m) {
                        continue;
                    }
                    if ((pos[0] + vec[0] == pos[2] + vec[2]) && (pos[1] + vec[1] == pos[3] + vec[3])) {
                        continue;
                    }
                    if (diag[pos[0] + pos[1]].size() > 2) {
                        continue;
                    }
                    if (diag[pos[0] + pos[1]].size() == 2) {
                        if (arch.find(1000 * pos[0] + pos[1]) == arch.end()) {
                            continue;
                        }
                        if (arch.find(1000 * pos[2] + pos[3]) == arch.end()) {
                            continue;
                        }
                    }
                    if (diag[pos[0] + pos[1]].size() == 1) {
                        if ((arch.find(1000 * pos[0] + pos[1]) == arch.end()) && (arch.find(1000 * pos[2] + pos[3]) == arch.end())) {
                            continue;
                        }
                    }
                    dp[pos[0] + vec[0]][pos[1] + vec[1]][pos[2] + vec[2]] += dp[pos[0]][pos[1]][pos[2]];
                    if (dp[pos[0] + vec[0]][pos[1] + vec[1]][pos[2] + vec[2]] >= mod) {
                        dp[pos[0] + vec[0]][pos[1] + vec[1]][pos[2] + vec[2]] -= mod;
                    }
                }
            }
        }
    }
    cout << dp[n - 1][m - 2][n - 2] * 2 % mod << "\n";
}
