#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

const int mod = 1e9 + 7;

void add(int& a, int b) {
    a += b;
    if (a >= mod) a -= mod;
}

int sum(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}

int dp[201][8][7][6][5][4][3][2] = {};
int dp_sum[201][7][6][5][4][3][2] = {};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> b(n + 1);
    for (int i = 1; i <= n; i++) cin >> b[i];

    dp[0][0][0][0][0][0][0][0] = 1;
    dp_sum[0][0][0][0][0][0][0] = 1;

    auto max_cnt = [&](int c) {
        if (k < c) return 0;
        return k - c + 1;
    };

    int mx[7] = {};
    for (int i = 0; i < 7; i++) mx[i] = max_cnt(i + 1);

    int t[7];
    int i[7];

    for (int col = 1; col <= n; col++) {
        for (i[0] = 0; i[0] <= mx[0]; i[0]++) {
            for (i[1] = 0; i[1] <= mx[1]; i[1]++) {
                for (i[2] = 0; i[2] <= mx[2]; i[2]++) {
                    for (i[3] = 0; i[3] <= mx[3]; i[3]++) {
                        for (i[4] = 0; i[4] <= mx[4]; i[4]++) {
                            for (i[5] = 0; i[5] <= mx[5]; i[5]++) {
                                for (i[6] = 0; i[6] <= mx[6]; i[6]++) {
                                    if (accumulate(i, i + 7, 0) != b[col]) continue;

                                    for (int mask = 0; mask < (1 << k); mask++) {
                                        bool ok = true;
                                        for (int bit = 0; bit < 7; bit++) {
                                            t[bit] = i[bit] - ((mask >> bit) & 1);
                                            if (t[bit] < 0) {
                                                ok = false;
                                            }
                                        }
                                        if (!ok || t[6] != 0) continue;

                                        add(dp[col][i[0]][i[1]][i[2]][i[3]][i[4]][i[5]][i[6]], dp_sum[col - 1][t[0]][t[1]][t[2]][t[3]][t[4]][t[5]]);
                                    }

                                    add(dp_sum[col][i[1]][i[2]][i[3]][i[4]][i[5]][i[6]], dp[col][i[0]][i[1]][i[2]][i[3]][i[4]][i[5]][i[6]]);
                                }
                            }
                        }
                    }
                }
            }
        }
    }


    int ans = 0;
    for (i[0] = 0; i[0] <= mx[0]; i[0]++) {
        for (i[1] = 0; i[1] <= mx[1]; i[1]++) {
            for (i[2] = 0; i[2] <= mx[2]; i[2]++) {
                for (i[3] = 0; i[3] <= mx[3]; i[3]++) {
                    for (i[4] = 0; i[4] <= mx[4]; i[4]++) {
                        for (i[5] = 0; i[5] <= mx[5]; i[5]++) {
                            for (i[6] = 0; i[6] <= mx[6]; i[6]++) {
                                add(ans, dp[n][i[0]][i[1]][i[2]][i[3]][i[4]][i[5]][i[6]]);
                            }
                        }
                    }
                }
            }
        }
    }
    cout << ans << '\n';
}
