#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<ll> a(n + 1), p(n + 1, 1e9), s(n + 2, 1e9);
    vector<ll> psum(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> a[i], psum[i] = a[i] + psum[i - 1];

    for (int i = 1; i <= n; i++) p[i] = min(a[i], p[i - 1]);
    for (int i = n; i >= 1; i--) s[i] = min(a[i], s[i + 1]);

    int l = n - (k - 1);

    ll ans = 0;
    for (int i = 1; i + l - 1 <= n; i++) ans = max(ans, (psum[i + l - 1] - psum[i - 1]) - min(p[i - 1], s[i + l]));
    cout << ans << '\n';
}
