#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

ll solve(vector<ll> a, int n, int k) {
    vector<ll> p(n + 1, 1e9), s(n + 2, 1e9), psum(n + 1, 0);

    for (int i = 1; i <= n; i++) psum[i] = a[i] + psum[i - 1];
    for (int i = 1; i <= n; i++) p[i] = min(a[i], p[i - 1]);
    for (int i = n; i >= 1; i--) s[i] = min(a[i], s[i + 1]);

    int l = n - (k - 1);
    vector<ll> best(n + 1, 0);
    for (int i = l; i <= n; i++) {
        best[i] = psum[i] - psum[i - l];
        best[i] = max(best[i], best[i - 1]);
    }


    ll res = 0;
    for (int mn = 1; mn <= n; mn++) {
        if (mn > 1 && 1 + (n - (mn - 1)) >= k) {
            res = max(res, psum[mn - 1] - a[mn]);
        }
        res = max(res, best[mn - 1] - a[mn]);
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];

    ll ans = solve(a, n, k);
    reverse(all(a));
    ans = max(ans, solve(a, n, k));

    cout << ans << '\n';
}
