#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 101010;
vector<int> c[MAXN];
vector<int> ans[MAXN];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, s;
    cin >> n >> s;

    vector<int> all_c = {-1};

    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        c[i].resize(k);
        cnt += k;
        for (int j = 0; j < k; j++) cin >> c[i][j], all_c.push_back(c[i][j]);
    }

    vector<vector<int>> dp(cnt + 1, vector<int>(s + 1, 0));
    vector<vector<array<int, 3>>> prv(cnt + 1, vector<array<int, 3>>(s + 1));

    dp[0][0] = 1;
    int cur = 0;
    for (int task = 1; task <= n; task++) {
        for (int id = 0; id < c[task].size(); id++, cur++) {
            dp[cur + 1] = dp[cur];
            prv[cur + 1] = prv[cur];

            int nv = c[task][id];
            for (int a = 0; a + nv <= s; a++) {
                if (dp[cur][a]) {
                    dp[cur + 1][a + nv] = 1;
                    prv[cur + 1][a + nv] = {cur + 1, task, id};
                }
            }
        }

        //for (int a = 0; a <= s; a++) cout << dp[cur][a] << " \n"[a == s];

        for (int a = 0; a <= s; a++) {
            if (dp[cur][a] && prv[cur][a][1] != task) {
                dp[cur][a] = 0;
            }
        }

        //for (int a = 0; a <= s; a++) cout << dp[cur][a] << " \n"[a == s];
    }

    if (dp[cnt][s] == 0) {
        cout << "No\n";
    } else {
        int now = s;
        int subtask = cnt;
        while (now) {
            auto [sub_id, task, real_id] = prv[subtask][now];
            ans[task].push_back(real_id);

            now -= all_c[sub_id];
            subtask = sub_id - 1;
        }

        cout << "Yes\n";
        for (int task = 1; task <= n; task++) {
            int m = ans[task].size();
            cout << m << '\n';
            for (int i = 0; i < m; i++) cout << ans[task][i] + 1 << " \n"[i + 1 == m];
        }
    }
}
