#include <bits.h>
#include <iostream>
#include <vector>
#include <random>
using namespace std;
using loh = long long;

loh checkMaxLeft(loh n, vector <loh> vc, vector <loh> prefSum, loh maxSz) {
    loh maxRazn = -1, maxSum = -1;
    vector <loh> minSuf(n + 1);
    minSuf[n] = vc[n];
    for (loh i = n-1; i >= 0; i--) {
        minSuf[i] = min(minSuf[i + 1], vc[i]);
    }
    for (loh i = 1; i < n; i++) {
        if (i >= maxSz) {
            maxSum = max(maxSum, prefSum[i] - prefSum[i - maxSz]);
            maxRazn = max(maxRazn, maxSum - minSuf[i + 1]);
        }
        else {
            maxSum = prefSum[i];
            maxRazn = max(maxRazn, maxSum - minSuf[i + 1]);
        }
    }
    return maxRazn;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    loh n, k; cin >> n >> k;
    vector <loh> vc(n + 1), prefSum(n + 1);
    loh maxsz = n - k + 1;
    for (loh i = 1; i <= n; i++) {
        cin >> vc[i];
        prefSum[i] = prefSum[i - 1] + vc[i];
    }
    if (k != 2) {
        loh first = checkMaxLeft(n, vc, prefSum, maxsz);
        vector <loh> vcReversed(n + 1);
        for (loh i = n; i >= 1; i--) {
            vcReversed[n - i + 1] = vc[i];
        }
        for (loh i = 1; i <= n; i++) {
            prefSum[i] = prefSum[i - 1] + vcReversed[i];
        }
        cout << max(first, checkMaxLeft(n, vcReversed, prefSum, maxsz));
    }
    else {
        loh otv = -1;
        for (loh i = 1; i < n; i++) {
            otv = max(otv, max(prefSum[n] - prefSum[i] - prefSum[i], prefSum[i] - (prefSum[n] - prefSum[i])));
        }
        cout << otv;
    }
}
