#include <bits/stdc++.h>
#define int long long

using namespace std;

int solve1(int n, int k, vector<int> arr){
    int a= 0, d= n;

    vector<int> pref(n + 1, 0);
    for(int i= 0; i < n; i++) pref[i + 1]= pref[i] + arr[i];

    int ans= 0;
    for(int b= 1; b < d; b++){
        for(int c= b + 1; c < d; c++){
            int s1= 0, s2= 0, s3= 0;
            s1= pref[b] - pref[a];
            s2= pref[c] - pref[b];
            s3= pref[d] - pref[c];

            int mx= max({s1, s2, s3});
            int mn= min({s1, s2, s3});

            ans= max(ans, mx - mn);
        }
    }

    return ans;
}

int solve2(int n, int k, vector<int> a){
    vector<int> mx_p(n + 1, -1), mx_s(n + 1, -1), pref(n + 1, 0);
    vector<int> mn_p(n + 1, 1e10), mn_s(n + 1, 1e10);
    for(int i= 0; i < n; i++) pref[i + 1]= pref[i] + a[i];

    mx_p[1]= a[0];
    for(int i= 2; i <= n; i++) mx_p[i]= max(a[i - 1], mx_p[i - 1]);

    mn_p[1]= a[0];
    for(int i= 2; i <= n; i++) mx_p[i]= min(a[i - 1], mx_p[i - 1]);

    mx_s[n - 1]= a[n - 1];
    for(int i= n - 2; i > -1; i--) mx_s[i]= max(a[i], mx_s[i + 1]);

    mn_s[n - 1]= a[n - 1];
    for(int i= n - 2; i > -1; i--) mn_s[i]= max(a[i], mn_s[i + 1]);

    int ans= 0;
    for(int i= 0; i < k; i++){
        int sum= pref[i + n + 1 - k] - pref[i];
        int mx_l= mx_p[i], mx_r= mx_s[i + n + 1 - k];
        int mn_l= mn_p[i], mn_r= mn_s[i + n + 1 - k];

        int mx_out= max(mx_l, mx_r);
        int mn_out= min(mn_l, mn_r);

        int mx= max({sum, mx_out});
        int mn= min({sum, mn_out});

        ans= max(ans, mx - mn);
    }

    return ans;
}

signed main(){
    while(0){
        mt19937 rnd(84365324);
        int n= rnd() % 10 + 3, k= 3;

        vector<int> a(n);
        for(auto &x: a) x= rnd() % 100;

        if(solve1(n, k, a) != solve2(n, k, a)){
            cout << n << " " << k << "\n";
            for(auto x: a) cout << x << " ";
            return 0;
        }
    }


    int n, k; cin >> n >> k;
    vector<int> a(n);
    for(auto &x: a) cin >> x;

    cout << solve1(n, k, a);
}

