from itertools import permutations


def main() -> None:
    delta, first, second = map(int, input().split())
    if first > second: first, second = second, first

    pairs = permutations((i for i in range(int(first ** 0.5), int(second ** 0.5) + 1)), 2)
    deltas = map(lambda p: (p[0] - p[1]) * (p[0] + p[1]), pairs)
    result = sum(map(lambda p: abs(p) == delta, deltas)) // 2
    print(result)


if __name__ == "__main__":
    main()