import itertools


def main() -> None:
    tasks_amount, needed_sum = map(int, input().split())
    tasks = {}
    for task_number in range(1, tasks_amount + 1):
        subtasks_amount = int(input())
        subtasks = list(map(int, input().split()))
        tasks[task_number] = subtasks

    subtasks_with_info = []
    for task_number, subtasks in tasks.items():
        subtasks_with_info.extend(zip([task_number] * len(subtasks), range(1, len(subtasks) + 1), subtasks))

    if sum(map(lambda p: p[2], subtasks_with_info)) < needed_sum:
        print("NO")
        return

    for subtasks_taked in range(tasks_amount, len(subtasks_with_info) + 1):
        permutations = itertools.permutations(subtasks_with_info, subtasks_taked)
        for permutation in permutations:
            task_numbers, subtasks_numbers, subtasks = zip(*permutation)

            if len(set(task_numbers)) != tasks_amount:
                continue

            if sum(subtasks) == needed_sum:
                print("YES")

                for task_number in sorted(set(task_numbers)):
                    subtasks = list(map(lambda x: x[1], filter(lambda x: x[0] == task_number, permutation)))
                    print(len(subtasks))
                    print(*sorted(subtasks))

                return

        print("NO")


if __name__ == "__main__":
    main()