﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

int add(int x, int y)
{
	if (x + y >= mod)
	{
		return x + y - mod;
	}
	return x + y;
}

void solve()
{
	int n, k;
	cin >> n >> k;
	vector <int> b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
	}

	int sz = ((int)1 << (k * (k - 1) / 2));
	int sz_old = ((int)1 << 22);

	vector <vector <int>> dp(n, vector <int>(sz, 0));

	vector <int> dp2(sz_old, 0);

	for (int i = 0; i < sz_old; i++)
	{
		int cnt = 0;
		int x = i;
		while (x > 0)
		{
			if (x % 2 == 1)
			{
				cnt++;
			}
			x /= 2;
		}
		dp2[i] = cnt;
	}

	vector <int> dp6(1 << sz);

	for (int i = 0; i < dp6.size(); i++)
	{
		int x = 0;
		int ind = 0;
		int tek_sz = k - 1;
		int ind2 = (k * (k - 1)) / 2 - k;
		for (int jj = 0; jj < k * (k - 1) / 2; jj++)
		{
			if (jj == ind)
			{
				x *= 2;
				if (i & ((int)1 << ((k - 1) * k / 2 - ind - 1)))
				{
					x++;
				}
				ind += tek_sz;
				tek_sz--;
			}
			else
			{
				ind2--;
			}
		}
		dp6[i] = x;
	}

	vector <int> dp7(1 << sz);

	for (int i = 0; i < dp7.size(); i++)
	{
		int x = 0;
		int ind = 0;
		int tek_sz = k - 1;
		int ind2 = (k * (k - 1)) / 2 - k;
		for (int jj = 0; jj < k * (k - 1) / 2; jj++)
		{
			if (jj == ind)
			{
				ind += tek_sz;
				tek_sz--;
			}
			else
			{
				x *= 2;
				if (i & ((int)1 << ((k - 1) * k / 2 - jj - 1)))
				{
					x++;
				}
				ind2--;
			}
		}
		dp7[i] = x;
	}

	vector <vector <vector <int>>> dp5(n, vector <vector <int>>(((int)1 << ((k - 2) * (k - 1) / 2)), vector <int>(k + 1, 0)));

	for (int i = 0; i < ((int)1 << k); i++)
	{
		if (dp2[i] == b[0])
		{
			dp[0][i / 2 * ((int)1 << ((k * (k - 1) / 2 - (k - 1))))]++;
			int ind = i / 2 * ((int)1 << ((k * (k - 1) / 2 - (k - 1))));
			dp5[0][dp7[ind]][dp2[dp6[ind]]] = add(dp5[0][dp7[ind]][dp2[dp6[ind]]], dp[0][ind]);
		}
	}

	for (int i = 1; i < n; i++)
	{
		for (int j = 0; j < sz; j++)
		{
			int cnt1 = dp2[j];
			if (cnt1 <= b[i])
			{
				dp[i][j] = add(dp[i][j], dp5[i - 1][j >> (k - 1)][b[i] - cnt1]);
				if (cnt1 + 1 <= b[i])
				{
					dp[i][j] = add(dp[i][j], dp5[i - 1][j >> (k - 1)][b[i] - cnt1 - 1]);
				}
			}
			dp5[i][dp7[j]][dp2[dp6[j]]] = add(dp5[i][dp7[j]][dp2[dp6[j]]], dp[i][j]);
		}
	}

	int ans = 0;
	for (int i = 0; i < sz; i++)
	{
		ans = add(ans, dp[n - 1][i]);
	}

	cout << ans << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
