﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

//#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

int cnk(int n, int k)
{
	int ans = 1;
	for (int i = 1; i <= n; i++)
	{
		ans *= i;
	}
	for (int i = 1; i <= k; i++)
	{
		ans /= i;
	}
	for (int i = 1; i <= k; i++)
	{
		ans /= i;
	}
	return ans;
}

int f(int n, int m)
{
	if (n == 0 || m == 0)
	{
		return 1;
	}
	return cnk(n + m - 2, n - 1);
}

void solve()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <bool>> visited(n, vector <bool>(m, false));

	vector <pair <int, int>> check(k);
	for (int i = 0; i < k; i++)
	{
		cin >> check[i].first >> check[i].second;
		check[i].first--;
		check[i].second--;
	}

	int ans = 0;
	for (int y1 = 0; y1 < m; y1++)
	{
		for (int y2 = y1 + 1; y2 < m; y2++)
		{
			vector <vector <bool>> used(n, vector <bool>(m, false));
			used[0][0] = true;
			for (int i = 0; i <= y1; i++)
			{
				used[1][i] = true;
			}
			for (int i = y1; i < m; i++)
			{
				used[2][i] = true;
			}

			for (int i = 0; i <= y2; i++)
			{
				used[0][i] = true;
			}
			for (int i = y2; i < m; i++)
			{
				used[1][i] = true;
			}

			bool flag = true;

			for (int ii = 0; ii < k; ii++)
			{
				if (!used[check[ii].first][check[ii].second])
				{
					flag = false;
				}
			}

			if (flag)
			{
				ans += 2;
			}
			/*
			if (y1 == 0 && y2 == 1)
			{
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						cout << used[i][j] << " ";
					}
					cout << '\n';
				}
				cout << '\n';
			}
			*/
		}
	}

	ans %= mod;
	cout << ans << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
