﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

//#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

void solve1(int n, int m, int k)
{
	vector <vector <bool>> visited(n, vector <bool>(m, false));

	vector <pair <int, int>> check(k);
	for (int i = 0; i < k; i++)
	{
		cin >> check[i].first >> check[i].second;
		check[i].first--;
		check[i].second--;
	}

	int ans = 0;
	for (int y1 = 0; y1 < m; y1++)
	{
		for (int y2 = y1 + 1; y2 < m; y2++)
		{
			vector <vector <bool>> used(n, vector <bool>(m, false));
			used[0][0] = true;
			for (int i = 0; i <= y1; i++)
			{
				used[1][i] = true;
			}
			for (int i = y1; i < m; i++)
			{
				used[2][i] = true;
			}

			for (int i = 0; i <= y2; i++)
			{
				used[0][i] = true;
			}
			for (int i = y2; i < m; i++)
			{
				used[1][i] = true;
			}

			bool flag = true;

			for (int ii = 0; ii < k; ii++)
			{
				if (!used[check[ii].first][check[ii].second])
				{
					flag = false;
				}
			}

			if (flag)
			{
				ans += 2;
			}
			/*
			if (y1 == 0 && y2 == 1)
			{
				for (int i = 0; i < n; i++)
				{
					for (int j = 0; j < m; j++)
					{
						cout << used[i][j] << " ";
					}
					cout << '\n';
				}
				cout << '\n';
			}
			*/
		}
	}

	ans %= mod;
	cout << ans << '\n';
}

void solve()
{
	int n, m, k;
	cin >> n >> m >> k;
	
	if (n == 3)
	{
		solve1(n, m, k);
		return;
	}

	vector <vector <bool>> visited(n, vector <bool>(m, false));

	vector <pair <int, int>> check(k);
	for (int i = 0; i < k; i++)
	{
		cin >> check[i].first >> check[i].second;
		check[i].first--;
		check[i].second--;
	}

	vector <vector <int>> g;
	for (int i = 0; i < (1 << (n + m - 2)); i++)
	{
		vector <int> a(n + m - 2, 0);
		int cnt = 0;
		for (int j = 0; j < n + m - 2; j++)
		{
			if (i & (1 << j))
			{
				cnt++;
				a[j] = 1;
			}
		}
		if (cnt == n - 1)
		{
			g.push_back(a);
		}
	}

	int ans1 = 0;
	int ans2 = 0;

	visited[0][0] = true;
	visited[n - 1][m - 1] = true;

	for (int i = 0; i < g.size(); i++)
	{
		vector <int> &a = g[i];

		int x = 0, y = 0;
		for (int ii = 0; ii < a.size() - 1; ii++)
		{
			if (a[ii] == 0)
			{
				y++;
			}
			else
			{
				x++;
			}

			visited[x][y] = true;
		}

		for (int j = i; j < g.size(); j++)
		{
			vector <int> &b = g[j];
			bool flag = true;

			int x = 0;
			int y = 0;

			vector <pair <int, int>> f;

			for (int ii = 0; ii < b.size() - 1; ii++)
			{
				if (b[ii] == 0)
				{
					y++;
				}
				else
				{
					x++;
				}

				if (visited[x][y])
				{
					flag = false;
					break;
				}
				visited[x][y] = true;
				f.push_back({ x, y });
			}

			for (int ii = 0; ii < k; ii++)
			{
				if (!visited[check[ii].first][check[ii].second])
				{
					flag = false;
					break;
				}
			}

			if (flag)
			{
				if (i == j)
				{
					ans2++;
					if (ans2 == mod)
					{
						ans2 = 0;
					}
				}
				else
				{
					ans1 += 2;
					if (ans1 >= mod)
					{
						ans1 -= mod;
					}
				}
			}

			for (auto [x, y] : f)
			{
				visited[x][y] = false;
			}
		}

		x = 0, y = 0;
		for (int ii = 0; ii < a.size() - 1; ii++)
		{
			if (a[ii] == 0)
			{
				y++;
			}
			else
			{
				x++;
			}

			visited[x][y] = false;
		}
	}
	int ans = ans1 + ans2;
	ans %= mod;
	cout << ans << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
