#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

int main(){
    ios::sync_with_stdio();
    cin.tie(0);
    ll n, s;
    cin >> n >> s;
    vector<ll> k(n);
    vector<vector<int>> v(n);
    bool flag = true;                 // podzadacha # 4
    for(int i = 0; i < n; ++i){
        cin >> k[i];
        if(k[i] != 1) flag = false;
        for(int j = 0; j < k[i]; ++j){
            ll x;
            cin >> x;
            v[i].push_back(x);              // v[i][j] - points pas la podgroupe j de probleme i
        }
    }
    if(flag){
        ll sum = 0;
        for(int i = 0; i < n; ++i){
            sum += v[i][0];
        }
        if(sum == s){
            cout << "Yes" << endl;
            for(int i = 0; i < n; ++i){
                cout << 1 << '\n' << 1 << '\n';
            }
        } else {
            cout << "No" << endl;
        }
        return 0;
    }
    if(n == 1){
        vector<vector<bool>> dp(k[0] + 1, vector<bool>(s + 1, true));    // dp[i][j] - on peut/pas avoir j points en utilisant que les premiers i pogdgroupes
        for(int i = 0; i <= k[0]; ++i){
            for(int j = 0; j <= s; ++j){
                if(i == 0 && j == 0) dp[i][j] = true;
                if(i == 0 && j > 0) dp[i][j] = false;
                if(i > 0 && v[0][i - 1] > j) dp[i][j] = dp[i - 1][j];
                if(i > 0 && v[0][i - 1] <= j && !dp[i - 1][j] && !dp[i - 1][j - v[0][i - 1]]) dp[i][j] = false;      // en debut tout est verite!!!
            }
        }
        /* for(int i = 0; i <= k[0]; ++i){
            cout << "i = " << i << '\n';
            for(int j = 0; j <= s; ++j){
                if(dp[i][j]){
                    cout << "t ";
                } else {
                    cout << "f ";
                }
            }
            cout << '\n';
        } */
        int num = -1;
        for(int i = 0; i <= k[0]; ++i){
            if(dp[i][s]){
                num = i;
                break;
            }
        }
        if(num != -1){
            cout << "Yes" << '\n';
            vector<int> ans;
            int j = s;
            while(num > 0){
                if(!dp[num - 1][j]){
                    ans.push_back(num);
                    j -= v[0][num - 1];
                }
                --num;
            }
            cout << ans.size() << '\n';
            sort(ans.begin(), ans.end());
            for(int i = 0; i < ans.size(); ++i){
                cout << ans[i] << " ";
            }
        } else {
            cout << "No" << '\n';
        }
        return 0;
    }
    if(n == 2){
        vector<vector<bool>> dp(k[0] + 1, vector<bool>(s + 1, true));            // dp[i][j] - on peut/pas avoir j points en utilisant que les premiers i pogdgroupes
        vector<vector<bool>> dpn(k[1], vector<bool>(s + 1, true));    //dpn - pareil
        for(int i = 0; i <= k[0]; ++i){
            for(int j = 0; j <= s; ++j){
                if(i == 0 && j == 0) dp[i][j] = true;
                if(i == 0 && j > 0) dp[i][j] = false;
                if(i > 0 && v[0][i - 1] > j) dp[i][j] = dp[i - 1][j];
                if(i > 0 && v[0][i - 1] <= j && !dp[i - 1][j] && !dp[i - 1][j - v[0][i - 1]]) dp[i][j] = false;      // en debut tout est verite!!!
            }
        }
        for(int i = 0; i < k[1]; ++i){
            for(int j = 0 ; j <= s; ++j){
                if(i == 0){
                    if(j == s){
                        if(v[1][i] >= j){      // j = s
                            dpn[i][j] = false;
                        } else {
                            dpn[i][j] = dp[k[0]][j - v[1][i]];
                        }
                    } else {
                        if(v[1][i] >= j){      // j = s
                            dpn[i][j] = dp[k[0]][j];
                        } else if(!dp[k[0]][j] && !dp[k[0]][j - v[1][i]]){
                            dpn[i][j] = false;
                        }
                    }
                } else {
                    if(v[1][i] >= j){
                        dpn[i][j] = dpn[i - 1][j];
                    } else if(!dpn[i - 1][j] && !dpn[i - 1][j - v[1][i]]){
                        dpn[i][j] = false;
                    }
                }
            }
        }
        int num = -1;
        for(int i = 0; i < k[1]; ++i){
            if(dpn[i][s]){
                num = i;
                break;
            }
        }
        if(num != -1){
            cout << "Yes" << '\n';
            vector<int> ans, ansn;
            int j = s;
            while(num > 0){
                if(!dpn[num - 1][j]){
                    ansn.push_back(num + 1);
                    j -= v[1][num];
                }
                --num;
            }
            num = k[0];
            if(j == s || !dp[k[0]][j]){
                j -= v[1][0];
                ansn.push_back(num + 1);
            }
            while(num > 0){
                if(!dp[num - 1][j]){
                    ans.push_back(num);
                    j -= v[0][num - 1];
                }
                --num;
            }
            cout << ans.size() << '\n';
            sort(ans.begin(), ans.end());
            for(int i = 0; i < ans.size(); ++i){
                cout << ans[i] << " ";
            }
            cout << '\n' << ansn.size() << '\n';
            sort(ansn.begin(), ansn.end());
            for(int i = 0; i < ansn.size(); ++i){
                cout << ansn[i] << " ";
            }
        } else {
            cout << "No" << endl;
        }
        cout << endl;
        return 0;
    }
    return 0;
}
