#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2,popcnt")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

const int mod = 1e9+7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    int sz = k * (k + 1) / 2, mask1 = (1 << (sz - k)) - 1;
    vector<int> in(sz + 1);
    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = k; j >= max(1, k - i); j--) s += j;
        if (v[i] > s) {
            cout << 0;
            return;
        }
        in[v[i]] = 1;
    }

if (k == 7) {
    int ans = 0;
    vector dp(2, vector(3, vector(4, vector(5, vector(6, vector(7, vector<int>(8)))))));
    auto ndp = dp;
    dp[0][0][0][0][0][0][0] = 1;
    for (int i = 0; i < n; i++) {
        for (int mask = 0; mask < (1 << 7); mask++) {
            for (int c1 = 0; c1 <= 1; c1++) {
                if (c1 != ((mask >> 0) & 1)) continue;
                for (int c2 = 0; c2 <= 2; c2++) {
                    if (c2 < ((mask >> 1) & 1)) continue;
                    for (int c3 = 0; c3 <= 3; c3++) {
                        if (c3 < ((mask >> 2) & 1)) continue;
                        for (int c4 = 0; c4 <= 4; c4++) {
                            if (c4 < ((mask >> 3) & 1)) continue;
                            for (int c5 = 0; c5 <= 5; c5++) {
                                if (c5 < ((mask >> 4) & 1)) continue;
                                for (int c6 = 0; c6 <= 6; c6++) {
                                    if (c6 < ((mask >> 5) & 1)) continue;
                                    for (int c7 = 0; c7 <= 7; c7++) {
                                        if (c1 + c2 + c3 + c4 + c5 + c6 + c7 != v[i]) continue;
                                        ndp[c1][c2][c3][c4][c5][c6][c7] += dp[c2 - ((mask >> 1) & 1)][c3 - ((mask >> 2) & 1)][c4 - ((mask >> 3) & 1)][c5 - ((mask >> 4) & 1)][c6 - ((mask >> 5) & 1)][c7 - ((mask >> 6) & 1)][c7];
                                        if (ndp[c1][c2][c3][c4][c5][c6][c7] >= mod) {
                                            ndp[c1][c2][c3][c4][c5][c6][c7] -= mod;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        if (i != n) {
            dp.swap(ndp);
            for (int c1 = 0; c1 <= 1; c1++) {
                for (int c2 = 0; c2 <= 2; c2++) {
                    for (int c3 = 0; c3 <= 3; c3++) {
                        for (int c4 = 0; c4 <= 4; c4++) {
                            for (int c5 = 0; c5 <= 5; c5++) {
                                for (int c6 = 0; c6 <= 6; c6++) {
                                    for (int c7 = 0; c7 <= 7; c7++) {
                                        ndp[c1][c2][c3][c4][c5][c6][c7] = 0;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } else {
            for (int c1 = 0; c1 <= 1; c1++) {
                for (int c2 = 0; c2 <= 2; c2++) {
                    for (int c3 = 0; c3 <= 3; c3++) {
                        for (int c4 = 0; c4 <= 4; c4++) {
                            for (int c5 = 0; c5 <= 5; c5++) {
                                for (int c6 = 0; c6 <= 6; c6++) {
                                    for (int c7 = 0; c7 <= 7; c7++) {
                                        if (c1 + c2 + c3 + c4 + c5 + c6 + c7 == v[i]) {
                                            ans += dp[c1][c2][c3][c4][c5][c6][c7];
                                            if (ans >= mod) ans -= mod;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    cout << ans;
} else {
    vector<vector<pair<int, int>>> ms(sz + 1);
        for (int i = 0; i < (1 << sz); i++) {
            if (!in[__builtin_popcount(i)]) continue;
            int pr = 0;
            for (int j = k; j > 1; j--) {
                pr = (pr << (j - 1)) + ((i >> (j * (j - 1) / 2)) & ((1 << (j - 1)) - 1));
            }
            ms[__builtin_popcount(i)].emplace_back(i & mask1, pr);
        }
        for (int i = 0; i <= sz; i++) {
            ms[i].shrink_to_fit();
        }

        vector<int> dp(1 << (sz - k)), ndp(1 << (sz - k));
        dp[0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (auto [a, b] : ms[v[i]]) {
                ndp[b] += dp[a];
                if (ndp[b] >= mod) ndp[b] -= mod;
            }
            dp.swap(ndp);
            if (i + 1 < n) {
                fill(all(ndp), 0);
            } else {
                for (int j = 0; j < dp.size(); j++) {
                    ans += dp[j];
                    if (ans >= mod) ans -= mod;
                }
            }
        }

        cout << ans;
}
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}