#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

const int mod = 1e9+7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    int sz = k * (k + 1) / 2, mask1 = (1 << (sz - k)) - 1;
    vector<int> in(sz + 1);
    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = k; j >= max(1, k - i); j--) s += j;
        if (v[i] > s) {
            cout << 0;
            return;
        }
        in[v[i]] = 1;
    }

    if (k == 7) {
        vector<vector<pair<int, int>>> l(15), r(15); // 14 9; 7 12
        vector<int> ind_l = {2, 4, 5, 7, 8, 9, 11, 12, 13};
        for (int mask = 0; mask < (1 << 14); mask++) {
            int pr = 0;
            for (int j = 0; j < ind_l.size(); j++) {
                pr ^= ((mask >> ind_l[j] & 1)) << j;
            }
            l[__builtin_popcount(mask)].emplace_back(mask, pr);
        }

        int mask1 = (1 << 7) - 1;
        vector<int> ind_r = {0, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13};
        for (int mask = 0; mask < (1 << 14); mask++) {
            int pr = 0;
            for (int j = 0; j < ind_r.size(); j++) {
                pr ^= ((mask >> ind_r[j] & 1)) << j;
            }
            r[__builtin_popcount(mask)].emplace_back((mask & mask1) << 14, pr << 9);
        }

        for (int i = 0; i < 14; i++) {
            l[i].shrink_to_fit();
            r[i].shrink_to_fit();
        }

        vector<int> dp(1 << (sz - k)), ndp(1 << (sz - k));
        dp[0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int cnt = 0; cnt <= min(v[i], 14); cnt++) {
                for (auto [a, b] : l[cnt]) {
                    for (auto [c, d] : r[v[i] - cnt]) {
                        ndp[b | d] += dp[a | c];
                        if (ndp[b | d] >= mod) ndp[b | d] -= mod;
                    }
                }
            }
            dp.swap(ndp);
            if (i + 1 < n) {
                fill(all(ndp), 0);
            } else {
                for (int j = 0; j < dp.size(); j++) {
                    ans += dp[j];
                    if (ans >= mod) ans -= mod;
                }
            }
        }

        cout << ans;
    } else {
        vector<vector<pair<int, int>>> ms(sz + 1);
        for (int i = 0; i < (1 << sz); i++) {
            if (!in[__builtin_popcount(i)]) continue;
            int pr = 0;
            for (int j = k; j > 1; j--) {
                pr = (pr << (j - 1)) + ((i >> (j * (j - 1) / 2)) & ((1 << (j - 1)) - 1));
            }
            ms[__builtin_popcount(i)].emplace_back(i & mask1, pr);
        }
        for (int i = 0; i <= sz; i++) {
            ms[i].shrink_to_fit();
        }

        vector<int> dp(1 << (sz - k)), ndp(1 << (sz - k));
        dp[0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (auto [a, b] : ms[v[i]]) {
                ndp[b] += dp[a];
                if (ndp[b] >= mod) ndp[b] -= mod;
            }
            dp.swap(ndp);
            if (i + 1 < n) {
                fill(all(ndp), 0);
            } else {
                for (int j = 0; j < dp.size(); j++) {
                    ans += dp[j];
                    if (ans >= mod) ans -= mod;
                }
            }
        }

        cout << ans;
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}