#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

void solve() {
    int n, s;
    cin >> n >> s;
    vector<pair<int, int>> v;
    vector<int> ind;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            v.emplace_back(i, x);
            ind.push_back(j);
        }
    }

    vector<vector<int>> dp(v.size(), vector<int>(s + 1));
    int st = -1;
    for (int i = 0; i < v.size(); i++) {
        if (i == 0 || v[i - 1].first != v[i].first) {
            st = i;
            for (int j = v[i].second; j <= s; j++) {
                if (i == 0 ? (j == v[i].second ? 1 : 0) : dp[i - 1][j - v[i].second]) dp[i][j] = 1;
            }
        } else {
            for (int j = 0; j <= s; j++) {
                if (dp[i - 1][j]) dp[i][j] = 2;
                if (j >= v[i].second) {
                    if (dp[i - 1][j - v[i].second]) dp[i][j] = 1;
                    if (st == 0 ? (j == v[i].second ? 1 : 0) : dp[st - 1][j - v[i].second]) dp[i][j] = 3;
                }
            }
        }
    }

    if (dp.back()[s] == 0) {
        cout << "No";
    } else {
        cout << "Yes\n";
        vector<vector<int>> ans(n);
        int pos = v.size() - 1, sum = s;
        while (sum > 0) {
            if (dp[pos][sum] == 1) {
                ans[v[pos].first].push_back(ind[pos]);
                sum -= v[pos].second;
                pos--;
            } else if (dp[pos][sum] == 2) {
                pos--;
            } else if (dp[pos][sum] == 3) {
                ans[v[pos].first].push_back(ind[pos]);
                sum -= v[pos].second;
                pos -= ind[pos] + 1;
            }
        }

        for (int i = 0; i < n; i++) {
            sort(all(ans[i]));
            cout << ans[i].size() << " ";
            for (int x : ans[i]) cout << x + 1 << " ";
            cout << "\n";
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}