#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
using namespace std;

bool strc(const string& s1, const string& s2)
{
    if(s1.size() < s2.size()) return true;

    for(int i = 0; i < s1.size(); i++) {
        if(s1[i] == s2[i]) continue;
        if(s1[i] < s2[i]) return true;
        else return false;
    }
    return true;
}
int solve(int n, char c,  const string& l, const string& r)
{
    string temp; temp+=c; 
    for(int i = 0; i < n-1; i++) temp+='1';
    string s = temp;
    int res = 0;
    for(int i = 0; i < n-1; i++){
        res+= strc(l, temp) && strc(temp, r);
        swap(temp[i], temp[i+1]);
    }
    if(s!= temp) res+= strc(l, temp) && strc(temp, r);

    return res;
}


int main()
{
    string l, r; cin >> l >> r;
    
    vector<char> dig {'2', '3', '5', '7'};

    int res = 0;
    for(int j = l.size(); j != r.size()+1; j++)
    {
        for(int i = 0; i < 4; i++)
        {
            res+=solve(j, dig[i], l, r);
        }
    }

    cout << res;
    return 0;
}