#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
using ll = long long;

constexpr double eps = 1e-6;
constexpr ll INF = numeric_limits<int>::max();
constexpr ll _INF = numeric_limits<int>::min();
vector<ll> sums;

void foo(vector<ll>& v, int k, int n, int& count)
{
    if(k <= 0) return;
    ll sum = 0;

    ll lenMax = ceil((double)count/k) + (n%k == 0);
    if(k == n || k == 1) lenMax = 1;
    if(k == 2) {
        lenMax =ceil((double)count/k);
    }

    for(ll i = 0; i < lenMax; i++)
        sum+=v[i];

    ll res = sum, lbound = 0;
    int templ = lbound, tempr = lenMax-1;
    for(ll i = lenMax; i < n; i++)
    {
        sum = sum - v[lbound++] + v[i];
        if(res > sum)
        {
            templ = lbound; tempr = i;
            res = min(res, sum);
        }

    }

    for(int i = templ; i <= tempr; i++) v[i] = INF;
    if(res < 2e9)sums.push_back(res);
    count = count - (tempr-templ)- 1;
    foo(v, k-1, n, count);
}
int main()
{
    ll n, k; cin >> n >> k;

    vector<ll> v(n, 0);

    for(auto& x : v) cin >> x;

    ll sum = 0;
    int c = n;
    ll lenMax = ceil((double)n/k) + (n%k == 0);
    if(k == n) lenMax = 1;

    for(ll i = 0; i < lenMax; i++)
        sum+=v[i];

    ll res = numeric_limits<int>::min(), lbound = 0;
    int templ, tempr;
    for(ll i = lenMax; i < n; i++)
    {
        sum = sum - v[lbound++] + v[i];
        if(res < sum)
        {
            templ = lbound; tempr = i;
            res = max(res, sum);
        }

    }

    for(int i = templ; i <= tempr; i++) v[i] = INF;
    sums.push_back(res);
    c = c- (tempr-templ) - 1;
    foo(v, k-1, n, c);

    ll mn = INF, mx = _INF;
    for(auto sum : sums)
    {
        if(sum < mn) mn = sum;
        if(mx < sum) mx = sum;
    }
    cout << mx - mn;
    // for(ll i = 0; i < n; i++)
    // {
    //     if(v[i] > minVal){
    //         minInd = i; minVal = v[i];
    //     }
    // }
 
    // ll currentLen = 0;
    // for(ll i = 0; i < lenMax; i++)
    // {
    //     if(i != minInd) {sum += v[i]; currentLen++;}
    //     else
    //     {
    //         sum = 0;
    //         currentLen = 0;
    //     }
    // }
    // ll res = _INF;
    // if(currentLen == lenMax) res = sum - minVal; 
    // ll lbound = lenMax; 
    // for(ll i = lenMax; i < n; i++)
    // {
    //     if(i != minInd)
    //     {
    //         if(currentLen == lenMax){
    //             sum = sum - v[lbound++] + v[i];
    //             res = max(res, sum - minVal);
    //         }
    //         else{
    //             currentLen++; sum+=v[i];
    //         }
    //     }
    //     else
    //     {
    //         currentLen = 0; sum = 0; 
    //         lbound = i;
    //     }
    // }

    // cout << max(res, sum-minVal);

    return 0;
}