#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
using ll = long long;

constexpr double eps = 1e-6;
constexpr ll INF = numeric_limits<ll>::max();
constexpr ll _INF = numeric_limits<ll>::min();

int main()
{
    ll n, k; cin >> n >> k;

    vector<ll> v(n, 0);

    for(auto& x : v) cin >> x;

    ll sum = 0;

    ll lenMax = ceil((double)n/k) + (n%k == 0);
    ll minVal = numeric_limits<ll>::max();

    for(ll i = 0; i < lenMax; i++)
    {
        sum+=v[i];
    }
    ll res = _INF, lbound = 0;
    for(ll i = lenMax; i < n; i++)
    {
        ll minVal = numeric_limits<ll>::max();
        for(int j = 0; j <= lbound; j++) minVal = min(minVal, v[j]);
        for(int j = i+1; j < n; j++) minVal = min(minVal, v[j]);
        
        sum = sum - v[lbound++] + v[i];
        res = max(res, sum-minVal);
    }
    cout << res;


    // for(ll i = 0; i < n; i++)
    // {
    //     if(v[i] > minVal){
    //         minInd = i; minVal = v[i];
    //     }
    // }
 
    // ll currentLen = 0;
    // for(ll i = 0; i < lenMax; i++)
    // {
    //     if(i != minInd) {sum += v[i]; currentLen++;}
    //     else
    //     {
    //         sum = 0;
    //         currentLen = 0;
    //     }
    // }
    // ll res = _INF;
    // if(currentLen == lenMax) res = sum - minVal; 
    // ll lbound = lenMax; 
    // for(ll i = lenMax; i < n; i++)
    // {
    //     if(i != minInd)
    //     {
    //         if(currentLen == lenMax){
    //             sum = sum - v[lbound++] + v[i];
    //             res = max(res, sum - minVal);
    //         }
    //         else{
    //             currentLen++; sum+=v[i];
    //         }
    //     }
    //     else
    //     {
    //         currentLen = 0; sum = 0; 
    //         lbound = i;
    //     }
    // }

    // cout << max(res, sum-minVal);

    return 0;
}