#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ll n, m, k;

    cin >> n >> m >> k;

    if (n - 1 == m - 1) {
        int result = (n - 1) / k;

        if (result <= 1) {
            cout << "1\n";

            return 0;
        }
    }

    int result1 = (n - 1) / k;

    if ((n - 1) % k != 0) {
        result1++;
    }

    int result2 = (m - 1) / k;

    if ((m - 1) % k != 0) {
        result2++;
    }

    if (result1 + result2 == 1) {
        cout << "1\n";

        return 0;
    }

    if (result1 + result2 == 2) {
        cout << "2\n";

        return 0;
    }

    if (k == 1) {
        if (n > m) {
            cout << n - 1 << "\n"; 
        } else {
            cout << m - 1 << "\n";
        }
    } else {
        if (n <= 10 && m <= 10 && k <= 10) {
            vector <vector <ll> > dp(n, vector <ll> (m));

            for (int i = 0; i < n; i++) {
                dp[i][0] = i / k;

                if (i % k != 0) {
                    dp[i][0]++;
                }
            }

            for (int j = 0; j < m; j++) {
                dp[0][j] = j / k;

                if (j % k != 0) {
                    dp[0][j]++;
                }
            }

            // for (int i = 0; i < n; i++) {
            //     for (int j = 0; j < m; j++) {
            //         cout << dp[i][j] << " ";
            //     }

            //     cout << "\n";
            // }

            for (int i = 1; i < n; i++) {
                for (int j = 1; j < m; j++) {
                    ll answer = INT_MAX;

                    for (int t = i - 1; t >= max(i - k, (ll)0); t--) {
                        answer = min(answer, dp[t][j] + 1);

                        // if (i == 1 && j == 1) {
                        //     cout << dp[t][j] << " ";
                        // }
                    }

                    for (int t = j - 1; t >= max(j - k, (ll)0); t--) {
                        answer = min(answer, dp[i][t] + 1);

                        // if (i == 1 && j == 1) {
                        //     cout << dp[t][j] << " ";
                        // }
                    }

                    for (int t = 1; t <= k && i - t >= 0 && j - t >= 0; t++) {
                        answer = min(answer, dp[i - t][j - t] + 1);

                        // if (i == 1 && j == 1) {
                        //     cout << dp[i - t][j - t] << " ";
                        // }
                    }

                    dp[i][j] = answer;
                }
            }

            // for (int i = 0; i < n; i++) {
            //     for (int j = 0; j < m; j++) {
            //         cout << dp[i][j] << " ";
            //     }

            //     cout << "\n";
            // }

            cout << dp[n - 1][m - 1] << "\n";
        }
    }
}