#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ll n;

    cin >> n;

    vector <vector <ll>> arr(n);
    vector <ll> inst(n - 1);

    for (ll i = 0; i < n; i++) {
        ll x;

        cin >> x;

        arr[i].push_back(x);
    }

    for (ll i = 0; i < n - 1; i++) {
        cin >> inst[i];
    }

    for (ll i = 0; i < n - 1; i++) {
        vector <ll> temp;

        for (ll j = 0; j < arr[inst[i]].size(); j++) {
            temp.push_back(arr[inst[i]][j]);
        }

        arr.erase(arr.begin() + inst[i]);

        for (ll j = 0; j < temp.size(); j++) {
            arr[inst[i] - 1].push_back(temp[j]);
        }

        temp.clear();

        // segment index: inst[i] - 1

        ll index = inst[i] - 1;

        ll result = 0;

        for (ll i = 0; i < arr[index].size(); i++) {
            ll lp = -1;
            ll rp = -1;

            for (ll j = 0; j <= i; j++) {
                lp = max(lp, arr[index][j]);
            }

            for (ll j = i; j < arr[index].size(); j++) {
                rp = max(rp, arr[index][j]);
            }

            // cout << lp << " " << rp << " " << max(0, min(lp, rp) - arr[index][i]) << "\n";

            result += max((ll)0, min(lp, rp) - arr[index][i]);
        }

        cout << result << "\n";
    }
} 