import re

def is_prime(n):
    assert(n >= 0 and n <= 10)
    return n == 2 or n == 3 or n == 5 or n == 7

def is_prostovatoe(x):
    not_one_been = False
    for c in x:
        if c != '1' and not_one_been:
            return False
        if c != '1':
            not_one_been = True
            if not is_prime(int(c)):
                return False
    return not_one_been

def factorial(k):
    assert(k >= 0)
    r = 1
    for i in range(1, k+1):
        r *= i
    return r
def c(n, k):
    return factorial(n) // (factorial(k) * factorial(n - k))

def naive(l, r):
    l = int(l)
    r = int(r)
    numbers = 0
    for i in range(l, r + 1):
        numbers += is_prostovatoe(str(i))
    return numbers

def tenth(r):
    numbers = 0
    for i in range(2, len(r) + 1):
        numbers += 4 * (i - 1)
    return numbers

assert(is_prostovatoe('15'))
assert(not is_prostovatoe('29'))

l = input()
r = input()
if len(l) <= 6 and len(r) <= 6:
    print(naive(l, r))
elif l == '1' and re.fullmatch(r'10+', r):
    print(tenth(r))
