def depth(seg, p):
    assert(p >= 0)
    lp = max(seg[:p+1])
    rp = max(seg[p:])
    return min(lp, rp) - seg[p]

def capacity(seg):
    return sum(depth(seg, p) for p in range(len(seg)))

def merge(k, h):
    assert(k >= 0)
    out = h[:k-1] + [h[k-1] + h[k]] + h[k + 1:]
    assert(len(out) == len(h) - 1)
    return out

assert(capacity([8, 1, 5]) == 4)

n = int(input())
h = [[int(c)] for c in input().split()]
assert(len(h) == n)
k = [int(c) for c in input().split()]
assert(len(k) == n - 1)

for i, c in enumerate(k):
    h = merge(c, h)
    print(capacity(h[c - 1]))
assert(len(h) == 1)
