
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> dtree;
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (auto& item: vec)
		in >> item;
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
	for (auto& item : vec)
		out << item << " ";
	return out;
}
#define int long long

const int MOD = 1e9 + 7;


int32_t main()
{
    int n, k_;
    cin >> n >> k_;
    vector<int> a(n);
    cin >> a;

    if (k_ == 1) {
        cout << 1 << "\n";
        return 0;
    }

    if (k_ == 2) {
        vector<vector<int>> dp(3, vector<int> (2, 0));
        dp[0][0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            auto dp_ = dp;
            dp.assign(3, vector<int> (2, 0));
            ans = 0;
            for (int j = 0; j <= k_; j++) {
                for (int k = 0; k <= k_ - 1; k++) {
                    int x = j + k;
                    if (x != a[i])
                        continue;
                    int maxMask = (1 << (k_ - 1));
                    for (int mask = 0; mask < maxMask; mask++) {
                        int cj = j - (mask & 1);
                        if (cj <= k_ - 1 && cj >= 0) {
                            for (int _ = 0; _ <= k_; _++) {
                                dp[j][k] = (dp[j][k] + (dp_[_][cj]) % MOD) % MOD;
                            }
                        }
                    }
                    ans = (ans + dp[j][k]) % MOD;
                }
            }
        }
        cout << ans << "\n";
    }

    if (k_ == 3) {
        vector<vector<int>> dp(3, vector<int> (2, 0));
        dp[0][0][0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            auto dp_ = dp;
            dp.assign(3, vector<int> (2, 0));
            ans = 0;
            for (int k = 0; k <= 2; k++) {
                for (int l = 0; l <= 1; l++) {
                    int x = j + k + l;
                    if (x > a[i])
                        continue;
                    int j = a[i] - x;
                    int maxMask = (1 << 2);
                    for (int mask = 0; mask < maxMask; mask++) {
                        int cj = j - (mask & 1), ck = k - ((mask >> 1) & 1);
                        if (cj <= k_ - 1 && cj >= 0 && ck <= k_ - 2 && ck >= 0) {
                            for (int _ = 0; _ <= k_; _++) {
                                dp[j][k][l] = (dp[j][k][l] + (dp_[_][cj][ck]) % MOD) % MOD;
                            }
                        }
                    }
                    ans = (ans + dp[j][k][l]) % MOD;
                }
            }
        }
        cout << ans << "\n";
    }

/*
    if (k_ == 4) {
        vector<vector<vector<int>>> dp(4, vector<vector<int>> (3, vector<int> (2, 0)));
        dp[0][0][0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            auto dp_ = dp;
            dp.assign(4, vector<vector<int>> (3, vector<int> (2, 0)));
            ans = 0;
            for (int j = 0; j <= 4; j++) {
                for (int k = 0; k <= 3; k++) {
                    for (int l = 0; l <= 2; l++) {
                        for (int m = 0; m <= 1; m++) {
                            int x = j + k + l + m;
                            if (x != a[i])
                                continue;
                            int maxMask = (1 << 3);
                            for (int mask = 0; mask < maxMask; mask++) {
                                int cj = j - (mask & 1), ck = k - ((mask >> 1) & 1), cl = l - ((mask >> 2) & 1);
                                if (cj <= k_ - 1 && cj >= 0 && ck <= k_ - 2 && ck >= 0 && cl <= k_ - 3 && cl >= 0) {
                                    for (int _ = 0; _ <= k_; _++) {
                                        dp[j][k][l] = (dp[j][k][l] + (dp_[_][cj][ck]) % MOD) % MOD;
                                    }
                                }
                            }
                            ans = (ans + dp[j][k][l]) % MOD;
                        }
                    }
                }
            }
        }
        cout << ans << "\n";
    }*/
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
