// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _Seg {
	ul Height;
} Segment;

typedef struct _MergedSeg {
	size_t count;
} MergedSegment;

ul* Segments;
size_t* MergedSegments;

int compare(const ul* elem1, const ul* elem2)
{
	return *elem2 - *elem1;
}

size_t GetRealIndex(ul K)
{
	ul Counter = 0;
	for (int i = 0; ; )
	{
		if (Counter == K) return i;
		i += MergedSegments[i];
		Counter++;
	}
}

int main()
{
	ull N;
	std::cin >> N;

	Segments = new ul[N];
	MergedSegments = new size_t[N];

	for (int i = 0; i < N; i++)
	{
		ul H;
		std::cin >> H;
		Segments[i] = H;
		MergedSegments[i] = 1;
	}

	for (int i = 0; i < N - 1; i++)
	{
		ul K;
		std::cin >> K;
		K--;
		ul Depth = 0;
		ul RealK = GetRealIndex(K);
		ul Old = MergedSegments[RealK + MergedSegments[RealK]];
		MergedSegments[RealK + MergedSegments[RealK]] = 0;
		MergedSegments[RealK] += Old;
		if (MergedSegments[RealK] > 2)
		{
			ul* a = new ul[MergedSegments[RealK]];
			for (int j = RealK; j < RealK + MergedSegments[RealK]; j++)
			{
				a[j - RealK] = (Segments[j]);
			}

			std::qsort(a, MergedSegments[RealK], sizeof(ul), (_CoreCrtNonSecureSearchSortCompareFunction)compare);

			ul LiquidLevel = min(Segments[RealK], Segments[RealK + MergedSegments[RealK] - 1]);
			LiquidLevel = a[1];
			for (int j = RealK + 1; j < RealK + MergedSegments[RealK] - 1; j++)
			{
				if (Segments[j] == LiquidLevel)
				{
					for (int k = j; k < RealK + MergedSegments[RealK] - 1; k++)
					{
						a[k - j] = Segments[k];
						std::qsort(a, RealK + MergedSegments[RealK] - 1 - j, sizeof(ul), (_CoreCrtNonSecureSearchSortCompareFunction)compare);
						LiquidLevel = a[1];
					}
				}
				else if (Segments[j] < Segments[RealK] && Segments[j] < Segments[RealK + MergedSegments[RealK] - 1])
					Depth += LiquidLevel - Segments[j];
			}
		}
		std::cout << Depth << std::endl;
	}
}
