// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _AB
{
	ull a;
	ull b;
} ABPair;

std::vector<ABPair> ABPairs;

void dels(ull val)
{
	ABPair p;
	for (ull i = 2; i < ceil(sqrt(val)); i++)
	{
		if (val % i == 0)
		{
			p.a = i;
			p.b = val / i;
			ABPairs.push_back(p);
		}
	}
}

int main()
{
	ull d, l, r;
	std::cin >> d >> l >> r;

	ul Count = 0;

	if (d > 1000000000 || l > 10000000000 || r > 10000000000)
	{
		dels(d);

		for (size_t i = 0; i < ABPairs.size(); i++)
		{
			ull a = ABPairs[i].a;
			ull b = ABPairs[i].b;
			ull x = (b + a);
			ull y = (max(b, a) - min(b, a));

			if (x % 2 == 0 && y % 2 == 0)
			{
				x /= 2;
				y /= 2;

				ull X = x * x;
				ull Y = y * y;

				if (l <= X && X <= r && l <= Y && Y <= r)
				{
					if (x - y == a && x + y == b)
					{
						if (X - Y == (x - y) * (x + y))
						{
							//std::cout << ABPairs[i].a << ' ' << ABPairs[i].b << std::endl;
							Count++;
						}
					}
				}
			}
		}
	}
	else
	{
		for (ull y = ceil(sqrt(l)); y <= floor(sqrt(r)); y++)
		{
			ull X = y * y + d;
			if (l <= X && X <= r)
			{
				double x = sqrt(X);

				ull xs = x;

				if (floor(x) == x && (xs - y) * (xs + y) == d)
				{
					Count++;
				}
			}
		}
	}

	std::cout << Count;
}
