// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _AB
{
	ull a;
	ull b;
} ABPair;

std::vector<ABPair> ABPairs;

void dels(ull val)
{
	ABPair p;
	for (ull i = 2; i < ceil(sqrt(val)); i++)
	{
		if (val % i == 0)
		{
			p.a = i;
			p.b = val / i;
			ABPairs.push_back(p);
		}
	}
}

int main()
{
	ull d, l, r;
	std::cin >> d >> l >> r;

	ul Count = 0;

	dels(d);

	for (ul i = 0; i < ABPairs.size(); i++)
	{
		ull a = ABPairs[i].a;
		ull b = ABPairs[i].b;
		ull x = (b + a) / 2;
		ull y = (max(b, a) - min(b, a)) / 2;

		ull X = x * x;
		ull Y = y * y;

		if (l <= X && X <= r && l <= Y && Y <= r)
		{
			if (x - y == a && x + y == b && (x - y) * (x + y) == d)
			{
				//if (floor(sqrt(x)) == sqrt(x) && floor(sqrt(y)) == sqrt(y))
				//{
					//std::cout << ABPairs[i].a << ' ' << ABPairs[i].b << std::endl;
					Count++;
				//}
			}
		}
	}

	std::cout << Count;
}
