// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)
#define min3(a, b, c) (min(min(a, b), min(b, c)))
#define max3(a, b, c) (max(max(a, b), max(b, c)))

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _AB
{
	ull a;
	ull b;
} ABPair;

std::vector<ABPair> ABPairs;

void dels(ull val)
{
	ABPair p;
	for (ull i = 2; i < ceil(sqrt(val)) + 1; i++)
	{
		if (val % i == 0)
		{
			p.a = i;
			p.b = val / i;
			ABPairs.push_back(p);
		}
	}
}

ull maxdiff = 0;

int main()
{
	ull n, k;
	std::cin >> n >> k;

	ul* a = new ul[n];
	ull* p = new ull[n + 1];
	p[0] = 0;

	for (int i = 0; i <= n; i++)
	{
		if (i < n)
		{
			std::cin >> a[i];
		}
		if (i > 0)
		{
			p[i] = p[i-1] + a[i-1];
		}
	}

	for (int j = n - 1; j >= 2; j--)
	{
		ull s3 = p[n] - p[j];
		for (int i = 1; i < j; i++)
		{
			ull s1 = 0;
			ull s2 = 0;
			s1 = p[i];
			s2 = p[j] - p[i];
			if (max3(s1, s2, s3) - min3(s1, s2, s3) > maxdiff) maxdiff = max3(s1, s2, s3) - min3(s1, s2, s3);
		}
	}

	std::cout << maxdiff;
}
