#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int rec(vector<int> a, vector<int> sum, vector<int> borders, int iteration, int n, int k) {
	int ans = -1;
	if (iteration == 1) {
		if (iteration < k - 1) {
			while (borders[iteration] < borders[iteration + 1]) {
				ans = max(ans, *max_element(sum.begin(), sum.end()) - *min_element(sum.begin(), sum.end()));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		} else {
			while (borders[iteration] < n) {
				ans = max(ans, *max_element(sum.begin(), sum.end()) - *min_element(sum.begin(), sum.end()));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
	} else {
		if (iteration < k - 1) {
			while (borders[iteration] < borders[iteration + 1]) {
				ans = max(ans, rec(a, sum, borders, iteration-1,n,k));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
		else {
			while (borders[iteration] < n) {
				ans = max(ans, rec(a, sum, borders, iteration - 1, n, k));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
	}
}
int main() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	vector<int> sum(k,0);
	vector<int> borders(k);
	for (int i = 0; i < k; i++) {
		borders[i] = i;
	}
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (i < k) {
			sum[i] += a[i];
		} else {
			sum[k - 1] += a[i];
		}
	}
	cout << rec(a, sum, borders, k-1, n, k);
}