#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int main() {
	int n, m, k, a, b;
	cin >> n >> m >> k;
	vector<vector<bool>> dost(n, vector<bool> (m, false));
	vector<vector<int>> dp(n, vector<int> (m, -1));
	vector<pair<int, int>> dost_coord(k);
	for (int i = 0; i < k; i++) {
		cin >> a >> b;
		dost[a - 1][b - 1] = true;
		dost_coord[i] = { a - 1,b - 1 };
	}
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (i == 0 && j == 0) {
				dp[i][j] = 1;
				continue;
			}
			if (dp[i][j] == 0) {
				continue;
			}
			if (i != n - 1 && dost[i + 1][j] == true) {
				dp[i][j + 1] = 0;
			}
			if (i == n - 1 && j != m - 1 && j != 0) {
				dp[i][j] = dp[i][j - 1];
				continue;
			}
			if (j == 0) {
				dp[i][j] = (dp[i - 1][j]) % (1000000000 + 7);
				continue;
			}
			if (i == 0) {
				dp[i][j] = (dp[i][j - 1]) % (1000000000 + 7);
				continue;
			}
			dp[i][j] = (dp[i - 1][j] + dp[i][j - 1]) % (1000000000 + 7);
		}
	}
	int ans = (dp[n - 1][m - 1] * 2) % (1000000000 + 7);
	for (pair<int, int> i : dost_coord) {
		if (dp[i.first][i.second] == 0) {
			ans = 0;
		}
	}
	cout << ans;
}