#include <algorithm>
#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

typedef long long ll;

using namespace std;

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll d, l, r;
	cin >> d >> l >> r;

	vector<ll> sq;
	unordered_map<ll, ll> at, bt;
	ll cnt = 0;
	for (ll i = ceil(sqrt(l)); i <= sqrt(r); i++)
		sq.push_back(i * i);
	for (ll y = 0; y < sq.size(); y++)
		for (ll x = y + 1; x < sq.size(); x++)
			if (sq[x] - sq[y] == d)
				cnt++;
	cout << cnt;
}
