#include <algorithm>
#include <iostream>
#include <vector>

typedef long long ll;

using namespace std;

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, s;
	cin >> n >> s;

	vector<vector<ll>> C(n);
	for (ll i = 0; i < n; i++)
	{
		ll k;
		cin >> k;
		C[i].resize(k);
		for (ll& j : C[i])
			cin >> j;
	}

	vector<vector<vector<ll>>> res(n, vector<vector<ll>>(s + 1));
	vector<vector<ll>> sum(n);
	
	for (ll m = 0; m < n; m++)
	{
		ll k = C[m].size();
		vector<vector<ll>>& dp = res[m];
		for (auto& s : dp)
			s.resize(k + 1);
		dp[0].assign(k + 1, 1);
		for (ll i = 1; i <= s; i++)
			for (ll j = 0; j <= k; j++)
				if (j == 0)
					dp[i][j] = 0;
				else if (dp[i][j - 1])
					dp[i][j] = 1;
				else if (i < C[m][j - 1])
					dp[i][j] = 0;
				else
					dp[i][j] = dp[i - C[m][j - 1]][j - 1];
		for (ll i = 1; i <= s; i++)
			if (dp[i][k])
				sum[m].push_back(i);
	}

	vector<ll> dp(s + 1);
	vector<vector<ll>> store(s + 1, vector<ll>(n + 1));
	for (ll i = 1; i <= s; i++)
		for (ll j = 1; j <= n; j++)
			if (j == 1)
			{
				for (ll c : sum[j - 1])
					if (i == c)
					{
						dp[i] = 1;
						store[i][j] = c;
					}
			}
			else
				for (ll c : sum[j - 1])
					if (i >= c && dp[i - c])
					{
						dp[i] =  1;
						store[i][j] = c;
					}

	if (dp[s])
	{
		cout << "Yes\n";
		ll m = n, i = s;
		vector<vector<ll>> t(n);
		while (m != 0)
		{
			ll c = store[i][m];
			ll ii = c, j = C[m - 1].size();
			while (j != 0)
			{
				if (res[m - 1][ii][j - 1])
					j--;
				else if (res[m - 1][ii - C[m - 1][j - 1]][j - 1])
				{
					t[m - 1].push_back(j);
					ii -= C[m - 1][j - 1], j--;
				}
			}
			i -= c;
			m--;
		}
		for (auto& h : t)
		{
			cout << h.size() << '\n';
			for (ll i : h)
				cout << i << ' ';
			cout << '\n';
		}
	}
	else
		cout << "No";
}
