﻿#include <iostream>
#include <vector>
using namespace std;
int N, K;
vector<vector<int>> dp(0);
void Build(int b, int s)
{
	if (b < 0 || s < 0 || b >= N || s >= N - b)
		b = 0; //pass
	else if (dp[b][s] == -1)
	{
		Build(b + 1, s - 1);
		Build(b, s - 1);
		Build(b + 1, s - 2);
		dp[b][s] = 0;
		if (b < N - 1 && s >= 1)
			dp[b][s] += dp[b + 1][s - 1];
		if (s >= 1)
			dp[b][s] += dp[b][s - 1]; 
		if (b < N - 1 && s >= 2)
			dp[b][s] -= dp[b + 1][s - 2];
	}
}
	
int main()
{
	cin >> N >> K;
	dp.resize(N);
	int t;
	for (int i = 0; i < N; i++)
	{
		dp[i].resize(N - i, -1);
		cin >> t;
		dp[i][0] = t;
	}
	Build(0, N - 1);
	if (N == K)
	{
		int max_ = 0;
		int min_ = dp[0][0];
		for (int i = 0; i < N; i++)
		{
			max_ = max(max_, dp[i][0]);
			min_ = min(min_, dp[i][0]);
		}
	}
	if (K == 2)
	{ 
		int r = 0;
		for (int i = 1; i < N - 1; i++)
		{
			r = max(r, abs(dp[0][i - 1] - dp[i][N - i - 1]));
		}
		cout << r;
	}
	if (K == 3)
	{
		int r = 0;
		for (int i = 1; i < N - 2; i++)
		{
			for (int j = i + 1; j < N - 1; j++)
			{
				r = max(max(r, abs(dp[0][i - 1] - dp[i][j - i - 1] - dp[i][j - i - 1]) ), max( abs(dp[i][j - i - 1] - dp[j][N - j - 1]), abs(dp[j][N - j - 1] - dp[0][i - 1]) ));
			}
		}
		cout << r;
	}
}