def solution(tasks: list[list[int]], need_to_collect: int):
    start_from = 0

    dps = [[[0] * need_to_collect for _ in range(len(i))] for i in tasks]

    # Fill first dp

    for i in range(len(tasks[0])):
        adding = tasks[0][i]
        for j in range(need_to_collect):
            dps[0][i][j] = max((dps[0][i - 1][j] if i - 1 >= 0 else 0,
                               dps[0][i - 1][j - adding] + adding if j - adding >= 0 and i - 1 >= 0 else 0,
                               adding if adding <= j + 1 else 0))

    for i in range(1, len(tasks)):
        for j in range(len(tasks[i])):
            adding = tasks[i][j]
            for k in range(need_to_collect):
                if j == 0:
                    last_row = dps[i - 1][-1]
                    dps[i][j][k] = last_row[k - adding] + adding if k - adding >= 0 and last_row[k - adding] > 0 else 0
                else:
                    # print(i, j, k, dps[i][j - 1][k], dps[i][j - 1][k - adding] + adding)
                    dps[i][j][k] = max((dps[i][j - 1][k],
                                       dps[i][j - 1][k - adding] + adding if k - adding >= 0 and dps[i][j - 1][k - adding] > 0 else 0,
                                        dps[i - 1][-1][k - adding] + adding if k - adding >= 0 and dps[i - 1][-1][k - adding] > 0 else 0))

    if dps[-1][-1][-1] != need_to_collect:
        print("No")
        return
    else:
        print("Yes")

    i = len(tasks) - 1
    j = len(tasks[i]) - 1
    k = need_to_collect - 1

    result = [[]]

    while i >= 0:
        if j == -1:
            i -= 1

            if i == -1:
                break

            j = len(tasks[i]) - 1
            result.append([])
            continue

        if j == 0 or dps[i][j][k] != dps[i][j - 1][k]:
            result[-1].append(j + 1)
            k -= tasks[i][j]

        j -= 1


    for i in result[::-1]:
        print(len(i))
        print(" ".join(map(str, sorted(i))))

n, s = map(int, input().split())
a = []

for _ in range(n):
    _ = input()
    a.append(list(map(int, input().split())))

solution(a, s)