#include <bits/stdc++.h>
using namespace std;

#define int long long

vector<int> get_deleteli(int b) {
    int i = 1;
    vector<int> ans;
    while (i * i < b) {
        if (b % i == 0) {
            ans.push_back(i);
            ans.push_back(b / i);
        }
        i += 1;
    }
    if (b % i == 0) {
        ans.push_back(i);
    }
    return ans;
}

bool check(int x, int y, int a, int b, int l, int r) {
    return x >= 1 and y >= 1 and y < x and (a + b) % 2 == 0 and l <= x * x and x * x <= r and l <= y * y and y * y <= r;
}



pair<int, int> find_x_and_y(int a, int b) {
    // x^2 - y^2 == (x - y)(x + y)
    // x - y = a
    // x + y = b
    // 2 * x = a + b
    // x = (a + b) / 2
    // y = b - x
    int x = (a + b) / 2;
    int y = b - x;
    return make_pair(x, y);
}


signed main() {
    int d, l, r;
    cin >> d >> l >> r;
    int ans = 0;
    for (auto i : get_deleteli(d)) {
        int a = i;
        int b = d / i;
        auto t = find_x_and_y(a, b);
        int x = t.first;
        int y = t.second;
        if (check(x, y, a, b, l, r))
            cout << x << ' ' << y << endl;
            ans += 1;
    }
    cout << ans << endl;
}
