#include <cstdlib>
#include <vector>
#include <iostream>

using namespace std;

int main()
{
	int n, m, k;
	const int INF = (int)1e9;
	cin >> n >> m >> k;
	vector<vector<int>> dp(n, vector<int>(m, INF));
	dp[n - 1][0] = 0;
	for (int y = n - 1; y != -1; y--)
	{
		for (int x = 0; x < m; x++)
		{
			if (dp[y][x] == 0)
				continue;
			if (x >= k && dp[y][x] > dp[y][x - k])
				dp[y][x] = dp[y][x - k];
			if (y + k < n && dp[y][x] > dp[y + k][x])
				dp[y][x] = dp[y + k][x];
			if (y + k < n && x >= k && dp[y][x] > dp[y + k][x - k])
				dp[y][x] = dp[y + k][x - k];
			if (dp[y][x] != INF)
				dp[y][x] += 1;
		}
	}
	cout << dp[n - 1][m - 1];
}