#include <cstdlib>
#include <vector>
#include <cstdint>
#include <iostream>

using namespace std;

int main()
{
	int64_t n, m, k;
	const int64_t INF = (int)1e9;
	cin >> n >> m >> k;
	if (k == 1)
	{
		if (n < m)
			cout << m - 1;
		else
			cout << n - 1;
	}
	else if (n == 1)
	{
		if ((m - 1) % k == 0)
			cout << (m - 1) / k;
		else
			cout << (m - 1) / k + 1;
	}
	else if (m == 1)
	{
		if ((n - 1) % k == 0)
			cout << (n - 1) / k;
		else
			cout << (n - 1) / k + 1;
	}
	else if (n == m && n <= k)
		cout << 1;
	else if (n == m && n <= 2 * k)
		cout << 2;
	else if (n <= k && m <= k)
		cout << 2;
	else if (n < m && n <= k && m - n <= k)
		cout << 2;
	else if (n >= m && m <= k && n - m <= k)
		cout << 2;
	else
	{
		static vector<vector<int>> dp(n, vector<int>(m, INF));
		dp[n - 1][0] = 0;
		for (int y = n - 1; y != -1; y--)
		{
			for (int x = 0; x < m; x++)
			{
				if (dp[y][x] == 0)
					continue;
				for (int d = 1; d <= k; d++)
				{
					if (x >= d && dp[y][x] > dp[y][x - d])
						dp[y][x] = dp[y][x - d];
					if (y + d < n && dp[y][x] > dp[y + d][x])
						dp[y][x] = dp[y + d][x];
					if (y + d < n && x >= d && dp[y][x] > dp[y + d][x - d])
						dp[y][x] = dp[y + d][x - d];
				}
				if (dp[y][x] != INF)
					dp[y][x] += 1;
			}
		}
		cout << dp[0][m - 1];
	}
}