#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <queue>




using namespace std;

ostream& operator<<(ostream& o, vector<int> T) {

    for (auto x : T) {
        o << x << " ";
    }
    o << endl;
    return o;
}

istream& operator>>(istream& i, vector<int>& T) {

    for (auto& x : T) {
        i >> x;
    }
    return i;
}

struct seg {

    vector<int> c;
    int n = 0;


    long long v() {
        n = c.size();
        long long w = 0;
        if (n > 2) {
            for (int i = 1; i < n - 1; i++) {
                int r = 0;
                int l = 0;

                for (int j = i; j < n and c[j] <= c[i]; j++) {
                    r = j;
                }
                if(r != n-1)
                r++;
                //cout << "r :" << r << endl;
                for (int j = i; j >= 0 and c[j] <= c[i]; j--) {
                    l = j;
                }
                if(l != 0)
                l--;
                //cout << "l :" << l << endl;
                if (c[i] < c[r] and c[i] < c[l]) {
                    w += (-1 + r - l) * (min(c[r], c[l]) - c[i]);
                }

            }
        }
        return w;

    }

    void add(seg s) {
        for (int i = 0; i < s.c.size(); i++) {
            c.push_back(s.c[i]);
        }
    }

    void p() {
        cout << c;
    }

    seg(int t) {
        c.push_back(t);
        n += 1;
    }
    seg() {}

};


void remove(vector<seg> &a, int x) {
    if (x < a.size()) {
        for (int i = x; i < a.size() - 1; i++) {
            a[i] = a[i + 1];
        }
    }

}


int main()
{
    int n, k;
    cin >> n;
    vector<int> h(n);
    cin >> h;
    vector<seg> s(n);
    for (int i = 0; i < n; i++) {
        s[i].add(h[i]);
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> k;
        k--;
        s[k].add(s[k + 1]);
        remove(s, k + 1);
        cout << s[k].v() << endl;
        //s[k].p();
    }
}

