﻿#include <iostream>
#include <vector>

using namespace std;

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, k; cin >> n >> m >> k;
    vector<vector<int>> dp(n, vector<int>(m, 1e9 + 7));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (dp[i][j] != 1e9 + 7) {
                for (int l = 1; l <= k; ++l) {
                    if (i + l < n && j + l < m) {
                        dp[i + l][j + l] = min(dp[i + l][j + l], dp[i][j] + 1);
                    }
                    if (i + l < n) {
                        dp[i + l][j] = min(dp[i + l][j], dp[i][j] + 1);
                    }
                    if (j + l < m) {
                        dp[i][j + l] = min(dp[i][j + l], dp[i][j] + 1);
                    }
                }
            }
        }
    }
    cout << dp[n - 1][m - 1];
}
