﻿#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

void solve(const vector<vector<int>>& c, int i, int now, int s, vector<vector<int>> res, int prev) {
    if (now == s && i == c.size() - 1 && res[i].size() != 0) {
        cout << "Yes" << '\n';
        for (int i = 0; i < res.size(); ++i) {
            cout << res[i].size() << '\n';
            for (int j = 0; j < res[i].size(); ++j) {
                cout << res[i][j] << '\n';
            }
        }
        exit(0);
    }
    if (now > s || i >= c.size()) return;
    for (int j = prev + 1; j < c[i].size(); ++j) {
        res[i].push_back(j + 1);
        solve(c, i, now + c[i][j], s, res, j);
        solve(c, i + 1, now + c[i][j], s, res, -1);
        res[i].pop_back();
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, s; cin >> n >> s;
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        for (int j = 0; j < k; ++j) {
            int m; cin >> m;
            c[i].push_back(m);
        }
    }
    vector<vector<int>> res(n);
    solve(c, 0, 0, s, res, -1);
    cout << "No";
}
/*
    A
    ll d, l, r; cin >> d >> l >> r;
    ll res = 0;
    ll sqStart = ceil(sqrt(l));
    ll sq2 = floor(sqrt(r));
    ll range = 0;
    for (ll k = sqStart + 1; k < sq2; ++k) {
        ll m = sqrt(k);
        if (m * m == k) {
            range = k - sqStart;
            break;
        }
    }
    for (ll y = sqStart; y < r; y += range, range += 2) {
        ll x = y + d;
        ll sq3 = floor(sqrt(x));
        if (sq3 * sq3 == x && x <= r) {
            res++;
        }
    }
    cout << res;
*/

/*
    A
    ll d, l, r; cin >> d >> l >> r;
    ll res = 0;
    ll sq1 = ceil(sqrt(l));
    ll sq2 = floor(sqrt(r));
    for (ll y = sq1; y < sq2; ++y) {
        ll x = y * y + d;
        ll sq3 = floor(sqrt(x));
        if (sq3 * sq3 == x && x <= r) {
            res++;
        }
    }
    cout << res;
*/
