import functools
import pprint
from itertools import *

n, k = map(int, input().split())

b = [int(i) for i in input().split()]

def perm(zeroes, ones):
    ln = zeroes + ones
    for i in range(2 ** ln):
        s = bin(i)[2:]
        while len(s) < ln:
            s = '0' + s
        if s.count('1') == ones:
            yield [int(j) for j in s]

def count_variants(scheme, col):
    if col == n:
        return 1
    res = 0
    sm = 0
    for c in range(max(col + 1 - k, 0), col):
        for r in range(k - col + c):
            sm += scheme[c][r]
    if sm > b[col] or b[col] - sm > k:
        return 0

    for p in perm(k - b[col] + sm, b[col] - sm):
        cs = scheme[:col] + (p, ) + scheme[col + 1:]
        res += count_variants(cs, col + 1)
    return res



def main():
    if k == 1:
        return 1
    cnt = 0
    scheme = tuple((0,) * k for _ in range(n))
    return count_variants(scheme, 0)

print(main())