﻿#include <bits/stdc++.h>
using namespace std;
string Z2(const string &s) {
    if (s == "0") {
        return "";
    }
    string res = s;
    int i = (int)res.size() - 1;
    while (i >= 0) {
        if (res[i] > '0') {
            res[i] = char(res[i] - 1);
            break;
        } else {
            // res[i] == '0'
            res[i] = '9';
            i--;
        }
    }
    while (res.size() > 1 && res[0] == '0') {
        res.erase(res.begin());
    }
    if (res == "") return "0";
    return res;
}
long long R(int L) {
    if (L <= 1) return 0LL;
    long long x = (long long)(L - 1);
    long long y = (long long)L;
    long long res = 2LL * x * y;
    return res;
}


long long F(const string &strN) {
    static const int MAXD = 100000;
    static const int PRIME_DIGITS[5] = {1,2,3,5,7};
    int len = (int)strN.size();
    static long long dp[2][2][2];
    memset(dp, 0, sizeof(dp));
    dp[0][0][0] = 1LL;
    for(int pos = 0; pos < len; pos++) {
        static long long nextDp[2][2][2];
        memset(nextDp, 0, sizeof(nextDp));

        int B = strN[pos] - '0';

        for(int usedPrime = 0; usedPrime < 2; usedPrime++){
            for(int less = 0; less < 2; less++){
                long long ways = dp[pos%2][usedPrime][less];
                if (ways == 0) continue;
                if (usedPrime == 1) {
                    int d = 1;
                    if (less == 1) {
                        int newLess = 1;
                        int newUsedPrime = 1;
                        nextDp[(pos+1)%2][newUsedPrime][newLess] += ways;
                    } else {
                        if (d <= B) {
                            int newLess = (d < B) ? 1 : 0;
                            int newUsedPrime = 1;
                            nextDp[(pos+1)%2][newUsedPrime][newLess] += ways;
                        }
                    }
                } else {
                    for (int i = 0; i < 5; i++){
                        int d = PRIME_DIGITS[i];
                        if (less == 1) {
                            int newLess = 1;
                            int newUsedPrime = (d != 1) ? 1 : 0;
                            nextDp[(pos+1)%2][newUsedPrime][newLess] += ways;
                        } else {
                            if (d <= B) {
                                int newLess = (d < B) ? 1 : 0;
                                int newUsedPrime = (d != 1) ? 1 : 0;
                                nextDp[(pos+1)%2][newUsedPrime][newLess] += ways;
                            }
                        }
                    }
                }
            }
        }
        memcpy(dp[(pos+1)%2], nextDp[(pos+1)%2], sizeof(dp[(pos+1)%2]));
        memcpy(dp[pos%2], nextDp[pos%2], sizeof(dp[pos%2]));
        memset(dp[pos%2], 0, sizeof(dp[pos%2]));
        memcpy(dp[pos%2], nextDp[(pos+1)%2], sizeof(dp[pos%2]));
    }
    return ans;
}
long long Z3(const string &N) {
    if (N == "" || N == "0") {
        return 0LL;
    }
    int L = (int)N.size();
    long long partial = R(L);
    long long dpVal = F(N);
    return partial + dpVal;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    string Ls, Rs;
    cin >> Ls >> Rs;
    if (Ls.size() > Rs.size() || (Ls.size() == Rs.size() && Ls > Rs)) {
        // swap
        string tmp = Ls;
        Ls = Rs;
        Rs = tmp;
    }
    string f2 = Z2(Ls);
    long long ansR = Z3(Rs);
    long long ansL_1 = Z3(f2);
    long long ans = ansR - ansL_1;
    cout << ans << "\n";
    return 0;
}