#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <bitset>

using namespace std;
using ll = long long;
using solution_description = deque<vector<ll>>;
solution_description solve(int s, vector<vector<ll>>& scores, int begin = 0) {
	bitset<30> options = 0;
	for (options = 0; (options >> scores[begin].size()) == 0; options = options.to_ullong() + 1) {
		auto choose_sum = 0;
		vector<ll> choose;
		for (int i = 0; i < scores[begin].size(); i++) {
			choose_sum += options[i] * scores[begin][i];
			if (options[i])
				choose.push_back(i);
		}
		if (begin == scores.size() - 1)
			if (s == choose_sum)
				return { choose };
			else
				return {};
		auto ans = solve(s - choose_sum, scores, begin + 1);
		if (ans.size()) {
			ans.push_front(choose);
			return ans;
		}
	}
}
int main()
{
	ll n, s;
	cin >> n >> s;
	vector<vector<ll>> scores(n);
	for (auto& n : scores) {
		ll size;
		cin >> size;
		n.resize(size);
		for (auto& s : n)
			cin >> s;
		sort(n.begin(), n.end());
	}
	int sum;
	for (auto& a : scores)
		for (auto& b : scores)
			sum += b;
	if (sum == s)
	{
		cout << "Yes";
		for (auto a : scores)
			cout << "1\n1\n";
	} else
		cout << "No";
}
// 2 4 1 2 2 2 1 