import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {

    public static int comp(char[] a, char[] b) { // -1 if a < b; 0 if a == b; 1 if a > b
        if (a.length < b.length) return -1;
        if (a.length > b.length) return 1;
        int n = a.length;
        for (int i = 0; i < n; i++) {
            if (a[i] < b[i]) {
                return -1;
            }
            if (a[i] > b[i]) {
                return 1;
            }
        }
        return 0;
    }

    public void solve() {
        char[] input = new char[100001];
        char t = '1';
        int n = 0;
        while (true) {
            try {
                t = (char) br.read();
            } catch (IOException e) {
                break;
            }
            if (!Character.isDigit(t)) {
                break;
            }
            input[n] = t;
            n += 1;
        }
        char[] l = new char[n];
        System.arraycopy(input, 0, l, 0, n);

        n = 0;
        while (true) {
            try {
                t = (char) br.read();
            } catch (IOException e) {
                break;
            }
            if (!Character.isDigit(t)) {
                break;
            }
            input[n] = t;
            n += 1;
        }

        char[] r = new char[n];
        System.arraycopy(input, 0, r, 0, n);

        n = l.length;
        char[] tmp = new char[n];
        Arrays.fill(tmp, '1');
        long s = 0;
        char[] primes = {'2', '3', '5', '7'};
        for (int i = 0; i < n; i++) {
            for (char sym : primes) {
                tmp[i] = sym;
                if (comp(tmp, l) != -1) {
                    s += 1;
                }
            }
            tmp[i] = '1';
        }

        n = r.length;
        tmp = new char[n];
        Arrays.fill(tmp, '1');
        for (int i = 0; i < n; i++) {
            for (char sym : primes) {
                tmp[i] = sym;
                if (comp(r, tmp) != -1) {
                    s += 1;
                }
            }
            tmp[i] = '1';
        }

        for (int i = l.length + 1; i < r.length; i++) {
            s += 4 * i;
        }

        System.out.println(s);
    }

    public void run() {
//        try {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);

        solve();

        out.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//            System.exit(1);
//        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}