import java.io.*;
import java.util.*;

public class F {
    long[] a;
    int n;
    int k;
    long[] prefix;
    int[] K;
    long dif = 0;

    public long get(int index) {
        if (index < 0) return 0;
        return prefix[index];
    }

    public void func(int last_k, int count_k, long min, long max) {
        if (count_k == k) {
//            out.print(Arrays.toString(K));
            long s = prefix[n] - prefix[last_k - 1];

            if (s < min) {
                min = s;
            } else if (s > max) {
                max = s;
            }
            if ((max - min) > dif) {
                dif = max - min;
            }
//            out.println(" : " + min + " : " + max);
            return;
        }
        if (n - last_k < k - count_k) return;
        for (int i = last_k + 1; i <= n - k + count_k; i++) {
            K[count_k] = i;
            long s = get(i - 1) - get(last_k - 1);
            if (s < min) {
                min = s;
            }
            if (s > max) {
                max = s;
            }
            func(i, count_k + 1, min, max);
        }
    }

    public void solve() throws IOException {
        n = nextInt();
        k = nextInt();
        a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }

        K = new int[k];
        K[0] = 0;
        prefix = new long[n + 1];
        long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i];
            prefix[i] = sum;
        }
        prefix[n] = sum;
        func(0, 1, sum, 0);
        out.println(dif);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new F().run();
    }

}