import java.io.*;
import java.util.*;

public class G {
    HashSet<Integer>[] sums;
    int n;
    int s;
    HashMap<Integer, Integer>[] map;

    public void print(int l) {
        out.println(Integer.bitCount(l));
        for (int i = 0; i < 32; i++) {
            if (((l >>> i) & 1) == 1) {
                out.println(i + 1);
            }
        }
    }

    public boolean func(int sum, int task) {
        if (sum > s || task < 0) {
            return false;
        }
        for (int i : sums[task]) {
            if (task == 0 && sum + i == s) {
                out.println("Yes");
                print(map[task].get(i));
                return true;
            }
            if (func(sum + i, task - 1)) {
                print(map[task].get(i));
                return true;
            }
        }
        return false;
    }
    public void solve() throws IOException {
        n = nextInt();
        s = nextInt();

        int[][] c = new int[n][];
        for (int i = 0; i < n; i++) {
            int k = nextInt();
            c[i] = new int[k];
            for (int j = 0; j < k; j++) {
                c[i][j] = nextInt();
            }
        }

        sums = new HashSet[n];
        map = new HashMap[n];
        for (int i = 0; i < n; i++) {
            sums[i] = new HashSet<>();
            map[i] = new HashMap<>();
            for (int j = 1; j < Math.pow(2, c[i].length); j++) {
                int sum = 0;
                for (int l = 0; l < c[i].length; l++) {
                    sum += c[i][l] * ((j >>> l) & 1);
                }
                if (!map[i].containsKey(sum)) {
                    map[i].put(sum, j);
                }
                sums[i].add(sum);
            }
        }
        if (!func(0, n - 1)) {
            out.println("No");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G().run();
    }

}