#include <iostream>
#include <string>
using namespace std;

bool prime(long long num) {
    if (num <= 1) return false;
    for (long long d = 2; d * d <= num; d++) {
        if (num % d == 0) return false;
    }
    return true;
}

int main()
{
    int l, r; cin >> l >> r;
    int cnt = 0;
    for (int i = l; i <= r; i++) {
        string snum = to_string(i);
        long long result = 1;
        for (char s: snum) {
            result *= s - '0';
        }
        if (prime(result)) {
            cnt++;
        }
    }
    cout << cnt << endl;
    return 0;
}
