prime = ['2', '3', '5', '7']

def for_left(l):
    res = 0
    for i in range(len(l)):
        if l[i] in "01": continue
        res += i * 4

        for p in prime:
            if p > l[i]:
                res += 1
            if p == l[i]:
                suit = True
                for j in range(i + 1, len(l)):
                    if l[j] not in "01":
                        suit = False
                if suit:
                    res += 1
            
        return res
    return 4

def for_right(r):
    res = 0
    nulls = r.count('0')
    for i in range(len(r)):
        if r[i] == '1': continue
        if r[i] == '0': break
    
        res += (len(r) - i - 1) * 4
    
        for p in prime:
            if p < r[i]:
                res += 1
            if p == r[i] and nulls == 0:
                res += 1
 
        return res
    return 0

def is_suit(num):
    have = False
    for i in num:
        if i == '1': continue
        elif i in prime:
            if have: return False
            have = True
        else: return False
    return True

l = input()
r = input()
ans = 0

if len(l) == len(r):
    a = for_right(l)
    b = for_right(r)
    
    ans = b - a
    if is_suit(l):
        ans += 1
else:
    ans += for_left(l)
    ans += for_right(r)

    l = len(l) + 1
    r = len(r) - 1
    for n in range(l, r + 1):
        ans += 4 * n

print(ans)
