#include <iostream>
#include <vector>

using namespace std;

vector<int> data;

int recFind(int ptr, vector<vector<int>>& table) {
    if (ptr == data.size()) {
        return 1;
    }

    int cnt = data[ptr];
    if (ptr > 0) {
        cnt -= table[ptr - 1][0];
    }
    if (cnt == -1) {
        return 0;
    }

    int variants = 0;
    if (cnt == 1) {
        table[ptr][0] = 1;
        variants  += recFind(ptr + 1, table);
        table[ptr][0] = 0;

        table[ptr][1] = 1;
        variants += recFind(ptr + 1, table);
        table[ptr][1] = 0;
    }
    if (cnt == 2) {
        table[ptr][0] = 1;
        table[ptr][1] = 1;
        variants += recFind(ptr + 1, table);
        table[ptr][0] = 0;
        table[ptr][0] = 0;
    }
    return variants;
}

int main()
{
    int n, k; cin >> n >> k;
    data.resize(n);
    for (int& i: data) {
        cin >> i;
    }

    vector<vector<int>> table(n, vector<int> (k));
    cout << recFind(0, table);
    return 0;
}
