#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int n, k; cin >> n >> k;
    vector<long long> arr(n);
    set<pair<long long, int>> nums;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        nums.insert({ arr[i], i });
    }

    if (k == 2) {
        long long summ = 0;
        for (int i = 0; i < n; i++) {
            summ += arr[i];
        }

        long long ans = max(abs(summ - 2 * arr[0]), abs(summ - 2 * arr.back()));
        cout << ans << endl;
        return 0;
    }

    int max_size = n - k + 1;
    long long ans = 0;
    while (!nums.empty()) {
        auto [num, ind] = *nums.begin();
        nums.erase(nums.begin());

        long long summL = 0, summR = 0;
        int ptrL = ind - 1, ptrR = ind + 1;

        int quan = n - k + 1;
        while (quan && ptrL >= 0) {
            summL += arr[ptrL];
            quan--;
            ptrL--;
        }

        quan = n - k + 1;
        while (quan && ptrR < n) {
            summR += arr[ptrR];
            quan--;
            ptrR++;
        }

        ans = max(ans, max(abs(summL - num), abs(summR - num)));
    }
    cout << ans << endl;
    return 0;
}
