#include <iostream>
#include <vector>

using namespace std;


int main()
{
    /*
    1.  
    2.  ,     ,        
    4.    ,    ,     
      ,   24 .
    */

    int n, s; cin >> n >> s;
    vector<vector<int>> table(n);

    bool anyIsOne = true;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        table[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> table[i][j];
            anyIsOne &= (table[i][j] == 1);
        }
    }

    if (anyIsOne) {
        if (s < n) {
            cout << "No" << endl;
            return 0;
        }
        vector<int> ans(n, 1);

        s -= n;
        for (int i = 0; i < n; i++) {
            ans[i] = min((int) table[i].size(), 1 + s);
            s -= min((int)table[i].size(), s);
            if (s == 0) {
                break;
            }
        }

        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i] << endl;
            for (int j = 0; j < ans[i]; j++) {
                cout << j + 1 << " ";
            } cout << endl;
        }
        return 0;
    }

    return 0;
}
