import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {
    String getOnes(int n) {
        String s = "";
        while (s.length() != n)
            s = s + "1";

        return s;
    }


    public void solve() throws IOException {
        BigInteger l = new BigInteger(nextToken());
        BigInteger r = new BigInteger(nextToken());

        long otv = 0;

        loop:
        for (BigInteger i = new BigInteger(String.valueOf(l)); i.compareTo(r) <= 0; i = i.add(BigInteger.ONE)) {
            String s = i.toString();

            boolean check = true;

            for (int j = 0; j < s.length(); j++) {
                switch (s.charAt(j)) {
                    case '0':
                    case '4':
                    case '6':
                    case '8':
                    case '9':
                        continue loop;
                    case '2':
                    case '3':
                    case '5':
                    case '7':
                        if (check)
                            check = false;
                        else
                            continue loop;
                        break;
                }
            }
            if (!check)
                otv++;
        }

        System.out.println(otv);

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}