#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>

#define MOD 10000007

using namespace std;

typedef long long ll;

struct Sek {
    ll h;
    ll ml;
    ll mr;
};

int main() {
    cin.tie(0);
    cout.tie(0);

    ll n;

    cin >> n;

    vector<vector<Sek>> arr(n);
    vector<ll> max_group(n);

    for (int i = 0; i < n; ++i) {
        ll p;
        cin >> p;

        arr[i].push_back({p, p, p});
        max_group[i] = p;
    }

    while (n > 0) {
        ll h;
        cin >> h;
        h--;


        ll sum_w = 0;

        //левая часть
        ll max_right = max_group[h + 1];

        for (Sek &s : arr[h]) {
            if (s.mr < max_right) {
                s.mr = max_right;
            }
            sum_w += min(s.ml, s.mr) - s.h; //ОПТИМИЗАЦИЯ!!! ДОБАВИТЬ ПОЛЕ, НЕ ПЕРЕСЧИТЫВАТЬ КАЖДЫЙ РАЗ, ТОЛЬКО ПРИ ОБНОВЛЕНИИ
        }


        //правая часть

        ll max_left = max_group[h];

        for (Sek &s : arr[h + 1]) {
            if (s.ml < max_left) {
                s.ml = max_left;
            }
            sum_w += min(s.ml, s.mr) -
                     s.h; //ОПТИМИЗАЦИЯ!!! ДОБАВИТЬ ПОЛЕ, НЕ ПЕРЕСЧИТЫВАТЬ КАЖДЫЙ РАЗ, ТОЛЬКО ПРИ ОБНОВЛЕНИИ
        }


        for (Sek a : arr[h + 1]) {
            arr[h].push_back(a);
        }

        max_group[h] = max(max_left, max_right);

        arr.erase(arr.begin() + (h + 1) );
        max_group.erase(max_group.begin() + (h + 1) );

        cout << sum_w << endl;
        n--;
    }

}