#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>
#include <set>
#include <unordered_set>

#define MOD 10000007

using namespace std;

typedef long long ll;

ll alt(ll d, ll l, ll r) {
    ll otv = 0;

    for (int y = 1; y * y <= r; ++y) {
        if (y * y < l)
            continue;
        for (int x = y + 1; x * x <= r; ++x) {
            if (x * x - y * y == d) {
                otv++;
        //        printf("DEBUG x: %d, y: %d,  sqares: %d   %d, raznost: %d \n", x, y, x * x, y * y,
          //             x * x - y * y);
            }
        }

    }

    return otv;

}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
   // ios::sync_with_stdio(false);


    ll d, l, r;

    cin >> d;// >> l >> r;
    l = 1;
    r = 3000;

    ll sl = sqrt(l), sr = sqrt(r);
    if (sl * sl != l) sl++;

    vector<ll> dels;

    ll perd = d;

    for (ll i = 2; i * i <= perd; ++i) {
        if (perd % i == 0) {
            dels.push_back(i);
            perd /= i;
            i--;
        }
    }
    if (perd != 1)
        dels.push_back(perd);


    ll tu_pow = pow(2, dels.size());

    unordered_set<ll> st;

    for (int mask = 0; mask < tu_pow; ++mask) {
        ll a = 1;

        ll pms = mask;
        for (int pos = 0; pms > 0; ++pos) {
            if (pms % 2 == 1)
                a *= dels[pos];
            pms /= 2;
        }


        st.emplace(a);
    }

    ll otv = 0;

    for (ll a : st) {
        ll b = d / a;
        if (b % 2 != a % 2)
            continue;

        if (sl <= (b - a) / 2 && (b + a) / 2 <= sr) {
            otv++;
            //debug
            ll x = (b + a) / 2;
            ll y = (b - a) / 2;
         //   printf("a: %d, b: %d,     x: %d, y: %d,  sqares: %d   %d, raznost: %d \n", a, b, x, y, x * x, y * y,
         //          x * x - y * y);
            //end_debug
        }
    }

    if (otv != alt(d, l, r)) {
    //    cout << "ALARM ALARM ALARM    " << otv << " " << alt(d, l, r);
    }

    cout << otv << endl;
}