#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define pbc push_back
#define pob pop_back()
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define vin(a)        \
    for (auto& i : a) \
    cin >> i

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline void chkmin(T1& x, const T2& y) {
    if (y < x)
        x = y;
}

template <typename T1, typename T2>
inline void chkmax(T1& x, const T2& y) {
    if (x < y)
        x = y;
}

// l <= y^2 < x^2 <= r
// x^2 - y^2 = d
// (x - y) * (x + y) = d
// x - y = a
// x + y = b
// x = (a + b) / 2
// y = (b - a) / 2

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    int d;
    ll l, r;
    cin >> d >> l >> r;

    set<pair<int, int>> ans;

    auto check = [&](int a, int b) {
        if ((a + b) % 2 != 0) {
            return;
        }
        if (a > b) {
            return;
        }
        int x = (a + b) / 2;
        int y = (b - a) / 2;
        if (y < x && (ll)x * x <= r && l <= (ll)y * y) {
            ans.insert({y, x});
        }
    };

    for (int i = 1; i * i <= d; ++i) {
        if (d % i == 0) {
            check(i, d / i);
            check(d / i, i);
        }
    }

    cout << ans.size() << endl;
    return 0;
}
