#include<bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define pii pair<int,int>
#define pb push_back
struct treemax {
    int n;
    vector<int> tree;
    void init() {
        n = 131072;
        tree.resize(262144,0);
    }
    int unite(int a, int b) {
        return max(a,b);
    }
    void upd(int i, int x, int l, int r, int num) {
        if(i <l || i >= r) return;
        if(r-l==1) {
            tree[num]=i;
            return;
        }
        upd(i,x,l,(l+r)/2,2*num+1);
        upd(i,x,(l+r)/2,r,2*num+2);
        tree[num] = unite(tree[2*num+1],tree[2*num+2]);
    }
    void upd(int i, int x) {
        return upd(i,x,0,131072,0);
    }
    int get(int l, int r, int tl, int tr, int num) {
        if(tr <= l || r <= tl) return 0;
        if(tl >= l && tr <= r) {
            return tree[num];
        }
        return unite(get(l,r,tl,(tl+tr)/2,2*num+1), get(l,r,(tl+tr)/2,tr,2*num+2));
    }
    int get(int l, int r) {
        return get(l,r,0,131072,0);
    }
};
struct treesum {
    int n;
    vector<int> tree;
    vector<int> lazy;
    vector<int> sz;
    void init() {
        n = 131072;
        tree.resize(262144,0);
        lazy.resize(262144,0);
        sz.resize(262144);
        for(int i = n-1; i < sz.size(); ++i) {
            sz[i]=1;
        }
        for(int i = n-2; i >= 0; i--) {
            sz[i] = sz[2*i+1] + sz[2*i+2];
        }
    }
    void push(int num) {

            tree[num] = lazy[num] * sz[num];
            if(2*num+2 >= lazy.size()) return;
            lazy[2*num+1] = lazy[num];
            lazy[2*num+2] = lazy[num];
        lazy[num] =0;

    }
    int unite(int a, int b) {
        return a+b;
    }
    void upd(int i, int x, int l, int r, int num) {
        push(num);
        if(i <l || i >= r) return;
        if(r-l==1) {
            tree[num]=i;
            push(num);
            return;
        }
        upd(i,x,l,(l+r)/2,2*num+1);
        upd(i,x,(l+r)/2,r,2*num+2);
        tree[num] = unite(tree[2*num+1],tree[2*num+2]);

    }
    void upd(int i, int x) {
        return upd(i,x,0,131072,0);
    }
    int get(int l, int r, int tl, int tr, int num) {
        push(num);
        if(tr <= l || r <= tl) return 0;
        if(tl >= l && tr <= r) {
            return tree[num];
        }
        return unite(get(l,r,tl,(tl+tr)/2,2*num+1), get(l,r,(tl+tr)/2,tr,2*num+2));
    }
    int get(int l, int r) {
        return get(l,r,0,131072,0);
    }
    void massupd(int l, int r, int tl, int tr, int num) {
        push(num);

    }
};
void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for(int i= 0; i < n; ++i) {
        cin >> h[i];
    }
    treemax tm;
    treesum ts;
    treesum em;
    treesum he;
    for(int i = 0; i < n; ++i) {
        tm.upd(i,h[i]);
        ts.upd(i,1);
        em.upd(i,0);
        he.upd(i,h[i]);
    }
    for(int qqq = 0; qqq < n-1; ++qqq) {
        int k;

    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
   // cerr <<clock();
}