#include<bits/stdc++.h>

using namespace std;
#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#define int long long
#define f first
#define s second
#define pii pair<int,int>
#define pb push_back
struct treemax {
    int n;
    vector<int> tree;
    void init() {
        n = 131072;
        tree.resize(262144,0);
    }
    int unite(int a, int b) {
        return max(a,b);
    }
    void upd(int i, int x, int l, int r, int num) {
        if(i <l || i >= r) return;
        if(r-l==1) {
            tree[num]=x;
            return;
        }
        upd(i,x,l,(l+r)/2,2*num+1);
        upd(i,x,(l+r)/2,r,2*num+2);
        tree[num] = unite(tree[2*num+1],tree[2*num+2]);
    }
    void upd(int i, int x) {
        return upd(i,x,0,131072,0);
    }
    int get(int l, int r, int tl, int tr, int num) {
        if(tr <= l || r <= tl) return 0;
        if(tl >= l && tr <= r) {
            return tree[num];
        }
        return unite(get(l,r,tl,(tl+tr)/2,2*num+1), get(l,r,(tl+tr)/2,tr,2*num+2));
    }
    int get(int l, int r) {
        return get(l,r,0,131072,0);
    }
};
struct treesum {
    int n;
    vector<int> tree;
    vector<int> lazy;
    vector<int> sz;
    void init() {
        n = 131072;
        tree.resize(262144,0);
        lazy.resize(262144,0);
        sz.resize(262144);
        for(int i = n-1; i < sz.size(); ++i) {
            sz[i]=1;
        }
        for(int i = n-2; i >= 0; i--) {
            sz[i] = sz[2*i+1] + sz[2*i+2];
        }
    }
    void push(int num) {
            if(lazy[num]==0) return;
            tree[num] = lazy[num] * sz[num];
            if(2*num+2 >= lazy.size()) return;
            lazy[2*num+1] = lazy[num];
            lazy[2*num+2] = lazy[num];
        lazy[num] =0;

    }
    int unite(int a, int b) {
        return a+b;
    }
    void upd(int i, int x, int l, int r, int num) {

        if(i <l || i >= r) return;
        push(num);
        if(r-l==1) {
            tree[num]=x;
            push(num);
            return;
        }
        upd(i,x,l,(l+r)/2,2*num+1);
        upd(i,x,(l+r)/2,r,2*num+2);
        tree[num] = unite(tree[2*num+1],tree[2*num+2]);

    }
    void upd(int i, int x) {
        return upd(i,x,0,131072,0);
    }
    int get(int l, int r, int tl, int tr, int num) {
        push(num);
        if(tr <= l || r <= tl) return 0;
        if(tl >= l && tr <= r) {
            return tree[num];
        }
        return unite(get(l,r,tl,(tl+tr)/2,2*num+1), get(l,r,(tl+tr)/2,tr,2*num+2));
    }
    int get(int l, int r) {
        return get(l,r,0,131072,0);
    }
    void massupd(int l, int r, int x, int tl, int tr,  int num) {
        push(num);
        if(tr<=l||r<=tl) return;
        if(tl>=l&&tr<=r) {
            lazy[num] = x;
            push(num);
            return;
        }
        massupd(l,r,x,tl,(tl+tr)/2,2*num+1);
        massupd(l,r,x,(tl+tr)/2,tr,2*num+2);
        tree[num] = unite(tree[2*num+1],tree[2*num+2]);
    }
    void massupd(int l, int r, int x) {
        if(l>=r) return;
        return massupd(l,r,x,0,131072,0);
    }
};
void solve() {
    int n=100000;
    cin >> n;
    vector<int> h(n);
    for(int i= 0; i < n; ++i) {
        h[i] = i+1;
        cin >> h[i];
    }
    treemax maxh;
    treesum sumh;
    treesum lmax;
    treesum rmax;
    treesum ord;
    maxh.init();
    sumh.init();
    lmax.init();
    rmax.init();
    ord.init();
    for(int i = 0; i < n; ++i) {
        maxh.upd(i,h[i]);
        sumh.upd(i,h[i]);
        lmax.upd(i,h[i]);
        rmax.upd(i,h[i]);
        ord.upd(i,1);
    }
    ord.upd(n,1);
    for(int qqq = 0; qqq < n-1; ++qqq) {
        int k=1;
        cin >> k;

        int l = -1, r = n;
        while(r-l>1) {
            int ch = (l+r)/2;
            if(ord.get(0,ch) >= k) {
                r=ch;
            }
            else {
                l=ch;
            }
        }
        int st1= l;
        l = -1; r= n;
        while(r-l>1) {
            int ch = (l+r)/2;
            if(ord.get(0,ch) >= k+1) {
                r=ch;
            }
            else {
                l=ch;
            }
        }
        int st2 = l;
        l=-1; r = n+1;
        while(r-l>1) {
            int ch = (l+r)/2;
            if(ord.get(0,ch) >= k+2) {
                r=ch;
            }
            else {
                l=ch;
            }
        }
        int st3 = l;
        l = st1;
        r = st2+1;
        int secmax = maxh.get(st2,st3);
        while(r-l>1) {
            int ch = (l+r)/2;
            if(rmax.get(ch-1,ch) >= secmax) {
                l=ch;
            }
            else {
                r=ch;
            }
        }
        rmax.massupd(l,st2,secmax);
        int firstmax = maxh.get(st1,st2);
        l = st2-1;
        r=st3;
        while(r-l>1) {
            int ch = (l+r)/2;
            if(lmax.get(ch,ch+1) >= firstmax) {
                r = ch;
            }
            else {
                l = ch;
            }
        }
        lmax.massupd(st2,r,firstmax);
        l=st1-1;
        r=st3;
        while(r-l>1) {
            int ch = (l+r)/2;
            if(lmax.get(ch,ch+1) < rmax.get(ch,ch+1)) {
                l=ch;
            }
            else {
                r=ch;
            }
        }
        ord.upd(st2,0);
        cout << lmax.get(st1,r) + rmax.get(r,st3) - sumh.get(st1,st3) << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
    cerr <<clock();
}