#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include<string>
#include<cassert>

using namespace std;

#define int long long
#define pii pair<int,int>
//#define f first
//#define s second
#define pb push_back

tuple<int,int,int> dp[11000005];
void solve(){

    int n,s;
    cin >> n >> s;
    for(int i = 0; i <= n*(s+1); ++i) {
        dp[i] = {-2,-2,-2};
    }
    dp[0] = {-1,-1,-1};
    vector<int> k(n);

    vector<vector<int>> c(n);
    for(int i = 0; i < n; ++i) {
        cin >> k[i];
        for(int j = 0; j < k[i]; ++j) {
            int cost;
            cin >> cost;
            c[i].pb(cost);
        }
    }

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < k[i]; ++j) {
            vector<pii>push;
            for(int st = s-c[i][j]; st >= 0; --st) {

                if(i==0||get<0>(dp[(i-1)*(s+1)+st]) < -1||(i==1&&st==0)) {}
                else {
                    push.pb({i*(s+1)+st+c[i][j],1});
                    //dp[i*(s+1)+st+c[i][j]] = {i,j,1};
                }
                if(get<0>(dp[i*(s+1)+st])<-1) {}
                else {
                    push.pb({i*(s+1)+st+c[i][j],0});
                    //dp[i*(s+1)+st+c[i][j]] = {i,j,0};
                }

            }
            for(pii p: push) {
                if(get<0>(dp[p.first])<i) dp[p.first] = {i,j,p.second};
            }
        }
    }
    if(get<0>(dp[(n-1)*(s+1)+s])!= n-1) {
        cout << "No\n";
        return;
    }
    vector<vector<int>> ans(n);
    int now = (n-1)*(s+1)+s;
    while(now>0) {
        auto p = dp[now];
        now -= c[get<0>(p)][get<1>(p)];
        now -= (s+1)*get<2>(p);
        ans[get<0>(p)].pb(get<1>(p));
    }
    cout << "Yes\n";
    for(int i = 0; i < n; ++i) {
        assert(ans[i].size()>0);
        cout << ans[i].size() << '\n';
        for(int j: ans[i]) {
            cout << j+1 << ' ';

        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t=1;
    //cin >> t;
    while(t--) {
        solve();
    }
}