#pragma GCC optimize(" unroll-loops")
#pragma gcc optimize("Ofast")
#pragma GCC optimization("Ofast")
#pragma optimize(Ofast)
#include <bits/stdc++.h>
#include <random>
#include <utility>
//#define int long long
#define ld long double
#define inf 1'000'000'000'000'000'000
#define eps 1e-12
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const long long p = 1'000'000'007;
const long long ahs = rng() % p;
const long long bhs = rng() % p;
const long long yhs = rng() % p;
# define M_PI 3.1415926535897932384
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


long long hs(long long x) {
    if (x < 0) {
        x += p;
        x %= p;
    }
    return (ahs * x % p + bhs) % p;
}

long long shs(string s) {
    long long ans = 0;
    long long pos = 1;
    for (auto c: s) {
        ans += hs(c) * pos % p;
        pos *= yhs;
        pos %= p;
        ans %= p;
    }
    return ans;
}

long long po(long long n, long long deg, long long mod = p) {
    if (deg == 0) {
        return 1 % mod;
    }
    auto pre = po(n, deg / 2, mod);
    if (deg % 2 == 0) {
        return pre * pre % mod;
    }
    return ((pre * n) % mod) * pre % mod;
}

template<typename T>
struct Point {
    T x, y;
    Point(): x(0), y(0) {
    }
    Point(T x_, T y_): x(x_), y(y_) {
    }
    Point operator+(const Point& other) const {
        return {x + other.x, y + other.y};
    }
    Point operator-(const Point& other) const {
        return {x - other.x, y - other.y};
    }
    bool operator<(const Point& other) const {
        return (x < other.x) || (x == other.x) && (y < other.y);
    }
    bool operator>(const Point& other) const {
        return (x > other.x) || (x == other.x) && (y > other.y);
    }
    bool operator<=(const Point& other) const {
        return !(*this > other);
    }
    bool operator>=(const Point& other) const {
        return !(*this < other);
    }
    T operator*(const Point& other) const {
        return x * other.x + y * other.y;
    }
    T operator^(const Point& other) const {
        return x * other.y - y * other.x;
    }
};

int phi(int x) {
    int ans = x;
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            ans *= (i - 1);
            ans /= i;
            while (x % i == 0) {
                x /= i;
            }
        }
    }
    if (x > 1) {
        ans *= (x - 1);
        ans /= x;
    }
    return ans;
}

struct LdPoint: Point<ld> {
    [[nodiscard]] ld norm() const {
        return sqrtl((*this) * (*this));
    }
    [[nodiscard]] ld cos() const {
        return x / norm();
    }
    [[nodiscard]] ld sin() const {
        return y / norm();
    }
    [[nodiscard]] ld tg() const {
        return y / x;
    }
    [[nodiscard]] ld acos() const {
        return acosl(x / norm());
    }
};

vector<vector<long long>> matmul(vector<vector<long long>> a1, vector<vector<long long>> a2) {
    vector<vector<long long>> ans(a1.size(), vector<long long> (a2[0].size(), 0));
    for (int i = 0; i < a1.size(); i++) {
        for (int j = 0; j < a2[0].size(); j++) {
            for (int k = 0; k < a2.size(); k++) {
                ans[i][j] += a1[i][k] * a2[k][j] % p;
                ans[i][j] %= p;
            }
        }
    }
    return ans;
}

vector<vector<long long>> mapo(vector<vector<long long>> &n, long long deg) {
    if (deg == 0) {
        vector<vector<long long>> ans(n.size(), vector<long long> (n.size(), 0));
        for (long long i = 0; i < ans.size(); i++) {
            ans[i][i] = 1;
        }
        return ans;
    }
    auto pre = mapo(n, deg / 2);
    if (deg % 2 == 0) {
        return matmul(pre, pre);
    }
    return matmul(pre, matmul(pre, n));
}

template<typename T>
bool clock_triple(Point<T> p1, Point<T> p2, Point<T> p3) {
    return ((p2 - p1) ^ (p3 - p1)) > 0;
}

template<typename T>
bool colin(Point<T> p1, Point<T> p2) {
    return (p1 ^ p2) == 0;
}

struct Segs {
    map<int, int> data;
    Segs() = default;

    pair<int, int> last() {
        auto pnt = data.rbegin();
        return *pnt;
    }

    int add(int l, int r) {
        //cout << l << " " << r << '\n';
        auto pnt = data.lower_bound(l);
        if (pnt == data.end()) {
            if (data.empty()) {
                data[l] = r;
                return r - l + 1;
            }
            auto [x, y] = last();
            //cout << x << y << "q";
            if (y >= r) {
                return 0;
            }
            if (y < l) {
                data[l] = r;
                return r - l + 1;
            }
            data[x] = r;
            return r - y;
        }
        if (pnt == data.begin()) {
            auto [x, y] = *pnt;
            if (x > r) {
                data[l] = r;
                return r - l + 1;
            }
            if (y >= r) {
                data.erase(x);
                data[l] = y;
                return x - l;
            }
            data.erase(x);
            return add(l, r) - (y - x + 1);
        }
        pnt--;
        auto [x, y] = *pnt;
        if (y >= r) {
            return 0;
        }
        if (y >= l) {
            return add(y + 1, r);
        }
        pnt++;
        auto [x1, y1] = *pnt;
        if (x1 > r) {
            data[l] = r;
            return r - l + 1;
        }
        if (y1 >= r) {
            data.erase(x1);
            data[l] = y1;
            return x1 - l;
        }
        data.erase(x1);
        return add(l, r) - (y1 - x1 + 1);
    }
};

template<typename T>
vector<int> prefixfunc(vector<T> &s) {
    vector<int> ans{-1, 0};
    for (int i = 1; i < s.size(); i++) {
        int k = ans[i];
        while (k != -1 and s[k] != s[i]) {
            k = ans[k];
        }
        ans.push_back(k + 1);
    }
    return ans;
}

template<typename T>
bool chkperp(Point<T> x, Point<T> y, Point<T> z) {
    auto v1 = x - y;
    auto v2 = z - y;
    if (v1 * v2 < 0) {
        return false;
    }
    auto v3 = y - x;
    auto v4 = z - x;
    if (v3 * v4 < 0) {
        return false;
    }
    return true;
}

vector<int> bits(long long x) {
    vector<int> ans;
    while (x > 0) {
        ans.push_back(x % 2);
        x /= 2;
    }
    return ans;
}

template<typename T>
T st_op(T left, T right) {
    return max(left, right);
}

template<typename T>
T st_accelerate(T prev, T add) {
    return prev;
}

template<typename T>
T st_push(int l, int r, T what) {
    return what;
}

template<typename T>
struct st {
    int n;
    int l, r;
    T neutral;
    vector<T> elems;
    vector<T> lazy;
    void build(vector<T> &arr, int node, int start, int end) {
        //cout << 1;
        if (start == end) {
            if (start < arr.size()) {
                elems[node] = arr[start];
            }
            return;
        }
        int mid = (start + end) / 2;
        build(arr, 2 * node, start, mid);
        build(arr, 2 * node + 1, mid + 1, end);
        elems[node] = st_op(elems[2 * node], elems[2 * node + 1]);
    }

    void push(int node, int start, int end) {
        if (lazy[node] != neutral) {
            elems[node] = st_push(start, end, lazy[node]);
            if (start != end) {
                lazy[2 * node] = st_accelerate(lazy[2 * node], lazy[node]);
                lazy[2 * node + 1] = st_accelerate(lazy[2 * node + 1], lazy[node]);
            }
            lazy[node] = neutral;
        }
    }

    void update(int node, int start, int end, T val) {
        push(node, start, end);
        if (r < start or l > end) {
            return;
        }
        if (l <= start and r >= end) {
            lazy[node] = st_accelerate(lazy[node], val);
            push(node, start, end);
            return;
        }
        int mid = (start + end) / 2;
        update(2 * node, start, mid, val);
        update(2 * node + 1, mid + 1, end, val);
        elems[node] = st_op(elems[node * 2], elems[node * 2 + 1]);
    }

    void update(int l_, int r_, T val) {
        l = l_;
        r = r_;
        update(1, 0, n - 1, val);
    }

    T query(int node, int start, int end) {
        push(node, start, end);
        if (r < start or l > end) {
            return neutral;
        }
        if (l <= start and r >= end) {
            return elems[node];
        }
        int mid = (start + end) / 2;
        T left = query(2 * node, start, mid);
        T right = query(2 * node + 1, mid + 1, end);
        return st_op(left, right);
    }

    T query(int l_, int r_) {
        l = l_;
        r = r_;
        return query(1, 0, n - 1);
    }

    st(vector<T> &arr, T neutral_): neutral(neutral_) {
        int s = arr.size();
        int hf = 1;
        while (hf < s) {
            hf *= 2;
        }
        n = hf;
        elems = vector<T> (2 * hf, neutral);
        lazy = vector<T> (2 * hf, neutral);
        build(arr, 1, 0, n - 1);
    }
};

struct dsu {
    vector<int> prev;
    vector<int> sz;
    dsu(int n) {
        prev = vector<int> (n);
        for (int i = 0 ; i < n; i++) {
            prev[i] = i;
        }
        sz = vector<int> (n, 1);
    }

    int root(int x) {
        if (prev[x] == x) {
            return x;
        }
        return root(prev[x]);
    }

    bool unite(int x, int y) {
        x = root(x);
        y = root(y);
        if (x == y) {
            return false;
        }
        if (sz[x] < sz[y]) {
            swap(x,y );
        }
        sz[x] += sz[y];
        prev[y] = x;
        return true;
    }
};

void solve(long long tc) {
    int n, k;
    cin >> n >> k;
    vector<int> cols(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> cols[i];
    }
    int ma = k * (k + 1) / 2;
    vector<int> alo(ma + 1, 1);
    for (int i = 1; i <= ma; i++) {
        alo[i] = alo[i - 1] * 2;
    }
    vector<long long> ans(1 << ma, 0);
    ans[0] = 1;
    for (int i = 0; i < n; i++) {
        vector<long long> preans(1 << ma, 0);
        for (int j = 0; j < ans.size(); j++) {
            int bitsi = 0;
            int s1 = 0;
            for (int d = 0; d < k; d++) {
                s1++;
                for (int d1 = 1; d1 < k - d; d1++) {
                    if ((alo[s1] & j) > 0) {
                        bitsi++;
                    }
                    s1++;
                }
            }
            for (int j1 = 0; j1 < alo[k]; j1++) {
                int lipsi = 0;
                for (int d = 0; d < k; d++) {
                    if ((j1 & alo[d]) > 0) {
                        lipsi++;
                    }
                }
                if (bitsi + lipsi != cols[i]) {
                    continue;
                }
                int ind = 0;
                int su = 0;
                int bli = 0;
                for (int d1 = 0; d1 < k; d1++) {
                    for (int d2 = 0; d2 < k - d1 - 1; d2++) {
                        if ((alo[su + 1] & j) > 0) {
                            ind += alo[su];
                            bli++;
                        }
                        su++;
                    }
                    if ((alo[d1] & j1) > 0) {
                        ind += alo[su];
                        bli++;
                    }
                    su++;
                }
                preans[ind] += ans[j];
                preans[ind] %= p;
            }
        }
        ans = preans;
    }
    long long finans = 0;
    for (int i = 0; i < ans.size(); i++) {
        finans += ans[i];
        finans %= p;
    }
    cout << finans;
}

signed main() {
    cin.tie(nullptr);cout.tie(nullptr);ios::sync_with_stdio(false);
    int tests;
    tests = 1;
    //cin >> tests;
    int pre = tests;
    while (tests--) {
        solve(pre - tests);
    }
    return 0;
}
