//  ↘ ⬇ ⬇ ⬇ ⬇ ⬇ ↙
//  ➡ @roadfromroi ⬅
//  ↗ ⬆ ⬆ ⬆ ⬆ ⬆ ↖
/*
░░░░░░░█▐▓▓░████▄▄▄█▀▄▓▓▓▌█
░░░░░▄█▌▀▄▓▓▄▄▄▄▀▀▀▄▓▓▓▓▓▌█
░░░▄█▀▀▄▓█▓▓▓▓▓▓▓▓▓▓▓▓▀░▓▌█
░░█▀▄▓▓▓███▓▓▓███▓▓▓▄░░▄▓▐█▌
░█▌▓▓▓▀▀▓▓▓▓███▓▓▓▓▓▓▓▄▀▓▓▐█
▐█▐██▐░▄▓▓▓▓▓▀▄░▀▓▓▓▓▓▓▓▓▓▌█▌
█▌███▓▓▓▓▓▓▓▓▐░░▄▓▓███▓▓▓▄▀▐█
█▐█▓▀░░▀▓▓▓▓▓▓▓▓▓██████▓▓▓▓▐█
▌▓▄▌▀░▀░▐▀█▄▓▓██████████▓▓▓▌█▌
▌▓▓▓▄▄▀▀▓▓▓▀▓▓▓▓▓▓▓▓█▓█▓█▓▓▌█▌
█▐▓▓▓▓▓▓▄▄▄▓▓▓▓▓▓█▓█▓█▓█▓▓▓▐█ йоу
 */
#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "iomanip"
#include "bitset"
#include "cmath"
#include "map"
#include "deque"
#include "array"
#include "set"
#define all(x) x.begin(), x.end()
using namespace std;
#define int long long
struct segtree {
    int sz;
    vector<int> tree;
    void init(int n) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, {});
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = i;
        }
        for (int i = n; i < sz; ++i) {
            tree[i + sz] = 1e9;
        }
    }
    int getv(int v) {
        v += sz;
        int res = 0;
        while (v) {
            res += tree[v];
            v /= 2;
        }
        return res;
    }
    void ch(int l, int r, int x) {
        l += sz;
        r += sz;
        while (l <= r) {
            if (l % 2) {
                tree[l++] += x;
            }
            if (r % 2 == 0) {
                tree[r--] += x;
            }
            l /= 2;r /= 2;
        }
    }
};
struct segtreemx {
    int sz;
    vector<pair<int, int>> tree;
    void init(int n, vector<int> a) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, {});
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = {a[i]+1, i};
        }
        for (int i = sz-1; i >= 1; --i) {
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    void tozer(int v) {
        v += sz;
        tree[v].first = 0;
        while (v != 1) {
            v /= 2;
            tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
        }
    }
    int gtmxp(int l, int r) {
        pair<int, int> res = {0, 0};
        l += sz;
        r += sz;
        while (l <= r) {
            if (l % 2) {
                res = max(res, tree[l++]);
            }
            if (r % 2 == 0) {
                res = max(res, tree[r--]);
            }
            l /= 2;r /= 2;
        }
        return res.second;
    }
};
struct myarr {
    deque<pair<int, int>> pep;
    int addres = 0;
    myarr() {

    }
    myarr(int x) {
        pep = {{x, 1}};
        return;
    }
    void push_back(pair<int, int> a) {
        if (pep.empty()) {
            pep.push_back(a);
            return;
        }
        while (pep.size() > 1 and pep.end()[-2].first > pep.end()[-1].first and pep.end()[-1].first < a.first) {
            if (pep.end()[-2].first > a.first) {
                a.second += pep.back().second;
                addres += (a.first - pep.back().first) * pep.back().second;
            } else {
                pep.end()[-2].second += pep.end()[-1].second;
                addres += (pep.end()[-2].first - pep.back().first) * pep.back().second;
            }
            pep.pop_back();
        }
        if (pep.back().first == a.first) {
            pep.back().second += a.second;
            return;
        }
        pep.push_back(a);
    }
    void push_front(pair<int, int> a) {
        if (pep.empty()) {
            pep.push_front(a);
            return;
        }
        while (pep.size() > 1 and pep[1].first > pep[0].first and pep[0].first < a.first) {
            if (pep[1].first > a.first) {
                a.second += pep[0].second;
                addres += (a.first - pep[0].first) * pep[0].second;
            } else {
                pep[1].second += pep[0].second;
                addres += (pep[1].first - pep[0].first) * pep[0].second;
            }
            pep.pop_front();
        }
        if (pep[0].first == a.first) {
            pep[0].second += a.second;
            return;
        }
        pep.push_front(a);
    }
};
void merg(myarr &a, myarr &b) {
    if (a.pep.size() < b.pep.size()) {
        b.addres += a.addres;
        while (!a.pep.empty()) {
            b.push_front(a.pep.back());
            a.pep.pop_back();
        }
        swap(a, b);
    } else {
        a.addres += b.addres;
        while (!b.pep.empty()) {
            a.push_back(b.pep.front());
            b.pep.pop_front();
        }
    }
}
vector<int> ans;
myarr slv(int l, int r, vector<int> &h, vector<int> &p, segtreemx &sg) {
    if (l == r) {
        return myarr(h[l]);
    }
    int t = sg.gtmxp(l, r-1);
    myarr a1 = slv(l, t, h, p, sg), a2 = slv(t+1, r, h, p, sg);
    /*

    cerr << p[t] << endl;
    for (auto i : a1.pep)
        cerr << i.first << ' ';
    cerr << '\n';
    for (auto i : a2.pep)
        cerr << i.first << ' ';
    cerr << '\n';
    cerr << "res\n";
     */
    merg(a1, a2);
     /*
    for (auto i : a1.pep)
        cerr << i.first << ' ';
    cerr << '\n';

     */
    //cerr << a1.addres << '\n';
    ans[p[t]] = a1.addres;
    return a1;
}
void solve() { // 2 3 5 7
    int n;
    cin >> n;
    ans.assign(n-1,{});
    vector<int> h(n);
    vector<int> ed(n-1);
    vector<int> p(n-1);
    segtree sg;
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    sg.init(n-1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> ed[i];
        ed[i]--;
        int l = 0, r = n;
        while (l + 1 < r) {
            int m = l + r >> 1;
            //cerr << m << ' ' << sg.getv(m) << endl;
            if (sg.getv(m) <= ed[i])
                l = m;
            else
                r = m;
        }
        //cerr << "!" << l << ' ' << ed[i] << ' ' << sg.getv(l) << '\n';
        sg.ch(l+1, n-1, -1);
        p[l] = i;
    }
    segtreemx sg2;
    sg2.init(n-1, p);
    slv(0, n-1, h, p, sg2);
    for (auto i : ans)
        cout << i << '\n';

}
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int t=1;
    while (t--) {
        solve();
    }
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
 */