#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;


int main(){
    int n, m, k;
    cin >> n >> m >> k;
    vector<unsigned> lm(k);
    for (int i = 0; i < k; i ++){
        int x, y;
        cin >> x >> y;
        x --, y --;
        lm[i] = x * m + y;
    }
    lm.push_back(0);
    lm.push_back(n * m - 1);
    unordered_map<unsigned, int> wh;
    vector<unsigned> st;
    for (unsigned i = 0; i < (1u << n * m); i ++)
        if (__builtin_popcount(i) <= n + n + m + m - 4){
            wh[i] = st.size();
            st.push_back(i);
        }
    vector<vector<vector<int>>> dp(n, vector<vector<int>>(m, vector<int>(st.size(), 0)));
    dp[0][0][0] = 1;
    for (int msk = 1; msk < st.size(); msk ++)
        for (int i = 0; i < n; i ++)
            for (int j = 0; j < m; j ++){
                unsigned x = i * m + j;
                if ((st[msk] >> x) & 1u){
                    unsigned l = wh[st[msk] ^ (1u << x)];
                    if (i) dp[i][j][msk] += dp[i - 1][j][l];
                    if (j) dp[i][j][msk] += dp[i][j - 1][l];
                    if (i != n - 1) dp[i][j][msk] += dp[i + 1][j][l];
                    if (j != m - 1) dp[i][j][msk] += dp[i][j + 1][l];
                }
            }
    int ans = 0;
    for (int msk = 0; msk < st.size(); msk ++)
        if (__builtin_popcount(st[msk]) == n + n + m + m - 4){
            bool ok = true;
            for (auto i: lm) ok = ok and ((st[msk] >> i) & 1u);
            if (ok) ans += dp[0][0][msk];
        }
    cout << ans << "\n";
}
