//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;
// typedef long double ld;
const ll INF = 1e9;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout << fixed;
    // cout.precision(5);
    int n, m, k;
    cin >> n >> m >> k;
    vector< vector<ll> > dp(n, vector<ll> (m, INF));
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            for (int a = 1; a <= k; ++a) {
                if (i + a < n) dp[i + a][j] = min(dp[i + a][j], dp[i][j] + 1);
                if (j + a < m) dp[i][j + a] = min(dp[i][j + a], dp[i][j] + 1);
                if (i + a < n && j + a < m) dp[i + a][j + a] = min(dp[i + a][j + a], dp[i][j] + 1);
            }
        }
    cout << dp[n - 1][m - 1];
    return 0;
}
