//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <queue>

using namespace std;
typedef long long ll;
// typedef long double ld;
const ll INF = 1e9;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout << fixed;
    // cout.precision(5);
    int n, m, k;
    cin >> n >> m >> k;
    vector< vector<ll> > dp(n, vector<ll> (m, INF));
    dp[0][0] = 0;
    queue< pair<int, int> > Q;
    Q.push({0, 0});
    while (!Q.empty()) {
        auto [i, j] = Q.front();
        Q.pop();
        for (int d = k; d >= 1; --d) {
            if (i + d < n && dp[i + d][j] == INF) {
                dp[i + d][j] = dp[i][j] + 1;
                Q.push({i + d, j});
            }
            if (j + d < m && dp[i][j + d] == INF) {
                dp[i][j + d] = dp[i][j] + 1;
                Q.push({i, j + d});
            }
            if (i + d < n && j + d < m && dp[i + d][j + d] == INF) {
                dp[i + d][j + d] = dp[i][j] + 1;
                Q.push({i + d, j + d});
            }
        }
    }
    cout << dp[n - 1][m - 1];
    return 0;
}