//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <unordered_map>
#include <queue>

using namespace std;
typedef long long ll;
// typedef long double ld;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    // cout << fixed;
    // cout.precision(5);
    int n, m, k;
    cin >> n >> m >> k;
    unordered_map< int, unordered_map<int, ll> > M;
    M[0][0] = 0;
    queue< pair<int, int> > Q;
    Q.push({0, 0});
    while (!Q.empty()) {
        auto [i, j] = Q.front();
        Q.pop();
        ll di = min(n - i - 1, k);
        if (i + di < n && !M[i + di][j]) {
            M[i + di][j] = M[i][j] + 1;
            Q.push({i + di, j});
        }
        ll dj = min(m - j - 1, k);
        if (j + dj < m && !M[i][j + dj]) {
            M[i][j + dj] = M[i][j] + 1;
            Q.push({i, j + dj});
        }
        ll dij = min(di, dj);
        if (i + dij < n && j + dij < m && !M[i + dij][j + dij]) {
            M[i + dij][j + dij] = M[i][j] + 1;
            Q.push({i + dij, j + dij});
        }
    }
    cout << M[n - 1][m - 1];
    return 0;
}