#include <iostream>
#include <cmath>
#include <vector>
// #include <bitset>

using namespace std;
typedef long long ll;
const ll INF = 1e18;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k; cin >> n >> k;
    vector<ll> A(n), P(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        P[i + 1] = P[i] + A[i];
    }
    ll answer = -INF;
    for (int l = 0; l < n - 1; ++l)
        for (int r = l; r < n && (n - (r - l + 1) >= k - 1); ++r) {
            for (int l_ = 0; l_ < l; ++l_)
                for (int r_ = l_; r_ < l && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
            for (int l_ = r + 1; l_ < n; ++l_)
                for (int r_ = l_; r_ < n && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
        }
    cout << answer;
}
