#include <iostream>
#include <cmath>
#include <vector>
// #include <bitset>

using namespace std;
typedef long long ll;
const ll INF = 1e18;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k; cin >> n >> k;
    vector<ll> A(n), P(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        P[i + 1] = P[i] + A[i];
    }
    if (k == 2) {
        vector< vector<ll> > D(n, vector<ll> (n, -INF));
        for (int l = 0; l < n; ++l)
            D[l][l] = A[l];
        for (int a = 1; a < n - 1; ++a)
            for (int l = 0; l < n - a; ++l)
                D[l][l + a] = min(D[l + 1][l + a], D[l][l + a - 1]);
        ll answer = -INF;
        for (int l = 0; l < n; ++l)
            for (int r = l; r < n; ++r)
                answer = max(answer, (P[r + 1] - P[l]) - min((l > 0 ? D[0][l - 1] : INF), (r + 1 < n ? D[r + 1][n - 1] : INF)));
        cout << answer;
        return 0;
    }
    ll answer = -INF;
    for (int l = 0; l < n - 1; ++l)
        for (int r = l; r < n && (n - (r - l + 1) >= k - 1); ++r) {
            for (int l_ = 0; l_ < l; ++l_)
                for (int r_ = l_; r_ < l && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
            for (int l_ = r + 1; l_ < n; ++l_)
                for (int r_ = l_; r_ < n && (n - (r - l + 1) - (r_ - l_ + 1) >= k - 2); ++r_) {
                    if ((P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]) <= answer) continue;
                    answer = (P[r + 1] - P[l]) - (P[r_ + 1] - P[l_]);
                }
        }
    cout << answer;
    return 0;
}
