#include <iostream>
#include <vector>
#include <set>;
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

bool f(ll x, ll l, ll r) {
    return x * x <= r && x * x >= l;
}

void solve() {
    ll d, l, r;
    cin >> d >> l >> r;
    ll m = d;
    vector<ll> del;
    ll t = 2;
    while (t * t <= d) {
        while (d % t == 0) {
            del.push_back(t);
            d /= t;
        }
        t++;
        if (t != 3) {
            t++;
        }
    }
    if (d != 1) {
        del.push_back(d);
    }
    ll n = del.size();
    set<ll> s;
    ll ans = 0;
    for (ll i = 0; i < (1 << n); i++) {
        ll x = 1;
        for (ll j = 0; j < n; j++) {
            if (((i >> j) & 1) == 1) {
                x *= del[j];
            }
        }
        ll y = m / x;
        if (s.find(x) == s.end()) {
            s.insert(x);
            s.insert(y);
            ll q = abs(x - y);
            if (q % 2 == 0) {
                ll a = q / 2;
                ll b = min(x, y) + a;
                if (f(a, l, r) && f(b, l, r)) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
