#include <iostream>
#include <vector>
#include <set>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e14;
const ll mod = 1e9 + 7;

ll n;
vector<ll> ls;
vector<ll> pref;

ll f(ll ma, ll mi, ll ind, ll ost, ll now) {
    if (ind == n) {
        if (ost == 0) {
            ma = max(ma, now);
            mi = min(mi, now);
            return ma - mi;
        }
        return -inf;
    }
    if (n - ind < ost) {
        return -inf;
    }
    if (ost == 0) {
        ma = max(ma, pref[n] - pref[ind] + now);
        mi = min(mi, pref[n] - pref[ind] + now);
        return ma - mi;
    }
    ll ans = f(ma, mi, ind + 1, ost, now + ls[ind]);
    ll ans2 = f(max(ma, now), min(mi, now), ind + 1, ost - 1, ls[ind]);
    return max(ans, ans2);
}

void solve() {
    ll k;
    cin >> n >> k;
    ls.resize(n);
    pref.resize(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i];
        pref[i + 1] = pref[i] + ls[i];
    }
    cout << f(-inf, inf, 1, k - 1, ls[0]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
