#include <iostream>
#include <set>
#include <bitset>
#include <vector>
#include <map>;
using namespace std;
using ll = long long;

void solve() {
    bitset<100001> s;
    s[0] = true;
    ll n, c;
    cin >> n >> c;
    vector<vector<ll>> ls(n);
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        ls[i].resize(k);
        for (ll j = 0; j < k; j++) {
            cin >> ls[i][j];
        }
    }
    vector<pair<ll, ll>> last(c + 1, {-1, -1});
    vector<pair<ll, ll>> last1(c + 1, {-1, -1});
    vector<pair<ll, ll>> last2(c + 1, {-1, -1});
    map<pair<ll, pair<ll, ll>>, pair<ll, ll>> m;
    for (ll i = 0; i < n; i++) {
        bitset<100001> s1;
        vector<bool> have(c + 1, false);
        for (ll j = 0; j < ls[i].size(); j++) {
            s1 |= (s << ls[i][j]);
            for (ll e = 0; e <= c; e++) {
                if (s1[e] && !have[e]) {
                    have[e] = true;
                    last[e] = {i, j};
                    m[{e, {i, j}}] = last1[e - ls[i][j]];
                    if (last1[e - ls[i][j]].first == -1) {
                        m[{e, {i, j}}] = last[e - ls[i][j]];
                    }
                }
            }
            s |= (s << ls[i][j]);
            last1 = last;
        }
        s = s1;
    }
    if (s[c]) {
        cout << "Yes\n";
        ll ost = c;
        vector<vector<ll>> ans(n);
        auto [i, j] = last[ost];
        while (ost != 0) {
            ans[i].push_back(j);
            ll sap = ost;
            ost -= ls[i][j];
            ll i1 = i;
            i= m[{sap, {i, j}}].first;
            j = m[{sap, {i1, j}}].second;
        }
        for (ll i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            set<ll> sr;
            for (auto j : ans[i]) {
//                if (sr.find(j) != sr.end()) {
//                    cout << n / 0;
//                }
//                sr.insert(j);
                cout << j + 1 << ' ';
            }
            cout << '\n';
        }
    } else {
        cout << "No";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
