#include <iostream>
#include <set>
#include <bitset>
#include <vector>
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

void solve() {
    bitset<100001> s;
    s[0] = true;
    ll n, c;
    cin >> n >> c;
    vector<vector<ll>> ls(n);
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        ls[i].resize(k);
        for (ll j = 0; j < k; j++) {
            cin >> ls[i][j];
        }
    }
    vector<pair<ll, ll>> last(c + 1, {-1, -1});
    for (ll i = 0; i < n; i++) {
        bitset<100001> s1;
        vector<bool> have(c + 1, false);
        for (ll j = 0; j < ls[i].size(); j++) {
            s1 |= (s << ls[i][j]);
            for (ll e = 0; e <= c; e++) {
                if (s1[e] && !have[e]) {
                    have[e] = true;
                    last[e] = {i, j};
                }
            }
            s |= (s << ls[i][j]);
        }
        s = s1;
    }
    if (s[c]) {
        cout << "Yes\n";
        ll ost = c;
        vector<vector<ll>> ans(n);
        while (ost != 0) {
            auto [i, j] = last[ost];
            ans[i].push_back(j);
            ost -= ls[i][j];
        }
        for (ll i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            for (auto j : ans[i]) {
                cout << j + 1 << ' ';
            }
            cout << '\n';
        }
    } else {
        cout << "No";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
