#include <iostream>
#include <set>
#include <bitset>
#include <vector>
#include <map>;
using namespace std;
using ll = long long;
using ld = long double;
const ld eps = 1e-9;
const ll inf = 1e16;
const ll mod = 1e9 + 7;

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    if (n == 3) {
        vector<bool> s(m, false);
        ll f = 0, t = m + 1;
        for (ll i = 0; i < k; i++) {
            ll x, y;
            cin >> x >> y;
            if (x == 1) {
                f = max(f, y - 1);
            } else if (x == 2) {
                s[y - 1] = true;
            } else {
                t = min(t, y - 1);
            }
        }
        ll ans = 0;
        for (ll i = f; i < m; i++) {
            for (ll j = 0; j <= min(i - 1, t); j++) {
                bool fl = true;
                for (ll e = j + 1; e < i; e++) {
                    if (s[e]) {
                        fl = false;
                        break;
                    }
                }
                if (fl) {
                    ans = (ans + 1) % mod;
                }
            }
        }
        cout << (ans * 2) % mod;
        return;
    }
    vector<pair<ll, ll>> ls(k);
    for (ll i = 0; i < n; i++) {
        cin >> ls[i].first >> ls[i].second;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
