#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
const ll INF = 1e10 + 100;

vector<ll> a;
ll left(ll x) {
    ll l = -1, r = a.size();
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (a[mid] >= x) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    return r;
}

ll right(ll x) {
    ll l = -1, r = a.size();
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (a[mid] <= x) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return l;
}

bool binsearch(ll x) {
    ll l = -1, r = a.size();
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (a[mid] == x) {
            return true;
        }
        else if (a[mid] > x) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll d, l, r;
    cin >> d >>  l >> r;
    ll n = 1;
    while (n * n < INF) {
        a.push_back(n * n);
        n += 1;
        //cout << n << " ";
    }
    //for (auto it: a) cout << it << " ";
    ll l1 = a[left(l)], r1 = a[right(r)];
    ll ind = left(l);
    //cout << l1 << " " << r1;
    ll cnt = 0;
    while (l1 + d <= r1) {
        //cout << l1 + d << " ";
        if (binsearch(l1 + d)) {
            cnt++;
        }
        if (ind + 1 < a.size()) {
            l1 = a[ind + 1];
            ind++;
            //cout << l1 << " ";
        }
        else {
            break;
        }
    }
    cout << cnt;
}
