#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;
typedef long long ll;
const ll INF = 1e18;

ll solve(ll n, ll k, vector<ll>& a, vector<ll>& pref) {
    ll l = n - k + 1;
    ll mx = -INF;
    ll i1, i2;
    ll ml = INF;
    for (int i = l; i <= n; ++i) {
        //cout << pref[i] - pref[i - l] << " ";
        if (pref[i] - pref[i - l] > mx) {
            mx = pref[i] - pref[i - l];
            i1 = i - l;
            i2 = i - 1;
        }
    }
    //cout << i1 << " " << i2 << "\n";
    for (int i = 0; i < n; ++i) {
        if (a[i] < ml && (i < i1 || i > i2)) {
            ml = a[i];
        }
    }
    return mx;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, k;
    cin >> n >> k;
    //cout << n << k;
    if (k == 2) {
        //cout << 1;
        vector<ll> a(n);
        vector<ll> pref(n + 1);
        ll ml = INF;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            pref[i + 1] = pref[i] + a[i];
        }
        //for (auto it: pref) cout << it << " ";
        ll l = n - k + 1;
        ll mx = -INF;
        ll i1, i2;
        for (int i = l; i <= n; ++i) {
            //cout << pref[i] - pref[i - l] << " ";
            if (pref[i] - pref[i - l] > mx) {
                mx = pref[i] - pref[i - l];
                i1 = i - l;
                i2 = i - 1;
            }
        }
        //cout << i1 << " " << i2 << "\n";
        for (int i = 0; i < n; ++i) {
            if (a[i] < ml && (i < i1 || i > i2)) {
                ml = a[i];
            }
        }
        cout << mx - ml;
    }
    else if (k == 3) {
        vector<ll> a(n);
        vector<ll> pref(n + 1);
        ll ml = INF;
        ll ind = 0;
        vector<ll> in;
        ll ans = -INF;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            if (a[i] < ml) {
                ml = a[i];
                //ind = i;
            }
            pref[i + 1] = pref[i] + a[i];
        }
        for (int i = 0; i < n; ++i) {
            if (a[i] == ml) {
                in.push_back(i);
            }
        }
        for (auto ind: in) {
            if (ind == 0) {
                vector<ll> b;
                vector<ll> pref1(n);
                for (int i = 1; i < n; ++i) {
                    b.push_back(a[i]);
                }
                for (int i = 1; i < n; ++i) {
                    pref1[i] = pref1[i - 1] + b[i - 1];
                }
                //cout << solve(n - 1, 2, b, pref1) - ml;
                if (solve(n - 1, 2, b, pref1) - ml > ans) {
                    ans = solve(n - 1, 2, b, pref1) - ml;
                }
            } else if (ind == n - 1) {
                vector<ll> b;
                vector<ll> pref1(n);
                for (int i = 0; i < n - 1; ++i) {
                    b.push_back(a[i]);
                }
                for (int i = 1; i < n; ++i) {
                    pref1[i] = pref1[i - 1] + b[i - 1];
                }
                //cout << solve(n - 1, 2, b, pref1) - ml;
                if (solve(n - 1, 2, b, pref1) - ml > ans) {
                    ans = solve(n - 1, 2, b, pref1) - ml;
                }
            } else {
                //cout << "!";
                //cout << max(pref[ind] - ml, pref[n] - pref[ind + 1] - ml);
                if (max(pref[ind] - ml, pref[n] - pref[ind + 1] - ml) > ans) {
                    ans = max(pref[ind] - ml, pref[n] - pref[ind + 1] - ml);
                }
            }
        }
        cout << ans;
    }
    else {
        vector<ll> a(n);
        vector<ll> pref(n + 1);
        //ll ml = INF;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            pref[i + 1] = pref[i] + a[i];
        }
        //for (auto it: pref) cout << it << " ";
        ll l = n - k + 1;
        ll ans = -INF;
        for (int j = 1; j <= l; ++j) {
            ll ml = INF;
            ll mx = -INF;
            ll i1, i2;
            for (int i = j; i <= n; ++i) {
                //cout << pref[i] - pref[i - l] << " ";
                if (pref[i] - pref[i - j] > mx) {
                    mx = pref[i] - pref[i - j];
                    i1 = i - j;
                    i2 = i - 1;
                }
            }
            //cout << i1 << " " << i2 << "\n";
            for (int i = 0; i < n; ++i) {
                if (a[i] < ml && (i < i1 || i > i2)) {
                    ml = a[i];
                }
            }
            //cout << i1 << " " << i2 << "\n";
            //cout << mx << " " << ml << "\n";
            //cout << j << " " << mx - ml << "\n";
            if (mx - ml > ans) {
                ans = mx - ml;
            }
        }
        cout << ans;
    }
}

/*
5 3
100 0 0 5 1
 */