#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <array>
#include <cmath>

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

//00000000111111
/*bool check() {

}

ll binSearch(ll l, ll r) {
	ll m;
	while (l < r) {
		m = (l + r) / 2;

		if (check(m)) {
			r = m;
		}
		else {
			l = m + 1;
		}
	}
}

void dfs(const vector<vector<ll>>& vec, vector<bool>& used, ll v, vector<ll>& ans) {

}*/

int main() {
	ll n, m, k;
	cin >> n >> m >> k;

	ll cnt = 0;
	if (k == 1) {
		cnt += min(n, m) - 1 + (max(n, m) - min(n, m));

		cout << cnt << "\n";
		return 0;
	}

	if ((n == m && n <= k) || (n == m && n <= 2 * k)) {
		cout << ceil(n / k) << "\n";

		return 0;
	}

	if (n < k && m > n && (m - n) <= k) {
		cout << "2\n";
		return 0;
	}

	if (m < k && n > m && (n - m) <= k) {
		cout << "2\n";
		return 0;
	}

	if (n < k && m < k) {
		cout << "2\n";
		return 0;
	}

	vector<vector<ll>> dp(n, vector<ll>(m, -1));
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (dp[i][j] == -1) {
				continue;
			}

			if (i < n - k) {
				if (dp[i + k][j] == -1) {
					dp[i + k][j] = dp[i][j] + 1;
				}
				else {
					dp[i + k][j] = min(dp[i][j] + 1, dp[i + k][j]);
				}
			}
			else {
				if (dp[n - 1][j] == -1) {
					dp[n - 1][j] = dp[i][j] + 1;
				}
				else {
					dp[n - 1][j] = min(dp[i][j] + 1, dp[n - 1][j]);
				}
			}

			if (j < m - k) {
				if (dp[i][j + k] == -1) {
					dp[i][j + k] = dp[i][j] + 1;
				}
				else {
					dp[i][j + k] = min(dp[i][j] + 1, dp[i][j + k]);
				}
			}
			else {
				if (dp[i][m - 1] == -1) {
					dp[i][m - 1] = dp[i][j] + 1;
				}
				else {
					dp[i][m - 1] = min(dp[i][j] + 1, dp[i][m - 1]);
				}
			}

			if (i < n - k && j < m - k) {
				if (dp[i + k][j + k] == -1) {
					dp[i + k][j + k] = dp[i][j] + 1;
				}
				else {
					dp[i + k][j + k] = min(dp[i][j] + 1, dp[i + k][j + k]);
				}
			}
			else {
				if (i >= n - k && j < m - k) {
					if (dp[n - 1][min(j + (n - 1) - i, m - 1)] == -1) {
						dp[n - 1][min(j + (n - 1) - i, m - 1)] = dp[i][j] + 1;
					}
					else {
						dp[n - 1][min(j + (n - 1) - i, m - 1)] = min(dp[i][j] + 1, dp[n - 1][min(j + (n - 1) - i, m - 1)]);
					}
				}

				if (i < n - k && j >= m - k) {
					if (dp[min(i + (m - 1) - j, n - 1)][m - 1] == -1) {
						dp[min(i + (m - 1) - j, n - 1)][m - 1] = dp[i][j] + 1;
					}
					else {
						dp[min(i + (m - 1) - j, n - 1)][m - 1] = min(dp[i][j] + 1, dp[min(i + (m - 1) - j, n - 1)][m - 1]);
					}
				}

				if (i >= n - k && j >= m - k) {
					if (dp[min(i + (m - 1) - j, n - 1)][min(j + (n - 1) - i, m - 1)] == -1) {
						dp[min(i + (m - 1) - j, n - 1)][min(j + (n - 1) - i, m - 1)] = dp[i][j] + 1;
					}
					else {
						dp[min(i + (m - 1) - j, n - 1)][min(j + (n - 1) - i, m - 1)] = min(dp[i][j] + 1, dp[min(i + (m - 1) - j, n - 1)][min(j + (n - 1) - i, m - 1)]);
					}
				}
			}
		}
	}

	cout << dp[n - 1][m - 1] << "\n";

	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << dp[i][j] << ' ';
		}

		cout << "\n";
	}*/
}