#include <iostream>
#include <vector>
#include <cmath>

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

vector<pair<ll, pair<bool, ll>>> res;

ll ans = -2;

ull max(ull a, ull b) {
	if (a > b) return a;

	return b;
}

ull min(ull a, ull b) {
	if (a < b) return a;

	return b;
}

void f(const vector<ll>& vec, ll ind, ll k, ll num) {
	if (ind == vec.size()) {
		ll mx = -1, mn = 1e18;
		bool flag = true;
		for (int i = 0; i < k; i++) {
			if (!res[i].second.first) {
				flag = false;
				break;
			}

			if (res[i].first > mx) {
				mx = res[i].first;
			}

			if (res[i].first < mn) {
				mn = res[i].first;
			}
		}

		if (flag && mx - mn > ans) {
			ans = mx - mn;
		}

		return;
	}

	for (int i = num; i < k; i++) {
		res[i].first += vec[ind];
		res[i].second.first = true;
		if (vec[ind] == 0) {
			res[i].second.second++;
		}
		f(vec, ind + 1, k, i);
		res[i].first -= vec[ind];
		if (vec[ind] == 0) {
			res[i].second.second--;
		}
		if (res[i].first == 0 && res[i].second.second == 0) {
			res[i].second.first = false;
		}
	}
}

int main() {
	ll n, k;
	cin >> n >> k;

	vector<ll> vec(n);
	ll sumR = 0;
	bool flag = true;
	ll tmp = 0;
	vector<ll> pref(n);
	for (int i = 0; i < n; i++) {
		pref[i] = sumR;
		cin >> vec[i];
		if (i == 0) {
			tmp = vec[i];
		}
		sumR += vec[i];

		if (vec[i] != tmp) {
			flag = false;
		}
	}

	if (flag) {
		cout << (n - k + 1) * tmp;
		return 0;
	}

	if (n <= 20) {
		res.resize(k, { 0, {false, 0 } });
		f(vec, 0, k, 0);

		cout << ans << "\n";
		return 0;
	}

	if (k == 3) {
		/*ll mx = 0;
		for (int i = 0; i < n - 2; i++) {
			for (int j = i + 1; j < n - 1; j++) {
				ll f = pref[i + 1];
				ll s = pref[j + 1] - f;
				ll t = sumR - s - f;

				mx = max(mx, max(f, max(s, t)) - min(f, min(s, t)));
			}
		}

		cout << mx << "\n";
		return 0;*/

		ll sumL = 0;
		ll mx = 0;
		ll ind = 0;
		for (int i = 0; i < n - 1; i++) {
			sumL += vec[i];
			sumR -= vec[i];

			if (mx < abs(sumL - sumR)) {
				mx = abs(sumL - sumR);
				ind = i;
			}
		}

		ll sumL1 = 0;
		ll tmp = sumL;
		ll mx1 = 0;
		for (int i = 0; i < ind; i++) {
			sumL1 += vec[i];
			tmp -= vec[i];

			mx1 = max(mx1, max(sumL1, max(tmp, sumR)) - min(sumL1, min(tmp, sumR)));
		}

		ll sumL2 = 0;
		ll tmp1 = sumR;
		ll mx2 = 0;
		for (int i = ind + 1; i < n - 1; i++) {
			sumL2 += vec[i];
			tmp1 -= vec[i];

			mx2 = max(mx2, max(sumL2, max(sumL, tmp1)) - min(sumL2, min(sumL, tmp1)));
		}

		cout << max(mx1, mx2) << "\n";
		return 0;
	}

	if (k == 2) {
		ll sumL = 0;
		ll mx = 0;
		for (int i = 0; i < n - 1; i++) {
			sumL += vec[i];
			sumR -= vec[i];
			
			if (mx < abs(sumL - sumR)) {
				mx = abs(sumL - sumR);
			}
		}

		cout << mx << "\n";
		return 0;
	}
}