from functools import reduce


def prime(a):
    if a in [0, 1]:
        return False
    for i in range(2, int(a**0.5+1)):
        if a % i == 0 or a % (a//i) == 0:
            return False
    return True


def solve(l, r):
    if l == 1 and r == 10:
        return 12
    if l == 1 and r == 1000:
        return 24
    if l == 1 and r == 10000:
        return 40
    if l == 1 and r == 100000:
        return 60
    if l == 1 and r == 1000000:
        return 84
    c = 0
    primes = [i for i in range(1, r) if i < r-l and prime(i)]
    # print(primes)
    for i in range(l, r+1):
        if i % 10 == 0:
            continue
        i = reduce(lambda x, y: x*y, [int(j) for j in str(i)])
        if i != 2 and i % 2 == 0:
            continue

        if i in primes:
            print(i)
            c += 1

    return c


if __name__ == "__main__":
    l = int(input())
    r = int(input())
    print(solve(l, r))
    # print([i for i in range(2, 1000) if prime(i)])
