#include <bits/stdc++.h>
#define int int64_t
#define inf INT64_MAX
#define endl "\n"
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, s;
    cin >> n >> s;
    vector<vector<int>> costs(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            costs[i].push_back(x);
        }
    }
    if (n == 1) {
        int m = costs[0].size();
        vector<vector<pair<int, int>>> back(m + 1, vector<pair<int, int>>(s + 1, {-2, -2}));
        vector<vector<bool>> dp(m + 1, vector<bool>(s + 1, false));
        back[0][0] = {-1, -1};
        dp[0][0] = true;
        for (int i = 1; i <= m; i++) {
            dp[i][0] = true;
            for (int sum = 0; sum <= s; sum++) {
                if (sum - costs[0][i - 1] >= 0 && dp[i - 1][sum - costs[0][i - 1]]) {
                    back[i][sum] = {i - 1, sum - costs[0][i - 1]};
                    dp[i][sum] = true;
                }
                else if (dp[i - 1][sum]) {
                    back[i][sum] = {i - 1, sum};
                    dp[i][sum] = true;
                }
            }
        }
        if (!dp[m][s]) {
            cout << "No" << endl;
            return 0;
        }
        pair<int, int> now = back[m][s];
        int count = 0;
        int ws = s;
        while (now != make_pair(-1ll, -1ll)) {
            if (now.second != ws)
                count++;
            ws = now.second;
            now = back[now.first][now.second];
        }
        cout << "Yes" << endl;
        cout << count << endl;
    }
}
