#include<bits/stdc++.h>

using namespace std;
using ll=long long;
using ld=long double;

vector<vector<ll>> c;

vector<ll> renew(ll k, ll s, vector<vector<ll>>& dp, ll lay){
    ll i = k;
    ll w = s;
    vector<ll> res;
    while (i > 0) {
        if (c[lay][i - 1] <= w && dp[i - 1][w - c[lay][i - 1]]) {
            res.push_back(i);
            w -= c[lay][i - 1];
            --i;
        } else {
            --i;
        }
    }
    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, s;
    cin>>n>>s;
    c.resize(n);
    for(ll i=0; i<n; ++i){
        ll k;
        cin>>k;
        for(ll j=0; j<k; ++j){
            ll x;
            cin>>x;
            c[i].push_back(x);
        }
    }
    if(n==1) {
        ll k = c[0].size();
        vector<vector<ll>> dp(k + 1, vector<ll>(s + 1));
        dp[0][0] = 1;

        for (ll i = 1; i <= k; ++i) {
            for (ll w = 0; w <= s; ++w) {
                dp[i][w] = dp[i - 1][w];
                if (c[0][i - 1] <= w) {
                    dp[i][w] = dp[i - 1][w] || dp[i - 1][w - c[0][i - 1]];
                }
            }
        }
        if (dp[k][s]) {
            cout << "YES\n";
            auto res=renew(k, s, dp, 0);
            cout << res.size() << '\n';
            for (auto x: res) {
                cout << x << ' ';
            }
        } else {
            cout << "NO\n";
        }
        return 0;
    }else if(n==2){
        ll k1 = c[0].size();
        vector<vector<ll>> dp1(k1 + 1, vector<ll>(s + 1));
        dp1[0][0] = 1;
        for (ll i = 1; i <= k1; ++i) {
            for (ll w = 0; w <= s; ++w) {
                dp1[i][w] = dp1[i - 1][w];
                if (c[0][i - 1] <= w) {
                    dp1[i][w] = dp1[i - 1][w] || dp1[i - 1][w - c[0][i - 1]];
                }
            }
        }

        ll k2 = c[1].size();
        vector<vector<ll>> dp2(k2 + 1, vector<ll>(s + 1));
        dp2[0][0] = 1;
        for (ll i = 1; i <= k2; ++i) {
            for (ll w = 0; w <= s; ++w) {
                dp2[i][w] = dp2[i - 1][w];
                if (c[1][i - 1] <= w) {
                    dp2[i][w] = dp2[i - 1][w] || dp2[i - 1][w - c[1][i - 1]];
                }
            }
        }

        for(ll sum1=0; sum1<=s; ++sum1){
            ll sum2=s-sum1;
            if(dp1[k1][sum1] && dp2[k2][sum2]){
                cout<<"YES\n";
                auto res1=renew(k1, sum1, dp1, 0);
                auto res2=renew(k2, sum2, dp2, 1);
                cout<<res1.size()<<'\n';
                for(auto x : res1){
                    cout<<x<<' ';
                }
                cout<<'\n';
                cout<<res2.size()<<'\n';
                for(auto x : res2){
                    cout<<x<<' ';
                }
                return 0;
            }
        }
    }
    cout<<"NO";

    return 0;
}