#include <iostream>
#include <vector>
#include <string>
#include <cstdint>

using namespace std;

uint64_t func(int l, int r, int k, uint64_t currmx, uint64_t currmn, vector<uint64_t>& partsum) {
  uint64_t currsum = partsum[r + 1] - partsum[l];

  if (currsum > currmx) {
    currmx = currsum;
  }
  if (currsum < currmn) {
    currmn = currsum;
  }

  if (k == 0) {
    return currmx - currmn;
  } else if (k == 1) {
    return func(r + 1, partsum.size() - 2, k - 1, currmx, currmn, partsum);
  }
  k--;

  uint64_t curropt = 0;
  uint64_t per;
  for (int i = r + 1; i < partsum.size() - 1 - k; i++) {
    per = func(r + 1, i, k, currmx, currmn, partsum);
    if (per > curropt) {
      curropt = per;
    }
  }
  return curropt;
}

int main() {
  int n, k;

  cin >> n >> k;
  vector<uint64_t> arr(n);
  vector<uint64_t> partsum(n + 1);

  for (int i = 0; i < n; i++) {
    cin >> arr[i];
  }
  partsum[0] = 0;

  for (int i = 1; i < n + 1; i++) {
    partsum[i] = (partsum[i - 1] + arr[i - 1]);
  }

  uint64_t opt;
  uint64_t optmax = 0;
  for (int r0 = 0; r0 < n - k + 1; r0++) {
    opt = func(0, r0, k - 1, 0, partsum[n], partsum);
    if (opt > optmax) {
      optmax = opt;
    }
  }
  cout << optmax;
  return 0;
}