#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <random>
#include <algorithm>
#include <chrono>
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;

int inf = 1e9 + 7;

void sample() { 
	int n, m, k;
	cin >> n >> m >> k;
	if (k == 1) {
		cout << max(n, m) - 1;
		return;
	}
	vector <vector <int>>dp(n, vector <int>(m, inf));
	dp[0][0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int ij = i + 1; ij <= i + k && ij < n; ij++)
				dp[ij][j] = min(dp[ij][j], dp[i][j] + 1);
			for (int ij = j + 1; ij <= j + k && ij < m; ij++)
				dp[i][ij] = min(dp[i][ij], dp[i][j] + 1);
			for (int a = i + 1, b = j + 1; a <= i + k && a < n && b <= j + k && b < m; a++, b++)
				dp[a][b] = min(dp[a][b], dp[i][j] + 1);

		}
	}
	cout << dp[n - 1][m - 1];
	return;
}

int main() {
	sample();
	return 0;
}