#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <random>
#include <chrono>
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;

//#define _GLIBCXX_DEBUG random device rd;
//mt19937 rg(chrono::_high_time_resolution()_::now()_since_time_apoch():(count())


int num(char i) {
	return i - '0';
}


bool find_zero(string s, int ind) {
	for (int i = ind; i < s.size(); i++) {
		if (s[i] == '0')
			return false;
		else if (s[i] != '1')
			return true;
	}
	return true;
}

ll get_dp(string n) {
	ll ans = 0;
	vector <ll> simps = { 2, 3, 5, 7 };

	if (n.size() == 1) {
		for (int i : simps)
			if (i <= num(n[0]))
				ans++;
		return ans;
	}
	for (ll i = 1; i < n.size(); i++)
		ans += 4 * i;

	for (ll i = 0; i < n.size(); i++) {
		if (n[i] == '0')
			return ans;
		if (num(n[i]) > 1) {
			ans += 4 * (n.size() - i - 1);
			for (int t : simps) {
				if (t < num(n[i])) {
					ans++;
 				}
				else if (t == num(n[i])) {
					if (find_zero(n, i + 1))
						ans++;
				}
				else
					break;
			}
			break;
		}
	}
	return ans;
}

void sample() {
	string a, b;
	cin >> a >> b;

	ll ans = get_dp(b) - get_dp(a);
	ll cnt = 1;
	for (int i = 0; i < a.size(); i++) {
		cnt *= num(a[i]);
		if (cnt > 7 || cnt == 0)
			break;
	}
	if (cnt == 2 || cnt == 3 || cnt == 5 || cnt == 7)
		ans++;
	cout << ans;
}

int main() {
	sample();
	return 0;
}