#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <random>
#include <algorithm>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector <ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int l = 0, r = 0;
	ll sum = a[0], maxs = a[0], minnow = a[0], minwas = a[0];
	int i = 0;
	for (int j = 1; j < n; j++) {
		while (i + 1 < j && a[i] == 0) {
			i++;
		}
		if (j - i + 1 <= n - k + 1) {
			sum += a[j];
			if (sum > maxs) {
				maxs = sum;
				l = i, r = j;
				minwas = minnow;
			}
			else if (sum == maxs && minnow > minwas) {
				l = i, r = j;
				minwas = minnow;
			}
		}
		else {
			sum -= a[i];
			i++;
			sum += a[j];
			if (sum > maxs) {
				maxs = sum;
				l = i, r = j;
				minwas = minnow;
			}
			else if (sum == maxs && minnow > minwas) {
				l = i, r = j;
				minwas = minnow;
			}
		}
	}
	while (a[r] == 0)
		r--;
	ll mins = 1e9 + 1;
	for (int j = 0; j < l; j++) {
		mins = min(mins, a[j]);
	}
	for (int j = r + 1; j < n; j++) {
		mins = min(mins, a[j]);
	}
	cout << maxs - mins;
}

int main() {
	solve();
	return 0;
}