#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <random>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}

ll inf = 1e18;

bool rec(int now, int s, vector <vector <ll>>& k, vector <vector <ll>>& res, vector <ll> &mins, int ind, int c) {
	if (now > s)
		return false;
	if (now == s) {
		for (int i = 0; i < res.size(); i++) {
			if (res[i].size() == 0)
				return false;
		}
		cout << "Yes\n";
		for (int i = 0; i < res.size(); i++) {
			cout << res[i].size() << '\n';
			for (int ll e : res[i])
				cout << e + 1 << ' ';
			cout << '\n';
		}
		return true;
	}
	for (int i = ind; i < k.size(); i++) {
		for (int j = c; j < k[i].size(); j++) { // s - now - k[i][j] >= mins[i + 1]
			now += k[i][j];
			res[i].push_back(j);
			if (rec(now, s, k, res, mins, i, j + 1))
				return true;
			now -= k[i][j];
			res[i].pop_back();
		}
		c = 0;
	}
	return false;
}

void solve() {
	int n, s;
	cin >> n >> s;
	vector <vector <ll>> k(n);
	vector <ll> mins(n + 1, inf), sz(n);
	mins[n] = 0;
	for (int i = 0; i < n; i++) {
		cin >> sz[i];
		for (int j = 0; j < sz[i]; j++) {
			int a;
			cin >> a;
			if (a < mins[i])
				mins[i] = a;
			k[i].push_back(a);
			//sort(k[i].begin(), k[i].end());
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		mins[i] = mins[i + 1] + mins[i];
	}
	vector <vector <ll>> res(n);
	if (!rec(0, s, k, res, mins, 0, 0))
		cout << "No";
	return;
}

int main() {
	solve();
	return 0;
}

/*

2 4
1
2
2
2 1


*/