#include <iostream>
#include <vector>
#include <map>
#include <chrono>
#include <algorithm>
#include <random>
#define _GLIBCXX_DEBUG
#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
using namespace std;
random_device rd;

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

ll randInt(ll L, ll R) {
	return uniform_int_distribution <ll>(L, R) (rng);
}


int ans = 0, mod = 1e9 + 7;
void rec(int n, int m, int len, vector <vector <int>>& used, vector <pii>& d, vector <pii>& usd, int x, int y) {
	if (x == 0 && y == 0 && len != 0 && len == n * 2 + m * 2 - 4 && usd.size() == d.size() && used[n - 1][m - 1]) {
		ans = (ans + 1) % mod;
		return;
	}
	if (x == 0 && y == 0 && len != 0 || len > n * 2 + m * 2 - 4) {
		return;
	}
	if (x > 0 && !used[x - 1][y]) {
		pii p = { x - 1, y };
		used[x - 1][y] = 1;
		if (find(d.begin(), d.end(), p) != d.end())
			usd.push_back(p);
		rec(n, m, len + 1, used, d, usd, x - 1, y);
		if (find(d.begin(), d.end(), p) != d.end())
			usd.pop_back();
		used[x - 1][y] = 0;
	}
	if (x < n - 1 && !used[x + 1][y]) {
		pii p = { x + 1, y };
		used[x + 1][y] = 1;
		if (find(d.begin(), d.end(), p) != d.end())
			usd.push_back(p);
		rec(n, m, len + 1, used, d, usd, x + 1, y);
		if (find(d.begin(), d.end(), p) != d.end())
			usd.pop_back();
		used[x + 1][y] = 0;
	}

	if (y > 0 && !used[x][y - 1]) {
		pii p = { x, y - 1 };
		used[x][y - 1] = 1;
		if (find(d.begin(), d.end(), p) != d.end())
			usd.push_back(p);
		rec(n, m, len + 1, used, d, usd, x, y - 1);
		if (find(d.begin(), d.end(), p) != d.end())
			usd.pop_back();
		used[x][y - 1] = 0;
	}
	if (y < m - 1 && !used[x][y + 1]) {
		pii p = { x, y + 1 };
		used[x][y + 1] = 1;
		if (find(d.begin(), d.end(), p) != d.end())
			usd.push_back(p);
		rec(n, m, len + 1, used, d, usd, x, y + 1);
		if (find(d.begin(), d.end(), p) != d.end())
			usd.pop_back();
		used[x][y + 1] = 0;
	}
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <int>> used(n, vector <int>(m, 0));
	vector <pii> d, usd;
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		d.push_back({ x, y });
	}
	rec(n, m, 0, used, d, usd, 0, 0);
	cout << ans;
}

int main() {
	solve();
	return 0;
}
