#include <iostream>
#include <vector>
#include <string>
#include <sstream>

using namespace std;
using ll = long long;

ll mul(ll a) {
    ll res = 1;
    while (a > 0) {
        res *= a % 10;
        a /= 10;
    }
    return res;
}

ll stupid(ll a, ll b) {
    ll ans = 0;
    for (ll i = a; i <= b; i++) {
        ll res = mul(i);
        if (res == 2 || res == 3 || res == 5 || res == 7) {
            ans++;
        }
    }
    return ans;
}

ll fullk(string& l, string& r) {
    ll n = l.size(), m = r.size();
    return (m + 1) * m * 2 - (n + 1) * n * 2;
}

ll partk(string& l, string& r) {
    ll n = l.size(), m = r.size();
    ll o1 = 0, o2 = 0;
    bool z1 = false, z2 = false;
    for (int i = 0; i < n; i++) {
        if (l[i] > '1') break;
        else if (l[i] == '0') {
            z1 = true;
            o1 = n;
            break;
        }
        o1++;
    }
    for (int i = 0; i < m; i++) {
        if (r[i] > '1') break;
        else if (r[i] == '0') {
            z2 = true;
            o2 = m;
            break;
        }
        o2++;
    }
    ll resl = o1 * 4;
    ll resr = o2 * 4;
    //cout << resl << ' ' << resr << endl;
    if (o1 != n) {
        if (z1 == false && (l[o1] == '2' || l[o1] == '3' || l[o1] == '5' || l[o1] == '7')) {
            bool win = true;
            for (int i = o1 + 1; i < n; i++) {
                if (l[i] > '1') win = false;
                else if (l[i] == '0') break;
            }
            if (win) resl++;
        }
        if (l[o1] - '0' < 2 || z1) resl++;
        if (l[o1] - '0' < 3 || z1) resl++;
        if (l[o1] - '0' < 5 || z1) resl++;
        if (l[o1] - '0' < 7 || z1) resl++;
    }
    //cout << resl << ' ' << resr << endl;
    if (o2 != m) {
        if (z2 == false && (r[o2] == '2' || r[o2] == '3' || r[o2] == '5' || r[o2] == '7')) {
            bool win = true;
            bool ex = true;
            for (int i = o2 + 1; i < m; i++) {
                if (r[i] == '0') ex = false;
                if (r[i] > '1') win = false;
                else if (r[i] == '0') break;
            }
            if (win && !ex) resr++;
        }
        if (r[o2] - '0' < 2 || z2) resr++;
        if (r[o2] - '0' < 3 || z2) resr++;
        if (r[o2] - '0' < 5 || z2) resr++;
        if (r[o2] - '0' < 7 || z2) resr++;
    }
    //cout << resl << ' ' << resr << endl;
    return resl - resr;
}

string tostr(ll a) {
    vector<char> arr;
    while (a > 0) {
        arr.push_back(a % 10 + '0');
        a /= 10;
    }
    string res;
    for (int i = arr.size() - 1; i >= 0; i--) {
        res += arr[i];
    }
    return res;
}

int main() {
    string s1, s2;
    cin >> s1 >> s2;
    cout << fullk(s1, s2) + partk(s1, s2) << endl;
    return 0;
}
