#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

ll ans = 0;

void bf(int n, int k, vector<int>& arr, int layer) {
    if (layer == k) {
        bool win = true;
        for (int i = 0; i < n; i++) {
            if (arr[i] != 0) {
                win = false;
            }
        }
        if (win) ans++;
        return;
    }
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> newarr = arr;
        bool neg = false;
        for (int i = 0; i < n && !neg; i++) {
            for (int l = max(0, i - k + 1 + layer); l <= i && !neg; l++) {
                if (mask & (1 << l)) {
                    newarr[i]--;
                    if (newarr[i] < 0) neg = true;
                }
            }
        }
        if (neg) continue;
        else bf(n, k, newarr, layer + 1);
    }
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<int> arr(n);
    int s = 0;
    for (int &o : arr) {
        cin >> o;
        s += o;
    }
    if (k == 1) {
        cout << 1 << endl;
        return 0;
    }
    bf(n, k, arr, 0);
    cout << ans << endl;
}
