#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll inf = LLONG_MAX;

vector<ll> pref(vector<ll>& arr) {
    vector<ll> p(arr.size() + 1, 0);
    for (ll i = 0; i < arr.size(); i++) {
        p[i + 1] = p[i] + arr[i];
    }
    return p;
}

int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(n);
    for (ll& o : arr) cin >> o;
    vector<ll> p = pref(arr);
    vector<ll> smn(n + 1, inf);
    vector<ll> pmn(n + 1, inf);
    for (ll i = 0; i < n; i++) {
        pmn[i + 1] = min(pmn[i], arr[i]);
    }
    for (ll i = n; i > 0; i--) {
        smn[i - 1] = min(smn[i], arr[i - 1]);
    }
    k = n - k + 1;
    ll mx = 0;
    for (ll i = 0; i <= n - k; i++) {
        mx = max(mx, abs((p[i + k] - p[i]) - min(pmn[i], smn[i + k])));
    }
    cout << mx << endl;
    return 0;
}
