typedef signed int int32;
typedef unsigned int uint32;
//typedef signed long long int64;
//typedef unsigned long long uint64;

#include <iostream>
#include <vector>

uint32 recursive_sep(std::vector<std::vector<uint32>> vecs, uint32 k) {
    std::vector<uint32> res;
    if (k > 1) {
        for (uint32 i = 0; i < vecs.size(); ++i) {
            if (vecs[i].size() >= 2) {
                for (uint32 s = 1; s < vecs[i].size(); ++s) {
                    std::vector<uint32> left, right;
                    for (uint32 j = 0; j < s; ++j) left.push_back(vecs[i][j]);
                    for (uint32 j = s; j < vecs[i].size(); ++j) right.push_back(vecs[i][j]);

                    std::vector<std::vector<uint32>> next;
                    for (uint32 j = 0; j < i; ++j) next.push_back(vecs[j]);
                    next.push_back(left);
                    next.push_back(right);
                    for (uint32 j = i + 1; j < vecs.size(); ++j) next.push_back(vecs[j]);

                    res.push_back(recursive_sep(next, k - 1));
                }
            }
        }
        uint32 max = 0;
        for (auto &e: res) {
            if (e > max) max = e;
        }
        return max;
    } else {
        uint32 max = 0;
        uint32 min = UINT_MAX;
        for (auto &vec: vecs) {
            uint32 sum = 0;
            for (auto &e: vec) sum += e;
            if (sum > max) max = sum;
            if (sum < min) min = sum;
        }
        return max - min;
    }
}

int main() {
    uint32 n{}, k{};
    std::cin >> n >> k;
    std::vector<uint32> a(n);
    for (auto &e: a) std::cin >> e;

    std::vector<std::vector<uint32>> send;
    send.push_back(a);
    std::cout << recursive_sep(send, k) << std::endl;
}
