#include <iostream>
#include <vector>
#include <map>
#include <set>
using namespace std;
using ill = long long;

vector<ill> p;
ill sum(ill l, ill r) {
    return p[r + 1] - p[l];
}

int main() {
    ill n, k, m;
    cin >> n >> k;
    m = n + 1 - k;
    vector<ill> a(n);
    for (ill i = 0; i < n; i++)
        cin >> a[i];
    p.resize(n + 1, 0);
    for (ill i = 0; i < n; i++)
        p[i + 1] = p[i] + a[i];
    ill ans = 0;

    multiset<ill> s;
    for (ill i = 0; i < n; i++)
        s.insert(a[i]);
    for (ill i = 0; i < m; i++) {
        s.erase(s.find(a[i]));
        ans = max(ans, sum(0, i) - *s.begin());
    }

    s.clear();
    for (ill i = 0; i < n; i++)
        s.insert(a[i]);
    for (ill i = 0; i < m; i++) {
        s.erase(s.find(a[n - 1 - i]));
        ans = max(ans, sum(n - 1 - i, n - 1) - *s.begin());
    }

    s.clear();
    for (ill i = m - 1; i < n; i++)
        s.insert(a[i]);
    for (ill i = m - 1; i < n; i++) {
        s.erase(s.find(a[i]));
        ans = max(ans, sum(i + 1 - m, i) - *s.begin());
        s.insert(a[i + 1 - m]);
    }

    cout << ans;
    return 0;
}
