#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ill = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ill n, s, m = 0;
    cin >> n >> s;
    vector<ill> w;
    for (ill i = 0; i < n; i++) {
        ill k;
        cin >> k;
        m += k;
        for (ill j = 0, x; j < k; j++) {
            cin >> x;
            w.push_back(x);
        }
    }
    sort(w.begin(), w.end());
    vector<vector<bool>> dp(m + 1, vector<bool>(s + 1, false));
    vector<ill> p(s + 1, -1);
    dp[0][0] = true;
    if (n == 1) {
        for (ill i = 1; i <= m; i++) {
            for (ill j = 0; j <= s; j++) {
                dp[i][j] = dp[i - 1][j];
                if (j - w[i - 1] >= 0 && dp[i - 1][j - w[i - 1]]) {
                    if (p[j] == -1)
                        p[j] = i - 1;
                    dp[i][j] = true;
                }
            }
        }
        if (!dp[m][s]) {
            cout << "No";
            return 0;
        }
        cout << "Yes" << '\n';
        vector<ill> ans;
        ill j = s;
        for (ill i = m; i > 0; i--) {
            if (dp[i - 1][j])
                continue;
            ans.push_back(p[j]);
            j -= w[p[j]];
        }
        cout << ans.size() << '\n';
        for (ill i = ans.size() - 1; i >= 0; i--)
            cout << ans[i] + 1 << ' ';
        return 0;
    }

    ill ans = 0;
    for (ill i = 0; i < n; i++)
        ans += w[i];
    if (ans != s) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << '\n';
    for (ill i = 0; i < 2 * n; i++)
        cout << 1 << '\n';
    return 0;
}
