#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;
//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,tree_order_statistics_node_update>;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << ' ';
    return out;
}

typedef long long ll;
typedef long double ld;
const int mod = 1e9 + 7;

struct Test {
    int n, k;
    int m;
    int g;
    vector<int> a;
    vector<vector<int>> dp;
    int mask1 = 0;
    int mask2 = 0;
    vector<int> zipped;
    vector<int>sum;
    int zip(int x) {
        int num = 0;
        int res = 0;
        for (int i = 0; i < k; i++) {
            for (int j = i; j < k; j++) {
                res += (x & (1 << num)) >> i;
                num++;
            }
        }
        return res;
    }

    Test() {
        cin >> n >> k;
        a.resize(n);
        cin >> a;
        m = 1 << (k * (k + 1) / 2);
        g = 1 << (k * (k - 1) / 2);
        zipped.resize(m);
        sum.resize(m,0);
        for (int x = 0; x < m; x++) {
            zipped[x] = zip(x);
            for (int i = 0; i < (k * (k + 1)) / 2; i++) {
                if ((x & (1 << i)) != 0)sum[x]++;
            }
        }
        int num = 0;
        for (int i = 0; i < k; i++) {
            for (int j = i; j < k; j++) {
                if (j != k - 1)mask1 += 1 << num;
                if (j != i)mask2 += 1 << num;
                num++;
            }
        }
        dp.resize(g, vector<int>(n + 1));
        dp[0][0] = 1;
        for (int ind = 1; ind <= n; ind++) {
            for (int x = 0; x < m; x++) {
                if (sum[x] != a[ind - 1])continue;
                int y = zipped[(x & mask2) >> 1];
                int z = zipped[x & mask1];
                dp[y][ind] = (dp[y][ind] + dp[z][ind - 1]) % mod;
            }
        }
        ll ans = 0;
        for (int x = 0; x < g; x++) {
            ans = (ans + dp[x][n]) % mod;
        }
        cout << ans << '\n';
    }
};

signed main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
    return 0;
}
