#pragma clang diagnostic push
#pragma ide diagnostic ignored "misc-no-recursion"

#include <bits/stdc++.h>

using namespace std;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    return in >> a.first >> a.second;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    return out << a.first << ' ' << a.second << '\n';
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const auto &i: a)out << i << ' ';
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<vector<T>> &a) {
    for (const auto &i: a)out << i << '\n';
    return out;
}

typedef long long ll;
const ll mod = 1e9 + 7;

struct Test {
    int n{}, m{}, k{};
    vector<pair<int, int>> a;
    vector<int> pos1;
    vector<int> pos2;
    ll ans = 0;
    vector<int> res;
    int t = 1;

    void check() {
        t++;
        int i = 0;
        int j = 0;
        int now = 0;
        for (auto pos: pos1) {
            while (j < pos) {
                res[i * m + j] = t;
                j++;
                now++;
            }
            res[i * m + j] = t;
            i++;
            now++;
        }
        while (j != m - 1) {
            res[i * m + j] = t;
            j++;
            now++;
        }
        for (auto pos: pos2) {
            while (j > pos) {
                if (res[i * m + j] == t)return;
                res[i * m + j] = t;
                j--;
                now++;
            }

            if (res[i * m + j] == t)return;
            res[i * m + j] = t;
            i--;
            now++;
        }
        while (j != 0) {
            if (res[i * m + j] == t)return;
            res[i * m + j] = t;
            j--;
            now++;
        }
        for (const auto &[x, y]: a) {
            if (res[(x - 1) * m + (y - 1)] != t)return;
        }
        ans++;
    }

    void gen2(int v, int prev) {
        if (v == n - 1) {
            check();
            return;
        }
        for (int x = prev; x >= 0; x--) {
            pos2.push_back(x);
            gen2(v + 1, x);
            pos2.pop_back();
        }
    }

    void gen1(int v, int prev = 0) {
        if (v == n - 1) {
            gen2(0, m - 1);
            return;
        }
        for (int x = prev; x < m; x++) {
            pos1.push_back(x);
            gen1(v + 1, x);
            pos1.pop_back();
        }
    }

    Test() {
        cin >> n >> m >> k;
        a.resize(k);
        cin >> a;
        res.resize(n * m, -1);
        gen1(0);
        cout << ans << '\n';
    }
};

int main() {
#ifdef home
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
    //cin>>t;
    while (t--)Test();
}

#pragma clang diagnostic pop