#include <iostream>
#include <vector>
#include <cmath>


int numLen(unsigned long long num)
{
	int res = 0;

	while (num > 0)
		num -= num % 10, num /= 10, res+= 1;

	return res;
}

unsigned long long buildNum(unsigned long long simple, int degree, int n)
{
	unsigned long long res = 0;

	for (int i = 0; i < degree; i++)
		res *= 10, res += 1;

	res *= 10, res += simple;

	for (int i = degree; i < n - 1; i++)
		res *= 10, res += 1;

	return res;
}

unsigned long long cnt(int degree, unsigned long long l, unsigned long long r) 
{
	std::vector<int> SIMPLES = { 2, 3, 5, 7 };
	unsigned long long res = 0, num;
	bool fullStop = false;

	if (l > buildNum(7, 0, degree))
		return 0;

	for (int i = degree - 1; 0 <= i; i--)
	{
		for (int simple : SIMPLES)
		{
			num = buildNum(simple, i, degree);
			//std::cout << num << '\n';

			if (l <= num && num <= r)
				res++;
			else if (r < num) {
				fullStop = true;
				break;
			}
		}

		if (fullStop)
			break;
	}
	
	return res;
}

int main() {
	unsigned long long l, r, res = 0;
	
	std::cin >> l;
	std::cin >> r;

	for (int degree = numLen(l); degree < numLen(r) + 1; degree++)
		res += cnt(degree, l, r);

	std::cout << res;
}
