# def rec(nums, now, n, sums):
#     print(now)
#     sums.add(now)
#     for i in range(n):
#         rec(nums[:i] + nums[i + 1:], now + nums[i], n - 1, sums)
#
# sums = set()
# rec([1,3,3], 0, 3, sums)
# sums.remove(0)
# print(sums)
# [1,3,6]
# [2,5,7]
# [1,2,9]
from copy import deepcopy

tasks = [
    [2],
    [2, 1]
]
N = 2
S = 4

tasks = []
N, S = map(int, input().split())

for i in range(N):
    k = int(input())
    tasks.append([int(elem) for elem in input().split()])

# print(tasks)

def build(tasks, need):
    if need == 0:
        # print(tasks)
        return True

    # print(tasks, need)
    blocks = []

    for task_i in range(N):
        for elem in tasks[task_i]:
            if elem <= need:
                blocks.append((elem, task_i))
    if blocks:
        good_block = max(blocks, key=lambda x: x[0])
        # print(good_block)
        tmp = deepcopy(tasks)
        tmp[good_block[1]].remove(good_block[0])
        # print(tmp)
        return build(tmp, need - good_block[0])
    else:
        return False


BUILDS = []

def start_select(tasks, task_i, s):
    if task_i == N:
        if S > s:
            BUILDS.append((tasks, S - s))
        elif S == s:
            BUILDS.append(True)
        return
    for ball in tasks[task_i]:
        if ball > S:
            continue
        tmp = deepcopy(tasks)
        tmp[task_i].remove(ball)
        start_select(tmp, task_i + 1, s + ball)

def f():
    start_select(tasks, 0, 0)
    # print(BUILDS)

    for build_task in BUILDS:
        if build_task is True:
            return 'YES'

        res = build(*build_task)
        # print(res)

        if res:
            return 'YES'

    return 'NO'

print(f())
