# def rec(nums, now, n, sums):
#     print(now)
#     sums.add(now)
#     for i in range(n):
#         rec(nums[:i] + nums[i + 1:], now + nums[i], n - 1, sums)
#
# sums = set()
# rec([1,3,3], 0, 3, sums)
# sums.remove(0)
# print(sums)
# [1,3,6]
# [2,5,7]
# [1,2,9]
from copy import deepcopy

tasks = [
    [1, 3, 6],
    [2, 5, 7],
    [1, 4, 9]
]
N = 3
S = 8

tasks = []
N, S = map(int, input().split())

for i in range(N):
    k = int(input())
    tasks.append([int(elem) for elem in input().split()])

# print(tasks)

def build(tasks, need, used):
    if need == 0:
        # print(tasks, used)
        return used

    # print(tasks, need)
    blocks = []
    good_block = None

    for task_i in range(N):
        for ball_i in range(len(tasks[task_i])):
            ball = tasks[task_i][ball_i]
            if ball < need:
                blocks.append((ball_i, task_i, ball))
            if ball == need:
                good_block = (ball_i, task_i, ball)
    if blocks:
        if not good_block:
            good_block = max(blocks, key=lambda x: x[2])
        # print(good_block)
        tmp = deepcopy(tasks)
        tmp[good_block[1]][good_block[0]] = S + 1
        used[good_block[1]] = used.get(good_block[1], []) + [good_block[0]]
        # print(tmp)
        return build(tmp, need - good_block[2], used)
    else:
        return False


BUILDS = []

def start_select(tasks, task_i, s, used):
    if task_i == N:
        if S > s:
            BUILDS.append((tasks, S - s, used))
        elif S == s:
            BUILDS.append((tasks,'True', used))
        return
    for ball_i in range(len(tasks[task_i])):
        ball = tasks[task_i][ball_i]
        if ball > S:
            continue
        tmp = deepcopy(tasks)
        tmp[task_i][ball_i] = S + 1
        utmp = deepcopy(used)
        utmp[task_i] = utmp.get(task_i, []) + [ball_i]
        start_select(tmp, task_i + 1, s + ball, utmp)

def f():
    start_select(tasks, 0, 0, {})
    # print(*BUILDS, sep='\n')

    for build_task in BUILDS:
        if 'True' in build_task:
            return build_task[-1]

        res = build(*build_task)
        # print(res)

        if res:
            return res

    return False

resp = f()
if not resp:
    print('NO')
else:
    print('YES')
    # print(resp)
    for task_i in range(N):
        print(len(resp[task_i]))
        for elem in resp[task_i]:
            print(elem + 1)
