#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

#define max2(a, b) __max(a, b)
#define max3(a, b, c) max2(max2(a, b), c)
#define min2(a, b) __min(a, b)

typedef long long ll;

vector<ll> solve(const vector<ll>& mas, ll k, ll sum)
{
	vector<ll> res(2);
	if (k == 2) {
		ll r1 = sum - 2 * *mas.begin(), r2 = sum - 2 * *(mas.end() - 1);
		ll v1 = *(mas.end() - 1), v2;
		if (r1 >= r2)
			v1 = *mas.begin();
		v2 = sum - v1;
		res[0] = min2(v1, v2);
		res[1] = max2(v1, v2);
		return res;
	}
	ll suml = 0;
	for (auto ptr = mas.begin(); ptr != mas.end() - k + 1; ++ptr) {
		suml += *ptr;
		vector<ll> remmas, subres;
		remmas.assign(ptr + 1, mas.end());
		subres = solve(remmas, k - 1, sum - suml);
		ll v1 = max2(suml, subres[1]), v0 = min2(suml, subres[0]);
		if (v1 - v0 > res[1] - res[0]) {
			res[0] = v0;
			res[1] = v1;
		}
	}
	return res;
}

int main(void)
{
	ll n, k, sum = 0;
	cin >> n >> k;
	vector<ll> mas(n);
	for (ll i = 0; i < n; i++) {
		cin >> mas[i];
		sum += mas[i];
	}
	vector<ll> res = solve(mas, k, sum);
	cout << (res[1] - res[0]);
}