#include <iostream>
#include <string>
#include <vector>
#include <math.h>
#include <algorithm>

using namespace std;

using mInt = long long;

struct Vertex
{
	mInt x;
	mInt y;
};

mInt goD(Vertex& v, mInt n, mInt m, mInt k)
{
	mInt res;

	mInt r = std::min(m, n);

	if (k > r)
	{
		res = 1;
		v.x = r;
		v.y = r;
	}
	else {
		if (r % (k + 1) == 0)
		{
			res = (r - 1) / (k);
			v.x = r;
			v.y = r;
		}
		else
		{
			res = (r - 1) / (k) + 1;

			v.x = r;
			v.y = r;
		}
	}
	return res;
}

mInt goS(const Vertex& v, mInt n, mInt m, mInt k)
{
	if (m > n)
	{
		if ((m - v.y) % (k) == 0)
		{
			return (m - v.y) / k;
		}
		else
		{
			return (m - v.y) / k + 1;
		}
	}
	else
	{
		if ((n - v.x) % (k) == 0)
		{
			return (n -v.x) / k;
		}
		else
		{
			return (n - v.x) / k + 1;
		}
	}
}

int main()
{
	mInt n, m, k;
	cin >> n >> m >> k;

	if (n == 1 && m == 1)
	{
		cout << 0;
		return 0;
	}

	Vertex f_cell = { 1, 1 };

	mInt res = 0;

	auto p = goD(f_cell, n, m, k);

	if (f_cell.x == 1 && f_cell.y == 1) res = 0;
	else res += p;

	if (!(f_cell.x == n && f_cell.y == m))
	{
res += goS(f_cell, n, m, k);
	}
	

	cout << res;
	return 0;
}
