#include <iostream>
#include <vector>
#include <map>
#define ll long long
using namespace std;

bool greater_than(const vector<ll>& a, vector<ll> b) {
    for (ll i = 0; i < a.size(); i++) {
        if (a[i] == b[i])
            continue;
        else if (a[i] < b[i])
            return false;
        else
            return true;
    }
    return true;

}


ll func(const vector<ll>& num) {
    ll k = num.size() - 1;
    ll ans = k * (k + 1) * 2;

    vector<ll> number(k + 1, 1);

    vector<ll> primes = {2, 3, 5, 7};

    for (ll j = 0; j < k + 1; j++) {
        for (ll i = 0; i < 4; i++) {
            number[j] = primes[i];
            if (num >= number)
                ans++;
            else
                break;
        }
        number[j] = 1;
    }

    return ans;
}

ll p(vector<ll> n){
    ll ans = 1;
    ll i = 0;
    ll k = n.size();
    while (i != k) {
        ans *= (n[i]);
        i++;
    }
    if (ans == 2 || ans == 3 || ans == 5 || ans == 7)
        return 1;
    return 0;
}


vector<ll> razl(string str) {
    vector<ll> ans;
    map<char, ll> numbers = {{'0', 0},
                             {'1', 1},
                             {'2', 2},
                             {'3', 3},
                             {'4', 4},
                             {'5', 5},
                             {'6', 6},
                             {'7', 7},
                             {'8', 8},
                             {'9', 9}
    };
    for (auto letter : str) {
        ans.push_back(numbers[letter]);
    }

    return ans;
}

int main() {
    string l, r;
    cin >> l >> r;

    vector<ll> left = razl(l), right = razl(r);

    cout << func(right) - func(left) + p(left) << endl;
    return 0;
}