#include <bits\stdc++.h>

using namespace std;
const long long N = 1e17;
struct SegmentTree {
    vector<long long> a;
    long long size = 1;

    SegmentTree(long long size1) {
        while (size < size1) {
            size *= 2;
        }
        a.resize(size * 2);
        fill(a.begin(), a.end(),N);
    }

    void set_val(long long pos, long long val) {
        long long pos1 = pos + size;
        a[pos1] = val;
        for (long long i = pos1 >> 1; i > 0; i >>= 1) {
            a[i] = min(a[i * 2 + 1], a[i * 2]);
        }
    }

    long long get_val(int l, int r) {
        if (l == r) {
            return a[l];
        }
        long long s = 1e17;
        if (l % 2 != 0) {
            s = min(a[l], s);
            l++;
        }
        if (r % 2 == 0) {
            s = min(a[r], s);
            r--;
        }
        if (r < l) {
            return s;
        }
        return min(s,get_val(l / 2, r / 2));
    }

};

int main() {
    long long n, k;
    cin >> n >> k;
    vector<long long> a(n);
    SegmentTree tree(n);
    for (int i = 0; i < n; i++) {
        long long tmp;
        cin >> tmp;
        a[i] = tmp;
        tree.set_val(i, tmp);
    }
    vector<long long> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    long long max_ = 0;
    for (int i = 0; i < k; i++) {
        long long l = i, r = i + n - k;
        if (a[r] == 0){
            long long sum_ = pref[r + 1] - pref[l];
            max_ = max(sum_,max_);
            continue;
        }
        long long sum_ = pref[r + 1] - pref[l];
        long long min1 = 1e18,min2 = 1e17;
        if (l > 0) {
            min1 = tree.get_val(0 + tree.size,l + tree.size - 1);
        }
        if (r < a.size() - 1){
            min2 = tree.get_val(r + tree.size + 1,a.size() - 1 + tree.size);
        }
        long long min_ = min(min1,min2);
        max_ = max(sum_ - min_,max_);
    }
    reverse(a.begin(), a.end());

    cout << max_;
    return 0;
}
