#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector <ll> tree;

void build(ll v, vector <ll>& h, ll l, ll r){
    if (r - l == 1){
        tree[v] = h[l];
        return;
    }
    ll mid = (l + r) / 2;
    build(2 * v + 1, h, l, mid);
    build(2 * v + 2, h, mid, r);
    tree[v] = max(tree[2 * v + 1], tree[2 + v + 2]);
}
ll maxdo(ll v, ll l, ll r, ll yl, ll yr){
    if (l >= yl && r <= yr){
        return tree[v];
    }
    if (l >= yr || r <= yl){
        return 0;
    }
    ll mid = (l + r) / 2;
    return max(maxdo(2 * v + 1, l, mid, yl, yr), maxdo(2 * v + 2, mid, r, yl, yr));
}

void solve(){
    ll n, k, ml, mr;
    cin >> n;
    //tree.resize(4 * n);
    vector <ll> h(n, 0);
    vector <ll> rp(n , -1);
    vector <ll> delt(n, 0);
    vector <pair<ll, ll>> mx(n);
    for (int i = 0; i < n; ++i) cin >> h[i], rp[i] = i, mx[i] = {h[i], h[i]};
    //build(0, h, 0, n);
    for (ll i = 1; i < n; ++i){
        cin >> k;
        k--;
        ll c = 0;
        for (int j = 0; j < k; ++j){
            c = rp[c] + 1;
        }
        ml = mx[rp[c]].first;
        mr = mx[rp[c] + 1].second;
        for (ll j = c; j < rp[c] + 1; ++j){
            mx[j].second = max(mx[j].second, mr);
        }
        for (ll j = rp[c] + 1; j < rp[rp[c] + 1] + 1; ++j){
            mx[j].first = max(mx[j].first, ml);
        }
        ll w = 0;
        for (ll j = c; j < rp[rp[c] + 1] + 1; ++j){
            w += min(mx[j].first, mx[j].second) - h[j];
        }
        cout << w << '\n';
        ll g;
        g = rp[rp[c] + 1];
        rp[rp[c] + 1] = -1;
        rp[c] = g;
    }
}

int main() {
    ll t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
}
