#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<ll> tree;

void build(vector<ll> &data, ll v, ll l, ll r) {
    if (r - l == 1) {
        tree[v] = data[l];
        return;
    }
    build(data, 2 * v + 1, l, (l + r) / 2);
    build(data, 2 * v + 2, (l + r) / 2, r);
    tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mindo(ll v, ll l, ll r, ll yl, ll yr) {
    if (l >= yl && r <= yr) {
        return tree[v];
    }
    if (l >= yr || r <= yl) {
        return 1e10;
    }
    return min(mindo(2 * v + 1, l, (l + r) / 2, yl, yr), mindo(2 * v + 2, (l + r) / 2, r, yl, yr));
}

void solve() {
    ll n;
    ll m;
    ll r;
    ll x;
    ll ans = 0;
    ll mn;
    cin >> n >> m;
    tree.resize(4 * n);
    vector<ll> data(n, 0);
    vector<ll> pref(n + 1, 0);
    for (int i = 0; i < n; ++i) cin >> data[i], pref[i + 1] = pref[i] + data[i];
    r = n - m + 1;
    build(data, 0, 0, n);
    for (int i = 0; i < m; ++i) {
        x = pref[r + i] - pref[i];
        if (i == 0){
            mn = mindo(0, 0, n, r, n);
        }
        else{
            mn = min(mindo(0, 0, n, 0, i), mindo(0, 0, n, r + i, n));
        }
        if (ans < x - mn){
            ans = x - mn;
        }
    }
    cout << ans;
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}