#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct seg {
    ll s, m;
    deque<pair<ll, ll>> a;
};

vector<int> par;
vector<int> r;
vector<seg> v;

int get(int a) {
    if (par[a] != a) par[a] = get(par[a]);
    return par[a];
}

void addr(int a, int b) {
    v[b].s += v[a].s;
    while (!v[a].a.empty()) {
        auto &x = v[a].a.back();
        if (x.first > v[b].m) {
            ll se = 0;
            while (true) {
                auto &y = v[b].a.front();
                if (y.first == v[b].m) {
                    y.second += se;
                    break;
                }
                else {
                    v[b].s += (v[b].m - y.first) * y.second;
                    se += y.second;
                    v[b].a.pop_front();
                }
            }v[b].m = x.first;
            v[b].a.push_front(x);
            v[a].a.pop_back();
        } else {
            auto &y = v[b].a.front();
            if (x.first == y.first) {
                y.second += x.second;
                v[a].a.pop_back();
            }
            else if (x.first > y.first) {
                v[b].s += (x.first - y.first) * y.second;
                x.second += y.second;
                v[b].a.pop_front();
            } else {
                v[b].a.push_front(x);
                v[a].a.pop_back();
            }
        }
    }
}

void addl(int b, int a) {
    v[a].s += v[b].s;
    while (!v[b].a.empty()) {
        auto &x = v[b].a.front();
        if (x.first > v[a].m) {
            ll se = 0;
            while (true) {
                auto &y = v[a].a.back();
                if (y.first == v[a].m) {
                    y.second += se;
                    break;
                }
                else {
                    v[a].s += (v[a].m - y.first) * y.second;
                    se += y.second;
                    v[a].a.pop_back();
                }
            }v[a].m = x.first;
            v[a].a.push_back(x);
            v[b].a.pop_front();
        } else {
            auto &y = v[a].a.back();
            if (x.first == y.first) {
                y.second += x.second;
                v[b].a.pop_front();
            }
            else if (x.first > y.first) {
                v[a].s += (x.first - y.first) * y.second;
                x.second += y.second;
                v[a].a.pop_back();
            } else {
                v[a].a.push_back(x);
                v[b].a.pop_front();
            }
        }
    }
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    if (r[a] > r[b]) swap(a, b);
    if (r[a] == r[b]) r[b]++;
    par[a] = b;
    if (a < b) addr(a, b);
    else addl(a, b);
}

struct segt {
    vector<int> a;
    int n;

    void build(int x, int l, int r) {
        if (r - l == 1) {
            a[x] = 1;
            return;
        }
        int m = (l + r) / 2;
        build(x * 2 + 1, l, m);
        build(x * 2 + 2, m, r);
        a[x] = a[x * 2 + 1] + a[x * 2 + 2];
    }

    segt(int n) : n(n) {
        a.resize(n * 4);
        build(0, 0, n);
    }

    int find(int x, int l, int r, int k) {
        a[x]--;
        if (r - l == 1) {
            return l;
        }
        int m = (l + r) / 2;
        if (a[x * 2 + 1] <= k) {
            return find(x * 2 + 2, m, r, k - a[x * 2 + 1]);
        }
        return find(x * 2 + 1, l, m, k);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    par.resize(n);
    for (ll i = 0; i < n; ++i) par[i] = i;
    r.resize(n);
    v.resize(n);
    segt t(n);
    for (ll i = 0; i < n; ++i) {
        cin >> v[i].m;
        v[i].a.push_back({v[i].m, 1});
    }
    for (ll i = 1; i < n; ++i) {
        ll a;
        cin >> a;
        ll k = t.find(0, 0, n, a - 1);
        unite(k, k + 1);
        cout << v[get(k)].s << '\n';
    }
}
