#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <algorithm>

using namespace std;

int symcount(long long x) {
    long long x1 = 10;
    for (int i = 1; i < 30; ++i) {
        if (x < x1) {
            return i;
        }
        x1 *= 10;
    }

    return 31;
}

int main() {
    cout.sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> h(n);
    vector<vector<int>> h1(n, vector<int>(1));
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        h1[i][0] = h[i];
    }

    for (int i = 0; i < n - 1; ++i) {
        int k = 0;
        cin >> k;
        k--;

        reverse(h1[k+1].begin(), h1[k+1].end());
        while(!h1[k+1].empty()){
            h1[k].push_back(h1[k+1].back());
            h1[k+1].pop_back();
        }
        h1.erase(h1.begin()+k+1);

        long long w = 0;
        int max1 = -1;
        vector<int> max2 = vector<int>(h1[k].size(), -1);
        max2[max2.size()-1] = h1[k][max2.size()-1];

        for (int j = h1[k].size()-2; j != -1; --j) {
            max2[j] = max(max2[j+1], h1[k][j]);
        }
        for (int j = 0; j < h1[k].size(); ++j) {
            max1=max(max1, h1[k][j]);
            if(j == 0 || j == h1[k].size()-1){
                continue;
            }
            int temp1 = min(max1, max2[j]) - h1[k][j];

            if(temp1 < 0){
                temp1 = 0;
            }

            w+=temp1;
        }

        cout << w << '\n';
    }
    return 0;
}
