#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    string l, r;
    cin >> l >> r;
    vector<int> rr(r.size()), ll(l.size());
    for (int i = r.size() - 1; i > -1; i--) {
        if (r[i] - '0' == 0) {
            rr[i] = 0;
        } else if (r[i] - '0' > 1) {
            rr[i] = 1;
        } else {
            if (i != r.size() - 1) {
                rr[i] = rr[i + 1];
            } else {
                rr[i] = 1;
            }
        }
    }
    for (int i = l.size() - 1; i > -1; i--) {
        if (l[i] - '0' == 0) {
            ll[i] = 1;
        } else if (l[i] - '0' > 1) {
            ll[i] = 0;
        } else {
            if (i != l.size() - 1) {
                ll[i] = ll[i + 1];
            } else {
                ll[i] = 1;
            }
        }
    }
    if (l.size() != r.size()) {
        if (l.size() > r.size()) {
            cout << 0 << '\n';
            return 0;
        }
        long long res = 0;
        for (int i = l.size() + 1; i < r.size(); i++) {
            res += 4 * i;
        }
        int st = -1, sti = -1;
        for (int i = 0; i < l.size(); i++) {
            if ((l[i] - '0') > 1) {
                sti = i;
                st = (l[i] - '0');
                break;
            }
        }
        if (sti == -1) {
            res += 4 * l.size();
        } else {
            res += sti * 4;
            if (st < 7 || (st == 7 && (sti == l.size() - 1 || ll[sti + 1] == 1)))
                res += 1;
            if (st < 5 || (st == 5 && (sti == l.size() - 1 || ll[sti + 1] == 1)))
                res += 1;
            if (st < 3 || (st == 3 && (sti == l.size() - 1 || ll[sti + 1] == 1)))
                res += 1;
            if (st < 2 || (st == 2 && (sti == l.size() - 1 || ll[sti + 1] == 1)))
                res += 1;
        }
        st = -1, sti = -1;
        for (int i = 0; i < r.size(); i++) {
            if ((r[i] - '0') == 0) {
                sti = i;
                break;
            }
            if ((r[i] - '0') > 1) {
                sti = i;
                st = (r[i] - '0');
                break;
            }
        }
        if (sti == -1) {
            res += 0;
        } else {
            if (st != -1) {
                res += (r.size() - sti - 1) * 4;
                if (st > 2 || (st == 2 && (sti == r.size() - 1 || rr[sti + 1] == 1)))
                    res += 1;
                if (st > 3 || (st == 3 && (sti == r.size() - 1 || rr[sti + 1] == 1)))
                    res += 1;
                if (st > 5 || (st == 5 && (sti == r.size() - 1 || rr[sti + 1] == 1)))
                    res += 1;
                if (st > 7 || (st == 7 && (sti == r.size() - 1 || rr[sti + 1] == 1)))
                    res += 1;
            }
        }
        cout << res << '\n';
    } else {
        int stl = -1, stli = -1, str = -1, stri = -1;
        for (int i = 0; i < l.size(); i++) {
            if (stri == -1 && (r[i] - '0') == 0) {
                stri = i;
                break;
            }
            if (stri == -1 && (r[i] - '0') > 1) {
                stri = i;
                str = (r[i] - '0');
            }
            if (stli == -1 && (l[i] - '0') > 1) {
                stli = i;
                stl = (l[i] - '0');
            }
        }
        if (stri != -1 && str == -1) {
            cout << 0 << '\n';
        } else if (stri == -1 && stli == -1) {
            cout << 0 << '\n';
        } else if (stri == -1) {
            cout << 0 << '\n';
        } else if (stli == -1) {
            long long res = 0;
            res += 4 * (r.size() - stri - 1);
            if (str > 2 || (str == 2 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 3 || (str == 3 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 5 || (str == 5 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 7 || (str == 7 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            cout << res << '\n';
        } else if (stli < stri) {
            cout << 0 << '\n';
        } else if (stli == stri && stl > str) {
            cout << 0 << '\n';
        } else if (stli == stri) {
            long long res = 0;
            if ((stl < 2 || (stl == 2 && (stli == l.size() - 1 || ll[stli + 1] == 1))) && (str > 2 || (str == 2 && (stri == r.size() - 1 || rr[stri + 1] == 1))))
                res += 1;
            if ((stl < 3 || (stl == 5 && (stli == l.size() - 1 || ll[stli + 1] == 1))) && (str > 3 || (str == 3 && (stri == r.size() - 1 || rr[stri + 1] == 1))))
                res += 1;
            if ((stl < 5 || (stl == 5 && (stli == l.size() - 1 || ll[stli + 1] == 1))) && (str > 5 || (str == 5 && (stri == r.size() - 1 || rr[stri + 1] == 1))))
                res += 1;
            if ((stl < 7 || (stl == 7 && (stli == l.size() - 1 || ll[stli + 1] == 1))) && (str > 7 || (str == 7 && (stri == r.size() - 1 || rr[stri + 1] == 1))))
                res += 1;
            cout << res << '\n';
        } else {
            long long res = 0;
            res += 4 * (stli - stri - 1);
            if (str > 2 || (str == 2 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 3 || (str == 3 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 5 || (str == 5 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (str > 7 || (str == 7 && (stri == r.size() - 1 || rr[stri + 1] == 1)))
                res += 1;
            if (stl < 7 || (stl == 7 && (stli == l.size() - 1 || ll[stli + 1] == 1)))
                res += 1;
            if (stl < 5 || (stl == 5 && (stli == l.size() - 1 || ll[stli + 1] == 1)))
                res += 1;
            if (stl < 3 || (stl == 3 && (stli == l.size() - 1 || ll[stli + 1] == 1)))
                res += 1;
            if (stl < 2 || (stl == 2 && (stli == l.size() - 1 || ll[stli + 1] == 1)))
                res += 1;
            cout << res << '\n';
        }
    }

}