#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(); cout.tie();

    //freopen("in1.txt", "r", stdin);
    //freopen("out1.txt", "w", stdout);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    vector<int> pref(n + 1, 0);
    vector<int> minl(n), minp(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            minl[i] = a[i];
            minp[n - i - 1] = a[n - i - 1];
        } else {
            minl[i] = min(minl[i - 1], a[i]);
            minp[n - i - 1] = min(minp[n - i], a[n - i - 1]);
        }
    }
    if (k == 2) {
        cout << max(pref[n] - 2 * a[0], pref[n] - 2 * a[n - 1]) << '\n';
        return 0;
    } else if (k == 3) {
        int res = 0;
        for (int i = 1; i < n - 1; i++) {
            res = max(res, max(pref[n] - pref[i + 1] - a[i], pref[i] - a[i]));
        }
        res = max(res, max(pref[n] - 2 * a[0] - a[n - 1], pref[n] - 2 * a[0] - a[1]));
        res = max(res, max(pref[n] - 2 * a[n - 1] - a[0], pref[n] - 2 * a[n - 1] - a[n - 2]));
        cout << res << '\n';
        return 0;
    } else if (k == 4) {
        int res = 0;
        for (int i = 1; i < n - 1; i++) {
            if (i == 1 || i == n - 2)
                res = max(res, max(max(pref[n] - pref[i + 1] - a[i] - a[i + 1], pref[n] - pref[i + 1] - a[i] - a[n - 1]), max(pref[i] - a[i] - a[i - 1], pref[i] - a[i] - a[0])));
            else
                res = max(res, max(max(pref[n] - pref[i + 1] - a[i], pref[n] - pref[i + 1] - a[i]), max(pref[i] - a[i], pref[i] - a[i])));
        }
        res = max(res, pref[n] - 2 * a[0] - a[1] - a[2]);
        res = max(res, pref[n] - 2 * a[0] - a[1] - a[n - 1]);
        res = max(res, pref[n] - 2 * a[0] - a[n - 1] - a[n - 2]);
        res = max(res, pref[n] - 2 * a[n - 1] - a[0] - a[1]);
        res = max(res, pref[n] - 2 * a[n - 1] - a[0] - a[n - 2]);
        res = max(res, pref[n] - 2 * a[n - 1] - a[n - 2] - a[n - 3]);
        cout << res << '\n';
        return 0;
    }
    int res = 0;
    for (int i = 0; i < k; i++) {
        if (i == 0) {
            res = max(res, pref[i + n - k + 1] - pref[i] - minp[i + n - k]);
        } else if (i == n - 1) {
            res = max(res, pref[i + n - k + 1] - pref[i] - minl[i - 1]);
        } else
            res = max(res, pref[i + n - k + 1] - pref[i] - min(minl[i - 1], minp[i + n - k]));
    }
    for (int i = 0; i < n - k + 1; i++) {
        res = max(res, pref[i + 1] - minp[i + 2]);
    }
    for (int i = 0; i < n - k + 1; i++) {
        res = max(res, pref[n] - pref[n - i - 1] - minl[n - i - 2]);
    }
    cout << res << '\n';
}
