#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(a) a.begin(),a.end()

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

const int mod = 1e9 + 7;

int n, k, ans = 0;
vector<int> b;
vector<vector<int>> dp;

void print(auto a) {
    for (auto b : a) {
        for (auto val : b) {
            cout << val << ' ';
        }
        cout << '\n';
    }
}

bool check() {
    int sum;
    for (int i = 0; i < n; ++i) {
        sum = 0;
        for (int j = i; j > max((i - k), -1); --j) {
            for (int l = k - 1 - (i - j); l >= 0; --l) {
                sum += dp[l][j];
            }
        }
        if (sum != b[i]) {
            return 0;
        }
    }
    return 1;
}

void perebor(int i, int j) {
    if (i == k - 1 && j == n) {
        ans += check();
        return;
    }
    if (j >= n) {
        j -=n;
        ++i;
    }
    perebor(i, j + 1);
    dp[i][j] = 1;
    perebor(i, j + 1);
    dp[i][j] = 0;
}

void solve() {
    cin >> n >> k;

    dp.resize(k, vector<int>(n));
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    perebor(0, 0);

    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie();
    cin.tie();

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}