#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    ll n, k;
    cin >> n >> k;

    vector<ll> a(n);
    vector<ll> pref(n);
    vector<ll> suf(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    pref[0] = a[0];
    suf[n - 1] = a[n - 1];
    for (int i = 1; i < n; ++i) {
        pref[i] = min(pref[i - 1], a[i]);
        suf[n - i - 1] = min(suf[n - i], a[n - i - 1]);
    }

    ll sum = 0;
    ll len = n - k + 1;
    for (int i = 0; i < len; ++i) {
        sum += a[i];
    }

    ll ans = sum - suf[n - k + 1];

    for (int i = len; i < n; ++i) {
        sum -= a[i - len];
        sum += a[i];
        ans = max(ans, sum - min(pref[i - len], (ll)(i + 1 < n ? suf[i + 1] : 1e9)));
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }
}