from collections import deque

def is_prime(n: int) -> bool:
    if n < 2:
        return False
    if n == 2:
        return True
    if n % 2 == 0:
        return False
    for i in range(3, int(pow(n, 1/2)) + 2, 2):
        if n % i == 0:
            return False
    return True

def to_num(arr: list[int]) -> int:
    s = ''
    for i in arr:
        s += str(i)
    return int(s)

def to_arr(num: int) -> list[int]:
    return list(map(int, str(num)))

def next(arr: list[int]) -> list[int]:
    k = len(arr)
    if arr[0] == 7:
        return [1 for _ in range(k)] + [2]
    for i in range(k):
        if arr[i] == 2:
            arr[i] = 3
            break
        elif arr[i] == 3:
            arr[i] = 5
            break
        elif arr[i] == 5:
            arr[i] = 7
            break
        if arr[i] == 7:
            return arr[:i-1] + [2, 1] + arr[i+1:]
    return arr


def count(n: int) -> int:
    i = 2
    ans = 0
    while i < n:
        ans += 1
        i = to_num(next(to_arr(i)))
    return ans
l = count(int(input()))
r = count(int(input())+1)
print(r - l)