from collections import deque
import sys
sys.set_int_max_str_digits(110000)
table = {10 ** 10:1}
def is_prime(n: int) -> bool:
    if n < 2:
        return False
    if n == 2:
        return True
    if n % 2 == 0:
        return False
    for i in range(3, int(pow(n, 1/2)) + 2, 2):
        if n % i == 0:
            return False
    return True

def to_num(arr: list[int]) -> int:
    size, num, dig = arr
    ans = '1' * (size - num - 1) + str(dig) + '1' * num
    return int(ans)


def next(arr: list[int]) -> list[int]:
    size, num, dig = arr
    if dig == 7 and num == size - 1:
        size += 1
        num = 0
        dig = 2
    elif dig == 2:
        dig = 3
    elif dig == 3:
        dig = 5
    elif dig == 5:
        dig = 7
    elif dig == 7:
        num += 1
        dig = 2
    return [size, num, dig]

def closest(n: int) -> list[int]:
    s = str(n)
    size = len(s)
    if n > to_num([size, size - 1, 7]):
        return [size + 1, size, 2]
    for i in range(size):
        if s[i] != '1':
            if n < to_num([size, size - i - 1, 2]):
                return [size, size - i - 1, 2]
            if n < to_num([size, size - i - 1, 3]):
                return [size, size - i - 1, 3]
            if n < to_num([size, size - i - 1, 5]):
                return [size, size - i - 1, 5]
            if n < to_num([size, size - i - 1, 7]):
                return [size, size - i - 1, 7]
            else:
                return [size, size - i, 7]
    else:
        return [size, size - 1, 2]


def count(beg, end: int, flag=False) -> (int, int):
    if not flag:
        beg = closest(beg)
    i = beg
    ans = 0
    while to_num(i) <= end:
        ans += 1
        i = next(i)
    return ans, i

if __name__ == '__main__':
    l, r = int(input()), int(input())
    ans, beg = count(l, r)
    print(ans)