def bin_search(arr, targ):
    beg, end = 0, len(arr) - 1
    while beg <= end:
        m = (beg + end) // 2
        if arr[m] == targ:
            return m
        if arr[m] < targ:
            beg = m + 1
        else:
            end = m - 1
    return -1

def _divisors(n: int) -> set[int]:
    if n == 1:
        return 0
    for i in range(2, n + 1):
        if n % i == 0:
            l = _divisors(n // i)
            if not l:
                return {i}
            f = lambda x: x * i
            s = l | set(map(f, l))
            return s | {i}


def divisors(n: int) -> list[int]:
    return sorted(list(_divisors(n)))


def answer(n: int) -> int:
    ans = 0
    div = divisors(n)
    f = lambda x: n // x
    co = list(map(f, div))
    k = len(div)
    s = 0
    for i in range(s, k // 2):
        t = div[i] + co[i]
        if t % 2 == 0:
            a, b = t // 2, (t - 2 * div[i]) // 2
            if l <= b ** 2 < a ** 2 <= r:
                ans += 1
    return ans

d, l, r = list(map(int, input().split()))
print(answer(d))