def bin_search(arr, targ):
    beg, end = 0, len(arr) - 1
    while beg <= end:
        m = (beg + end) // 2
        if arr[m] == targ:
            return m
        if arr[m] < targ:
            beg = m + 1
        else:
            end = m - 1
    return m


def divisors(d: int, l: int, r: int) -> int:
    ans = 0
    x = int(pow(r, 1/2)) + 1
    while x ** 2 > l and x ** 2 > d:
        x -= 1
        y = pow(x ** 2 - d, 1/2)
        if isinstance(y, complex) or y < 1:
            return ans
        if x ** 2 - int(y) ** 2 == d:
            ans += 1
    return ans




if __name__ == '__main__':
    d, l, r = list(map(int, input().split()))
    print(divisors(d, l, r))