#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;

int p[4] = { 2, 3, 5, 7 };

int sign(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

int merge(int x, int y) {
	if (x == 0) return y;
	return x;
}

int merge(int x, int y, int z) {
	return merge(merge(x, y), z);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	string l, r;
	cin >> l >> r;

	ll ans = 0;

	for (int i = len(l) + 1; i < len(r); ++i) {
		ans += 4ll * i;
	}

	vector<int> dl(len(r)), dr(len(r));
	vector<int> clp(len(r) + 1, 0), cls(len(r) + 1, 0), crp(len(r) + 1, 0), crs(len(r) + 1, 0);

	for (int i = 0; i < len(r); ++i) {
		dr[i] = sign(1 - (r[i] - '0'));
	}
	for (int i = 0; i < len(l); ++i) {
		dl[i] = sign(1 - (l[i] - '0'));
	}

	for (int i = 0; i < len(r); ++i) {
		clp[i + 1] = merge(clp[i], dl[i]);
		crp[i + 1] = merge(crp[i], dr[i]);
	}

	for (int i = len(r) - 1; i >= 0; --i) {
		cls[i] = merge(dl[i], cls[i + 1]);
		crs[i] = merge(dr[i], crs[i + 1]);
	}

	if (len(l) == len(r)) {
		for (int i = 0; i < len(r); ++i) {
			for (int j = 0; j < 4; ++j) {
				if (merge(clp[i], sign(p[j] - (l[i] - '0')), cls[i + 1]) >= 0 && merge(crp[i], sign(p[j] - (r[i] - '0')), crs[i + 1]) <= 0) ++ans;
			}
		}
	}
	else {
		for (int i = 0; i < len(r); ++i) {
			for (int j = 0; j < 4; ++j) {
				if (merge(crp[i], sign(p[j] - (r[i] - '0')), crs[i + 1]) <= 0) {
					++ans;
				}
			}
		}
		for (int i = 0; i < len(l); ++i) {
			for (int j = 0; j < 4; ++j) {
				if (merge(clp[i], sign(p[j] - (l[i] - '0')), cls[i + 1]) >= 0) {
					++ans;
				}
			}
		}
	}
	cout << ans << '\n';
}
