#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int n, k;
	cin >> n >> k;
	--k;

	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	vector<ll> p1(n + 1, 0), p2(n + 1, 0), s2(n + 1, 0);

	for (int i = 0; i < n; ++i) {
		p1[i + 1] = p1[i] + a[i];
		p2[i + 1] = min(p2[i], (ll)a[i]);
	}

	for (int i = n - 1; i >= 0; --i) {
		s2[i] = min(s2[i + 1], (ll)a[i]);
	}

	ll ans = 0;
	for (int i = 0; i <= k; ++i) {
		ans = max(ans, abs(p1[i + n - k] - p1[i] - min(p2[i], s2[i + n - k])));
	}
	cout << ans << '\n';
}
