#include <iostream>
#include <algorithm>
#include <math.h>
#include <random>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define len(v) (int)((v).size())
typedef long long ll;


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int n, s;
	cin >> n >> s;

	vector<vector<int>> a(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;

		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}

	for (int i = 0; i < n; ++i) {
		bool fl = false;
		for (int j = 0; j < len(a[i]); ++j) {
			fl = fl || (a[i][j] <= s);
		}
		if (!fl) {
			cout << "NO\n";
			return 0;
		}
	}

	vector<int> b;
	vector<int> upd;

	for (int i = 0; i < n; ++i) {
		int lna = 0;
		for (int j = 0; j < len(a[i]); ++j) {
			if (a[i][j] > s) continue;
			++lna;
			b.push_back(a[i][j]);
			upd.push_back(-1);
		}
		upd.back() = len(b) - lna;
	}


	vector<vector<int>> dp(len(b) + 1, vector<int>(s + 1, 0));
	dp[0][0] = 1;

	for (int i = 0; i < len(b); ++i) {
		dp[i + 1] = dp[i];
		for (int j = 0; j + b[i] <= s; ++j) {
			dp[i + 1][j + b[i]] += dp[i][j];
		}
		if (upd[i] != -1) {
			for (int j = 0; j <= s; ++j) {
				dp[i + 1][j] -= dp[upd[i]][j];
			}
		}
	}

	if (dp[len(b)][s] == 0) {
		cout << "NO\n";
		return 0;
	}
	else cout << "YES\n";

	vector<int> ans;

	int v = s;

	for (int i = len(b) - 1; i >= 0; --i) {
		if (v - b[i] >= 0 && dp[i][v - b[i]] != 0) {
			v -= b[i];
			ans.push_back(i);
		}
	}

	int ind = 0;
	reverse(ans.begin(), ans.end());
	
	int cr = 0;
	for (int i = 0; i < n; ++i) {
		vector<int> res;
		for (int j = 0; j < len(a[i]); ++j) {
			if (a[i][j] > s) continue;
			if (ind < len(ans) && cr == ans[ind]) {
				++ind;
				res.push_back(j);
			}
			++cr;
		}
		cout << len(res) << '\n';
		for (int x : res) cout << x + 1 << ' ';
		cout << '\n';
	}


}
