#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <valarray>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();

    return 0;
}

void solve() {
    ll d, l, r;
    cin >> d >> l >> r;
    set<pair<int, int>> ans;
    for (ll i = 1; i * i <= d; i++) {
        if (d % i == 0) {
            ll xmy = i;
            ll xpy = d / i;
            if (xmy % 2 != xpy % 2) continue;
            ll x = (xmy + xpy) / 2;
            ll y = (-xmy + xpy) / 2;
            if (l <= x * x && x * x <= r && l <= y * y && y * y <= r) ans.insert({x, y});
        }
    }
    cout << ans.size() << '\n';
}