#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
const vector<ll> prime = {2, 3, 5, 7};
ll count_large(ll x) {
    ll ans = 0;
    for (ll i = x; i < 10; i++) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
ll count_large_prime(string s) {
    ll non_1 = 0;
    for (char c : s) {
        if (c - '0' == 0) {
            if (non_1 == 0) {
                return 4 * s.size();
            }
        }
        if (c - '0' > 1) {
            non_1++;
        }
    }
    ll rem = 0;
    for (char c : s) {
        rem += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && non_1 > 1);
        if (c - '0' > 1) {
            break;
        }
    }
    if (s.size() == 1) {
        rem = count_large(s[0] - '0');
    }
    return rem;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string l, r;
    cin >> l >> r;
    ll ans = 0;
    ans += (ll)((r.size() + 1) * r.size() - (l.size() + 1) * l.size()) * 2 + count_large_prime(l) - count_large_prime(r);
    ll v = 0;
    ll x = 0;
    for (char c : r) {
        if (c != '1') {
            v++;
            x = c - '0';
        }
    }
    if (v == 1 && find(prime.begin(), prime.end(), x) != prime.end()) {
        ans++;
    }
    cout << ans << endl;
    return 0;
}
