#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
const vector<int> prime = {2, 3, 5, 7};
int count_large(int x) {
    int ans = 0;
    for (int i = x; i < 10; i++) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
int count_less(int x) {
    int ans = 0;
    for (int i = x; i > 1; i--) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
int main() {
   string l, r;
   cin >> l >> r;
   int ans = 0;
   if (l.size() < r.size()) {
       bool zeroes = false;
       for (char c : l) {
           if (c - '0' <= 1) {
               zeroes = true;
               break;
           }
       }
       int fl = 0;
       int rem1 = 0;
       for (char c: l) {
           if (!fl) {
               rem1 += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && !zeroes);
           }
           fl += ((c - '0') > 1);
       }
       if (l.size() == 1) {
           rem1 = count_large(l[0] - '0');
       }
       ans += rem1;
       int len = l.size() + 1;
       while (len < r.size()) {
           ans += len * 4;
           len++;
       }
       int fl2 = 0;
       zeroes = true;
       int rem = 0;
       for (char c : r) {
           if (c - '0' > 1) {
               fl2++;
               rem += (count_less(c - '0'));
           }
           if (c == '0') {
               zeroes = false;
           }
       }
       if (!zeroes) {
           ans = 0;
       } else if (fl2 > 0) {
           ans += rem;
       } else {
           ans += 1;
       }
   } else {
       bool zeroes = false;
       for (char c : l) {
           if (c -  '0' <= 1) {
               zeroes = true;
               break;
           }
       }
       int fl = 0;
       int rem1 = 0;
       for (char c: l) {
           if (!fl) {
               rem1 += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && !zeroes);
           }
           fl += ((c - '0') > 1);
       }
       if (l.size() == 1) {
           rem1 = count_large(l[0] - '0');
       }
       zeroes = false;
       for (char c : r) {
           if (c - '0' <= 1) {
               zeroes = true;
               break;
           }
       }
       int fl2 = 0;
       int rem2 = 0;
       for (char c : r) {
           if (!fl2) {
               rem2 += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && !zeroes);
           }
           fl2 += ((c - '0') > 1);
       }
       if (r.size() == 1) {
           rem2 = count_large(r[0] - '0');
       }
       int v = 1;
       for (char c : r) {
           v *= (c - '0');
       }
       if (find(prime.begin(), prime.end(), v) != prime.end()) {
           rem2--;
       }
      //cout << rem1 << ' ' << rem2 << endl;
       ans = rem1 - rem2;
   }
   cout << ans << endl;
   return 0;
}
