#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
bool prime[11] = {false, false, true, true, false, true, false, true, false, false};
ll largest[11] = {4, 4, 4, 3, 2, 2, 1, 1, 0, 0};
ll count_large_prime(const string& s) {
    ll non_1 = 0;
    for (char c : s) {
        if ((c - '0') == 0 && non_1 == 0) {
            return 4 * (ll)s.size();
        }
        if ((c - '0') > 1) {
            non_1++;
        }
        if (non_1 == 2) {
            break;
        }
    }
    bool mas[s.size()];
    ll co = 0;
    ll type = false;
    for (int i = s.size()-1; i >= 0; i--) {
        mas[i] = type;
        if (s[i] == '0') {
            co++;
            type = 0;
        }
        if (s[i] > '1') {
            type = 1;
        }
    }
    ll rem = 0;
    for (int i = 0; i < s.size(); i++) {
        char c = s[i];
        rem += largest[c - '0'] - ((prime[c - '0'] && (non_1 > 1) && mas[i]) ? 1 : 0);
        if ((c - '0') > 1) {
            break;
        }
    }
    return rem;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string l, r;
    getline(cin, l);
    getline(cin, r);
    ll ans = (ll)((r.size() + 1) * r.size() - (l.size() + 1) * l.size()) * 2 + count_large_prime(l) - count_large_prime(r);
    ll v = 0;
    ll x = 0;
    for (char c : r) {
        if (c != '1') {
            v++;
            x = (c - '0');
        }
        if (v == 2) {
            break;
        }
    }
    if (v == 1 && prime[x]) {
        ans++;
    }
    cout << ans;
    return 0;
}
