#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e5+1;
const vector<int> prime = {2, 3, 5, 7};
int count_large(int x) {
    int ans = 0;
    for (int i = x; i < 10; i++) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
int count_less(int x) {
    int ans = 0;
    for (int i = x; i > 1; i--) {
        if (find(prime.begin(), prime.end(), i) != prime.end()) {
            ans++;
        }
    }
    return ans;
}
ll count_large_prime(string r) {
   ll zeroes = 0;
    for (char c : r) {
        if (c - '0' > 1) {
            zeroes++;
        }
    }
    ll fl2 = 0;
    ll rem2 = 0;
    for (char c : r) {
        if (!fl2) {
            rem2 += count_large(c - '0') - (find(prime.begin(), prime.end(), c - '0') != prime.end() && zeroes > 1);
        }
        fl2 += ((c - '0') > 1);
    }
    if (r.size() == 1) {
        rem2 = count_large(r[0] - '0');
    }
    return rem2;
}
int main() {
   string l, r;
   cin >> l >> r;
   ll ans = 0;
   if (l.size() < r.size()) {
       ll rem1 = count_large_prime(l);
       ans += rem1;
       ll len = l.size() + 1;
       while (len < r.size()) {
           ans += len * 4;
           len++;
       }

       string s = "1";
       for (int i = 1; i < len; i++) {
           s += '0';
       }
       int rem2 = count_large_prime(s) - count_large_prime(r);
       //cout << count_large_prime(s) << ' ' << count_large_prime(r) << ' ' << count_large_prime(l) << endl;
       ll v = 1;
       for (char c : r) {
           v *= (c - '0');
       }
       if (find(prime.begin(), prime.end(), v) != prime.end()) {
           rem2++;
       }
       ans += rem2;
   } else {
       ll rem1 = count_large_prime(l);
       ll rem2 = count_large_prime(r);
       ll v = 1;
       for (char c : r) {
           v *= (c - '0');
       }
       if (find(prime.begin(), prime.end(), v) != prime.end()) {
           rem2--;
       }
      //cout << rem1 << ' ' << rem2 << endl;
       ans = rem1 - rem2;
   }
   cout << ans << endl;
   return 0;
}
