#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
#include <cmath>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 1e18+1;
ll stress(ll d, ll l, ll r) {
    ll ans = 0;
    vector<ll> sq;
    for (ll i = ceil(sqrt(l)); i * i <= r; i++) {
        sq.push_back(i * i);
        for (long long j : sq) {
            if (i * i - j == d) {
                ans++;
            }
        }
    }
    return ans;
}
ll my(ll d, ll l, ll r) {
    ll ans = 0;
    for (ll z = 1; z * z <= d; z++) {
        if (d % z == 0) {
            ll y = (d / z - z) / 2;
            if (y <= 0 || (d / z - z) % 2) continue;
            if ((y + z) * (y + z) <= r && y * y >= l) {
                ans++;
                //cout << y * y << ' ' << (y + z) * (y + z) << endl;
            }
        }
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll d, l, r;
//    for (d = 1; d < 100; d++) {
//        for (l = 1; l < 1000; l++) {
//            for (r = 1; r < 1000; r++) {
//                if (stress(d, l, r) != my(d, l, r)) {
//                    cout << d << ' ' << l << ' ' << r << endl;
//                    return 0;
//                }
//            }
//        }
//    }
    cin >> d >> l >> r;
    cout << my(d, l, r);
    return 0;
}
