#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
#include <cmath>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 3e5+1;
ll a[MAX_N];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }

    ll ans = 0;
    for (ll r = 1; r <= n - k + 1; r++) {
        multiset<ll> S;
        for (ll i = r; i < n; i++) {
            S.insert(a[i]);
        }
        ll s = 0;
        for (ll i = 0; i < r; i++) {
            s += a[i];
        }
        ll j = r;
        while (j < n) {
            ans = max(ans, s - *S.begin());
            s -= a[j - r];
            s += a[j];
            S.insert(a[j - r]);
            S.erase(S.find(a[j]));
            j++;
        }
        ans = max(ans, s - *S.begin());
    }

    cout << ans;
    return 0;
}
