#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>
#include <cmath>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
typedef long long ll;
typedef long double ld;
const ll MAX_N = 3e5+1;
ll a[MAX_N], pref[MAX_N];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    multiset<ll> S1;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pref[i+1] = pref[i] + a[i];
        S1.insert(a[i]);
    }
    ll ans = 0;
    for (ll r = 1; r <= n - k + 1; r++) {
        S1.erase(S1.find(a[r-1]));
        multiset<ll> S = S1;
        for (ll j = r; j < n; j++) {
            ans = max(ans, (pref[j] - pref[j - r]) - *S.begin());
            S.insert(a[j - r]);
            S.erase(S.find(a[j]));
        }
        ans = max(ans, (pref[n] - pref[n - r]) - *S.begin());
    }
    cout << ans;
    return 0;
}
