#include <iostream>
#include <string>
#include <map>
#include <cstring>
#include <vector>
using namespace std;
using ll = long long;
const int maxn = 1e7 + 20;
int a[maxn];
int ind[maxn];
int rind[maxn];
vector<int> ans[int(1e5) + 1];

int main()
{
	int n, s;
	cin >> n >> s;
	map<pair<int, int>, int> mp;
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			cin >> a[cnt];
			mp[{i, j}] = cnt;
			ind[cnt] = i;
			rind[cnt] = j;
			cnt++;
		}
	}
	vector<vector<int>> dp(cnt + 1, vector<int>(s + 1, -2));
	vector<vector<bool>> tt(cnt + 1, vector<bool>(s + 1, false));
	for (int i = 1; i <= cnt; i++)
		dp[i][0] = -1;
	dp[0][0] = 0;
	for (int i = 1; i <= cnt; i++) {
		for (int j = 1; j <= s; j++) {
			if (i == 1 || ind[i - 2] != ind[i - 1]) {
				if (dp[i - 1][j] == 0)
					dp[i][j] = -1;
				if (j - a[i - 1] >= 0 && dp[i - 1][j - a[i - 1]] == 0) {
					dp[i][j] = 0;
					tt[i][j] = true;
				}
			}
			else {
				dp[i][j] = dp[i - 1][j];
				if (j - a[i - 1] >= 0 && dp[i - 1][j - a[i - 1]] != -2) {
					dp[i][j] = 0;
					tt[i][j] = true;
				}
			}
		}
	}
	/*for (int i = 0; i <= cnt; i++) {
		for (int j = 0; j <= s; j++)
			cout << dp[i][j] << " ";
		cout << "\n";
	}*/
	if (dp[cnt][s] != 0) {
		cout << "No\n";
		return 0;
	}
	//cout << "Yes\n";
	string anss;
	anss += "Yes\n";
	int cur = s, curi = cnt;
	ll check = 0;
	while (cur != 0 || curi != 0) {
		if (tt[curi][cur]) {
			ans[ind[curi - 1]].push_back(rind[curi - 1]);
			cur -= a[curi - 1];
			check += a[curi - 1];
			curi--;
		}
		else
			curi--;
	}
	for (int i = 0; i < n; i++) {
		anss += to_string(ans[i].size());
		anss += "\n";
		//cout << ans[i].size() << "\n";
		if (ans[i].size() == 0) {
			cout << "No\n";
			return 0;
		}
		for (auto& v : ans[i]) {
			anss += to_string(v + 1) + " ";
			//cout << v + 1 << " ";
		}
		anss += "\n";
		//cout << "\n";
	}
	cout << anss;
	return 0;
}
