﻿#include <iostream>
#include <vector>
#define int long long

using namespace std;
bool check(vector<int> nm) {
    int cnt = 0;
    int ln;
    for (int i = 0; i < nm.size(); i++) {
        if (nm[i] != 1) {
            cnt++;
            ln = nm[i];
        }
    }
    return cnt == 1 && (ln == 2 || ln == 3 || ln == 5 || ln == 7);
}
int stress(int n) {
    int ans = 0;
    vector<int> k;
    int kk;
    for (int i = 1; i <= n; i++) {
        k.clear();
        kk = i;
        while (kk) {
            k.push_back(kk % 10);
            kk /= 10;
        }
        reverse(k.begin(), k.end());
        if (check(k)) ans++;
    }
    return ans;
}
int solve(vector<int> n) {
    int fp = 0;
    for (int i = 1; i < n.size(); i++) {
        fp += 4 * i;
    }
    int sp = 0;
    bool fl = false;
    for (int i = 0; i < n.size(); i++) {
        if (n[i] > 1) {
            fl = true;
        }
        if (n[i] == 0 && !fl) return fp;
    }
    if (!fl) return fp;
    int it = 0;
    while (n[it] == 1) it++;
    bool mn = false;
    for (int i = it + 1; i < n.size(); i++) {
        if (n[i] > 1) break;
        if (n[i] == 0) {
            mn = true;
            break;
        }
    }
    if (n[it] == 2) sp = 1 - mn;
    else if (n[it] == 3) sp = 2 - mn;
    else if (n[it] == 5) sp = 3 - mn;
    else if (n[it] == 7) sp = 4 - mn;
    else if (n[it] > 7) sp = 4;
    else if (n[it] > 5) sp = 3;
    else if (n[it] > 3) sp = 2;
    else if (n[it] > 2) sp = 1;
    for (int i = it + 1; i < n.size(); i++) {
        sp += 4;
    }
    return fp + sp;
}

void test() {
    vector<int> k;
    int kk;
    for (int i = 1; i <= 10000; i++) {
        k.clear();
        kk = i;
        while (kk) {
            k.push_back(kk % 10);
            kk /= 10;
        }
        reverse(k.begin(), k.end());
        if (stress(i) != solve(k)) {
            cout << "WA\n";
            cout << i << '\n';
            break;
        }
    }
}
signed main() {
    
    string ll, rr;
    cin >> ll >> rr;
    vector<int> l(ll.length());
    vector<int> r(rr.length());
    for (int i = 0; i < ll.length(); i++) {
        l[i] = ll[i] - '0';
    }
    for (int i = 0; i < rr.length(); i++) {
        r[i] = rr[i] - '0';
    }
    int a = solve(l);
    int b = solve(r);
    cout << b - a + check(l);
    
    return 0;
}
