﻿#include <iostream>
#include <vector>
#include <string>
using namespace std;


long long f(string a, int i, vector<int>& d, vector<int>& p, vector<int>& e)
{
	int ans = 0, n = a.size() - i;

	if (n == 0)
	{
		return 0;
	}
	if (a[i] == '0')
	{
		return 0;
	}

	if (a[i] == '1')
	{
		ans += f(a, i + 1, d, p, e);
	}
	else
	{
		if(n > 1) ans += d[n - 1] - d[n - 2];
		//cout << a << " " << i << "-) " << ans << "\n";
	}

	int j = 0; 
	while (j < p.size() && p[j] < a[i] - '0')
	{
		j++;
	}
	ans += j;
	if (j < p.size() && p[j] == a[i] - '0')
	{
		if (i == a.size() - 1)
		{
			ans++;
		}
		else
		{
			if (e[i + 1] == 1)
			{
				ans++;
			}
		}
	}
	//cout << a << " " << i << ") " << ans << "\n";
	return ans;

}

void build(vector<int>& d)
{
	long long inf = 1e5 + 1;
	d.resize(inf);

	d[0] = 0;
	d[1] = 4;

	for (int i = 2; i < d.size(); i++)
	{
		d[i] = d[i - 1] + i * 4;
	}

}

int main()
{
	string l, r;
	cin >> l >> r;
	int ansl, ansr;

	vector<int> d;
	build(d);
	vector<int> p = { 2, 3, 5, 7 };

	vector<int> e(l.size());
	for (int i = e.size() - 1; i >= 0; i--)
	{
		if (l[i] == '0')
		{
			e[i] = 0;
			continue;
		}
		if (l[i] == '1')
		{
			if (i < e.size() - 1)
			{
				e[i] = e[i + 1];
				continue;
			}
			e[i] = 1;
			continue;
		}
		e[i] = 1;
	}
	ansl = f(l, 0, d, p, e);


	e.resize(r.size());
	for (int i = e.size() - 1; i >= 0; i--)
	{
		if (r[i] == '0')
		{
			e[i] = 0;
			continue;
		}
		if (r[i] == '1')
		{
			if (i < e.size() - 1)
			{
				e[i] = e[i + 1];
				continue;
			}
			e[i] = 1;
			continue;
		}
		e[i] = 1;
	}
	ansr = f(r, 0, d, p, e);

	if(l.size() > 0) ansl += d[l.size() - 1];
	if (r.size() > 0) ansr += d[r.size() - 1];

	vector<int> pr(10, 0);
	for (int i = 0; i < l.size(); i++)
	{
		if (l[i] != '1' && pr[l[i] - '0'] == 1)
		{
			//cout << "\n" << ansl << " " << ansr << "\n";
			cout << ansr - ansl << "\n";
			return 0;
		}
		pr[l[i] - '0']++;
		if (l[i] != '1' && l[i] != '2' && l[i] != '3' && l[i] != '5' && l[i] != '7')
		{
			//cout << "\n" << ansl << " " << ansr << "\n";
			cout << ansr - ansl << "\n";
			return 0;
		}

	}
	//cout << "\n" << ansl << " " << ansr << "\n";
	if (pr[2] == 1 || pr[3] == 1 || pr[5] == 1 || pr[7] == 1) ansl--;

	cout << ansr - ansl;
}
