﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
//
struct tree
{
	long long sum, mi;
	int ima, imi;
	tree() {}
	tree(long long a)
	{
		sum = a;
		mi = a;
	}
	tree(long long a, int b)
	{
		sum = a;
		mi = a;
		ima = b;
		imi = b;
	}
	tree(long long a, long long c)
	{
		sum = a;
		mi = c;
		ima = -1;
		imi = -1;
	}
};

void build(int x, int l, int r, vector<long long>& t, vector <long long>& a)
{
	if (r - l == 1)
	{
		t[x] = a[l];
		return;
	}

	int m = (l + r) / 2;
	build(x * 2 + 1, l, m, t, a);
	build(x * 2 + 2, m, r, t, a);

	t[x] = min(t[x * 2 + 1], t[x * 2 + 2]);
}

void build(vector<long long>& t, vector<long long>& a)
{
	t.resize(a.size() * 4, 0);
	build(0, 0, a.size(), t, a);
}

long long get(int x, int l, int r, int lx, int rx, vector<long long>& t, vector<long long>& a)
{
	if (r <= lx || l >= rx)
	{
		return 1e9;
	}
	if (r <= rx && l >= lx)
	{
		return t[x];
	}

	int m = (l + r) / 2;
	return min(get(x * 2 + 1, l, m, lx, rx, t, a), get(x * 2 + 2, m, r, lx, rx, t, a));

}

long long get(int lx, int rx, vector<long long>& t, vector<long long>& a)
{
	return get(0, 0, a.size(), lx, rx, t, a);
}

void f2(long long s, vector<long long>& a)
{
	int n = a.size();
	long long m = 0, ans = 0;
	for (int i = 0; i < n - 1; i++)
	{
		m += a[i];
		ans = max(ans, max(m, s - m) - min(m, s - m));
	}
	cout << ans;
	return;
}

int main()
{
	int n, s;
	cin >> n >> s;
	int m = 0;
	for (int i = 0; i < n; i++)
	{
		int k, a;
		cin >> k >> a;
		m += a;
	}
	if (m == s)
	{
		cout << "Yes\n";
		for (int i = 0; i < n; i++)
		{
			cout << "1\n1\n";
		}
		return 0;
	}
	cout << "No";
}
/*


A 78


	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	long long d, l, r;
	cin >> d >> l >> r;
	r++;
	vector<long long> a(2);
	a[1] = 1;
	a[0] = 0;
	long long x = 2, y = 1;
	while (y * y < l)
	{
		y++;
	}
	l = y;
	while (x * x < r)
	{
		a.push_back(x * x - (x - 1) * (x - 1) + a[a.size() - 1]);
		x++;
	}
	r = x;
	long long s = 0;
	for (long long i = l; i < r - 1; i++)
	{
		long long ll = i + 1, rr = r;
		while (rr - ll > 1)
		{
			long long m = (ll + rr) / 2;
			if (a[m] - a[i] > d) rr = m;
			else ll = m;
		}
		if (a[ll] - a[i] == d)
		{
			//cout << i << " " << ll << " " << d << "\n";
			s++;
		}
	}
	cout << s;

64 1 100

64 1 300


*/