#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
#define PB push_back
#define all(x) x.begin(), x.end()
#define endl "\n"

void print(vi v){
    for (auto& x: v){
        cout << x << " ";
    }
    cout << endl;
}

// solve

int get_v(vi& v){
    int n = v.size();

    vi ind_l(n);
    int mx = -1;
    int ind = -1;
    for (int i = 0; i < n; i++){
        if (v[i] > mx){
            ind_l[i]= -1;
            mx = v[i];
            ind = i;
        }
        else{
            ind_l[i] = ind;
        }
    }

    vi ind_r(n);

    mx = -1;
    ind = -1;
    for (int i = n - 1; i >= 0; i--){
        if (v[i] > mx){
            ind_r[i]= -1;
            mx = v[i];
            ind = i;
        }
        else{
            ind_r[i] = ind;
        }
    }

    /*
    cout << "v: "; print(v);
    cout << "l: "; print(ind_l);
    cout << "r: "; print(ind_r);
    */

    int ans = 0;
    for (int i = 0; i < n; i++){
        int l = ind_l[i];
        int r = ind_r[i];
        if (l == -1 || r == -1){
            continue;
        }

        int h1 = v[l], h2 = v[r];
        int h = min(h1, h2);
        ans += h - v[i];
    }

    return ans;
}

set<pair<int, vi>> st;



void solve(){
    int n; cin >> n;

    for (int i = 0; i < n; i++){
        int x; cin >> x;
        st.insert({i + 1, {x}});
    }

    vi v;
    for (int _ = 0; _ < n - 1; _++){
        int k; cin >> k;
        auto it = st.begin();
        for (int i = 0; i < k - 1; i++){
            it++;
        }

        v = (*it).second;
        int num = (*it).first;
        auto it2 = it;
        it2++;
        for (auto& el: (*it2).second){
            v.PB(el);
        }
        int ans = get_v(v);
        cout << ans << endl;

        st.erase(it);
        st.erase(it2);
        st.insert({num, v});

    }

}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
};

/*
8
9 1 8 1 5 2 3 6
3
3
1
3
3
2
1
 */
