#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a){
    for (auto x: a){
        cout << x << " ";
    }
    cout << endl;
}

void solve(){
    int n, k; cin >> n >> k;
    vi a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    vi pref = {a[0]};
    for (int i = 1; i < n; i++){
        pref.PB(min(pref.back(), a[i]));
    }
    vi suf = {a[n - 1]};
    for (int i = n - 2; i >= 0; i--){
        suf.PB(min(suf.back(), a[i]));
    }
    reverse(all(suf));

    int len = n - k + 1;
    int sum = 0;
    for (int i = 0; i < len; i++){
        sum += a[i];
    }

    int ans = -INF;
    ans = max(ans, sum - suf[2]);

    for (int i = 1; i < n - len; i++){
        sum += a[i + len - 1];
        sum -= a[i - 1];
        int mn = min(pref[i - 1], suf[i + len]);
        ans = max(ans, sum - mn);
    }
    sum += a[n - 1];
    sum -= a[n - len - 1];
    ans = max(ans, sum - pref[n - len - 1]);

    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}
