#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <set>


using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << endl;
}

void solve1(int s) {
    int k; cin >> k;
    vi a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }

    vector<set<int>> dp(k);
    dp[0] = { a[0] };
    int val = -1;
    vi take(100001, -1);
    take[a[0]] = 0;
    for (int i = 1; i < k; i++) {
        dp[i] = dp[i - 1];
        for (auto x : dp[i - 1]) {
            val = x + a[i];
            if (val <= s && !dp[i].count(val)) {
                take[val] = i;
                dp[i].insert(val);
            }
        }
    }

    if (!dp[k - 1].count(s)) {
        cout << "NO" << endl;
        return;
    }
    cout << "YES" << endl;
    vi ans;
    while (s > 0) {
        ans.PB(take[s] + 1);
        s -= a[take[s]];
    }
    cout << ans.size() << endl;
    print(ans);
}

void solve() {
    int n, s; cin >> n >> s;
    if (n == 1) {
        solve1(s);
        return;
    }
    vector<vi> a(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        while (k--) {
            int x; cin >> x;
            a[i].push_back(x);
        }
    }



}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}