﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <set>


using namespace std;

#define int long long

using ll = long long;
using vi = vector<int>;
#define all(x) x.begin(), x.end()
#define PB push_back

const int inf = 1e9 + 1;
const ll INF = 1e18 + 1;


void print(vi a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << endl;
}

void solve1(int s) {
    int k; cin >> k;
    vi a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }

    vi dp1(s + 1, 0);
    vi dp2(s + 1, 0);
    
    int val = -1;
    vi take(s + 1, -1);
    dp1[0] = 1;
    for (int i = 0; i < k; i++) {
        dp2 = dp1;
        if (a[i] > s) {
            continue;
        }
        for (int j = 0; j < s; j++) {
            if (dp1[j]) {
                val = a[i] + j;
                if (val <= s && !dp2[val]) {
                    dp2[val] = 1;
                    take[val] = i;
                }
            }
        }
        print(dp2);
        dp1 = dp2;
        dp2.assign(s + 1, 0);
    }

    if (!dp1[s]) {
        cout << "NO" << endl;
        return;
    }
    else {
        cout << "YES" << endl;
        vi ans;
        while (s > 0) {
            ans.PB(take[s] + 1);
            s -= a[take[s]];
        }
        cout << ans.size() << endl;
        print(ans);
    }
}

void solve() {
    int n, s; cin >> n >> s;
    if (n == 1) {
        solve1(s);
        return;
    }
    vector<vi> a(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        while (k--) {
            int x; cin >> x;
            a[i].push_back(x);
        }
    }


    
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
}