#include <bitset>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <map>
#include <deque>
#include <iostream>

using namespace std;
using ll = long long;

void sol() {
    int n, k;
    cin >> n;
    vector <ll> v(n);
    vector <int> nxt(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        nxt[i] = i + 1;
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> k;
        k--;
        int ptr = 0, cur = 0;
        while (ptr < k) {
            ptr++;
            cur = nxt[cur];
        }
        nxt[cur] = nxt[nxt[cur]];
        ll res = 0;
        multiset <ll> s1, s2;
        for (int j = cur + 1; j < nxt[cur]; j++) {
            s2.insert(-v[j]);
        }
        s1.insert(-v[cur]);
        for (int j = cur + 1; j < nxt[cur] - 1; j++) {
            s1.insert(-v[j]);
            ll h = min(-*s1.begin(), -*s2.begin());
            res += h - v[j];
            s2.erase(s2.find(-v[j]));
        }
        cout << res << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> t;
    while (T--) {
        sol();
    }
}

//8
//9 1 8 1 5 2 3 6
//3 3 1 3 3 2 1
