#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <climits>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

void sol() {
    int n, k;
    cin >> n >> k;
    vector <ll> v(n), p(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        if (i != 0) {
            p[i] = p[i - 1];
        }
        p[i] += v[i];
    }
    if (k == 2) {
        ll sm1 = 0, sm2 = p[n - 1];
        ll ans = -1;
        for (int i = 1; i < n; i++) {
            sm1 += v[i - 1], sm2 -= v[i - 1];
            ans = max(ans, max(sm1, sm2) - min(sm1, sm2));
        }
        cout << ans << '\n';

        return;
    }
    set <pair <ll, int>> s;
    int d = n - k + 1;
    for (int i = 1; i + d <= n; i++) {
        s.insert({-(p[i + d- 1] - p[i - 1]), i});
    }
    ll ans = -s.begin()->first - v[0];
    for (int i = 1; i < n; i++) {
        if (i == d) {
            s.insert({-(p[i - 1]), n});
        } else if (i > d) {
            s.insert({-(p[i - 1] - p[i - d - 1]), n});
        }
        while (!s.empty() &&  s.begin()->second <= i) {
            s.erase(s.begin());
        }
        if (!s.empty()) {
            ans = max(ans, -s.begin()->first - v[i]);
        } else {
            if (i != n - 1) {
                ans = max(ans, p[n - 1] - p[i] - v[i]);
            }
            ans = max(ans, p[i - 1] - v[i]);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}
