#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <climits>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

constexpr ll M = 1e9 + 7;

int n, m, k;
int ans = 0;
vector <pair <int, int>> v;

void dfs(int x, int y, vector <vector <bool>> used, bool st, bool vniz, bool k1, bool k2, bool p1, bool p2) {
    if (vniz) {
        for (int i = 0; i < k; i++) {
            if (!used[v[i].first][v[i].second]) {
                if (k1 && v[i].second < y && v[i].first == x) {
                    return;
                }
                if (k2 && v[i].second > y && v[i].first == x) {
                    return;
                }
                if (p1 && v[i].second == y && v[i].first < x) {
                    return;
                }
                if (p2 && v[i].second == y && v[i].first > x) {
                    return;
                }
            }
        }
    }
    if (x == n - 1 && y == m - 1) {
        k1 = false;
        k2 = false;
        p1 = false;
        p2 = false;
        vniz = false;
    } else if (x != 0 || y != 0) {
        if (y == 0) {
            k1 = true;
        }
        if (y == m - 1) {
            k2 = true;
        }
        if (k1 && k2) {
            return;
        }
        if (x == 0) {
            p1 = true;
        }
        if (x == n - 1) {
            p2 = true;
        }
        if (p1 && p2) {
            return;
        }
    }
    if (!st && x == 0 && y == 0) {
        used[0][0] = true;
        if (used[n - 1][m - 1]) {
            int flag = 1;
            for (int i = 0; i < k; i++) {
                if (!used[v[i].first][v[i].second]) {
                    flag = 0;
                    break;
                }
            }
            ans += flag;
        }
        return;
    }
    if (!st) {
        used[x][y] = true;
    }
    if (!vniz) {
        if (x != 0 && !used[x - 1][y]) {
            dfs(x - 1, y, used, false, false, k1, k2, p1, p2);
        }
        if (y != 0 && !used[x][y - 1]) {
            dfs(x, y - 1, used, false, false, k1, k2, p1, p2);
        }
    } else {
        if (x != n - 1 && !used[x + 1][y]) {
            dfs(x + 1, y, used, false, true, k1, k2, p1, p2);
        }
        if (y != m - 1 && !used[x][y + 1]) {
            dfs(x, y + 1, used, false, true, k1, k2, p1, p2);
        }
    }
}

void sol() {
    cin >> n >> m >> k;
    v.resize(k);
    vector <vector <bool>> mp(n, vector <bool> (m));
    for (int i = 0; i < k; i++) {
        cin >> v[i].first >> v[i].second;
        v[i].first--, v[i].second--;
        mp[v[i].first][v[i].second] = true;
    }
    vector<vector<bool>> used(n, vector<bool>(m));
    dfs(0, 0, used, true, true, false, false, false, false);
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}
