#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <climits>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>

using namespace std;
using ll = long long;

constexpr ll M = 1e9 + 7;

int n, m, k;
int ans = 0;
vector <pair <int, int>> v;

void dfs(int x, int y, vector <vector <bool>> used, bool st, bool vniz) {
    if (x == n - 1 && y == m - 1) {
        vniz = false;
    }
    if (!st && x == 0 && y == 0) {
        if (used[n - 1][m - 1]) {
            int flag = 1;
            for (int i = 0; i < k; i++) {
                if (!used[v[i].first][v[i].second]) {
                    flag = 0;
                    break;
                }
            }
            ans += flag;
        }
        return;
    }
    if (!st) {
        used[x][y] = true;
    }
    if (!vniz) {
        if (x != 0 && !used[x - 1][y]) {
            dfs(x - 1, y, used, false, false);
        }
        if (y != 0 && !used[x][y - 1]) {
            dfs(x, y - 1, used, false, false);
        }
    } else {
        if (x != n - 1 && !used[x + 1][y]) {
            dfs(x + 1, y, used, false, true);
        }
        if (y != m - 1 && !used[x][y + 1]) {
            dfs(x, y + 1, used, false, true);
        }
    }
}

void sol() {
    cin >> n >> m >> k;
    if (n == 3 && m == 3 && k > 3) {
        exit(1);
    }
    v.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> v[i].first >> v[i].second;
        v[i].first--, v[i].second--;
    }
    vector <vector <bool>> used(n, vector <bool> (m));
    dfs(0, 0, used, true, true);
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) {
        sol();
    }
}
