#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using oredred_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define fi first
#define se second
// #define int ll

#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": "; for (auto &i : a) cerr << i << ' '; cerr << '\n'

bool ckmax(int &a, int b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<int> a;
    vector<int> gr;
    vector<int> g{0};
    unordered_map<int, bool> is;
    is[0] = true;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            a.push_back(x);
            gr.push_back(j + 1);
        }
        g.push_back(g.back() + k);
        is[g.back()] = true;
    }
    int m = a.size();
    int dp[m + 1][s + 1][2];
    for (int i = 0; i < m + 1; ++i) {
        for (int j = 0; j < s + 1; ++j) {
            for (int k = 0; k < 2; ++k) {
                dp[i][j][k] = 0;
            }
        }
    }
    dp[0][0][1] = 1;
    map<tuple<int, int, int>, pair<int, int>> pr;
    for (int i = 1; i <= m; ++i) {
        for (int j = 0; j <= s; ++j) {
            if (!is[i - 1]) {
                if (ckmax(dp[i][j][0], dp[i - 1][j][0])) {
                    pr[{i, j, 0}] = {j, 0};
                }
                if (ckmax(dp[i][j][1], dp[i - 1][j][1])) {
                    pr[{i, j, 1}] = {j, 1};
                }
            } else {
                if (ckmax(dp[i][j][0], dp[i - 1][j][1])) {
                    pr[{i, j, 0}] = {j, 1};
                }
            }
            if (is[i - 1]) {
                if (j - a[i - 1] >= 0) {
                    if (dp[i - 1][j - a[i - 1]][1]) {
                        if (ckmax(dp[i][j][1], dp[i - 1][j - a[i - 1]][1])) {
                            pr[{i, j, 1}] = {j - a[i - 1], 1};
                        }
                    }
                }
            } else {
                if (j - a[i - 1] >= 0) {
                    if (dp[i - 1][j - a[i - 1]][0]) {
                        if (ckmax(dp[i][j][1], dp[i - 1][j - a[i - 1]][0])) {
                            pr[{i, j, 1}] = {j - a[i - 1], 0};
                        }
                    }
                    if (dp[i - 1][j - a[i - 1]][1]) {
                        if (ckmax(dp[i][j][1], dp[i - 1][j - a[i - 1]][1])) {
                            pr[{i, j, 1}] = {j - a[i - 1], 1};
                        }
                    }
                }
            }
        }
    }
//    for (int i = 1; i <= m; ++i) {
//        for (int j = 0; j <= s; ++j) {
//            cerr << dp[i][j][0] << ' ' << dp[i][j][1] << '\n';
//        }
//    }
    int res = dp[m][s][1];
    if (res) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
        return;
    }
    int i = m, j = s, fl = 1;
    vector<vector<int>> ans(n);
    int cur = n - 1;
    while (i > 0 && j > 0) {
        pair<int, int> nxt = pr[{i, j, fl}];
        if (nxt.first != j) ans[cur].push_back(gr[i - 1]);
        if (is[i - 1]) {
            --cur;
        }
        --i;
        j = nxt.first;
        fl = nxt.second;
    }
    for (int l = 0; l < n; ++l) {
        cout << ans[l].size() << '\n';
        for (auto &i:ans[l]) cout << i << ' ';
        cout << '\n';
    }
}


/*
2 4
1 2
2 2 1
 */

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    solve();
}