#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using oredred_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(a) a.begin(), a.end()
#define fi first
#define se second
// #define int ll

#define db(a) cerr << #a << ": " << a << '\n'
#define dbv(a) cerr << #a << ": "; for (auto &i : a) cerr << i << ' '; cerr << '\n'

vector<int> dx = {0, 1, -1, 0};
vector<int> dy = {1, 0, 0, -1};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        a[x][y] = 1;
    }
    int ans = 0;
    for (int y = 0; y < m; ++y) {
        int cnt = 0;
        for (int i = 0; i <= y; ++i) {
            cnt += a[0][i];
        }
        for (int i = y; i < m; ++i) {
            cnt += a[1][i];
        }
        for (int i = m - 1; i >= 0; --i) {
            cnt += a[2][i];
        }
        cnt += a[1][0];
        if (cnt == k) ++ans;
        cnt = 0;
        for (int i = 0; i < m; ++i) {
            cnt += a[0][i];
        }
        for (int i = m - 1; i >= y; --i) {
            cnt += a[1][i];
        }
        for (int i = y; i >= 0; --i) {
            cnt += a[2][i];
        }
        cnt += a[1][0];
        if (cnt == k) ++ans;
    }
    cout << ans << '\n';
}


/*
2 4
1 2
2 2 1
 */

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // cin.tie(nullptr)->sync_with_stdio(false);

    solve();
}