#include <iostream>
#include <istream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;

struct node {
    ll l, r, mx, mxl, mxr;
};

ll min(ll a, ll b) {
    if (a < b) {
        return a;
    }
    return b;
}

int main() {
    ll n, x;
    cin >> n;
    vector<ll> h(n);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
    }

    vector<ll> pref(n + 1, 0);
    for (ll i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + h[i];
    }

    vector<ll> mx(n, -1);
    for (ll i = 1; i < n; i++) {
        ll x = i - 1;
        while(mx[x] != -1 && h[i] > h[x]) {
            x = mx[x];
        }
        mx[i] = x;
    }

    vector<ll> ls(n, 0);
    for (ll r = 1; r < n; r++) {
        if (mx[r] == -1) {
            ls[r] = ls[r - 1];
        }
        else {
            ls[r] = ls[mx[r]] + min(h[mx[r]], h[r]) * (r - mx[r] - 1) - (pref[r] - pref[mx[r] + 1]);
            cout << h[r] << " " << mx[r] << '\n';
            cout << min(h[mx[r]], h[r]) << " " << (r - mx[r] - 1) << " " << (pref[r] - pref[mx[r] + 1]) << '\n';
        }

        // cout << ls[r] << '\n';
    }

}