#include <iostream>
#include <istream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;
using ll = int;

int main() {
    ll n, s, k;
    cin >> n >> s;
    vector<vector<ll>> matr(n, vector<ll>());
    ll all = 0;
    for (ll i = 0; i < n; i++) {
        cin >> k;
        all += k;
        matr[i].assign(k, 0);
        for (ll j = 0; j < k; j++) {
            cin >> matr[i][j];
        }
    }

    vector<vector<vector<pair<bool, ll>>>> dp(s + 1, vector<vector<pair<bool, ll>>> (n, vector<pair<bool, ll>>()));
    for (ll i = 0; i < n; i++) {
        for (ll c = 0; c <= s; c++) {
            dp[c][i].assign(matr[i].size() + 1, {false, 0});
        }
        for (ll j = 0; j <= matr[i].size(); j++) {
            dp[0][i][j] = {true, 0};
        }
    }

    for (ll c = 1; c <= s; c++) {
        for (ll i = 0; i < n; i++) {
            for (ll j = 1; j <= matr[i].size(); j++) {
                dp[c][i][j] = dp[c][i][j - 1];
                ll w = matr[i][j - 1];

                if (i == 0) {
                    if (w < c) {
                        dp[c][i][j] = dp[c - w][i][j - 1];
                        if (dp[c][i][j].first) {
                            dp[c][i][j].second++;
                        }
                    }
                    if (c == w) {
                        dp[c][i][j] = {true, 1};
                    }
                    continue;
                }

                if (w <= c && dp[c - w][i - 1][matr[i - 1].size()].second > 0) {
                    dp[c][i][j] = dp[c - w][i - 1][matr[i - 1].size()];
                    dp[c][i][j].second = 1;
                }
                if (j == 1 || dp[c][i][j].second > 0) {
                    continue;
                }
                    
                if (w <= c && dp[c - w][i - 1][matr[i - 1].size()].second > 0) {
                    dp[c][i][j] = dp[c - w][i][j - 1];
                    dp[c][i][j].second++;
                }

            }
        }
    }

    // ll m = 0;
    // for (auto p : dp) {
    //     cout << m << '\n';
    //     for (auto l : p) {
    //         for (auto v : l) {
    //             cout << v.first << " " << v.second << "  ";
    //         }
    //         cout << '\n';
    //     }
    //     m++;
    //     cout << '\n';
    // }

    ll c = s;
    ll i = n - 1;
    ll j = 0;
    for (ll x = 1; x <= matr[i].size(); x++) {
        if (dp[c][i][x].first) {
            j = x;
            break;
        }
    }

    if (j == 0) {
        cout << "No";
        return 0;
    }

    cout << "Yes" << '\n';
    vector<vector<ll>> ans(n, vector<ll>());
    while (c > 0) {
        while (dp[c][i][j - 1].second == dp[c][i][j].second) {
            j--;
        }
        ans[i].push_back(j);

        ll w = matr[i][j - 1];
        // cout << c << " " << i << " " << j << " " << w << '\n';

        if (dp[c][i][j].second > 1) {
            c -= w;
            j--;
            continue;
        }

        c -= w;
        i--;
        j = matr[i].size();
    }

    for (auto ls : ans) {
        cout << ls.size() << '\n';
        for (auto a: ls) {
            cout << a << " ";
        }
        cout << '\n';
    }
}