#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int z=1e5+10;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,s;
    cin>>n>>s;
    if(n==1){
        int k;
        cin>>k;
        vector<int> c(k+1);
        for(int i=1;i<=k;i++){
            cin>>c[i];
        }
        vector<vector<int>> dp(k+1, vector<int>(s+1,-1));
        dp[0][0]=0;
        for(int i=1;i<=k;i++){
            for(int j=0;j<=s;j++){
                dp[i][j]=dp[i-1][j];
                if(j>=c[i] && dp[i-1][j-c[i]]!=-1){
                    dp[i][j]=dp[i-1][j-c[i]]+1;
                }
                //cout<<dp[i][j]<<" ";
            }
           // cout<<'\n';
        }
        if(dp[k][s]==-1){
            cout<<"No";
            return 0;
        }
        cout<<"Yes\n"<<dp[k][s]<<'\n';
        vector<int> ans;
        int i=k,j=s;
        while(i>0 && j>0){
            //cout<<"! "<<i<<' '<<j<<'\n';
            if(dp[i][j]-1==dp[i-1][j-c[i]]){
                cout<<i<<' ';
                j-=c[i];
            }
            i--;
        }
        return 0;
    }
    vector<int> k(n+1),p(z),pref(n+1);
    pref[0]=0;
    for(int i=1;i<=n;i++){
        cin>>k[i];
        pref[i]=pref[i-1]+k[i];
        for(int j=pref[i-1]+1;j<=pref[i];j++){
            cin>>p[j];
        }
    }
    if(pref[n]==n){
        ll sum=0;
        for(int i=1;i<=n;i++){
            sum+=p[i];
        }
        if(sum==s){
            cout<<"Yes\n";
            for(int i=0;i<n;i++){
                cout<<1<<'\n'<<1<<'\n';
            }
        }else{
            cout<<"No";
        }
        return 0;
    }
    if(pref[n]<=20){
        for(int mask=1;mask<(1<<20);mask++){
            vector<bool> used(20,0);
            ll sum=0;
            for(int i=0;i<20;i++){
                if(mask & (1<<i)){
                    int t=lower_bound(pref.begin(),pref.end(),i+1)-pref.begin();
                    used[t-1]=1;
                    sum=sum+p[i+1];
                }
            }
            bool f=1;
            for(int i=0;i<n;i++){
                f=f && used[i];
            }
            if(f && sum==s){
                vector<vector<int>> ans(n);
                for(int i=19;i>=0;i--){
                    if(mask & (1<<i)){
                        int t=lower_bound(pref.begin(),pref.end(),i+1)-pref.begin();
                        ans[t-1].push_back(i+1-pref[t-1]);
                    }
                }
                cout<<"Yes\n";
                for(auto i:ans){
                    cout<<i.size()<<'\n';
                    for(auto j:i){
                        cout<<j<<' ';
                    }
                    cout<<'\n';
                }
                return 0;
            }
        }
        cout<<"No";
        return 0;
    }
}