#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
//#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll z=1e3+5, mod =1e9+7, q=2005;
pair<int,int> to[4]={{1,0},{0,1},{-1,0},{0,-1}};
bool term[z][z];
int used[z][z], mx,n,m,k, ans=0;

void bfs(int x, int y, int cnt, int cou, bool h){
    if(x==1 && y==1 && cou==k && cnt==mx && h){
        ans++;
        ans%=mod;
    }
    if(cnt>mx || x>n || x<1 || y>m || y<1 || used[x][y]==1) return;
    used[x][y]=1;
    if(term[x][y]) cou++;
    if(x==n && y==m){
        h=1;
    }
    for(int i=0;i<4;i++){
        bfs(x+to[i].first,y+to[i].second,cnt+1,cou,h);
    }
    used[x][y]=2;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>k;
    if(k==0){
        cout<<n*(n-1)/2%mod;
        return 0;
    }
    mx=2*n+2*m-4;
    for(int i=0;i<k;i++){
        int x,y;
        cin>>x>>y;
        term[x][y]=1;
    }
    int cou=0;
    if(term[1][1]) cou++;
    bfs(1,1,0,cou,0);
    cout<<ans;
}