#include <iostream>
#include <vector>
#include <set>
#include <math.h>
using namespace std;
int n, k; vector<long long> a;
vector<long long> sum;
vector<long long> mini_left;
vector<long long> mini_right;
vector<long long> maxi_left;
vector<long long> maxi_right;
long long get_sum(int l, int r) {
    return sum[r + 1] - sum[l];
}
long long best_split(int left, int right, int p) {
    if (!p || left > right || p > (right - left + 1)) {return 0;}
    if (p == 1) {return get_sum(left, right);}
    long long ans = 0ll;
    int size = (right - left + 1) - p + 1;
    for (int i = left; i + size - 1 <= right; i++) {
        ans = max(ans, get_sum(i, i + size - 1));
    }
    return ans;
}
void big_solve_AAA(void) {
    cin >> n >> k;
    a.clear(); a.resize(n);
    sum.clear(); sum.resize(n + 1, 0ll);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum[i + 1] = sum[i] + a[i];
    }
    if (k == 2) {
        cout << max(abs(get_sum(1, n - 1) - a[0]), abs(get_sum(0, n - 2) - a[n - 1])) << endl;
        return;
    }
    mini_left.clear(); mini_left.resize(n, a[0]);
    mini_right.clear(); mini_right.resize(n, a[n - 1]);
    maxi_left.clear(); maxi_left.resize(n, a[0]);
    maxi_right.clear(); maxi_right.resize(n, a[n - 1]);
    for (int i = 1; i < n; i++) {
        mini_left[i] = min(mini_left[i - 1], a[i]);
        maxi_left[i] = max(maxi_left[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; i--) {
        mini_right[i] = min(mini_right[i + 1], a[i]);
        maxi_right[i] = max(maxi_right[i + 1], a[i]);
    }
    long long ans = 0ll;
    ans = max(ans, best_split(0, n - 2, k - 1) - a[n - 1]);
    ans = max(ans, best_split(1, n - 1, k - 1) - a[0]);
    for (int i = 1; i + 1 < n; i++) {
        long long left = -1, right = -1;
        if (((n - 1) - (i + 1) + 1) >= k - 2) {
            left = best_split(0, i - 1, 1);
            right = best_split(i + 1, n - 1, k - 2);
            ans = max(ans, max(left, right) - a[i]);
        } else {
            int pr = ((n - 1) - (i + 1) + 1);
            int pl = k - pr - 1;
            left = best_split(0, i - 1, pl);
            right = best_split(i + 1, n - 1, pr);
            ans = max(ans, max(left, right) - a[i]);
        }
        if (i >= k - 2) {
            left = best_split(0, i - 1, 1);
            right = best_split(i + 1, n - 1, k - 2);
            ans = max(ans, max(left, right) - a[i]);
        } else {
            int pl = i;
            int pr = k - 1 - pl;
            left = best_split(0, i - 1, pl);
            right = best_split(i + 1, n - 1, pr);
            ans = max(ans, max(left, right) - a[i]);
        }
    }
    cout << ans << endl;
}
int main() {
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        big_solve_AAA();
    }
    return 0;
}
