﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <set>

using namespace std;

int prost(long long k)
{
    if (k == 0 || k == 1) return 0;
    for (long long i = 2; i * i <= k; i++)
    {
        if (k % i == 0) return 0;
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    long long l, r;
    cin >> l >> r;
    long long ans = 0;
    for (long long i = l; i <= r; i++)
    {
        long long sum = 1;
        long long k = i;
        while (k > 0)
        {
            sum *= k % 10;
            k /= 10;
        }
        if (prost(sum)) ans++;
    }
    cout << ans << endl;
}
