﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <set>

using namespace std;

int check(int k)
{
    if (k == 1 || k == 0) return 0;
    for (int i = 2; i * i <= k; i++)
    {
        if (k % i == 0) return 0;
    }
    return 1;
}

/* findlpos(string l, int k)
{
    for (int i = 0; i < l.size(); i++)
    {
        if (l[i] - '0' > 1)
        {
            if (l[i] - '0' < k)
            {
                return i + 1;
            }
            if (l[i] - '0' > k) return i;
            if (l[i] - '0' == k)
            {
                for (int j = i + 1; j < l.size(); j++)
                {
                    if (l[j] - '0' > 1)
                    {
                        return i;
                    }
                }
                return i + 1;
            }
        }
    }
    return l.size();
}

int findrpos(string r, int k)
{
    vector<int> pref(r.size(), 0);
    vector<int> pref1(r.size(), 0);
    if (r[0] - '0' > 1) pref[0] = 2;
    if (r[0] - '0' == 1) pref[0] = 1;
    if (r[r.size() - 1] - '0' == 1) pref[r.size() - 1] = 1;
    if (r[r.size() - 1] - '0' > 1) pref[r.size() - 1] = 2;
    for (int i = 0; i < r.size(); i++)
    {
        pref[i] = pref[i - 1];
        if (r[i] - '0' == 0)
        {
            if (pref[i] == 1) pref[i] = 0;
        }
        if (r[i] - '0' == 1) pref[i] = min(pref[i], 1);
        if (r[i] - '0' > 1) pref[i] = min(pref[i], 2);
    }
    for (int i = r.size() - 2; i >= 0; i--)
    {
        pref[i] = pref[i - 1];
        if (r[i] - '0' == 0) pref[i] = 0;
        else if (r[i] - '0' == 1) pref[i] = min(pref[i], 1);
        else pref[i] = min(pref[i], 2);
    }
    for (int i = r.size() - 1; i >= 0; i--)
    {
        if (r[i] - '0' < k)
        {
            if (pref[i] == 0)
            {
                return r.size() - 
            }
        }
    }
}
*/

int chmin(string a, string l)
{
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] < l[i]) return 0;
        if (a[i] > l[i]) return 1;
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    string l, r;
    cin >> l >> r;
    if (l.size() > r.size() || (l.size() == r.size() && chmin(l, r)))
    {
        cout << 0;
        return 0;
    }
    long long ans = 0;
    for (int i = l.size() + 1; i < r.size(); i++) ans += 4 * i;
    string a = "";
    for (int i = 0; i < l.size(); i++) a += '1';
    string b = "";
    for (int i = 0; i < r.size(); i++) b += '1';

    vector<int> ch = { 2, 3, 5, 7 };

    for (int k : ch)
    {
        int l1 = 0, r1 = l.size();
        while (r1 - l1 > 1)
        {
            int mid = (r1 + l1) / 2;
            a[mid] = k + '0';
            if (chmin(a, l)) l1 = mid;
            else r1 = mid;
            a[mid] = '1';
        }
        int c;
        a[l1] = k + '0';
        if (chmin(a, l))
        {
            c = l1 + 1;
           // if (l.size() == r.size()) c = l.size() - c;
        }
        else
        {
            c = l1;
           // if (l.size() == r.size()) c = l.size() - c;
        }
        a[l1] = '1';

        int l2 = -1, r2 = r.size() - 1;
        while (r2 - l2 > 1)
        {
            int mid = (r2 + l2) / 2;
            b[mid] = k + '0';
            if (chmin(r, b)) r2 = mid;
            else l2 = mid;
            b[mid] = '1';
        }
        int d;
        b[r2] = k + '0';
        if (chmin(r, b))
        {
            d = r.size() - r2;
          //  if (l.size() == r.size()) d = r2 + 1;
        }
        else
        {
            d = r.size() - r2 - 1;
          //  if (r.size() == l.size()) d = r2;
        }
        b[r2] = '1';
        int gh = c + d - l.size();
        if (l.size() == r.size()) ans += max(0, gh);
        else ans += c + d;
    }

    cout << ans;
}

/*
string l, r;
    cin >> l >> r;
    long long ans = 0;
    for (int i = l.size() + 1; i < r.size(); i++) ans += 4 * i;
    string a = "";
    for (int i = 0; i < l.size(); i++) a += '1';
    string b = "";
    for (int i = 0; i < r.size(); i++) b += '1';

    vector<int> ch = { 2, 3, 5, 7 };

    for (int k : ch)
    {
        int l1 = 0, r1 = l.size();
        while (r1 - l1 > 1)
        {
            int mid = (r1 + l1) / 2;
            a[mid] = k + '0';
            if (chmin(a, l)) l1 = mid;
            else r1 = mid;
            a[mid] = '1';
        }
        int c;
        a[l1] = k + '0';
        if (chmin(a, l))
        {
            c = l1 + 1;
            if (l.size() == r.size()) c = l.size() - c;
        }
        else
        {
            c = l1;
            if (l.size() == r.size()) c = l.size() - c;
        }
        a[l1] = '1';

        int l2 = -1, r2 = r.size() - 1;
        while (r2 - l2 > 1)
        {
            int mid = (r2 + l2) / 2;
            b[mid] = k + '0';
            if (chmin(r, b)) r2 = mid;
            else l2 = mid;
            b[mid] = '1';
        }
        int d;
        b[r2] = k + '0';
        if (chmin(r, b))
        {
            d = r.size() - r2;
            if (l.size() == r.size()) d = r2 + 1;
        }
        else
        {
            d = r.size() - r2 - 1;
            if (r.size() == l.size()) d = r2;
        }
        b[r2] = '1';
        int p = c - d + 1;
        if (l.size() == r.size()) ans += max(p, 0);
        else ans += c + d;
    }

    cout << ans;*/

/*
int l, r;
    cin >> l >> r;
    for (int i = l; i <= r; i++)
    {
        int k = i;
        int sum = 1;
        while (k > 0)
        {
            sum *= k % 10;
            k /= 10;
        }
        if (check(sum)) cout << i << endl;
    }*/