﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <set>

using namespace std;

/*struct vec
{
    int x;
    int y;
    
    vec(int x, int y)
    {
        this->x = x;
        this->y = y;
    }

    vec operator*(int k)
    {
        return { this->x * k, this->y * k };
    }

    friend istream& operator>>(istream& in, vec& a)
    {
        return in >> a.x >> a.y;
    }

    friend ostream& operator<<(ostream& out, vec& a)
    {
        return out << a.x << a.y;
    }
};
*/

/*
long long solve(int n, int k, vector<long long>& a)
{
    vector<long long> pref(n + 1, 0);
    vector<long long> pref_min(n + 1, 1e18);
    vector<long long> pref_max(n + 1, 0);
    vector<long long> suff_min(n + 1, 1e18);
    vector<long long> suff_max(n + 1, 0);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    for (int i = 1; i <= n; i++)
    {
        pref_min[i] = min(pref_min[i - 1], a[i - 1]);
        pref_max[i] = max(pref_max[i - 1], a[i - 1]);
    }
    for (int i = n - 1; i >= 0; i--)
    {
        suff_min[i] = min(suff_min[i + 1], a[i]);
        suff_max[i] = max(suff_max[i + 1], a[i]);
    }
    long long ans = 0;
    for (long long i = 0; i < k; i++)
    {
        long long c = max(pref_max[i], suff_max[n - k + i + 1]);
        long long d = min(pref_min[i], suff_min[n - k + i + 1]);
        c = max(c, pref[n - k + i + 1] - pref[i]);
        d = min(d, pref[n - k + i + 1] - pref[i]);
        ans = max(ans, c - d);
    }
    return ans;
}

long long stupid(int n, int k, vector<long long>& a)
{
    vector<long long> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    long long ans = 0;
    long long f = a[0];
    for (int i = 2; i < n; i++)
    {
        long long s1 = pref[i] - a[0];
        long long s2 = pref[n] - pref[i];
        if (ans < max(max(f, s1), s2) - min(min(f, s1), s2))
        {
            ans = max(max(f, s1), s2) - min(min(f, s1), s2);
            cout << ans;
        }
        cout << endl;
    }

    for (int i = 1; i < n - 1; i++)
    {
        long long c = a[i];
        long long d = pref[i];
        long long e = pref[n] - pref[i + 1];
        if (ans < max(max(c, d), e) - min(min(c, d), e))
        {
            ans = max(max(c, d), e) - min(min(c, d), e);
            cout << ans;
        }
        cout << endl;
    }

    f = a[n - 1];
    for (int i = 1; i < n - 1; i++)
    {
        long long s1 = pref[i];
        long long s2 = pref[n] - pref[i] - f;
        if (ans < max(max(f, s1), s2) - min(min(f, s1), s2))
        {
            ans = max(max(f, s1), s2) - min(min(f, s1), s2);
            cout << ans;
        }
        cout << endl;
    }
    return ans;
}
*/

void check(int s, int id, vector<pair<int, int>>& nums, vector<int>& ans)
{
    if (s == 0)
    {
        cout << "Yes" << endl;
        cout << ans.size() << endl;
        for (int i = 0; i < ans.size(); i++)
        {
            cout << nums[ans[i]].second + 1 << " ";
        }
        exit(0);
    }
    for (int i = id; i < nums.size(); i++)
    {
        if (nums[i].first > s) return;
        ans.push_back(i);
        check(s - nums[i].first, i + 1, nums, ans);
        ans.pop_back();
    }
}

struct num
{
    long long x;
    int id;
    int numex;
    num(long long x = 0, int id = 0, int numex = 0)
    {
        this->x = x;
        this->id = id;
        this->numex = numex;
    }

    bool operator <(num& a)
    {
        if (this->x < a.x) return true;
        return false;
    }
};

void check1(int s, int id, vector<num>& nums, vector<int>& ans)
{
    if (s == 0)
    {
        int how = 0;
        for (int i = 0; i < ans.size(); i++)
        {
            if (nums[ans[i]].numex == 0) how++;
        }
        if (how == 0 || how == ans.size()) return;
        cout << "Yes" << endl;
        cout << how << endl;
        for (int i = 0; i < ans.size(); i++)
        {
            if(!nums[ans[i]].numex)
                cout << nums[ans[i]].id + 1 << " ";
        }
        cout << endl << ans.size() - how << endl;
        for (int i = 0; i < ans.size(); i++)
        {
            if (nums[ans[i]].numex)
                cout << nums[ans[i]].id + 1 << " ";
        }
        exit(0);
    }
    for (int i = id; i < nums.size(); i++)
    {
        if (nums[i].x > s) return;
        ans.push_back(i);
        check1(s - nums[i].x, i + 1, nums, ans);
        ans.pop_back();
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    //freopen("a.txt", "r", stdin);
    //freopen("a.txt", "w", stdout);
    int n, s;
    cin >> n >> s;
    int f = 1;
    long long s1 = 0;
    vector<vector<int>> tasks(n);
    for (int i = 0; i < n; i++)
    {
        int how;
        cin >> how;
        if (how > 1) f = 0;
        for (int j = 0; j < how; j++)
        {
            int x;
            cin >> x;
            tasks[i].push_back(x);
            s1 += x;
        }
    }
    if (f)
    {
        if (s1 != s)
        {
            cout << "No";
            return 0;
        }
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++)
        {
            cout << 1 << endl;
            cout << 1 << endl;
        }
    }
    else if (n == 1)
    {
        vector<pair<int, int>> nums;
        for (int i = 0; i < tasks[0].size(); i++)
        {
            nums.push_back({ tasks[0][i], i });
        }
        sort(nums.begin(), nums.end());
        vector<int> ans;
        for (int i = 0; i < nums.size(); i++)
        {
            if (s < nums[i].first)
            {
                cout << "No";
                return 0;
            }
            ans.push_back(i);
            check(s - nums[i].first, i + 1, nums, ans);
            ans.pop_back();
        }
    }
    /*else if (n == 2)
    {
        vector<num> nums;
        for (int i = 0; i < tasks[0].size(); i++)
        {
            nums.push_back({tasks[0][i], i, 0});
        }
        for (int i = 0; i < tasks[1].size(); i++)
        {
            nums.push_back({ tasks[1][i], i, 1 });
        }
        sort(nums.begin(), nums.end());
        vector<int> ans;
        for (int i = 0; i < nums.size(); i++)
        {
            if (s < nums[i].x)
            {
                cout << "No";
                return 0;
            }
            ans.push_back(i);
            check1(s - nums[i].x, i + 1, nums, ans);
            ans.pop_back();
        }
    }
    cout << "No" << endl;
    */
}

/*
    int n;
    cin >> n;
    int sum = 0;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        sum += x;
    }
    cout << sum;
    */

    /* while (true)
     {
         int n = 3 + rand() % 15;
         int k = 3;
         vector<long long> a(n);
         for (int i = 0; i < n; i++) a[i] = rand() % 100000001;
         long long ans1 = solve(n, k, a);
         long long ans2 = stupid(n, k, a);
         if (ans1 == ans2) cout << "YES" << endl;
         else
         {
             cout << n << " " << k << endl;
             for (int i = 0; i < n; i++) cout << a[i] << " ";
             cout << endl;
             cout << ans1 << " " << ans2 << endl;
             return 0;
         }
     }
     */

     /*int n, k;
     cin >> n >> k;
     vector<long long> a(n);
     for (int i = 0; i < n; i++) cin >> a[i];
     vector<long long> pref(n + 1, 0);
     vector<long long> pref_min(n + 1, 1e18);
     vector<long long> pref_max(n + 1, 0);
     vector<long long> suff_min(n + 1, 1e18);
     vector<long long> suff_max(n + 1, 0);
     for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
     for (int i = 1; i <= n; i++)
     {
         pref_min[i] = min(pref_min[i - 1], a[i - 1]);
         pref_max[i] = max(pref_max[i - 1], a[i - 1]);
     }
     for (int i = n - 1; i >= 0; i--)
     {
         suff_min[i] = min(suff_min[i + 1], a[i]);
         suff_max[i] = max(suff_max[i + 1], a[i]);
     }
     long long ans = 0;
     for (long long i = 0; i < k; i++)
     {
         long long c = max(pref_max[i], suff_max[n - k + i + 1]);
         long long d = min(pref_min[i], suff_min[n - k + i + 1]);
         c = max(c, pref[n - k + i + 1] - pref[i]);
         d = min(d, pref[n - k + i + 1] - pref[i]);
         ans = max(ans, c - d);
     }
     cout << ans;
     */

/*
14 3
23805 15890 6729 24370 15350 15006 31101 24393 3548 19629 12623 24084 19954 18756*/

/*
int n, k;
    cin >> n >> k;
    vector<long long> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<long long> pref(n + 1, 0);
    vector<long long> pref_min(n + 1, 1e18);
    vector<long long> pref_max(n + 1, 0);
    vector<long long> suff_min(n + 1, 1e18);
    vector<long long> suff_max(n + 1, 0);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    for (int i = 1; i <= n; i++)
    {
        pref_min[i] = min(pref_min[i - 1], a[i - 1]);
        pref_max[i] = max(pref_max[i - 1], a[i - 1]);
    }
    for (int i = n - 1; i >= 0; i--)
    {
        suff_min[i] = min(suff_min[i + 1], a[i]);
        suff_max[i] = max(suff_max[i + 1], a[i]);
    }
    long long ans = 0;
    for (long long i = 0; i < k; i++)
    {
        long long c = max(pref_max[i], suff_max[n - k + i + 1]);
        long long d = min(pref_min[i], suff_min[n - k + i + 1]);
        c = max(c, pref[n - k + i + 1] - pref[i]);
        d = min(d, pref[n - k + i + 1] - pref[i]);
        ans = max(ans, c - d);
    }
    cout << ans;
*/

/*vector<long long> min_pref(n);
    vector<long long> min_suff(n);
    min_pref[0] = a[0];
    min_suff[n - 1] = a[n - 1];
    for (int i = 1; i < n; i++) min_pref[i] = min(min_pref[i - 1], a[i]);
    for (int i = n - 2; i >= 0; i--) min_suff[i] = min(min_suff[i + 1], a[i]);

    for (int i = 1; i < n - 1; i++)
    {
        long long h = a[i];
        long long s1 = pref[i];
        long long s2 = pref[n] - pref[i + 1];
        long long how = k;
        long long minn = a[i], maxx = a[i];
        if (s2 > s1)
        {
            how -= i + 1;
            minn = min(minn, min_pref[i]);
            int l = i, r = n;
        }
    }*/

/*
int n, s;
    cin >> n >> s;
    int f = 1;
    long long s1 = 0;
    vector<vector<int>> tasks(n);
    for (int i = 0; i < n; i++)
    {
        int how;
        cin >> how;
        if (how > 1) f = 0;
        for (int j = 0; j < how; j++)
        {
            int x;
            cin >> x;
            tasks[i].push_back(x);
            s1 += x;
        }
    }
    if (f)
    {
        if (s1 != s)
        {
            cout << "No";
            return 0;
        }
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++)
        {
            cout << 1 << endl;
            cout << 1 << endl;
        }
    }
*/

    /*int n, k;
        cin >> n >> k;
        vector<long long> a(n);
        vector<long long> pref(n + 1, 0);
        for (int i = 0; i < n; i++) cin >> a[i];
        for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
        long long ans = 0;
        if (k == 2)
        {
            for (int i = 1; i < n; i++)
            {
                long long s1 = pref[i];
                long long s2 = pref[n] - pref[i];
                if (ans < max(s1, s2) - min(s1, s2)) ans = max(s1, s2) - min(s1, s2);
            }
            cout << ans;
            return 0;
        }
        if (k == 3)
        {
            long long f = a[0];
            for (int i = 2; i < n; i++)
            {
                long long s1 = pref[i] - a[0];
                long long s2 = pref[n] - pref[i];
                if (ans < max(max(f, s1), s2) - min(min(f, s1), s2)) ans = max(max(f, s1), s2) - min(min(f, s1), s2);
            }

            for (int i = 1; i < n - 1; i++)
            {
                long long c = a[i];
                long long d = pref[i];
                long long e = pref[n] - pref[i + 1];
                if (ans < max(max(c, d), e) - min(min(c, d), e)) ans = max(max(c, d), e) - min(min(c, d), e);
            }

            f = a[n - 1];
            for (int i = 1; i < n - 1; i++)
            {
                long long s1 = pref[i];
                long long s2 = pref[n] - pref[i] - f;
                if (ans < max(max(f, s1), s2) - min(min(f, s1), s2)) ans = max(max(f, s1), s2) - min(min(f, s1), s2);
            }

            cout << ans;
            return 0;
        }
        long long minn = 1e9, maxx = 0;
        long long l = 0, r = n - 1;
        for (long long i = 0; i < k - 1; i++)
        {
            if (a[l] < a[r])
            {
                minn = min(minn, a[l]);
                maxx = max(maxx, a[l]);
                l++;
            }
            else if(a[l] > a[r])
            {
                minn = min(minn, a[r]);
                maxx = max(maxx, a[r]);
                r--;
            }
            else
            {
                long long f = 1;
                long long l1 = l, r1 = r;
                l1++, r1--;
                while (l1 < r1)
                {
                    if (a[l1] < a[r1])
                    {
                        break;
                    }
                    else if (a[l1] > a[r1])
                    {
                        f = 0;
                        break;
                    }
                    l1++;
                    r1--;
                }
                if (f)
                {
                    minn = min(minn, a[l]);
                    maxx = max(maxx, a[l]);
                    l++;
                }
                else
                {
                    minn = min(minn, a[r]);
                    maxx = max(maxx, a[r]);
                    r--;
                }
            }
        }
        minn = min(minn, pref[r + 1] - pref[l]);
        maxx = max(maxx, pref[r + 1] - pref[l]);
        cout << maxx - minn;
        */
