#include<iostream>
#include<vector>

using namespace std;

vector<int> denominators(int n) {
	vector<int> res;
	for (int i = 1; i < (int)(sqrt(n) + 1); i++) {
		if (n / i == (double)n / i) {
			res.push_back(i);
		}
	}
	return res;
}

int A(int d, int l, int r) {
	int res = 0;
	int i = (int)(sqrt(l));
	vector<int> denom = denominators(d);
	if (i < 0) {
		i = 0;
	}
	if (i * i < l) {
		i++;
	}
	while (i * i < r) {
		for (int j = 0; j < denom.size(); j++) {
			int f = denom[j];
			if ((i + f) * (i + f) > r) {
				break;
			}
			int razn = f * (2 * i + f);
			if (razn == d) {
				res++;
			}
			if (razn > d) {
				break;
			}
		}
		i++;
	}
	return res;
}

int main() {
	int d, l, r;
	cin >> d >> l >> r;
	cout << A(d, l, r);
	return 0;
}
