#include<iostream>
#include<vector>

using namespace std;


long long min(long long a, long long b) {
	if (a < b) return a;
	return b;
}


long long max(long long a, long long b) {
	if (a < b) return b;
	return a;
}

/*
long long B(int n, int k, vector<long long> a) {
	vector<long long> pref(n);
	pref[0] = a[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + a[i];
	}
	if (k == 2) {
		return (pref[n - 1] - 2 * min(a[0], a[n - 1]));
	}
	else if (k == 3) {
		long long res = 0;
		
		res = max(pref[n - 2] - pref[0] - a[0], pref[n - 2] - pref[0] - a[n - 1]);
		for (int i = 0; i < n - 2; i++) {
			long long perekos = max(pref[i], pref[n - 1] - pref[i + 1]) - a[i + 1];
			if (perekos > res) res = perekos;
		}
		return res;
	}
}
*/

long long B(int n, int k, vector<long long> a) {
	vector<long long> pref(n + 1);
	pref[0] = 0;
	for (int i = 1; i < n + 1; i++) {
		pref[i] = pref[i - 1] + a[i - 1];
	}
	if (k == 2) {
		return (pref[n] - 2 * min(a[0], a[n - 1]));
	}
	else {
		long long res = 0;
		for (int i = 0; i < k; i++) {
			long long otrezok = pref[i + n + 1 - k] - pref[i];
			long long m = 1000000000;
			for (int j = 0; j < n; j++) {
				if (!((j >= i) && (j <= i + n + 1 - k))) {
					if (a[j] < m) m = a[j];
				}
			}
			long long perekos = otrezok - m;
			if (perekos > res) res = perekos;
		}
		return res;
	}
}


int main() {
	int n, k;
	cin >> n >> k;
	vector<long long> a(n);
	for (int i = 0; i < n; i++) {
		int a_i;
		cin >> a_i;
		a[i] = a_i;
	}
	cout << B(n, k, a);
	return 0;
}
