#include <iostream>
#include <cmath>

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")


using namespace std;

using ll = long long;




int main() {
    ll d, l ,r ;
    cin >> d >> l >> r;

    ll start = sqrt(l);
    ll end = sqrt(r)+1;
    ll ans = 0;
    ll cur_exp = start+1;

    for (ll i = start; i <= min(d, end); ++i) {

        while (cur_exp * cur_exp < i *i +d) {
            cur_exp++;
        }

        if(cur_exp * cur_exp > r) {
            break;
        }

        if(cur_exp * cur_exp == i *i + d) {
            ++ans;
        }
    }

    cout << ans << '\n';
    return 0;
}