#include <iostream>
#include <cmath>
#include <vector>
#include <map>


#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")


using namespace std;

using ll = long long;




int main() {
    int k, n;
    cin >>n >> k;
    vector<ll> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    vector<ll> prefx(n);
#define pref(l,r) (l == 0 ? prefx[r] : prefx[r]-prefx[l-1])
    for(int i = 0; i < n; i++) {
        if(i!=0){
            prefx[i] = prefx[i-1] + arr[i];
        } else {
            prefx[i] = arr[i];
        }
    }


    int delt = n-k+1;
    map<ll,int> stat;
    for (int j =delt-1; j < n; ++j) {
        stat[arr[j]]++;
    }

    ll best_ans = 0;

//    for(int i = delt-1; i < n; i++) {
//        stat[arr[i]]--;
//        if(stat[arr[i]] == 0) {
//            stat.erase(arr[i]);
//        }
//        ll cur_sum = pref(i-delt+1,i);
//        ll ans1 = cur_sum - (*stat.begin()).first;
//        ll ans2 = 0;
//        if(stat.size() > 1){
//            ans2 = (*stat.rbegin()).first -  (*stat.begin()).first;
//        }
//
//        best_ans = max(best_ans, max(ans1,ans2));
//        stat[arr[i-delt+1]]++;
//    }

    vector<ll> pref_best(n);
    vector<ll> reverse_best(n);

    for (int i = 0; i < n; ++i) {
        if(i!=0){
            pref_best[i] = max(pref_best[i-1], pref(max(0, i-delt+1),i));
        }  else {
            pref_best[i] = arr[i];
        }
    }

    for (int i = n-1; i >=0 ; --i) {
        if(i!=n-1){
            reverse_best[i] = max(reverse_best[i+1], pref(i, min(n-1, i+delt-1)));
        }  else {
            reverse_best[i] = arr[i];
        }
    }


    for (int i = 0; i < n; ++i) {
        if(i == 0) {
            best_ans = max(best_ans, reverse_best[i+1]-arr[i]);
        } else if(i == n-1) {
            best_ans = max(best_ans, pref_best[i-1]-arr[i]);
        } else {
            best_ans = max(best_ans, max(pref_best[i-1]-arr[i], reverse_best[i+1]-arr[i]));
        }
    }

    cout << best_ans << endl;
    return 0;
}