#define __GLIBCXX_DEBUG

#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,tune=native")


using namespace std;

using ll = long long;
#define all(x) x.begin(), x.end()




int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, s;
    cin >> n >> s;
    vector<vector<ll>> arr(n);
    ll checked = 0;
    ll min_checked = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        arr[i].resize(k);
        ll minvs = 1e18;
        for (int j = 0; j < k; ++j) {
            cin >> arr[i][j];
            checked+= arr[i][j];
            minvs = min(minvs, arr[i][j]);
        }

//        sort(all(arr[i]));
        min_checked += minvs;
    }

    if(checked < s || s < min_checked) {
        cout << "No" << endl;
        return 0;
    }


//    cout << "im alive" << endl;





    // process
    vector<bool> prev_ans(s+1);
    prev_ans[0] = 1;
    vector<bool> cur_ans(s+1);
    vector<vector<int>> jump(n,vector<int>(s+1));

//    jump[0] = vector<int>(s+1,-1);

    for (int i = 0; i < n; ++i) {
        vector<bool> prev_inc(s+1);
        vector<bool> now_inc(s+1);
        prev_inc[0] = 1;


        for (int j = 0; j < arr[i].size(); ++j) {
            now_inc[arr[i][j]] = 1;
            for (int k = 0; k <= s; ++k) {
                if(prev_inc[k] && k + arr[i][j] <= s) {
                    now_inc[k + arr[i][j]] = true;
                    if(k!=0){
                        now_inc[k] = true;
                    }
                }
            }

            prev_inc = now_inc;
        }



        now_inc = prev_inc;

        vector<int> avalible_add;
        for (int l = 0; l <= s; ++l) {
            if(now_inc[l]) {
                avalible_add.push_back(l);
            }
        }


        for (int j = 0; j <= s; ++j) {
            for (int k = 0; k < avalible_add.size(); ++k) {
                if(prev_ans[j]&&j + avalible_add[k] <= s) {
                    jump[i][j + avalible_add[k]] = j;
                    cur_ans[j + avalible_add[k]] = true;
                }
            }
        }

//        cout << "Indx: " << i << endl;
//        cout << "Main: " << endl;
//        for (int m =0; m <= s; ++m) {
//            cout << cur_ans[m] << ' ';
//        }
//        cout << endl;
//
//        cout << "Additonal: " << endl;
//        for (int m = 0; m < avalible_add.size(); ++m) {
//            cout << avalible_add[m] << ' ';
//        }
//        cout << endl;
//
//        cout << "Jump: " << endl;
//        for (int m = 0; m <=s; ++m) {
//            cout << jump[i][m] << ' ';
//        }
//        cout << endl;
//
//        cout << "--------------" << endl;

        prev_ans = cur_ans;
        prev_ans[0] = false;


    }


//    return 0;


    if(!cur_ans[s]) {
        cout << "No" << endl;
        return 0;
    } else {
        // print ans
        cout << "Yes" << endl;


        vector<ll> unfold(n);


        int shifted = n-1;
        ll cur = s;
        while(cur != 0) {
            unfold[shifted] = cur - jump[shifted][cur];
            cur = jump[shifted][cur];
            shifted--;
        }



        for (int i = 0; i < n; ++i) {
            vector<bool> prev_inc(s+1);
            vector<bool> now_inc(s+1);
            vector<vector<int>> jumps(arr[i].size(), vector<int>(s+1));

            prev_inc[0] = 1;


            for (int j = 0; j < arr[i].size(); ++j) {
                now_inc[arr[i][j]] = 1;
                jumps[j][arr[i][j]] = -1;
                for (int k = 0; k <= s; ++k) {
                    if(prev_inc[k] && k + arr[i][j] <= s) {
                        now_inc[k + arr[i][j]] = true;
                        jumps[j][k + arr[i][j]] = k;
                        if(k != 0) {
                            now_inc[k] = true;
                            jumps[j][k] = k;
                        }
                    }
                }
                prev_inc = now_inc;
            }

//            cout << "Main: " << endl;
//            for (int m =0; m <= s; ++m) {
//                cout << now_inc[m] << ' ';
//            }
//            cout << endl;


//            jumps[0] = vector<int>(s+1, -1);

            vector<int> ans;
            int cur = unfold[i];
            int shifted = arr[i].size()-1;
            while (cur != 0) {
                if(cur != jumps[shifted][cur]) {
                    ans.push_back(shifted);
                }
                cur = jumps[shifted][cur];
                shifted--;
            }


            sort(all(ans));
            cout << ans.size() << '\n';
            for(int i = 0; i < ans.size(); i++) {
                cout << ans[i]+1 << ' ';
            }

            cout << endl;

        }
    }


    return 0;
}