#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define ll long long

int n, m, k, ans = 0;
vector<vector<bool>> used;
vector<pair<int, int>> dost;

void check()
{
    for (auto i : dost)
    {
        if ((i.first != 1) or (i.second != 1))
        {
            if (used[i.first-1][i.second-1] == false)
            {
                return;
            }
        }
    }
    ans++;
}

void Prohod_obratno(int x, int y)
{
    if ((x == 0) && (y == 0))
    {
        check();
        return;
    }
    if ((x > 0) && (!used[x - 1][y]))
    {
        used[x-1][y] = true;
        Prohod_obratno(x-1, y);
        used[x-1][y] = false;
    }
    if ((y > 0) && (!used[x][y - 1]))
    {
        used[x][y-1] = true;
        Prohod_obratno(x, y-1);
        used[x][y-1] = false;
    }
}

void Prohod_tuda(int x, int y)
{
    if ((x == n - 1) && (y == m - 1))
    {
        Prohod_obratno(x, y);
        return;
    }
    if (x < n - 1)
    {
        used[x + 1][y] = true;
        Prohod_tuda(x + 1, y);
        used[x + 1][y] = false;
    }
    if (y < m - 1)
    {
        used[x][y + 1] = true;
        Prohod_tuda(x, y + 1);
        used[x][y + 1] = false;
    }
}


int main()
{
    cin >> n >> m >> k;
    used.resize(n, vector<bool>(m, false));
    for (int i = 0; i < k; ++i)
    {
        pair<int, int> l;
        cin >> l.first >> l.second;
        dost.push_back(l);
    }
    Prohod_tuda(0, 0);
    cout << ans;
}