#include <iostream>
#include <cmath>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    ll l, r, d;
    cin >> d >> l >> r;
    ll sq = sqrtl(d);
    ll a1, b1, x, y;
    ll ans = 0;
    for (ll i = 1; i <= sq; ++i) {
        if (d % i == 0) {
            a1 = i, b1 = d / i;
            if (a1 == b1) break;
            x = (a1 + b1) / 2;
            y = (b1 - a1) / 2;
            x *= x;
            y *= y;
            if (y < x && l <= y && x <= r) ++ans;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

