#include <iostream>
#include <vector>
using namespace std;

using ll = long long;

ll max(ll a, ll b) {
  if (a > b) {
    return a;
  }
  return b;
}

void solve2(int n, vector<ll>& a) {
  ll sum = 0;
  for(int i = 0; i < n; i++) {
    sum += a[i];
  }
  ll ans = 0;
  ll cur = 0;
  for (int i = 0; i < n - 1; i++) {
    cur += a[i];
    ll rest = sum - cur;
    ans = max(ans, (abs(cur - rest)));
  }
  cout << ans;
}


void solve() {
  int n, k;
  cin >> n >> k;
  vector<ll> a(n);
  vector<ll> pref(n + 1, 0);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    pref[i + 1] = pref[i] + a[i];
  }
  if (k == 2) {
    solve2(n, a);
    return;
  }
  ll cur = 0;
  vector<ll> sum(n);
  int len = n - k + 1;
  for (int i = 0; i < len; i++) {
    cur += a[i];
  }
  sum[0] = cur;
  int l = 0;
  for (int r = len; r < n; r++) {
    cur -= a[l];
    cur += a[r];
    l++;
    sum[l] = cur;
  }
  vector<ll> max_pr(n + 1, 0);
  for (int i = len; i <= n; i++) {
    max_pr[i] = max(max_pr[i - 1], sum[i - len]);
  }
  vector<ll>max_suf(n, 0);
  for (int i = n - len; i >= 0; i--) {
    max_suf[i] = max(max_suf[i + 1], sum[i]);
  }
  ll ans = 0;
  for (int i = 0; i < n; i++) {
    ll cur = 0;
    if (i <= len) {
      cur = max(cur, pref[i]);
    }
    if (n - 1 - i <= len) {
      cur = max(cur, pref[n] - pref[i + 1]);
    }
    cur = max(cur, max_pr[i]);
    if (i < n - 1) {
      cur = max(cur, max_suf[i + 1]);
    }
    ans = max(ans, cur - a[i]);
  }
  cout << ans;

}

int main() {

  solve();
}
