﻿// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<ios>
using namespace std;
#define ll long long

#define ch char

#define ull unsigned long long

#define f float
#define _d double

#define ui  unsigned int;

#define be(v) v.begin(), v.end()

#define s(v) std::sort(be(v));

#define matrix(T) vector<std::vector<T>>

#define graph(T) vector<pair<T, vector<T>>>
template<typename T>
void outv(std::vector<T> v, ch sep)
{
    for (const auto& i : v)
    {
        std::cout << i;
    }
}
typedef struct Point
{
    ull x;
    ull y;
} p;

ull Mode(p p1, p p2)
{
    return abs(sqrt((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y)));
}

p Plus(p p1, p p2)
{
    return { p1.x + p2.x, p1.y + p2.y };
}

p Minus(p p1, p p2)
{
    return { p1.x - p2.x, p1.y - p2.y };
}

inline pair<bool , ll> _x(ll a, ll d)
{
    if ((d / a + a) % 2 != 0 || (d / a + a) / 2 <= 0)
    {
        return { false, 0 };
    }
    else
    {
        return{ true, (d / a + a) / 2 };
    }
}
inline pair<bool, ll> _y(ll a, ll d)
{
    if (abs((d / a - a)) % 2 != 0 || (d / a - a) / 2 <= 0)
    {
        return { false, 0 };
    }
    else
    {
        return{ true, (d / a - a) / 2 };
    }
}
int main()
{   
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, k, _max = 0;

    std::cin >> n >> k;
    std::vector<ll> v(n), dp(n);
    for (size_t i = 0; i < n; i++)
    {
        std::cin >> v[i];
        if (i != 0)
        {
            dp[i] = dp[i - 1] + v[i];
        }
        else
        {
            dp[i] = v[i];
        }
    }

    for (size_t i = 0; i < n - 1; i++)
    {
        if (abs(dp[n - 1] - dp[i] - dp[i]) > _max)
        {
            _max = abs(dp[n - 1] - dp[i] - dp[i]);
        }
    }

    std::cout << _max;

}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
