//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <functional>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <unordered_map>
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;

using namespace std;

vector<int> a, b;

ll f(int i, int n, int k){
    if (i == n) return 1;
    int cur = 0;
    for (int j = i - 1; j >= 0 && j > i - k; --j){
        for (int t = k - i + j - 1; t >= 0; --t){
            if (a[j] & (1 << t)) cur++;
        }
    }
    int p = b[i] - cur; ll ans = 0;
    for (int mask = 0; mask < (1 << k); mask++){
        cur = 0;
        for (int t = 6; t >= 0; --t){
            if (mask & (1 << t)) cur++;
        }
        if (cur == p){
            a[i] = mask;
            ans = (ans + f(i + 1, n, k)) % (int)(1e9 + 7);
        }
    }

    return ans;
}

ll fast_pow(ll a, int b, int m){
    if (b == 0) return 1;
    if (b % 2 == 0) return fast_pow((a * a) % m, b / 2, m);
    return (fast_pow(a, b - 1, m) * a) % m;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n, k; cin >> n >> k;
    b.resize(n); a.resize(n);
    for (int i = 0; i < n; ++i) cin >> b[i];

    cout << f(0, n, k);


    return 0;
}
//5 3
//2 1 2 3 2