//#pragma GCC target("avx2")
//#pragma GCC optimize("O3")
#include <iostream>
#include <cmath>
#include <algorithm>
#include <functional>
#include <vector>
#include <iomanip>
#include <cassert>
#include <string>
#include <unordered_map>
#include <map>
#include <set>
#include <bitset>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

using namespace std;

vector<vector<int>> g, vis;

ll dfs(int x, int y, int n, int m, int s, int f, int k){
    if (x == 0 && y == 0 && f == 1 && s == k) return 1;
    if (vis[x][y]) return 0;
    vis[x][y] = 1;
    int f1 = f, s1 = s;
    if (g[x][y]) s1++;
    if (x == n - 1 && y == m - 1) f1 = 1;
    ll ans = 0;
    if (f1 == 0){
        if (x + 1 < n) ans += dfs(x + 1, y, n, m, s1, f1, k);
        if (y + 1 < m) ans += dfs(x, y + 1, n, m, s1, f1, k);
    } else {
        if (x - 1 >= 0) ans += dfs(x - 1, y, n, m, s1, f1, k);
        if (y - 1 >= 0) ans += dfs(x, y - 1, n, m, s1, f1, k);
    }

    vis[x][y] = 0;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
//    cout.setf(ios::fixed); cout.precision(10);

    int n, m, k; cin >> n >> m >> k;
    g.resize(n); vis.resize(n);
    for (int i = 0; i < n; ++i) g[i].resize(m), vis[i].resize(m);
    for (int i = 0; i < k; ++i){
        int x, y; cin >> x >> y; x--, y--;
        g[x][y]++;
    }

    cout << dfs(0, 0, n, m, 0, 0, k);

    return 0;
}
//
//3 4 2
//2 2
//2 3
