#include <bits/stdc++.h>

using namespace std;

const int MOD = (int)1e9 + 7;
vector <vector<int>> a;
vector<vector<bool>> used;

int n, m;
int ans = 0, k;

void gen(int rest, int i, int j, int cnt) {
    if (i >= 0 && i < n && j >= 0 && j < m && (!used[i][j] || (i == 0 && j == 0 && rest == 0))) {
        //cout << i << " " << j << " " << rest << "\n";
        used[i][j] = true;

        cnt += a[i][j];

        if (rest == 0) {
            if (i == 0 && j == 0 && cnt == k && used[n - 1][m - 1]) {
                ans = (ans + 1) % MOD;
            }
            used[i][j] = false;
            return;
        }

        gen(rest - 1, i + 1, j, cnt);
        gen(rest - 1, i, j + 1, cnt);
        gen(rest - 1, i - 1, j, cnt);

        //if (i == 1 && j == 2)
        //    cout << (used[i][j - 1]) << "-hm?\n";

        gen(rest - 1, i, j - 1, cnt);

        used[i][j] = false;
    }
}

int main () {
    cin >> n >> m >> k;

    a.resize(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> x >> y;

        a[x - 1][y - 1] = 1;
    }

    used.resize(n, vector<bool>(m, false));

    vector <pair<int, int>> tmp;

    gen(2 * n + 2 * m - 4, 0, 0, 0);

    cout << ans << "\n";
}
