#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  int n, k;
  cin >> n >> k;

  vector<int> a(n), s(n);

  for (int &x : a) {
    cin >> x;
  }

  vector<int64_t> p(n + 1);
  int64_t ans = 0;

  for (int z : {1, 2}) {
    (void)z;
    for (int i = 0; i < n; i++) {
      p[i + 1] = p[i] + a[i];
    }

    for (int i = n - 1; i >= 0; i--) {
      s[i] = a[i];
      if (i != n - 1) {
        s[i] = min(s[i], s[i + 1]);
      }
    }

    for (int l1 = 0; l1 < n; l1++) {
      for (int r1 = l1 + 1; r1 < n; r1++) {
        int len1 = r1 - l1;
        if (len1 <= n - k + 1) {
          int64_t t = s[r1];
          int64_t s = p[r1] - p[l1];
          // cout << t << " " << s << "\n";
          ans = max(ans, abs(t - s));
        }
      }
    }

    reverse(a.begin(), a.end());
  }

  cout << ans;
}