#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
#include <bitset>

const int MAX_N = 1e5 + 1;
const long long INF = 1e18 + 1;

typedef long long ll;

#define sz(s) int(s.size())
#define pb push_back
#define eb emplace_back
#define mp make_pair

using namespace std;
// using namespace __gnu_pbds;

// template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int n, k;
ll a[MAX_N];
ll pref[MAX_N];
ll cyff[MAX_N];

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
    }
    for (int i = n; i >= 1; i--) {
        cyff[i] = cyff[i + 1] + a[i];
    }
    ll ans = 0;
    for (int chosen = 1; chosen <= n; chosen++) {
        ll law = n - k + 1;
        if (chosen - 1 <= law) {
            ans = max(ans, abs( pref[chosen - 1] - a[chosen]));
            // cout << ans << "EXTRA" << "  " << chosen << " " << law << endl;
        } else {
            ll mx = -INF;
            for (int i = 1; i <= chosen - law; i++) {
                ans = max(ans, abs(pref[i + law - 1] - pref[i - 1] - a[chosen]));
                // cout << ans << " " << chosen << " " << i << endl;
            }
        }
        if (n - chosen <= law) {
            ans = max(ans, abs(cyff[chosen + 1] - a[chosen]));
            // cout << ans << "DOUBLEE" << "  " << chosen << " " << law << endl;
        } else {
            ll mx = -INF;
            for (int i = chosen + 1; i <= chosen - law; i++) {
                ans = max(ans, abs(cyff[i] - cyff[i + law] - a[chosen]));
                // cout << ans << " " << chosen << " " << i << endl;
            }
        }
    }
    // ll rig = 0;
    // for (int i = 1; i < n; i++) {
    //     rig = max(rig, abs(pref[n] - pref[i] - pref[i]));
    // }
    // cout << rig << endl;
    cout << ans << endl;
    
    
    return 0;
}

