#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

// int getInt(int l, int r) {
//     return uniform_int_distribution<int>(l, r)(gen);
// }

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    ll d, l, r; cin >> d >> l >> r;


    int ans = 0;
    

    ll x, y, x2, y2, b;
    
    for (ll a = 1; a <= d; a += 1; a++) {
        if (d / a * a != d) {
            continue;
        }
        b = d / a;

        if ((a + b) & 1) {
            continue;
        }

        x = ((a + b) >> 1);
        y = a - x;

        x2 = x * x;
        y2 = y*y;

        if (x > 0 && y > 0 && y < x && l <= x2 && x2 <= r && l <= y2 && y2 <= r) {
            ans++;
        }
    }

    cout << ans << "\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}