#include<bits/stdc++.h>

using namespace std;
using ll = long long;

#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

// int getInt(int l, int r) {
//     return uniform_int_distribution<int>(l, r)(gen);
// }

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<ll> a(n);

    for (auto &i : a) cin >> i;

    vector<ll> pr(n), sf(n), mn_pref(n), mn_sf(n);
    ll ans = 0;

    for(int i = 0; i < n; i++) {
        pr[i] = a[i];
        mn_pref[i] = a[i];
        if (i) pr[i] += pr[i - 1];
        if (i) mn_pref[i] = min(mn_pref[i], mn_pref[i - 1]);
    }

    for (int i = n -1 ;i >= 0; i--) {
        sf[i] = a[i];
        mn_sf[i] = a[i];

        if (i != n - 1) sf[i] += sf[i + 1];
        if (i != n - 1) mn_sf[i] = min(mn_sf[i], mn_sf[i + 1]);
    }

    if (k == 2) {
        
        for (int i = 0; i < n - 1; i++) {
            ans = max(ans, max(pr[i], sf[i + 1]) -  min(pr[i], sf[i + 1]));
        }

        cout << ans << "\n";
        return;
    }

    if (k == 3) {
        for (int i = 1; i < n - 1; i++) {
            ans = min(ans, pr[n - 2] - pr[i - 1] - pr[i - 1]);
            ans = min(ans, pr[i] - pr[0] - sf[i + 1]);

            ans = min(ans, max(a[i], max(pr[i - 1], sf[i + 1]) - min(a[i], min(pr[i - 1], sf[i + 1]));
        }

        ans = min(ans, sf[2] - min(a[0], a[1]));
        ans = min(ans, pr[n - 3] - min(a[n - 1], a[n - 2]));


        cout << ans << "\n";
        return;
    }
    for (int l = 0; l < n; l++) {
        for (int r = l; r < n; r++) {
            if (l && 1 + 1 + (n - r - 1) >= k && 1 + 1 + min(1, (n - r - 1)) <= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - pr[l - 1]);
            if (r != n - 1 && 1 + 1 + l >= k && 1 + 1 + min(1, l) <= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - sf[r + 1]);

            if (l > 1 && k >= 3 + min(1, (n - r - 1)) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - a[l - 1]);
            if (l > 1 && k >= 3 + min(1, (n - r - 1)) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - a[0]);

            if ((n - r - 1) > 1 && k >= 3 + min(1, l) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - a[r + 1]);
            if ((n - r - 1) > 1 && k >= 3 + min(1, l) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - a[n - 1]);

            if ((n - r - 1) > 2 && k >= 4 + min(1, l) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - mn_sf[r + 1]);
            if (l > 2 && k >= 4 + min(1, (n - r - 1)) && (n - r - 1) + 1 + l >= k) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - mn_pref[l - 1]);
            

            //if (l) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - mn_pref[l - 1]);
            //if (r != n - 1) ans = max(ans, pr[r] - (l ? pr[l - 1] : 0) - mn_sf[r + 1]);
        }
    }

    cout << ans << "\n";
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}