#include<bits/stdc++.h>

using namespace std;
using ll = long long;

//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2","bmi2","sse4.2")

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

// int getInt(int l, int r) {
//     return uniform_int_distribution<int>(l, r)(gen);
// }

struct point {
    int x, y;
    point() {};
    point (int X, int Y) {x = X; y = Y;}

    point friend operator+(point a, point b) {
        return point(a.x + b.x, a.y + b.y);
    }

    point friend operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    point friend operator*(point a, int b) {
        return point(a.x * b, a.y * b);
    }

    point friend operator/(point a, int b) {
        return point(a.x / b, a.y / b);
    }

    int friend operator*(point a, point b) {
        return a.x * b.x + a.y * b.y;
    }

    int friend operator^(point a, point b) {
        return a.x * b.y - a.y * b.x;
    }
};

void solve() {
    int n, s; cin >> n >> s;


    vector<vector<int>> a(n);


    vector<pair<int, int>> w;
    w.push_back({0, -1});

    for (int i = 0; i < n; i++) {
        int k; cin >> k; a[i].resize(k);
        for (auto &j : a[i]) {
            cin >> j;
            w.push_back({j, i});
        }
    }

    
    if (n == 1) {
        vector<vector<int>> dp(s + 1,vector<int>(w.size() + 1));
        vector<vector<int>> pr(s + 1,vector<int>(w.size() + 1));
        dp[0][0] = 1;

        for (int q = 1; q <= s; q++) {
            for (int i = 1; i < w.size(); i++) {
                if (dp[q][i - 1]) {
                        dp[q][i] = 1;        
                }
                if (w[i].first <= q) {
                    if (dp[q - w[i].first][i - 1]) {
                        dp[q][i] = 1;
                    }
                }
            }
        }

        int ind = -1;
        for (int i = 1; i < w.size(); i++) {
            if (dp[s][i]) {
                ind = i;
                break;
            }
        }

        if (ind == -1) {
            cout << "-1\n";
            return;
        }

        vector<int> e;
        while (ind != 0) {
            if (!dp[s][ind - 1]){
                s -= w[ind].first;
                e.push_back(ind);
            }
            ind--;
        }
        reverse(all(e));
        cout << "YES\n";
        cout << e.size() << "\n";
        for (auto i : e) cout << i << " ";
        return;
    }


    int cnt = w.size();

    vector<vector<bool>> dp(s + 1, vector<bool> (cnt));
    vector<vector<pair<int, int>>> prv(s + 1, vector<pair<int, int>> (cnt));
    pair<int, int> aa;
    dp[0][0] = 1;

    int a1 = -1, a2 = -1;

    for (int q = 1; q <= s; q++) {
        

        for (int i = 1; i < cnt; i++) {
            if (w[i].second != w[i - 1].second) {
                a1 = a2 + 1;
                a2 = i - 1;
            }


            if (w[i].first <= q) {
                for (int j = a1; j <= a2; j++) {
                    if (dp[q - w[i].first][j]) {
                        dp[q][i] = 1;
                        prv[q][i] = {j, i - a2};
                        break;
                    }

                }

                for (int j = a2 + 1; j < i; j++) {
                    if (dp[q - w[i].first][j]) {
                        dp[q][i] = 1;
                        prv[q][i] = {j, i - a2};
                        break;
                    }
                }
            }
            
        }

        if (q != s) {
            a1 = -1; 
            a2 = -1;
        }
    }

    int ind = -1;



    for (int i = a2 + 1; i < cnt; i++) {
        if (dp[s][i]) {
            ind = i;
            break;
        }
    }

    if (ind == -1) {
        cout <<  "No\n";
        return;
    }



    vector<vector<int>> p(n);

    while (ind != 0) {
        p[w[ind].second].push_back(prv[s][ind].second);
        int u = s;
        s -= w[ind].first;
        ind = prv[u][ind].first;
    }

    cout << "Yes\n";

    for (int i = 0; i < n; i++) {
        cout << p[i].size() << "\n";
        for (auto j : p[i]) cout << j << " ";
        cout << "\n";
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}