#include <bits/stdc++.h>
using namespace std;
#define int long long

const int maxn = 1e6 + 1;

int a[maxn], pref[maxn];
int n, k;

void solve1() {
    int ans = 0;
    for (int i = 1; i < n; i++) {
        ans = max(ans, pref[n] - pref[i] * 2);
    }
    for (int i = 1; i < n; i++) {
        ans = max(ans, pref[n] - (pref[n] - pref[i]) * 2);
    }
    cout << ans << '\n';
}

void solve2() {
    int ans = 0;
    for (int i = 0; i + 2 < n; i++) {
        int mxsuf = pref[n] - pref[i + 2], mnsuf = a[n - 1], mxser = pref[n - 1] - pref[i + 1], mnser = a[i + 1];
        ans = max(ans, abs(pref[i + 1] - mxsuf));
        ans = max(ans, abs(pref[i + 1] - mnsuf));
        ans = max(ans, abs(pref[i + 1] - mxser));
        ans = max(ans, abs(pref[i + 1] - mnser));
        ans = max(ans, abs(mxsuf - mnser));
        ans = max(ans, abs(mxser - mnsuf));
    }
    cout << ans << '\n';
}

void solve() {
    cin >> n >> k;
    multiset<int> aboba;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    if (k == 2) {
        solve1();
        exit(0);
    }
    if (k == 3) {
        solve2();
        exit(0);
    }
    int k1 = k;
    k = n - k + 1;
    for (int i = k; i < n; i++) {
        aboba.insert(a[i]);
    }
    int ans = 0;
    for (int i = 0; i + k <= n; i++) {
        ans = max(ans, pref[i + k] - pref[i] - *aboba.begin());
        aboba.insert(a[i]);
        if (i + k != n) {
            aboba.erase(aboba.find(a[i + k]));
        }
    }
    aboba.clear();
    for (int i = 0; i < n; i++) {
        aboba.insert(a[i]);
    }
    for (int i = 0; i + k1 <= n; i++) {
        aboba.erase(aboba.find(a[i]));
        ans = max(ans, pref[i + 1] - *aboba.begin());
    }
    aboba.clear();
    for (int i = 0; i < n; i++) {
        aboba.insert(a[i]);
    }
    for (int i = n - 1; i >= k1 - 1; i--) {
        aboba.erase(aboba.find(a[i]));
        ans = max(ans, pref[n] - pref[i] - *aboba.begin());
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    while (tests--) solve();
}
