#pragma GCC optimize("Ofast")
#pragma target("avx2", "sse2")
#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5 + 1000;
int a[maxn];
vector<int> g[maxn];
pair<int, int> rec[maxn];
vector<int> ans1[maxn];

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int>> rec(n, vector<int> (s + 2, -1));
    for (int i = 0; i < n; i++) {
        int ki;
        cin >> ki;
        for (int j = 0; j < ki; j++) {
            int cj;
            cin >> cj;
            if (cj > s) {
                g[i].push_back(s + 2);
            } else {
                g[i].push_back(cj);
            }
        }
    }
    bitset<maxn> abb1;
    abb1[0] = 1;
    for (int i = 0; i < n; i++) {
        bitset<maxn> mask = 0;
        for (int j = 0; j < (int) g[i].size(); j++) {
            bitset<maxn> adiba = ((mask | (abb1 << g[i][j])) ^ mask);
            mask |= (abb1 << g[i][j]);
            for (int w1 = adiba._Find_first(); w1 <= s; w1 = adiba._Find_next(w1)) {
                rec[i][w1] = j;
            }
            abb1 |= (abb1 << g[i][j]);
        }
        abb1 &= mask;
    }
    if (!abb1[s]) {
        cout << "No\n";
        exit(0);
    }
    cout << "Yes\n";
    int w = s, step = n - 1;
    map<pair<int, int>, bool> was;
    while (w > 0 && step >= 0) {
        bool fl = 0;
        while (rec[step][w] != -1) {
            ans1[step].push_back(rec[step][w]);
            if (was[{step, rec[step][w]}] == 1) {
                break;
            }
            was[{step, rec[step][w]}] = 1;
            w -= g[step][rec[step][w]];
            fl = 1;
        }
        /*if (fl == 0) {
            exit(1);
        }*/
        step--;
    }
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cout << (int) ans1[i].size() << '\n';
        sort(ans1[i].begin(), ans1[i].end());
        for (auto x : ans1[i]) {
            sum += g[i][x];
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
    /*if (sum != s) {
        exit(1);
    }*/
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int tests = 1;
    while (tests--) solve();
}
