#pragma GCC optimize("Ofast")
#pragma target("avx2", "sse2")
#include <bits/stdc++.h>
using namespace std;
#define int long long

const int maxn = 1e5 + 1;

mt19937 rng(1);
int a[maxn];
vector<int> g[maxn];
pair<int, int> rec[maxn];
vector<int> ans1[maxn];

void solve() {
    int n, s;
    cin >> n >> s;
    int sum = 0;
    vector<vector<int>> rec(n, vector<int> (s + 2, -1));
    for (int i = 0; i < n; i++) {
        int ki;
        cin >> ki;
        for (int j = 0; j < ki; j++) {
            int cj;
            cin >> cj;
            if (cj > s) {
                g[i].push_back(s + 1);
            } else {
                g[i].push_back(cj);
            }
        }
    }
    bitset<maxn> abb = 0;
    abb[0] = 1;
    for (int i = 0; i < n; i++) {
        bitset<maxn> abb1 = 0;
        for (int j = 0; j < (int) g[i].size(); j++) {
            bitset<maxn> adiba = ((abb1 | (abb << g[i][j])) ^ abb1);
            for (int w1 = adiba._Find_first(); w1 <= s; w1 = adiba._Find_next(w1)) {
                rec[i][w1] = j;
            }
            abb1 = (abb1 | adiba);
        }
        swap(abb, abb1);
    }
    if (!abb[s]) {
        cout << "No\n";
        exit(0);
    }
    cout << "Yes\n";
    int w = s, step = n - 1;
    while (w > 0 && step >= 0) {
        while (rec[step][w] != -1) {
            ans1[step].push_back(rec[step][w]);
            w -= g[step][rec[step][w]];
        }
        step--;
    }
    for (int i = 0; i < n; i++) {
        cout << (int) ans1[i].size() << '\n';
        for (auto x : ans1[i]) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    while (tests--) solve();
}
