from itertools import combinations


def get_value(segment):
    segment = [0] + segment + [0]
    result = 0
    high_spots = []
    for i in range(1, len(segment) - 1):
        if segment[i - 1] <= segment[i] and segment[i + 1] <= segment[i]:
            high_spots.append(i)

    # for distance in range(2, len(high_spots)):
    #     n = 0
    #     while n < len(high_spots) - distance:
    #         # print(high_spots[n], high_spots[n+2], high_spots[n+1])
    #         if min(segment[high_spots[n]], segment[high_spots[n + distance]]) >= max(
    #                 segment[high_spots[n + it]] for it in range(1, distance)):
    #
    #             high_spots.pop(n + 1)
    #         else:
    #             n += 1

    to_remove = set()

    for a, b in combinations(range(len(high_spots)), 2):
        spots = list(map(lambda x: [x, segment[x]], high_spots[a+1:b]))
        if max(spots + [[0, 0]], key=lambda x: x[1])[1] <= min(segment[high_spots[a]], segment[high_spots[b]]):
            for i, _ in spots:
                to_remove.add(i)

    for i in to_remove:
        high_spots.remove(i)

    for i in range(len(high_spots) - 1):
        l, r = high_spots[i], high_spots[i + 1]
        height = min(segment[l], segment[r])
        for i in range(l + 1, r):
            result += height - segment[i]
    return result


n = int(input())
h = list(map(int, input().split()))
k = list(map(int, input().split()))

segments = [[x] for x in h]

for i in k:
    segments[i - 1] += segments.pop(i)
    print(get_value(segments[i - 1]))
