from itertools import combinations


n, k = map(int, input().split())
a: tuple[int] = tuple(map(int, input().split()))


def test_peregorodki(peregorodki: tuple[int]) -> int:
    peregorodki: tuple[int] = tuple([0] + list(peregorodki) + [n])
    Min: int = 10**16
    Max: int = 0
    for i in range(k):
        result: int = sum(a[peregorodki[i]:peregorodki[i + 1]])
        Min: int = min(Min, result)
        Max: int = max(Max, result)
    return Max - Min


def main() -> None:
    t: int = 0

    for peregorodki in combinations(range(1, n), k - 1):
        data: int = test_peregorodki(peregorodki)
        if data > t:
            t = data

    print(t)


main()
