from itertools import combinations
from copy import copy
from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    n, k = map(int, input().split())
    a = list(map(int, input().split()))

    t = 0

    for peregorodki in combinations(range(1, n), k - 1):
        peregorodki = [0] + list(peregorodki) + [n]
        Min = float('inf')
        Max = 0
        for i in range(k):
            result = sum(a[peregorodki[i]:peregorodki[i + 1]])
            if result < Min:
                Min = copy(result)
            if result > Max:
                Max = copy(result)
        if Max - Min > t:
            t = Max - Min

    print(t)


thread = threading.Thread(target=main)
thread.start()

