from itertools import combinations
from copy import copy
from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

n, k = map(int, input().split())
a = list(map(int, input().split()))


def test_peregorodki(peregorodki):
    peregorodki = [0] + list(peregorodki) + [n]
    Min = float('inf')
    Max = 0
    for i in range(k):
        result = sum(a[peregorodki[i]:peregorodki[i + 1]])
        if result < Min:
            Min = copy(result)
        if result > Max:
            Max = copy(result)
    return Max - Min


def main():
    t = 0

    for peregorodki in combinations(range(1, n), k - 1):
        data = test_peregorodki(peregorodki)
        if data > t:
            t = data

    print(t)


thread = threading.Thread(target=main)
thread.start()
