#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi2,fma")

#ifndef lisie_bimbi
#define endl '\n'
#endif

using ll = long long;

const int mod = 1'000'000'007;

int add(int a, int b){
    if(a + b < mod){
        return a + b;
    }else{
        return (a + b - mod);
    }
}

int mul(int a, int b){
    return ((ll)a * b) % mod;
}

void solve(){
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> z(n + m + 1, vector<int>(n + m + 1));
    for(int i = 0; i < k; i++){
        int x, y;
        cin >> x >> y;
        x--;y--;
        z[x + y][x] = 1;
    }
    int now = 1;
    vector<vector<int>> d(n + m + 1, vector<int>(n + m + 1));
    d[0][1] = 1;
    auto d1 = d;
    for(; now < n - 1 + m - 1 - 1; ){
        vector<int> dd;
        now++;
        for(int i = 0; i < n + m + 1; i++){
            if(z[now][i]){
                dd.push_back(i);
            }
        }
        if(dd.size() > 2){
            cout << "0\n";
            return;
        }
        for(int i = 0; i < n + m + 1; i++){
            for(int j = i + 1; j < n + m + 1; j++){
                d1[i][j] = d[i][j];
                if(i > 0){
                    d1[i][j] = add(d1[i][j], d[i - 1][j]);
                }
                if(j > 0){
                    d1[i][j] = add(d1[i][j], d[i][j - 1]);
                }
                if((i > 0) && (j > 0)){
                    d1[i][j] = add(d1[i][j], d[i - 1][j - 1]);
                }
                for(auto t : dd){
                    if((i != t) && (j != t)){
                        d1[i][j] = 0;
                    }
                }
            }
        }
        swap(d, d1);
    }
    cout << add(d[n - 2][n - 1], d[n - 2][n - 1]) << endl;
}

signed main(){
#ifdef lisie_bimbi    
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif    
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}