//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>


#define int long long

using namespace std;

vector <int> a(0);
vector <int> t(0);

void build(int v, int l, int r) {
    if (r - l == 1) {
        t[v] = a[l];
    } else {
        int m = (l + r) / 2;
        build(2*v+1, l, m);
        build(2*v+2, m, r);
        t[v] = min(t[2*v+1], t[2*v+2]);
    }
}

int get_min(int v, int l, int r, const int &ql, const int &qr) {
    if (l >= ql && r <= qr) {
        return t[v];
    }
    if (l >= qr || r <= ql) {
        return 1e12;
    }
    int m = (l + r) / 2;
    return min(get_min(2*v+1, l, m, ql, qr), get_min(2*v+2, m, r, ql, qr));
}

bool compare(const pair<int,int>& a,const pair<int,int> b) {
    return a.first > b.first;
}

signed main() {
    int n, s;
    cin >> n >> s;
    if (n == 1) {
        int k;
        cin >> k;
        vector <pair<int, int>> c(k);
        for (int i = 0; i < k; ++i) {
            cin >> c[i].first;
            c[i].second = i;
        }
        vector <int> ans(0);
        sort(c.begin(), c.end(), compare);
        int index = k-1;
        while (s != 0 && index >= 0) {
            if (s < c[index].first) {
                index--;
            } else {
                s -= c[index].first;
                ans.push_back(c[index].second);
                index--;
            }
        }
        if (s == 0) {
            cout << "Yes" << endl;
            cout << ans.size() << endl;
            for (int i = 0; i < ans.size(); ++i) {
                cout << ans[i]+1 << endl;
            }
        } else {
            cout << "No";
        }
    }

}
