#include <bits/stdc++.h>

#define int long long

using namespace std;

int m, n;

vector <vector<int>> g(0);
vector <vector <int>> puti(0);
vector <int> vert(0);

void dfs(int u, vector <int> used) {
    /*
    cout << "dfs  " << u << endl;
    for (int i = 0; i < m*n; ++i) {
        if (used[i] == 1) cout << i << ' ';
    } cout << endl;
    */
    for (auto v: g[u]) {
        if (used[v] == 0 && v != m*n-1) {
            used[v] = 1;
            dfs(v, used);
            used[v] = 0;
        }
        if (v == m*n-1 && used[v] == 0) {
            used[v] = 1;
            vector <int> a(0);
            for (int i = 0; i < used.size(); ++i) {
                if (used[i] == 1) a.push_back(i);
            }
            puti.push_back(a);
            used[v] = 0;
        }
    }
}

bool proverka (vector <int> &a, vector <int> &b) {
    bool flag = true;
    int cnt = 0;
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < b.size(); ++j) {
            if (a[i] == b[j] && (i > 0 || j > 0)) flag = false;
        }
    }
    for (int i = 0; i < a.size(); ++i) {
        for (int j =0; j < vert.size(); ++j) {
            if (a[i] == vert[j]) cnt++;
        }
    }
    for (int i = 0; i < b.size(); ++i) {
        for (int j =0; j < vert.size(); ++j) {
            if (b[i] == vert[j]) cnt++;
        }
    }
    if (flag && cnt == vert.size()) return true;
    else return false;
}

signed main() {
    int k;
    cin >> m >> n >> k;
    g.resize(n*m);
    vector <pair <int, int>> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        int  x  = a[i].first;
        int y = a[i].second;
        x--, y--;
        vert.push_back(n*y + x);
    }
    for (int i = 0; i < n*m; ++i) {
        for (int j = 0; j < n*m; ++j) {
            if (abs(i-j) == 1 && (min(i,j)+1)%n != 0) {
                g[i].push_back(j);
            }
            if (abs(i-j) == n && i/n != j/n) {
                g[i].push_back(j);
            }
        }
    }
    vector <int> used(m*n, 0);
    used[0] = 1;
    dfs(0, used);
    int cnt = 0;
    for (int i = 0; i < puti.size() ;++i) {
            puti[i].pop_back();
    }

    for (int i = 0; i < puti.size() ;++i) {
        for (int j = 0; j < i ;++j) {
            vector <int> a = puti[i];
            vector <int> b = puti[j];
            if (proverka(a, b)) {
                    cnt++;

            }
            cnt %= 1000000000+7;
        }
    }
    cout << cnt;
}
