﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#define int long long
#define all(arr) arr.begin(), arr.end()
using namespace std;
bool bigger(string l, string r) {
	int n = l.size();
	int m = r.size();
	if (n == m) {
		return r >= l;
	}
	else {
		return m > n;
	}
}
bool bigger2(string l, string r) {
	int n = l.size();
	int m = r.size();
	if (n == m) {
		return r > l;
	}
	else {
		return m > n;
	}
}
string get_first(string l) {
	string ans = "";
	int n = l.size();
	for (int i = 0; i < n; i++) ans += "1";
	for (int i = n - 1; i >= 0; i--) {
		vector<char> prime = { '2','3','5','7' };
		for (int j = 0; j < 4; j++) {
			ans[i] = prime[j];
			if (bigger(l, ans)) return ans;
			ans[i] = '1';
		}
	}
	ans += "1";
	for (int i = n; i >= 0; i--) {
		vector<char> prime = { '2','3','5','7' };
		for (int j = 0; j < 4; j++) {
			ans[i] = prime[j];
			if (bigger(l, ans)) return ans;
			ans[i] = '1';
		}
	}
}
string get_first_binpow(string l) {
	string ans = "";
	int n = l.size();
	for (int i = 0; i < n; i++) ans += "1";
	int L = 1;
	int R = 4 * n;
	while (R - L > 1) {
		int mid = L + (R - L) / 2;
		int idx = mid / 4;
		if (mid % 4 == 0) idx--;
		int number = mid % 4;
		vector<char> prime = { '7','2','3','5' };
		ans[n - idx - 1] = prime[number];
		if (bigger(l, ans)) {
			R = mid;
			ans[n - idx - 1] = '1';
		}
		else {
			L = mid;
			ans[n - idx - 1] = '1';
		}
	}
	int idx1 = L / 4;
	if (L % 4 == 0) idx1--;
	int number1 = L % 4;
	vector<char> prime = { '7','2','3','5' };
	ans[n - idx1 - 1] = prime[number1];
	if (bigger(l, ans)) return ans;
	int idx2 = R / 4;
	if (R % 4 == 0) idx2--;
	int number2 = R % 4;
	ans[n - idx1 - 1] = '1';
	ans[n - idx2 - 1] = prime[number2];
	if (bigger(l, ans)) return ans;
	ans[n - idx2 - 1] = '1';
	ans += '2';
	return ans;


}
string get_last(string r) {
	string ans = "";
	int n = r.size();
	for (int i = 0; i < n; i++) ans += "1";
	for (int i = 0; i <= n - 1; i++) {
		vector<char> prime = { '7','5','3','2' };
		for (int j = 0; j < 4; j++) {
			ans[i] = prime[j];
			if (bigger(ans, r)) return ans;
			ans[i] = '1';
		}
	}
	string ans2 = "";
	for (int i = 0; i < n - 1; i++) ans2 += "1";
	for (int i = 0; i <= n - 1; i++) {
		vector<char> prime = { '7','5','3','2' };
		for (int j = 0; j < 4; j++) {
			ans2[i] = prime[j];
			if (bigger(ans2, r)) return ans2;
			ans2[i] = '1';
		}
	}

}
int more_than(string s) {
	int ans = 0;
	int idx = 0;
	int n = s.size();
	for (int i = 0; i < n; i++) {
		if (s[i] == '1') {
			ans += 4;
		}
		else {
			if (s[i] == '2') ans += 4;
			else if (s[i] == '3') ans += 3;
			else if (s[i] == '5') ans += 2;
			else if (s[i] == '7') ans += 1;
			return ans;
		}
	}
}

int less_than(string s) {
	int ans = 0;
	int idx = 0;
	int n = s.size();
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '1') {
			ans += 4;
		}
		else {
			if (s[i] == '2') ans += 1;
			else if (s[i] == '3') ans += 2;
			else if (s[i] == '5') ans += 3;
			else if (s[i] == '7') ans += 4;
			return ans;
		}
	}
}
signed main()
{
	//string x;
	//cin >> x;
	//cout << get_first_binpow(x);
	string l, r;
	cin >> l >> r;
	int r_size = r.size();
	string solve3 = "1";
	for (int i = 0; i < r_size - 1; i++) solve3 += "0";
	if (solve3 == r && l == "1") {
		int ans = 0;
		for (int i = 1; i <= r.size() - 1; i++) {
			ans += 4 * i;
		}
		cout << ans << "\n";
		return 0;
	}
	string first = get_first_binpow(l);
	string last = get_last(r);
	int n = first.size();
	int m = last.size();
	//cout << first << " " << last << "\n";
	if (bigger2(last, first)) {
		cout << 0 << "\n";
		return 0;
	}
	int ans = 0;

	if (m > n) {
		int more_than_first = more_than(first);
		//cout << more_than_first << "\n";
		int less_than_last = less_than(last);
		//cout << less_than_last << "\n";
		ans += more_than_first;
		ans += less_than_last;
		for (int i = n + 1; i <= m - 1; i++) ans += 4 * i;
		cout << ans << "\n";
		return 0;
	}
	if (m == n) {
		int more_than_first = more_than(first);
		//cout << more_than_first << "\n";
		int less_than_last = less_than(last);
		//cout << less_than_last << "\n";
		cout << -4 * n + more_than_first + less_than_last << "\n";
		return 0;
	}


}
