#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>
#include <vector>
#include <set>
#include <tuple>
#include <algorithm>

using namespace std;

//template <typename type> void out(type a) {
//	auto it = a.begin();
//	while (it != a.end()) {
//		for (auto e : *it) {
//			cout << e << " ";
//		}
//		it++;
//		cout << "\n";
//	}
//	cout << "\n";
//}

bool comp(vector <int> a, int k) {
	return a[3] < k;
}

typedef long long ll;
vector <int> h, p;
vector <pair <int, int>> g;
set <vector <int>> a; // granici, max
int n;

void solve() {
	cout << "SIGMA";
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		auto it = lower_bound(a.begin(), a.end(), k, comp);
		vector <int> t1 = *it, t2 = *(++it);
		/*for (auto e : t1) {
			cout << e << " ";
		}
		cout << "\n";
		for (auto e : t2) {
			cout << e << " ";
		}
		cout << "\n";*/
		a.erase(t1);
		a.erase(t2);
		vector <int> ans(4);
		ans[2] = max(t1[2], t2[2]);
		ans[0] = t1[0];
		ans[1] = t2[1];
		ll gl = min(h[ans[0] - 1], h[ans[1] - 2]) * (ans[1] - ans[0]);
		gl -= p[ans[1]-1] - p[ans[0]-1];
		gl = max(gl, 0LL);
		cout << gl << "\n";
		//cout << h[ans[0] -1] << " " << h[ans[1] - 2] << " " << ans[1] << " " << ans[0] << " " << p[ans[1]-1] << " " << p[ans[0]-1] << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	h.resize(n);
	g.resize(n);
	p.resize(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> h[i];
		p[i + 1] = p[i] + h[i];
		a.insert({ i, i + 1, h[i], i });
		g[i] = { h[i],h[i] };
	}
	int l = 0, r = n;
	while (r - l > 2) {
		int m1 = (l * 2 + r) / 3,
			m2 = (l + r * 2) / 3;
		if (h[m1] < h[m2]) {
			r = m2;
		}
		else {
			l = m1;
		}
	}
	int nom = 0;
	if ((l == 0 || h[l] >= h[l - 1]) && (l == n - 1 || h[l] <= h[l + 1])) {
		nom = l;
	}
	else
		if ((l + 1 == 0 || h[l + 1] <= h[l]) && (l + 1 == n - 1 || h[l + 1] <= h[l + 2])) {
			nom = l + 1;
		}
	if (nom != -1) {
		solve();
		exit(0);
	}
	for (int i = 0; i < n - 1; i++) {
		int k;
		cin >> k;
		auto it = lower_bound(a.begin(), a.end(), k - 1, comp);
		vector <int> t1 = *it, t2 = *(++it);
		a.erase(t1);
		a.erase(t2);
		vector <int> ans(3);
		ans[2] = max(t1[2], t2[2]);
		ans[0] = t1[0];
		ans[1] = t2[1];
		ll gl = 0;
		for (int j = t1[0]; j < t1[1]; j++) {
			if (g[j].second < t2[2]) {
				g[j].second = t2[2];
			}
			gl += min(g[j].first, g[j].second) - h[j];
		}
		for (int j = t2[0]; j < t2[1]; j++) {
			if (g[j].first < t1[2]) {
				g[j].first = t1[2];
			}
			gl += min(g[j].first, g[j].second) - h[j];
		}
		a.insert(ans);
		cout << gl << "\n";
	}

}