#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>
#include <vector>
#include <set>
#include <tuple>
#include <algorithm>

using namespace std;

typedef unsigned long long ll;

bool compy(pair <ll, ll> p, ll l) {
	ll y = (p.second - p.first) / 2;
	return y*y >= l;
}

bool compx(pair <ll, ll> p, ll r) {
	ll x = (p.second + p.first) / 2;
	return x*x > r;
}

/*bool comp(int a, int b) {
	return a < b;
}*/

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll l, r, d;
	cin >> d >> l >> r;
	vector <pair< ll, ll>> a;
	for (int i = 2; i * i <= d; i++) {
		if (d % i == 0 && ((i + d / i) % 2 == 0)) {
			a.push_back({ i,d / i });
		}
	}
	sort(a.begin(), a.end());
	/*for (auto e : a) {
		cout << e.first << " " << e.second << "\n";
	}*/
	auto itl = lower_bound(a.begin(), a.end(), l, compy);
	auto itr = lower_bound(a.begin(), a.end(), r, compx);
	cout << itl - itr;
	//cout << (*itl).first << " " << (*itl).second << "\n" << (*itr).first << " " << (*itr).second;
}