#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	vector <ll> a(n);
	vector <ll> mp(n + 1, INT_MAX), p(n + 1, 0);
	ll sum = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
		mp[i + 1] = min(mp[i], a[i]);
		p[i + 1] = p[i] + a[i];
	}
	vector <ll> ms(n + 1, INT_MAX);
	for (int i = n - 1; i >= 0; i--) {
		ms[i] = min(ms[i + 1], a[i]);
	}
	if (k == 2) {
		ll ans = 0;
		for (int i = 1; i < n; i++) {
			ans = max(ans, abs(sum - p[i] - p[i]));
		}
		cout << ans << "\n";
	}
	else {
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			ll sum = 0;
			for (int j = i; j < i + n - k + 1 && j < n; j++) {
				sum += a[j];
				ans = max(ans, sum - min(mp[i], ms[j + 1]));
			}
		}
		cout << ans;
	}
}