#include <iostream>
#include <algorithm>
#include <limits.h>
#include <string>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, s;
	cin >> n >> s;
	vector <int> k(n);
	vector <vector <int>> c(n);
	for (int i = 0; i < n; i++) {
		cin >> k[i];
		c[i].resize(k[i]);
		for (int j = 0; j < k[i]; j++) {
			cin >> c[i][j];
		}
	}
	vector <set <pair <int, int>>> ans(n);
	for (int i = 0; i < n; i++) {
		ans[i].insert({ 0,-1 });
		for (int j = 0; j < k[i]; j++) {
			for (auto e : ans[i]) {
				if (e.second == j) {
					continue;
				}
				ans[i].insert({ e.first + c[i][j], j });
			}
		}
	}
	set <pair <int, int>> res2;
	res2.insert({ 0,-1 });
	bool flag = false;
	int noms = 0;
	for (int i = 0; i < n && !flag; i++) {
		int nom = 0;
		for (auto e : ans[i]) {
			nom++;
			for (auto eres : res2) {
				if (eres.second == nom) {
					continue;
				}
				res2.insert({eres.first + e.first, nom});
				if (eres.first + e.first == s) {
					flag = true;
					noms = nom;
				}
			}
			if (flag)
				break;
		}
	}
	cout << "\n";
	set <int> res;
	for (auto e : res2) {
		res.insert(e.first);
	}
	if (res.find(s) == res.end()) {
		cout << "No";
	}
	else {
		cout << "Yes\n";
		for (int i = 0; i < n; i++) {
			vector <int> out;
			for (auto e : ans[i]) {
				if (res.find(s - e.first) != res.end() && e.first != 0) {
					s -= e.first;
					out.push_back(e.first);
				}
			}
			cout << out.size() << "\n";
			for (auto e : out) {
				cout << e << " ";
			}
			cout << "\n";
		}
	}
	///*for (int a1 = 0; a1 <= s; a1++) {
	//	if (ans[0].find(a1) != ans[0].end()) {
	//		set <int> res;
	//		for (int i = 1; i < n; i++) {
	//			for (auto e : ans[i]) {

	//			}
	//		}
	//	}
	//}*/
}