#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, k;
ll midr = -1;
ll midmin = 0, midmax = 1e18, midlst = 0;
vector<int> a;

void searchM(int i, int curk) {
    if (curk == k - 1 && i == n) {
        midr = max(midr, max(midmax, midlst) - min(midmin, midlst));
        return;
    }
    if (curk > k - 1 || i >= n)
        return;
    ll minbuf = midmin;
    ll maxbuf = midmax;
    ll lstbuf = midlst;
    midlst += a[i];
    searchM(i + 1, curk);
    midmin = min(minbuf, lstbuf);
    midmax = max(maxbuf, lstbuf);
    midlst = a[i];
    searchM(i + 1, curk + 1);
    midmin = minbuf;
    midmax = maxbuf;
    midlst = lstbuf;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    if (n <= 15) {
        midlst = midmax = midmin = a[0];

        searchM(1, 0);
        cout << midr << '\n';
    } else
    if (k == 2) {
        vector<ll> pref(n, 0);
        vector<ll> suf(n, 0);
        pref[0] = a[0];
        suf[n - 1] = a[n - 1];
        for (int i = 1, j = n - 2; i < n; ++i, --j) {
            pref[i] = pref[i - 1] + a[i];
            suf[j] = suf[j + 1] + a[j];
        }
        ll res = -1;
        for (int i = 1; i < n; ++i) {
            ll left = pref[i - 1];
            ll right = suf[i];
            res = max(res, max(left, right) - min(left, right));
        }
        cout << res << '\n';
    }

    return 0;
}
