#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int n, k;
ll midr = -1;
ll midmin = 0, midmax = 1e18, midlst = 0;
vector<ll> a;

void searchM(int i, int curk) {
    if (curk == k - 1 && i == n) {
        midr = max(midr, max(midmax, midlst) - min(midmin, midlst));
        return;
    }
    if (curk > k - 1 || i >= n)
        return;
    ll minbuf = midmin;
    ll maxbuf = midmax;
    ll lstbuf = midlst;
    midlst += a[i];
    searchM(i + 1, curk);
    midmin = min(minbuf, lstbuf);
    midmax = max(maxbuf, lstbuf);
    midlst = a[i];
    searchM(i + 1, curk + 1);
    midmin = minbuf;
    midmax = maxbuf;
    midlst = lstbuf;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    a.resize(n);
    vector<ll> pref(n, 0);
    vector<ll> suf(n, 0);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    pref[0] = a[0];
    suf[n - 1] = a[n - 1];
    for (int i = 1, j = n - 2; i < n; ++i, --j) {
        pref[i] = pref[i - 1] + a[i];
        suf[j] = suf[j + 1] + a[j];
    }

    if (n <= 15) {
        midlst = midmax = midmin = a[0];

        searchM(1, 0);
        cout << midr << '\n';
    } else
    if (k == 2) {
        ll res = -1;
        for (int i = 1; i < n; ++i) {
            ll left = pref[i - 1];
            ll right = suf[i];
            res = max(res, max(left, right) - min(left, right));
        }
        cout << res << '\n';
    } else
    if (k == 3) {
        ll res = -1;
        for (int i = 1; i < n - 1; ++i) {
            ll opt1 = max(pref[i - 1], max(a[i], suf[i + 1])) -
                      min(pref[i - 1], min(a[i], suf[i + 1]));
            ll opt2 = max(pref[i - 1], max(a[n - 1], suf[i] - a[n - 1])) -
                      min(pref[i - 1], min(a[n - 1], suf[i] - a[n - 1]));
            res = max(res, max(opt1, opt2));
        }
        for (int i = n - 2; i > 0; --i) {
            ll opt1 = max(suf[i + 1], max(a[i], pref[i - 1])) -
                      min(suf[i + 1], min(a[i], pref[i - 1]));
            ll opt2 = max(suf[i + 1], max(a[0], pref[i] - a[0])) -
                      min(suf[i + 1], min(a[0], pref[i] - a[0]));
            res = max(res, max(opt1, opt2));
        }
        cout << res << '\n';
    } else {
        ll res = -1;
        midr = -1;
        for (int jk = k - 2, l = 1, r = n - 1 - jk; r < n; ++l, ++r) {
            res = max(res, (suf[0] - (l == 0 ? 0 : pref[l - 1])
                             - (r == n - 1 ? 0 : suf[r + 1])) - a[0]);
        }
        for (int jk = k - 2, l = jk, r = n - 2; l >= 0; --l, --r) {
            res = max(res, (suf[0] - (l == 0 ? 0 : pref[l - 1])
                             - (r == n - 1 ? 0 : suf[r + 1])) - a[n - 1]);
        }
        for (int i = 1; i < n - 1; ++i) {
            for (int jk = k - 2 - n + i, l = jk, r = i - 1; l >= 0; --l, --r) {
                res = max(res, (suf[0] - (l == 0 ? 0 : pref[l - 1])
                             - (r == n - 1 ? 0 : suf[r + 1])) - a[i]);
            }
            for (int jk = k - 3 - i, l = i + jk, r = n - 1; l > i; --l, --r) {
                res = max(res, (suf[0] - (l == 0 ? 0 : pref[l - 1])
                             - (r == n - 1 ? 0 : suf[r + 1])) - a[i]);
            }
        }
        cout << res << '\n';
    }

    return 0;
}

/*
int n, m, k;
vector<pair<int, int>> p;
map<pair<int, int>, bool> used;
ll lst = 0;
ll path = 0;
ll res = 0;
//vector<pair<int, int>> allpath;
vector<int> cols;
vector<int> cols1;

void search(int y, int x) {
    if (y == 0 && x == 0 && path != 0) {
        res += path == 2*n + 2*m - 4 && lst == k && used[{n - 1, m - 1}];
        //for (auto f : allpath)
        //    cout << f.first << ':' << f.second << "; ";
        //cout << '\n';
        return;
    }
    ll lstbuf = lst;
    //allpath.push_back({y, x});
    if (p.size() > 1) {
        auto iter = lower_bound(p.begin(), p.end(), make_pair(y, x));
        if (iter != p.end() && *iter == make_pair(y, x))
            ++lst;
    }
    if (p.size() == 1) {
        lst += make_pair(y, x) == p[0];
    }
    path += 1;
    int cbuf = cols[x];
    int c1buf = cols1[x];
    if (cols1[x] == n - y - 2)
        ++cols1[x];
    if (cols[x] == y)
        ++cols[x];
    if (!(path - 1 + x + y > m*2+n*2-4 ||
        used[{0, 1}] && used[{1, 0}] && used[{1, 1}])) {
        used[{y, x}] = 1;
        if (y > 0 && (y -1 == 0 && x == 0 || !used[{y - 1, x}]))
            search(y - 1, x);
        if (y < n - 1 && (y +1 == 0 && x == 0 || !used[{y + 1, x}]))
            search(y + 1, x);
        if (x > 0 && (y == 0 && x-1 == 0 || !used[{y, x-1}]))
            search(y, x - 1);
        if (x < m - 1 && (cols[x] + cols1[x] != n && y == 0 && x +1== 0 || !used[{y, x+1}]))
            search(y, x + 1);
    }
    path -= 1;
    used[{y, x}] = 0;
    lst = lstbuf;
    cols[x] = cbuf;
    cols1[x] = c1buf;
    //allpath.pop_back();
}

vector<

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> m >> n >> k;
    p.resize(k);
    cols.assign(m, 0);
    cols1.assign(m, 0);
    for (int i = 0; i < k; ++i) {
        cin >> p[i].second >> p[i].first;
        --p[i].second, --p[i].first;
    }
    sort(p.begin(), p.end());
    search(0, 0);
    cout << res << '\n';
    return 0;
}*/
