#include <iostream>
#include <vector>
#include <set>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k; cin >> n >> k;
    vector<ll> a(n); for (auto &i : a) cin >> i;

    multiset<ll> mn;
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        if (i < n - k + 1) sm += a[i];
        else mn.insert(a[i]);
    }
    ll best = sm - *mn.begin();

    if (k >= 3) {
        ll psm = a[0];
        best = max(best, psm - a[1]);
        for (int i = 2; i < n - k + 1; i++) {
            psm += a[i - 1];
            best = max(best, psm - a[i]);
        }
        ll ssm = a[n - 1];
        best = max(best, ssm - a[n - 2]);
        for (int i = n - 3; i >= k - 1; i--) {
            ssm += a[i + 1];
            best = max(best, ssm - a[i]);
        }
    }

    for (int i = 0; i < k - 1; i++) {
        sm -= a[i];
        sm += a[i + n - k + 1];
        mn.insert(a[i]);
        mn.extract(a[i + n - k + 1]);
        best = max(best, sm - *mn.begin());
    }

    cout << best << '\n';
}