#include <iostream>
#include <vector>

using namespace std;
typedef int ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; ll sd; cin >> n >> sd;
    vector<pair<ll, int>> c;
    vector<int> pr;
    pr.reserve(1e5);
    c.reserve(1e5);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            ll x; cin >> x;
            c.emplace_back(x, j);
            pr.push_back(i);
        }
    }

    ll sm = 0;
    bool flag = true;
    for (auto [x, j] : c) {
        if (j != 0) flag = false;
        sm += x;
    }
    if (flag) {
        if (sm == sd) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                cout << "1\n1\n";
            }
        } else {
            cout << "No\n";
        }
        return 0;
    }

    vector<vector<vector<bool>>> dp(sd + 1, vector<vector<bool>>(c.size(), {false, false}));
    vector<vector<bool>> back(sd + 1, vector<bool>(c.size(), false));
    dp[0][0][0] = true;
    if (c[0].first <= sd) {
        dp[c[0].first][0] = {true, true};
        back[c[0].first][0] = true;
    }

    int ks = c.size() - 1;
    flag = false;
    for (int k = 1; k < c.size(); k++) {
        for (ll s = 0; s <= sd; s++) {
            if (s >= c[k].first) {
                bool t = c[k].second == 0 ? dp[s-c[k].first][k-1][1] : dp[s-c[k].first][k-1][0];
                dp[s][k] = {t, t};
                if (t) back[s][k] = true;
            }
            bool t = c[k].second == 0 ? dp[s][k-1][1] : dp[s][k-1][0];
            dp[s][k][0] = dp[s][k][0] || t;
            if (c[k].second != 0) {
                dp[s][k][1] = dp[s][k][1] || dp[s][k-1][1];
            }
            if (s == sd && dp[s][k][1]) {
                ks = k;
                flag = true;
            }
        }
        if (flag) break;
    }

    // for (int k = 0; k < c.size(); k++) {
    //     for (ll s = 0; s <= sd; s++) {
    //         cout << dp[s][k][0] << dp[s][k][1] << ' ';
    //     }
    //     cout << '\n';
    // }
    // cout << "---\n";
    // for (int k = 0; k < c.size(); k++) {
    //     for (ll s = 0; s <= sd; s++) {
    //         cout << back[s][k] << ' ';
    //     }
    //     cout << '\n';
    // }

    cout << (dp[sd][ks][1] ? "Yes" : "No") << '\n';
    if (dp[sd][ks][1]) {
        vector<vector<int>> ans(n);
        int s = sd;
        for (int k = ks; k >= 0; k--) {
            if (back[s][k]) {
                s -= c[k].first;
                ans[pr[k]].push_back(c[k].second);
            }
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            for (auto j = ans[i].rbegin(); j != ans[i].rend(); j++) {
                cout << *j + 1 << ' ';
            }
            cout << '\n';
        }
    }
}