﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <bits/stdc++.h>

using namespace std;

#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define x first
#define y second
#define int long long

struct seg {
	int d, maxh, lmaxd, rmaxd, midd;
	pair<int, int> indh;

	seg(int d, int h, int ind) : d(d), maxh(h), indh(make_pair(ind, ind + 1)), lmaxd(0), rmaxd(0), midd(0) {

	}

	seg(int d, int h, pair<int, int> ind, int lmaxdd, int rmaxdd, int midd) : d(d), maxh(h), indh(ind), lmaxd(lmaxdd), rmaxd(rmaxdd), midd(midd) {

	}

	seg() {

	}
};

vector<int> prefh;

int geth(int l, int r) {
	return prefh[r] - prefh[l];
}

seg merge(seg a, seg b) {
	int maxh, lmaxd, rmaxd;
	pair<int, int> indh;
	int l = a.indh.y, r = b.indh.x;
	int d;
	int midd = 0;
	if (a.maxh > b.maxh) {
		maxh = a.maxh;
		midd = a.midd;
		indh = a.indh;
		lmaxd = a.lmaxd;
		rmaxd = max(b.maxh * (r - l) - geth(l, r), 0ll) +
			b.rmaxd + b.midd;
		d = lmaxd + rmaxd + midd;
	}
	else if (a.maxh < b.maxh) {
		maxh = b.maxh;
		midd = b.midd;
		indh = b.indh;
		lmaxd = max(a.maxh * (r - l) - geth(l, r), 0ll) +
			a.lmaxd + a.midd;
		rmaxd = b.rmaxd;
		d = lmaxd + rmaxd + midd;
	}
	else {
		maxh = a.maxh;
		indh = { a.indh.x, b.indh.y };

		lmaxd = a.lmaxd;
		rmaxd = b.rmaxd;
		midd = max((a.maxh * (r - l) - geth(l, r)), 0ll) + a.midd + b.midd;
		d = lmaxd + rmaxd + midd;
	}
	return { d, maxh, indh, lmaxd, rmaxd, midd };
}

void solve() {
	int n;
	cin >> n;
	ordered_set os;
	prefh.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> prefh[i];
		prefh[i] += prefh[i - 1];
	}
	//vector<int> rgr(n);
	for (int i = 0; i < n; i++) {
		//rgr[i] = i + 1;
		os.insert(i);
	}
	//SegTree t;
	//t.build();
	vector<seg> segs(n);
	for (int i = 0; i < n; i++) {
		segs[i] = seg(0, geth(i, i + 1), i);
	}
	int a;
	for (int i = 0; i < n - 1; i++) {
		cin >> a; a--;
		int l = *os.find_by_order(a), r = *os.find_by_order(a + 1);
		//cout << l << ' ' << r << '\n';
		os.erase(r);
		//rgr[l] = rgr[r];
		segs[l] = merge(segs[l], segs[r]);
		//r = rgr[r];
		//seg tt = segs[l];
		cout << segs[l].d << '\n';
		//cout << tt.d << ' ' << tt.indh.x << ' ' << tt.indh.y << ' ' << tt.maxh << ' ' << tt.lmaxd << ' ' << tt.rmaxd << "\n\n";
		/*
		cout << l << ' ' << r << '\n';
		seg tt = t.getsum(0, l, r, 0, n);

		cout << t.getsum(0, l, r, 0, n).d << '\n';*/
	}

	//cin >> a;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1

0
4
0
0
-1
13
16

10
5 4 3 2 3 5 5 6 5 4


6
5 5 1 2 5 5
2

3

2

1

1




*/
