﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
#define int long long

int mod = 1e9 + 7;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> b(n);
	for (auto& i : b) {
		cin >> i;
	}
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(3, vector<int>(2)));
	dp[0][0][0] = 1;
	dp[0][1][0] = 0;
	dp[0][2][0] = 0;

	dp[0][0][1] = 0;
	dp[0][1][1] = 0;
	dp[0][2][1] = 0;
	for (int i = 1; i <= n; i++) {
		if (b[i - 1] > 3) {
			cout << 0;
			return;
		}
		if (b[i - 1] == 2) {
			dp[i][0][0] = 1 * dp[i - 1][1][0] % mod;
			dp[i][1][0] = 2 * dp[i - 1][1][0] % mod;
			dp[i][2][0] = 0;

			dp[i][0][1] = 0;
			dp[i][1][1] = 2 * dp[i - 1][1][0] % mod;
			dp[i][2][1] = 1 * dp[i - 1][0][0] % mod;
		}

		if (b[i - 1] == 3) {
			dp[i][0][0] = 0;
			dp[i][1][0] = dp[i - 1][1][0] % mod;
			dp[i][2][0] = 0;

			dp[i][0][1] = 0;
			dp[i][1][1] = 0;
			dp[i][2][1] = 1 * dp[i - 1][1][0] % mod;
		}


		if (b[i - 1] == 1) {
			dp[i][0][0] = (2 * dp[i - 1][0][0] + dp[i -1][1][0]) % mod;
			dp[i][1][0] = dp[i - 1][0][0];
			dp[i][2][0] = 0;

			dp[i][0][1] = 0;
			dp[i][1][1] = (2 * dp[i - 1][0][0]) % mod;
			dp[i][2][1] = 0;
		}

		if (b[i - 1] == 0) {
			dp[i][0][0] = dp[i - 1][0][0];
			dp[i][1][0] = 0;
			dp[i][2][0] = 0;

			dp[i][0][1] = dp[i - 1][0][0];
			dp[i][1][1] = 0;
			dp[i][2][1] = 0;
		}
	}
	int sum = (dp[n][0][1] + dp[n][1][1] + dp[n][2][1]) % mod;
	cout << sum;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}
