﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> v(n), sufmin(n + 1, inf), prefmin(n + 1, inf);
	for (auto& i : v) {
		cin >> i;
	}
	for (int i = n - 1; i >= 0; i--) {
		sufmin[i] = min(sufmin[i + 1], v[i]);
	}
	for (int i = 0; i < n; i++) {
		prefmin[i + 1] = min(prefmin[i], v[i]);
	}
	int sum = 0;
	int sz = n - k + 1;
	for (int i = 0; i < sz; i++) {
		sum += v[i];
	}
	int ans = 0;
	ans = max(ans, sum - min(sufmin[sz], prefmin[0]));
	for (int i = 0; i + sz < n; i++) {
		sum -= v[i];
		sum += v[i + sz];
		ans = max(ans, sum - min(sufmin[i + sz + 1], prefmin[i + 1]));
		//cout << i << ' ' << ans << ' ' << sufmin[i + sz + 1] << ' ' << prefmin[i + 1] << '\n';
	}
	cout << ans;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}
