﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
//#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, s, k;
	cin >> n >> s;

	set<int> se, se2, se3;
	vector<vector<pair<int, pair<int, int>>>> pred(n + 1, vector<pair<int, pair<int, int>>>(s + 1, {-1, {-1, -1}}));
	se.insert(0);
	pred[0][0] = { -1, {-1, -1} };
	int a;
	//vector<vector<int>> v(n);
	for (int i = 0; i < n; i++) {
		cin >> k;
		for (int j = 0; j < k; j++) {
			cin >> a;
			for (auto& o : se2) {
				if (o + a > s) {
					break;
				}
				if (se3.insert(o + a).second) {
					if (pred[i + 1][o + a].first == -1) {
						pred[i + 1][o + a] = { i + 1,  {j + 1, o } };
					}
				}
			}
			for (auto& o : se) {
				if (o + a > s) {
					break;
				}
				if (se2.insert(o + a).second) {
					if (pred[i + 1][o + a].first == -1) {
						pred[i + 1][o + a] = { i, { j + 1, o } };
					}
				}
			}
			for (auto& o : se3) {
				se2.insert(o);
			}
			se3.clear();
		}
		se = se2;/*
		for (auto& j : se) {
			cout << j << ' ';
		}cout << '\n';*/
		se2.clear();
	}/*
	for (auto& i : pred) {
		for (auto& j : i) {
			cout << j.x << ' ' << j.y.x << ' ' << j.y.y << "   ";
		}cout << "\n\n";
	}*/
	if (se.find(s) != se.end()) {
		cout << "Yes\n";
		int ind = s, i = n;
		int newind, newi;
		vector<vector<int>> ans(n); 
		while (i != 0 || ind != 0) {
			ans[i - 1].push_back(pred[i][ind].y.x);
			newi = pred[i][ind].x;
			newind = pred[i][ind].y.y;
			ind = newind;
			i = newi;
		}
		for (auto& i : ans) {
			cout << i.size() << '\n';
			for (auto& j : i) {
				cout << j << ' ';
			}cout << '\n';
		}
	}
	else {
		cout << "No\n";
	}
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}


/*
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> v(n), suf(n + 1, 0), pref(n + 1, 0);
	for (auto& i : v) {
		cin >> i;
	}
	int sum = 0, st = 0;
	int sz = n - k + 1;
	for (int i = n - 1; i >= 0; i--) {
		sum += v[i];
		st++;
		if (st > sz) {
			sum -= v[i + sz];
			st--;
		}
		suf[i] = max(suf[i + 1], sum);
	}
	sum = 0;
	st = 0;
	for (int i = 0; i < n; i++) {
		sum += v[i];
		st++;
		if (st > sz) {
			sum -= v[i - sz];
			st--;
		}
		pref[i + 1] = max(pref[i], sum);
	}
	for (int i = 0; i < sz; i++) {
		sum += v[i];
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		ans = max(ans, max(suf[i + 1], pref[i]) - v[i]);
		//cout << i << ' ' << ans << ' ' << sufmin[i + sz + 1] << ' ' << prefmin[i + 1] << '\n';
	}
	cout << ans;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}
*/