﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
//#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

vector<vector<int>> used;

int ans = 0, cnt = 0, n, m, k;

void dfs(int x, int y, int type = 0) {
	used[x][y] += 2;
	if (used[x][y] == 3) {
		cnt++;
	}
	if (((x == 1 && y == 0) || (x == 0 && y == 1)) && type == 1 && cnt == k) {
		ans++;
	}
	if (!type) {
		if (x == n - 1 && y == m - 1) {
			type = 1;
		}
	}
	if (!type) {
		if (x < n - 1 && used[x + 1][y] < 2) {
			dfs(x + 1, y, type);
		}
		if (y < m - 1 && used[x][y + 1] < 2) {
			dfs(x, y + 1, type);
		}
	}
	else {
		if (x > 0 && used[x - 1][y] < 2) {
			dfs(x - 1, y, type);
		}
		if (y > 0 && used[x][y - 1] < 2) {
			dfs(x, y - 1, type);
		}
	}
	if (used[x][y] == 3) {
		cnt--;
	}
	used[x][y] -= 2;
}

void solve() {
	cin >> n >> m >> k;
	used.resize(n, vector<int>(m));
	int a, b;
	cnt = 0;

	for (int i = 0; i < k; i++) {
		cin >> a >> b; a--; b--;
		used[a][b] = 1;
	}
	dfs(0, 0);
	cout << ans;
}


signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}


/*
#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>
#include <cmath>

using namespace std;

#define x first
#define y second
#define int long long

int mod = 1e9 + 7;
int inf = 1e15 + 1;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> v(n), suf(n + 1, 0), pref(n + 1, 0);
	for (auto& i : v) {
		cin >> i;
	}
	int sum = 0, st = 0;
	int sz = n - k + 1;
	for (int i = n - 1; i >= 0; i--) {
		sum += v[i];
		st++;
		if (st > sz) {
			sum -= v[i + sz];
			st--;
		}
		suf[i] = max(suf[i + 1], sum);
	}
	sum = 0;
	st = 0;
	for (int i = 0; i < n; i++) {
		sum += v[i];
		st++;
		if (st > sz) {
			sum -= v[i - sz];
			st--;
		}
		pref[i + 1] = max(pref[i], sum);
	}
	for (int i = 0; i < sz; i++) {
		sum += v[i];
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		ans = max(ans, max(suf[i + 1], pref[i]) - v[i]);
		//cout << i << ' ' << ans << ' ' << sufmin[i + sz + 1] << ' ' << prefmin[i + 1] << '\n';
	}
	cout << ans;
}

signed main() {
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
	}

}
*/