#include <iostream>
#include <bits/stdc++.h>

using namespace std;

vector<int> st;

void build(int v, int tl, int tr){
    if (tl == tr){
        st[v] = 1;
    } else{
        int tm = (tr + tl) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);
        st[v] = st[2 * v] + st[2 * v + 1];
    }
}

void upd(int v, int tl, int tr, int ind){
    if (tl == tr){
        st[v] = 0;
    } else{
        int tm = (tl + tr) / 2;
        if (ind <= tm){
            upd(2 * v, tl, tm, ind);
        } else{
            upd(2 * v + 1, tm + 1, tr, ind);
        }
        st[v] = st[2 * v] + st[2 * v + 1];
    }
}

int fnd(int v, int tl, int tr, int k){
    if (tl == tr){
        return tl;
    } else{
        int tm = (tl + tr) / 2;
        if (st[2 * v] >= k){
            return fnd(2 * v, tl, tm, k);
        }
        return fnd(2 * v + 1, tm + 1, tr, k - st[2 * v]);
    }
}

int main()
{
    long long n;
    cin >> n;
    vector<long long> h(n);
    vector<int> a(n, 1);
    st.resize(4 * n);
    build(1, 0, n - 1);
    vector<long long> w(n, 0), psum(n + 1), gml(n, 0), gmr(n, 0);
    vector<vector<long long>> mxup(n), mxdn(n), smup(n), smdn(n);
    vector<int> opup(n), opdn(n);
    for (int i = 0; i < n; ++i){
        cin >> h[i];
        psum[i + 1] = psum[i] + h[i];
        gml[i] = i;
        gmr[i] = i;
        opup[i] = i;
        opdn[i] = i;
        mxup[i].push_back(i);
        mxdn[i].push_back(i);
        smup[i].push_back(0);
        smdn[i].push_back(0);
    }
    for (int _ = 0; _ < n - 1; ++_){
        int k;
        cin >> k;
        int i = fnd(1, 0, n - 1, k);
        int j = fnd(1, 0, n - 1, k + 1);
        upd(1, 0, n - 1, j);
        //cout << i << " " << j << endl;
        //cout << gm[i] << " " << gm[j] << endl;
        //cout << h[gm[i]] << " " << h[gm[j]] << endl;
        if (h[gmr[i]] >= h[gml[j]]){
            int ind = opdn[i], jnd = opdn[j];
            int xl = -1, xr = mxdn[ind].size() - 1, xm;
            while (xl + 1 < xr){
                xm = (xl + xr) / 2;
                if (h[mxdn[ind][xm]] < h[gmr[j]]){
                    xl = xm;
                } else{
                    xr = xm;
                }
            }
            int x = xr;
            //cout << h[mxdn[ind][x]] << " " << min(h[gm[i]], h[gm[j]]) << " " << (psum[gm[j]] - psum[mxdn[ind][x] + 1]) << endl;
            //int x = lower_bound(mxdn[ind].begin(), mxdn[ind].end(), gm[j]) - mxdn[ind].begin();
            long long aded = min(h[gmr[i]], h[gml[j]]) * (gml[j] - mxdn[ind][x] - 1) - (psum[gml[j]] - psum[mxdn[ind][x] + 1]);
            if (x == mxdn[ind].size()){
                w[i] += -smdn[ind][x - 1] + smdn[jnd][smdn[jnd].size() - 1] + aded;
            } else{
                w[i] += -smdn[ind][x] + smdn[jnd][smdn[jnd].size() - 1] + aded;
            }
            cout << w[i] << endl;
            bool op = false;
            for (int m = x; m < mxdn[ind].size(); ++m){
                if (h[gml[j]] == h[mxdn[ind][x]] && x == m){
                    continue;
                }
                mxdn[jnd].push_back(mxdn[ind][x]);
                smdn[jnd].push_back(smdn[jnd][smdn[jnd].size() - 1] + smdn[ind][x] - (x == 0 ? 0 : smdn[ind][x - 1]));
                if (!op){
                    smdn[jnd][smdn[jnd].size() - 1] += -(smdn[ind][x] - (x == 0 ? 0 : smdn[ind][x - 1])) + aded;
                    op = true;
                }
                //cout << smdn[jnd][smdn[jnd].size() - 1] << " ";
            }
            //cout << endl;
            if (h[gmr[i]] == h[gml[j]]){
                gmr[i] = gmr[j];
            }
            opdn[i] = opdn[j];
        } else{
            int ind = opdn[i], jnd = opdn[j];
            int xl = -1, xr = mxup[jnd].size() - 1, xm;
            while (xl + 1 < xr){
                xm = (xl + xr) / 2;
                if (h[mxup[jnd][xm]] < h[gmr[i]]){
                    xl = xm;
                } else{
                    xr = xm;
                }
            }
            int x = xr;
            //cout << h[mxdn[ind][x]] << " " << min(h[gm[i]], h[gm[j]]) << " " << (psum[gm[j]] - psum[mxdn[ind][x] + 1]) << endl;
            //int x = lower_bound(mxdn[ind].begin(), mxdn[ind].end(), gm[j]) - mxdn[ind].begin();
            long long aded = min(h[gmr[i]], h[gml[j]]) * (mxup[jnd][x] - gmr[i] - 1) - (psum[mxup[jnd][x]] - psum[gmr[i] + 1]);
            //cout << w[i] << "before " << aded << " " << mxup[jnd][x] - gm[i] - 1 << "  " << (psum[mxup[jnd][x]] - psum[gm[i] + 1]) << endl;
            w[i] += -smup[jnd][x] + smup[jnd][smup[jnd].size() - 1] + aded;
            cout << w[i] << endl;
            bool op = false;
            for (int m = x; m < mxup[jnd].size(); ++m){
                mxup[ind].push_back(mxup[jnd][x]);
                smup[ind].push_back(smup[ind][smup[ind].size() - 1] + smup[jnd][x] - (x == 0 ? 0 : smup[jnd][x - 1]));
                if (!op){
                    smup[ind][smup[ind].size() - 1] += -smup[jnd][x] - (x == 0 ? 0 : smup[jnd][x - 1]) + aded;
                    op = true;
                }
            }
            gmr[i] = gmr[j];
            gml[i] = gml[j];
        }
    }
    return 0;
}

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
