#include <iostream>
#include <string>
#include <vector>

#define int long long

using namespace std;

bool isPrime(int x)
{
    return x == 2 || x == 3 || x == 5 || x == 7;
}

int main()
{
    string l, r;
    cin >> l >> r;
    long long lsz = l.size(), rsz = r.size();
    if (l == r)
    {
        int cnt = 0;
        for (char c: l)
        {
            if (isPrime(c - '0')) cnt++;
            if ((c - '0') != 1 && !isPrime((int) (c - '0')))
            {
                cout << 0;
                return 0;
            }
        }
        if (cnt) cout << 1;
        else cout << 0;
        return 0;
    }
    long long ans = 0;
    for (int i = 2; i <= 9; i++)
    {
        if (isPrime(i))
        {
            int lpos = lsz - 1, rpos = rsz - 1;
            for (int j = 0; j < lsz; j++)
            {
                if ((l[j] - '0') < i && (l[j] - '0') > 1)
                {
                    lpos = j;
                    break;
                }
                else if ((l[j] - '0') > i)
                {
                    lpos = j - 1;
                    break;
                }
                else if ((l[j] - '0') == i)
                {
                    bool flag = true;
                    for (int Z = j + 1; Z < lsz; Z++)
                    {
                        if ((l[Z] - '0') > 1)
                        {
                            flag = false;
                            break;
                        }
                    }
                    if (flag) lpos = j;
                    else lpos = j - 1;
                    break;
                }
            }
            for (int j = 0; j < rsz; j++)
            {
                if ((r[j] - '0') < i && (r[j] - '0') > 1)
                {
                    rpos = j;
                    break;
                }
                else if ((r[j] - '0') > i)
                {
                    rpos = j - 1;
                    break;
                }
                else if ((r[j] - '0') == i)
                {
                    bool flag = true;
                    bool f1 = true;
                    for (int Z = j + 1; Z < rsz; Z++)
                    {
                        if ((r[Z] - '0') != 1) f1 = false;
                        if ((r[Z] - '0') > 1)
                        {
                            flag = false;
                            break;
                        }
                    }
                    if (flag && !f1) rpos = j;
                    else rpos = j - 1;
                    break;
                }
            }
            if (lsz != rsz)
            {
                ans += lpos + 1 + rsz - rpos - 1;
                if (rsz - lsz >= 2) ans += (lsz + rsz) * (rsz - lsz - 1) / 2;
            }
            else if (rpos + 1 <= lpos) ans += lpos - (rpos + 1) + 1;
        }
    }
    cout << ans;
    return 0;
}
