#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

#define FAST ios::sync_with_stdio(0), cout.tie(0); cin.tie(0);
#define ll int64_t
#define int int64_t
#define endl '\n'

void solve();

int32_t main() {
    FAST;

    int64_t t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

ll max(ll a, ll b, ll c) {
    return max(a, max(b, c));
}
ll min(ll a, ll b, ll c) {
    return min(a, min(b, c));
}

ll ab(ll sum, map<ll, ll> s) {
    return abs(max(sum, s.begin()->first, prev(s.end())->first) - min(sum, s.begin()->first, prev(s.end())->first));
}

void solve() {
    ll n, k;
    cin >> n >> k;

    map<ll, ll> s;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;

        s[i]++;
    }

    ll sum = 0, mx = 0;
    for (ll i = 0; i < n - k + 1; i++) {
        sum += a[i];
        
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);

        mx = max(mx, ab(sum, s));
    }

    for (ll i = n - k + 1; i < n; i++) {
        sum -= a[i - (n - k + 1)];
        sum += a[i];

        s[a[i - (n - k + 1)]]++;
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);

        mx = max(mx, ab(sum, s)); 
    }

    for (ll i = k - 1; i < n - 1; i++) {
        sum -= a[i];

        s[a[i]]++;

        mx = max(mx, ab(sum, s)); 
    }

    cout << mx << endl;
}