#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

#define FAST ios::sync_with_stdio(0), cout.tie(0); cin.tie(0);
#define ll int64_t
#define int int64_t
#define endl '\n'

void solve();

int32_t main() {
    FAST;

    int64_t t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}

ll max(ll a, ll b, ll c) {
    return max(a, max(b, c));
}
ll min(ll a, ll b, ll c) {
    return min(a, min(b, c));
}

ll ab(ll sum, multiset<ll> s) {
    if (!s.empty()) return abs(max(sum, *s.begin(), *prev(s.end())) - min(sum, *s.begin(), *prev(s.end())));
    return 0;
}

void solve() {
    ll n, k;
    cin >> n >> k;

    multiset<ll> s;
    vector<ll> a(n);
    for (ll &i : a) {
        cin >> i;

        s.insert(i);
    }

    ll sum = 0;
    for (ll i = 0; i < n - k + 1; i++) {
        sum += a[i];
        s.erase(s.find(a[i]));
    }

    ll mx = ab(sum, s);
    for (ll i = n - k + 1; i < n; i++) {
        sum -= a[i - (n - k + 1)];
        sum += a[i];

        s.insert(a[i - (n - k + 1)]);
        s.erase(s.find(a[i]));

        mx = max(mx, ab(sum, s)); 
    }

    cout << mx << endl;
}