#include<bits/stdc++.h>
using namespace std;

using ll = long long;

ll calc(string s) {
	ll ans = 0;
	for (int i = 1; i < s.size(); ++i) {
		ans += i * 4;
	}
	for (auto d : {2, 3, 5, 7}) {
		int L = 0, R = s.size();
		while (L != R) {
			int M = (L + R) / 2;
			string q(s.size(), '1');
			q[M] = d + '0';
			if (q <= s) R = M;
			else L = M + 1;
		}
		ans += s.size() - R;
	}
	return ans;
}

bool check(string s) {
	int cnt = 0;
	bool ok = true;
	for (auto i : s) {
		if (i == '1') continue;
		cnt++;
		ok &= i == '2' || i == '3' || i == '5' || i == '7';
	}
	return cnt == 1 && ok;
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	string L, R;
	cin >> L >> R;
	cout << calc(R) - calc(L) + check(L);
}