#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	vector<vector<int>> cnt(k + 1);
	for (int i = 0; i < 1 << k; ++i) {
		cnt[__builtin_popcount(i)].push_back(i);
	}
	vector<int> b(n);
	for (auto& i : b) cin >> i;
	vector<map<vector<int>, int>> memo(n);
	auto rec = [&](auto rec, int i, vector<int> c) -> int {
		if (i == n) return 1;
		c.pop_back();
		c.insert(c.begin(), 0);
		int s = accumulate(c.begin(), c.end(), 0);
		int need = b[i] - s;
		if (need > k || need < 0) return 0;
		if (memo[i].count(c)) return memo[i][c];
		int& ret = memo[i][c];
		for (auto msk : cnt[need]) {
			for (int i = 0; i < k; ++i) {
				if (msk >> i & 1) c[i]++;
			}
			ret = add(ret, rec(rec, i + 1, c));
			for (int i = 0; i < k; ++i) {
				if (msk >> i & 1) c[i]--;
			}
		}
		return ret;
	};
	cout << rec(rec, 0, vector<int>(k, 0));
}