#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
vector<int> cnt[8];
int n, k;
int b[200];
int memo[200][40320];

int hsh(vector<int> c) {
	int cur = 1, sum = 0;
	for (int i = 0; i < c.size(); ++i) {
		sum += cur * c[i];
		cur *= (i + 1);
	}
	return sum;
}

int rec(int i, vector<int> c) {
	if (i == n) return 1;
	c.pop_back();
	c.insert(c.begin(), 0);
	int s = accumulate(c.begin(), c.end(), 0);
	int need = b[i] - s;
	if (need > k || need < 0) return 0;
	int h = hsh(c);
	if (memo[i][h] != -1) return memo[i][h];
	int& ret = memo[i][h];
	ret = 0;
	for (auto msk : cnt[need]) {
		for (int i = 0; i < k; ++i) {
			if (msk >> i & 1) c[i]++;
		}
		ret = add(ret, rec(i + 1, c));
		for (int i = 0; i < k; ++i) {
			if (msk >> i & 1) c[i]--;
		}
	}
	return ret;
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	for (int i = 0; i < 200; ++i) {
		for (int j = 0; j < 40320; ++j) {
			memo[i][j] = -1;
		}
	}
	cin >> n >> k;
	for (int i = 0; i < 1 << k; ++i) {
		cnt[__builtin_popcount(i)].push_back(i);
	}
	for (int i = 0; i < n; ++i) cin >> b[i];
	cout << rec(0, vector<int>(k, 0));
}