#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
int inv(int x) {
	return x == 1 ? 1 : sub(0, mul(mod / x, inv(mod % x)));
}

const int N = 3e6;

int fact[N], ifact[N];

int C(int n, int k) {
	if (n < 0 || k < 0 || n < k) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}

int catalan(int n) {
	return sub(C(2 * n, n), C(2 * n, n + 1));
}
int go(pair<int, int> start, pair<int, int> finish) {
	int dx = finish.first - start.first, dy = finish.second - start.second;
	return C(dx + dy, dx);
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	fact[0] = 1;
	for (int i = 1; i < N; ++i) fact[i] = mul(i, fact[i - 1]);

	ifact[N - 1] = inv(fact[N - 1]);
	for (int i = N - 1; i; --i) ifact[i - 1] = mul(i, ifact[i]);

	int n, m, k;
	cin >> n >> m >> k;
	n--, m--;
	vector<pair<int, int>> pts(k);
	for (auto& [x, y] : pts) cin >> x >> y, --x, --y;
	sort(pts.begin(), pts.end());
	vector<vector<int>> dp(pts.size(), vector<int>(pts.size(), 0));
	int t1 = 0, t2 = 0;
	for (int mask = 0; mask < (1 << k); ++mask) {
		pair<int, int> fst = {0, 1}, scd = {0, 0};
		int dp = 1;
		for (int i = 0; i < k; ++i) {
			if (mask >> i & 1) {
				dp = mul(dp, go(fst, pts[i]));
				fst = pts[i];
			} else {
				dp = mul(dp, go(scd, pts[i]));
				scd = pts[i];
			}
		}
		t1 = add(t1, mul(mul(go(fst, {n, m}), go(scd, {n, m - 1})), dp));
		t2 = add(t2, mul(mul(go(fst, {n, m - 1}), go(scd, {n, m})), dp));
	}
	cout << mul(2, sub(t1, t2));
}