#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e9 + 7;

int add(int a, int b) {
	return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
	return a >= b ? a - b : a + mod - b;
}
int mul(int a, int b) {
	return 1ll * a * b % mod;
}
int inv(int x) {
	return x == 1 ? 1 : sub(0, mul(mod / x, inv(mod % x)));
}

const int N = 3e6;

int fact[N], ifact[N];

int C(int n, int k) {
	if (n < 0 || k < 0 || n < k) return 0;
	return mul(fact[n], mul(ifact[k], ifact[n - k]));
}

int catalan(int n) {
	return sub(C(2 * n, n), C(2 * n, n + 1));
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	fact[0] = 1;
	for (int i = 1; i < N; ++i) fact[i] = mul(i, fact[i - 1]);

	ifact[N - 1] = inv(fact[N - 1]);
	for (int i = N - 1; i; --i) ifact[i - 1] = mul(i, ifact[i]);

	int n, m, k;
	cin >> n >> m >> k;
	n--, m--;
	if (k == 0) {
		cout << mul(2, sub(mul(C(n + m - 1, n), C(n + m - 1, n)), mul(C(n + m - 2, n), C(n + m, n))));
		return 0;
	}
}