﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>


using namespace std;

#define int long long

int cnt(string l, string r, int p) {
	int ans = 0;
	int n = l.size();
	vector<int> prefix_l(n + 1, 0);
	vector<int> prefix_r(n + 1, 0);
	prefix_l[0] = 1;
	prefix_r[0] = 1;
	for (int i = 1; i <= n; i++) {
		if (i > 0 && prefix_l[i - 1] == 100) {
			prefix_l[i] = 100;
			continue;
		}
		if (l[i - 1] == '0') {
			prefix_l[i] = 100;
		}
		else if (l[i - 1] == '1') {
			prefix_l[i] = 1;
		}
		else {
			break;
		}
	}
	for (int i = 1; i <= n; i++) {
		if (i > 0 && prefix_r[i - 1] == 100) {
			prefix_r[i] = 100;
			continue;
		}
		if (r[i - 1] == '0') {
			break;
		}
		else if (r[i - 1] == '1') {
			prefix_r[i] = 1;
		}
		else {
			prefix_r[i] = 100;
		}
	}
	vector<int> suf_l(n + 1, -1);
	vector<int> suf_r(n + 1, -1);
	suf_l[0] = 1;
	suf_r[0] = 1;
	for (int i = 1; i <= n; i++) {
		if (l[i - 1] == '0') {
			suf_l[i] = 1;
		}
		else if (l[i - 1] == '1') {
			suf_l[i] = suf_l[i - 1];
		}
		else {
			suf_l[i] = 0;
		}
	}
	for (int i = 1; i <= n; i++) {
		int c = r[i - 1] - '0';
		if (c > 1) {
			suf_r[i] = 1;
		}
		else if (c == 1) {
			suf_r[i] = suf_r[i - 1];
		}
		else {
			suf_r[i] = 0;
		}
	}

	for (int i = 0; i < n; i++) {
		bool canwe = true;
		canwe &= (prefix_l[i] > 0);
		canwe &= (prefix_r[i] > 0);
		if (prefix_l[i] == 1) {
			int c = l[i] - '0';
			if (c > p) {
				canwe = false;
			}
			else if (c == p) {
				canwe &= suf_l[n - i - 1];
			}
		}
		if (prefix_r[i] == 1) {
			int c = r[i] - '0';
			if (c < p) {
				canwe = false;
			}
			else if (c == p) {
				canwe &= suf_r[n - i - 1];
			}
		}
		ans += canwe;
	}
	return ans;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	string l, r;
	cin >> l >> r;



	int pref_l = 0;
	int pref_r = 0;

	for (int i = 0; i < l.size();i++) {
		if (l[i] == '1') {
			pref_l++;
		}
		else {
			break;
		}
	}

	for (int i = 0; i < r.size(); i++) {
		if (r[i] == '1') {
			pref_r++;
		}
		else {
			break;
		}
	}


	vector<int> ps = { 2, 3, 5, 7 };

	int ans = 0;

	for (auto p : ps) {
		for (int len = l.size() + 1; len <= r.size() - 1; len++) {
			ans += len;
		}
		if (l.size() == r.size()) {
			ans += cnt(l, r, p);
			continue;
		}
		string gr = "1";
		for (int i = 0; i < (int)r.size() - 1;i++) {
			gr += '0';
		}

		string gl = "";

		for (int i = 0; i < l.size(); i++) {
			gl += '9';
		}

		ans += cnt(l, gl, p);
		ans += cnt(gr, r, p);
		
	}

	cout << ans << endl;
}

