﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int d, l, r;
	cin >> d >> l >> r;

	set<int> st;

	for (int del = 1; del * del <= d; del++) {
		if (d % del == 0) {
			st.insert(del);
			st.insert(d / del);
		}
	}

	int ans = 0;

	for (auto it: st) {
		int a = min(it, d / it);
		int b = max(it, d / it);
		if (a % 2 != b % 2) {
			continue;
		}
		int x = (a + b) / 2;
		int y = (b - a) / 2;
		ans += ((l <= x * x) && (x * x <= r) && (l <= y * y) && (y * y <= r) && x != y);
	}

	cout << ans / 2 << endl;
	
}

