﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

const int INF = 1e18;


signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, s;
	cin >> n >> s;

	vector<int> curr(s + 1);

	curr[0] = 1;

	vector<vector<pair<int, int>>> prev(n, vector<pair<int, int>>(s + 1, { 0, 0 }));
	vector<vector<int>> a;

	for (int i = 0; i < n; i++) {
		vector<int> nw(s + 1);
		int k;
		cin >> k;
		a.push_back({});
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			a[i].push_back(x);
			for (int cs = s - x; cs >= 0; cs--) {
				if (nw[cs]) {
					nw[cs + x] = 1;
					prev[i][cs + x] = { i, j };
				}
				if (curr[cs]) {
					nw[cs + x] = 1;
					prev[i][cs + x] = { i - 1, j };
				}
			}
		}
		curr = nw;
	}

	/*cerr << "done" << endl;*/

	if (!curr[s]) {
		cout << "No" << endl;
		return 0;
	}

	cout << "Yes" << endl;

	int cw = s;
	int clayer = n - 1;

	vector<vector<int>> ans(n);

	while (cw) {
		auto prv = prev[clayer][cw];
		int ind = prv.second;
		ans[clayer].push_back(ind);
		cw -= a[clayer][ind];
		clayer = prv.first;
	}

	for (auto it: ans) {
		cout << it.size() << endl;
		for (auto tt: it) {
			cout << tt + 1 << " ";
		}
		cout << endl;
	}

}

