#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

typedef tree<int, int, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve() {
    int n;
    cin >> n;
    vector <ll> h(n);
    ordered_set s;
    vector <ll> l(n);
    vector <ll> r(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        s.insert({i, i + 1}); // [l..r)
        l[i] = h[i];
        r[i] = h[i];
    }
    for (int t = 0; t < n - 1; t++) {
        int k;
        cin >> k;
        k--;
        auto p1 = s.find_by_order(k);
        auto p2 = s.find_by_order(k + 1);
        int L1 = p1 -> first;
        int R1 = p1 -> second;
        int L2 = p2 -> first;
        int R2 = p2 -> second;
        s.erase(p1);
        s.erase(p2);
        s.insert({L1, R2});
        ll mxL = 0, mxR = 0;
        for (int i = L1; i < R1; i++) {
            mxL = max(mxL, h[i]);
        }
        for (int i = L2; i < R2; i++) {
            mxR = max(mxR, h[i]);
        }
        for (int i = L1; i < R1; i++) {
            r[i] = max(r[i], mxR);
        }
        for (int i = L2; i < R2; i++) {
            l[i] = max(l[i], mxL);
        }
        int ans = 0;
        for (int i = L1; i < R2; i++) {
            ans += min(l[i], r[i]) - h[i];
        }
        cout << ans << "\n";
    }
}

const ll MOD = 1e9+7;
ll add(ll a, ll b) {
    return a + b - (a + b >= MOD);
}
ll mul(ll a, ll b) {
    return (a * b) % MOD;
}
void solve2() {
    int n, k;
    cin >> n >> k;
    vector <int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector <vector <int>> dp(n, vector <int> (1 << (k * (k + 1) / 2), 0));
    if (n < k || k >= 5) {
        ll ans = 0;
        for (int mask = 0; mask < (1 << (n * k)); mask++) {
            //cout << mask << "\n";
            bool f = true;
            for (int i = 0; i < n; i++) {
                int cnt = 0;
                for (int j = i; j >= 0; j--) {
                    for (int t = j * k; t <= j * k + j; t++) {
                        if (((mask >> t) & 1) == 1) {
                            cnt++;
                        }
                    }
                }
                //cout << cnt << " ";
                if (cnt != b[i]) {
                    f = false;
                    break;
                }
            }
            if (f) ans = add(ans, 1);
            //cout << "\n";
        }
        cout << ans;
    }
    else {
        for (int mask = 1; mask < (1 << (k * k)); mask++) {
            //cout << mask << "\n";
            bool f = true;
            int bit = 0, mask_ = 0;
            for (int i = 0; i < k; i++) {
                int cnt = 0;
                for (int j = i; j >= 0; j--) {
                    for (int t = j * k; t < j * k + k - (i - j); t++) {
                        if (((mask >> t) & 1) == 1) {
                            cnt++;
                            if (i == k - 1) {
                                mask_ |= (1 << bit);
                            }
                        }
                        if (i == k - 1) {
                            bit++;
                        }
                    }
                }
                //cout << cnt << " ";
                if (cnt != b[i]) {
                    f = false;
                }
            }
            if (f) {
                //cout << mask_;
                dp[k - 1][mask_] = add(dp[k - 1][mask_], 1);
            }
            //cout << "\n";
        }
        /*for (int i = 0; i < n; i++) {
            for (int mask = 0; mask < (1 << (k * (k + 1) / 2)); mask++) {
                cout << i << " " << mask << " : " << dp[i][mask] << "\n";
            }
        }*/
        vector <int> toAdd(k);
        toAdd[0] = k - 1;
        for (int i = 1; i < k; i++) {
            toAdd[i] = toAdd[i - 1] + (k - i);
        }
        int mask_, p, ind, mask2;
        for (int i = k; i < n; i++) {
            for (int mask = 0; mask < (1 << (k * (k + 1) / 2)); mask++) {
                if (__builtin_popcount(mask) != b[i]) continue;
                mask_ = 0;
                p = 0;
                ind = 0;
                for (int b = k; b < k * (k + 1) / 2; b++) {
                    //cout << b;
                    if (ind == toAdd[p]) {
                        ind++;
                        p++;
                    }
                    if ((mask >> b) & 1) {
                        mask_ |= (1 << ind);
                    }
                    ind++;
                }
                mask2 = mask_;
                for (int added_mask = 0; added_mask < (1 << k); added_mask++) {
                    mask2 = mask_;
                    for (int t = 0; t < k; t++) {
                        if (((added_mask >> t) & 1) == 1) {
                            mask2 |= (1 << toAdd[t]);
                        }
                    }
                    dp[i][mask] = add(dp[i][mask], dp[i - 1][mask2]);
                }
            }
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << (k * (k + 1) / 2)); mask++) {
            ans = add(ans, dp[n - 1][mask]);
        }
        cout << ans;
    }
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve2();
    return 0;
}
/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
