#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define int long long

using namespace std;
using ll = long long;
using ld = long double;

ll sum(int l, int r, vector <ll> &pref) {
    return pref[r] - pref[l];
}
int f(int l, int m, int r, ll s, vector <ll> &pref) {
    ll s2 = sum(l, m, pref);
    ll s3 = sum(m, r, pref);
    return max(s, max(s2, s3)) - min(s, min(s2, s3));
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector <ll> a(n);
    vector <ll> prefS(n + 1);
    vector <ll> prefM(n + 1);
    vector <ll> sufM(n + 1);
    prefS[0] = 0;
    prefM[0] = 1e9+10;
    sufM[n] = 1e9+10;
    ll S = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        S += a[i];
        prefS[i + 1] = prefS[i] + a[i];
        prefM[i + 1] = min(prefM[i], a[i]);
    }
    for (int i = n - 1; i >= 0; i--) {
        sufM[i] = min(sufM[i + 1], a[i]);
    }
    if (k == 1) {
        cout << 0;
        return;
    }
    if (k == 2) {
        ll ans = 0;
        for (int i = 0; i < n - 1; i++) {
            ans = max(ans, abs(prefS[i + 1] - (S - prefS[i + 1])));
        }
        cout << ans;
        return;
    }
    if (k == 3) {
        ll ans = 0;
        for (int L = 1; L < n; L++) {
           // cout << L << " ";
            ll s = prefS[L];
            int l = L;
            int r = n + 1;
            int cnt = 0;
            while (r - l > 10 && cnt < 100) {
                int m1 = (r + l) / 3;
                int m2 = 2 * (r + l) / 3;
                if (f(L + 1, m1, n, s, prefS) <= f(L, m2, n, s, prefS)) {
                    l = m1;
                }
                else {
                    r = m2;
                }
                cnt++;
            }
            for (int L_ = max(l - 20, L + 1); L_ < min(r + 20, n); L_++) {
                ans = max(ans, max(s, max(sum(L, L_, prefS), sum(L_, n, prefS))) - min(s, min(sum(L, L_, prefS), sum(L_, n, prefS))));
            }
        }
        cout << ans;
        return;
    }
    ll ans = 0;
    for (int len = 1; len <= (n - k + 1); len++) {
        ll sum = 0;
        for (int i = 0; i < len; i++) {
            sum += a[i];
        }
        ans = max(ans, sum - min(prefM[0], sufM[len]));
        for (int i = 0; i < n - len; i++) {
            sum += a[i + len];
            sum -= a[i];
            ans = max(ans, sum - min(prefM[i + 1], sufM[i + len + 1]));
         }
    }
    cout << ans;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}

/*
4 2
2 1 3 4

5 4
2 1 3 4 1
*/
