#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;

void solve()
{
    int n, s;
    cin >> n >> s;
    vector <int> k(n);
    vector <vector <int>> a(n);

    int x;
    for (int i=0; i<n; i++)
    {
        cin >> k[i];
        for (int j=0; j<k[i]; j++)
        {
            cin >> x;
            a[i].push_back(x);
        }
    }

    vector <vector <int>> dp(n+1, vector <int>(s+1));
    dp[0][0] = 1;

    for (int i=0; i<n; i++)
    {
        for (int j=0; j<k[i]; j++)
        {
            for (int w=s-a[i][j]; w>=0; w--)
            {
                if(dp[i][w])
                {
                   dp[i+1][w+a[i][j]] = j+1;
                }
            }
        }
    }

    if (!dp[n][s])
    {
        cout << "No";
        return;
    }

    vector <vector <int>> ans(n);

    int w = s;
    for (int i=n; i>=1; i--)
    {
        while (!dp[i-1][w-a[i-1][dp[i][w]-1]])
        {
            ans[i-1].push_back(dp[i][w]-1);
            w -= a[i-1][dp[i][w]-1];
            if (w == 0)
            {
                break;
            }
        }
        ans[i-1].push_back(dp[i][w]-1);
        w -= a[i-1][dp[i][w]-1];
    }

    cout << "Yes\n";
    for (auto i : ans)
    {
        cout << i.size() << '\n';
        for (auto j : i) cout << j+1 << ' ';
        cout << '\n';
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << endl;
    }
}
