#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 123;
const int mod = 1e9 + 7;

int poww(int a, int n, int mod)
{
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n%2 == 0)
    {
        int x = poww(a, n/2, mod);
        return (x*x) % mod;
    }
    return (poww(a, n-1, mod) * a) % mod;
}

void solve()
{
    int n, m, k;
    cin >> n >> m >> k;

    vector <pair <int, int>> p(k);

    int x, y;
    for (int i=0; i<k; i++)
    {
        cin >> x >> y;
        p[i] = {x, y};
    }

    vector <int> fact(n+m);
    fact[0] = 1;

    for (int i=1; i<n+m; i++)
    {
        fact[i] = (fact[i-1] * i) % mod;
    }

    int ans = (fact[n+m-3]*fact[n+m-3]) % mod;
    int zn = (((((fact[n-2]*fact[m-1])%mod)*((fact[m-2]*fact[n-1])%mod))%mod)*(n+m-3))%mod;
    ans *= poww(zn, mod-2, mod); ans %= mod;

    cout << ans;

    return;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;

    for (int i=0; i<tests; i++)
    {
        solve();
        cout << endl;
    }
}
