#include <cstdint>
#include <iostream>
#include <vector>
#include <cassert>
#include <cstring>

using namespace std;

uint64_t sol1(size_t n,uint64_t *sums,uint64_t sx,uint64_t mx,uint64_t mn){
	return max(sums[n-1]-sx,mx)-min(sums[n-1]-sx,mn);
}
uint64_t sol2(size_t n,uint64_t* a,uint64_t *sums,uint64_t sx,uint64_t mx,uint64_t mn){
	return max(max(sums[n-1]-sx-a[0],mx)-min((a[0]),mn), max(sums[n-2]-sx,mx)-min(a[n-1],mn));
}

uint64_t sol_m(uint32_t k,uint32_t n,uint64_t* a,uint64_t* sums,uint64_t sx,uint64_t mxg,uint64_t mng){
	// if (k==1)
	// 	return sol1(sums,sx,mxg,mng);
	if (k==2)
		return sol2(n, a,sums,sx,mxg,mng);
	uint64_t df=0;
	for (uint32_t i=1;i<n-k+2;i++){
		const uint64_t mx=sums[i-1]-sx;
		const uint64_t mn=sums[i-1]-sx;
		const uint64_t dq=sol_m(k-1,n-i,&a[i],&sums[i],sums[i-1],max(mxg,mx),min(mng,mn));
		if (dq>df)
			df=dq;
	}
	return df;
}
uint64_t sol_m0(uint32_t k,uint32_t n,uint64_t* a,uint64_t* sums){
	return sol_m(k,n,a,sums,0,0,sums[n-1]);
}

extern "C" uint64_t sol(uint32_t k,uint32_t n,uint64_t* a){
	uint64_t* sums = new uint64_t[n];
	uint64_t s=0;
	for(uint32_t i=0; i<n;i++){
		s+=a[i];
		sums[i]=s;
	}
	if (k==2)
		return max(sums[n-1]-2*sums[0], sums[n-2]-a[n-1]);
	const uint64_t d = sol_m0(k,n,a,sums);
	free(sums);
	return d;
}

int main(){
	uint32_t n,k;
	std::cin >> n >> k;
	assert(k<=n);
	uint64_t *a = new uint64_t[n];
	memset(a,0,n*sizeof(*a));
	for(uint64_t i=0; i<n;i++){
		std::cin >> a[i];
	}
	uint64_t d=sol(k,n,a);
	std::cout << d << std::endl;
	return 0;
}
