import math

n = int(input())
h = [int(i) for i in input().split()]
k_arr = [int(i) for i in input().split()]

d = int(math.ceil(math.log2(n)))
tree = []

arr0 = [-10 ** 8] * (2 ** d)
for k in range(n):
    arr0[k] = h[k]
    
tree.append(arr0)

for i in range(d - 1, -1, -1):
    m = 2 ** i
    arr = [-10 ** 8] * m
    for k in range(m):
        arr[k] = max(tree[-1][2 * k], tree[-1][2 * k + 1])
    tree.append(arr)


def upper_power(n):
    v = 1
    while v < n:
        v *= 2
    return v

def level(n):
    d = 0
    while n > 0 and n % 2 == 0:
        n //= 2
        d += 1
    return d, n

def getmax(l, r):

    v = -10**8

    while l < r:
        d_max, k = level(l)
        d = 0
        span = 1

        while d < d_max and l + span * 2 < r:
            span *= 2
            d += 1
            
        k *= 2 ** (d_max - d)
        v = max(v, tree[d][k])
        l += span
        
    return v


segments = [
    (i, i + 1) for i in range(n)
]

for ki in k_arr:
    s1 = segments[ki - 1]
    s2 = segments[ki]
    s3 = (s1[0], s2[1])
    segments[ki - 1] = s3
    segments.pop(ki)
    
    v = 0
    for i in range(s3[0], s3[1]):
        ml = getmax(s3[0], i + 1)
        mr = getmax(i, s3[1])
        #print(i, ml, mr, h[i])
        v += min(ml, mr) - h[i]
    
    print(v)        



"""
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
"""