d, l, r = map(int, input().split())

def decompose(n):
    primes = []
    counts = []
    i = 2
    while n > 1:
        j = 0
        while n % i == 0:
            j += 1
            n //= i
        if j > 0:
            primes.append(i)
            counts.append(j)
        i += 1
    return primes, counts

primes, counts = decompose(d)

def rec(i, a, b):
    if i == len(primes):
        if a >= b or (a + b) % 2 != (b - a) % 2:
            return 0
        x = (a + b) // 2
        y = (b - a) // 2
        if l <= y ** 2 < x ** 2 <= r:
            return 1
        return 0
    
    s = 0
    for j in range(counts[i] + 1):
        s += rec(i + 1, a * primes[i] ** j, b * primes[i] ** (counts[i] - j))

    return s

print(rec(0, 1, 1))