import math

d, l, r = map(int, input().split())


def is_square(n):
    l = 1
    r = n
    while r - l > 1:
        m = (l + r) // 2
        w = m * m
        if w <= n:
            l = m
        else:
            r = m 
        
    return l * l == n

def naive():
    if r < d:
        return 0
    
    minb = math.ceil(math.sqrt(l))
    maxb = math.floor(math.sqrt(r - d))
    
    c = 0
    
    for y in range(minb, maxb + 1):
        t = y ** 2 + d
        if is_square(t):
            c += 1
    
    return c

print(naive())