n, m, k = map(int, input().split())
xy = [tuple(int(i) for i in input().split()) for _ in range(k)]

# s -> e: + +
# e -> s - - 

def rec(i, j, phase, visited):
    if i == 1 and j == 1 and phase == 1:
        for xi, yi in xy:
            if not visited[xi][yi]:
                return 0
        else:
            return 1
    elif i == n and j == m and phase == 0:
        return rec(i, j, 1, visited)

    c = 0
    delta_i = 1 if phase == 0 else -1
    delta_j = 1 if phase == 0 else -1
    
    if 1 <= i + delta_i <= n and not visited[i + delta_i][j]:
        visited[i + delta_i][j] = 1
        c += rec(i + delta_i, j, phase, visited)
        visited[i + delta_i][j] = 0
    
    if 1 <= j + delta_j <= m and not visited[i][j + delta_j]:
        visited[i][j + delta_j] = 1
        c += rec(i, j + delta_j, phase, visited)
        visited[i][j + delta_j] = 0

    return c


visited = [
    [0] * (m + 1) for i in range(n + 1)
]

print(rec(1, 1, 0, visited) % (10 ** 9 + 7))
