n, m, k = map(int, input().split())
xy = [tuple(int(i) for i in input().split()) for _ in range(k)]

# s -> e: + +
# e -> s - - 

def rec(i, j, phase, visited):
    if i == 1 and j == 1 and phase == 1:
        for xi, yi in xy:
            if not visited[xi][yi]:
                return 0
        else:
            return 1
    elif i == n and j == m and phase == 0:
        return rec(i, j, 1, visited)

    c = 0
    delta = 1 if phase == 0 else -1
    
    if 1 <= i + delta <= n and not visited[i + delta][j]:
        visited[i + delta][j] = 1
        c += rec(i + delta, j, phase, visited)
        visited[i + delta][j] = 0
    
    if 1 <= j + delta <= m and not visited[i][j + delta]:
        visited[i][j + delta] = 1
        c += rec(i, j + delta, phase, visited)
        visited[i][j + delta] = 0

    return c

if k == 0:
    def rec(i, j, phase):
        if i == 1 and j == 1 and phase == 1:
            return 1
        elif i == n and j == m and phase == 0:
            return rec(i, j, 1)

        c = 0
        delta = 1 if phase == 0 else -1
        
        if 1 <= i + delta <= n:
            c += rec(i + delta, j, phase, visited)
        
        if 1 <= j + delta <= m:
            c += rec(i, j + delta, phase, visited)

        return c
    print(rec(1, 1, 0) % (10 ** 9 + 7))
    exit()


visited = [
    [0] * (m + 1) for i in range(n + 1)
]

print(rec(1, 1, 0, visited) % (10 ** 9 + 7))
