#include<bits/stdc++.h>

using namespace std;

#define int long long 

vector<int> v;
int n, k;

struct seg{
    vector<int> t, tr ;
    seg(vector<int> & a){
        tr = a;
        t.resize(a.size()*2-1);
        build(0, 0, a.size() );
    }
    void build(int v, int l, int r){
        if(r - l == 1){
            t[v]=tr[l];
            return;
        }
        int m = l+r >> 1;
        build(v+1, l, m);
        build(v+2*(m-l), m, r);
        t[v] = min(t[v+2*(m-l)], t[v+1]);
    }
    int get_min(int v, int l, int r, int ql, int qr){
        if(qr <= l || r <= ql){
            return INT_MAX;}
        if(ql <= l && r <= qr){
            return t[v];}
        int m = l+r>>1;
        return min(get_min(v+1, l, m, ql, qr), get_min(v+2*(m-l), m, r, ql, qr));
    }
};

signed main(){
    int max_e = INT_MIN;
    cin >> n >> k;
    v.resize(n);

    for(int & i: v){
        cin >> i;
        max_e = max(max_e, i);
    }
    vector<int> p_sum(n+1);
    for(int i = 1; i < n+1; i++){
        p_sum[i]=p_sum[i-1]+v[i-1];
    }
    
    seg tree(v);
    int ans = INT_MIN;
    int c_min = INT_MAX, real_min = INT_MAX;
    k = n - k + 1;
    //cout << k << endl;
    for(int i = 0; i <= n - k; i++){
        if(i!=0) c_min = min(c_min, v[i-1]);
        //cout << i <<": ";
        int s = p_sum[i+k] - p_sum[i];
        real_min = min(c_min, tree.get_min(0,0, n, i+k, n));
        //cout << s <<" "<<c_min<< " "<<real_min<<" "<< s - real_min<<endl;
        ans = max(ans, s - real_min);
    }
    cout << ans;
}