#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

const int N = 100100;
ll pref[N];
int h[N];

ll get_sum(int l, int r) {
    return pref[r + 1] - pref[l];
}

struct node {
    ll ans;
    deque<pair<int, int>> stl, str;
};

node nd[N];

void merge(node &a, node &b) {
    int lev = min(a.str[0].x, b.stl[0].x);
    ll nwans = a.ans + b.ans;
    while (true) {
        // cout << a.str.size() << ' ' << b.stl.size() << '\n';
        if (a.str[0].x > b.stl[0].x) {
            if (b.stl.size() == 1) {
                break;
            }
            b.stl.pop_front();
            int nwlev = min(a.str[0].x, b.stl[0].x);
            nwans += 1ll * (nwlev - lev) * (b.stl[0].y - a.str[0].y - 1);
            lev = nwlev;
        } else {
            if (a.str.size() == 1) {
                break;
            }
            a.str.pop_front();
            int nwlev = min(a.str[0].x, b.stl[0].x);
            nwans += 1ll * (nwlev - lev) * (b.stl[0].y - a.str[0].y - 1);
            lev = nwlev;
        }
    }
    a.ans = nwans;
    if (a.str.back() > b.stl.back()) {
        if (a.str.size() < b.str.size()) {
            swap(a.str, b.str);
            for (int i = 0; i < b.str.size(); i++) {
                a.str.push_back(b.str[i]);
            }
        } else {
            for (int i = b.str.size() - 1; i >= 0; i--) {
                a.str.push_front(b.str[i]);
            }
        }
    } else {
        swap(a.str, b.str);
        if (a.stl.size() < b.stl.size()) {
            swap(a.stl, b.stl);
            for (int i = b.stl.size() - 1; i >= 0; i--) {
                a.stl.push_front(b.stl[i]);
            }
        } else {
            for (int i = 0; i < b.stl.size(); i++) {
                a.stl.push_back(b.stl[i]);
            }
        }
    }
}

int32_t main() {
    int n;
    cin >> n;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
        nd[i].ans = 0;
        nd[i].str.emplace_back(h[i], i);
        nd[i].stl.emplace_back(h[i], i);
    }
    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);
    for (int _ = 0; _ < n - 1; _++) {
        int hh;
        cin >> hh; hh--;
        int i = ind[hh];
        int j = ind[hh + 1];
        ind.erase(ind.begin() + hh + 1);
        merge(nd[i], nd[j]);
        cout << nd[i].ans << '\n';
    }
}