﻿#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vi vector<int>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>

int sum(vi::iterator beg, vi :: iterator en) {
	int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
	return ans;
}

vi solve(int n, vi a, vi kk) {
	vi ans;
	vi seg(n); for (int i = 0; i < n; i++) seg[i] = i;
	vi pr(n + 1);
	vi suf(n + 1);
	vi val(n);
	for (int k : kk) {
		int l1 = lower_bound(all(seg), k) - seg.begin();
		int r1 = upper_bound(all(seg), k) - seg.begin() - 1;
		int l2 = lower_bound(all(seg), k + 1) - seg.begin();
		int r2 = upper_bound(all(seg), k + 1) - seg.begin() - 1;
		for (int i = l2; i < n; i++) seg[i]--; 
		pr[l1] = 0;
		for (int i = l1; i <= r2; i++) {
			pr[i + 1] = max(pr[i], a[i]);
		}
		suf[r2 + 1] = 0;
		for (int i = r2; i >= l1; i--) {
			suf[i] = max(suf[i + 1], a[i]);
		}
		for (int i = l1; i <= r2; i++) {
			val[i] = min(suf[i], pr[i + 1]) - a[i];
		}
		ans.push_back(sum(val.begin() + l1, val.begin() + r2));
	}
	return ans;
}

signed main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vi a(n); for (auto& e : a) cin >> e;
	vi k(n - 1); for (auto& e : k) cin >> e, e--;
	vi ans = solve(n, a, k);
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << '\n';
	}
}
