#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vi vector<int>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)

const int inf = 1e16 + 50;

int sum(vi::iterator beg, vi::iterator en) {
    int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
    return ans;
}

void print(vi a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

int solve(int n, int k, vi a) {
    vi p(n + 1);
    for (int i = 0; i < n; i++) p[i + 1] = p[i] + a[i];
    multiset<int> ms;
    for (int i = k; i < n; i++) ms.insert(a[i]);
    int ans = -inf;
    for (int i = k - 1; i < n; i++) {
        int bg = (i - k + 1);
        imax(ans, p[i + 1] - p[bg] - *ms.begin());
        if(k != 2)imax(ans, p[i] - p[bg] - a[i]);
        if(k != 2)imax(ans, p[i + 1] - p[bg + 1] - a[i]);
        //cout << p[i + 1] - p[bg] - *ms.begin() << ' ' << i << '\n';
        ms.insert(a[bg]);
        if(i != n - 1) ms.erase(ms.find(a[i + 1]));
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, k; cin >> n >> k;
    vi a(n); for (auto& e : a) cin >> e;
    cout << solve(n, n - k + 1, a) << '\n';
}
