#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vi vector<int>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)

const int inf = 1e16 + 50;

int sum(vi::iterator beg, vi::iterator en) {
    int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
    return ans;
}

void print(vi a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}

int stupid(int n, int k, vi a) {
    vi p(n + 1);
    for (int i = 0; i < n; i++) p[i + 1] = p[i] + a[i];
    multiset<int> ms;
    for (int i = k; i < n; i++) ms.insert(a[i]);
    int ans = -inf;
    for (int i = k - 1; i < n; i++) {
        int bg = (i - k + 1);
        imax(ans, p[i + 1] - p[bg] - *ms.begin());
        //cout << p[i + 1] - p[bg] - *ms.begin() << ' ' << i << '\n';
        ms.insert(a[bg]);
        if(i != n - 1) ms.erase(ms.find(a[i + 1]));
    }
    return ans;
}
const int N = 19;
#ifdef _MSC_VER
#define __lg log2
#endif

int solve(int n, int k, vi a) {
    vi p(n + 1);
    for(int i = 0; i < n; i++) p[i + 1] = p[i] + a[i];
    int ans = -inf;
    int len = n - k + 1;
    vi seg(n);
    for(int i = 0; i < n; i++) if(i + len - 1 < n) {
        seg[i] = p[i + len] - p[i];
    }
    vec<vi> jump(N, vi(n)); for (int i = 0; i < n; i++) jump[0][i] = seg[i];
    for (int j = 1; j < N; j++) {
        for (int i = 0; i < n; i++) if(i + (1ll << (j - 1)) < n){
            jump[j][i] = max(jump[j - 1][i], jump[j - 1][i + (1ll << (j - 1))]);
        }
    }
    auto get_max = [&](int l, int r) {
        int t = __lg(r - l + 1);
        return max(jump[t][l], jump[t][r - (1ll << t) + 1]);
    };
    for(int i = 0; i < n; i++) {
        int cntPrev = i;
        int cntNxt = n - i - 1;
       // cout << i << ' ';
        if(cntNxt >= k - 2) {
            imax(ans, p[i] - a[i]);

        } else {
            //n - k + 1
            //0 ... i - len
            imax(ans, get_max(0, i - len) - a[i]);
        }
        if(cntPrev >= k - 2) {
            imax(ans, p[n] - p[i + 1] - a[i]);
        } else {
            //i + 1 ... n - len
            imax(ans, get_max(i + 1, n - len) - a[i]);
        }
       // cout << ans << endl;
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, k; cin >> n >> k;
    vi a(n); for (auto& e : a) cin >> e;
    if(k == 2) cout << stupid(n, n - k + 1, a) << '\n';
    else cout << solve(n, k, a) << '\n';
}
