#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define int long long
#define vec vector
#define vb vec<bool>
#define vi vector<int>
#define vvi vec<vi>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)

const int inf = 1e16 + 50;

int sum(vi::iterator beg, vi::iterator en) {
    int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
    return ans;
}

void print(vi a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
const int N = 1e5 + 5;
#ifdef _MSC_VER
#define __lg log2
#endif

template<typename T>
void print(vec<T> a) {
    for(int i = 0; i < a.size(); i++) {
        cout << a[i] << ' ';
    }
    cout << '\n';
}

void solve(int n, int S, vi lens, vvi a) {
    vb poss(S + 1);
    poss[0] = 1;
    vvi goTo(n, vi(S + 1, -1));
    vec<vi> curr(n, vi(S + 1));
    for(int i = 0; i < n; i++) {
        vb now_poss(S + 1);
        vb cur_poss(S + 1);
        cur_poss[0] = 1;
        vi curgoTo(S + 1);
        for(int j = 0; j < lens[i]; j++ ) {
            vb copy = cur_poss;
            for(int k = 0; k + a[i][j] <= S; k++) {
                if(copy[k] && !copy[k + a[i][j]]) cur_poss[k + a[i][j]] = 1, curgoTo[k + a[i][j]] = j;
            }
        }
        curr[i] = curgoTo;
       // print(cur_poss);
        cur_poss[0] = 0;
        for(int k = 0; k <= S; k++) if(cur_poss[k]) {
            for(int j = 0; j + k <= S; j++) {
                if(poss[j]) now_poss[j + k] = 1, goTo[i][j + k] = k;
            }
        }
        poss = now_poss;
       // print(goTo[i]);
       // print(poss);
    }
    if(poss[S]) {
        auto go = [&](int i, int val) {
            vi ans;
            while(val != 0) {
                ans.push_back(curr[i][val] + 1);
                val -= a[i][curr[i][val]];
            }
            return ans;
        };
        cout << "Yes\n";
        vvi ans(n);
        int val = S;
        for(int i = n - 1; i >= 0; i--) {
            vi now = go(i, goTo[i][val]);
            ans[i] = now;
            val -= goTo[i][val];
        }
        for(int i = 0; i < n; i++) {
            cout << ans[i].size() << '\n';
            assert(ans[i].size());
            for(int j : ans[i]) cout << j << ' ';
            cout << '\n';
        }

    } else {
        cout << "No";
    }
}

void

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, s; cin >> n >> s;
    vi lens(n); for(auto& e : lens) cin >> e;
    vvi a(n); for(int i = 0; i < n; i++) for(int j = 0; j < lens[i]; j++) {int x; cin >> x; a[i].push_back(x);}
    solve(n, s, lens, a);

}
