#ifdef _MSC_VER
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cassert>
#else
#include <bits/stdc++.h>
#endif
using namespace std;
#define all(v) v.begin(),v.end()
#define str string
#define int long long
#define vec vector
#define vb vec<bool>
#define vi vector<int>
#define vvi vec<vi>
#define vpi vec<pair<int, int>>
#define make_pair mkp
#define pii pair<int, int>
#define imax(a, b) a=max(a, b)

const int inf = 1e16 + 50;

int sum(vi::iterator beg, vi::iterator en) {
    int ans = 0; for (auto i = beg; i <= en; i++) ans += *i;
    return ans;
}

void print(vi a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
const int N = 1e5 + 5;
#ifdef _MSC_VER
#define __lg log2
#endif

template<typename T>
void print(vec<T> a) {
    for (int i = 0; i < a.size(); i++) {
        cout << a[i] << ' ';
    }
    cout << '\n';
}
str toBin(int n) {
    str ans = "";
    while(n != 0) {
        if(n & 1) ans += "1";
        else ans += "0";
        n /= 2;
    }
    reverse(all(ans));
    return ans;
}
#pragma GCC("Ofast")
#ifdef _MSC_VER
int __builtin_popcount(int mask) {
    int cc = 0;
    for (int i = 0; i < 35; i++) if (mask & (1ll << i)) cc++;
    return cc;
}
#endif
int solve(int n, int m, int k, vpi poss) {
    int ans = 0;
    vi good_masks;
    for (int mask = 0; mask < (1ll << (n + m - 2)); mask++) {
        if (__builtin_popcount(mask) == n - 1) {
            good_masks.push_back(mask);
        }
    }
   // cout << good_masks.size() << endl;
    for (int mask : good_masks) {
        vec<vb> prev_used(n, vb(m));
        int x = 0, y = 0;
        for (int _ = 0; _ < n + m - 2; _++) {
            if (mask & (1ll << _)) x++;
            else y++;
            prev_used[x][y] = 1;
        }
        for (int ma : good_masks) {
            auto used = prev_used;
            x = n - 1, y = m - 1;
            bool flg = 1;
            for (int _ = 0; _ < n + m - 2; _++) {
                if (ma & (1ll << _)) {
                    x--;
                }
                else y--;
                if (used[x][y]) {
                    flg = 0;
                    break;
                }
                used[x][y] = 1;
            }
            if (!flg) continue;
            for (int c = 0; c < k; c++) {
                if (!used[poss[c].first - 1][poss[c].second - 1]) {
                    flg = 0;
                    break;
                }
            }
            if (flg){
              //  cout << toBin(mask) << ' ' << toBin(ma) << '\n';
                ans++;
            }
        }
    }
    return ans;
}




signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    int k; cin >> k;
    vpi dst(k); for (auto& e : dst) cin >> e.first >> e.second;
    cout << solve(n, m, k, dst);
    return 0;
}
