#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (k == 1) {
        cout << 1;
        return;
    }
    if (k == 2) {
        vector<vector<int>> dp(n, vector<int>(4, 0));
        if (a[0] == 0) {
            dp[0][0] = 1;
        } else if (a[0] == 1) {
            dp[0][1] = 1;
            dp[0][2] = 1;
        } else if (a[0] == 2) {
            dp[0][3] = 1;
        }
        for (int i = 1; i < n; i++) {
            if (a[i] == 0) {
                dp[i][0] = (dp[i - 1][0] + dp[i - 1][2]) % mod;
            } else if (a[i] == 1) {
                dp[i][0] = (dp[i - 1][1] + dp[i - 1][3]) % mod;
                dp[i][1] = (dp[i - 1][0] + dp[i - 1][2]) % mod;
                dp[i][2] = (dp[i - 1][0] + dp[i - 1][2]) % mod;
            } else if (a[i] == 2) {
                dp[i][1] = (dp[i - 1][1] + dp[i - 1][3]) % mod;
                dp[i][2] = (dp[i - 1][1] + dp[i - 1][3]) % mod;
                dp[i][3] = (dp[i - 1][0] + dp[i - 1][2]) % mod;
            } else if (a[i] == 3) {
                dp[i][3] = (dp[i - 1][1] + dp[i - 1][3]) % mod;
            }
        }
        cout << (dp[n - 1][0] + dp[n - 1][1] + dp[n - 1][2] + dp[n - 1][3]) % mod;
        return;
    }
    if (n * k <= 25) {
        int ans = 0;
        for (int i = 0; i < (1 << n * k); i++) {
            vector<vector<int>> t(k, vector<int>(n, 0));
            for (int j = 0; j < n * k; j++) {
                if ((i >> j) & 1) {
                    t[j / n][j % n] = 1;
                }
            }
            bool ok = true;
            for (int p = 0; p < n; p++) {
                int c = k, curr = 0;
                for (int j = p; j >= 0; j--) {
                    if (c == 0) {
                        break;
                    }
                    for (int q = 0; q < c; q++) {
                        curr += t[q][j];
                    }
                    c--;
                }
                if (curr != a[p]) {
                    ok = false;
                    break;
                }
            }
            ans += ok;
        }
        cout << ans;
    }
}

signed main() {
    cin.tie(0); cout.tie(0);
    freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}