#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    k = n - k + 1;
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    int mn = *min_element(a.begin() + 1, a.end());
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != mn) {
            continue;
        }
        int r1 = i - 1, l1 = max(1ll, r1 - k + 1);
        int s1 = pref[r1] - pref[l1 - 1];
        ans = max(ans, s1 - mn);

        int l2 = i + 1, r2 = min(n, l2 + k - 1);
        int s2 = pref[r2] - pref[l2 - 1];
        ans = max(ans, s2 - mn);
    }
    cout << ans;
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}