#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int n, m, k, ans = 0;

void goUp(int x, int y, vector<vector<int>>& a, int cnt) {
    if (x == 0 && y == 0) {
        ans += (cnt == k);
        return;
    }
    a[x][y]++;
    if (x > 0 && (a[x - 1][y] == 0 || a[x - 1][y] == 2)) {
        goUp(x - 1, y, a, cnt + (a[x - 1][y] == 2));
    }
    if (y > 0 && (a[x][y - 1] == 0 || a[x][y - 1] == 2)) {
        goUp(x, y - 1, a, cnt + (a[x][y - 1] == 2));
    }
    a[x][y]--;
}

void goDown(int x, int y, vector<vector<int>>& a, int cnt) {
    if (x == n - 1 && y == m - 1) {
        a[0][0] = 0;
        goUp(n - 1, m - 1, a, cnt);
        return;
    }
    a[x][y]++;
    if (x < n - 1) {
        goDown(x + 1, y, a, cnt + (a[x + 1][y] == 2));
    }
    if (y < m - 1) {
        goDown(x, y + 1, a, cnt + (a[x][y + 1] == 2));
    }
    a[x][y]--;
}

void solve() {
    cin >> n >> m >> k;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < k; i++) {
        int x, y; cin >> x >> y; x--; y--;
        a[x][y] = 2;
    }
    goDown(0, 0, a, 0);
    cout << ans;
}

signed main() {
    cin.tie(0); cout.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
    solve();
}