﻿#include <iostream>
#include <vector>
#include <cmath>
#include <string>

using namespace std;

#define int long long

struct tr {
	int lans, rans, hmax, posl, posr;
};

vector <int> t;
vector <tr> tree;

void update(int v, int l, int r, int pos, int val) {
	if (r - l == 1) {
		t[v] = val;
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) {
		update(2 * v + 1, l, m, pos, val);
	}
	else {
		update(2 * v + 2, m, r, pos, val);
	}
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}

int get(int v, int l, int r, int ll, int rr) {
	if (ll >= r || rr <= l) {
		return 0;
	}
	if (l >= ll && r <= rr) {
		return t[v];
	}
	int m = (l + r) / 2;
	return (get(2 * v + 1, l, m, ll, rr) + get(2 * v + 2, m, r, ll, rr));
}

void solve() {
	int n;
	cin >> n;
	t.resize(4 * n, 0);
	tree.resize(4 * n);
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		update(0, 0, n, i, a[i]);
	}

	/*for (int i = 0; i < n; i++) {
		int num;
		cin >> num;
		num--;
		for(int )
	}*/
	
	vector <tr> otr(n);
	for (int i = 0; i < n; i++) {
		otr[i].lans = 0;
		otr[i].rans = 0;
		otr[i].hmax = a[i];
		otr[i].posl = i;
		otr[i].posr = i;
	}
	//cout << get(0, 0, n, 3, 3);
	for (int i = 0; i < n - 1; i++) {
		int num;
		cin >> num;
		num--;
		tr mer;
		if (otr[num].hmax > otr[num + 1].hmax) {
			mer.hmax = otr[num].hmax;
			mer.lans = otr[num].lans;
			mer.rans = otr[num + 1].rans + max((int)0, (otr[num + 1].posr - otr[num].posr - 1) * otr[num + 1].hmax);
			if (otr[num + 1].posr - otr[num].posr >= 2) {
				mer.rans -= get(0, 0, n, otr[num].posl + 1, otr[num + 1].posr);
			}
			mer.posl = otr[num].posl;
			mer.posr = otr[num].posr;
		}
		else if (otr[num].hmax < otr[num + 1].hmax) {
			mer.hmax = otr[num + 1].hmax;
			mer.rans = otr[num + 1].rans;
			mer.lans = otr[num].lans + max((int)0, (otr[num + 1].posl - otr[num].posl - 1) * otr[num].hmax);
			if (otr[num + 1].posl - otr[num].posl >= 2) {
				mer.lans -= get(0, 0, n, otr[num].posl + 1, otr[num + 1].posr);
			}
			mer.posl = otr[num + 1].posl;
			mer.posr = otr[num + 1].posr;
		}
		else {
			mer.hmax = otr[num].hmax;
			mer.rans = otr[num + 1].rans;
			mer.lans = otr[num].lans;
			mer.posl = otr[num].posl;
			mer.posr = otr[num + 1].posr;
		}
		otr[num] = mer;
		for (int i = num + 1; i < n - 1; i++) {
			otr[i] = otr[i + 1];
		}
		//cout << mer.lans << " " << mer.rans <<  " " << max((int)0, (mer.posr - mer.posl - 1)) * mer.hmax << "\n";
		int anss = mer.lans + mer.rans + max((int)0,(mer.posr - mer.posl - 1) * mer.hmax);
		if (mer.posr - mer.posl >= 2) {
			anss -= get(0, 0, n, mer.posl + 1, mer.posr);
		}
		cout << anss << "\n";
	}
	//cout << otr[0].lans + otr[0].rans + otr[0].hmax * (otr[0].posr - otr[0].posl - 1) - get(0, 0, n, otr[0].posl + 1, otr[0].posr) << "\n";
} 

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}