﻿#include <iostream>
#include <vector>
#include <cmath>
#include <string>

using namespace std;

#define int long long

int p = 1e9 + 7;
struct tr {
	int lans, rans, hmax, posl, posr, l, r;
};

vector <int> t;
vector <tr> tree;
vector <int> a;
void update(int v, int l, int r, int pos, int val) {
	if (r - l == 1) {
		t[v] = val;
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) {
		update(2 * v + 1, l, m, pos, val);
	}
	else {
		update(2 * v + 2, m, r, pos, val);
	}
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}

int get(int v, int l, int r, int ll, int rr) {
	if (ll >= r || rr <= l) {
		return 0;
	}
	if (l >= ll && r <= rr) {
		return t[v];
	}
	int m = (l + r) / 2;
	return (get(2 * v + 1, l, m, ll, rr) + get(2 * v + 2, m, r, ll, rr));
}

void update1(int v, int l, int r, int pos, int val) {
	if (r - l == 1) {
		t[v] = pos;
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) {
		update(2 * v + 1, l, m, pos, val);
	}
	else {
		update(2 * v + 2, m, r, pos, val);
	}
	int ch1 = t[2 * v + 1];
	int ch2 = t[2 * v + 2];
	if (a[ch1] > a[ch2]) {
		t[v] = ch1;
	}
	else {
		t[v] = ch2;
	}
}

int get1(int v, int l, int r, int ll, int rr) {
	if (ll >= r || rr <= l) {
		return -1;
	}
	if (l >= ll && r <= rr) {
		return t[v];
	}
	int m = (l + r) / 2;
	int ch1 = get(2 * v + 1, l, m, ll, rr);
	int ch2 = get(2 * v + 2, m, r, ll, rr);
	if (a[ch1] > a[ch2]) {
		return ch1;
	}
	else {
		return ch2;
	}
}
void solve() {
	cout << 0;
} 

/*
8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1
*/
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}