﻿#include <string>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

void solve() {
    int d, l, r;
    cin >> d >> l >> r;
    int ans = 0;
    set <int> c;
    for (int i = 1; i * i <= d; i++) {
        int a = i, b = d / i;
        if ((a + b) % 2 == 0) {
            int x = (a + b) / 2;
            int y = (b - a) / 2;
            if (abs(x * x - y * y) == d && x * x >= l && x * x <= r && y * y >= l && y * y <= r) {
                c.insert(x);
            }
        }
    }
    cout << c.size();
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
