﻿#include <string>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    int ch = n - k;
    vector <int> pref(n + 1, 0);
    vector <int> mn_pref(n, 0), mn_suf(n, 0);
    vector <int> mx_pref(n, 0), mx_suf(n, 0);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
        if (i == 0) {
            mx_pref[i] = a[i];
            mn_pref[i] = a[i];
        }
        else {
            mx_pref[i] = max(mx_pref[i - 1], a[i]);
            mn_pref[i] = min(mn_pref[i - 1], a[i]);
        }
    }
    mx_suf[n - 1] = a[n - 1];
    mn_suf[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        mx_suf[i] = max(mx_suf[i + 1], a[i]);
        mn_suf[i] = min(mn_suf[i + 1], a[i]);
    }
    if (n == k) {
        cout << mx_pref[n - 1] - mn_pref[n - 1];
        return;
    }

    int ans = 0;
    for (int i = 0; i + ch < n; i++) {
        int sum = pref[i + ch + 1] - pref[i];
        if (i == 0) {
            int mx2 = mx_suf[i + ch + 1];
            int mn2 = mn_suf[i + ch + 1];
            ans = max(ans, sum - mn2);
            
        }
        else if (i + ch + 1 == n) {
            int mx1 = mx_pref[i - 1];
            int mn1 = mn_pref[i - 1];
            ans = max(ans, sum - mn1);
        }
        else {
            int mx1 = mx_pref[i - 1], mn1 = mn_pref[i - 1];
            int mx2 = mx_suf[i + ch + 1], mn2 = mn_suf[i + ch + 1];
            ans = max(ans, sum - min(mn1, mn2));
        }
    }
    cout << ans;
}

/*
4 2
2 1 3 4

10 5
1 3 2 7 3 0 4 5 3 7
*/
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
