﻿#include <string>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

void solve() {
    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    int ch = n - k;
    vector <int> pref(n + 1, 0);
    vector <int> mx_pref(n, 0), mx_suf(n, 0);
    int maximum = 0, minimum = (int)1e18;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        maximum = max(maximum, a[i]);
        minimum = min(minimum, a[i]);
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; i++) {
        if (i < ch) {
            mx_pref[i] = pref[i + 1] - pref[0];
        }
        else {
            mx_pref[i] = max(mx_pref[i - 1], pref[i + 1] - pref[i - ch]);
        }
    }
    
    for (int i = n - 1; i >= 0; i--) {
        if (i + ch + 1 > n) {
            mx_suf[i] = pref[n] - pref[i];
        }
        else {
            mx_suf[i] = max(mx_suf[i + 1], pref[i + ch + 1] - pref[i]);
        }
    }

    /*for (int i = 0; i < n; i++) {
        cout << mx_suf[i] << " ";
    }*/
    if (n == k) {
        cout << maximum - minimum;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            int mxr = mx_suf[i + 1];
            ans = max(ans, mxr - a[i]);
        }
        else if (i == n - 1) {
            int mxl = mx_pref[i - 1];
            ans = max(ans, mxl - a[i]);
        }
        else {
            int mxl = mx_pref[i - 1];
            int mxr = mx_suf[i + 1];
            ans = max(ans, max(mxl, mxr) - a[i]);
        }
    }
    cout << ans;
}

/*
4 2
2 1 3 4

10 5
1 3 2 7 3 0 4 5 3 7
*/
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
