﻿#include <string>
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

void solve() {
    int n, s;
    cin >> n >> s;
    vector <vector <int>> a(n);

    for (int i = 0; i < n; i++) {
        int kol;
        cin >> kol;
        for (int j = 0; j < kol; j++) {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    vector<pair<pair<int, int>, int>> dp(s + 1, { {-1, -1}, -1 });
    dp[0].second = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i].size(); j++) {
            for (int cost = s - a[i][j]; cost >= 0; cost--) {
                if (dp[cost].second != -1 && dp[cost + a[i][j]].second == -1) {
                    dp[cost + a[i][j]].second = cost;
                    dp[cost + a[i][j]].first = {i, j};
                }
            }
        }
    }
    /*for (int i = 0; i < s + 1; i++) {
        cout << i << " " << dp[i].first.first << " " << dp[i].first.second << " " << dp[i].second << "\n";
    }*/
    if (dp[n - 1].second == -1) {
        cout << "No";
    }
    else {
        vector<vector<int>> ans(n);
        int cost = s;
        while (cost != 0) {
            int i = dp[cost].first.first;
            int j = dp[cost].first.second;
            ans[i].push_back(j);
            cost = dp[cost].second;
        }
        for (int i = 0; i < n; i++) {
            cout << ans[i].size() << "\n";
            for (auto j : ans[i]) {
                cout << j + 1 << " ";
            }
            cout << "\n";
        }
    }

}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
