﻿// ConsoleApplication1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main()
{
    ll n;
    cin >> n;
    vector <ll> h(n + 1);
    for (ll i = 1; i < n + 1; i++) {
        cin >> h[i];
    }
    ll k;
    vector<ll> ans(n + 1);
    for (ll i = 1; i < n + 1; i++) {
        ans[i] = i;
    }
    ll INF = 1e9;
    vector<pair<ll, ll>> minimax(n + 1);
    for (ll i = 1; i < n + 1; i++) {
        minimax[i].first = h[i];
        minimax[i].second = h[i];
    }
    for (ll i = 0; i < n - 1; i++) {
        ll w = 0;
        cin >> k;
        for (ll j = n; j > 0; j--) {
            if (ans[j] == k) {
                minimax[j].second = max(minimax[j + 1].second, h[j]);
            }
        }
        for (ll j = 1; j < n + 1; j++) {
            if (ans[j] == k + 1) {
                minimax[j].first = max(minimax[j - 1].first, h[j]);
            }
            if (ans[j] > k) {
                ans[j]--;
            }
        }
        for (ll j = 1; j < n + 1; j++) {
            if (ans[j] == k) {
                    w += min(minimax[j].first, minimax[j].second) - h[j];
                }
            
        }
        cout << w << '\n';
    }
   

}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
