def check_connection(conn_data):
    conn_data = list(map(int, conn_data.split('-')))
    if len(conn_data) < 3:
        return 0
    w = 0
    for i in range(1, len(conn_data) - 1):
        prev, cur, next = int(max(conn_data[:i])), int(conn_data[i]), int(max(conn_data[i + 1:]))
        if prev > cur and next > cur:
            k = min(prev, next) - cur
            w += k
    return w


n = int(input())
blocks = list(map(int, input().split()))
connections = list(map(int, input().split()))

for con in connections:
    a, b = blocks[con - 1], blocks[con]
    con_data = f'{a}-{b}'
    print(check_connection(con_data))
    blocks = blocks[:con - 1] + [con_data] + blocks[con + 1:]