#include<iostream>
#include<vector>
using namespace std;

int main() {
    int n, k; 
    cin >> n >> k;

    vector<int> arr(n);
    for (int i = 0; i < n; i++) cin >> arr[i];

    int maxEl = n - k + 1;
    int minEl = 1;

    vector<int> prefixSum(1 + n);
    for (int i = 1; i <= n; i++) prefixSum[i] = prefixSum[i - 1] + arr[i - 1];

    int maxMax = 0;
    int maxStart, maxEnd;
    for (int i = maxEl; i <= n; i++) {
        int currSum = prefixSum[i] - prefixSum[i - maxEl];
        if (currSum >= maxMax) {
            maxStart = i - maxEl;
            maxEnd = i - 1;

            maxMax = currSum;
        }
    }


    for (int i = maxStart; i <= maxEnd; i++) {
        arr[i] = 1e9;
    }

    int minMin = 1e9;
    for(int el: arr) {
        if (el < minMin) {
            minMin = el;
        }
    }

    cout << maxMax - minMin;

    return 0;
}