#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

int main() {
    long long n, k; 
    cin >> n >> k;

    vector<long long> arr(n);
    for (long long i = 0; i < n; i++) cin >> arr[i];

    long long maxEl = n - k + 1;
    long long minEl = 1;

    vector<long long> prefixSum(1 + n);
    for (long long i = 1; i <= n; i++) prefixSum[i] = prefixSum[i - 1] + arr[i - 1];

    long long maxMax = 0;
    long long maxStart, maxEnd;
    for (long long i = maxEl; i <= n; i++) {
        long long currSum = prefixSum[i] - prefixSum[i - maxEl];
        if (currSum >= maxMax) {
            maxStart = i - maxEl;
            maxEnd = i - 1;

            maxMax = currSum;
        }
    }

    long long minMin = pow(2, 64);
    for(long long i = 0; i < n; i++) {
        if (i >= maxStart && i <= maxEnd) continue;
        if (arr[i] < minMin) {
            minMin = arr[i];
        }
    }

    cout << maxMax - minMin;

    return 0;
}   