#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;

int main() {
    int s, n;
    cin >> s >> n;

    vector<vector<int>> tasks(n);
    for (int i = 0; i < n; ++i) {
        int k_i;
        cin >> k_i;
        tasks[i].resize(k_i);
        for (int j = 0; j < k_i; ++j) {
            cin >> tasks[i][j];
        }
    }

    vector<int> dp(s + 1, -1);
    dp[0] = 0;
    vector<vector<int>> prev(s + 1, vector<int>(n, -1));

    for (int i = 0; i < n; ++i) {
        for (int j = s; j >= 0; --j) {
            if (dp[j] != -1) {
                for (int subtask : tasks[i]) {
                    if (j + subtask <= s && dp[j + subtask] == -1) {
                        dp[j + subtask] = i;
                        prev[j + subtask] = prev[j];
                        prev[j + subtask][i] = subtask;
                    }
                }
            }
        }
    }

    if (dp[s] == -1) {
        cout << "No" << endl;
    } else {
        cout << "Yes" << endl;
        vector<int> result(n, -1);
        int current = s;
        while (current > 0) {
            result[dp[current]] = prev[current][dp[current]];
            current -= prev[current][dp[current]];
        }
        for (int i = 0; i < n; ++i) {
            cout << result[i] << endl;
        }
    }

    return 0;
}
