#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

ll md = 1e9 + 7;

vector<vector<bool>> v;
vector<int> a;
ll ans = 0;
int n, k;

bool check(int jj) {
    int cnt = 0;
    int ii = k - 1;
    for (int j = jj; j >= 0 && ii >= 0; --j, --ii) {
        for (int i = 0; i <= ii && cnt <= a[jj]; ++i)
            cnt += v[i][j];
        if (cnt > a[jj]) return false;
    }
    if (cnt != a[jj]) return false;
    return true;
}

void rec(int i, int j) {
    if (j >= n) {
        ++ans;
        return;
    }
    if (i < k - 1) {
        v[i][j] = false;
        rec(i + 1, j);
        v[i][j] = true;
        rec(i + 1, j);
    } else {
        v[i][j] = false;
        if (check(j)) rec(0, j + 1);
        v[i][j] = true;
        if (check(j)) rec(0, j + 1);
    }
}

void rec2(int i, int j) {
    if (j >= n) {
        ans = (ans + 1) % md;
        return;
    }
    if (a[j] < 0) return;
    if (i < k - 1) {
        v[i][j] = false;
        rec(i + 1, j);
        if (a[j] <= 0) return;
        v[i][j] = true;
        for (int x = j; x < j + (k - i); ++x) {
            --a[x];
        }
        rec(i + 1, j);
        for (int x = j; x < j + (k - i); ++x)
            ++a[x];
    } else {
        v[i][j] = false;
        rec(0, j + 1);
        if (a[j] <= 0) return;
        v[i][j] = true;
        --a[j];
        if (a[j] > 0) {
            ++a[j];
            return;
        }
        rec(0, j + 1);
        ++a[j];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> k;
    a.resize(n);
    for (int &i: a) cin >> i;
    v.resize(k, vector<bool>(n, false));
    // if (n * k <= 25)
    //     rec(0, 0);
    // else
        rec2(0, 0);
    cout << ans << "\n";
}