#include <iostream>
#include <vector>
#include <algorithm>
#define ff first
#define ss second

using namespace std;

vector<vector<bool>> used;
vector<pair<int, int>> g;
int n, m, k;
int ans = 0;

bool valid(int i, int j) {
    return (0 <= i && i < n && 0 <= j && j < m);
}

int di[4] = {1, -1, 0, 0};
int dj[4] = {0, 0, 1, -1};
int d[4] = {0, 0, 0, 0};

void rec(int i, int j) {
    if (d[0] == 0 && d[1] == 0 && d[2] == 0 && d[3] == 0) {
        if (!used[n - 1][m - 1]) return;
        bool f = true;
        for (auto [i, j]: g)
            if (!used[i][j]) {
                f = false;
                break;
            }
        if (f) ++ans;
        return;
    }
    if (!used[n - 1][m - 1] && (d[0] < n - 1 - i || d[2] < m - 1 - j))
        return;
    for (int k = 0; k < 4; ++k) {
        if (d[k] > 0) {
            int ni = i + di[k], nj = j + dj[k];
            if (valid(ni, nj) && !used[ni][nj]) {
                --d[k];
                used[ni][nj] = true;
                rec(ni, nj);
                used[ni][nj] = false;
                ++d[k];
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        int r, c;
        cin >> r >> c; --r; --c;
        g.emplace_back(r, c);
    }
    used.resize(n, vector<bool>(m, false));
    d[0] = d[1] = n - 1;
    d[2] = d[3] = m - 1;
    rec(0, 0);
    cout << ans << "\n";
}