#include <iostream>
#include <vector>
#include <algorithm>

#define deb(x) cout << (#x) << ": " << x << "\n";
#define ff first
#define ss second

using namespace std;

vector<vector<bool>> used;
vector<pair<int, int>> g;
int n, m, k;
int ans = 0;

bool valid(int i, int j) {
    return (0 <= i && i < n && 0 <= j && j < m);
}

int di[4] = {1, 0, -1, 0};
int dj[4] = {0, 1, 0, -1};
int d[4] = {0, 0, 0, 0};

void rec(int i, int j) {
    if (d[0] == 0 && d[1] == 0 && d[2] == 0 && d[3] == 0) {
        // cout << "?" << endl;
        if (!used[n - 1][m - 1]) return;
        if (k == 0) {
            ++ans;
            return;
        }
        bool f = true;
        int f_i = -1, f_j = -1;
        for (auto [xi, xj]: g)
            if (!used[xi][xj]) {
                f = false;
                f_i = xi; f_j = xj;
                break;
            }
        if (f) ++ans;
        // else cout << f_i << " " << f_j << endl;
        return;
    }
    if (!used[n - 1][m - 1]) {
        // cout << i << " " <<  j << " #" << endl;
        for (int k = 0; k < 2; ++k)
            if (d[k] > 0) {
                int ni = i + di[k], nj = j + dj[k];
                if (valid(ni, nj) && !used[ni][nj]) {
                    --d[k];
                    used[ni][nj] = true;
                    // cout << "# " << i << " " << j << " -> " << ni << " " << nj << " | " << used[n - 1][m - 1] << "\n";
                    rec(ni, nj);
                    used[ni][nj] = false;
                    ++d[k];
                }
            }
    } else {
        // cout << i << " " <<  j << " @" << endl;
        for (int k = 2; k < 4; ++k)
            if (d[k] > 0) {
                int ni = i + di[k], nj = j + dj[k];
                if (valid(ni, nj) && !used[ni][nj]) {
                    --d[k];
                    used[ni][nj] = true;
                    // cout << "@ " << i << " " << j << " -> " << ni << " " << nj << " | " << used[n - 1][m - 1] << " " << d[0] << " " << d[1] << " " << d[2] << " " << d[3] << "\n";
                    rec(ni, nj);
                    used[ni][nj] = false;
                    ++d[k];
                }
            }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        int r, c;
        cin >> r >> c; --r; --c;
        g.emplace_back(r, c);
    }
    used.resize(n, vector<bool>(m, false));
    // deb(n)
    // deb(m)
    d[0] = d[2] = n - 1;
    d[1] = d[3] = m - 1;
    rec(0, 0);
    cout << ans << "\n";
}