#include <bits/stdc++.h>

// Currently playing Kill Me Baby ending theme in my head

typedef uint_fast8_t u8;
typedef uint_fast16_t u16;
typedef uint_fast32_t u32;
typedef uint_fast64_t u64;

typedef int_fast8_t s8;
typedef int_fast16_t s16;
typedef int_fast32_t s32;
typedef int_fast64_t s64;

typedef float f32;
typedef double f64;
typedef long double f128;

typedef size_t usz;
typedef intmax_t smx;
typedef uintmax_t umx;

using namespace std;    // F-ck it, easier to write sh-t

typedef struct {
    vector<u32> heights;
    deque<u32> maxlheights;
    deque<u32> maxrheights;
    u32 maxHeight;
} seg;

deque<seg> segs;
u16 n;

int main() {

    cin >> n;

    u32 tmpHeight;
    for (u16 i = 0; i < n; i++) {
        cin >> tmpHeight;
        segs.push_back(seg {vector<u32> {tmpHeight}, deque<u32> {tmpHeight}, deque<u32> {tmpHeight}, tmpHeight});
    }

    u16 idx;
    for (u16 inst = 0; inst < n-1; inst++) {
        cin >> idx;

        idx -= 1;

        seg segA = segs[idx];
        seg segB = segs[idx+1];

        seg segFinal = {
            segA.heights,
            segA.maxlheights,
            segB.maxrheights,
            max(segA.maxHeight, segB.maxHeight)
        };

        segFinal.maxlheights.resize(segA.maxlheights.size() + segB.maxlheights.size());

        for (int i = 0; i < segB.maxlheights.size(); i++) {
            segFinal.maxlheights[segA.maxlheights.size()+i] = max(segB.maxrheights[i], segA.maxHeight);
        }

        while (segA.maxrheights.size()) {
            segFinal.maxrheights.push_front(max(segA.maxrheights.back(), segB.maxHeight));
            segA.maxrheights.pop_back();
        }

        for (auto &i : segB.heights) segFinal.heights.push_back(i);


        segs[idx] = segFinal;
        segs.erase(segs.cbegin()+idx+1);

        // now calculate the volume

        u64 totalDepth = 0;

        for (int i = 0; i < segFinal.heights.size(); i++) {
            totalDepth += min(segFinal.maxlheights[i], segFinal.maxrheights[i]) - segFinal.heights[i];
        }
        std::cout << totalDepth << std::endl;
    }

    return 0;
}
