#include <bits/stdc++.h>

// Currently playing moondriver opl3 demo 002 in my head

typedef uint_fast8_t u8;
typedef uint_fast16_t u16;
typedef uint_fast32_t u32;
typedef uint_fast64_t u64;

typedef int_fast8_t s8;
typedef int_fast16_t s16;
typedef int_fast32_t s32;
typedef int_fast64_t s64;

typedef float f32;
typedef double f64;
typedef long double f128;

typedef size_t usz;
typedef intmax_t smx;
typedef uintmax_t umx;

using namespace std;    // F-ck it, easier to write sh-t

typedef struct {
    vector<u32> heights;
    deque<u32> maxlheights;
    deque<u32> maxrheights;
    u32 maxHeight;
} seg;

typedef struct _ dll;

typedef struct _ {
    seg data;
    dll* prev;
    dll* next;
} dll;

dll* walk(dll * head, s16 relidx) {
    if (relidx == 0)    return head;
    else if (relidx > 0) {
        dll * cur = head;
        while (relidx != 0) {
            cur = cur->next;
            relidx--;
        }
        return cur;
    } else if (relidx < 0) {
        dll * cur = head;
        while (relidx != 0) {
            cur = cur->prev;
            relidx++;
        }
        return cur;
    }
}

dll* at(u16 newidx, dll * head, dll * tail, dll * last, u16 size, u16 lastidx) {
    int da = newidx;
    int db = newidx - lastidx;
    int dc = newidx - size;
    int absa = abs(da), absb = abs(db), absc = abs(dc);
    int minas = min(absa, min(absb, absc));
    if (minas == absa) {
        return walk(head, da);
    } else if (minas == absb) {
        return walk(last, db);
    } else if (minas == absc) {
        return walk(tail, dc);
    }
}

dll* segsHead;
dll* segsTail;
u16 n;

int main() {

    cin >> n;

    u32 tmpHeight;
    segsHead = new dll[n];
    for (u16 i = 0; i < n; i++) {
        cin >> tmpHeight;
//        segs[i] = seg {vector<u32> {tmpHeight}, deque<u32> {tmpHeight}, deque<u32> {tmpHeight}, tmpHeight
        segsHead[i] = dll {
            seg {vector<u32> {tmpHeight}, deque<u32> {tmpHeight}, deque<u32> {tmpHeight}, tmpHeight},
            segsHead+i-1,
            segsHead+i+1
        };
    }

    segsTail = segsHead+n-1;

    u16 idx;
    dll * last = segsHead;
    u16 lastidx = 0;
    u16 dllsize = n;
    for (u16 inst = 0; inst < n-1; inst++) {
        cin >> idx;

        idx -= 1;

        dll * dllA = at(idx, segsHead, segsTail, last, dllsize, lastidx);
        seg segA = dllA->data;
        dll * dllB = dllA->next;
        seg segB = dllB->data;

        last = dllA;
        lastidx = idx;

        seg segFinal = {
            segA.heights,
            segA.maxlheights,
            segB.maxrheights,
            max(segA.maxHeight, segB.maxHeight)
        };

        segFinal.maxlheights.resize(segA.maxlheights.size() + segB.maxlheights.size());

        for (int i = 0; i < segB.maxlheights.size(); i++) {
            segFinal.maxlheights[segA.maxlheights.size()+i] = max(segB.maxlheights[i], segA.maxHeight);
        }

        while (segA.maxrheights.size()) {
            segFinal.maxrheights.push_front(max(segA.maxrheights.back(), segB.maxHeight));
            segA.maxrheights.pop_back();
        }

        for (auto &i : segB.heights) segFinal.heights.push_back(i);


        *dllA = dll {
            segFinal,
            dllA->prev,
            dllB->next
        };
//        memcpy(segs+idx, segs+idx+1, n-idx-1);
        dllsize--;

        // now calculate the volume

        u64 totalDepth = 0;
        if (segFinal.heights.size() >= 3) {
            for (int i = 0; i < segFinal.heights.size(); i++) {
//                std::cout << segFinal.maxlheights[i] << " " << segFinal.maxrheights[i] << " " << segFinal.heights[i] << std::endl;
                totalDepth += min(segFinal.maxlheights[i], segFinal.maxrheights[i]) - segFinal.heights[i];
            }
        }
        std::cout << totalDepth << std::endl;
    }

    return 0;
}
