﻿//#define _GLIBCXX_DEBUG 1
//#pragma GCC optimize("inline")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

bool prim(int x) {
	return (x == 2 || x == 3 || x == 5 || x == 7);
}

bool fi(int x) {
	int ans = 1;
	while (x > 0) {
		ans *= x % 10;
		if (ans > 10) break;
		x /= 10;
	}
	return prim(ans);
}

bool fs(string s) {
	int ans = 1;
	for (int i = 0; i < s.size(); ++i) {
		ans *= s[i] - '0';
		if (ans > 10) break;
	}
	return prim(ans);
}

bool comp(string a, string b) {
	if (a.size() < b.size()) {
		return true;
	} else if (a.size() > b.size()) {
		return false;
	}
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] < b[i]) {
			return true;
		} else if (a[i] > b[i]) {
			return false;
		}
	}
	return false;
}

ll slv(string s, char a) {
	ll l = -1, r = s.size(), mid;
	while (r - l > 1) {
		mid = (r + l) / 2;
		string tmp;
		for (int i = 0; i < mid; ++i) {
			tmp.push_back('1');
		}
		tmp.push_back(a);
		for (int i = mid + 1; i < s.size(); ++i) {
			tmp.push_back('1');
		}
		if (comp(s, tmp)) {
			l = mid;
		} else {
			r = mid;
		}
	}
	return s.size() - r;
}

void solve() {
	//cout << slv("3", '5') << endl;
	string l, r;
	cin >> l >> r;
	/*int q = stoi(l);
	int w = stoi(r);
	ll ansn = 0;
	for (int i = q; i <= w; ++i) {
		if (fi(i)) {
			ansn++;
		}
	}
	cout << ansn << "\n";*/
	ll plus = (fs(l) ? 1 : 0);
	plus += (ll)r.size() * ((ll)r.size() - 1) * 2;
	plus -= (ll)l.size() * ((ll)l.size() - 1) * 2;
	plus += slv(r, '2');
	plus += slv(r, '3');
	plus += slv(r, '5');
	plus += slv(r, '7');
	plus -= slv(l, '7');
	plus -= slv(l, '5');
	plus -= slv(l, '3');
	plus -= slv(l, '2');
	cout << plus;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}
