﻿//#define _GLIBCXX_DEBUG 1
//#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <algorithm>
#include <set>
#include <queue>
#include <map>
#include <cmath>
#include <random>

using namespace std;

mt19937 gen(553321);

int fr(int a, int b) {
	return uniform_int_distribution<int>(a, b)(gen);
}

typedef long long ll;
typedef long double ld;

void solve() {
	int k, n;
	cin >> n >> k;
	vector<int> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	if (n * k <= 25) {
		int ans = 0;
		vector<vector<int>> vec(k, vector<int>(n, 0));
		vector<vector<int>> ps(k, vector<int>(n, 0));
		for (int i = (1 << (n * k)) - 1; i >= 0; --i) {
			int cnt = 0;
			for (int q = 0; q < k; ++q) {
				for (int w = 0; w < n; ++w) {
					if (i & (1 << cnt)) {
						vec[q][w] = 1;
					} else {
						vec[q][w] = 0;
					}
					ps[q][w] = vec[q][w];
					if (q > 0) {
						ps[q][w] += ps[q - 1][w];
					}
					++cnt;
				}
			}
			bool flag = true;
			for (int q = 0; q < n; ++q) {
				cnt = 0;
				for (int w = q; w >= 0; --w) {
					if (k + w - q - 1 < 0) break;
					cnt += ps[k - q + w - 1][w];
				}
				if (cnt != arr[q]) {
					flag = false;
					break;
				}
			}
			if (flag) {
				ans++;
			}
		}
		cout << ans;
	}
	if (k < 3) {

		return;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int _ = 1;
	//cin >> _;
	while (_--) {
		solve();
		cout << "\n";
	}
	return 0;
}

/*

5 3
2 1 2 3 2

*/