﻿/*#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast");*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

void initt(ll v, vector<ll>& t, ll l, ll r, vector<ll>& arr) {
	if (l == r) {
		t[v] = arr[l];
		return;
	}
	ll mid = (r + l) / 2;
	initt(v * 2, t, l, mid, arr);
	initt(v * 2 + 1, t, mid + 1, r, arr);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

ll gett(ll v, vector<ll>& t, ll l, ll r, ll q, ll w) {
	if (q <= l && r <= w) {
		return t[v];
	}
	if (q > r || w < l) {
		return 2100000000000000000;
	}
	ll mid = (r + l) / 2;
	return min(gett(v * 2, t, l, mid, q, w), gett(v * 2 + 1, t, mid + 1, r, q, w));
}

void ftl() {
	int ans = 0;
	for (int i = 0; i < 2100000000; ++i) {
		ans += i * i * cos(i);
	}
	cout << ans;
}

ll gn, gk;

vector<ll> seq;
vector<ll> vec;

ll gans = 0;

void reCursion(int ind) {
	if (seq.size() > gk || (seq.size() == gk && ind != (gn - 1))) {
		return;
	}
	if (seq.size() == gk && ind == (gn - 1)) {
		ll mx = 0;
		ll mn = 2100000000000000000;
		for (ll i : seq) {
			mx = max(mx, i);
			mn = min(mn, i);
		}
		gans = max(gans, mx - mn);
		return;
	}
	ll ts = 0;
	for (int i = ind + 1; i < gn; ++i) {
		ts += vec[i];
		seq.push_back(ts);
		reCursion(i);
		seq.pop_back();
	}
}

void solved() {
	cin >> gn >> gk;
	vec.resize(gn);
	for (int i = 0; i < gn; ++i) {
		cin >> vec[i];
	}
	reCursion(-1);
	cout << gans;
}

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<ll> arr(n);
	for (ll i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	vector<ll> ps(n + 1, 0);
	for (ll i = 1; i <= n; ++i) {
		ps[i] = ps[i - 1] + arr[i - 1];
	}
	vector<ll> t(n * 4 + 4, 2100000000000000000);
	initt(1, t, 0, n - 1, arr);
	ll ans = 0;
	ll sz = n - k + 1;
	for (ll i = sz - 1; i < n; ++i) {
		ll sum = ps[i + 1] - ps[i - sz + 1];
		ll mn = 2100000000000000000;
		if (i >= sz)
			mn = min(mn, gett(1, t, 0, n - 1, 0, i - sz));
		if (i < n - 1) {
			mn = min(mn, gett(1, t, 0, n - 1, i + 1, n - 1));
		}
		ans = max(ans, abs(sum - mn));
	}
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll _ = 1;
	//cin >> _;
	while (_--) {
		solved();
		cout << "\n";
	}
	return 0;
}

/*

4 2 2 1 3 4

5 4
2 1 3 4 1

*/