#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

// нужные простые: 2 3 5 7
ll prostWithoutGranicas(int llength, int rlength) {
    ll l = llength + 1;
    ll r = rlength - 1;
    return 4 * (r * (r + 1) / 2 - l * (l - 1) / 2); // 4 * сумма длин от l до r
}

int fast(vector<int> l, vector<int> r) {
    return prostWithoutGranicas(l.size() - 1, r.size() + 1);
}

int main() {
    string ls, rs;
    getline(cin, ls);
    getline(cin, rs);
    vector<int> l(ls.size()), r(rs.size());
    for (int i = 0; i < ls.size(); i++) {
        l[i] = ls[i] - '0';
    }
    for (int i = 0; i < rs.size(); i++) {
        r[i] = rs[i] - '0';
    }
    

    ll la = l.size();
    ll ra = r.size() - 1;
    cout << 4 * (ra * (ra + 1) / 2 - la * (la - 1) / 2); // 4 * сумма длин от l до r
}