#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

int glubina(vector<int> h) {
    int l = 0;
    int r = h.size() - 1;
    int w = 0;
    for (int p = l; p <= r; p++) {
        int lp = 0;
        for (int pp = l; pp <= p; pp++) {
            lp = max(lp, h[pp]);
        }
        int rp = 0;
        for (int pp = p; pp <= r; pp++) {
            rp = max(rp, h[pp]);
        }
        int dp = min(lp, rp) - h[p];
        dp = max(0, dp);
        w += dp;
    }
    return w;
}

void slow(int n, vector<vector<int>> h, vector<int> k) {
    for (int j = 0; j < n - 1; j++) {
        for (int hi : h[k[j] + 1]) {
            h[k[j]].push_back(hi);
        }
        for (int i = k[j] + 2; i < h.size(); i++) {
            h[i - 1] = h[i];
        }
        h.pop_back();

        cout << glubina(h[k[j]]) << endl;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> h(n, vector<int> (1));
    for (int i = 0; i < n; i++) {
        cin >> h[i][0];
    }
    vector<int> k(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int ki;
        cin >> ki;
        k[i] = ki - 1;
    }
    
    slow(n, h, k);
}

int main() {
    solve();
    return 0;
}