#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int k;

pair<int, vector<int>> to2(int num){
    int amount = 0;
    vector<int> ans;
    while(num >= 2){
        if(num % 2 == 1)
            ++amount;
        ans.push_back(num % 2);
        num /= 2;
    }
    if(num == 1)
        ++amount;
    ans.push_back(num);
    while(ans.size() < k)
        ans.push_back(0);
    reverse(ans.begin(), ans.end());
    return {amount, ans};
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n >> k;
    vector<int> a(n);
    for(int i = 0; i < n ; ++i)
        cin >> a[i];

    vector<vector<vector<int>>> str(k + 1);
    map<pair<int, vector<int>>, ll> dp;
    for(int i = 0; i < pow(2, k); ++i){
        auto q = to2(i);
        str[q.first].push_back(q.second);
        dp[{0, q.second}] = 0;
    }

    for(auto &x : str[a[0]])
        dp[{0, x}] = 1;


    for(int i = 0; i < n - 1; ++i){
        for(auto &x : dp){
            if(x.first.first == i){
                int sum = 0;
                for(int i = 0; i < k - 1; ++i)
                    sum += x.first.second[i];
                int need = a[i + 1] - sum;
                if(need >= 0 && need <= k){
                    for(auto &z : str[need]){
                        vector<int> now(k);
                        now[0] = z[0];
                        for(int j = 1; j < k; ++j)
                            now[j] = x.first.second[j - 1] + z[j];
                        dp[{i + 1, now}] += x.second;
                        dp[{i + 1, now}] %= 1000000007;
                    }
                }
            }
        }
    }

    ll answer = 0;
    for(auto x : dp){
        if(x.first.first == n - 1){
            if(answer + x.second >= 1000000007)
                answer = answer + x.second - 1000000007;
            else
                answer += x.second;
        }
    }
    cout << answer;
}
