#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, s;
    cin >> n >> s;
    vector<vector<int>> groups(n);
    for(int i = 0; i < n; ++i){
        int am;
        cin >> am;
        groups[i].resize(am);
        for(int j = 0; j < am; ++j)
            cin >> groups[i][j];
    }
    vector<vector<int>> dp(n + 1, vector<int> (s + 1, 0));
    dp[0][0] = 1;
    vector<vector<pair<int, int>>> prev(n + 1, vector<pair<int, int>> (s + 1, {-1, -1})); //coords in dp of previous element
    prev[0][0] = {-1, -1};
    vector<vector<int>> take(n + 1, vector<int> (s + 1, 0));
    vector<int> now(s + 1);
    for(int i = 1; i <= n; ++i){
        int am = groups[i - 1].size();
        for(int j = 0; j < am; ++j){
            now.assign(s + 1, 0);
            int x = groups[i - 1][j];
            for(int k = 0; k + x <= s; ++k){
                if(dp[i - 1][k]){
                    if(take[i][k + x] == 0){
                        prev[i][k + x] = {i - 1, k};
                        take[i][k + x] = x;
                    }
                    now[k + x] = 1;
                } else if(dp[i][k]){
                    if(take[i][k + x] == 0){
                        prev[i][k + x] = {i, k};
                        take[i][k + x] = x;
                    }
                    now[k + x] = 1;
                }
            }
            for(int k = 0; k <= s; ++k)
                if(now[k])
                    dp[i][k] = 1;
        }
    }
    if(dp[n][s]){
        cout << "YES" << endl;
        vector<vector<int>> answer(n + 1);
        pair<int, int> place = {n, s};
        while(prev[place.first][place.second].first != -1){
            answer[place.first].push_back(take[place.first][place.second]);
            place = prev[place.first][place.second];
        }
        for(int i = 1; i <= n; ++i){
            cout << answer[i].size() << endl;
            for(auto x : answer[i])
                cout << x << " ";
            cout << endl;
        }
    } else
        cout << "NO";
}
