#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;

/*int n, s;
vector<vector<ll>> k;
void zov(int v = 0, ll sum = 0, vector<int> ans = {})
{
    ans.push_back(0);
    for (ll i : k[v])
    {
        if (v < k.size() - 1)
            zov(v + 1, sum + i);
        else
            if (sum + i == s)
            {

            }
    }
}

int main()
{
    cin >> n >> s;

    k.resize(n);
    for (vector<int>& i : k)
    {
        int c;
        cin >> c;

        i.resize(c);
        for (ll& j : i)
            cin >> j;
    }

    return 0;
}*/

int n, k;
vector<ll> treezov, treesvo;
void build_tree(int v, int L, int R, vector<ll>& tree, vector<ll> a)
{
    if (L + 1 == R)
    {
        tree[v] = a[L];
        return;
    }
    int m = (L + R) / 2;
    build_tree(2 * v + 1, L, m, tree, a);
    build_tree(2 * v + 2, m, R, tree, a);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

ll mx(int v, int l, int r, int L, int R, vector<ll> tree)
{
    if (L >= l && R <= r)
        return tree[v];
    if (L >= r || R <= l)
        return 0;
    int m = (L + R) / 2;
    return max(mx(2 * v + 1, l, r, L, m, tree), mx(2 * v + 2, l, r, m, R, tree));
}

/*ll solve()
{
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        ll sum = 0;
        for (int j = i; j < n && j - i < n - k + 1; j++)
        {
            sum += a[j];
            ll mini = 1e9;
            for (int z = 0; z < i; z++)
                mini = min(mini, a[z]);
            for (int z = j + 1; z < n; z++)
                mini = min(mini, a[z]);
            ans = max(ans, sum - mini);
        }
    }
    return ans;
}*/

int main()
{
    cin >> n >> k;

    vector<ll> a(n);
    for (ll& i : a)
        cin >> i;

    //cout << solve();

    ll nn = n;

    vector<ll> pref(nn + 1, 0);
    for (int i = 1; i <= nn; i++)
        pref[i] = pref[i - 1] + a[i - 1];

    vector<ll> zov(nn, a[0]), svo(nn, a[nn - 1]);
    for (int i = 1; i < nn; i++)
    {
        zov[i] = zov[i - 1] + a[i];
        svo[nn - i - 1] = svo[nn - i] + a[nn - i - 1];
        if (i > nn - k)
        {
            zov[i] -= a[i - nn + k - 1];
            svo[nn - i - 1] -= a[nn - i + nn - k];
        }
    }

    while (1 << __lg(n) != n)
    {
        n++;
        zov.push_back(0);
        svo.push_back(0);
    }

    treezov.resize(2 * n);
    treesvo.resize(2 * n);
    build_tree(0, 0, n, treezov, zov);
    build_tree(0, 0, n, treesvo, svo);

    /*for (int i : zov)
        cout << i << ' ';
    cout << '\n';

    for (int i : svo)
        cout << i << ' ';
    cout << '\n';*/

    ll ans = 0, mxzov = 0, mxsvo = *max_element(svo.begin(), svo.end());
    for (int i = 0; i < nn; i++)
    {
        if (a[i] > mxzov)
            mxzov = mx(0, 0, i, 0, n, treezov);
        if (a[i] == mxsvo)
            mxsvo = mx(0, i + 1, nn, 0, n, treesvo);
        ans = max(ans, mxzov - a[i]);
        ans = max(ans, mxsvo - a[i]);
    }
    cout << ans;

    return 0;
}
