#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

int dti(char x)
{
  return x - '0';
}

int primesIn(int a, int b)
{
  int res = 0;
  if (a <= 2 && b >= 2)
    res++;
  if (a <= 3 && b >= 3)
    res++;
  if (a <= 5 && b >= 5)
    res++;
  if (a <= 7 && b >= 7)
    res++;

  return res;
}

bool isPrime(int a)
{
  return a == 2 || a == 3 || a == 5 || a == 7;
}

int main()
{
  string a, b;
  int answer = 0;

  cin >> a;
  cin >> b;

  int lgA = size(a);
  int lgB = size(b);
  
  if (lgA == lgB)
  {
    

    return 0;
  }

  // ---------- lower echelon

  for (int i = 0; i < lgA; i++)
    if (a[i] <= '1')
    {
      answer += 4;
    }
    else
    {
      answer += primesIn(dti(a[i]) + 1, 9);
      
      bool extra = isPrime(dti(a[i]));

      for (int j = i + 1; j < lgA && extra; j++)
        if (a[j] > '1')
        {
          extra = false;
        }

      answer += extra;

      break;
    }  

  // -------------- middle

  if (lgB - 1 > lgA)
    answer += 4 * (((lgB - 1) * lgB - (lgA + 1) * (lgA + 2)) / 2 + (lgA + 1));

  // -------------- upper

  for (int i = 0; i < lgB; i++)
  {
    answer += primesIn(1, dti(b[i]) - 1);

    bool extra = isPrime(dti(b[i]));

      for (int j = i + 1; j < lgB && extra; j++)
        if (b[j] == '0')
        {
          extra = false;
        }

      answer += extra;
  }

  /**/

  cout << answer;
  return 0;
}
