#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

int dti(char x)
{
  return x - '0';
}

int primesIn(int a, int b)
{
  int res = 0;
  if (a <= 2 && b >= 2)
    res++;
  if (a <= 3 && b >= 3)
    res++;
  if (a <= 5 && b >= 5)
    res++;
  if (a <= 7 && b >= 7)
    res++;

  return res;
}

bool isPrime(int a)
{
  return a == 2 || a == 3 || a == 5 || a == 7;
}

bool stupidIsPrime(long long x)
{
  if (x < 2)
    return false;

  for (long long i = 2; i <= sqrt(x); i++)
    if (x % i == 0)
      return false;

  return true;
}

bool stupidCheck(const string &A)
{
  long long prod = dti(A[0]);

  for (int i = 1; i < A.size(); i++)
    prod *= dti(A[i]);

  return stupidIsPrime(prod);
}

bool check(const string &A)
{
  bool hasPrime = false;

  for (int i = 0; i < A.size(); i++)
    if (A[i] == '0')
      return false;
    else if (isPrime(dti(A[i])))
      if (hasPrime)
        return false;
      else
        hasPrime = true;
    else if (A[i] != '1')
      return false;

  return hasPrime;
}

bool strLorGT(const string& A, const string& B)
{
  if (A.size() > B.size())
    return false;
  else if (A.size() < B.size())
    return true;

  for (int i = 0; i < A.size(); i++)
    if (A[i] < B[i])
      return true;
    else if (A[i] > B[i])
      return false;

  return true;
}

int main()
{
  string l, r;
  int answer = 0;

  cin >> l;
  cin >> r;

  string Str = l;

  //cout << stupidCheck("12");

  while (strLorGT(Str, r))
  {
    if (stupidCheck(Str))
    {
      //cout << Str << endl;
      answer++;
    }
    
    bool changed = false;
    for (int i = Str.size() - 1; i >= 0; i--)
      if (Str[i] < '9')
      {
        Str[i] = Str[i] + 1; 

        changed = true;
        break;
      }
      else
        for (int j = i; j < Str.size(); j++)
          Str[j] = '0';

    if (!changed)
    {
      for (int i = 0; i < Str[i]; i++)
        Str[i] = '0';

      Str = "1" + Str;
    }
  }

  cout << answer;
  return 0;
}
