                                                                                                                                  #include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

struct subtask
{
  int Index = 0;
  long long Points = 0;
};

vector<vector<subtask>> Tasks;
vector<vector<subtask*>> Path;

long long CurPoints = 0;
int n;
long long s;

void search( int Task )
{
  if (Task == n)
  {
    if (CurPoints == s && Path[n - 1].size() != 0)
    {
      cout << "Yes" << endl;
      
      for (auto tsk : Path)
      {
        cout << tsk.size() << endl;
        for (auto sub : tsk)
          cout << sub->Index + 1 << " ";
        cout << endl;
      }
      
      exit(0);
    }
    else
      return;
  }
  

  for (int i = 0; i < Tasks[Task].size(); i++)
  {
    CurPoints += Tasks[Task][i].Points;
    Path[Task].push_back(&(Tasks[Task][i]));
    search(Task + 1);
    Path[Task].pop_back();
    CurPoints -= Tasks[Task][i].Points;
  }
}

int main()
{
  cin >> n;
  cin >> s;
  
  for (int i = 0; i < n; i++)
  {
    int k;
    cin >> k;
    Tasks.push_back({});
    Path.push_back({});

    for (int j = 0; j < k; j++)
    {
      long long c;
      cin >> c;

      for (int a = Tasks[i].size(); a >= 0; a--)
      {
        if (Tasks[i].size() == 0 || a == 0 || c > Tasks[i][a - 1].Points)
        {
          Tasks[i].insert(Tasks[i].begin() + a, {j, c});
          break;
        }
      }
    }
  }
  
  search(0);

  cout << "No";

  return 0;
}
