#include <iostream>
#include <cmath>
#include <string>

using namespace std;

typedef unsigned long long ll;

int primes[] = { 2, 3, 5, 7 };

ll sub_digi(const char* num, int num_size)
{
	ll res = 0;

	for (int i = num_size - 1; i >= 0; i--)
		for (int j = 0; j < 4; j++)
		{
			bool flag = false;

			for (int k = 0; k < num_size; k++)
			{
				int d = 1;
				if (k == i)
					d = primes[j];

				if (num[k] - '0' < d)
					return res;
				else if (num[k] - '0' > d)
				{
					res++;
					flag = true;
					break;
				}
			}
			if (!flag)
				res++;
		}
	return res;
}

ll digi(const char* num, int num_size)
{
	if (num_size == 0)
		return 0;
	int first_not_one = 0;

	while (first_not_one < num_size && num[first_not_one] == '1')
		first_not_one++;

	if (first_not_one >= num_size || num[first_not_one] == '0')
		return 2 * (num_size - 1) * num_size;

	ll res = sub_digi(num + first_not_one, num_size - first_not_one);
	if (num_size > 1)
		res += 2 * (num_size - 1) * num_size;
	return res;
}

bool is_primy(const char* num, int num_size)
{
	bool prime_found = false;

	for (int i = 0; i < num_size; i++)
	{
		if (num[i] != '1')
		{
			if (prime_found)
				return false;
			for (int j = 0; j < 4; j++)
				if (num[i] - '0' == primes[j])
				{
					prime_found = true;
					break;
				}
			if (!prime_found)
				return false;
		}
	}
	return prime_found;
}

ll main1(const char* l, int l_size, const char* r, int r_size)
{
	return digi(r, r_size) - digi(l, l_size) + is_primy(l, l_size);
}

int main()
{
	string l, r;

	cin >> l >> r;

	cout << main1(l.c_str(), l.size(), r.c_str(), r.size()) << endl;
}