#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;


int deg2(int deg) {
	return (1 << deg);
}
bool have(int mask, int deg) {
	return mask & deg2(deg);
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (auto& i : a) {
		cin >> i;
	}


	int sz = n * k;
	int ans = 0;
	for (int mask = 0; mask < deg2(sz); mask++) {
		vector<vector<int>> b(k, vector<int>(n, 0));
		for (int i = 0; i < sz; i++) {
			if (have(mask, i)) {
				b[i / n][i % n] = 1;
			}
		}
		int sm = 0;
		bool ok = true;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < k; j++) sm += b[j][i];
			int i_ = i - 1, j_ = k - 1;
			while (i_ >= 0 && j_ >= 0) {
				sm -= b[j_][i_];
				j_--; i_--;
			}
			if (sm != a[i]) ok = false;
		}
		if (ok) ans++;
	}


	cout << ans;
} 