#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;

//#define int ll


const int MOD = 1e9 + 7;


int deg2(int deg) {
	return (1 << deg);
}
bool have(int mask, int deg) {
	return mask & deg2(deg);
}


signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n, k;
	cin >> n >> k;
	vector<int> b(n);
	for (auto& i : b) {
		cin >> i;
	}


	vector<vector<int>> dp(n, vector<int>(deg2(3), 0));
	for (int mask = 0; mask < deg2(2); mask++) {
		if (have(mask, 0) + have(mask, 1) == b[0]) {
			dp[0][mask * 2]++;
		}
	}
	for (int i = 1; i < n; i++) {
		for (int prev = 0; prev < deg2(3); prev++) {
			if (dp[i - 1][prev] == 0) break;
			for (int j1 = 0; j1 <= 1; j1++) {
				for (int j2 = 0; j2 <= 1; j2++) {
					if (have(prev, 1) + j1 + j2 == b[i]) {
						int new_mask = have(prev, 1) + 2 * j1 + 4 * j2;
						dp[i][new_mask] = (dp[i][new_mask] + dp[i - 1][prev]) % MOD;
					}
				}
			}
		}
	}


	int ans = 0;
	for (auto& i : dp[n - 1]) {
		ans = (ans + i) % MOD;
	}
	cout << ans;
}