#include <iostream>
#include <algorithm>
#include <vector>


using namespace std;

using str = string;
using ll = long long;
using pii = pair<int, int>;

//#define int ll



signed main() {
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);


	int n, s;
	cin >> n >> s;
	vector<vector<int>> a(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (auto& j : a[i]) cin >> j;
	}


	vector<bool> dp(s + 1, false);
	dp[0] = true;
	vector<vector<pii>> par(n, vector<pii>(s + 1, {-1, -1}));
	for (int i = 0; i < n; i++) {
		vector<bool> new_dp(s + 1, false);
		for (int j = 0; j < (int) a[i].size(); j++) {
			int c = a[i][j];
			for (int sm = s - 1; sm >= 0; sm--) {
				int new_sm = sm + c;
				if (new_sm > s) continue;
				if (new_dp[new_sm]) continue;
				if (dp[sm]) {
					new_dp[new_sm] = true;
					par[i][new_sm] = { i - 1, j };
				}
				else if (new_dp[sm]) {
					new_dp[new_sm] = true;
					par[i][new_sm] = { i, j };
				}
			}
		}
		swap(dp, new_dp);
	}

	
	if (!dp[s]) {
		cout << "NO\n";
		exit(0);
	}

	vector<vector<int>> ans(n);
	int i = n - 1, sm = s;
	while (i != -1) {
		int j = par[i][sm].second;
		ans[i].push_back(j);
		int del = a[i][j];
		i = par[i][sm].first;
		sm -= del;
	}

	cout << "YES\n";
	for (int i = 0; i < n; i++) {
		cout << (int)ans[i].size() << "\n";
		for (auto& j : ans[i]) {
			cout << j + 1 << " ";
		}
		cout << "\n";
	}
}