﻿#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;



int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int N, K; cin >> N >> K;
    vector <long long> v(N);
    for (int i = 0; i < N; i++) {
        cin >> v[i];
    }

    if (K == 2) {
        long long OTV = 0;
        long long tekpref = v[0];
        long long teksuff = 0;
        for (int i = 1; i < N; i++) {
            teksuff += v[i];
        }
        OTV = abs(teksuff - tekpref);
        for (int i = 1; i < N - 1; i++) {
            tekpref += v[i];
            teksuff -= v[i];
            OTV = max(OTV, abs(teksuff - tekpref));
        }
        cout << OTV << endl;
        return 0;
    }





    int K2 = N - K + 1;
    vector <pair<long long, long long>> pref(N, {0, 0});
    pref[0].first = v[0]; pref[0].second = v[0];
    for (int i = 1; i < K2; i++) {
        pref[i].first = pref[i - 1].first + v[i];
        pref[i].second = pref[i - 1].second + v[i];
    }
    pref[K2 - 1].second = pref[K2 - 1].first;
    for (int i = K2; i < N; i++) {
        pref[i].first = pref[i - 1].first + v[i] - v[i - K2];
        pref[i].second = max(pref[i].first, pref[i - 1].second);
    }
    //for (int i = 0; i < N; i++) cout << pref[i].second << " ";


    vector <pair <long long, long long>> suff(N, {0, 0});
    suff[N - 1].first = v[N - 1]; suff[N - 1].second = v[N - 1];
    for (int i = N - 2; i >= N - K2; i--) {
        suff[i].first = suff[i + 1].first + v[i];
        suff[i].second = suff[i + 1].second + v[i];
    }
    suff[N - K2].second = suff[N - K2].first;
    for (int i = N - K2 - 1; i >= 0; i--) {
        suff[i].first = suff[i + 1].first + v[i] - v[i + K2];
        suff[i].second = max(suff[i].first, suff[i + 1].second);
    }
    //for (int i = 0; i < N; i++) cout << suff[i].second << " ";
    




    long long OTV = max(suff[1].second - v[0], pref[N - 2].second - v[N - 1]);
    for (int i = 1; i < N - 1; i++) {
        OTV = max(OTV, max(pref[i - 1].second, suff[i + 1].second) - v[i]);
    }
    cout << OTV << endl;
    return 0;



}
