﻿#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int cur;
vector <int> OTV;
void gen(vector <int>& v, vector <vector <int>>& dp, int S) {
    cur = 0;
    for (int i = 0; i < dp[S].size(); i++) {
        cur += v[dp[S][i]];
    }
    if (cur != S) {
        gen(v, dp, S - cur);
    } 

    for (int i = 0; i < dp[S].size(); i++) {
        OTV.push_back(dp[S][i] + 1);
    }
    
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int N, S; cin >> N >> S;

    if (N == 1) {
        int K; cin >> K;
        vector <int> v(K);
        for (int i = 0; i < K; i++) cin >> v[i];
        vector <vector <int>> dp(S + 1);
        for (int i = 0; i < K; i++) {
            for (int j = S - 1; j > 0; j--) {
                if (dp[j].size() != 0 && j + v[i] <= S && dp[j + v[i]].size() == 0) dp[j + v[i]].push_back(i);
            }
            if(v[i] <= S && dp[v[i]].size() == 0) dp[v[i]].push_back(i);
        }

        if (dp[S].size() != 0) { 
            cout << "Yes" << endl;
            gen(v, dp, S);
            cout << OTV.size() << endl;
            for (int i = 0; i < OTV.size(); i++) {
                cout << OTV[i] << " ";
            }
            cout << endl;
        }
        else cout << "NO" << endl;

    }
    return 0;
}
