﻿#include<string>
#include <iostream>
#include <vector>
#include <map>
using namespace std;
#define int long long

int podsch(vector<int> mn, int n ) {
	if (mn.size() < 3) {
		return 0;
	}
	int ans = 0;
	vector<int>pref(n);
	vector<int>suff(n);
	pref[0] = mn[0];
	suff[n - 1] = mn[n - 1];
	for (int i = 1; i < n; ++i) {
		pref[i] = max(pref[i - 1], mn[i]);
	}
	for (int i = n-2; i >-1; --i) {
		suff[i] = max(suff[i + 1], mn[i]);
	}
	for (int i = 1; i < n - 1; ++i) {
		if (mn[i] < pref[i] and mn[i] < suff[i]) {
			ans += min(pref[i], suff[i]) - mn[i];
		}
	}
	return ans;
}
signed main()
{
	int n;
	cin >> n;
	vector<int>h(n);
	vector<vector<int>>mnoj(n,vector<int>(1));
	
	map<int, int>uniq;
	for (int i = 0; i < n; ++i) {
		cin >> mnoj[i][0];
		uniq[mnoj[i][0]] = 1;
	}
	
	for (int i = 0; i < n - 1; ++i) {
		int k;
		cin >> k;
		if (uniq.size() == 1) {
			cout << 0 << '\n';
			continue;
		}
		for (auto j : mnoj[k]) {
			mnoj[k - 1].push_back(j);
		}
		int ans = podsch(mnoj[k-1],mnoj[k-1].size());
		mnoj.erase(mnoj.begin() + k);
	
		cout << ans << '\n';
	}

}

