#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3,unrool-loops")
#pragma GCC target("avx2")
#define isz(x) (int(x.size()))
using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

using ll = long long;
using vll = vector<ll>;
void solve();

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
// change the constant
const int N = 1e5+1;

vector<vector<int>> ans(N);

void one(vector<int>& a, int need, int index) {
    // solve rykzak
    // cout << "Here" << endl;
    int n = isz(a);
    vector<vector<bool>> dp(n, vector<bool>(need + 1));
    vector<vector<int>> p(n, vector<int>(need + 1, -1));
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 1;
        if (i != 0) {
            for (int j = 0; j <= need; ++j) {
                dp[i][j] = dp[i - 1][j];
                p[i][j] = p[i - 1][j];
            }
        }
        for (int j = need; j >= a[i]; --j) {
            if (dp[i][j - a[i]] && p[i][j] == -1) {
                dp[i][j] = 1;
                p[i][j] = i;
            }
        }
    }

    int cur = need;
    // cout << index << ":\n";
    while (p[n - 1][cur] != -1) {
        ans[index].push_back(p[n - 1][cur]);
        // cout << p[n - 1][cur] << endl;
        cur -= a[p[n - 1][cur]];
    }
}

void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int>> a(n);
    vector<bitset<N>> dp(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        dp[i][0] = 1;
        for (int j = 0; j < k; ++j) {
            int el; cin >> el;
            a[i].push_back(el);
            dp[i] |= (dp[i] << el);
        }
        dp[i][0] = 0;
        // sort(a[i].begin(), a[i].end());
    }
    // up OK
    vector<vector<int>> d(n, vector<int>(s + 1, 1e9+7));
    for (int i = 0; i < 1; ++i) {
        for (int j = 1; j <= s; ++j) {
            if (dp[i][j]) d[i][j] = i;
        }
    }
    // cout << "OK" << endl;

    bitset<N> hlp = dp[0];
    for (int i = 1; i < n; ++i) {
        for (int z = s; z > 0; --z) {
            for (int j = s - z; j > 0; --j) {
                if (dp[i][z] && d[i - 1][j] == i - 1) {
                    d[i][z+j] = i;
                }
            }
        }
        // need update
        for (int j = 1; j <= s; ++j) {
            if (d[i][j] == i) hlp[j] = 1;
        }
    }
    // check ans
    if (d[n - 1][s] == n - 1) {
        cout << "Yes\n";
        int cur = n - 1;
        int sum = s;
        while (cur > 0) {
            for (int i = 1; i <= s; ++i) {
                if (dp[cur][i] && d[cur - 1][s - i] == cur - 1) {
                    int need = i;
                    // cout << "need: " << need << endl;
                    one(a[cur], need, cur);
                    sum -= i;
                    break;
                }
            }
            --cur;
        }
        // cout << sum << endl;
        one(a[cur], sum, cur);
        for (auto& el : ans) {
            if (isz(el) == 0) break;
            cout << isz(el) << '\n';
            for (int ind : el) cout << ind + 1 << ' ';
            cout << '\n';
        }
    } else {
        cout << "No\n";
    }
}
