#include<iostream>
#include<vector>
using namespace std;
vector<long long> pref;
vector<long long> pref_min;
vector<long long> suf_min;
vector<long long> a;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    pref.resize(n+1);
    pref_min.resize(n+1);
    suf_min.resize(n+1);
    suf_min[n] = 1e18;

    for (int i = n-1; i >= 0; i--) {
        suf_min[i] = min(suf_min[i+1], a[i]);
    }
    pref_min[0] = 1e18;

    vector<long long> pref_suf(n+1);
    vector<long long> pref_pref(n+1);

    for (int i = 1; i <= n; i++) {
        pref[i] = a[i-1] + pref[i-1];
        pref_min[i] = min(pref_min[i-1], a[i-1]);
    }

    for (int i = 1; i <= n; i++) {
        pref_suf[i] = max(0ll, pref[i]-suf_min[i]);
    }
    int m = __lg(n)+1;
    vector<vector<long long>> spr(m, vector<long long>(n+1));
    spr[0] = pref_suf;
    for (int i = 1; i < m; i++) {
        for (int j = 0; j+(1<<(i-1)) < n; j++) {
            spr[i][j] = max(spr[i-1][j], spr[i-1][j+(1<<(i-1))]);
        }
    }

    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int fn = min(n, i+n-k+1);
        ans = max(ans, pref[fn] - pref[i] - pref_min[i]);
        int l = i+1;
        int r = fn+2;
        int p = __lg(r-l);
        long long val = max(spr[p][l], spr[p][r-(1<<p)]);
        ans = max(ans, val - pref[i]);
    }
    cout << ans << "\n";
}
