#include<iostream>
#include<vector>
#include<set>
using namespace std;
long long pow_mod(long long a, long long b, long long m) {
    if (b == 0) return 1;
    if (b % 2 == 0) {
        long long x = pow_mod(a, b/2, m);
        return (x*x)%m;
    }
    long long x = pow_mod(a, b/2, m);
    return (((x*a)%m)*x)%m;
}
long long ans = 0;
int n, m, k;
void rec(set<pair<int, int>> used, set<pair<int, int>> land, pair<int, int> cur, bool st, bool go, int cnt) {
    if (cur.first == m && cur.second == n) {
        go = false;
    }
    if (cur.first == 1 && cur.second == 1 && !st) {
        // << cnt << "\n";
        if (cnt == k) {
            ans++;
        }
        return;
    }
    if (go) {
        if (cur.first + 1 <= m && used.count({cur.first + 1, cur.second}) == 0) {
            int x = cnt;
            if (land.count({cur.first + 1, cur.second})) x++;
            set<pair<int, int>> usd;
            usd = used;
            usd.insert({cur.first + 1, cur.second});
            rec(usd, land, {cur.first + 1, cur.second}, false, go, x);
        }

        if (cur.second + 1 <= n && used.count({cur.first, cur.second+1})==0) {
            int x = cnt;
            if (land.count({cur.first, cur.second+1})) x++;
            set<pair<int, int>> usd;
            usd = used;
            usd.insert({cur.first, cur.second+1});
            rec(usd, land, {cur.first, cur.second+1}, false,go, x);
        }
    } else {
        if (cur.first - 1 >= 0 && used.count({cur.first - 1, cur.second})==0) {
            int x = cnt;
            if (land.count({cur.first - 1, cur.second})) x++;
            set<pair<int, int>> usd;
            usd = used;
            usd.insert({cur.first - 1, cur.second});
            rec(usd, land, {cur.first - 1, cur.second}, false,go, x);
        }

        if (cur.second - 1 >= 0 && used.count({cur.first, cur.second-1})==0) {
            int x = cnt;
            if (land.count({cur.first, cur.second-1})) x++;
            set<pair<int, int>> usd;
            usd = used;
            usd.insert({cur.first, cur.second-1});
            rec(usd, land, {cur.first, cur.second-1}, false, go,x);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> k;
    vector<pair<int, int>> stops(k);
    set<pair<int, int>> land;
    for (int i = 0; i < k; i++) {
        cin >> stops[i].first >> stops[i].second;
        land.insert({stops[i].first , stops[i].second});
    }
    long long mod = 1e9 + 7;

    set<pair<int,int>> used;
    int x = 0;
    if (land.count({1,1})) x = 1;
    rec(used, land, {1,1}, true, true, x);
    cout << ans;
    /*vector<long long> fact(5*10e6);
    fact[0] = 1;
    for (int i = 1; i < 5*10e6; i++) {
        fact[i] = (fact[i-1] * i)%mod;
    }
    vector<long long> refact(5*10e6);
    refact[0] = 1;
    for (int i = 1; i < 5*10e6; i++) {
        refact[i] = pow_mod(fact[i], mod-2, mod);
    }

    if (k == 0) {
        cout << pow_mod((((fact[n+m-2] * refact[n-1])%mod)*refact[m-1])%mod, 2, mod);
    }*/




}
