﻿#include <iostream>
#include <bitset>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;

const int g_size = 11;

signed main() {
    int n;
    cin >> n;
    int s;
    cin >> s;
    vector<int> k(n);
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        cin >> k[i];
        c[i].resize(k[i]);
        for (int j = 0; j < k[i]; j++) {
            cin >> c[i][j];
        }
    }
    vector<vector<vector<bool>>> dp(n);
    vector<bool> tek(s + 1, false);
    tek[0] = true;
    vector<vector<vector<int>>> pred(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(k[i], vector<bool>(s + 1, false));
        pred[i].resize(k[i], vector<int>(s + 1, -1));
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k[i]; j++) {
            for (int w = 0; w <= s; w++) {
                if (j != 0) {
                    if (dp[i][j - 1][w]) {
                        dp[i][j][w] = true;
                        pred[i][j][w] = 0;
                    }
                    if (w >= c[i][j]) {
                        if (dp[i][j - 1][w - c[i][j]]) {
                            dp[i][j][w] = true;
                            pred[i][j][w] = 1;
                        }
                    }
                }
                if (w >= c[i][j]) {
                    if (tek[w - c[i][j]]) {
                        dp[i][j][w] = true;
                        pred[i][j][w] = 2;
                    }
                }
            }
        }
        tek = dp[i].back();
    }
    if (dp[n - 1].back().back() == false) {
        cout << "No\n";
        return 0;
    }
    vector<vector<bool>> berem(n);
    for (int i = 0; i < n; i++) {
        berem[i].resize(k[i], false);
    }
    int i, j, w;
    i = n - 1;
    j = k[i] - 1;
    w = s;
    while (w != 0) {
        if (pred[i][j][w] == 0) {
            j--;
        }
        else if (pred[i][j][w] == 1) {
            w = w - c[i][j];
            berem[i][j] = true;
            j--;
        }
        else {
            w = w - c[i][j];
            berem[i][j] = true;
            i--;
            if (i == -1) {
                break;
            }
            j = k[i] - 1;
        }
    }
    vector<int> vs(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k[i]; j++) {
            if (berem[i][j]) {
                vs[i]++;
            }
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < n; i++) {
        cout << vs[i] << "\n";
        for (int j = 0; j < k[i]; j++) {
            if (berem[i][j]) {
                cout << j + 1 << " ";
            }
        }
        cout << "\n";
    }
}
