#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll d, l, r;
    cin >> d >> l >> r;

    int ans = 0;

    auto check = [&](ll a) {
        ll b = d / a;
        if (a % 2 != b % 2) return;
        ll x = (a + b) / 2;
        ll y = (a - b) / 2;
        if (x > 0 && y > 0 && l <= y * y && y * y < x * x && x * x <= r) ans++;
    };

    for (ll i = 1; i * i <= d; i++) {
        if (d % i != 0) continue;
        check(i);
        if (i * i != d) check(d / i);
    }

    cout << ans << '\n';
}
