#include <bits.h>
#include <iostream>
#include <vector>
using namespace std;
using loh = long long;

class block {
    struct element {
        element* prev_element = nullptr, *next_element = nullptr;
        loh value, max_value;
        vector <loh> elements, maximums_left = { 0 }, maximums_right = { 0 };
        void set_value(loh val) {
            value = val;
            max_value = val;
            elements.push_back(value);
        }
    }; element* first_element = nullptr, * lastelement = nullptr;
public:
    void add_element(loh value) {
        if (first_element == nullptr) {
            first_element = new element();
            first_element->set_value(value);
            lastelement = first_element;
        }
        else {
            lastelement->next_element = new element();
            lastelement->next_element->prev_element = lastelement;
            lastelement = lastelement->next_element;
            lastelement->set_value(value);
        }
    }

    loh merge(loh index) {
        element *now = first_element;
        while (index != 1) {
            now = now->next_element;
            index--;
        }
        loh our = now->elements.size();
        for (loh i = 0; i < now->next_element->elements.size(); i++) {
            now->elements.push_back(now->next_element->elements[i]);
            now->maximums_left.push_back(now->next_element->maximums_left[i]);
            now->maximums_right.push_back(now->next_element->maximums_right[i]);
        }
        for (loh i = 0; i < our; i++) {
            now->maximums_right[i] = max(now->next_element->max_value, now->maximums_right[i]);
        }

        for (loh i = our; i < now->elements.size(); i++) {
            now->maximums_left[i] = max(now->max_value, now->maximums_left[i]);
        }
        if (now->next_element != lastelement) {
            now->next_element = now->next_element->next_element;
            now->next_element->prev_element = now;
        }
        else {
            now->next_element = nullptr;
            lastelement = now;
        }
        loh summa = 0;
        for (loh i = 0; i < now->elements.size(); i++) {
            now->max_value = max(now->max_value, now->elements[i]);
            summa += max(0ll, min(now->maximums_left[i], now->maximums_right[i]) - now->elements[i]);
        }
        return summa;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    loh n; cin >> n;
    block solve;
    vector <loh> vc(n), instructions(n-1);
    for (loh i = 0; i < n; i++) {
        cin >> vc[i];
    }
    bool flag = true;
    for (loh i = 0; i < n - 1; i++) {
        cin >> instructions[i];
        if (instructions[i] != 1) {
            flag = false;
        }
    }
    if (!flag || flag) { //n < 1000
        for (loh i = 0; i < n; i++) {
            solve.add_element(vc[i]);
        }
        for (loh i = 0; i < n - 1; i++) {
            cout << solve.merge(instructions[i]) << "\n";
        }
    }
    else { //k = 1

    }
}
//n < 1000
/*8
9 1 8 1 5 2 3 6
3 3 1 3 3 2 1*/
