#include <bits/stdc++.h>
#define int long long

using namespace std;

int solve1(int n, int k, vector<int> a){
    int ans= 0;
    for(int i= 0; i < k; i++){
        int sum= 0, mx_l= -1e10, mx_r= -1e10;

        for(int shift= 0; shift < n + 1 - k; shift++) sum+= a[i + shift];
        for(int j= 0; j < i; j++) mx_l= max(mx_l, a[j]);
        for(int j= i + n - k + 1; j < n; j++) mx_r= max(mx_r, a[j]);

        if(mx_l == -1e10) mx_l= mx_r;
        if(mx_r == -1e10) mx_r= mx_l;

        int mx= max({sum, mx_l, mx_r});
        int mn= min({sum, mx_l, mx_r});

        ans= max(ans, mx - mn);
    }

    return ans;
}

int solve2(int n, int k, vector<int> a){
    vector<int> mx_p(n + 1), mx_s(n + 1), pref(n + 1, 0);
    for(int i= 0; i < n; i++) pref[i + 1]= pref[i] + a[i];

    mx_p[0]= a[0];
    for(int i= 1; i < n; i++) mx_p[i]= max(a[i], mx_p[i - 1]);

    mx_s[n - 1]= a[n - 1];
    for(int i= n - 2; i > -1; i--) mx_s[i]= max(a[i], mx_s[i + 1]);

    int ans= 0;
    for(int i= 0; i < k; i++){
        int sum= pref[i + n + 1 - k] - pref[i];
        int mx_l, mx_r= mx_s[i + n + 1 - k];

        if(i == 0) mx_l= mx_r;
        else mx_l= mx_p[i - 1];

        if(i == k - 1) mx_r= mx_l;

        int mx= max({sum, mx_l, mx_r});
        int mn= min({sum, mx_l, mx_r});

        ans= max(ans, mx - mn);
    }

    return ans;
}

signed main(){
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for(auto &x: a) cin >> x;

    cout << solve1(n, k, a);
}

