﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int f(string l, string r)
{
	vector <int> s;
	s.push_back(2);
	s.push_back(3);
	s.push_back(5);
	s.push_back(7);

	vector <bool> dp1(l.size() + 1), dp2(r.size() + 1);
	dp1.back() = true;
	dp2.back() = true;

	for (int i = (int)l.size() - 1; i >= 0; i--)
	{
		if (l[i] - '0' > 1)
		{
			dp1[i] = false;
		}
		else if (l[i] - '0' == 0)
		{
			dp1[i] = true;
		}
		else
		{
			dp1[i] = dp1[i + 1];
		}

		if (r[i] - '0' > 1)
		{
			dp2[i] = true;
		}
		else if (r[i] - '0' == 0)
		{
			dp2[i] = false;
		}
		else
		{
			dp2[i] = dp2[i + 1];
		}
	}

	bool flag1 = false;
	bool flag2 = false;
	int ans = 0;
	for (int i = 0; i < l.size(); i++)
	{
		for (auto x : s)
		{
			bool check = true;
			if (!flag1)
			{
				if (l[i] - '0' > x)
				{
					check = false;
				}
				else if (l[i] - '0' == x)
				{
					check = (check && dp1[i + 1]);
				}
			}

			if (!flag2)
			{
				if (r[i] - '0' < x)
				{
					check = false;
				}
				else if (r[i] - '0' == x)
				{
					check = (check && dp2[i + 1]);
				}
			}
			if (check)
			{
				//cout << x << " " << i << '\n';
				ans++;
			}
		}

		if (1 > l[i] - '0')
		{
			flag1 = true;
		}
		else if (l[i] - '0' > 1 && !flag1)
		{
			break;
		}
		if (1 < r[i] - '0')
		{
			flag2 = true;
		}
		else if (r[i] == '0' && !flag2)
		{
			break;
		}
	}
	return ans;
}

void solve()
{
	string l, r;
	cin >> l >> r;

	if (l.size() == r.size())
	{
		cout << f(l, r) << '\n';
		return;
	}

	string ll = l;

	string ss = "";
	for (int i = 0; i < r.size() - l.size(); i++)
	{
		ss += '0';
	}
	l = ss + l;
	
	int ans = f(l, r);

	int cnt = 0;
	for (int i = 0; i < l.size(); i++)
	{
		if (l[i] == '0')
		{
			cnt++;
		}
		else
		{
			break;
		}
	}

	string rr = "";
	for (int i = 0; i < ll.size(); i++)
	{
		rr += '9';
	}

	ans += f(ll, rr);

	for (int i = 0; i < cnt - 1; i++)
	{
		ans += 4 * (ll.size() + cnt - i - 1);
	}

	cout << ans << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
