﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

int add(int x, int y)
{
	if (x + y >= mod)
	{
		return x + y - mod;
	}
	return x + y;
}

void solve()
{
	int n, k;
	cin >> n >> k;
	vector <int> b(n);
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
	}

	int sz = ((int)1 << (k * (k - 1) / 2));
	int sz_old = ((int)1 << 22);

	vector <vector <int>> dp(n, vector <int>(sz, 0));

	vector <int> dp2(sz_old, 0);

	for (int i = 0; i < sz_old; i++)
	{
		int cnt = 0;
		int x = i;
		while (x > 0)
		{
			if (x % 2 == 1)
			{
				cnt++;
			}
			x /= 2;
		}
		dp2[i] = cnt;
	}

	for (int i = 0; i < ((int)1 << k); i++)
	{
		if (dp2[i] == b[0])
		{
			dp[0][i / 2 * ((int)1 << ((k * (k - 1) / 2 - (k - 1))))]++;
		}
	}

	for (int i = 1; i < n; i++)
	{
		for (int j = 0; j < sz; j++)
		{
			int x = 0;
			int ind = 0;
			int tek_sz = k - 1;
			int ind2 = (k * (k - 1)) / 2 - k;
			for (int jj = 0; jj < k * (k - 1) / 2; jj++)
			{
				if (jj == ind)
				{
					x *= 2;
					ind += tek_sz;
					tek_sz--;
				}
				else
				{
					x *= 2;
					if ((j & ((int)1 << ind2)))
					{
						x++;
					}
					ind2--;
				}
			}
			for (int ii = 0; ii < ((int)1 << k); ii++)
			{
				if (dp2[j] + dp2[ii] == b[i])
				{
					int ind = 0;
					int tek_sz = k - 1;
					for (int jj = 0; jj < k * (k - 1) / 2; jj++)
					{
						if (jj == ind)
						{
							if ((ii & ((int)1 << (k - 1 - tek_sz))))
							{
								x ^= ((int)1 << jj);
							}
							ind += tek_sz;
							tek_sz--;
						}
					}
					dp[i][j] = add(dp[i][j], dp[i - 1][x]);

					ind = 0;
					tek_sz = k - 1;
					for (int jj = 0; jj < k * (k - 1) / 2; jj++)
					{
						if (jj == ind)
						{
							if ((ii & ((int)1 << (k - 1 - tek_sz))))
							{
								x ^= ((int)1 << jj);
							}
							ind += tek_sz;
							tek_sz--;
						}
					}
				}
			}
		}
	}

	int ans = 0;
	for (int i = 0; i < sz; i++)
	{
		ans = add(ans, dp[n - 1][i]);
	}

	cout << ans << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
