﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

void solve()
{
	int n, k;
	cin >> n >> k;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	vector <int> pref(n + 1, 0);
	for (int i = 0; i < n; i++)
	{
		pref[i + 1] = pref[i] + a[i];
	}

	vector <int> pref_mn_l(n);
	vector <int> pref_mn_r(n);

	pref_mn_l[0] = a[0];
	for (int i = 1; i < n; i++)
	{
		pref_mn_l[i] = min(pref_mn_l[i - 1], a[i]);
	}

	pref_mn_r[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--)
	{
		pref_mn_r[i] = min(pref_mn_r[i + 1], a[i]);
	}

	int mx = 0;
	for (int i = 0; i < k; i++)
	{
		int mn = inf;
		if (i != 0)
		{
			mn = pref_mn_l[i - 1];
		}
		if (i != n - 1)
		{
			mn = min(mn, pref_mn_r[i + 1]);
		}

		mx = max(mx, pref[i + n - k + 1] - pref[i] - mn);
	}

	cout << mx << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
