﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

void solve()
{
	int n, s;
	cin >> n >> s;

	vector <bool> a(s + 1, false);
	a[0] = true;

	vector <vector <pair <int, int>>> g(n, vector <pair <int, int>>(s + 1, {-1, -1}));
	vector <vector <int>> g2(n);

	for (int i = 0; i < n; i++)
	{
		vector <bool> b(s + 1, false);

		int k;
		cin >> k;
		g2[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			int c;
			cin >> c;
			g2[i][j] = c;

			for (int w = s; w >= 0; w--)
			{
				if (w >= c && b[w - c])
				{
					if (!b[w])
					{
						b[w] = true;
						g[i][w] = {j, 0};
					}
				}
			}

			for (int w = 0; w <= s; w++)
			{
				if (a[w] && w + c <= s)
				{
					if (!b[w + c])
					{
						b[w + c] = true;
						g[i][w + c] = {j, 1};
					}
				}
			}
		}

		a = b;
	}

	if (a[s])
	{
		cout << "Yes" << '\n';
		vector <vector <int>> ans(n);

		int w = s;
		int ind = n - 1;
		while (w > 0)
		{
			auto [j, flag] = g[ind][w];
			w -= g2[ind][j];
			ans[ind].push_back(j);

			if (flag)
			{
				ind--;
			}
		}

		for (int i = 0; i < n; i++)
		{
			cout << ans[i].size() << '\n';
			for (auto j : ans[i])
			{
				cout << j + 1 << " ";
			}
			cout << '\n';
		}
	}
	else
	{
		cout << "No" << '\n';
	}
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
