﻿#include "iostream"
#include "vector"
#include "set"
#include "map"
#include "algorithm"
#include <string>

using namespace std;

#define int long long

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000;

int mod = 1000 * 1000 * 1000 + 7;

int cnk(int n, int k)
{
	int ans = 1;
	for (int i = 1; i <= n; i++)
	{
		ans *= i;
	}
	for (int i = 1; i <= k; i++)
	{
		ans /= i;
	}
	for (int i = 1; i <= k; i++)
	{
		ans /= i;
	}
	return ans;
}

int f(int n, int m)
{
	if (n == 0 || m == 0)
	{
		return 1;
	}
	return cnk(n + m - 2, n - 1);
}

void solve()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <bool>> visited(n, vector <bool>(m, false));

	vector <pair <int, int>> check(k);
	for (int i = 0; i < k; i++)
	{
		cin >> check[i].first >> check[i].second;
		check[i].first--;
		check[i].second--;
	}

	vector <vector <int>> g;
	for (int i = 0; i < (1 << (n + m - 2)); i++)
	{
		vector <int> a(n + m - 2, 0);
		int cnt = 0;
		for (int j = 0; j < n + m - 2; j++)
		{
			if (i & (1 << j))
			{
				cnt++;
				a[j] = 1;
			}
		}
		if (cnt == n - 1)
		{
			g.push_back(a);
		}
	}

	int ans1 = 0;
	int ans2 = 0;

	int ans0 = 0;

	for (int i = 0; i < g.size(); i++)
	{
		vector <int> a = g[i];
		for (int j = 0; j < g.size(); j++)
		{
			vector <int> b = g[j];
			bool flag = true;
			for (int ii = 0; ii < n; ii++)
			{
				for (int jj = 0; jj < m; jj++)
				{
					visited[ii][jj] = false;
				}
			}

			int x = 0, y = 0;
			for (int ii = 0; ii < a.size() - 1; ii++)
			{
				if (a[ii] == 0)
				{
					y++;
				}
				else
				{
					x++;
				}

				visited[x][y] = true;
			}
			
			x = n - 1;
			y = m - 1;

			for (int ii = 0; ii < b.size() - 1; ii++)
			{
				if (b[ii] == 0)
				{
					y--;
				}
				else
				{
					x --;
				}

				if (visited[x][y])
				{
					flag = false;
				}
				visited[x][y] = true;
			}
			
			visited[0][0] = true;
			visited[n - 1][m - 1] = true;
			
			for (int ii = 0; ii < k; ii++)
			{
				if (!visited[check[ii].first][check[ii].second])
				{
					flag = false;
				}
			}
			
			if (flag)
			{
				if (i == j)
				{
					ans2++;
				}
				else
				{
					ans1++;
				}
				ans0++;
			}
		}
	}
	int ans = ans1 * 2 + ans2;
	ans %= mod;
	cout << ans0 % mod << '\n';
}

signed main()
{
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	int _ = 1;
	//cin >> _;
	while (_--)
	{
		solve();
	}
}
