#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

const int mod = 1e9 + 7;

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    if (k == 0) {
        vector <vector <int>> dp(n, vector <int> (m));
        for (int i = 0; i < n; ++i) {
            //cout << "$";
            for (int j = 0; j < m; ++j) {
                dp[i][j] = 0;
            }
        }
        dp[0][0] = 1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i - 1 >= 0) {
                    dp[i][j] = (dp[i][j] + dp[i - 1][j]) % mod;
                }
                if (j - 1 >= 0) {
                    dp[i][j] = (dp[i][j - 1] + dp[i][j]) % mod;
                }
            }
        }
        cout << dp[n - 1][m - 1] % mod;
    }
}
