#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

void solve() {
    string l, r;
    cin >> l >> r;

    auto len = [&](int l, int p) {
        if (l == 0) {
            if (p == 0) return 1;
            return 0;
        }
        if (p == 0) return 1;
        return l;
    };

    auto calc = [&](string s) {
        ll res = 0;
        reverse(all(s));
        vector<vector<ll>> dp(s.size() + 1, vector<ll>(5));
        dp[0][0] = 1;
        for (int i = 1; i <= s.size(); i++) {
            for (int j = 0; j < 5; j++) {
                for (char c = '1'; c <= s[i - 1]; c++) {
                    if (c == '1') dp[i][j] += (c == s[i - 1] ? dp[i - 1][j] : len(i - 1, j));
                    if (c == '2' && j == 1) dp[i][j] += (c == s[i - 1] ? dp[i - 1][0] : len(i - 1, 0));
                    if (c == '3' && j == 2) dp[i][j] += (c == s[i - 1] ? dp[i - 1][0] : len(i - 1, 0));
                    if (c == '5' && j == 3) dp[i][j] += (c == s[i - 1] ? dp[i - 1][0] : len(i - 1, 0));
                    if (c == '7' && j == 4) dp[i][j] += (c == s[i - 1] ? dp[i - 1][0] : len(i - 1, 0));
                }
                //cout << i << " " << j << ": " << dp[i][j] << "\n";
                if (j > 0) {
                    if (i == s.size()) res += dp[i][j];
                    else res += len(i, j);
                }
            }
        }
        //cout << res << "\n";
        return res;
    };

    auto check = [](string s) {
        bool is2 = false, is3 = false, is5 = false, is7 = false;
        bool gd = true;
        for (char c : s) {
            if (c == '0' || c == '4' || c == '6' || c == '8' || c == '9') gd = false;
            else if (c == '2') {
                if (is2) gd = false;
                is2 = true;
            }
            else if (c == '3') {
                if (is3) gd = false;
                is3 = true;
            }
            else if (c == '5') {
                if (is5) gd = false;
                is5 = true;
            }
            else if (c == '7') {
                if (is7) gd = false;
                is7 = true;
            }
        }
        return gd && ((int)is2 + (int)is3 + (int)is5 + (int)is7 == 1);
        };

    cout << calc(r) - calc(l) + (int)check(l);
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}