#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

const int mod = 1e9+7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int& x : v) cin >> x;
    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = k; j >= max(1, k - i); j--) s += j;
        if (v[i] > s) {
            cout << 0;
            return;
        }
    }

    int sz = k * (k + 1) / 2, mask1 = (1 << (sz - k)) - 1;
    vector<vector<pair<int, int>>> ms(sz + 1);
    for (int i = 0; i < (1 << sz); i++) {
        int pr = 0;
        for (int j = k; j > 1; j--) {
            pr = (pr << (j - 1)) + ((i >> (j * (j - 1) / 2)) & ((1 << (j - 1)) - 1));
        }
        ms[__builtin_popcount(i)].emplace_back(i & mask1, pr);
    }
    for (int i = 0; i <= sz; i++) {
        ms[i].shrink_to_fit();
    }

    vector<int> dp(1 << (sz - k)), ndp(1 << (sz - k));
    dp[0] = 1;
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (auto [a, b] : ms[v[i]]) {
            ndp[b] += dp[a];
            if (ndp[b] >= mod) ndp[b] -= mod;
        }
        dp.swap(ndp);
        if (i + 1 < n) {
            fill(all(ndp), 0);
        } else {
            for (int j = 0; j < dp.size(); j++) {
                ans += dp[j];
                if (ans >= mod) ans -= mod;
            }
        }
    }

    cout << ans;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}