#include <bits/stdc++.h>
using ll = long long;
#define all(v) (v).begin(), (v).end()

const int mod = 1e9+7;

void solve() {
    int n, k;
    std::cin >> n >> k;
    std::vector<int> v(n);
    for (int& x : v) std::cin >> x;

    int sz = k * (k + 1) / 2, mask1 = (1 << (sz - k)) - 1;
    std::vector<int> in(sz + 1);
    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = k; j >= std::max(1, k - i); j--) s += j;
        if (v[i] > s) {
            std::cout << 0;
            return;
        }
        in[v[i]] = 1;
    }

    if (k == 7) {
        int ans = 0;
        std::vector<std::vector<int>> dp(22, std::vector<int>(1 << 15)), ndp(22, std::vector<int>(1 << 15));
        std::vector<int> indd = std::vector<int>({1, 3, 4, 6, 7, 8, 10, 11, 12, 13});
        dp[0][0] = 1;
        for (int i = 0; i < n; i++) {
            for (int mask = 0; mask < (1 << 7); mask++) {
                int ndd = v[i] - __builtin_popcount(mask);
                if (ndd < 0) continue;
                for (int pr = 0; pr < (1 << 15); pr++) {
                    if (!dp[ndd][pr]) continue;
                    int nw = 0;
                    for (int j = 0; j < indd.size(); j++) {
                        nw ^= ((pr >> indd[j]) & 1) << j;
                    }
                    nw ^= (mask & ((1 << 5) - 1)) << 10;
                    int ss = v[i] - ((mask >> 6) & 1);
                    ndp[ss][nw] += dp[ndd][pr];
                    if (ndp[ss][nw] >= mod) ndp[ss][nw] -= mod;
                }
            }

            dp.swap(ndp);
            if (i + 1 < n) {
                for (int i = 0; i < ndp.size(); i++) {
                    fill(all(ndp[i]), 0);
                }
            } else {
                for (int j = 0; j < dp.size(); j++) {
                    for (int j2 = 0; j2 < dp[j].size(); j2++) {
                        ans += dp[j][j2];
                        if (ans >= mod) ans -= mod;
                    }
                }
            }
        }

        std::cout << ans;
    } else {
        std::vector<std::vector<std::pair<int, int>>> ms(sz + 1);
        for (int i = 0; i < (1 << sz); i++) {
            if (!in[__builtin_popcount(i)]) continue;
            int pr = 0;
            for (int j = k; j > 1; j--) {
                pr = (pr << (j - 1)) + ((i >> (j * (j - 1) / 2)) & ((1 << (j - 1)) - 1));
            }
            ms[__builtin_popcount(i)].emplace_back(i & mask1, pr);
        }
        for (int i = 0; i <= sz; i++) {
            ms[i].shrink_to_fit();
        }

        std::vector<int> dp(1 << (sz - k)), ndp(1 << (sz - k));
        dp[0] = 1;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (auto [a, b] : ms[v[i]]) {
                ndp[b] += dp[a];
                if (ndp[b] >= mod) ndp[b] -= mod;
            }
            dp.swap(ndp);
            if (i + 1 < n) {
                fill(all(ndp), 0);
            } else {
                for (int j = 0; j < dp.size(); j++) {
                    ans += dp[j];
                    if (ans >= mod) ans -= mod;
                }
            }
        }

        std::cout << ans;
    }
}

int main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    solve();
}