#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    vector<ll> pref(n), suff(n);
    for (int i = 0; i < n; i++) {
        pref[i] = v[i];
        if (i > 0) pref[i] = min(pref[i], pref[i - 1]);
    }
    for (int i = n - 1; i >= 0; i--) {
        suff[i] = v[i];
        if (i + 1 < n) suff[i] = min(suff[i], suff[i + 1]);
    }

    ll ans = 0, sum = 0, sz = n - k + 1;
    for (int i = 0; i < sz; i++) {
        sum += v[i];
    }
    for (int i = 0; i + sz - 1 < n; i++) {
        if (i > 0 && sum >= pref[i - 1]) ans = max(ans, sum - pref[i - 1]);
        if (i + sz < n && sum >= suff[i + sz]) ans = max(ans, sum - suff[i + sz]);
        if (i + sz < n) sum += v[i + sz];
        sum -= v[i];
    }
    cout << ans;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}