#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;
#define all(v) (v).begin(), (v).end()

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    vector<ll> pref(n), suff(n);
    ll sum = 0, sz = n - k + 1;
    for (int i = 0; i < n; i++) {
        sum += v[i];
        if (i >= sz) sum -= v[i - sz];
        pref[i] = sum;
        if (i > 0) pref[i] = max(pref[i], pref[i - 1]);
    }
    for (int i = n - 1; i >= 0; i--) {
        sum += v[i];
        if (i + sz < n) sum -= v[i + sz];
        suff[i] = sum;
        if (i + 1 < n) suff[i] = max(suff[i], suff[i + 1]);
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        if (i > 0) ans = max(ans, abs(v[i] - pref[i - 1]));
        if (i + 1 < n) ans = max(ans, abs(v[i] - suff[i + 1]));
    }
    cout << ans;
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    solve();
}