#include <iostream>
#include <cmath>
using namespace std;
using ll = long long;

constexpr double eps = 1e-6;

bool isSqr(ll s)
{
    double r = sqrt(s);
    return abs(r-int(r)) < eps;
}


int main()
{
    ll d, l, r; cin >> d >> l >> r;
    int count = 0;
    for(ll i = 1; i <= r; i++){
        ll temp = i*i;
        if(temp > r) break;
        if(isSqr(d + temp) && temp>=l && temp<=r && temp+d >= l && temp +d <= r) {count++; }
    }
    cout << count;
    return 0;
}