#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

void prost(ll d, vector <ll> &del) {
    for (ll i = 1; i <= sqrt(d); i++) {
        if (d % i == 0) {
            del.push_back(i);
        }
    }
}

int main() {
    ll d, l, r;

    cin >> d >> l >> r;

    ll right = sqrt(r);
    ll left = sqrt(l);

    if (left * left != l) {
        left++;
    }

    vector <ll> del;

    prost(d, del);

    // for (int i = 0; i < del.size(); i++) {
    //     cout << del[i] << " ";
    // }

    // cout << "\n";

    ll t1, t2, b, a;

    ll counter = 0;

    for (int i = 0; i < del.size(); i++) {
        t1 = max(del[i], d / del[i]);
        t2 = min(d / del[i], del[i]);

        if ((t1 - t2) % 2 == 0) {
            b = (t1 - t2) / 2;
            a = t1 - b;

            // cout << a << " " << b << "\n";

            if (a >= left && a <= right && b >= left && b <= right && ((a - b) * (a + b) == d)) {
                counter++;
            }
        }
    }

    cout << counter << "\n";
}