#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

ll answer = LONG_MIN;

void perebor(vector <ll> arr, vector <ll> pref, vector <ll> curr, int k, int index) {
    if (curr.size() == (k - 1)) {
        // for (int i = 0; i < curr.size(); i++) {
        //     cout << curr[i] << " ";
        // }

        // cout << "\n";

        ll min_sum = LONG_MAX;
        ll max_sum = LONG_MIN;

        for (int i = 0; i < curr.size(); i++) {
            ll curr_sum = 0;

            if (i == 0) {
                curr_sum = pref[curr[i] - 1];
            } else {
                curr_sum = pref[curr[i] - 1] - pref[curr[i - 1] - 1];
            }

            min_sum = min(min_sum, curr_sum);
            max_sum = max(max_sum, curr_sum);
        }

        ll last_sum = pref[pref.size() - 1] - pref[curr[curr.size() - 1] - 1];

        min_sum = min(min_sum, last_sum);
        max_sum = max(max_sum, last_sum);

        answer = max(answer, (max_sum - min_sum));

        return;
    }

    if (index > arr.size() - 1) {
        return;
    }

    if (curr.size() == 0 || index == 0) {
        for (int i = 1; i <= arr.size() - 1; i++) {
            curr.push_back(i);

            int temp = index;

            index = i + 1;
            
            perebor(arr, pref, curr, k, index);

            curr.pop_back();

            index = temp;
        }

        return;
    } else {
        for (int i = index; i <= arr.size() - 1; i++) {
            curr.push_back(i);

            int temp = index;
            
            index = i + 1;

            // for (int j = 0; j < curr.size(); j++) {
            //     cout << curr[j] << " ";
            // }

            // cout << "\n";

            // for (int j = 0; j < curr.size(); j++) {
            //     cout << curr[j] << " ";
            // }
            
            // cout << "\n";
                        
            perebor(arr, pref, curr, k, index);

            curr.pop_back();

            perebor(arr, pref, curr, k, index);

            index = temp;
        }
    }

    return;
}

int main() {
    int n, k;

    cin >> n >> k;

    vector <ll> arr(n);
    vector <ll> pref_sum(n);

    for (int i = 0; i < n; i++) {
        cin >> arr[i];

        if (i != 0) {
            pref_sum[i] = pref_sum[i - 1] + arr[i];
        } else {
            pref_sum[0] = arr[0];
        }
    }

    if (k == 2) {
        cout << pref_sum[n - 1] - (2 * min(arr[0], arr[arr.size() - 1])) << "\n";

        return 0;
    }

    if (k == 3) {
        ll answer = LONG_MIN;

        for (int i = 1; i < n - 1; i++) {
            ll first = pref_sum[i - 1];
            ll maxim = pref_sum[n - 1] - pref_sum[i - 1] - min(arr[i], arr[n - 1]);
            ll minim = min(arr[i], arr[n - 1]);

            answer = max(answer, max(abs(maxim - minim), abs(maxim - first)));
            answer = max(answer, (first - minim));
        }

        cout << answer << "\n";
    }

    // for (int i = 0; i < n; i++) {
    //     cout << pref_sum[i] << " ";
    // }

    // cout << "\n";

    ll min_sum = LONG_MAX;
    ll max_sum = LONG_MIN;
    vector <ll> curr;

    curr.clear();

    int index = 0;

    perebor(arr, pref_sum, curr, k, index);

    cout << answer << "\n";
}