﻿#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

void solA() {
    ll n, m, k;
    cin >> n >> m >> k;
    n--;
    m--;
    if (n < m) swap(n, m);
    ll ans = (m + k - 1) / k;
    n -= m;
    ans += (n + k - 1) / k;
    cout << ans;
}

int fun(char a) {
    int n = 0;

    vector <char> p = { '2', '3', '5', '7' };
    while (n < 4 && p[n] != a) n++;
    return n;
}

void solB(string l, string r) {
    vector <char> p = { '2', '3', '5', '7'};

    string t1;
    int k1 = -1;
    for (int i = 0; i < l.length(); i++) t1 += "1";
    bool f = 0;
    for (int i = l.length() - 1; i >= 0; i--) {
        for (int j = 0; j < 4; j++) {
            t1[i] = p[j];
            if (t1 >= l) {
                f = 1;
                k1 = i;
                break;
            }
        }
        if (f) {
            break;
        }
        t1[i] = '1';
    }
    if (k1 == -1) {
        t1[t1.length() - 1] = '2';
        k1 = t1.length() - 1;
    }

    string t2;
    int k2 = -1;
    for (int i = 0; i < r.length(); i++) t2 += "1";
    f = 0;
    for (int i = 0; i < r.length(); i++) {
        for (int j = 3; j >= 0; j--) {
            t2[i] = p[j];
            if (t2 <= r) {
                f = 1;
                k2 = i;
                break;
            }
        }
        if (f) {
            break;
        }
        t2[i] = '1';
    }
    if (k2 == -1) {
        t2 = t2.substr(0, t2.length() - 1);
        if (t2.length() == 0) t2 = "2";
        else t2[0] = '7';
        k2 = 0;
    }

    if (t1.length() > r.length() || (t1.length() == r.length() && t1 > r) || (t2.length() == l.length() && t2 < l) || t2.length() < l.length()) {
        cout << 0;
        return;
    }

    if (t1.length() == t2.length()) {
        if (k1 == k2) {
            cout << fun(t2[k2]) - fun(t1[k1]) + 1;
            return;
        }
        else {
            cout << (k2 - k1 - 1) * 4 + 4 - fun(t1[k1]) + fun(t2[k2]) + 1;
        }
    }

    cout << (t1.length() + t2.length()) * (t2.length() - t1.length() - 1) * 2 + k1 * 4 + 4 - fun(t1[k1]) + ((t2.length() - k2 - 1) * 4 + fun(t2[k2]) + 1);
}

void solnotB() {
    string l, r;
    cin >> l >> r;
    vector <char> p = { '2', '3', '5', '7' };

    /*
    bool f1 = 1;
    for (int i = 1; i < r.length(); i++) f1 &= (r[i] == '0');
    if (f1 && l == "1" && r[0] == '1') solB(l, r);
    */

    if (r.length() > 1e3) {
        solB(l, r);
        return;
    }

    string t1;
    ll ans = 0;
    for (int i = 0; i < l.length() - 1; i++) t1 += "1";
    for (int g = l.length(); g <= r.length(); g++) {
        t1 += "1";
        for (int i = t1.length() - 1; i >= 0; i--) {
            for (int j = 0; j < 4; j++) {
                t1[i] = p[j];
                if ((t1.length() > l.length() || t1 >= l) && (t1.length() < r.length() || t1 <= r)) {
                    ans++;
                }
            }
            t1[i] = '1';
        }
    }
    cout << ans;
}

int find_p(int a, vector <int> k) {
    while (k[a] != a) a = k[a];
    return a;
}
void unite(int a, int b, vector <int> k) {
    k[b] = find_p(a, k);
}

void solC1(vector <int> h, int c) {
    int n = h.size();
    vector <ll> k(n + 2), l(n + 2), r(n + 2);
    for (int i = 1; i < n + 2; i++) {
        k[i] = i;
        l[i] = i;
        r[i] = i;
    }
    vector <int> q(n - 1);
    for (int i = 0; i < n - 1; i++) cin >> q[i];

    int t = c;
    ll w = 0;
    for (int g = 0; g < n - 1; g++) {
        if (q[g] < t || q[g] > t + 1) w = 0;
        else {
            w = min(h[k[q[g]]], h[k[q[g] + 2] - 1]) - h[c];
            if (q[g] == t + 1) t--;
        }
        cout << w << '\n';
        for (int i = q[g] + 1; i < n + 1; i++) k[i] = k[i + 1];
    }
}

void solC() {
    int n;
    cin >> n;
    vector <int> h(n + 2);
    for (int i = 1; i <= n; i++) cin >> h[i];
    /*
    int c = 1;
    while (c < n && h[c] >= h[c + 1]) c++;
    int c1 = c;
    while (c < n && h[c] <= h[c + 1]) c++;
    if (c == n) {
        solC1(h, c1);
        return;
    }
    */
    vector <ll> k(n + 2), l(n + 2), r(n + 2);
    for (int i = 1; i < n + 2; i++) {
        k[i] = i;
        l[i] = i;
        r[i] = i;
    }
    vector <int> q(n - 1);
    for (int i = 0; i < n - 1; i++) cin >> q[i];
    for (int g = 0; g < n - 1; g++) {
        for (int i = k[q[g] + 1] - 1; i >= k[q[g]]; i--) {
            if (h[r[i + 1]] > h[r[i]]) r[i] = r[i + 1];
        }
        for (int i = k[q[g] + 1]; i < k[q[g] + 2]; i++) {
            if (h[l[i - 1]] > h[l[i]]) l[i] = l[i - 1];
        }
        ll w = 0;
        for (int i = k[q[g]]; i < k[q[g] + 2]; i++) w += min(h[r[i]], h[l[i]]) - h[i];
        cout << w << '\n';
        for (int i = q[g] + 1; i < n + 1; i++) k[i] = k[i + 1];
    }
}

void solD() {
    int n, k;
    cin >> n >> k;
    vector <int> b(n);
    for (int i = 0; i < n; i++) cin >> b[i];
    vector <vector <bool>> d(k, vector <bool>(n));
    ll ans = 0;
    for (ll g = 0; g < (1 << (n * k)); g++) {
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < n; j++) {
                if (g & (1 << (n * i + j))) d[i][j] = 1;
                else d[i][j] = 0;
            }
        }

        ll  c = 0;
        bool f = 1;
        for (int i = 0; i < n; i++) {
            c = 0;
            for (int j = 0; j <= i; j++) {
                for (int g = 0; g + j < k; g++) {
                    c += d[g][i - j];
                }
            }
            if (c != b[i]) {
                f = 0;
                break;
            }
        }
        if (f) ans++;
    }

    cout << ans;
}

int main() {
    int o = 1;
    //cin >> 0;
    for (int oo = 0; oo < o; oo++) {
        solD();
    }
    return 0;
}
