#include<iostream>
#include<vector>
using namespace std;
#define ll long long
const ll SIZE = 2e9;
struct node
{
    node* left = nullptr;
    node* right = nullptr;
    ll mx = 0;
};
void is(node* root)
{
    if(root->left==nullptr)root->left=new node;;
    if(root->right==nullptr)root->right=new node;
}
ll add(node* root, ll l, ll r, ll q_l, ll q_r, ll val)
{
    if(l>q_r ||r<q_l) return 0;
    is(root);
    if(l>=q_l && r<=q_r)
    {
        return root->mx = max(root->mx, val);
    }
    ll m = (l+r)/2;
    return root->mx = max(root->mx, max(add(root->left, l, m, q_l, q_r, val), add(root->right, m+1, r, q_l, q_r, val)));
}
ll get(node* root, ll l, ll r, ll q_l, ll q_r)
{
    if(l>q_r || r<q_l) return 0;
    if(l>=q_l && r<=q_r) return root->mx;
    ll m = (l+r)/2;
    return max(get(root->left, l, m,q_l,q_r), get(root->right,m+1,r,q_l,q_r));
}
int main()
{
    ll n,k;
    cin>>n>>k;
    vector<ll>arr(n);
    for(int i=0;i<n;++i)
    {
        cin>>arr[i];
    }
    vector<ll>pref(n);
    vector<ll>suf(n);
    pref[0]=arr[0];
    suf[n-1]=arr[n-1];
    for(int i=1;i<n;++i)
    {
        pref[i]=pref[i-1]+arr[i];
    }
    for(int i=n-2;i>=0;--i)
    {
        suf[i]=suf[i+1]+arr[i];
    }
    if(k==2)
    {
        ll res = 0;
        for(int m=0;m<n-1;++m)
        {
            res=max(res, abs(pref[m]- suf[m+1]));
        }
        cout<<res;
        return 0;
    }
    ll len = n-k+1;
    node* preE = new node;
    vector<ll>prefT(n);
    for(int i=0;i<n;++i)
    {
        if(i==0) prefT[i] = pref[i+len-1];
        else prefT[i] = pref[min(n-1, i+len-1)]-pref[i-1];
        add(preE, 0, SIZE, i, i, prefT[i]);
    }
    vector<ll>sufT(n);
    node* sufE = new node;
    for(int i=n-1;i>=0;--i)
    {
        if(i==n-1) sufT[i] = suf[n-len];
        else sufT[i] = suf[max(0ll, i-len+1)]-suf[i+1];
        add(sufE, 0, SIZE, i, i, sufT[i]);
    }

    ll res = 0;
    for(int i=0;i<n;++i)
    {
        ll mx =0;
        if(i==0)
        {
            mx = get(preE, 0, SIZE, i+1, n-1);
        }
        else if(i==n-1)
        {
            mx = get(sufE, 0, SIZE, 0, i-1);
        }
        else
        {
            mx = max(get(preE, 0, SIZE, i+1, n-1), get(sufE, 0, SIZE, 0, i-1));
        }
        res=max(res, abs(mx-arr[i]));
    }
    cout<<res;
    return 0;
}
