
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> dtree;
using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (auto& item: vec)
		in >> item;
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
	for (auto& item : vec)
		out << item << " ";
	return out;
}
#define ll long long
ll solve (string &r) {
    ll n = r.size();
    ll ans = 2 * n * (n - 1);
    vector<int> d(r.size());
    for (int i = 0; i < r.size(); i++)
        d[i] = r[i] - '0';
    bool cur = true;
    for (int i = 0; i < n; i++) {
        if (cur) {
            if (d[i] == 1)
                continue;
            if (d[i] == 0)
                break;
            bool flag = true;
            for (int j = i + 1; j < n; j++) {
                if (d[j] > 1)
                    break;
                if (d[j] == 0) {
                    flag = false;
                    break;
                }
            }
            ll mx = d[i] - 1;
            if (flag)
                mx++;
            if (mx >= 2)
                ans++;
            if (mx >= 3)
                ans++;
            if (mx >= 5)
                ans++;
            if (mx >= 7)
                ans++;
            cur = false;
        }
        else {
            ans += 4ll;
        }
    }
    return ans;
}

bool check (string &s) {
    int n = s.size();
    vector<int> d(s.size());
    for (int i = 0; i < s.size(); i++)
        d[i] = s[i] - '0';
    int cur = -1;
    for (int i = 0; i < n; i++) {
        if (d[i] == 1)
            continue;
        if (cur == -1) {
            cur = d[i];
        } else
            return false;
    }
    return (cur == 2) || (cur == 3) || (cur == 5) || (cur == 7);
}

int main()
{
	string l, r;
	cin >> l >> r;

	cout << solve(r) - solve(l) + check(l) << "\n";
}
