#pragma GCC optimize("unroll-loops", "O3")

#include <bits/stdc++.h>
using namespace std;

#define int long long

vector<vector<bool>> pathsRes;

void paths (int n, int ind, int k, vector<bool> &cur) {
    if (k > n - ind)
        return;
    if (k == n - ind) {
        vector<bool> res = cur;
        for (int i = ind; i < n; i++)
            res.push_back(1);
        pathsRes.push_back(res);
        return;
    }
    if (k == 0) {
        vector<bool> res = cur;
        for (int i = ind; i < n; i++)
            res.push_back(0);
        pathsRes.push_back(res);
        return;
    }
    cur.push_back(0);
    paths(n, ind + 1, k, cur);
    cur.pop_back();
    cur.push_back(1);
    paths(n, ind + 1, k - 1, cur);
    cur.pop_back();
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<bool> temp;
    paths(n + m - 2, 0, n - 1, temp);
    vector<pair<int, int>> cords(k);
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        cords[i] = {x - 1, y - 1};
    }
    int cnt = 0;
    for (int i = 0; i < pathsRes.size(); i++) {
        int curX = 0, curY = 0;
        set<pair<int, int>> st1;
        st1.insert({0, 0});
        for (auto c: pathsRes[i]) {
            if (c)
                curX++;
            else
                curY++;
            st1.insert({curX, curY});
        }
        for (int j = i + 1; j < pathsRes.size(); j++) {
            curX = 0, curY = 0;
            set<pair<int, int>> st2;
            for (auto c: pathsRes[j]) {
                if (c)
                    curX++;
                else
                    curY++;
                if (curX != n - 1 || curY != m - 1) {
                    if (st1.find({curX, curY}) == st1.end()) {
                        st2.insert({curX, curY});
                    } else {
                        break;
                    }
                }
            }
            if (st2.size() != st1.size() - 2)
                continue;
            bool flag = true;
            for (int j = 0; j < k; j++) {
                auto [x, y] = cords[j];
                if (st1.find({x, y}) == st1.end() && st2.find({x, y}) == st2.end()) {
                    flag = false;
                    break;
                }
            }
            if (flag)
                cnt++;
        }
    }
    cout << cnt * 2;
}
