// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _AB
{
	ull a;
	ull b;
} ABPair;

std::vector<ABPair> ABPairs;

void dels(ull val)
{
	ABPair p;
	for (ull i = 2; i < ceil(sqrt(val)) + 1; i++)
	{
		if (val % i == 0)
		{
			p.a = i;
			p.b = val / i;
			ABPairs.push_back(p);
		}
	}
}

ul maxdiff = 0;

int main()
{
	ull n, k;
	std::cin >> n >> k;

	ul* a = new ul[n];

	for (int i = 0; i < n; i++)
	{
		std::cin >> a[i];
	}

	for (int i = 1; i < n; i++)
	{
		ul s1 = 0;
		ul s2 = 0;
		for (int j = 0; j < i; j++)
		{
			s1 += a[j];
		}
		for (int j = i; j < n; j++)
		{
			s2 += a[j];
		}
		if (max(s1, s2) - min(s1, s2) > maxdiff) maxdiff = max(s1, s2) - min(s1, s2);
	}

	std::cout << maxdiff;
}
