// Olimp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>

#define min(a, b) (a <= b ? a : b)
#define max(a, b) (a <= b ? b : a)

typedef unsigned long long ull;
typedef unsigned long ul;

typedef struct _AB
{
	ull a;
	ull b;
} ABPair;

std::vector<ABPair> ABPairs;

void dels(ull val)
{
	ABPair p;
	for (ull i = 2; i < ceil(sqrt(val)) + 1; i++)
	{
		if (val % i == 0)
		{
			p.a = i;
			p.b = val / i;
			ABPairs.push_back(p);
		}
	}
}

ull maxdiff = 0;

int main()
{
	ull n, k;
	std::cin >> n >> k;

	ul* a = new ul[n];
	ull* p = new ull[n + 1];
	p[0] = 0;

	for (int i = 0; i <= n; i++)
	{
		if (i < n)
		{
			std::cin >> a[i];
		}
		if (i > 0)
		{
			p[i] = p[i-1] + a[i-1];
		}
	}

	for (int i = 1; i < n; i++)
	{
		ull s1 = 0;
		ull s2 = 0;
		s1 = p[i];
		s2 = p[n] - p[i];
		if (max(s1, s2) - min(s1, s2) > maxdiff) maxdiff = max(s1, s2) - min(s1, s2);
	}

	std::cout << maxdiff;
}
