#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
unsigned long long rec(vector<unsigned long long> a, vector<unsigned long long> sum, vector<unsigned long long> borders, unsigned long long iteration, unsigned long long n, unsigned long long k) {
	unsigned long long ans = 0;
	if (iteration == 1) {
		if (iteration < k - 1) {
			while (borders[iteration] < borders[iteration + 1]) {
				ans = max(ans, *max_element(sum.begin(), sum.end()) - *min_element(sum.begin(), sum.end()));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		} else {
			while (borders[iteration] < n) {
				ans = max(ans, *max_element(sum.begin(), sum.end()) - *min_element(sum.begin(), sum.end()));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
	} else {
		if (iteration < k - 1) {
			while (borders[iteration] < borders[iteration + 1]) {
				ans = max(ans, rec(a, sum, borders, iteration-1,n,k));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
		else {
			while (borders[iteration] < n) {
				ans = max(ans, rec(a, sum, borders, iteration - 1, n, k));
				sum[iteration - 1] += a[borders[iteration]];
				sum[iteration] -= a[borders[iteration]];
				borders[iteration]++;
			}
			return ans;
		}
	}
}
int main() {
	unsigned long long n, k;
	cin >> n >> k;
	vector<unsigned long long> a(n);
	vector<unsigned long long> sum(k,0);
	vector<unsigned long long> borders(k);
	for (unsigned long long i = 0; i < k; i++) {
		borders[i] = i;
	}
	for (unsigned long long i = 0; i < n; i++) {
		cin >> a[i];
		if (i < k) {
			sum[i] += a[i];
		} else {
			sum[k - 1] += a[i];
		}
	}
	cout << rec(a, sum, borders, k-1, n, k);
}