#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

ll f(string n)
{
	ll res = 0;
	ll cnt = 0;
	for (ll i = n.size() - 1; i > 0; i--)
	{
		char c = n[i], c1 = n[i - 1];
		ll cnt1 = 0;
		if (c < '1')
		{
			cnt = 0;
			break;
		}
		if (c1 > '1')
			cnt1 = 4;
		else if (c >= '7')
			cnt1 = 4;
		else if (c >= '5')
			cnt1 = 3;
		else if (c >= '3')
			cnt1 = 2;
		else if (c >= '2')
			cnt1 = 1;
		else
			cnt1 = 0;
		cnt += cnt1;
	}
	{
		char c = n[0];
		ll cnt1 = 0;
		if (c >= '7')
			cnt1 = 4;
		else if (c >= '5')
			cnt1 = 3;
		else if (c >= '3')
			cnt1 = 2;
		else if (c >= '2')
			cnt1 = 1;
		else
			cnt1 = 0;
		cnt += cnt1;
	}
	res += cnt;

	for (ll i = n.size() - 1; i > 0; i--)
		res += 4 * i;
	return res;
}

void stress()
{
	for (ll r = 1; r < 1e6; r++)
	{
		ll cnt = 0;
		for (ll x = 1; x <= r; x++)
		{
			set<char> S;
			for (ll c = 1; c < 6; c++)
				S.insert(x % ll(pow(10, c)) - x % ll(pow(10, c - 1)));
			if (S.count(1) == S.size() - 1 && ((S.count(2) || S.count(3) || S.count(5) || S.count(7))))
				cnt++;
		}

	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string r, l;
	cin >> l >> r;
	if (l.back() == '0')
	{
		for (ll i = l.size() - 1; i >= 0; i--)
			if (l[i] != '0')
			{
				l[i]--;
				for (ll j = i + 1; j < l.size(); j++)
					l[j] = '9';
				break;
			}
	}
	else
		l[l.size() - 1]--;

	if (l[0] == '0' && l.size() > 1)
		l = l.substr(1);
	if (r[0] == '0' && r.size() > 1)
		r = r.substr(1);
	cout << f(r) - f(l);
}
