#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>

typedef long long ll;

using namespace std;

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll d, l, r;
	cin >> d >> l >> r;

	vector<ll> sq;
	ll cnt = 0;
	for (ll i = ceil(sqrt(l)); i <= sqrt(r); i++)
		sq.push_back(i * i);
	for (ll y = 0; y < sq.size(); y++)
	{
		auto x = lower_bound(sq.begin() + y, sq.end(), sq[y] + d);
		if (x != sq.end() && *x - sq[y] == d)
			cnt++;
	}
	cout << cnt;
}
