#include <algorithm>
#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

typedef long long ll;

using namespace std;

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll d, l, r;
	cin >> d >> l >> r;

	vector<ll> sq;
	unordered_map<ll, ll> at, bt;
	for (ll i = sqrt(l); i <= sqrt(r); i++)
		sq.push_back(i * i);
	for (ll a = 0; a < sq.size(); a++)
		for (ll b = a; b < sq.size(); b++)
			for (ll c = b; c < sq.size(); c++)
				if (sq[a] + sq[b] == sq[c])
					at[sq[a]]++, bt[sq[b]]++;
	cout << at[d] + bt[d];
}
