#include <algorithm>
#include <iostream>
#include <vector>

typedef long long ll;

using namespace std;

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, s;
	cin >> n >> s;

	vector<vector<ll>> C(n);
	for (ll i = 0; i < n; i++)
	{
		ll k;
		cin >> k;
		C[i].resize(k);
		for (ll& j : C[i])
			cin >> j;
	}

	if (n == 1)
	{
		ll k = C[0].size();
		vector<vector<ll>> dp(s + 1, vector<ll>(k + 1));
		dp[0].assign(k + 1, 1);
		for (ll i = 1; i <= s; i++)
			for (ll j = 0; j <= k; j++)
				if (j == 0)
					dp[i][j] = 0;
				else if (dp[i][j - 1])
					dp[i][j] = 1;
				else if (i < C[0][j - 1])
					dp[i][j] = 0;
				else
					dp[i][j] = dp[i - C[0][j - 1]][j - 1];
		if (dp[s][k])
		{
			cout << "Yes\n";
			vector<ll> t;
			ll i = s, j = k;
			while (j != 0)
			{
				if (dp[i][j - 1])
					j--;
				else if (dp[i - C[0][j - 1]][j - 1])
				{
					t.push_back(j);
					i -= C[0][j - 1], j--;
				}
			}
			cout << t.size() << '\n';
			for (ll i : t)
				cout << i << ' ';
		}
		else
			cout << "No";
	}
}
