from math import ceil

def upper_div(n, k):
    return ceil(n / k)

def redo(n, k):
    minimal = min(n[0] // k, n[1] // k)
    
    n[0] -= minimal * k
    n[1] -= minimal * k

    return minimal

def solution(n, m, k):
    distance = [n - 1, m - 1]
    
    result = redo(distance, k)

    result += upper_div(distance[0], k)
    result += upper_div(distance[1], k)

    return result
    

n, m, k = map(int, input().split())
print(solution(n, m, k))