﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

using namespace std;

int main() {
	long long n, s;
	cin >> n >> s;
	vector<vector<int>> a(n, vector<int>());
	vector<vector<vector<pair<int, int>>>> dp(n, vector<vector<pair<int, int>>>());
	vector<vector<vector<int>>> p(n, vector<vector<int>>());
	long long k;
	for (int i = 0; i < n; ++i) {
		cin >> k;
		a[i].resize(k);
		dp[i].resize(k + 1, vector<pair<int, int>>(s + 1));
		p[i].resize(k + 1, vector<int>(s + 1));
		for (int& j : a[i])
			cin >> j;
	}
	
	dp[0][0][0] = { 1, 0 };

	for(int i = 0; i < n; ++i)
		for(int j = 0; j < dp[i].size(); ++j)
			for (int t = 0; t <= s; ++t) {
				if (i == 0 && j == 0)
					continue;
				if (j == 0)
					dp[i][j][t].first = dp[i - 1][dp[i - 1].size() - 1][t].second;
				else {
					dp[i][j][t].first = dp[i][j - 1][t].first;
					dp[i][j][t].second = dp[i][j - 1][t].second;
					if (t >= a[i][j - 1] && dp[i][j - 1][t - a[i][j - 1]].first > dp[i][j - 1][t].second) {
						dp[i][j][t].second = dp[i][j - 1][t - a[i][j - 1]].first;
						dp[i][j][t].first = dp[i][j - 1][t - a[i][j - 1]].first;
						p[i][j][t] = 1;
					}
				}

			}
	if (dp[n - 1][dp[n - 1].size() - 1][s].second == 1)
		cout << "Yes" << '\n';
	else {
		cout << "No" << '\n';
		return 0;
	}
	vector<vector<int>> ans(n);
	int l = n - 1, r = dp[n - 1].size() - 1, t = s;
	while (t > 0) {
		if (p[l][r][t] == 1) {
			ans[l].push_back(r);
			t -= a[l][r - 1];
		}
			--r;
		if (r < 0) {
			--l;
			r = dp[l].size() - 1;
		}
	}
	for (vector<int>&i : ans) {
		cout << i.size() << '\n';
		for (int& j : i)
			cout << j << '\n';
	}
}
