#include <cstdlib>
#include <vector>
#include <iostream>

using namespace std;

int main()
{
	int n, m, k;
	const int INF = (int)1e9;
	cin >> n >> m >> k;
	vector<vector<int>> dp(n, vector<int>(m, INF));
	dp[n - 1][0] = 0;
	for (int y = n - 1; y != -1; y--)
	{
		for (int x = 0; x < m; x++)
		{
			if (dp[y][x] == 0)
				continue;
			for (int d = 1; d <= k; d++)
			{
				if (x >= d && dp[y][x] > dp[y][x - d])
					dp[y][x] = dp[y][x - d];
				if (y + d < n && dp[y][x] > dp[y + d][x])
					dp[y][x] = dp[y + d][x];
				if (y + d < n && x >= d && dp[y][x] > dp[y + d][x - d])
					dp[y][x] = dp[y + d][x - d];
			}
			if (dp[y][x] != INF)
				dp[y][x] += 1;
		}
	}
	cout << dp[0][m - 1];
}