from sys import setrecursionlimit
from functools import lru_cache

setrecursionlimit(99999999)

n, m, k = map(int, input().split())
INF = 999999999999


@lru_cache(maxsize=None)
def min_jumps_at (i, j):
    if i == 0 and j == 0:
        return 0

    a = []
    for kk in range(1, k + 1):
        ni = i - kk
        nj = j - kk

        if nj >= 0:
            a.append(min_jumps_at(i, nj))
        if ni >= 0:
            a.append(min_jumps_at(ni, j))
        if ni >= 0 and nj >= 0:
            a.append(min_jumps_at(ni, nj))

    return min(a) + 1
        
print(min_jumps_at(n - 1, m - 1))
