#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>


using namespace std;
typedef long long ll;

// a-sorted vector
bool can_sum (vector<int> &a, int l, int s, vector<int> &result) {
    if (l >= a.size()) {
        return s == 0;
    }

    for (int i = l; i < a.size(); i++) {
        if (s >= a[i]) {
            //cout << i + 1 << " " << s - a[i] << endl; 
            bool b = can_sum(a, i + 1, s - a[i], result);
            //cout << " ---- " << b << endl;
            if (b) {
                result.push_back(i);
                return true;
            }
        }   
    }

    return false;
}


int main () {
    int n, s; cin >> n >> s;
    
    

    // n = 1
    int k; cin >> k;
    vector<int> res;
    vector<int> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    bool b = can_sum(a, 0, s, res);
    if (b) {
        cout << "Yes" << endl;
        for (auto i: res) {
            cout << i + 1 << " ";
        }
    } else cout << "No" << endl;

    return 0;
}