n = int(input())
h = [int(i) for i in input().split()]



class Segment:
    def __init__(self, start, end=-1):
        self.start = start
        self.end = end

    def __add__(self, other):
        return Segment(
            min(self.start, other.start),
            max(self.end, other.end)
        )

    def get_capacity(self):
        mxl = [0] * n
        mxr = [0] * n

        for i in range(self.start, self.end + 1):
            if i == 0:
                mxr[i] = h[i]
            else:
                mxr[i] = max(h[i], mxr[i - 1])
        d = 0
        for i in range(self.end, self.start - 1, -1):
            if i == self.end:
                mxl[i] = h[i]
            else:
                mxl[i] = max(mxl[i + 1], h[i])
            d += max(min(mxl[i], mxr[i]) - h[i], 0)
        return d


seg = [Segment(i, i) for i in range(n)]

for k in map(int, input().split()):
    k -= 1
    seg[k] = seg[k] + seg.pop(k + 1)
    print(seg[k].get_capacity())
