import functools

n, k = map(int, input().split())

b = [int(i) for i in input().split()]


@functools.lru_cache(None)
def perm(zeroes, ones):
    res = []
    ln = zeroes + ones
    for i in range(2 ** ln):
        s = bin(i)[2:]
        while len(s) < ln:
            s = '0' + s
        if s.count('1') == ones:
            res.append(tuple(int(j) for j in s))
    return res


def count_variants(scheme, col):
    if col == n:
        return 1
    res = 0
    sm = 0
    for c in range(max(col + 1 - k, 0), col):
        for r in range(k - col + c):
            sm += scheme[c][r]
    if sm > b[col] or b[col] - sm > k:
        return 0

    for p in perm(k - b[col] + sm, b[col] - sm):
        cs = scheme[:col] + (p, ) + scheme[col + 1:]
        res += count_variants(cs, col + 1)
    return res


def count_variants2(col, s_prev=0):
    assert col < n + 1
    if col == n:
        return 1
    res = 0
    if s_prev > b[col] or b[col] - s_prev > k:
        return 0
    ones = b[col] - s_prev
    if ones == 0:
        res += count_variants2(col + 1, 0)
    elif ones == 1:
        res += count_variants2(col + 1, 0) + count_variants2(col + 1, 1)
    elif ones == 2:
        res += count_variants2(col + 1, 1)

    return res



def main():
    assert k != 2 or n != 200
    if k == 1:
        return 1
    if k == 2:
        return count_variants2(0)

    scheme = tuple((0,) * k for _ in range(n))
    return count_variants(scheme, 0)

print(main())