n, m, k = map(int, input().split())

dostso = [list(map(lambda i: int(i) - 1, input().split())) for _ in range(k)]
dosts = [0] * (m * n)
for x, y in dostso:
    dosts[y * n + x] = True


fw = [[] for _ in range(n * m)]
bw = [[] for _ in range(n * m)]
for i in range(m):
    for j in range(n):
        a = [] if i == m - 1 else [(i + 1) * n + j]
        b = [] if j == n - 1 else [i * n + (j + 1)]
        fw[i * n + j] = a + b
        c = [] if i == 0 else [(i - 1) * n + j]
        d = [] if j == 0 else [i * n + j - 1]
        bw[i * n + j] = c + d


def count_fw(v, dost, used):
    d = dosts[v]
    if v == m * n - 1:
        return count_bw(v, dost + d, used)
    used[v] = True
    c = 0
    for to in fw[v]:
        if not used[to]:
            c += count_fw(to, dost + d, used)
    used[v] = False
    return c


def count_bw(v, dost, used):
    d = dosts[v]
    if v == 0:
        return dost + d >= k
    used[v] = True
    c = 0
    for to in bw[v]:
        if to == 0 or not used[to]:
            c += count_bw(to, dost + d, used)
    used[v] = False
    return c


print(count_fw(0, 0, [0 for i in range(m * n)]))