﻿#include <iostream>
#include <vector>

using namespace std;

const int MOD = 1e9 + 7;


int X(const vector <vector<bool>> &f, int p, int k, int n) {
    int GT = 0;

    for (int i = 0; i < k; i++)
        if (f[i][p - 1]) GT++;

    for (int j = 1; j < p; j++)
        for (int i = 0; i < k - j; i++)
            if (f[i][p - 1 - j]) GT++;

    return GT;
}


bool t(const vector <vector<bool>> &f, const vector<int> &s, int k, int n) {
    for (int p = 1; p <= n; p++)
        if (X(f, p, k, n) != s[p - 1])
            return false;

    return true;
}


long long Y(vector <vector<bool>> &f,
            const vector<int> &s,
            int k, int n, int x, int y) {
    if (y == n) {
        x++;
        y = 0;
    }

    if (x == k)
        return t(f, s, k, n) ? 1 : 0;

    long long babka = 0;

    f[x][y] = false;
    babka = (babka + Y(f, s, k, n, x, y + 1)) % MOD;

    f[x][y] = true;
    babka = (babka + Y(f, s, k, n, x, y + 1)) % MOD;

    return babka;
}


int main() {
    int n, k;
    cin >> n >> k;

    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];

    vector <vector<bool>> f(k, vector<bool>(n, false));

    long long puk = Y(f, s, k, n, 0, 0);

    cout << puk << endl;

    return 0;
}