import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {

    public static int comp(char[] a, char[] b) { // -1 if a < b; 0 if a == b; 1 if a > b
        if (a.length < b.length) return -1;
        if (a.length > b.length) return 1;
        int n = a.length;
        for (int i = 0; i < n; i++) {
            if (a[i] < b[i]) {
                return -1;
            }
            if (a[i] > b[i]) {
                return 1;
            }
        }
        return 0;
    }

    public void solve() {
        char[] l;
        try {
            l = br.readLine().toCharArray();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        char[] r;
        try {
            r = br.readLine().toCharArray();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        if (r.length == l.length) {
            int n = l.length;
            char[] tmp = new char[n];
            Arrays.fill(tmp, '1');
            long s = 0;
            char[] primes = {'2', '3', '5', '7'};
            for (int i = 0; i < n; i++) {
                for (char sym : primes) {
                    tmp[i] = sym;
                    if (comp(tmp, l) != -1 && comp(r, tmp) != -1) {
//                        out.println(tmp);
                        s += 1;
                    }
                }
                tmp[i] = '1';
            }
            out.println(s);
            return;
        }

        int n = l.length;
        char[] tmp = new char[n];
        Arrays.fill(tmp, '1');
        long s = 0;
        char[] primes = {'2', '3', '5', '7'};
        for (int i = 0; i < n; i++) {
            for (char sym : primes) {
                tmp[i] = sym;
                if (comp(tmp, l) != -1) {
//                    out.println(tmp);
                    s += 1;
                }
            }
            tmp[i] = '1';
        }

        n = r.length;
        tmp = new char[n];
        Arrays.fill(tmp, '1');
        for (int i = 0; i < n; i++) {
            for (char sym : primes) {
                tmp[i] = sym;
                if (comp(r, tmp) != -1) {
//                    out.println(tmp);
                    s += 1;
                }
            }
            tmp[i] = '1';
        }

        for (int i = l.length + 1; i < r.length; i++) {
            s += 4 * i;
        }

        out.println(s);
    }

    public void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    BufferedReader br;
    PrintWriter out;

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}