import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {

    public static int comp(char[] a, char[] b) { // -1 if a < b; 0 if a == b; 1 if a > b
        if (a.length < b.length) return -1;
        if (a.length > b.length) return 1;
        int n = a.length;
        for (int i = 0; i < n; i++) {
            if (a[i] < b[i]) {
                return -1;
            }
            if (a[i] > b[i]) {
                return 1;
            }
        }
        return 0;
    }

    public static char[] primes = {'2', '3', '5', '7'};

    public static int set(char[] arr, int id) {
        arr[arr.length - id / 4 - 1] = primes[id % 4];
        return arr.length - id / 4 - 1;
    }

    public void solve() {
        char[] l;
        try {
            l = br.readLine().toCharArray();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        char[] r;
        try {
            r = br.readLine().toCharArray();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        long s = 0;

        int n = l.length;
        char[] tmp = new char[n];
        Arrays.fill(tmp, '1');
        int L = 0;
        int R = 4 * n;
        while (R - L > 1) {
            int m = (R + L) / 2;
            int ret = set(tmp, m);
            if (comp(tmp, l) != 1) {
                L = m;
            } else {
                R = m;
            }
            tmp[ret] = '1';
        }
        int Rl = R;
        int Ll = L;
        boolean flag = false;

        set(tmp, L);
        if (new String(tmp).equals(new String(l))) {
            flag = true;
        }

        n = r.length;
        tmp = new char[n];
        Arrays.fill(tmp, '1');
        L = 0;
        R = 4 * n;
        while (R - L > 1) {
            int m = (R + L) / 2;
            int ret = set(tmp, m);
            if (comp(tmp, r) != 1) {
                L = m;
            } else {
                R = m;
            }
            tmp[ret] = '1';
        }
        int Rr = R;
        int Lr = L;

//        out.println(Ll);
//        out.println(Rl);
//        out.println(Lr);
//        out.println(Rr);

        if (r.length == l.length) {
            s = Rr - Ll;
            if (flag) s += 1;
            out.println(s);
            return;
        }

        n = l.length;
        s += 4L * n - 1 - Ll;
        if (flag) s += 1;
        s += Rr;

//        for (int i = 0; i < n; i++) {
//            for (char sym : primes) {
//                tmp[i] = sym;
//                if (comp(r, tmp) != -1) {
//                    s += 1;
//                }
//            }
//            tmp[i] = '1';
//        }

        for (int i = l.length + 1; i < r.length; i++) {
            s += 4L * i;
        }

        out.println(s);
    }

    public void run() {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    BufferedReader br;
    PrintWriter out;

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}