import java.io.*;
import java.util.*;

public class E {
    public void solve() throws IOException {
        long d, l, r;
        d = nextLong();
        l = nextLong();
        r = nextLong();

        long cnt = 0;
        for (long i = 1; i * i <= d; i++) {
            if (d % i == 0) {
                long a = i;
                long b = d / i;
                if ((a + b) % 2 == 0) {
                    long x = (a + b) / 2;
                    long y = (b - a) / 2;
                    if (x * x <= r && x * x >= l && y * y >= l && y * y <= r) cnt++;
                }
            }
        }
        out.println(cnt);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new E().run();
    }

}