#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int n, k; cin >> n >> k;
    vector<long long> arr(n);
    vector<long long> psum(n + 1);
    set<pair<long long, int>> nums;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        psum[i + 1] = psum[i] + arr[i];
        nums.insert({ arr[i], i });
    }

    if (k == 2) {
        long long summ = psum.back();
        long long ans = max(abs(summ - 2 * arr[0]), abs(summ - 2 * arr.back()));
        cout << ans << endl;
        return 0;
    }

    int max_size = n - k + 1;
    long long ans = 0;
    while (!nums.empty()) {
        auto [num, ind] = *nums.begin();
        nums.erase(nums.begin());

        int left = max(0, ind - max_size);
        int right = min(n, ind + max_size + 1);

        long long summL = psum[ind] - psum[left];
        long long summR = psum[right] - psum[ind + 1];

        ans = max(ans, max(abs(summL - num), abs(summR - num)));
    }
    cout << ans << endl;
    return 0;
}
