#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int n, k; cin >> n >> k;
    vector<long long> arr(n);
    vector<long long> psum(n);
    set<pair<long long, int>> nums;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        if (i == 0) psum[i] = arr[i];
        else psum[i] = psum[i - 1] + arr[i];
        nums.insert({ arr[i], i });
    }

    if (k == 2) {
        long long summ = psum.back();
        long long ans = max(abs(summ - 2 * arr[0]), abs(summ - 2 * arr.back()));
        cout << ans << endl;
        return 0;
    }

    vector<long long> pmax(n);
    vector<long long> smax(n);

    int sz = n - k + 1;
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            pmax[i] = arr[i];
            continue;
        }

        long long summ = psum[i];
        if (i - sz >= 0) {
            summ -= psum[i - sz];
        }

        pmax[i] = max(pmax[i - 1], summ);
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 == n) {
            smax[i] = arr.back();
            continue;
        }

        long long summ = psum[min(i + sz, n) - 1];
        if (i > 0) {
            summ -= psum[i - 1];
        }
        smax[i] = max(smax[i + 1], summ);
    }


    long long ans = 0;
    while (!nums.empty()) {
        auto [num, ind] = *nums.begin();
        nums.erase(nums.begin());

        long long result = 0;
        if (ind > 0) {
            result = pmax[ind - 1];
        }
        if (ind + 1 < n) {
            result = max(result, smax[ind + 1]);
        }
        result -= num;

        ans = max(ans, result);
    }

    cout << ans << endl;
    return 0;
}
