import sys
from random import randint as rnd

def r(s, k, wt):
    dp = [0] * (len(wt) + 1)
    size = min(s, sum(wt)) + 1
    
    for i in range(len(dp)):
        dp[i] = [False] * size

    dp[0][0] = True
    for ind in range(1, len(dp)):
        for w in range(size):
            dp[ind][w] = dp[ind - 1][w]
            if wt[ind - 1] <= w:
                dp[ind][w] |= dp[ind - 1][w - wt[ind - 1]]

    return dp

def path(dp, wt):
    ind, w = len(dp), wt

    ans = []
    while ind > 0:
        if not dp[ind - 1][w]:
            ans.append(ind)
            w -= wt[ind - 1]
        ind -= 1

    ans.reverse()
    return ans

n, s = map(int, input().split())
k = int(input())
wt = list(map(int, input().split()))

if n == 1:
    dp = r(s, k, wt)

    a = False
    if s <= sum(wt):
        a = not dp[-1][s]
    b = (s > sum(wt))

    if a or b:
        print("No")
        sys.exit(0)

    ans = path(dp, s)
    print("Yes")
    print(len(ans))
    print(*ans)
    sys.exit(0)

dct = {}

k2 = int(input())
wt2 = list(map(int, input().split()))

dp1 = r(s, k, wt)
dp2 = r(s, k2, wt2)

for i in range(1, s + 1):
    if dp1[-1][i]:
        dct[i] = True

suit1, suit2 = -1, -1
for i in range(1, s + 1):
    if dp2[-1][i] and dct[s - i]:
        suit1 = s - 1
        suit2 = i

if suit1 == -1:
    print("No")
    sys.exit(0)

ans1 = path(dp1, suit1)
ans2 = path(dp2, suit2)

print("Yes")
print(len(ans1))
print(*ans1)
print(len(ans2))
print(*ans2)
"""
for i in range(n):
    arr[i] = int(input())
    mass = list(map(int, input().split()))

if s < n or sum(arr) < s:
    print("No")
else:
    for i in range(n):
        x = s - n + i + 1
        x = min(x, arr[i])
        s -= x
        arr[i] = x

    print("Yes")
    for i in arr:
        print(i)
        for j in range(1, i + 1):
            print(j, end = " ")
        print()
"""
