import sys
from random import randint as rnd

n, s = map(int, input().split())
k = int(input())
wt = list(map(int, input().split()))

def knapsack(s, k, wt):
    dp = [0] * (len(wt) + 1)
    size = min(s, sum(wt)) + 1
    
    for i in range(len(dp)):
        dp[i] = [False] * size

    dp[0][0] = True
    for ind in range(1, len(dp)):
        for w in range(size):
            dp[ind][w] = dp[ind - 1][w]
            if wt[ind - 1] <= w:
                dp[ind][w] |= dp[ind - 1][w - wt[ind - 1]]

    ind, w = len(dp), s

    a = False
    if s <= sum(wt):
        a = not dp[-1][s]
    b = s > sum(wt)
    
    if a or b:
        print("No")
        return

    ans = []
    while ind > 0:
        if not dp[ind - 1][w]:
            ans.append(ind)
            w -= wt[ind - 1]
        ind -= 1

    ans.reverse()

    print("Yes")
    print(len(ans))
    print(*ans)

    return

knapsack(s, k, wt)

"""
for i in range(n):
    arr[i] = int(input())
    mass = list(map(int, input().split()))

if s < n or sum(arr) < s:
    print("No")
else:
    for i in range(n):
        x = s - n + i + 1
        x = min(x, arr[i])
        s -= x
        arr[i] = x

    print("Yes")
    for i in arr:
        print(i)
        for j in range(1, i + 1):
            print(j, end = " ")
        print()
"""
