#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<pair<int, int>> d;
int n, m, k, cnt = 0;
int mod = 1e9 + 7;

bool isSuit(set<pair<int, int>>& path) {
    for (auto [a, b]: d) {
        if (path.find({ a, b }) == path.end()) {
            return false;
        }
    }
    return true;
}

void allPaths(int x, int y, bool visNM, set<pair<int, int>>& path) {
    if (x == 1 && y == 1 && visNM) {
        /*cout << "path:" << endl;
        for (auto [a, b]: path) {
            cout << a << " " << b << endl;
        } cout << endl << endl;
        cout << "suit? " << isSuit(path) << endl; */
        cnt += isSuit(path);
        cnt %= mod;
        /*cout << "path " << endl;
        for (auto [a, b]: path) {
            cout << a << " " << b << endl;
        } cout << endl << endl; */
        return;
    }
    if (x == n && y == m) {
        visNM = true;
    }

    if (path.find({ x, y }) != path.end()) return;
    path.insert({ x, y });

    if (visNM) {
        if (x > 1) {
            allPaths(x - 1, y, visNM, path);
        }
        if (y > 1) {
            allPaths(x, y - 1, visNM, path);
        }
    } else {
        if (x < n) {
            allPaths(x + 1, y, visNM, path);
        }
        if (y < m) {
            allPaths(x, y + 1, visNM, path);
        }
    }

    path.erase({ x, y });
}


int main()
{
    n, m, k; cin >> n >> m >> k;
    d.resize(k);

    for (auto& [a, b]: d) {
        cin >> a >> b;
    }

    set<pair<int, int>> path;
    allPaths(1, 1, false, path);
    cout << cnt << endl;
    return 0;
}
