#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>

using namespace std;

typedef long long ll;

ll after_it(ll p) {
    switch (p) {
        case 8:
        case 9:
            return 0;

        case 6:
        case 7:
            return 1;

        case 4:
        case 5:
            return 2;

        case 3:
            return 3;
        case 0:
        case 1:
        case 2:
            return 4;
        default:
            return 0;
    }
}

ll get_one(string s) {
    s = s.substr(1);

    ll otv = 0;

    for (int i = 0; i < s.size(); ++i) {
        char c = s[i];

        if (c != '1') {
            if (c == '0') {
                otv += 4 *(s.size() - i - 1);
            }
            bool edinici = true;
            for (char q : s.substr(i + 1)) {
                if (q == '0')
                    break;
                else if (q != '1') {
                    edinici = false;
                    break;
                }
            }

            if (edinici)
                otv += after_it(c - '0');
            else otv += after_it(c - '0' + 1);

            otv += 4 * i;

            return otv;
        }
    }

    return 4 * s.size();

}

ll get_more_one(string s) {
    ll perv = s[0] - '0';
    s = s.substr(1);

    for (char c : s) {
        if (c == '0')
            break;
        else if (c != '1') {
            perv++;
            break;
        }
    }

    return after_it(perv);
}

ll get_all(string a) {
    if (a[0] == '1')
        return get_one(a) + get_more_one(a);
    else return get_more_one(a);

}

bool check_prime(string a) {
    bool c = true;

    for (int j = 0; j < a.length(); j++) {
        switch (a[j]) {
            case '0':
            case '4':
            case '6':
            case '8':
            case '9':
                return false;
            case '2':
            case '3':
            case '5':
            case '7':
                if (c)
                    c = false;
                else
                    return false;
        }
    }

    if (!c)
        return true;
    else
        return false;
}

int main() {
    cin.tie(0);
    cout.tie(0);

    string l, r;
    cin >> l >> r;


    if (l.length() == r.length()) {
        cout << get_all(l) - get_all(r) + check_prime(r) << endl;
    } else {
        ll otv = 0;
        otv += get_all(l);
        for (ll i = l.size() + 1; i < r.size(); ++i) {
            otv += 4 * i;
        }
        otv += (4 * r.size()) - get_all(r) + check_prime(r);

        cout << otv << endl;
    }

}