#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>

#define MOD 10000007

using namespace std;

typedef long long ll;

struct Sek {
    ll h;
    ll ml;
    ll mr;
    ll w;
};

int main() {
    cin.tie(0);
    cout.tie(0);

    ll n;

    cin >> n;

    vector<vector<Sek>> arr(n);
    vector<ll> max_group(n);
    vector<ll> w_group(n);

    for (int i = 0; i < n; ++i) {
        ll p;
        cin >> p;

        arr[i].push_back({p, p, p, 0});
        max_group[i] = p;
    }

    while (--n > 0) {
        ll h;
        cin >> h;
        h--;


        ll sum_w = 0;

        //левая часть
        ll max_right = max_group[h + 1];

        for (ll i = arr[h].size() - 1; i > - 1 ; --i) {
            Sek &s = arr[h][i];

            if (s.mr < max_right) {
                s.mr = max_right;
                w_group[h] -= s.w;
                s.w = min(s.ml, s.mr) - s.h;
                w_group[h] += s.w;
            }
        }



        //правая часть

        ll max_left = max_group[h];

        for (Sek &s : arr[h + 1]) {
            if (s.ml < max_left) {
                s.ml = max_left;
                w_group[h + 1] -= s.w;
                s.w = min(s.ml, s.mr) - s.h;
                w_group[h + 1] += s.w;
            }
        }


        for (Sek a : arr[h + 1]) {
            arr[h].push_back(a);
        }

        max_group[h] = max(max_left, max_right);
        w_group[h] += w_group[h+1];

        arr.erase(arr.begin() + (h + 1));
        max_group.erase(max_group.begin() + (h + 1));
        w_group.erase(w_group.begin() + (h + 1));

        cout << w_group[h] << endl;
    }

}