#include<iostream>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>
#include <set>
#include <unordered_set>

#define MOD 10000007

using namespace std;

typedef long long ll;


int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;
    vector<ll> arr;

    for (int i = 0; i < n; ++i) {
        ll p;
        cin >> p;

        arr.push_back(p);
    }

    vector<ll> pref(n + 1, 0); //сдвиг на 1
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + arr[i];
    }

    vector<ll> lmin = {arr[0]};
    for (int i = 1; i < n; ++i) {
        lmin.push_back(min(lmin[i - 1], arr[i]));
    }

    vector<ll> rmin = {arr[n - 1]};
    for (int i = n - 2; i > -1; --i) {
        rmin.push_back(min(rmin[n - i - 2], arr[i]));
    }
    reverse(rmin.begin(), rmin.end());

    ll otv = -1;

    if (k == 3 && n > 1000) {
        for (int l = (n - k - 1) /2 ; l <= n - k + 1; ++l) {
            for (int start = 0; start < n - l + 1; ++start) {
                ll sum = pref[start + l] - pref[start];

                ll mn = LLONG_MAX;

                if (start > 0)
                    mn = lmin[start - 1];
                if (start + l < n)
                    mn = min(mn, rmin[start + l]);


                otv = max(otv, sum - mn);
            }
        }

        cout << otv << endl;
        return 0;
    }

    if (k == 2) {
        for (int l = max(n - k + 1, 1) ; l <= n - k + 1; ++l) {
            for (int start = 0; start < n - l + 1; ++start) {
                ll sum = pref[start + l] - pref[start];

                ll mn = LLONG_MAX;

                if (start > 0)
                    mn = lmin[start - 1];
                if (start + l < n)
                    mn = min(mn, rmin[start + l]);


                otv = max(otv, sum - mn);
            }
        }

        cout << otv << endl;
        return 0;
    }

    for (int l =  1; l <= n - k + 1; ++l) {
        for (int start = 0; start < n - l + 1; ++start) {
            ll sum = pref[start + l] - pref[start];

            ll mn = LLONG_MAX;

            if (start > 0)
                mn = lmin[start - 1];
            if (start + l < n)
                mn = min(mn, rmin[start + l]);


            otv = max(otv, sum - mn);
        }
    }

    cout << otv << endl;
    return 0;
}
