#include<iostream>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>
#include <tuple>
#include <set>
#include <unordered_set>

#define MOD 10000007

using namespace std;

typedef long long ll;

ll otv = 0;
vector<vector<int>> stpole;
int n, m, k;

void suda(int x, int y, ll used, vector<vector<int>> pole) {
    if (pole[x][y] == 1)
        used++;

    if (x > 0 && pole[x - 1][y] != -1)
        suda(x - 1, y, used, pole);
    if (y > 0 && pole[x][y - 1] != -1)
        suda(x, y - 1, used, pole);

    if (x == 0 && y == 0 && used == k)
        otv++;
}

void tuda(int x, int y, ll used, vector<vector<int>> pole) {
    if (pole[x][y] == 1)
        used++;

    if (x != 0 && y != 0) pole[x][y] = -1;

    if (x < n - 1)
        tuda(x + 1, y, used, pole);
    if (y < m - 1)
        tuda(x, y + 1, used, pole);

    if (x == n - 1 && y == m - 1)
        suda(x, y, used, pole);
}


int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    cin >> n >> m >> k;

    stpole.resize(n);
    for (int i = 0; i < n; ++i) {
        stpole[i].resize(m);
    }

    for (int i = 0; i < k; ++i) {
        int q, p;
        cin >> q >> p;
        stpole[q - 1][p - 1] = 1;
    }


    stpole[0][0] = -10;
    stpole[n - 1][m - 1] = -11;
    tuda(0, 0, 0, stpole);

    cout << otv / 2 << endl;

    return 0;
}
